<?php


class Options
{

    public function __construct()
    {
    }

   static function version()
    {

        $s = Options::get(["name" => "version"])["data"];
        $data =  json_decode($s, true);
        return  $data["version"];
    }



    static   function app($name = "all")
    {


        if (is_array($name)) {
            if (isset($name["name"])) {
                $name = $name["name"];
            } else {
                $name = "all";
            }
        }

        $s = Options::get(["name" => "settings"])["data"];

        $data =  json_decode($s, true);
        if ($name == "all") {
            return  $data;
        } else {

            return  $data[$name];
        }
    }

    /**
     * id  :send_notification id
     * players:players_ids
     */
    function send_notification_by_player_ids($req)
    {

        if (!isset($req["notification_id"]) &&  isset($req["send_notifaction"])) {

            $req["notification_id"] = $req["send_notifaction"];
        }
        $notifications = \ins::_db()->_get_row("sys_notifications_templates", "*", "id ='{$req["notification_id"]}'");

        if (is_array($notifications)) {
            $playerIDs = explode(",", $req["notification_to"]);


            foreach ($playerIDs as $player_id) {
                $player_id = str_replace("p", "", $player_id);

                $user_data = \ins::_db()->_get_row("sys_users", "*", "ex_table ='com_htrk_players' and ex_id ='$player_id'");


                $notifications = \lib::_data()->_lang_trans($notifications, $req);

                /*  \ins::_db()->_insert(
                    "com_htrk_notifications",
                    [
                        "template" => $req["notification_id"], "date" => ins::_timedate()->_now(),
                        "to" => '[{"id":"' . $user_data["id"] . '"}]',
                        "lang" => json_encode($req)
                    ]
                );*/

                Options::send_notification($notifications["title"], $notifications["body"],  $user_data["device_token"]);
            }
        }
    }

    function send_notification($title = "", $body = "", $tk = "")
    {


        $data  = '{
"to":"' . $tk . '",
 "notification" : {
  "sound" : "default",
  "body" :  "' . $body . '",
  "title" : "' . $title . '",
  "content_available" : true,
  "priority" : "high"
 },
 "data" : {
  "sound" : "default",
  "body" :    "' . $body . '",
  "title" :  "' . $title . '",
  "content_available" : true,
  "priority" : "high"
 }
}';


        //FCM API end-point
        $url = 'https://fcm.googleapis.com/fcm/send';
        //api_key in Firebase Console -> Project Settings -> CLOUD MESSAGING -> Server key
        $server_key = 'AAAAQcaTrm8:APA91bEFpJVCJkAFvk-hnJtzBsBhAuCYzTSCDvWhSo65hW8dgR7gzdaGh1i5VNw3RBAefy5EyMUs-Dbw0Illo3f483MFLfs2aOFwNJ4HBSsuxwwcsJNPI4W_U9Ps-sj94tmmUtT7vQl_';
        //header with content_type api key
        $headers = array(
            'Content-Type:application/json',
            'Authorization:key=' . $server_key
        );




        //CURL request to route notification to FCM connection server (provided by Google)
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);


        $result = curl_exec($ch);


        if ($result === FALSE) {
            die('Oops! FCM Send Error: ' . curl_error($ch));
        }
        curl_close($ch);
    }




    static   function get($data)
    {
        $r = \ins::_db()->_get_row("com_options", "*", "name='{$data["name"]}'");

        if ($data["lang"] != null) {
            $r = \ins::_data()->_update_language($r, $data["lang"], true);
        }

        return Shared::unset_data([$r])[0];
    }

    static   function all($data)
    {
        $r = \ins::_db()->_get_data("com_options");
        if ($data["lang"] != null) {
            $r = \ins::_data()->_update_language_array($r, $data["lang"], true);
        }
        return Shared::unset_data($r);
    }
}
