<?php

class com_finance extends ins_com
{
    var $_return = "";
    var  $g;

    public function __construct()
    {
        parent::__construct();
        $this->g = ins::_eng()->_get();
    }


    /*@regin start home form fill list  */

    function _get_dormitories($rq)
    {
        $options = [
            "select_type" => "db",
            "select_table" => "com_school_dormitories",
            "select_text" => "title",    "select_vlaue" => "id",
            "select_query" => "`class`='{$rq["class"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }
    function _get_students($rq)
    {
        $options = [
            "select_type" => "db", "select_text" => "name",
            "select_table" => "app_school_students",
            "select_vlaue" => "id",
            "select_query" => "`dormitory`='{$rq["dormitory"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }

    /*@regin end home form fill list  */


    /*@regin strat add to active actions  */


    function _get_groups($rq)
    {
        $options = [
            "select_type" => "db",
            "select_table" => "com_school_activity",
            "select_vlaue" => "id",
            "select_query" => "`act_id`='{$rq["activity"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }

    function _add_student_to_act_ui($rq)
    {

        $sdata =  \ins::_db()->_get_row("app_school_students", "*", "id={$rq["student_id"]}");
        $cq = ins::_data()->_db_create_where_to_group($sdata["class"], "for_type");
        $dq = ins::_data()->_db_create_where_to_group($sdata["dormitory"], "for_type");

        $uidata = [
            "start" => ["class" => "ins_grid"],
            "activity" => [
                "title" => 'class', "title-ar" => "النشاط",

                "select_query" => " pay=0 and (`for`='all' or (`for`='class' and $cq ) or  (`for`='dormitory' and $dq ) )",
                "type" => 'select', "select_type" => "db",
                "select_table" => "com_school_activities", "pclass" => ' ins_col_12'
            ],
            "act_id" => ["title" => 'act_group', "title-ar" => "المجموعه", "type" => 'select',  "pclass" => ' ins_col_12'],
            "button" => ["class" => 'btn_add_student ins_col_12', "data-student_id" => "{$rq["student_id"]}", "data" => "add Student", "data-ar" => "اضافة  الطالب"],
            "end" => []

        ];




        return \ins::_ui()->_data($uidata)->_render();
    }

    /*@regin end add to active actions  */

    /*@regin strat pay actions  */

    function _print($rq)
    {
        $r = "";
        $fdata = \ins::_db()->_get_row("com_finance", "*", "id={$rq["id"]}");
        if (!isset($fdata["user"])) {
            $fdata["user"] =  \ins::_db()->_get_row("app_school_students", "*", "id={$rq["student_id"]}")["name"];
        }

        if ($fdata["des"] != "") {
            $fdata["des"] = " - ";
        }

        if (isset($rq["fee_value"])) {
            $fdata["fee_value"] = $rq["fee_value"];
        }




        $f = new \NumberFormatter("ar", \NumberFormatter::SPELLOUT);
        $fdata["fee_text"] = $f->format($fdata["fee_value"]) . " جنيها لا غير ";
        $_SESSION["f_pay_print"] = $fdata;
    }

    function _payfee($rq)
    {

        if (!isset($rq["date"])) {
            $rq["date"] = date('Y-m-d');
        }
        if (!isset($rq["user"])) {
            $rq["user"] =  \ins::_db()->_get_row("app_school_students", "*", "id={$rq["student_id"]}")["name"];
        }

        unset($rq["id"]);

        print_R($rq);
        $sdata = \ins::_db()->_insert("com_finance", $rq);
    }

    function _ui_payfee($rq)
    {
        $sdata = \ins::_db()->_get_row("app_school_students", "*", "id={$rq["student_id"]}");

        $data = [
            "start" => ["class" => "ins_grid"],
            "user" => ["input" => true, "value" => $sdata["name"], "title-ar" => "الطالب", "title" => "Student", "type" => "text", "pclass" => "ins_col_12"],
            "date" => ["input" => true, "value" => date("Y-m-d"), "title-ar" => "التاريخ",  "title" => "Date", "type" => "date", "pclass" => "ins_col_6"],
            "payment_method" => ["type" => "payment_methods", "title" => "payment method", "title-ar" => "طرقه الدفع",  "pclass" => "ins_col_6"],
            "fee_value" => ["input" => true, "value" => $rq["fee_value"], "title-ar" => "المبلغ", "title" => "value",  "type" => "text", "pclass" => "ins_col_6"],
            "currency" => ["type" => "currencies", "title" => "currency", "title-ar" => "العملة",  "pclass" => "ins_col_6"],
            "des" => ["style" => "height:110px",  "title-ar" => "ملاحظات", "title" => "ملاحظات", "type" => "textarea", "class" => "des", "pclass" => "ins_col_12"],
            "button" => [
                "data-student_id" => $rq["student_id"],
                "data-subact_id" => $rq["subact_id"],
                "data-mode" => $rq["mode"],
                "data-act_id" => $rq["act_id"],  "data-fee_index" => $rq["fee_index"],
                "type" => "text", "data" => "pay", "data-ar" => "دفع", "class" => "btn_ui_fee_pay ins_button ins_col_12"
            ],
            "end" => [],

        ];

        return  \lib::_ui()->_data($data)->_render();
    }





    /*@regin end pay actions  */

    /*@regin strat user ui  */



    function _students_get_activty_item($rq)
    {

        $sdata = \ins::_db()->_get_row("app_school_students", "*", "id='{$rq["student_id"]}'");
        $c = \ins::_db()->_get_row("com_school_activities", "*", "id='{$rq["act_id"]}'");
        $act = \ins::_db()->_get_row("com_school_activity", "*", "id='{$rq["subact_id"]}'");


        $c["fees"] =  str_replace("[]", "", $c["fees"]);
        $fees =  json_decode($c["fees"], true);
        $i = 0;
        $table = [];

        $delete = "";

        if ($c["pay"] == '0' and $c["optional"] = '1') {

            $delete = "<i data-student_id='{$rq["student_id"]}' data-id='{$act["id"]}'  style='float: left' class='fas btn_delete_student_from_act fa-trash'></i>";
        }

        $table[] = [[
            "data" =>  $c["title"] . " -" . $act["title"] . $delete, "style" => "text-align: center;", "class" => "ins_col_24"
        ]];
        $table[] = [
            "class" => "ins_light ",
            "data" => [
                [/*"data" => "date",*/"data" => "دفع خلال فتره ", "class" => "ins_col_10"],
                [/*"data" => "value",*/"data" => "القيمه", "class" => "ins_col_10"],
                [/*"data" => "actions",*/"data" => "عمليات", "class" => "ins_col_4"]
            ]
        ];
        foreach ($fees as $i => $fee) {
            $w = " student_id='{$sdata["id"]}' and act_id='{$c["id"]}'  and fee_index='{$i}' ";
            $fdata = \ins::_db()->_get_data("com_finance", "*", "$w");


            $llfee = 0;

            $t = $fee["fee_value"];

            $last_f_id = "";
            foreach ($fdata as $f) {
                $llfee += $f["fee_value"];
                $t -= $f["fee_value"];

                $last_f_id =  $f["id"];
            }

            $date_string = $fee["fee_from_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_from_month"]) .
                " --> " . $fee["fee_to_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_to_month"]);


            if ($llfee == $fee["fee_value"]) {

                $table[] = [
                    ["data" => $date_string, "class" => "ins_col_10"],
                    ["data" => $fee["fee_value"], "class" => "ins_col_10"],
                    ["data" => " <i  style='color:green' class='fas  fa-check'></i>
        <i  data-id='{$last_f_id}' data-fee_value='{$fee["fee_value"]}'  class='fas _btn_print ins_icon_button fa-print'></i>
         
         
         ", "class" => "ins_col_4"]
                ];
            } else {

                $table[] = [
                    ["data" => $date_string, "class" => "ins_col_10"],
                    ["data" => $fee["fee_value"], "class" => "ins_col_10"],
                    ["data" => "
        <i  data-student_id='{$sdata["id"]}'  data-subact_id='{$rq["subact_id"]}'  data-fee_value='{$t}' 
         data-act_id='{$c["id"]}'  data-fee_index='{$i}' class='fas ins_icon_button btn_ui_pay  fa-money-check-alt'></i>
        <i  data-student_id='{$sdata["id"]}' data-fee_value='{$t}' 
         data-act_id='{$c["id"]}'    data-subact_id='{$rq["subact_id"]}'    data-fee_index='{$i}' class='fas ins_icon_button btn_fee_pay  fa-check'></i>", "class" => "ins_col_4"]
                ];
            }



            $t = $fee["fee_value"];

            foreach ($fdata as $f) {
                $table[] = [
                    "class" => "",
                    "data" => [
                        ["data" => $f["date"], "class" => "ins_col_10"],

                        ["data" => $f["fee_value"], "class" => "ins_col_10"],
                        ["data" => "<i  data-id='{$f["id"]}' class='fas _btn_print ins_icon_button fa-print'></i>", "class" => "ins_col_4"]
                    ]
                ];
                $t -= $f["fee_value"];
            }
            $table[] = [
                "class" => "fin_pay_row",
                "data" => [
                    ["data" => "متبقى ", "class" => "ins_col_10"],
                    ["data" => $t, "class" => "ins_col_10"]
                ]
            ];
        }
        $data = [
            "table_divs" => ["data" => $table, "class" => "ins_col_12 ins_card"],
        ];
        return \lib::_ui()->_data($data)->_render();
    }
    function _students_get_activies($id, $pay = "0")
    {
        $sdata = \ins::_db()->_get_row("app_school_students", "*", "id=$id");
        $w = " and ( com_school_activities.pay='{$pay}'  and ( com_school_activities.for='all' ||
        (com_school_activities.for='class' and " . \ins::_data()->_db_create_where_to_group($sdata["class"], "for_type") . "  )
        || (com_school_activities.for='dormitory' and " . \ins::_data()->_db_create_where_to_group($sdata["dormitory"], "for_type") . ")
        )) ";

        $cdata = \ins::_db()->_get_data("com_school_activities", "*", "optional=0 and free=0   $w ");

        $qdata = \ins::_db()->_get_query("SELECT com_school_activities.*  ,com_school_activity.id as act_id  FROM com_school_activities 
        inner JOIN com_school_activity  ON com_school_activity.act_id=com_school_activities.id 
         where com_school_activities.optional=1 and  com_school_activities.free=0    $w 
          and  JSON_EXTRACT(com_school_activity.students, '$.{$id}')<>''");
        $cdata = array_merge($qdata, $cdata);

        foreach ($cdata as $c) {
            $data[] =
                [
                    "type" => "div",
                    "data" =>  com_finance::_students_get_activty_item(["act_id" => $c["id"], "subact_id" => $c["act_id"], "student_id" => $id]),
                    "data-acts_id" => $c["id"],
                    "data-act_id" => $c["act_id"],
                    "data-st_id" => $id,
                    "class" => "ins_col_12 _students_get_activty_item _data_st{$id}act{$c["id"]}subact{$c["act_id"]}"
                ];
        }
        return \lib::_ui()->_data($data)->_render();
    }

    function _get_fee_data_ui($rq)
    {
        $w = " student_id='{$rq["student_id"]}' and act_id='{$rq["act_id"]}'  and fee_index='{$rq["fee_index"]}' ";
        $fdata = \ins::_db()->_get_data("com_finance", "*", "$w");

        $table[] = [
            "class" => "",
            "data" => [
                ["data" => "تاريخ تسديد الدفعه ", "class" => "ins_col_10"],
                ["data" => "قيمة الدفعه", "class" => "ins_col_6"],
                ["data" => "خيارات", "class" => "ins_col_6"]
            ]
        ];


        foreach ($fdata as $f) {
            $table[] = [
                "class" => "",
                "data" => [
                    ["data" => $f["date"], "class" => "ins_col_10"],
                    ["data" => $f["fee_value"], "class" => "ins_col_6"],
                    ["data" => "<i  data-id='{$f["id"]}' class='fas _btn_print ins_icon_button fa-print'></i>", "class" => "ins_col_6"]
                ]
            ];
        }
        $data[] =  ["type" => "table_divs", "data" => $table, "class" => "ins_col_12"];
        return  \lib::_ui()->_data($data)->_render();
    }



    /*@regin start view_by act */


    function  _activity_get_row($rq)
    {
        $i = $rq["fee_index"];

        $d = \ins::_db()->_get_row("app_school_students", "*", "id='{$rq["student_id"]}'");
        $activity = \ins::_db()->_get_row("com_school_activities", "*", " id='{$rq["act_id"]}'");


        $activities["fees"] =  str_replace("[]", "", $activity["fees"]);
        $fees =  json_decode($activities["fees"], true);
        $fee = $fees[$i];


        $data = [];

        $w = " student_id='{$d["id"]}' and act_id='{$activity["id"]}'  and fee_index='{$i}' ";

        $fdata = \ins::_db()->_get_data("com_finance", "*", "$w");

        $fee_value = 0;

        $t =  $fee["fee_value"];

        foreach ($fdata as $f) {

            $fee_value +=  $f["fee_value"];
            $t -=  $f["fee_value"];
        }

        $info_data = " data-student_id='{$d["id"]}' and data-act_id='{$activity["id"]}'  and data-fee_index='{$i}'";

        if ($fee_value == $fee["fee_value"]) {





            $data[] =   ["type" => "div", "data" => $d["name"], "class" => "ins_col_8 ins_td"];
            $data[] =   ["type" => "div", "data" => $fee["fee_value"], "class" => "ins_col_3 ins_td"];
            $data[] =   ["type" => "div", "data" =>  $fee_value, "class" => "ins_col_3 ins_td"];
            $data[] =   ["type" => "div", "data" =>  "لا يوجد", "class" => "ins_col_3 ins_light ins_td"];

            $data[] =   [
                "type" => "div",
                "class" => "ins_col_6 ins_text_tocenter  ins_td",
                "data" => " 
                 <i  $info_data     class='fas ins_get_fee_data   fa-info-circle'></i> 
    <i   $info_data   class='fas    fa-check'></i>",
            ];
        } else {


            $data[] =   ["type" => "div", "data" => $d["name"], "class" => "ins_col_8 ins_td "];
            $data[] =   ["type" => "div", "data" => $fee["fee_value"], "class" => "ins_col_3 ins_td"];
            $data[] =   ["type" => "div", "data" =>  $fee_value, "class" => "ins_col_3 ins_td"];
            $data[] =   ["type" => "div", "data" => ($fee["fee_value"] - $fee_value), "class" => "ins_col_3 ins_light ins_td"];

            $data[] =   [
                "type" => "div",
                "data" => "
                <i  $info_data     class='fas ins_get_fee_data   fa-info-circle'></i> 
             

    <i  data-student_id='{$d["id"]}' data-fee_value='$t' 
     data-act_id='{$activity["id"]}'   data-mode ='activity' data-fee_index='$i' class='fas ins_icon_button btn_ui_pay  fa-money-check-alt'></i>
    <i  data-student_id='{$d["id"]}' data-fee_value='$t' 
     data-act_id='{$activity["id"]}'  data-mode ='activity'  data-fee_index='$i' class='fas ins_icon_button btn_fee_pay  fa-check'></i>", "class" => "ins_col_6 ins_td ins_text_tocenter"
            ];
        }

        return  \lib::_ui()->_data($data)->_render();
    }


    function  _activity_get_act_dormitory($activity, $i, $fee, $st_ids = null)
    {



        $table[] = [
            ["data" => "الاسم", "class" => "ins_col_8"],
            ["data" => "القيمية", "class" => "ins_col_3"],
            ["data" => "تم دفع", "class" => "ins_col_3"],
            ["data" =>  "متبقى ", "class" => "ins_col_3 ins_light"],
            ["data" => " خيارت ", "class" => "ins_col_6 "],
        ];

        if ($st_ids == null) {
            $w = "dormitory='{$activity["dormitory"]}'";
            $sdata = \ins::_db()->_get_data("app_school_students", "*", $w . "");
        } else {
            $sdata = \ins::_db()->_get_data("app_school_students", "*", ins::_data()->_db_create_where_from_array($st_ids));
        }


        foreach ($sdata as $d) {


            $w = " student_id='{$d["id"]}' and act_id='{$activity["id"]}'  and fee_index='{$i}' ";
            $fdata = \ins::_db()->_get_data("com_finance", "*", "$w");

            $fee_value = 0;




            $t =  $fee["fee_value"];

            foreach ($fdata as $f) {

                $fee_value +=  $f["fee_value"];
                $t -=  $f["fee_value"];
            }
            $info_data = " data-student_id='{$d["id"]}' and data-act_id='{$activity["id"]}'  and data-fee_index='{$i}'";

            if ($fee_value == $fee["fee_value"]) {


                $table[] = [

                    ["data" => $d["name"], "class" => "ins_col_8"],
                    ["data" => $fee["fee_value"], "class" => "ins_col_3"],
                    ["data" =>  $fee_value, "class" => "ins_col_3"],
                    ["data" =>  "لا يوجد", "class" => "ins_col_3 ins_light"],
                    [
                        "class" => "ins_col_6 ins_text_tocenter ",
                        "data" => "  <i  $info_data     class='fas ins_get_fee_data   fa-info-circle'></i> <i   $info_data   class='fas    fa-check'></i>",
                    ],
                ];
            } else {

                $table[] = [
                    "data-student_id" => $d["id"],
                    "data-act_id" => $activity["id"],
                    "data-i" => $i,
                    "data-fee_value" => $fee["fee_value"], "class" => "_activity_get_row _row_act{$activity["id"]}student{$d["id"]}i$i",

                    "data-mode" => "activity",
                    "data" => [
                        ["data" => $d["name"], "class" => "ins_col_8"],
                        ["data" => $fee["fee_value"], "class" => "ins_col_3"],
                        ["data" =>  $fee_value, "class" => "ins_col_3"],
                        ["data" => ($fee["fee_value"] - $fee_value), "class" => "ins_col_3 ins_light"],

                        [
                            "data" => "
                            <i  $info_data     class='fas ins_get_fee_data   fa-info-circle'></i> 

            <i  data-student_id='{$d["id"]}'   data-mode ='activity' data-fee_value='$t' 
             data-act_id='{$activity["id"]}'  data-fee_index='$i' class='fas ins_icon_button btn_ui_pay  fa-money-check-alt'></i>
            <i  data-student_id='{$d["id"]}' data-fee_value='$t' 
             data-act_id='{$activity["id"]}'   data-mode ='activity'  data-fee_index='$i' class='fas ins_icon_button btn_fee_pay  fa-check'></i>", "class" => "ins_col_6 ins_text_tocenter"
                        ]
                    ]
                ];
            }
        }

        return     $table;
    }

    function  _activity_get_act_data_fee($activity, $i, $fee)
    {


        if ($activity["for"] == "class") {

            $cldata = \ins::_db()->_get_data("com_school_classes", "*", ins::_data()->_db_create_where_from_array($activity["for_type"]));
            foreach ($cldata as $cd) {

                $data[] = ["type" => "h2", "data" => $cd["title"], "style" => "margin-top:25px", "class" => "ins_col_12"];

                $w = "class='{$cd["id"]}'";
                $sdata = \ins::_db()->_get_data("com_school_dormitories", "*", ins::_data()->_db_create_where_from_array($activity["for_type"], "or", "class"));
                foreach ($sdata as $d) {
                    $activity["dormitory"] = $d["id"];
                    $data[] = ["type" => "h4", "data" => $d["title"], "style" => "margin-top:25px", "class" => "ins_col_12"];
                    $data[] =  ["type" => "table_divs", "data" =>  com_finance::_activity_get_act_dormitory($activity, $i, $fee), "class" => "ins_col_12"];
                }
            }
        } else   if ($activity["for"] == "dormitory") {

            $sdata = \ins::_db()->_get_data("com_school_dormitories", "*", ins::_data()->_db_create_where_from_array($activity["for_type"]));
            foreach ($sdata as $d) {
                $activity["dormitory"] = $d["id"];
                $data[] = ["type" => "h4", "data" => $d["title"], "style" => "margin-top:25px", "class" => "ins_col_12"];
                $data[] =  ["type" => "table_divs", "data" =>  com_finance::_activity_get_act_dormitory($activity, $i, $fee), "class" => "ins_col_12"];
            }
        }


        return  \lib::_ui()->_data($data)->_render();
    }

    function  _activity_get_act_data_ch($activity, $i, $fee)
    {


        $cldata = \ins::_db()->_get_data("com_school_activity", "*", "act_id='{$activity["id"]}'");

        foreach ($cldata as $cd) {

            $data[] = ["type" => "h2", "data" => $cd["title"], "style" => "margin-top:25px", "class" => "ins_col_12"];
            $students =  json_decode($cd["students"], true);
            $data[] = ["type" => "table_divs", "data" =>  com_finance::_activity_get_act_dormitory($activity, $i, $fee, array_keys($students)), "style" => "margin-top:25px", "class" => "ins_col_12"];
        }
        return  \lib::_ui()->_data($data)->_render();
    }

    function _activity_get_act_data($activity)
    {
        $activities["fees"] =  str_replace("[]", "", $activity["fees"]);
        $fees =  json_decode($activities["fees"], true);
        $data = [];
        foreach ($fees as  $k => $fee) {

            $date_string = $fee["fee_from_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_from_month"]) .
                " --> " . $fee["fee_to_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_to_month"]);
            $data[] =  ["type" => "block", "title" =>     $date_string, "style" => "margin-top:25px", "class" => "ins_col_12"];
            if ($activity["pay"] == "1") {
                $data[] =  ["type" => "div", "data" => $this->_activity_get_act_data_fee($activity, $k, $fee), "class" => "ins_col_12 ins_grid"];
            } else {
                $data[] =  ["type" => "div", "data" => $this->_activity_get_act_data_ch($activity, $k, $fee), "class" => "ins_col_12 ins_grid"];
            }

            $data[] =  ["type" => "end"];

            $data[] =  ["type" => "line"];
        }


        return  \lib::_ui()->_data($data)->_render();
    }
    /*@reginend view_by act  */


    function _data()
    {
        if ($this->g["mode"] == "act") {
            $activity = \ins::_db()->_get_row("com_school_activities", "*", "  id='{$this->g["id"]}'");
            $data = [
                "start" => ["class" => "ins_grid ins_dark", "style" => "padding:10px"],
                "h2" => ["data" => $activity["title"], "class" => "ins_col_11"],
                "a" => ["href" => ins::_map()->_url([], ["id", "mode"]), "data" => '<i font-size="font-size: 20px;" class="fas fa-arrow-left"></i>', "class" => "ins_col_1"],
                "end" => [],

                "line" => [],
                "div" => ["data" => $this->_activity_get_act_data($activity), "style" => "margin-top:25px", "class" => "ins_col_12"],
            ];

            $this->_return .= \lib::_ui()->_data($data)->_render();
        } else {

            $w = "id='{$this->g["id"]}'";

            $rq = ins::_map()->_get();
            $rq["mode"] = "students";



            if ($this->g["mode"] == "class") {
                $w = "class='{$this->g["id"]}'";
                $rq["class"] = $this->g["id"];
            } else if ($this->g["mode"] == "dormitory") {
                $w = "dormitory='{$this->g["id"]}'";
                $rq["dormitory"] = $this->g["id"];
            } else {
                $rq["student_id"] = $this->g["id"];
            }
            $sdata = \ins::_db()->_get_data("app_school_students", "*", $w);


            $data = [
                "start" => ["class" => "ins_grid ins_dark", "style" => "padding:10px"],
                "h2" => ["data" => $this->_get_update_des($rq), "class" => "ins_col_11"],
                "a" => ["href" => ins::_map()->_url([], ["id", "mode"]), "data" => '<i font-size="font-size: 20px;" class="fas fa-arrow-left"></i>', "class" => "ins_col_1"],
                "end" => [],
            ];

            foreach ($sdata as $d) {

                $data[] =  ["type" => "block", "title" => $d["name"], "style" => "margin-top:25px", "class" => "ins_col_12 st_block_data st_{$d["id"]}"];
                $data[] = ["type" => "i", "data-insaction" => "print_area", "data-area" => ".st_block_data.st_{$d["id"]}",  "class" => "   fas fa-print"];


                $data[] = ["type" => "h4", "data" => "Payments", "data-ar" => "مصروفات", "style" => "margin-top:25px", "class" => "ins_col_12"];
                $data[] = ["type" => "div", "data" => $this->_students_get_activies($d["id"], 1), "class" => "ins_col_12"];
                $data[] = ["type" => "line"];
                $data[] = ["type" => "span", "data-student_id" => $d["id"], "data" =>  "<span class='ins_col_10'>اضافة نشاط</span><i  
                
                class='fas  fa-hiking'></i>", "style" => "margin:25px", "class" => "ins_col_4 btn_student_to_act_ui ins_button"];
                $data[] = ["type" => "h4", "data" => "activtes", "data-ar" =>  "الانشطه", "style" => "margin-top:25px", "class" => "ins_col_12"];
                $data[] = ["type" => "div", "data" => $this->_students_get_activies($d["id"], 0),  "class" => "ins_col_12"];
                $data[] = ["type" => "end"];
                $data[] = ["type" => "line"];
            }

            $this->_return .= \lib::_ui()->_data($data)->_render();
        }
    }


    /** 
     *@regin Home Tabs 
     *  */

    function _get_update_des($rq)
    {


        $msg = "<i class='fas fa-info-circle'></i>";

        if ($rq["mode"] == "students") {
            $msg .= " عرض طلاب  ";




            if (isset($rq["class"]) && $rq["class"] != "") {
                $msg .= " الصف  ";
                $class = \ins::_db()->_get_row("com_school_classes", "*", "  id='{$rq["class"]}'");

                $msg .= "<strong>"  . $class["title"] . "</strong>";
            }


            if (isset($rq["dormitory"]) && $rq["dormitory"] != "") {
                $dormitory = \ins::_db()->_get_row("com_school_dormitories", "*", "  id='{$rq["dormitory"]}'");


                if (!isset($rq["class"])) {
                    $msg .= " الصف  ";
                    $class = \ins::_db()->_get_row("com_school_classes", "*", "  id='{$dormitory["class"]}'");
                    $msg .= "<strong>"  . $class["title"] . "</strong>";
                }

                $msg .= " الفصل  ";
                $msg .= "<strong>"  .  $dormitory["title"] . "</strong>";
            }


            if (isset($rq["student_id"]) && $rq["student_id"] != "") {
                $activities = \ins::_db()->_get_row("app_school_students", "*", "  id='{$rq["student_id"]}'");



                if (!isset($rq["class"])) {
                    $msg .= " الصف  ";
                    $class = \ins::_db()->_get_row("com_school_classes", "*", "  id='{$activities["class"]}'");
                    $msg .= "<strong>"  . $class["title"] . "</strong>";
                }


                if (!isset($rq["dormitory"])) {
                    $dormitory = \ins::_db()->_get_row("com_school_dormitories", "*", "  id='{$activities["dormitory"]}'");
                    $msg .= " الفصل  ";
                    $msg .= "<strong>"  .  $dormitory["title"] . "</strong>";
                }


                $msg .= " الطالب  ";
                $msg .= "<strong>"  . $activities["name"] . "</strong>";
            }
        } else {
            $msg .= " عرض مصروفات ";
            if (isset($rq["act_id"]) && $rq["act_id"] != "") {

                $activities = \ins::_db()->_get_row("com_school_activities", "*", "  id='{$rq["act_id"]}'");

                $msg .= "<strong>"  . $activities["title"] . "</strong>";
            }

            if (isset($rq["fee"]) && $rq["fee"] != "") {
                $msg .= " الدفعه خلال ";

                $activities["fees"] =  str_replace("[]", "", $activities["fees"]);
                $fees =  json_decode($activities["fees"], true);

                $fee = $fees[$rq["fee"]];

                $date_string = $fee["fee_from_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_from_month"]) .
                    " --> " . $fee["fee_to_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_to_month"]);


                $msg .= "<strong>"  . $date_string . "</strong>";
            }
        }


        $ui_data[] =  ["type" => "div", "data" =>   $msg, "class" => "ins_col_12  ins_info   "];

        return ins::_ui()->_data($ui_data)->_render();
    }


    function _get_act_fees($rq)
    {
        $c = \ins::_db()->_get_row("com_school_activities", "*", "  id='{$rq["act_id"]}'");


        $c["fees"] =  str_replace("[]", "", $c["fees"]);
        $fees =  json_decode($c["fees"], true);
        $data = '';
        $data .= "<option value=''></option>";
        foreach ($fees as $k => $fee) {
            $date_string = $fee["fee_from_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_from_month"]) .
                " --> " . $fee["fee_to_day"] . " " . ins::_data()->_datetime()->_lang_month($fee["fee_to_month"]);

            $data .= "<option value='$k'> $date_string </option>";
        }

        return   $data;
    }

    function _student_ui_add()
    {


        $uidata = [
            "start" => ["class" => "ins_grid"],
            "class" => ["title" => 'class', "title-ar" => "الصف", "type" => 'select', "select_type" => "db", "select_table" => "com_school_classes", "pclass" => ' ins_col_12'],
            "dormitory" => ["title" => 'dormitory', "title-ar" => "الفصل", "type" => 'select',  "pclass" => ' ins_col_12'],
            "student_id" => ["title" => 'student', "title-ar" => "الطالب", "type" => 'select',  "pclass" => ' ins_col_12'],
            "button" => [
                "data-url" => \ins::_eng()->_url([], ["id", "mode"]), "class" => '_get_student_fin ins_col_12',
                "data" => "Next ", "data-ar" => "  التالى"
            ],
            "end" => [],

        ];



        $actuidata = [
            "start" => ["class" => "ins_grid"],
            "active" => [
                "title" => 'class',
                "select_query" => 'free=0',
                "title-ar" => "المصروف", "type" => 'select', "select_type" => "db", "select_table" => "com_school_activities", "pclass" => ' ins_col_12'
            ],
            "fee" => ["title" => 'fee', "title-ar" => "الدفعه", "type" => 'select',  "pclass" => ' ins_col_12'],
            "button" => [
                "data-url" => \ins::_eng()->_url([], ["id", "mode"]), "class" => '_get_acts_fin ins_col_12',
                "data" => "Next ", "data-ar" => "  التالى"
            ],
            "end" => [],

        ];

        $ui_data[] =  ["type" => "div", "class" => "ins_col_12 ins_grid _get_update_des  "];
        $ui_data[] =  [

            "type" => "ins_tabs", "data" => '[
            {"data":"  students " ,"data-ar":"   طلاب"  ,"class":"ins_col_6 students_tab_li" ,"data-show":".students_tab"},
            {"data":"  activities" ,"data-ar":"  مصروفات"  ,"class":"ins_col_6 activities_tab_li" ,"data-show":".activities_tab"}
        
        ]'
        ];

        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid students_tab  "];
        $ui_data[] =  ["type" => "div", "data" => ins::_ui()->_data($uidata)->_render(), "class" => "ins_col_12    "];
        $ui_data[] =  ["type" => "end"];


        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid activities_tab  ins_hidden"];
        $ui_data[] =  ["type" => "div", "data" => ins::_ui()->_data($actuidata)->_render(), "class" => "ins_col_12    "];

        $ui_data[] =  ["type" => "end"];
        $ui_data[] =  ["type" => "ins_tabs_end"];

        return ins::_ui()->_data($ui_data)->_render();
    }


    /*@regin strat no id  ui  */
    function _out()
    {


        if (isset($this->g["id"])) {
            $this->_data();
        } else {
            $this->_return = $this->_student_ui_add();
        }

        return  \lib::_ui()->_data([
            "div" => ["data" => $this->_return, "data-paycon" => "سوف يتم تنفذ عمليه دفع بقيمة @fee_value ",  "class" => "ins_col_12 _finance_com_data"]
        ])->_render();
    }
}
