<?php

class com_home extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }


/**
menu
 */

function _get_menu($rq)
{
    $data = [
        "start" => ["class" => "home_main"],
        "search" => ["input" => "true", "placeholder" => $this->_lang["search"] . "...", "class" => "col12"],
        "start-data" => ["class" => "menu_data ins_grid"]
    ];

    $w = "cat_id=:menu";
    $w_data = ["menu" => $rq["menu"]];

    if (isset($rq["parent"]) && $rq["parent"] != "") {
        $w .= " and id=:id ";
        $w_data["id"] = $rq["parent"];
    } else {
        $w .= " and  parent_id = '0' ";
    }


    $ms = ins::_db()->_get_data("sys_menus_items", "*", "$w order by `sys_order`", $w_data);


    $sopen = " ins_opend ";
    foreach ($ms as $pm) {


        if (ins::_eng()->is_in_status("sys_menus_items", $pm["id"]) && $this->__users->_permission_chk($pm)) {
            ins::_data()->_update_language($pm);
            $subms = $this->__db->_get_data("sys_menus_items", "*", "parent_id='" . $pm["id"] . "' order by `sys_order`");
            $data[] = ["type" => "block",'title'=>$pm["title"], "class" => "ins_col_12 ins_grid ins_border_bottom    $sopen"];

            $sopen = "";
            foreach ($subms as $m) {
                if ($this->__eng->is_in_status("sys_menus_items", $m["id"]) && $this->__users->_permission_chk($m)) {
                    ins::_data()->_update_language($m);
                    $this->__data->_update_data_language("sys_menus_items", $m);
                    $data[] = ["type" => "start", "class" => " ins_col_3 ins_card_btn ins_light"];
                    $h_m = "";
                    if ($this->_fav_chack($m)) {
                        $h_m = " act ";
                    }
                    $data[] = ["type" => "a", "data" => "<span>" . $m["icon"] . "</span> <i data-id='" . $m["id"] . "' class=\"fas ins_change_fav  $h_m fa-heart\"></i>"
                        . $m["title"], "href" => \ins::_eng()->_url(["alias" => $m["alias"]])];
                    $data[] = ["type" => "end"];
                }
            }
            $data[] = ["type" => "end"];
        }
    }


    $h = $this->__db->_get_row("sys_html", "*", " id=:id  ", ["id" => "74"]);

    $data["end-data"] = [];
    $data["line-pc"] = [];
    $data["div-pc"] = ["data" => $h["content"]];
    $data["end"] = [];
    return \ins::_ui()->_data($data)->_render();
}



/**
menu
 */



    function _cal()
    {





        $data = \ins::_db()->_get_data("com_calendar");

        foreach ($data as $d) {
            $mstyle = "";
            if ($d['color'] != "") {
                $mstyle .= ' style="background:' . $d['color'] . '" ';
            }
            $v = "<b  $mstyle class=\"ins_calendar_event_data\" data-id=\"" . $d['id'] . "\">" . $d["icon"] . " " . ins::_data()->get_ins_list("calendar_event_type", $d["calendar_event_type"])["text"] . "</b>";
            $cldata[] = [
                "from" => $d["c_from"],
                "to" => $d["c_to"],
                "text" => $v
            ];
        }



        $uidata = [
            "type" => "div",
            "data-cl" => json_encode($cldata),
            "data-lang" => ins::_eng()->_this_lang,
            "class" => "mycal ins_mode_calendar ins_calendar", "data" => "<span></span>"
        ];




        return ins::_ui()->_data($uidata)->_render();
    }

    function _get_mydata()
    {

        $udata = $_SESSION["sys_users_login_data"];
        $entities_data = \ins::_eng()->_isd()->_get_user("job_data");
        $udata = $_SESSION["sys_users_login_data"];
        if (isset($_SESSION["sys_users_login_ex_data"])) {
            $udata = array_merge($udata, $_SESSION["sys_users_login_ex_data"]);
        }
        if (isset($udata["name"])) {
            $udata["title"] = $udata["name"];
        }

        $data = [
            "span" => [
                "data" => ins::_map()->_format("datetime", "now"), "class" => "  ins_texttocenter",
                "style" => 'position: absolute;top: 0;left: 20px;width: auto;font-size: 12px;'
            ],
            "start" => ["class" => "ins_card ins_grid h_user_data "],
            "img" => ["src" => $udata["image"], "pclass" => " ins_col_1", "pstyle" => 'grid-row-start: 1;grid-row-end: 3;'],
            "h4" => ["data" => $udata["title"], "class" => "ins_float_right ins_col_8 "],
            "h5" => ["data" => $entities_data==null?"": $entities_data=["title"], "class" => "ins_float_right ins_col_8"],
            "start-btns" => ["class" => "  ins_grid ins_col_4 ",
                "style" => "text-align: CENTER;padding: 4px;grid-row-start: 1;grid-row-end: 3;grid-column-start: 10;"
            ],
            "a" => ["#", "class" => "insaction ins_col_6 ", "data-insaction" => "logout", "data" => '<i class="fas fa-edit"></i>'],
            "a-btns" => ["#", "class" => "insaction ins_col_6", "style" => "color:red", "data-insaction" => "logout", "data" => '<i style="    color: #fd4b4b;" class="fas fa-power-off" ></i>'],
            "start-sss" => ["class" => " ins_col_12 h_user_data ", "data" => "span"],
            "a-btns2" => [
                "#", "class" => "ins_button ins_col_12 ins_set_checkin","data-employee" => "{$udata["id"]}",
                "data-ar" => '<i class="far fa-clock"></i> تسجيل دخول النظام',"data" => '<i class="far fa-clock"></i>  Checkin  '
            ],
            "end-sss" => ["data" => "span"],
            "end-btnsdata" => ["class" => ""],
            "end-data" => ["class" => ""]
        ];

        return \ins::_ui()->_data($data)->_render();
    }

    function _add_remove_tofav($m)
    {
        $old_data = ins::_db()->_get_row("sys_menus_items", "*", " id=:id", ["id" => $m["id"]]);
        $status = "";
        if (com_home::_fav_chack($old_data)) {
            ins::_db()->_delete("sys_menus_items", " alias='" . $old_data["alias"] . "' and cat_id=33 ");
            $status = "remove";
        } else {

            $old_data["parent_id"] = "0";
            $old_data["cat_id"] = "33";
            unset($old_data["id"]);
            $old_data = ins::_db()->_insert("sys_menus_items", $old_data);
            $status = "add";
        }
        return $status;
    }

    function _fav_chack($m)
    {
        $favid = "33";
        $ms = ins::_db()->_get_row("sys_menus_items", "*", " alias=:alias and  cat_id=:favid", ["alias" => $m["alias"], "favid" => $favid]);
        return is_array($ms);
    }


    function _out()
    {


        $this->_include("my_style.css");
        $this->_include("my_js.js");



        $data = [
            ["type" => "start", "class" => "ins_grid", "style" => "    align-items: start;"],
           // ["type" => "div", "data" => $this->_get_mydata(), "class" => " ins_col_12"],
            ["type" => "div", "data" => $this->_get_menu($this->_pro), "class" => "ins_card ins_col_12"],
       //     ["type" => "div", "data" => $this->_cal(), "class" => "ins_col_5 ins_card"],
            ["type" => "end"]
        ];



        return \ins::_ui()->_data($data)->_render();
    }
}
