<?php

class com_hr_checkin_chackout extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }
    /**
report
     */

    function _report_checkin_checkout($rq)
    {
        $prefix = "chreport";

        $uidata[] = ["type" => "start", "class" => "ins_grid"];
        $uidata[] = ["type" => "h4", "class" => "ins_col_12", "data" => "عداد الزوار"];
        $uidata[] = [
            "title" => "عرض حسب",

            "data-employee" => $rq["employee"],

            "type" => "select", "pclass" => "ins_col_12 ", "value" => "",
            "class" => "_{$prefix}_inpt_type", "value" => "week", "select_value" => "all,last_week,last_month,week,month,wheel",
            "select_text" => "الكل,اخر   سبع ايام ,اخر 30 يوم,هذا الاسبوع,هذا الشهر,محددة"
        ];
        $uidata[] = ["type" => "div", "class" => "ins_col_12 _{$prefix}_inpt_data"];
        $uidata[] = ["type" => "end"];

        return \ins::_ui()->_data($uidata)->_render();
    }

    function _report_duration($rq)
    {
        $prefix  = "chreport";
        $w = "1=1";

        $from_code = "";

        if ($rq["type"] == "last_week") {
            $from_code = "-7 day";
            $from_to = "+1 day";
        } else if ($rq["type"] == "last_month") {
            $from_code = "-7 day";
            $from_to = "+1 day";
        } else   if ($rq["type"] == "week") {
            $from_code = "last Saturday";
            $from_to = "next Thursday";
        } else if ($rq["type"] == "month") {

            $from_code = "first day of this month";
            $from_to = "last day of this month";
        } else if ($rq["type"] == "wheel") {
            $from_code = "-7 day";
            $from_to = "+1 day";
        }


        if ($rq["type"] != "all") {

            $rq["from"] = $rq["from"] ? $rq["from"] :  ins::_data()->_datetime()->_date($from_code);
            $rq["to"]  = $rq["to"] ? $rq["to"] : ins::_data()->_datetime()->_date($from_to);

            $rq["from_text"]    = $rq["from"] ? $rq["from"] :  ins::_data()->_datetime()->_date($from_code);
            $rq["to_text"] = $rq["to"] ? $rq["to"] : ins::_data()->_datetime()->_date($from_to);

            $rq["w"] =  ins::_data()->_datetime()->_db_select_between_two_dates_sql($rq["from"], $rq["to"]);
        }

        $uidata[] = ["type" => "start", "class" => "ins_grid"];

        if ($rq["type"] != "all") {
            $uidata[] = ["type" => "date", "input" => "true", "value" =>  $rq["from"], "pclass" => "ins_col_6", "class" => "_{$prefix}_inpt_from"];
            $uidata[] = ["type" => "date", "input" => "true", "value" =>  $rq["to"], "pclass" => "ins_col_6", "class" => "_{$prefix}_inpt_to"];
        }
        $uidata[] = ["type" => "div", "class" => "ins_col_12 ins_grid", "data" => com_hr_checkin_chackout::_report_checkin_checkout_body($rq)];
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function _report_checkin_checkout_body($rq)
    {



        $title = "تقرير غياب وحضور  عن الفترة  ";
        $title .=  " من " . " " . $rq["from_text"] . " الى " . " " . $rq["to_text"];


        $uidata[] = ["type" => "start", "class" => " ins_col_12 ins_grid"];
        $uidata[] = ["type" => "h4", "class" => "ins_col_12", "data" => $title];

        $uidata[] = ["type" => "div", "class" => "ins_col_12", "data" => com_hr_checkin_chackout::_data_Period_table($rq)];


        $uidata[] = ["type" => "end"];

        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function _data_Period_table($rq)
    {

        $data_p =   \ins::_data()->_datetime()->_date_period($rq["from"], $rq["to"]);
        // $options = [];
        $table = [];
        $chartdatas = [];
        $table[] = [
            ["data" => "التاريخ", "class" => "ins_col_6"],
            ["data" => "", "class" => "ins_col_16"],

        ];

        $chartdatas[] = ["date", "checkin", "checkout"];
        foreach ($data_p as  $d) {
            $table_row = [];
            $c  = ins::_db()->_get_row("com_hr_employee_day", '*',  "date='$d' and employee='{$rq["employee"]}'");
            $data = json_decode($c["data"], true);
            $chdata = [];
            for ($i = 0; $i < count($data["chackin"]); $i++) {

                $chdata[] = 
                
                [
                    "chackin_time"=> \ins::_map()->_format("time",$data["chackin"][$i]["time"])  ,
                    "chackin_location"=>   $data["chackin"][$i]["location"],
                    "chackout_time"=> \ins::_map()->_format("time",$data["chackout"][$i]["time"]) ,
                    "chackout_location"=>   $data["chackout"][$i]["location"],


                ];
                
             
            }


     
            $table_row[] =  ["data" => ins::_data()->_datetime()->_date($d, "D Y/m/j"),     "class" => "ins_col_6"];

            $chartdatas[] = [$d, $data["chackin"][0], $data["chackin"][1]];




            foreach ($chdata as $k => $v) {


                $tduidata =[];
                $tduidata[] = ["class" => "ins_col_12 ins_grid","style"=>"    align-items: center;", "type" => "start"];

                $tduidata[] = ["type" => "div" ,"data-insaction"=>"tooltip","data-title"=> $v["chackin_location"] ,"class"=>"ins_col_5","data"=> $v["chackin_time"] ];

                $tduidata[] = ["type" => "i" ,"class"=>"ins_col_2 fas fa-arrow-left"];

                $tduidata[] = ["type" => "div" ,"data-insaction"=>"tooltip","class"=>"ins_col_5","data-title"=> $v["chackout_location"]  ,"style"=>"line","data"=> $v["chackout_time"] ];
                
                $tduidata[] = ["type" => "end"];



                $tdata=  \ins::_ui()->_data($tduidata)->_render();

                $table_row[] = ["data" =>  $tdata , "class" => "ins_col_4 ins_dark"];
            }
            $table[] = $table_row;
            $table[] = [
                ["class" => "ins_col_12"],

            ];
        }

        /*  $options = [
            "title" => "الغياب والحضور",
            "data" =>  $chartdatas

        ];
        $uidata[] = ["type" => "div", "class" => "ins_col_10 insaction", 'data-chart' => "_bar", 'data-options' => json_encode($options), 'data-insaction' => "chart", "style" => "align-items: start;height:400px"];
       */

        $uidata[] = ["class" => "ins_col_12", "data" => $table, "type" => "table_divs"];
        return  \ins::_ui()->_data($uidata)->_render();
    }


    function  chack_report($data, $dbdata)
    {
        $prefix  = "chreport";
        $uidata[] = ["type" => "i", "data-employee" => $dbdata["id"], "class" => "far _btn_{$prefix}_checkin_checkout fa-chart-bar"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    /**
report
     */


    /**
other
     */

    function chack_btn($data, $dbdata)
    {

        /*  $lang = \lib::_eng()->_get_lang_xml("/com_hr/com_hr_checkin_chackout");

        $w = " employee='" . $dbdata["id"] . "' and date='" . date("Y-m-d") . "'";
       $array_ch = ins::_db()->_get_row("com_hr_employee_day", '*', $w);

       $last_status = "";
        $last_status_data = "";
        if (is_array($array_ch)) {
            $last_status = $array_ch["last_status"];
            $last_status_data = $array_ch["last_status_data"];
        }
        $data = [];
        if ($last_status == "checkin") {
            $data[] = ["type" => "div", "data-employee" => $dbdata["id"], "style" => "text-align:center", "class" => "ins_button ins_set_checkout", "data" => $lang["checkout"] . "  <i class=\"fas fa-user-times\"></i>"];
            $data[] = ["type" => "div", "data" => $lang["checkin_msg"] . '   ' . $last_status_data];
        } else {
            $data[] = ["type" => "div", "data-employee" => $dbdata["id"],
             "style" => "text-align:center", "class" => "ins_button ins_set_checkin",
              "data" => $lang["checkin"] . "<i class=\"fas fa-user-check\"></i>"];
            $data[] = ["type" => "div", "data" => $lang["checkout_msg"] . '   ' . $last_status_data];
        }
       // return ins::_ui()->_data($data)->_render();*/

        return  com_hr_checkin_chackout::_chack_status(["employee" => $dbdata["id"]]);
    }

    function _chack_out($rq)
    {


        $w = " employee='" . $rq["employee"] . "' and date='" . date("Y-m-d") . "'";
        $array_ch = ins::_db()->_get_row("com_hr_employee_day", '*', $w);



        $last_status_data = date("G:i:s");
        if (is_array($array_ch)) {
            $ddata = json_decode($array_ch["data"], true);
            $ddata["chackout"][] = ["time" => $last_status_data, "location" => $rq["location"]];
            $data = [
                "data" => json_encode($ddata),
                "last_status_data" => $last_status_data,
                "last_location" => $rq["location"],

                "last_status" => "checkout"
            ];
            ins::_db()->_update("com_hr_employee_day", $data, $w);
        } else {
            $ddata = [];
            $ddata["chackout"][] = ["time" => $last_status_data, "location" => $rq["location"]];
            $data = [
                "employee" => $rq["employee"],
                "last_status_data" => $last_status_data,
                "date" => date("Y-m-d"),
                "last_location" => $rq["location"],
                "last_status" => "checkout",
                "data" => json_encode($ddata)
            ];
            ins::_db()->_insert("com_hr_employee_day", $data);
        }
        return  com_hr_checkin_chackout::_chack_status($rq);
    }
    function _chack_status($rq)

    {


        $lang = \lib::_eng()->_get_lang_xml("/com_hr/com_hr_checkin_chackout", $rq["_lang"]);

        $w = " employee='" . $rq["employee"] . "' and date='" . date("Y-m-d") . "'";
        $array_ch = ins::_db()->_get_row("com_hr_employee_day", '*', $w);
        if (is_array($array_ch)) {
            $data = [];

            $lang_data =   ($array_ch["last_status"] == "checkin") ?    $lang["checkout"] : $lang["checkin"];
            $lang_msg =   ($array_ch["last_status"] == "checkin") ?    $lang["checkin_msg"] : $lang["checkout_msg"];
            $class_data =   ($array_ch["last_status"] == "checkin") ?  "ins_set_checkout" : "ins_set_checkin";

            $data[] = [
                "type" => "div", "data-employee" =>  $rq["employee"], "style" =>
                "text-align:center", "class" => "ins_button ins_col_12  $class_data",
                "data" => $lang_data . "  <i class=\"fas fa-user-times\"></i>"
            ];

            $ltime = ins::_map()->_format("time", $array_ch["last_status_data"]);

            $data[] = ["type" => "div", "data" =>  $lang_msg . ' <strong>' .  $ltime . "
        </strong><br/>" . $lang["location_msg"] .
                "<strong><a href='https://www.google.com/maps/search/?api=1&query={$array_ch["last_location"]}' target='_blank'> {$array_ch["last_location"]}</a></strong>"];
        } else {



            $lang_data =   $lang["checkin"];
            $lang_msg =  $lang["checkout_msg"];
            $class_data =   "ins_set_checkin";

            $data[] = [
                "type" => "div", "data-employee" =>  $rq["employee"], "style" =>
                "text-align:center", "class" => "ins_button ins_col_12  $class_data",
                "data" => $lang_data . "  <i class=\"fas fa-user-times\"></i>"
            ];





            $data[] = ["type" => "div", "data" =>  $lang["no_checkin_msg"]];
        }


        return ins::_ui()->_data($data)->_render();
    }
    function _chack_in($rq)
    {
        $lang = \lib::_eng()->_get_lang_xml("/com_hr/com_hr_checkin_chackout", $rq["_lang"]);

        $w = " employee='" . $rq["employee"] . "' and date='" . date("Y-m-d") . "'";

        $array_ch = ins::_db()->_get_row("com_hr_employee_day", '*', $w);
        $last_status_data = date("G:i:s");

        if (is_array($array_ch)) {
            $ddata = json_decode($array_ch["data"], true);
            $ddata["chackin"][] = ["time" => $last_status_data, "location" => $rq["location"]];
            $data = [
                "last_status" => "checkin",
                "last_location" => $rq["location"],

                "last_status_data" =>  $last_status_data,
                "data" => json_encode($ddata)
            ];
            ins::_db()->_update("com_hr_employee_day", $data, $w);
        } else {

            $ddata = [];
            $ddata["chackin"][] = $last_status_data;
            $data = [
                "employee" => $rq["employee"],
                "last_status_data" => $last_status_data,
                "date" => date("Y-m-d"),
                "last_location" => $rq["location"],

                "last_status" => "checkin",
                "data" => json_encode($ddata)
            ];
            ins::_db()->_insert("com_hr_employee_day", $data);
        }

        $data = [];
        return  com_hr_checkin_chackout::_chack_status($rq);
    }


    /**
other
     */

    function _out()
    {
        $data = [];
        $msg = "";
        $langdata = ["date" => "<span class='_data ins_dark '>" . date("d/m/Y") . "</span>", "time" => "<span class='ins_dark _time'>" . date("g:i a ") . "</span> "];
        $msg = ins::_data()->_lang_trans($this->_lang["gen_msg"], $langdata);
        if ($this->_lang == "ar") {
            $this->_include("style-ar.css");
        }
        $data[] = ["type" => "div", "class" => "ins_col_12 ins_info", "data" => $msg];
        $data[] = ["type" => "div", "class" => "ins_col_12", "data" => lib::_pages()->get_page("admin", "com_hr_employees")];
        return ins::_ui()->_data($data)->_render();
    }
}
