<?php

class com_hr_leaves extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    function _chack_array($data, $array)
    {
        $r = false;

        $data = explode(",", $data);



        foreach ($data as $d) {

            if (in_array($d, $array)) {
                return true;
            }
        }

        return $r;
    }



    function _get_query_by_row($d)
    {
        if ($d["accrual"] == "ontime") {
            $w = "";
        } else if ($d["accrual"] == "monthly") {

            $w = " and  com_hr_leaves.from >'" . date("Y") . "-" . date("m") . "-01' ";
        } else if ($d["accrual"] == "yearly") {
            $y = date("Y");
            if (strtotime(date("Y") . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"]) > strtotime(date('Y-m-d'))) {
                $y--;
            }
            $w = " and  com_hr_leaves.from >'" . $y . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"] . "' ";
        } else if ($d["accrual"] == "half_yearly") {

            if (strtotime(date("Y") . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"]) > strtotime(date('Y-m-d'))) {


                $h2 = strtotime((date("Y")) . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"] . "  -6 month");

                if ($h2 > strtotime(date('Y-m-d'))) {

                    $dat = (date("Y") - 1) . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"];
                } else {

                    $dat = date("Y-m-d", $h2);
                }
            } else {
                $dat = date("Y") . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"];
            }



            $w = " and  com_hr_leaves.from >'$dat' ";
        } else if ($d["accrual"] == "quarterly") {
            $qs = [];

            for ($i = 0; $i < 5; $i++) {
                $h2 = strtotime((date("Y")) . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"] . "  +" . ($i * 3) . " month");
                if (date("Y", $h2) > date("Y")) {
                    $h2 = strtotime((date("Y") - 1) . "-" . $d["accrual_from"] . "-" . $d["accrual_from_day"] . "  +" . ($i * 3) . " month");
                }

                $qs[] = $h2;
            }

            for ($i = 0; $i < 4; $i++) {

                if ($qs[$i] < strtotime(date('Y-m-d')) && $qs[$i + 1] > strtotime(date('Y-m-d'))) {
                    $dat = date("Y-m-d", $qs[$i]);
                    break;
                }
            }



            $w = " and  com_hr_leaves.from >'$dat' ";
        }
        return $w;
    }
    function _chk_leav_daies($rq)
    {
        $data = ins::_db()->_get_row("com_hr_leaves_types", "*", "id='" . $rq["id"] . "'");
        if ($data["days"] > 0) {
            return date('Y-m-d', strtotime($rq["from"] . ' + ' . $data["days"] . ' days'));
        } else {

            return 0;
        }
    }

    function _chk_rols($d)
    {

        $ex_data = $_SESSION["sys_users_login_ex_data"];

      $c_status_id = \ins::_eng()->_isd()->_isd_get_status("accept","id");

        $ex_data["job"] = explode(",", $ex_data["job"]);
        $ex_data["branch"] = explode(",", $ex_data["branch"]);
        $ex_data["department"] = explode(",", $ex_data["department"]);




        $enabled = true;

        if ($d["gender"] != "" && $d["gender"] != $ex_data["gender"]) {
            $enabled = false;
        }



        if ($d["job"] != "" && $d["job"] != "0" && !com_hr_leaves::_chack_array($d["job"], $ex_data["job"])) {
            $enabled = false;
        }
        if ($d["branch"] != "" && $d["branch"] != "0" & !com_hr_leaves::_chack_array($d["branch"], $ex_data["branch"])) {
            $enabled = false;
        }
        if ($d["department"] != "" && $d["department"] != "0" &  !com_hr_leaves::_chack_array($d["department"], $ex_data["department"])) {
            $enabled = false;
        }
        if ($d["marital_status"] != ""  && $d["marital_status"] != $ex_data["marital_status"]) {
            $enabled = false;
        }


        if ($d["effective_after"] != "" && $d["effective_after_type"] != "") {
            $ldate = strtotime('-' . $d["effective_after"] . " " . $d["effective_after_type"]);
            $exdate = strtotime($ex_data["date_of_joining"]);
            if ($ldate < $exdate) {
                $enabled = false;
            }
        }

        if ($d["leave_from"] != "" && $d["leave_to"] != "" && $d["leave_from"] != "0000-00-00" && $d["leave_to"] != "0000-00-00") {
            $leave_from = strtotime($d["leave_from"]);
            $leave_to = strtotime($d["leave_to"]);
            $today = strtotime("now");

            if (!($leave_from < $today && $today < $leave_to)) {
                $enabled = false;
            }
        }




        if ($d["accrual"] != "") {
            $w = "";


            $w =  com_hr_leaves::_get_query_by_row($d);

            $data = \ins::_db()->_get_row("com_isd_status", "*", "mode='accept'");
            //_isd_get_status
           

            $sql = "select com_hr_leaves.*,com_isd_operations.isd_status from  
                com_hr_leaves INNER JOIN com_isd_operations ON  (com_isd_operations.isd_table='com_hr_leaves'  "
                . " and com_isd_operations.isd_table_id=com_hr_leaves.id   and com_hr_leaves.leave_type='" . $d["id"] . "'  "
                . " and com_hr_leaves.employee_id='" . $_SESSION["sys_users_login_ex_data"]["id"] . "' and com_isd_operations.isd_status= $c_status_id) ";

            $olddata = ins::_db()->_get_query($sql);



            if (is_array($olddata[0])) {
                $enabled = false;
            }
        }

        return $enabled;
    }

    function _get_balance()
    {
        if (isset($_SESSION["sys_users_login_ex_data"]["id"])) {

            $tydata = ins::_db()->_get_data("com_hr_leaves_types", "*", "from_balance=1");
            $types = [];
            foreach ($tydata as $ty) {
                $types[] = $ty["id"];
            }

            $data = \ins::_db()->_get_row("com_hr_employees", "*", 'id=' . $_SESSION["sys_users_login_ex_data"]["id"]);

            $r = [];
            $c_status_id = \ins::_eng()->_isd()->_isd_get_status("accept","id");


            $sql = "select com_hr_leaves.*,com_isd_operations.isd_status from "
                . "  com_hr_leaves INNER JOIN com_isd_operations ON "
                . " (com_isd_operations.isd_table='com_hr_leaves'  "
                . " and com_isd_operations.isd_table_id=com_hr_leaves.id   "
                . " and com_hr_leaves.employee_id='" . $_SESSION["sys_users_login_ex_data"]["id"] . "' and com_isd_operations.isd_status=$c_status_id) ";
            $olddata = \ins::_db()->_get_query($sql);
            $sum = 0;
            foreach ($olddata as $d) {
                if (in_array($d["leave_type"], $types)) {
                    $sum += ins::_data()->_datetime()->howManyDays($d["from"], $d["to"]);
                }
            }
            $r["all"] = $data["leaves_balance"];
            $r["used"] = $sum;

            $r["left"] = ($data["leaves_balance"] - $sum);
        }


        return $r;
    }

    function _get_leaves_type_options($rq)
    {

        $data = ins::_db()->_get_data("com_hr_leaves_types");
        $ui_data = [];

        $r = "<option ></option>";
        foreach ($data as $d) {
            if (com_hr_leaves::_chk_rols($d)) {

                $mclass = "";
                if (isset($rq["value"]) && $rq["value"] == $d["id"]) {

                    $mclass = "selected";
                }

                $r .= "<option $mclass value='" . $d["id"] . "'>" . $d["title"] . "</option>";
            }
        }


        return $r;
    }

    function _get_leaves_type($data, $db_data)
    {

        $data = ins::_db()->_get_data("com_hr_leaves_types");
        $ui_data = [];

        $ui_data[] = ["type" => "start", "class" => "ins_grid ins_list"];
        foreach ($data as $d) {
            $ex_data = $_SESSION["sys_users_login_ex_data"];

            $daysdata =  \ins::_db()->_get_row("com_hr_leaves", "  SUM(DATEDIFF( `to` ,`from`) )
            AS days", " com_hr_leaves.employee_id='" . $ex_data["id"] . "' and com_hr_leaves.leave_type='" . $d["id"] . "' " . com_hr_leaves::_get_query_by_row($d));

            $daysdata["days"]=$daysdata["days"]?$daysdata["days"]:"0";


           if (com_hr_leaves::_chk_rols($d) && ($d["balance"] > $daysdata["days"] || $d["balance"] == "0")) {

                $b=$d["balance"]=="0"?"غير محدود" :$d["balance"];


                $ui_data[] = ["data-type" => $d["id"], "type" => "start", "class" => "ins_col_4  ins_card hl_leaves_type_btn ins_texttocenter"];
                $ui_data[] = ["type" => "div", "data" => $d["icon"], "style" => "font-size:30px"];
                $ui_data[] = ["type" => "b", "data" => $d["title"]];
                $ui_data[] = ["type" => "line"];
                $ui_data[] = ["type" => "span", "data" =>  $daysdata["days"]];

                $ui_data[] = ["type" => "span", "data" => "/"] ;
                $ui_data[] = ["type" => "span", "data" => $b  ];

                $ui_data[] = ["type" => "end"];
        }
        }
        $ui_data[] = ["type" => "end"];

        return ins::_ui()->_data($ui_data)->_render();
    }

    function _status($data, $db_data)
    {


        $data = ins::_eng()->_isd()->_isd_gestatus(["isd_table" => "com_hr_leaves", "isd_table_id" => $db_data["id"]]);

        return "<b style='background:" . $data["color"] . " ;    padding: 5px 10px;'>" . $data["title"] . "</b>";
    }

    function _get_type($data, $db_data)
    {
        $tydata = ins::_db()->_get_row("com_hr_leaves_types", "*", "id=" . $db_data["leave_type"]);

        return $tydata["title"];
    }

    function _test($id)
    {
        ins::_eng()->_isd()->_start_path($_POST["isd_path"], "com_hr_leaves", $id);
    }

    function _out()
    {
        $_SESSION["employee_id"] = $_SESSION["sys_users_login_ex_data"]["id"];

        if ($_POST["form_mode"] == "add") {
            $_POST["employee_id"] = $_SESSION["sys_users_login_ex_data"]["id"];
            $_POST["isd_path"] = $this->_pro["code"];
        }

        $options = ["fun_after_add" => "com_hr_leaves::_test"];





        $r =  \lib::_ui()->_data(
            ["div" => ["data" => \ins::_pages()->_admin("com_hr_leaves", $options)->_render(), 
            
            "data-lb_title" =>$this->_lang["add_lb_title"],
            "class" => "ins_col_12 com_hr_leaves_data"]])
            ->_render();





        if (\ins::_app_map()->_get()["mode"] == "edit") {





?>

            <style>
                .ins_grid.ins_page_actions {
                    display: none !important;
                }
            </style>
<?php

            $r .= "<br/><br/><br/><div class='line'/><div style=' 
            clear: both;
    margin: 25px;
    display: BLOCK;
            
            padding: 10px; margin: 10px;direction: RTL;;' class='info'>  
            <i class=\"fas fa-info-circle\"></i>تم إرسالها الى الادارة للموافقة عليها</div>";
        }

        return $r;
    }
}
