<?php

class com_hr_reports extends ins_com
{
    var $_return = "";
    var  $g;

    public function __construct()
    {
        parent::__construct();
        $this->g = ins::_eng()->_get();
    }


    function gen_reports()
    {


        $uidata[] = ["type" => "start", "class" => "ins_grid"];
        $jobs = \ins::_db()->_get_data("com_structure_jobs", "*");
        foreach ($jobs as $job) {
            $count = \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]}")["c"];


            $uidata[] = ["type" => "start", "class" => " ins_col_6 ins_card ins_grid ins_light"];
            $uidata[] = ["type" => "h4", "style" => "padding:10px", "class" => "ins_col_12 ins_texttocenter ins_dark", "data" => $job["title"]];

            $uidata[] = ["type" => "h5", "class" => "ins_col_6 ins_texttocenter", "data" => "Employees Count", "data-ar" => "عدد الموظفيين"];
            $uidata[] = ["type" => "h5", "class" => "ins_col_6 hr_rep_value ins_texttocenter", "data" => $count];

            $uidata[] = ["type" => "h5", "class" => "ins_col_6 ins_texttocenter", "data" => "new employees Count this month", "data-ar" => "موظفيين جدد لهذا الشهر  "];
            $uidata[] = ["type" => "h5", "class" => "ins_col_6 hr_rep_value ins_texttocenter", "data" => \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]} and   MONTH(date_of_joining)=" . date("m"))["c"]];

            $uidata[] = ["type" => "line"];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 ins_texttocenter", "data" => "active", "data-ar" => " فعال "];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 ins_texttocenter", "data" => "terminted", "data-ar" => " مفصل "];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 ins_texttocenter", "data" => "deceased", "data-ar" => " مستقيل "];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 ins_texttocenter", "data" => "resigned", "data-ar" => " متوفى "];

            $uidata[] = ["type" => "h5", "class" => "ins_col_3 hr_rep_value ins_texttocenter", "data" => \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]} and (employee_status='active' or employee_status='') ")["c"]];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 hr_rep_value ins_texttocenter", "data" => \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]} and employee_status='terminted'")["c"]];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3 hr_rep_value ins_texttocenter", "data" => \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]} and employee_status='deceased'")["c"]];
            $uidata[] = ["type" => "h5", "class" => "ins_col_3  hr_rep_value ins_texttocenter", "data" => \ins::_db()->_get_row("com_hr_employees", "count(id) as c", "job={$job["id"]} and employee_status='resigned'")["c"]];


            $uidata[] = ["type" => "end"];
        }


        $uidata[] = ["type" => "end"];



        return \ins::_ui()->_data($uidata)->_render();
    }





    function bar_buttons()
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid"];
        $uidata[] = [
            "type" => "h5", "class" => "ins_col_3 ins_card_btn ins_light  ins_texttocenter",
            "data-ar" => '<span><i class="fas fa-money-bill"></i></span>  التقارير الماليه',
            "data" => '<span><i class="fas fa-money-bill"></i></span> finance reports'
        ];
        $uidata[] = [
            "type" => "h5", "class" => "ins_col_3 ins_card_btn ins_light ins_texttocenter",
            "data" => '<span><i class="fas fa-candy-cane"></i></span> checkin sheckout reports',
            "data-ar" => '<span><i class="fas fa-candy-cane"></i></span> تقارير الاجازات'
        ];
        $uidata[] = [
            "type" => "h5", "class" => "ins_col_3 ins_card_btn ins_light ins_texttocenter",
            "data" => '<span><i class="far fa-clock"></i></span> checkin sheckout reports',
            "data-ar" => '<span><i class="far fa-clock"></i></span> تقارير الحضور والانصرف  '
        ];
        $uidata[] = [
            "type" => "h5", "class" => "ins_col_3 ins_card_btn ins_light ins_texttocenter",
            "data" => '<span><i class="fas fa-history"></i></span> holidies reports',
            "data-ar" => '<span><i class="fas fa-history"></i></span> تقارير الاجازات '
        ];
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }
    function _out()
    {



        $data = [
            ["type" => "start", "class" => "ins_grid"],
            ["type" => "div", "class" => "ins_col_12", "data" => $this->bar_buttons()],
            ["type" => "div", "class" => "ins_col_12", "data" => $this->gen_reports()],
            ["type" => "end"]
        ];


        return \ins::_ui()->_data($data)->_render();
    }
}
