<?php

class com_icac_inventories   extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }
    function _reports_q($rq)
    {


        $data = ins::_db()->_get_data("com_icac_inventories_operations", "*", "inventory_id='{$rq["id"]}'");

        $table = [];
        $blan = [];
        foreach ($data as $d) {
            if ($d["op"] == "bay") {
                $blan[$d["pro_id"]] += $d["quantity"];
            }else{
                $blan[$d["pro_id"]] -= $d["quantity"];
            }
        }


        $table = [];
        $table[] = [
            ["data" =>"الصنف", "style" => "    text-align: center;", "class" => "ins_col_16"],
            ["data" => "الكميه", "style" => "    text-align: center;", "class" => "ins_col_8"],
           
        ];



        foreach ($blan as $k => $v) {

            $table[] = [
                ["data" =>  ins::_db()->_get_row("com_icac_products", "title", "id=$k")["title"], "style" => "    text-align: center;", "class" => "ins_col_16"],
                ["data" => $v, "style" => "    text-align: center;", "class" => "ins_col_8"],
            ];


        }

        $data = [
            "table_divs" => ["data" => $table, "class" => "ins_col_12 "],
        ];
        return  \lib::_ui()->_data($data)->_render();
    }
    function _reports_data($rq)
    {


        $data = ins::_db()->_get_data("com_icac_inventories_operations", "*", "inventory_id='{$rq["id"]}'");


        $table = [];
        $table[] = [
            ["data" =>"العمليه", "style" => "    text-align: center;", "class" => "ins_col_4"],
            ["data" => "التاريخ", "style" => "    text-align: center;", "class" => "ins_col_4"],
            ["data" =>  "المنتج", "style" => "    text-align: center;", "class" => "ins_col_8"],
            ["data" => "الكمية ", "style" => "    text-align: center;", "class" => "ins_col_4"],
            ["data" => "رصيد المنتج", "style" => "    text-align: center;", "class" => "ins_col_4"],
        ];



        $blan = [];
        foreach ($data as $d) {
             if ($d["op"] == "bay") {
                $blan[$d["pro_id"]] += $d["quantity"];

                
            }else{
                $blan[$d["pro_id"]] -= $d["quantity"];


            }
            $table[] = [
                ["data" => ($d["op"] == "bay") ? "شراء" : "صرف", "style" => "    text-align: center;", "class" => "ins_col_4"],
                ["data" => $d["date"], "style" => "    text-align: center;", "class" => "ins_col_4"],
                ["data" =>  ins::_db()->_get_row("com_icac_products", "title", "id={$d["pro_id"]}")["title"], "style" => "    text-align: center;", "class" => "ins_col_8"],
                ["data" => $d["quantity"], "style" => "    text-align: center;", "class" => "ins_col_4"],
                ["data" => $blan[$d["pro_id"]], "style" => "    text-align: center;", "class" => "ins_col_4"],
            ];
        }

        $data = [
            "table_divs" => ["data" => $table, "class" => "ins_col_12 "],
        ];
        return  \lib::_ui()->_data($data)->_render();
    }


    function _reports($data, $dbdata)
    {
        return '
        <i data-lb_title="حركة المخزن"  title="حركة المخزن"  data-status="_reports_data"  data-id="' . $dbdata["id"] . '" class="far _btn_reports_data  fa-chart-bar"></i>
    
        <i data-lb_title="الكميات "  title=" الكميات" data-status="_reports_q" data-id="' . $dbdata["id"] . '" class="fas _btn_reports_data  fa-chart-pie "></i>';


    }




    function _out()
    {
        return  lib::_pages()->_get_class("admin", "com_icac_inventories")->_render();
    }
}
