<?php

class com_isd_home extends ins_com {

    var $_get, $_isd_entity;

    public function __construct() {
        parent::__construct();

        $this->_get = \lib::_eng()->_get();

        $entity = explode(",", $_SESSION["sys_users_login_data"]["entity"]);

        $entity = array_filter($entity);


        $this->isd_entity = $_SESSION["sys_users_entity"];
    }

    function _getstrat() {
        $data_status = \lib::_db()->_get_data("sys_menus_items", "*", " isd_entity=' $this->isd_entity ' && isd_strat=1 ");
        $ui_data = [];
        $i = 0;
        $ui_data = [
            "start" => ["class" => "home_main"],
            "search" => ["input" => "true", "placeholder" => $this->_lang["search"] . "...", "class" => "col12", "data-for" => '.home_main'],
            "start-data" => ["class" => "menu_data"]
        ];
        foreach ($data_status as $m) {
            $ui_data["start-" . $m["id"]] = ["class" => "ins_card_btn ins_light search_item_data"];
            $ui_data["a-" . $m["id"]] = ["data" => "<span>" . $m["icon"] . "</span>" . $m["title"], "href" => lib::_eng()->_url(["mode" => $m["id"]])];
            $ui_data["end-" . $m["id"]] = [];
            $i++;
        }


        $ui_data["end-data"] = [];
        $ui_data["line-pc"] = [];
        $ui_data["end"] = [];
        $this->r .= \lib::_ui()->_data($ui_data)->_render();
    }

    function _getitems_style(&$ui_data, $data) {

        foreach ($data as $d) {

            if ($d["isd_table"] != "") {
                if ($d["isd_strat"] !== "1") {


                    $isddata = \lib::_db()->_get_data("com_isd_operations", "*", "isd_entity='" . $_SESSION["sys_users_entity"] . "' and isd_status='" . $d["isd_status"] . "' order by `sys_created` DESC ");

                    $cat_data = \lib::_db()->_get_row("sys_menus", "*", "id='" . $d['cat_id'] . "' ");
                    $tabledata[] = [];


                    foreach ($isddata as $is) {
                        $isd = \lib::_db()->_get_row($is["isd_table"], "*", "id='" . $is["isd_table_id"] . "'");
                        $url = lib::_eng()->_url(["mode" => $is["isd_to"], "id" => $is["id"]]);
                        $lang_data = $isd;
                        $n = $lang_data["title"];
                        $us = \lib::_db()->_get_row("sys_users", "*", "id='" . $is["isd_owner"]["isd_table_id"] . "'");
                     
                        $m = "";
                        if (ins::_app_map()->_get["mode"] == $d["id"] && ins::_app_map()->_get["id"] == $isd["id"]) {

                            $m = "ins_act";
                        }

                        $tabledata[] = [ "class"=>"ins_card_col_12",
                            "data" => [
                                ["data" => $lang_data["name"], "class" => "ins_col_5 ins_card_col_24 ins_card_col_bold"],
                                ["data" => $lang_data["national_id"], "class" => "ins_col_5 ins_card_col_12"],
                                ["data" => \lib::_data()->_datetime->dateFromdb($isd["sys_created"], "d/m/Y h:m A"), "class" => "ins_col_5 ins_card_col_12"],
                                ["data" => $cat_data["title"], "class" => "ins_col_4 ins_card_col_24"],
                                ["data" => $us["title"], "class" => "ins_col_5 ins_card_col_24"],
                        ]];
                    }
                }
            }
        }

        
        
        $sdata = ins::_data()->_app_settings_get("com_isd_home", \ins::_usere()->_get("id"));
        
        
        

        $ui_data[] = ["type" => "table_divs", "data" => $tabledata, "class" =>$sdata["isd_status_style"]. "  ins_block ins_col_12"];
        return $ui_data;
    }

    function _add_stat_item($rq) {
        $status_data = \lib::_db()->_get_row("com_isd_status", "*", "id='" . $rq["id"] . "' ");

        $ui_data[] = ["type" => "div", "class" => "ins_status_cont _" . $rq["id"], "data" => com_isd_home::_getstat_item($status_data)];


        return \lib::_ui()->_data($ui_data)->_render();
    }

    function _getstat_item($status_data) {

        $sdata = ins::_data()->_app_settings_get("com_isd_home", \ins::_usere()->_get("id"));
        $sdata = json_decode($sdata["isd_status"], true);
        $mclass = "";
        if (key_exists($status_data["id"] , $sdata)) {
            $mclass = " status_pin ";
        }
        $ui_data = [];
        $data = \lib::_db()->_get_data("sys_menus_items", "*", " (isd_entity='" . $_SESSION["sys_users_entity"] . "') and isd_status='" . $status_data["id"] . "'");
        $ui_data[] = ["type" => "start", "data-status_title" => $status_data["title"], "data-status" => $status_data["id"], "class" => "$mclass ins_grid ins_status_panel  ins_col_12", "style" => ""];
        $ui_data[] = ["type" => "h4", "data" => $status_data["title"] . '<i class="fas fa-thumbtack ins_status_pin"></i><i class="far ins_status_ex fa-minus-square"></i>', "class" => "status_title  ins_col_12  ins_border_bottom"];
        com_isd_home::_getitems_style($ui_data, $data);
        $ui_data[] = ["type" => "end"];


        return \lib::_ui()->_data($ui_data)->_render();
    }

    function _getitems() {

        $data_status = \lib::_db()->_get_data("sys_menus_items", "DISTINCT(isd_status)", " isd_entity=' $this->isd_entity ' and isd_strat='0'  ");

        $all_status_data = \lib::_db()->_get_data("com_isd_status", "*");

        $ui_data = [
            "start-data" => ["class" => "status_bar ins_fixed_right ins_light closed   ins_col_6"],
            "start-header" => ["class" => "ins_grid", "style" => "    align-items: start;"],
            "span-data" => ["class" => "ins_col_1 sl_data_tools ins_dark status_bar_open_close", "data" => '<i class="fas fa-chevron-right   "></i>'],
            "h2" => ["data" => " My File", "pclass" => "ins_col_11"],
            "search" => ["input" => "true", "placeholder" => "search...", "pclass" => "ins_col_11", "pstyle" => "padding: 0;", "data-for" => '.status_bar'],
            "span-data2" => ["class" => "ins_col_1 sl_data_tools", "pstyle" => "padding: 0;", "data" => '<i class="fas fa-ellipsis-v  ins_show_menu "></i>  <i class="fas fa-th-large"></i>'],
            "end-header" => []
        ];
        $ui_data[] = ["type" => "start", "data" => "ul", "class" => "ins_menu ins_status_menu ins_light"];
        $sdata = ins::_data()->_app_settings_get("com_isd_home", \ins::_usere()->_get("id"));
        $sdata = json_decode($sdata["isd_status"], true);


        foreach ($all_status_data as $s) {
            $st = "fa-eye-slash";
            if (key_exists($s["id"], $sdata)) {
                $st = "fa-eye";
            }
            $ui_data[] = ["type" => "li", "data-id" => $s["id"], "data" => ' <i class="far ' . $st . '"></i> ' . $s["title"]];
        }

        $ui_data[] = ["type" => "end", "data" => "ul"];

        foreach ($data_status as $d) {
            $status_data = \lib::_db()->_get_row("com_isd_status", "*", "id='" . $d["isd_status"] . "' ");
            if (key_exists($d["isd_status"], $sdata)) {
                $ui_data[] = ["type" => "div", "class" => "ins_status_cont _" . $status_data["id"], "data" => $this->_getstat_item($status_data)];
            }
        }
        $ui_data[] = ["type" => "end"];
        $this->r .= \lib::_ui()->_data($ui_data)->_render();
    }

    function _getitem() {
        $d = \lib::_db()->_get_row("sys_menus_items", "*", " isd_entity=' $this->isd_entity '  or  id='" . $this->_get["mode"] . "'  ");
        $options = ["form_id" => $this->_get["mode"], "isd_step" => true, "isd_url" => \lib::_eng()->_url([], ["mode", "id"])];
        if (is_array($d)) {
            if (isset($this->_get["id"])) {
                $options["isd_id"] = $this->_get["id"];
            }
        }
        $ui_data = [
            "div-s" => [
                "class" => " ins_breadcrumb",
                "data" => "<span><a href='/ins_admin/isd_home/'><i class=\"fas fa-home\"></i> </a></span><span class='ins_separtor'><i class=\"fas fa-chevron-right\"></i></span><span>" . $d["title"] . "</span>"
            ], "div" => ["data" => \lib::_eng()->_get_plgin("plg_form", $options, "root") . "<div class='clearfix'></div>", "class" => "set_data ins_container   "]
        ];


        \lib::_template()->_title = $d["title"];


        $this->r .= \lib::_ui()->_data($ui_data)->_render();
    }

    function _out() {




        $this->_include("my_style.css");
        $this->_include("my_js.js");
        $this->_getitems();
        if (isset($this->_get["mode"])) {
            $this->_getitem();
        } else {
            $this->_getstrat();
        }

        return $this->r;
    }

}
