<?php


class com_hr_employees extends ins_com
{
    public function __construct()
    {
        parent::__construct();
    }

    function _get_data_salary_row($rq)
    {
        $data =   ins::_db()->_get_row("com_hr_salary_component", "*", "id='{$rq['id']}'");



        if ($data['value_type'] == "percentage") {

            $value_type = '<i class="fas fa-percent"></i>';
        } else {

            $value_type = '<i class="far fa-money-bill-alt"></i>';
        }






        $uidata = [
            "start" => ["class" => "ins_col_6 ins_card ins_grid _data_salary_row  {$rq['type']} _{$data["id"]}", "data-id" => $data["id"]],
            "div" => ["data" => $data["title"], "class" => "ins_col_6"],
            "span" => ["data" => $data["value"], "class" => "ins_col_2"],
            "span-2" => ["data" => $value_type, "class" => "ins_col_2"],

            "i" => ["data-type" => "{$rq['type']}", "class" => "fas fa-times ins_col_2 ins_btn_salary_remove ins_button"],
            "end" => []

        ];

        return \ins::_ui()->_data($uidata)->_render();
    }




    function _fill_list($rq)
    {
        return \ins::_ui()->_html()->_get_select_options([
            "select_type" => "db", "select_table" => $rq["type"],
            "select_query" => \ins::_data()->_db_create_where_to_group($rq["value"], $rq["by"])
        ]);
    }


    /*
    function     salary_function($data, $dbdata)
    {


        $data = [
            [
                "type" => "i", "data-id" => $dbdata["id"], "data-type" => "deduction", "class" => "ins_add_salary_component fas fa-file-download ",
            ],  [
                "type" => "i", "data-id" => $dbdata["id"], "data-type" => "earning", "class" => "fas ins_add_salary_component fa-file-upload", "data-title" => "",

            ],  [
                "type" => "i", "data-id" => $dbdata["id"], "class" => "ins_salary_summray fas fa-chart-line",  "data-title" => "",

            ]

        ];



        return \ins::_ui()->_data($data)->_render();
    }

*/


    function _out()
    {
        /** @var ins_lib\pages\page_admin  $admin*/
        $admin = \lib::_pages()->_admin("com_hr_employees");
        return $admin->_render();
    }
}
