<?php

class com_school_activity extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    /**
map
     */
    function _set_Loctions($rq)
    {
        return $_SESSION["locations"] = $rq["locations"];
    }

    function _get_Loctions($rq)
    {
        return $_SESSION["locations"];
    }

    function _ui_edit_marker($rq)
    {

        $uidata = [
            "start" => ["class" => "ins_grid"],
            "student_id" => [
                "title" => 'text', "title-ar" => "النص", "value" => $rq["title"], "class" => "map_m_title", "type" => 'text', "input" => "true",
                "pclass" => ' ins_col_12'
            ],
            "button" => ["class" => ' bt_map_update_m ins_col_6', "data" => "update Location", "data-ar" => "تحديث الموقع    "],
            "button-2" => ["class" => ' bt_map_delete_m ins_col_6', "data" => "delete Location", "data-ar" => " حذف الموقع   "],
            "end" => [],

        ];
        return \ins::_ui()->_data($uidata)->_render();
    }
    function _ui_add_marker($rq)
    {
        $uidata = [
            "start" => ["class" => "ins_grid"],
            "student_id" => [
                "title" => 'text', "title-ar" => "النص", "class" => "map_m_title", "type" => 'text', "input" => "true",
                "pclass" => ' ins_col_12'
            ],
            "button" => ["class" => 'bt_map_add_m ins_col_12', "data" => "add Student", "data-ar" =>  "اضافة  الموقع    "],
            "end" => [],

        ];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function _get_dormitories($rq)
    {
        $data  = [
            ["from" => "9:30", "to" => "11:00", "day" => "tuesday", "color" => "#eee", "title" => "sdfsdf", "des" => "asdas asdas asdas"],
            ["from" => "12:00", "to" => "1:00", "day" => "thursday"],
            ["from" => "12:00", "to" => "1:00", "day" => "tuesday"]
        ];
        $options = [
            "select_type" => "db",
            "select_table" => "com_school_dormitories",
            "select_text" => "title",    "select_vlaue" => "id",
            "select_query" => "`class`='{$rq["class"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }

    /**
students
     */

    function _student_ui_add($rq)
    {

        if (isset($rq["id"])) {
            $act = \ins::_db()->_get_row("com_school_activity", "*", "id='{$rq["id"]}'");

            $data = \ins::_db()->_get_row("com_school_activities", "*", "id='{$act["act_id"]}'");

            $uidata = [
                "start" => ["class" => "ins_grid"],
                "class" => ["title" => 'class', "data-act_id" => $act["act_id"], "title-ar" => "الصف", "type" => 'select', "select_type" => "db", "select_table" => "com_school_classes", "pclass" => ' ins_col_12'],
                "dormitory" => ["data-act_id" => $act["act_id"],     "title" => 'dormitory', "title-ar" => "الفصل", "type" => 'select',  "pclass" => ' ins_col_12'],
                "student_id" => ["data-act_id" => $act["act_id"], "title" => 'student', "title-ar" => "الطالب", "type" => 'select',  "pclass" => ' ins_col_12'],
                "button" => ["class" => 'btn_add_student ins_col_12', "data" => "add Student", "data-ar" => "اضافة  الطالب"],
                "end" => [],

            ];


            if ($data["for"] == "class") {
                $uidata["class"]["select_query"] = \ins::_data()->_db_create_where_from_array($data["for_type"]);
            }

            if ($data["for"] == "dormitory") {
                unset($uidata["class"]);
                $uidata["dormitory"]["select_type"] = "db";
                $uidata["dormitory"]["select_table"] = "com_school_dormitories";
                $uidata["dormitory"]["select_query"] = \ins::_data()->_db_create_where_from_array($data["for_type"]);
            }
        } else {


            $uidata = [

                "div" => ["data" => " Sorry, but the activity must be added before adding students", "data" => "عفوا ولكن يجب اضافه النشاط قبل اضافه الطلاب", "class" => "ins_col_12 info"]
            ];
        }



        return   \ins::_ui()->_data($uidata)->_render();
    }

    function _get_students($rq)
    {
        $options = [
            "select_type" => "db", "select_text" => "name",
            "select_table" => "app_school_students",
            "select_vlaue" => "id",
            "select_query" => "`dormitory`='{$rq["dormitory"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }

    function _student_add($rq)
    {
        $actdata =   ins::_db()->_get_row("com_school_activity", "*", "id={$rq["id"]}");

        $students = [];
        if ($actdata["students"]) {
            $students = json_decode($actdata["students"], true);
        }


        if ($rq["op"] == "delete") {
            unset($students[$rq["student_id"]]);
        } else {
            $students[$rq["student_id"]] = ["id" => $rq["student_id"]];
        }

        \ins::_db()->_update("com_school_activity", ["students" => json_encode($students)], "id={$rq["id"]}");
    }

    function  _get_students_area($rq)
    {

        if (isset($rq["id"])) {
            $actdata =   \ins::_db()->_get_row("com_school_activity", "*", "id={$rq["id"]}");
            $students = [];
            if ($actdata["students"]) {
                $students = json_decode($actdata["students"], true);
            }
            $table[] = [
                ["class" => "ins_col_10"],
                ["class" => "ins_col_2"],

            ];

            foreach ($students as $student) {

                if ($student["id"] != "") {
                    $sdata  = \ins::_db()->_get_row("app_school_students", "*", "id={$student["id"]}");


                    $table[] = [

                        ["data" => '<img  class"ins_tiny_circle" src="' . ins::_map()->upload_folder . $sdata["image"] . '" />', "class" => "ins_col_4"],

                        ["data" => $sdata["name"], "class" => "ins_col_16"],
                        ["data" => "<i-addst data-op='delete' data-student_id='" . $student["id"] . "' class='fas fa-times ins_student_delete  ins_icon_button ' />", "class" => "ins_col_4"],

                    ];
                }
            }



            $uidata = [

                "table_divs" => ["data" => $table, "class" => "ins_col_12"]
            ];
        } else {

            $uidata = [

                "div" => ["data" => " Sorry, but the activity must be added before adding students", "data" => "عفوا ولكن يجب اضافه النشاط قبل اضافه الطلاب", "class" => "ins_col_12 info"]
            ];
        }
        return   \ins::_ui()->_data($uidata)->_render();
    }

    /**
Calender
     */

    function _calender_get_ui()
    {
        $data = $_SESSION["calendar"];

        foreach ($data as $k => $v) {
            $des_data = "<div class='ins_col_12 ins_calendar_item_actions'>
            <i data-index='$k' class='fas fa-times btn_calender_remove'></i>
            <i data-index='$k'  class='fas fa-edit btn_calender_edit'></i></div>";
            $des_data .= "<div class='ins_col_12'>{$data[$k]["des"]}</div>";
            $data[$k]["des"] = $des_data;
        }
        $uidata = [
            "weekly_calender" => ["class" => "ins_col_12", "data" => $data]
        ];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function _calender_item_update($rq)
    {
        $_SESSION["calendar"][$rq["index"]] = [
            "from" => $rq["from"],
            "to" => $rq["to"],
            "color" => $rq["color"],
            "day" => $rq["day"],
            "des" => $rq["des"]
        ];
        return com_school_activity::_calender_get_ui();
    }

    function _calender_edit($rq)
    {
        $d = $_SESSION["calendar"][$rq["index"]];
        $d["index"] =    $rq["index"];


        return com_school_activity::_calender_add($d, "edit");
    }

    function _calender_remove($rq)
    {
        unset($_SESSION["calendar"][$rq["index"]]);
        return  com_school_activity::_calender_get_ui();
    }

    function _calender_update($rq)
    {
        if (isset($rq["from"])) {

            $data = [
                "from" => $rq["from"],
                "to" => $rq["to"],
                "color" => $rq["color"],
                "day" => $rq["day"],
                "des" => $rq["des"]
            ];

            if (is_array($_SESSION["calendar"])) {
                $_SESSION["calendar"][] = $data;
            } else {

                $_SESSION["calendar"] = [$data];
            }
        }




        return  com_school_activity::_calender_get_ui();
    }

    function _calender_add($rq, $status)
    {


        $rq["color"] = $rq["color"] ? $rq["color"] : "#3178c4";

        $uidata = [
            "start" => ["class" => "ins_grid"],
            "day" => ["title" => "day", "title-ar" => "اليوم", "value" => trim($rq["day"]), "select_type" => "xml", "select_file" => "days", "pclass" => ' ins_col_12', "type" => "select"],
            "from" => ["title" => "from", "title-ar" => "من",  "value" => trim($rq["from"]), "select_type" => "xml", "select_file" => "work_times", "pclass" => ' ins_col_6', "type" => "select"],
            "to" => ["title" => "to", "title-ar" => "الى", "value" => trim($rq["to"]), "select_type" => "xml", "select_file" => "work_times", "pclass" => 'ins_col_6', "type" => "select"],
            "color" => ["title" => "Color", "title-ar" => "لون", "value" => trim($rq["color"]),   "pclass" => ' ins_col_12', "type" => "color", "input" => "true"],
            "des" => ["title" => "des", "title-ar" => "نبذة", "value" => trim($rq["des"]),   "pclass" => ' ins_col_12', "type" => "textarea", "style" => "height:100px"],
            "button" => ["data" => "add", "data-ar" => "اضافة",   "pclass" => 'ins_col_12'],
            "end" => [],
        ];
        if ($status == "edit") {
            $uidata["button"]["data-index"] = $rq["index"];
            $uidata["button"]["class"] = $rq["index"];

            $uidata["button"]["class"] = "update_item_calender";
        } else {

            $uidata["button"]["class"] = "add_item_calender";
        }

        return ins::_ui()->_data($uidata)->_render();
    }









    /**
 out
     */



    function _out()
    {

        if (isset($_POST["title"])) {
            $_POST["calendar"] = json_encode($_SESSION["calendar"]);
            $_POST["locations"] = $_SESSION["locations"];
        }

        $admin = \ins::_pages()->_admin("com_school_activity");

        $adm =   $admin->_render();
        $g = \ins::_eng()->_get();
        $_SESSION["calendar"] = "";
        $_SESSION["locations"] = "";
        if (isset($g["id"])) {
            $calendar = \ins::_db()->_get_row("com_school_activity", "*", "id='{$g["id"]}'");
            if ($calendar["calendar"] != "") {
                $_SESSION["calendar"] = json_decode($calendar["calendar"], true);
            }
            if ($calendar["locations"] != "") {
                $_SESSION["locations"] = $calendar["locations"];
            }
        }
        return    $adm;
    }
}
