<?php

class com_school_student extends ins_com
{
    /**
--class
     */
    var  $_g = [];
    var $udata = [];
    var $_height_color = "#0e6531";

    public function __construct()
    {
        parent::__construct();

        $this->_g = \ins::_eng()->_get();
    }

    /**
--charts
     */
    function _data_st_attendance($rq)
    {
        $adata = \ins::_db()->_get_row('app_school_students', "*", "id={$rq["st_id"]}");
        $atdata = \ins::_db()->_get_data('com_school_attendance', "*", "dormitory='{$adata["dormitory"]}'");

        $table[] = [
            ["data" => "teacher", "data-ar" => "المدرس", "class" => "ins_col_6"],
            ["data" => "date", "data-ar" => "التاريخ", "class" => "ins_col_4"],
            ["data" => "status", "data-ar" => "الحالة", "class" => "ins_col_3"],
            ["data" => "des", "data-ar" => "نبذة", "class" => "ins_col_8"]

        ];

        $gpoints = 0;
        $bpoints = 0;

        $att = [];


        foreach ($atdata as $a) {
            $attendance =  json_decode($a["attendance"], true);
            $status = \ins::_db()->_get_row('com_school_attendance_types', "*", "id={$attendance[$rq["st_id"]]["attendance"]}")["title"];
            $table[] = [
                ["data" => $a["ch_id"], "class" => "ins_col_6"],
                ["data" => $a["date"], "class" => "ins_col_4"],
                ["data" => $status, "class" => "ins_col_3"],
                ["data" => $attendance[$rq["st_id"]]["notes"], "class" => "ins_col_8"]

            ];
            $att[$attendance[$rq["st_id"]]["attendance"]]++;;
        }


        $adata = \ins::_db()->_get_data('com_school_attendance_types');

        foreach ($adata  as $d) {



            $table[] = [
                ["data" => $d["title"],  "class" => "ins_col_12"],
                ["data" => $att[$d["id"]], "class" => "ins_col_12"],


            ];
        }



        $data = [
            "table_divs" => ["data" => $table, "style" => "margin-top:25px", "class" => "ins_col_12"],
        ];

        return  \lib::_ui()->_data($data)->_render();
    }

    function _data_st_repoets($rq)
    {

        $adata = \ins::_db()->_get_row('app_school_students', "*", "id={$rq["st_id"]}");
        $atdata = \ins::_db()->_get_data('com_school_attendance', "*", "dormitory='{$adata["dormitory"]}'");
        $att = [];
        foreach ($atdata as $a) {
            $attendance =  json_decode($a["attendance"], true);
            $att[$attendance[$rq["st_id"]]["attendance"]]++;;
        }

        $adata = \ins::_db()->_get_data('com_school_attendance_types');
        $data = [
            ["Task", "Hours per Day"]
        ];
        foreach ($adata  as $d) {
            $data[] = [$d["title"], $att[$d["id"]]];
        }
        return json_encode($data);
    }

    function  _ui_st_behaviours($rq)
    {

        $bhs = \ins::_db()->_get_data('com_school_behaviours', "*", "student_id={$rq["id"]}");

        $table[] = [
            ["data" => "teacher", "data-ar" => "المدرس", "class" => "ins_col_6"],
            ["data" => "date", "data-ar" => "التاريخ", "class" => "ins_col_4"],
            ["data" => "status", "data-ar" => "الحالة", "class" => "ins_col_3"],
            ["data" => "point", "data-ar" => "نقاط", "class" => "ins_col_3"],
            ["data" => "des", "data-ar" => "نبذة", "class" => "ins_col_8"]

        ];

        $gpoints = 0;
        $bpoints = 0;

        foreach ($bhs as $bh) {
            $table[] = [
                ["data" => $bh["ch_id"], "class" => "ins_col_6"],
                ["data" => $bh["date"], "class" => "ins_col_4"],
                ["data" => $bh["status"], "class" => "ins_col_3"],
                ["data" => $bh["points"], "class" => "ins_col_3"],
                ["data" => $bh["des"], "class" => "ins_col_8"]



            ];
            if ($bh["status"] == "bad") {
                $bpoints += $bh["points"];
            } else {

                $gpoints += $bh["points"];
            }
        }
        $table[] = [
            ["data" => "bad points", "data-ar" => "النقاط السيئة", "class" => "ins_col_6"],
            ["data" => $bpoints, "class" => "ins_col_6"],
            ["data" => "good points", "data-ar" => "النقاط الجيدة", "class" => "ins_col_6"],
            ["data" => $gpoints, "class" => "ins_col_6"],

        ];



        $data = [
            "table_divs" => ["data" => $table, "style" => "margin-top:25px", "class" => "ins_col_12"],
        ];

        return  \lib::_ui()->_data($data)->_render();
    }



    function ui_st_repoets($rq)
    {
        $adata = \ins::_db()->_get_row('app_school_students', "*", "id={$rq["st_id"]}");
        $s = "font-size:40px;    text-align: center;line-height: 45px;";
        $gh = trim(\ins::_db()->_get_row('com_school_behaviours', "sum(points) as points", "student_id={$rq["st_id"]} and status ='good'")["points"]);
        $bh = \ins::_db()->_get_row('com_school_behaviours', "sum(points) as points", "student_id={$rq["st_id"]} and status ='bad'")["points"];
        $agh = $gh + $bh;
        $ghp = round(($gh / $agh) * 100) . "%";


        $sp = "text-align: center;
        font-size: 40px;
        position: relative;
        top: 50px;
        height: 100px !important;
        width: 100px !important;
        line-height: 100px;";

        if ($bh > $gh) {

            $spclass = "ins_s_red";
        } else {
            $spclass = "ins_s_green";
        }

        $data = [

            ["type" => "start", "class" => "ins_grid", "style" => "   align-items: center;"],
            ["type" => "start", "style" => "height:250px", "class" => "ins_col_6  ins_grid  ins_card  "],
            [
                "type" => "i", "data-status" => "_data_st_attendance",
                "data-st_id" => $rq["st_id"],
                "data-lb_title" => "تقرير غياب " . $adata["name"],
                "class" => "fas  _btn_info  fa-info-circle  ins_col_1"
            ],
            ["type" => "div", "class" => "ins_col_12    attnchart"],
            ["type" => "end"],
            //  ["type" => "div", "data" => "", "style" => "height:250px", "class" => "ins_col_6  ins_card  "],
            ["type" => "start", "style" => "height:250px ;align-items: center; ", "class" => "ins_grid ins_col_6  ins_card "],

            [
                "type" => "i", "data-lb_style" =>  "width:60%;height:450px",
                "data-status" => "_ui_st_behaviours", "data-id" => $rq["st_id"], "data" => "",
                "data-lb_title" => "تقرير سولكيات " . $adata["name"], "class" => "fas  _btn_info  fa-info-circle  ins_col_1"
            ],

            ["type" => "i", "style" =>  $s, "class" => "far fa-thumbs-up ins_col_4"],
            ["type" => "span", "style" => $s,  "data" => $gh, "class" => "ins_col_4"],
            ["type" => "span", "style" => $sp,  "data" => $ghp, "class" => "ins_col_4 $spclass ins_light  ins_circle"],
            ["type" => "i", "style" =>  $s,  "class" => "far fa-thumbs-down ins_col_4"],
            ["type" => "span", "style" =>  $s,  "data" =>  $bh, "class" => "ins_col_4"],

            ["type" => "end"],

            ["type" => "end"]
        ];

        return  \lib::_ui()->_data($data)->_render();
    }


    /**
--home
     */

    function get_mydata()
    {
        if (isset($this->udata["name"])) {
            $this->udata["title"] = $this->udata["name"];
        }
        // $entities_data = \ins::_eng()->_isd()->_get_user("job_data");
        $data = [

            "start" => ["class" => " ins_grid h_user_data "],
            "img" => ["src" => $this->udata["image"], "pclass" => " ins_col_1", "pstyle" => '    grid-row-start: 1;grid-row-end: 3;'],
            "h4" => ["data" => $this->udata["title"], "style" => "font-size: 30px;", "class" => "ins_float_right ins_col_9 "],
            "h5" => ["data" =>  $this->udata["class_title"] . " -  " .  $this->udata["dormitory_title"], "class" => "ins_float_right ins_col_9"],
            "start-btns" => ["class" => "  ins_grid ins_col_2     ", "style" => " text-align: CENTER; padding:4px text-align: CENTER;padding: 4px;grid-row-start: 1;grid-row-end: 3;grid-column-start: 11;"],
            "a" => ["#", "class" => "insaction ins_col_6 ", "data-insaction" => "logout", "data" => '<i class="fas fa-edit"></i>'],
            "a-btns" => ["#", "class" => "insaction ins_col_6", "style" => "color:red", "data-insaction" => "logout", "data" => '<i style="    color: #fd4b4b;" class="fas fa-power-off" ></i>'],
            "end-btnsdata" => ["class" => ""],
            "end-data" => ["class" => ""]
        ];
        return \ins::_ui()->_data($data)->_render();
    }

    function _add_remove_tofav($m)
    {
        $old_data = ins::_db()->_get_row("sys_menus_items", "*", " id=:id", ["id" => $m["id"]]);
        $status = "";
        if (com_home::_fav_chack($old_data)) {
            ins::_db()->_delete("sys_menus_items", " alias='" . $old_data["alias"] . "' and cat_id=33 ");
            $status = "remove";
        } else {

            $old_data["parent_id"] = "0";
            $old_data["cat_id"] = "33";
            unset($old_data["id"]);
            $old_data = ins::_db()->_insert("sys_menus_items", $old_data);
            $status = "add";
        }
        return $status;
    }

    function _fav_chack($m)
    {
        $favid = "33";
        $ms = ins::_db()->_get_row("sys_menus_items", "*", " alias=:alias and  cat_id=:favid", ["alias" => $m["alias"], "favid" => $favid]);
        return is_array($ms);
    }

    function get_menu()
    {



        $data = [
            "start" => ["class" => "home_main"],
            "search" => ["input" => "true", "placeholder" => $this->_lang["search"] . "...", "class" => "col12"],
            "start-data" => ["class" => "menu_data ins_grid"]
        ];

        $w = "cat_id=:menu";
        $w_data = ["menu" => $this->_pro["menu"]];


        if (isset($this->_pro["parent"]) && $this->_pro["parent"] != "") {

            $w .= " and id=:id ";
            $w_data["id"] = $this->_pro["parent"];
        } else {
            $w .= " and  parent_id = '0' ";
        }


        $ms = ins::_db()->_get_data("sys_menus_items", "*", "$w order by `sys_order`", $w_data);


        $sopen = " ins_opend ";
        foreach ($ms as $pm) {
            ins::_data()->_update_language($pm);

            $subms = $this->__db->_get_data("sys_menus_items", "*", "parent_id='" . $pm["id"] . "' order by `sys_order`");


            $data[] = ["type" => "start", "data-insaction" => "ins_collapsed", "class" => "$sopen ins_collapsed  insaction ins_border_bottom ins_col_12 ins_grid"];

            $data[] = ["type" => "h3", "data" => "<span>" . $pm["icon"] . "</span>" . $pm["title"], "class" => "ins_panel_title  ins_col_12"];

            $sopen = "";
            foreach ($subms as $m) {
                ins::_data()->_update_language($m);

                $this->__data->_update_data_language("sys_menus_items", $m);
                $data[] = ["type" => "start", "class" => " ins_col_4 ins_card_btn ins_light"];
                $h_m = "";

                if ($this->_fav_chack($m)) {
                    $h_m = " act ";
                }
                $data[] = ["type" => "a", "data" => "<span>" . $m["icon"] . "</span> <i data-id='" . $m["id"] . "' class=\"fas ins_change_fav  $h_m fa-heart\"></i>"
                    . $m["title"], "href" => \ins::_eng()->_url(["alias" => $m["alias"]])];
                $data[] = ["type" => "end"];
            }
            $data[] = ["type" => "end"];
        }



        $h = $this->__db->_get_row("sys_html", "*", " id=:id  ", ["id" => "74"]);

        $data["end-data"] = [];
        $data["line-pc"] = [];
        $data["div-pc"] = ["data" => $h["content"]];
        $data["end"] = [];
        return \ins::_ui()->_data($data)->_render();
    }



    /**
Teacher
     */

    function _plg_st_chat($rq)
    {


        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
        $uidata[] = [
            "type" => "plugin",
            "data" => "plg_ins_chat",
            "pclass" => "ins_col_12",



            "from_user_type" => $rq["from_user_type"], // "app_school_students",
            "from_type" => $rq["from_type"], //"user"
            "from_id" => $rq["from_id"], // "6",


            "area" => "root",
            "chat_type" => $rq["chat_type"],
            "to_type" => $rq["to_type"],
            "to_id" => $rq["to_id"],
            "to_user_type" => $rq["to_user_type"]
        ];


        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }
    function ui_st_teacher($rq)
    {

        $adata =   com_school::get_teachers("id={$rq["gdata_id"]}", true);


        $subjects =  explode(",", $adata["subjects"]);
        $subjects =  \ins::_db()->_get_data("com_school_subjects", "title", \ins::_data()->_db_create_where_from_array($subjects)); //["title"];

        $subjects_t = "";
        foreach ($subjects as  $s) {
            $subjects_t .= " " . $s["title"];
        }

        $uidata = [];
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
        $uidata[] = ["type" => "start", "class" => "ins_grid ins_card ins_col_4 menu_data ", "style" => "align-items: start;    text-align: center;"];
        $uidata[] = [
            "type" => "div",


            "data-status" => "_plg_st_chat",
            "data-lb_title" => " تواصل مع " . $adata["title"],
            "data-lb_style" => "height:530px;width:60%;",

            "data-chat_type" => "message",

            "data-to_id" => $adata["id"],
            "data-to_user_type" => "com_hr_employees",
            "data-to_type" => "user",

            "data-from_id" => $this->_g["id"], // "6",
            "data-from_user_type" => "app_school_students",
            "data-from_type" => "user",


            "data" => '<span><i class="fas fa-comment-dots"></i></span> ارسل رسالة ',
            "class" => " _btn_getdata ins_col_6 ins_card_btn ins_light"
        ];





        $uidata[] = [
            "type" => "div",

            "data-status" => "_plg_st_chat",
            "data-lb_title" => "  ارسل شكوى الى " . $adata["title"],
            "data-lb_style" => "height:530px;width:60%;",

            "data-chat_type" => "Complaintomplaint",

            "data-to_id" => $adata["id"],
            "data-to_user_type" => "com_hr_employees",
            "data-to_type" => "user",

            "data-from_id" => $this->_g["id"], // "6",
            "data-from_user_type" => "app_school_students",
            "data-from_type" => "user",


            "data" => '<span><i class="fas fa-comment-slash"></i></span> ارسل شكوى ', "class" => "ins_col_6 _btn_getdata ins_card_btn ins_light"
        ];
        $uidata[] = ["type" => "end"];
        $uidata[] = ["type" => "start", "class" => "ins_grid ins_col_8 ins_card", "style" => "align-items: start;"];
        $uidata[] = ["type" => "h4", "data" => $adata["title"], "class" => "ins_col_6"];
        $uidata[] = ["type" => "h5", "data" => $subjects_t, "class" => "ins_col_6"];
        $uidata[] = ["type" => "line"];
        $uidata[] = ["type" => "img", "data" => $adata["image"], "pclass" => "ins_col_4"];
        $uidata[] = ["type" => "div", "data" => $adata["des"], "class" => "ins_col_8"];
        $uidata[] = ["type" => "end"];

        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function teacher($udata)
    {
        $r = "";

        $adata =  com_school::get_teachers_by_dormitory($udata["dormitory"]);


        $uidata = [];
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "text-align:center"];
        foreach ($adata as $ad) {
            $itemdata = [
                "img" => ["data" => $ad["image"], "class" => "ins_circle_tiny", "pstyle" => "text-align:center"],
                "li" => ["data" => $ad["title"]],
            ];
            $uidata[] = [
                "type" => "div", "data-gdata" => "ui_st_teacher",  "data-gdata_id" => $ad["id"],
                "data" => \ins::_ui()->_data($itemdata)->_render(), "class" => "ins_col_4 _btn_getdata_page "
            ];
        }
        $uidata[] = ["type" => "end"];
        $r =   \ins::_ui()->_data($uidata)->_render();
        return $r;
    }





    /**
--Body
     */


    function table_footer()
    {

        $uidata[] = ["type" => "start", "class" => "ins_grid ins_col_12", "style" => "align-items: start;"];
        $uidata[] = ["type" => "div",  "class" => "ins_col_3"];

        $uidata[] = ["type" => "start",  "class" => "ins_col_6 ins_grid"];


        $uidata[] = ["type" => "i",  "class" => "ins_col_2 fas fa-chevron-right"];

        $uidata[] = ["type" => "span", "data" => "1",  "class" => "ins_col_2"];
        $uidata[] = ["type" => "span", "data" => "2",  "class" => "ins_col_2"];
        $uidata[] = ["type" => "span", "data" => "3",  "class" => "ins_col_2"];
        $uidata[] = ["type" => "span", "data" => "4",  "class" => "ins_col_2"];


        $uidata[] = ["type" => "i",  "class" => "ins_col_2 fas fa-chevron-left"];



        $uidata[] = ["type" => "end"];


        $uidata[] = ["type" => "end"];

        return \ins::_ui()->_data($uidata)->_render();
    }

    function assignment($rq)
    {
        $adata = \ins::_db()->_get_data('com_school_assignment', "*", "dormitories='{$rq["dormitory"]}'");
        $uidata = [];

        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];

        $table[] = [
            ["data" => "التاريخ", "data-ar" => "التاريخ", "class" => "ins_col_6"],
            ["data" => "العنوان", "data-ar" => "العنوان", "class" => "ins_col_8"],
            ["data" => "المادة", "data-ar" => "المادة", "class" => "ins_col_6"],
            ["data" => "الحالة", "data-ar" => "الحالة", "class" => "ins_col_4"]

        ];


        foreach ($adata as $s) {

            $sdata = \ins::_db()->_get_row('com_school_subjects', "*", "id='{$s["subject"]}'");
            $ssdata = \ins::_db()->_get_row('com_school_send_assignment', "*", "ass_id='{$s["id"]}' and  student_id='{$rq["id"]}'");
            $status = '<i class="fas fa-upload"></i>';;
            if (is_array($ssdata)) {
                $status = '<i class="fas fa-check"></i>';
            }
            $table[] = [
                ["data" => $s["date"], "class" => "ins_col_6"],
                ["data" => $s["title"], "class" => "ins_col_8"],
                ["data" =>  $sdata["title"], "data-ar" => "المادة", "class" => "ins_col_6"],
                ["data" => $status, "class" => "ins_col_4"]

            ];
        }

        $uidata[] = ["type" => "table_divs", "data" => $table, "style" => "margin-top:25px", "class" => "ins_col_12"];
        $uidata[] = ["type" => "div", "class" => "ins_grid ins_col_8 ins_table_footer", "data" => $this->table_footer(), "style" => "grid-column-start: 3;align-items: start;"];

        $uidata[] = ["type" => "end"];

        return \ins::_ui()->_data($uidata)->_render();
    }
    function exmas($rq)
    {
        $adata = \ins::_db()->_get_data('com_school_exams');
        $uidata = [];

        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];

        $table[] = [
            ["data" => "التاريخ", "data-ar" => "التاريخ", "class" => "ins_col_6"],
            ["data" => "العنوان", "data-ar" => "العنوان", "class" => "ins_col_14"],
            ["data" => "الدرجه", "data-ar" => "الدرجه", "class" => "ins_col_4"]

        ];


        foreach ($adata as $s) {

            $sdata = \ins::_db()->_get_row('com_school_subjects', "*", "id='{$s["subject"]}'");
            $ssdata = \ins::_db()->_get_row('com_school_exams_results', "*", "exam_id='{$s["id"]}' and  student_id='{$rq["id"]}'");
            $table[] = [
                ["data" => $s["date"], "class" => "ins_col_6"],
                ["data" => $s["title"], "class" => "ins_col_14"],
                ["data" =>  $ssdata["st_degree"], "class" => "ins_col_4"]

            ];
        }

        $uidata[] = ["type" => "table_divs", "data" => $table, "style" => "margin-top:25px", "class" => "ins_col_12"];
        $uidata[] = ["type" => "div", "class" => "ins_grid ins_col_8 ins_table_footer", "data" => $this->table_footer(), "style" => "grid-column-start: 3;align-items: start;"];
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }




    function ui_st_subject($rq)
    {
        $adata = \ins::_db()->_get_row('com_school_subjects', "*", "id='{$rq["gdata_id"]}'");




        $uidata = [];

        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];


        $uidata[] = ["type" => "start", "class" => "ins_grid ins_col_12 ins_card", "style" => "align-items: start;"];
        $uidata[] = ["type" => "h5", "data" => $adata["title"], "class" => "ins_col_6 st_page_title"];
        $uidata[] = ["type" => "line"];
        $uidata[] = ["type" => "img", "data" => $adata["image"], "pclass" => "ins_col_4"];
        $uidata[] = ["type" => "div", "data" => $adata["des"], "class" => "ins_col_8"];
        $uidata[] = ["type" => "end"];

        $uidata[] = [
            "type" => "ins_tabs", "class" => "ins_col_12",
            "data-show" => "cldata",
            "data" => '[
            {"data":"Conent","data-ar":"المحتويات" ,"data-show":".tabconent" ,"class":"ins_col_4"},
            {"data":"cal" ,"data-ar":"التقويم","data-show":".cldata" ,"class":"ins_col_4"}
            ]'
        ];

        $uidata[] = ["type" => "start", "class" => "cldata ins_grid ins_col_12"];
        $uidata[]  = ["type" => "weekly_calender", "class" => "ins_col_12", "data" =>   $adata["calendar"]];
        $uidata[] = ["type" => "end"];

        $uidata[] = ["type" => "start", "class" => "tabconent  ins_hidden ins_grid ins_col_12"];
        $uidata[] = ["type" => "plugin", "data" => "plg_conent", "pclass" => "ins_col_12 ", "cat_id" => $adata["content_category"], "area" => "root"];

        $uidata[] = ["type" => "end"];
        $uidata[] = ["type" => "end"];


        if ($adata["calendar"] != "" &&  $adata["calendar"] != "null") {
        }








        $uidata[] = ["type" => "end"];




        return \ins::_ui()->_data($uidata)->_render();
    }

    function subject($udata)
    {
        $r = "";

        $adata = \ins::_db()->_get_data('com_school_subjects', "*", ins::_data()->_db_create_where_to_group($udata["class"], "classes"));

        //<i class="fas fa-bell"></i>

        $uidata = [];
        // $uidata[] = ["type" => "h3", "data-ar" => '<i class="fas fa-boxes"></i>' . "المواد الدراسية", "data" => '<i class="fas fa-boxes"></i>' . "Subjects", "style" => "margin:10px;padding:5px 10px"];

        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "text-align:center"];
        foreach ($adata as $ad) {
            $itemdata = [
                "i" => ["class" => "     fas fa-book", "style" => 'font-size: 33px;padding: 25px;text-align: center;'],
                "li" => ["data" => $ad["title"]],
            ];
            $uidata[] = [
                "type" => "div", "data-gdata" => "ui_st_subject",  "data-gdata_id" => $ad["id"],
                "data" => \ins::_ui()->_data($itemdata)->_render(), "class" => "ins_col_4 ins_card_btn ins_light   _btn_getdata_page"
            ];
        }
        $uidata[] = ["type" => "end"];
        $r =   \ins::_ui()->_data($uidata)->_render();
        return $r;
    }

    function notification($udata)
    {

        $uidata[] = ["type" => "h3", "data-ar" => '<i class="fas fa-bell"></i>' . "إشعارات ", "data" => '<i class="fas fa-bell"></i>' . "Notifications", "style" => "margin:10px;padding:5px 10px"];
        $types = ["class" => $udata["class"]];
        $uidata[] = ["type" => "plugin", "data" => "ins_sys_notifications", "area" => "root"];

        $uidata[] = ["type" => "i", "class" => "fas ins_col_12 _btn_more fa-chevron-circle-down", "style" => "text-align:center"];



        return   \ins::_ui()->_data($uidata)->_render();
    }


    function _update_udata()
    {
        if (
            $_SESSION["sys_user_login_data"]["ex_table"] != "app_school_students"
            && isset($this->_g["id"])
        ) {
            $this->udata  = \ins::_db()->_get_row('app_school_students', "*", "id={$this->_g["id"]}");
        } else if ($_SESSION["sys_user_login_data"]["ex_table"] != "app_school_students") {
            return false;
        } else {
            $this->udata = $_SESSION["sys_users_login_ex_data"];
        }
        $this->udata["class_title"] = ins::_db()->_get_row("com_school_classes", "*", "id={$this->udata["class"]}")["title"];
        $this->udata["dormitory_title"] = ins::_db()->_get_row("com_school_dormitories", "*", "id={$this->udata["dormitory"]}")["title"];
        return true;
    }

    /**
--calender
     */
    function cal_week()
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid ins_dark", "style" => "grid-gap: 0;"];
        $uidata[] = ["type" => "h2", "data" => date("F j, Y, g:i a"), "class" => "ins_col_12", "style" => "    padding: 20px;
        text-align: center;"];

        $uidata[] = ["type" => "start", "data" => "ul", "style" => "grid-gap: 0;", "class" => "ins_grid ins_cal_week_days ins_dark ins_col_12"];
        $uidata[] = ["type" => "li", "data" => "السبت", "class" => " ins_col_2", "style" => "text-align:center"];
        $uidata[] = ["type" => "li", "data" => "الاحد", "class" => " ins_col_2", "style" => "text-align:center"];
        $uidata[] = ["type" => "li", "data" => "الاثنين", "class" => " ins_col_2 ins_light", "style" => "text-align:center"];
        $uidata[] = ["type" => "li", "data" => "الثلاثاء", "class" => " ins_col_2", "style" => "text-align:center"];
        $uidata[] = ["type" => "li", "data" => "الاربعاء", "class" => " ins_col_2", "style" => "text-align:center"];
        $uidata[] = ["type" => "li", "data" => "الخميس", "class" => " ins_col_2", "style" => "text-align:center"];
        $uidata[] = ["type" => "end", "data" => "ul"];
        $uidata[] = ["type" => "start", "style" => "grid-gap: 0;", "data" => "ul", "class" => "ins_grid  ins_cal_week_data ins_light  ins_col_12",];

        $uidata[] = ["type" => "li", "data" => " 9:30 am <span>1</span>", "class" => " ins_col_1   ins_cal_week_subject_time"];
        $uidata[] = ["type" => "li", "data" => "<span class='ins_dark    ins_card'>اللغة العربية     <b class='ins_dark    '></b></span>", "class" => " ins_col_11   ins_cal_week_subject"];



        $uidata[] = ["type" => "li", "data" => " 10:30 am <span>2</span>", "class" => " ins_col_1   ins_cal_week_subject_time"];
        $uidata[] = ["type" => "li", "data" => "<span class='ins_dark     ins_card'>اللغة الانجليزية <b class='ins_dark    '></b></span>", "class" => " ins_col_11   ins_cal_week_subject"];

        $uidata[] = ["type" => "li", "data" => " 11:00 am <span>3</span>", "class" => " ins_col_1   ins_cal_week_subject_time"];
        $uidata[] = ["type" => "li", "data" => "<span class='ins_dark     ins_card'>دين اسلامى  <b class='ins_dark    '></b></span>", "class" => " ins_col_11   ins_cal_week_subject"];

        $uidata[] = ["type" => "li", "data" => " 11:30 am <span>4</span>", "class" => " ins_col_1   ins_cal_week_subject_time"];
        $uidata[] = ["type" => "li", "data" => "<span class='ins_dark     ins_card'>نشاط  <b class='ins_dark    '></b></span>", "class" => " ins_col_11   ins_cal_week_subject"];


        $uidata[] = ["type" => "li", "data" => " 12:30 am <span>5</span>", "class" => " ins_col_1   ins_cal_week_subject_time"];
        $uidata[] = ["type" => "li", "data" => "<span class='ins_dark     ins_card'>اللغة العربية <b class='ins_dark    '></b></span>", "class" => " ins_col_11   ins_cal_week_subject"];

        $uidata[] = ["type" => "end", "data" => "ul"];


        $uidata[] = ["type" => "div", "data" => $this->cal(), "style" => "padding: 25px 0;", "class" => " ins_col_12 "];

        $uidata[] = ["type" => "end"];
        return   \ins::_ui()->_data($uidata)->_render();
    }

    function cal()
    {
        $data = \ins::_db()->_get_data("com_calendar");
        foreach ($data as $d) {
            $mstyle = "";
            if ($d['color'] != "") {
                $mstyle .= ' style="background:' . $d['color'] . '" ';
            }
            $v = "<b  $mstyle class=\"ins_calendar_event_data\" data-id=\"" . $d['id'] . "\">" . $d["icon"] . " " . ins::_data()->get_ins_list("calendar_event_type", $d["calendar_event_type"])["text"] . "</b>";
            $cldata[] = [
                "from" => $d["c_from"],
                "to" => $d["c_to"],
                "text" => $v
            ];
        }
        $uidata = [
            "type" => "div",
            "data-cl" => json_encode($cldata),
            "data-lang" => ins::_eng()->_this_lang,
            "class" => "mycal ins_mode_calendar ins_calendar", "data" => "<span></span>"
        ];
        return ins::_ui()->_data($uidata)->_render();
    }

    /**
--activeies

     */


    function get_message_options($title, $toid, $type = "message", $to_user_type = "com_hr_employees")
    {

        return [

            "data-lb_title" => $title,
            "data-status" => "_plg_st_chat",
            "data-lb_style" => "height:530px;width:60%;",
            "data-chat_type" => $type,

            "data-to_id" => $toid,
            "data-to_user_type" => $to_user_type,
            "data-to_type" => "user",

            "data-from_id" => $this->_g["id"],
            "data-from_user_type" => "app_school_students",
            "data-from_type" => "user",
        ];
    }
    function ui_st_activeies($rq)
    {
        $adata = \ins::_db()->_get_query("SELECT  com_school_activity.* ,com_school_activities.title as act_title 
        ,com_school_activities.icon as act_icon,com_school_activities.resp as act_resp FROM com_school_activities 
        inner JOIN com_school_activity  ON com_school_activity.act_id=com_school_activities.id  where com_school_activity.id={$rq["gdata_id"]}");
        $adata =  $adata[0];
        $uidata = [];
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
        $uidata[] = ["type" => "start", "class" => "ins_grid ins_card ins_col_4 menu_data ", "style" => "align-items: start;    text-align: center;"];
        $uidata[] = ["type" => "h4", "data" => "المسئولين عن النشاط", "class" => "ins_col_12  "];

        $res = explode(",", $adata["act_resp"]);


        $res = array_filter($res);
        foreach ($res  as $rs) {
            $resdata = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$rs["id"]}'");
            $uidata[] = ["type" => "div", "data" =>  $resdata["name"], "class" => "ins_col_12 ins_card_btn ins_light"];
            $actmresid = $resdata["id"];
        }




        $uidata["_plg_st_chatact_msg"] = [
            "type" => "div",
            "data" => '<span><i class="fas fa-comment-dots"></i></span> ارسل رسالة ', "class" => "ins_col_6 _btn_getdata ins_card_btn ins_light"
        ];


        $uidata["_plg_st_chatact_msg"] = array_merge(
            $uidata["_plg_st_chatact_msg"],
            $this->get_message_options(" ارسل رسالة الى المسئول عن النشاط " . $adata["act_title"], $actmresid)
        );



        $uidata["_plg_st_chatact_com"] = [
            "type" => "div",
            "data-chat_type" => "complaint",
            "data" => '<span><i class="fas fa-comment-slash"></i></span> ارسل شكوى ', "class" => "ins_col_6 _btn_getdata ins_card_btn ins_light"
        ];


        $uidata["_plg_st_chatact_com"] = array_merge(
            $uidata["_plg_st_chatact_com"],
            $this->get_message_options(" ارسل شكوى الى المسئول عن النشاط " . $adata["act_title"], $actmresid, "complaint")
        );




        $uidata[] = ["type" => "h4", "data" => "المسئولين عن المجموعة", "class" => "ins_col_12  "];

        $res = explode(",", $adata["resp"]);
        $res = array_filter($res);
        foreach ($res  as $rs) {
            $resdata = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$rs["id"]}'");
            $uidata[] = ["type" => "div", "data" => $resdata["name"], "class" => "ins_col_12 ins_card_btn ins_light"];
            $mresid = $resdata["id"];
        }


        $uidata["_plg_st_chat_msg"] = [
            "type" => "div",
            "data" => '<span><i class="fas fa-comment-dots"></i></span> ارسل رسالة ', "class" => "ins_col_6 _btn_getdata ins_card_btn ins_light"
        ];


        $uidata["_plg_st_chat_msg"] = array_merge(
            $uidata["_plg_st_chat_msg"],
            $this->get_message_options(" ارسل رسالة الى المسئول عن المجموعة " . $adata["title"], $mresid)
        );



        $uidata["_plg_st_chat_com"] = [
            "type" => "div",
            "data-chat_type" => "complaint",
            "data" => '<span><i class="fas fa-comment-slash"></i></span> ارسل شكوى ', "class" => "ins_col_6 _btn_getdata ins_card_btn ins_light"
        ];


        $uidata["_plg_st_chat_com"] = array_merge(
            $uidata["_plg_st_chat_com"],
            $this->get_message_options(" ارسل شكوى الى المسئول عن المجموعة " . $adata["title"], $mresid, "complaint")
        );


        $uidata[] = ["type" => "end"];

        $uidata[] = ["type" => "start", "class" => "ins_grid ins_col_8 ins_card", "style" => "align-items: start;"];
        $uidata[] = ["type" => "h5", "data" => $adata["act_icon"], "class" => "ins_col_2", "style" => "   
        font-size: 40px;grid-row-start: 1;text-align: center;grid-row-end: 3;"];

        $uidata[] = ["type" => "h4", "data" => $adata["act_title"], "style" => 'font-size: 22px;', "class" => "ins_col_10"];
        $uidata[] = ["type" => "h5", "data" => $adata["title"], "class" => "ins_col_10"];

        $uidata[] = ["type" => "line"];
        if ($adata["image"] != "") {
            $uidata[] = ["type" => "img", "data" => $adata["image"], "pclass" => "ins_col_4"];
        }

        $uidata[] = ["type" => "div", "data" => $adata["des"], "class" => "ins_col_8"];
        $uidata[] = ["type" => "end"];
        $uidata[] = [
            "type" => "ins_tabs", "class" => "ins_col_12",
            "data-show" => "cldata",
            "data" => '[
            {"data":"map","data-ar":"خريطه" ,"data-show":".mapdata" ,"class":"ins_col_4"},
            {"data":"cal" ,"data-ar":"التقويم","data-show":".cldata" ,"class":"ins_col_4"}
            ]'
        ];



        $uidata[] = ["type" => "start", "class" => "cldata ins_grid ins_col_12"];
        $uidata[]  = ["type" => "weekly_calender", "class" => "ins_col_12", "data" =>   $adata["calendar"]];
        $uidata[] = ["type" => "end"];
        $uidata[] = [
            "type" => "div",  "data-locations" => $adata["locations"],
            "data" => "<div id='map' style='height: 400px;width:100%'></div>", "class" => "mapdata ins_hidden"
        ];
        $uidata[] = ["type" => "end"];

        if ($adata["calendar"] != "" &&  $adata["calendar"] != "null") {
        }
        $uidata[] = ["type" => "end"];

        return \ins::_ui()->_data($uidata)->_render();
    }

    function activeies($udata)
    {

        $adata = \ins::_db()->_get_query("SELECT com_school_activities.* ,com_school_activity.id as gid  FROM com_school_activities 
        inner JOIN com_school_activity  ON com_school_activity.act_id=com_school_activities.id 
         where com_school_activities.optional=1 and 
          JSON_EXTRACT(com_school_activity.students, '$.{$udata["id"]}')<>''");

        $uidata = [];
        // $uidata[] = ["type" => "h3", "data-ar" => '<i class="fas fa-swimmer"></i>' . "الانشظة", "data" => '<i class="fas fa-swimmer"></i>' . "Activeies", "style" => "margin:10px;padding:5px 10px"];
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "text-align:center"];
        $itemdata = [
            "i" => ["class" => "fas fa-plus", "style" => 'font-size: 33px;padding: 25px;text-align: center;'],
            "li" => ["data" => "add", "data-ar" => "  اشترك فى نشاط"],
        ];
        $uidata[] = ["type" => "div", "data" => \ins::_ui()->_data($itemdata)->_render(), "class" => "ins_col_4 ins_card_btn ins_dark "];


        $ud = [];
        foreach ($adata as $ad) {
            if (!in_array($ad["id"], $ud)) {

                array_push($ud, $ad["id"]);

                $itemdata = [
                    "span" => [
                        "data" => $ad["icon"],
                        "class" => "",
                        "style" => 'font-size: 33px;padding: 25px;text-align: center;'
                    ],
                    "li" => ["data" => $ad["title"]],
                ];
                $uidata[] = [
                    "type" => "div",
                    "data-gdata" => "ui_st_activeies",
                    "data-gdata_id" => $ad["gid"],
                    "data" => \ins::_ui()->_data($itemdata)->_render(), "class" => "ins_col_4 _btn_getdata_page ins_card_btn ins_light "
                ];
            }
        }
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    /**
--out
     */


    function _out()
    {
        include_once("ins_coms/com_school/com_school.php");

        $this->_include("my_style.css");
        $this->_include("my_js.js");




        \ins::_ui()->_data([
            "type" => "plugin",
            "data" => "plg_ins_chat",
            "area" => "root",
            "import_file_only" => true,
        ])->_render();




        if (isset($this->_g["gdata"])) {

            if ($this->_update_udata()) {
                $data = [
                    [
                        "type" => "start",
                        "data-url" => ins::_eng()->_url([], ["gdata", "gdata_id"]),
                        "data-id" => $this->udata["id"], "class" => "ins_grid ins_st_home_panel", "style" => "  grid-gap: 0;    align-items: start;"
                    ],

                    [
                        "type" => "a", "href" => ins::_eng()->_url([], ["gdata", "gdata_id"]),
                        "data-ar" => 'رجوع' . '<i style="margin:0 15px;text-align: left;" class="fas fa-chevron-left"></i>',
                        "data" => '<i class="fas fa-chevron-right"></i>Back',
                        "class" => " ins_dark ins_col_12", "style" => "padding:25px"
                    ],
                    ["type" => "div", "data" => $this->get_mydata(), "class" => " ins_dark ins_shadow ins_col_12", "style" => "padding:25px"],

                    ["type" => "div", "data" => call_user_func("com_school_student::" . $this->_g["gdata"], $this->_g), "class" => " ins_col_12", "style" => "padding:25px"],



                    ["type" => "end"]
                ];
                $r .= \ins::_ui()->_data($data)->_render();
            }
        } else if ($this->_update_udata()) {

            $data = [
                [
                    "type" => "start",
                    "data-url" => ins::_eng()->_url([], ["gdata", "gdata_id"]),
                    "data-id" => $this->udata["id"], "class" => "ins_grid ins_st_home_panel", "style" => "  grid-gap: 0;    align-items: start;"
                ],

                ["type" => "div", "data" => $this->get_mydata(), "class" => "ins_shadow  ins_dark ins_col_8", "style" => "padding:25px"],
                ["type" => "div", "data" => $this->cal_week($this->udata), "class" => " ins_shadow ins_dark  ins_col_6", "style" => "grid-row-end: 8; grid-row-start: 1;grid-column-start: 9; padding:10px;"],
                [
                    "type" => "start", "data-id" => $this->udata["id"], "class" => "ins_grid ins_col_8", "style" => "align-items: start;     padding: 20px;"
                ],
                [
                    "type" => "div", "data" => $this->ui_st_repoets(["st_id" => $this->udata["id"]]), "class" => " ins_col_12 _ui_st_repoets", "style" => "align-items: center;"
                ],
                ["type" => "div", "data" => $this->notification($this->udata), "class" => "ins_card  ins_col_4", "style" => "grid-row-end: 8;grid-row-start: 2;"],



                ["type" => "start", "class" => "ins_grid ins_col_8", "style" => "padding:15px"],
                [
                    "type" => "ins_tabs", "class" => "ins_col_12",
                    "data-show" => "tab_t",
                    "data" => '[
                    {"data":"Conent","data-ar":"<i class=\"fas fa-chalkboard-teacher\"></i>المدرسين" ,"data-show":".tab_t" ,"class":"ins_col_4"},
                    {"data":"cal" ,"data-ar": "<i class=\"fas fa-boxes\"></i> المواد الدراسية","data-show":".tab_s" ,"class":"ins_col_4"},
                    {"data":"cal" ,"data-ar":"<i class=\"fas fa-swimmer\"></i> الانشطة","data-show":".tab_a" ,"class":"ins_col_4"}
                    ]'
                ],
                ["type" => "div", "data" => $this->teacher($this->udata), "style" => '     min-height: 260px;   padding: 10px 0;', "class" => "tab_t ins_col_12 "],
                ["type" => "div", "data" => $this->subject($this->udata), "style" => '   min-height: 260px;  padding: 10px 0;', "class" => " tab_s ins_hidden ins_col_12 "],
                ["type" => "div", "data" => $this->activeies($this->udata), "style" => '   min-height: 260px;  padding: 10px 0;', "class" => " tab_a ins_hidden ins_col_12"],
                ["type" => "ins_tabs_end"],


                [
                    "type" => "ins_tabs", "class" => "ins_col_12",
                    "data-show" => ".tab_ass",
                    "data" => '[
                    {"data":"assignment","data-ar":"<i class=\"fas fa-chalkboard-teacher\"></i>الواجبات المدرسية" ,"data-show":".tab_ass" ,"class":"ins_col_6"},
                    {"data":"exams" ,"data-ar": "<i class=\"fas fa-boxes\"></i>  نتائج الامتحانات","data-show":".tab_ex" ,"class":"ins_col_6"}
                    ]'
                ],

                ["type" => "div", "data" => $this->assignment($this->udata),  "class" => "tab_ass tab_a ins_col_12", "style" => "    font-size: 11px;"],

                ["type" => "div", "data" => $this->exmas($this->udata), "style" => ' 
                  height: 360px;  padding: 10px 0;', "class" => "tab_ex ins_hidden tab_a ins_col_6", "style" => "    font-size: 11px;"],


                ["type" => "ins_tabs_end"],


                ["type" => "end"],
                // ["type" => "div", "data" => $this->get_menu(), "class" => "ins_card ins_col_12"]

            ];
            $r .= \ins::_ui()->_data($data)->_render();
        }

        return $r;
    }
}
