<?php

class sys_ui_builder extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    function _ins_editor_code_update($rq)
    {
        $out = $rq["ins_code"];
        $out =  strip_tags($out);
        $out = str_replace('&nbsp;', '', $out);
        $out =  trim($out);
        $sdata = json_decode($out, true);

        $uidata = [];
        foreach ($sdata  as $uiitem) {
            if (!isset($uiitem["id"])) {
                $uiitem["id"] = "_" . uniqid();
            }
            $uiitem["data-ins_editor_data"] = json_encode($uiitem);
            $uidata[] = ["type" => "div", "id" => "_cont" . $uiitem["id"], "data-uiid" => $uiitem["id"],  "data" => $uiitem, "class" => $uiitem["class"] . " ins_editor_ui_contner"];
        }

        return ins::_ui()->_data($uidata)->_render();;
    }


    function ins_editor_settings_panel()
    {

        $uidata[] = ["type" => "start", "class" => "ins_grid"];
        $uidata[] = ["type" => "textarea", "title" => "data", "data-for" => "data", "class" => "ins_col_12 ins_editor_settings_panel_text  _data", "pclass" => "ins_col_12"];
        $uidata[] = ["type" => "textarea", "title" => "classes", "data-for" => "class", "class" => " ins_editor_settings_panel_text _class ", "pclass" => "ins_col_12"];
        $uidata[] = ["type" => "textarea", "title" => "attrs", "data-for" => "attras", "class" => "ins_col_12 ins_editor_settings_panel_text  _attrs ", "pclass" => "ins_col_12"];
        $uidata[] = ["type" => "textarea", "title" => "style", "data-for" => "style", "class" => "ins_col_12 ins_editor_settings_panel_text _style ", "pclass" => "ins_col_12"];
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }


    function mian_ui()
    {

        $uidata[] = ["type" => "start", "class" => "ins_grid"];
        $uidata[] = ["type" => "div", "class" => "ins_col_2 ins_editor_panel ins_light", "data" => $this->ins_editor_settings_panel(), "style" => "min-height:500px;"];


        $uidata[] = ["type" => "div", "class" => "ins_col_10 ins_editor_ins_stage ins_grid", "style" => "min-height:500px;"];



        $uidata[] = ["type" => "div", "contenteditable" => "true", "class" => "ins_col_12 ins_editor_ins_code ins_editor_codearea ins_dark", "style" => "min-height:200px;"];
        $uidata[] = ["type" => "start", "class" => "ins_col_12 ins_editor_toobar ins_editor_toobar_footer  ins_dark", "style" => "height:50px;"];
        $uidata[] = ["type" => "div", "data" => "update", "class" => "ins_toolbar_btn_update"];
        $uidata[] = ["type" => "div", "data" => "tocode", "class" => "ins_toolbar_btn_update_code"];

        $uidata[] = ["type" => "end"];
        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }


    function _out()
    {

        return $this->mian_ui();
    }
}
