<?php

class sys_images_categories extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    function _update_order($rq)
    {

        $ids = explode(";", $rq["ids"]);

        foreach ($ids as $id) {
            $id = explode(",", $id);

            if (isset($id[1])) {

                echo ins::_db()->_update("sys_images", ["sys_order" => $id[1]], "id=" . $id[0]);
            }
        }
    }

    function _delete_images($rq)
    {
        $all_data = ins::_db()->_delete("sys_images", "id=" . $rq["image_id"]);
        return sys_images_categories::_get_images($rq);
    }

    function _upload_images($rq)
    {
        $all_data = ins::_db()->_insert(
            "sys_images",
            [
                "title" => explode(".", $rq["name"])[0], "alias" => explode(".", $rq["name"])[0], "image" => $rq["location"], "title" => $rq["location"], "cat_id" => $rq["id"]
            ]
        );
        return sys_images_categories::_get_images($rq);
    }

    function _get_images($rq)
    {





        $all_data = ins::_db()->_get_data("sys_images", "*", ins::_data()->_db_create_where_to_group($rq["id"]) . " order by sys_order ");

        $uidata = [];

        $uidata[] = ["type" => "start", "class" => "ins_grid"];


        foreach ($all_data as $data) {

            $uidata[] = ["type" => "start", "data-order" => $data["sys_order"], "data-id" => $data["id"], "class" => "ins_col_3 sic_image_item"];

            $uidata[] = ["type" => "start", "data" => "ul", "class" => "ins_col_12 sic_image_tools ins_dark"];


            $uidata[] = ["type" => "i", "data-id" => $data["id"], "class" => "fas fa-times sic_delete_image"];
            $uidata[] = ["type" => "i", "data-id" => $data["id"], "class" => "fas fa-edit sic_edit_image"];
            $uidata[] = ["type" => "i", "data-id" => $data["id"], "class" => "fas fa-arrows-alt sic_movie_image"];





            $uidata[] = ["type" => "end", "data" => "ul"];

            $uidata[] = ["type" => "img", "data" => $data["image"]];

            $uidata[] = ["type" => "end"];
        }


        $uidata[] = ["type" => "end"];


        return ins::_ui()->_data($uidata)->_render();
    }

    function _out()
    {

        $g = ins::_app_map()->_get();




        return $this->__ui->_data(["div" => [
            "data" => lib::_pages()->get_page("admin", "sys_images_categories"),
            "data-id" => $g["id"],
            "class" => "ins_block sys_images_categories_data col12"
        ]])
            ->_render();
    }
}
