<style>
    .sys_history_data {
        display: none;
    }

    .sys_history_show_hide_data {
        transform: rotate(90deg);
    }

    .sys_history_data_show .sys_history_data {
        display: block;
        transform: rotate(0);
    }
</style>
<?php


$data = \ins::_db()->_get_row($_REQUEST["table"], "*", "id={$_REQUEST["id"]}");


if ($data["sys_history"] == "") {
    echo '<div class="warning">No history</div>';
} else {
    $sys_history = json_decode($data["sys_history"], true);
    $uidata = [];
    $sys_history= array_reverse($sys_history);

    foreach ($sys_history as $history) {
        $user = \ins::_db()->_get_row("sys_users", "*", "id={$history["user_id"]}");

        $uiid = "_" . uniqid();


        $uidata[] = ["type" => "start", "class" => "ins_table   $uiid "];
        $uidata[] = ["type" => "start", "class" => "ins_tr"];
        $uidata[] = ["type" => "span", "data" => $history["date"], "class" => "ins_th ins_col_8"];
        $uidata[] = ["type" => "span", "data" => $history["action"], "class" => "ins_th ins_col_6"];
        $uidata[] = ["type" => "span", "data" => $user["title"], "class" => "ins_th ins_col_8"];
        $uidata[] = ["type" => "span", "data" => '<i data-sys_history_data="' . $uiid . '"   class="fas sys_history_show_hide_data fa-caret-down"></i>', "class" => "ins_th ins_col_2"];
        $uidata[] = ["type" => "end"];

        $uidata[] = ["type" => "start", "class" => "sys_history_data"];

        $uidata[] = ["type" => "start", "class" => "ins_tr"];
        $uidata[] = ["type" => "span", "data" =>"Field", "class" => "ins_td ins_col_8" ,"style"=> "font-weight: BOLD;"];
        $uidata[] = ["type" => "span", "data" =>  "Old Data", "class" => "ins_td ins_col_8", "style" => "font-weight: BOLD;"];
        $uidata[] = ["type" => "span", "data" => "New Data", "class" => "ins_td ins_col_8", "style" => "font-weight: BOLD;"];
        $uidata[] = ["type" => "end"];

        foreach ($history["old_data"] as $k => $v) {

            $uidata[] = ["type" => "start", "class" => "ins_tr"];
            $uidata[] = ["type" => "span", "data" => $k, "class" => "ins_td ins_col_8", "style" => "font-weight: BOLD;"];
            $uidata[] = ["type" => "span", "data" => $v, "class" => "ins_td ins_col_8"];
            $uidata[] = ["type" => "span", "data" => $history["new_data"][$k], "class" => "ins_td ins_col_8"];
            $uidata[] = ["type" => "end"];
        }

        $uidata[] = ["type" => "end"];
        $uidata[] = ["type" => "end"];
    }
    echo  \ins::_ui()->_data($uidata)->_render();
}
