class Helper {
    _ajax(type, options, fun) {
        console.log(type);
        ins(type)._ajax._class(
            options,
            function(data) {
                fun(data);
            }, {
                _myname: "com_auc_game",
                _mypath: "ins_coms/com_auc_game",
            }
        );
    }

    _get_msg(type = "_right_msg", op = {}, ondone = () => {}) {
        ins("._g_msg_cont")._remove();
        this._ajax(type, op, function(data) {
            var i = ins(".ins_main")._append(data);
            var intv = setInterval(() => {
                i._addclass("show");
                clearInterval(intv);
                ondone();

            }, 50);
        });
    }

    _remove_msg() {
        ins("._g_msg_cont")._removeclass("show");
        var intv = setInterval(() => {
            ins("._g_msg_cont")._remove();
            clearInterval(intv);
        }, 400);
    }

    _get_level_data(l = "one", fun) {
        this._ajax(`_level_${l}_data`, {}, function(data) {
            var j = JSON.parse(data);
            fun(j);
        });
    }

    _get_game_data(fun) {
        this._ajax("_get_game_data", {}, function(data) {
            var j = JSON.parse(data);
            fun(j);
        });
    }

    _timer_stop() {
        var th = this;

        if (th.timer_inv != null) {
            clearInterval(th.timer_inv);
            th.timer_inv = null;
        }
    }

    _timer(fun) {
        var th = this;
        var s = 0;
        var m = 0;
        if (th.timer_inv != null) {
            clearInterval(th.timer_inv);
        }
        th.timer_inv = setInterval(function() {
            s++;
            if (s == 60) {
                m++;
                s = 0;
            }
            var mt = m;
            var st = s;
            if (m < 10) {
                mt = "0" + m;
            }
            if (s < 10) {
                st = "0" + s;
            }
            var this_time = `${mt} : ${st}`;
            fun(this_time);
            ins("._g_timer")._sethtml(this_time);
        }, 1000);
    }

    _htmlDecode(input) {
        var e = document.createElement("textarea");
        e.innerHTML = input;
        return e.childNodes.length === 0 ? "" : e.childNodes[0].nodeValue;
    }

    _ru_ui_s() {
        var act_answer = 10;
        var top = 40;
        var u_height = 20;
        var hu_height = 10;

        var main_stroke_width = 1;
        var main_stroke_uwidth = 1;

        var main_stroke_color = "stroke:rgb(0,0,0)";

        var main_line_style = `style ="${main_stroke_color};stroke-width:${main_stroke_width}"`;
        var main_u_style = `style ="${main_stroke_color} ;stroke-width:${main_stroke_uwidth}"`;
        var main_hu_style = `style ="${main_stroke_color};stroke-width:${main_stroke_uwidth}"`;

        u_height = top + u_height;
        hu_height = top + hu_height;

        var r =
            ' <svg width="100%;" style="   margin-top: -15px;    overflow: visible;">';

        /** sp data */
        for (var i = 1; i <= act_answer; i++) {
            var sp = 100 / act_answer;
            var ui = 100 - i * sp;
            r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${
        top - 10
      }"  ${main_u_style} />`;
            r += `<text  style='fill:rgb(29, 48, 133);' x="${ui}%" text-anchor="middle"  y="${
        top - 20
      }">${i}M</text>`;
        }

        for (var i = 0; i < act_answer; i++) {
            var sp = 100 / act_answer;
            var ui = 100 - i * sp - 5;
            r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${hu_height}"  ${main_hu_style} />`;
        }
        r += `<line x1="100%"  x2="0" y1="${top}" y2="${top}" ${main_line_style} />`;
        r += "</svg>";

        ins("._g_ru_")._sethtml(r);
    }

    _ru_ui(act_answer, user_answer) {
        var top = 40;
        var th = this;
        var u_height = 20;
        var hu_height = 10;
        var ans_height = 20;

        var main_stroke_width = 1;
        var main_stroke_uwidth = 1;
        var main_stroke_ans_width = 3;

        var main_stroke_color = "stroke:rgb(0,0,0)";
        var answer_stroke_color = "rgb(0,0,255)";

        var main_line_style = `style ="${main_stroke_color};stroke-width:${main_stroke_width}"`;

        var main_u_style = `style ="${main_stroke_color} ;stroke-width:${main_stroke_uwidth}"`;
        var main_hu_style = `style ="${main_stroke_color};stroke-width:${main_stroke_uwidth}"`;

        var answer_style = `style ="stroke:${answer_stroke_color};stroke-width:${main_stroke_ans_width}"`;

        u_height = top + u_height;
        hu_height = top + hu_height;

        var r =
            ' <svg width="100%;" style="   margin-top: -76px;    overflow: visible;">';

        /** sp data */
        for (var i = 1; i <= act_answer; i++) {
            var sp = 100 / act_answer;
            var ui = 100 - i * sp;
            r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${u_height}"  ${main_u_style} />`;
            r += `<text  x="${ui}%" text-anchor="middle" y="${
        u_height + 15
      }">${i}</text>`;
        }

        for (var i = 0; i < act_answer * 2; i++) {
            var sp = 100 / act_answer;
            var ui = 100 - (i * sp) / 2;
            r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${hu_height}"  ${main_hu_style} />`;
        }

        /** main data */

        if (parseFloat(act_answer) < parseFloat(user_answer)) {
            r += `<line x1="0%"  stroke-dasharray="4" x2="-10%" y1="${top}" y2="${top}" ${main_line_style} />`;
        }

        r += `<line x1="100%"  x2="0" y1="${top}" y2="${top}" ${main_line_style} />`;

        /** answer data */
        var pans = th._get_ball_per(act_answer, user_answer);
        pans = 100 - pans;

        r += `<line x1="${pans}%" x2="${pans}%"   y1="${ans_height}"  y2="${top}"  ${answer_style} />`;
        r += `<text text-anchor="middle"  x="${pans}%" y="${
      ans_height - 5
    }" style=' fill:${answer_stroke_color};    font-size: 20px;'>${user_answer}</text>`;

        r += "</svg>";

        ins("._g_ru_")._sethtml(r);
    }

    _remove_ru_ui() {
        ins("._g_ru_")._sethtml("");
    }
}