<?php

\lib::_eng()->_this_lang = "ar";



if (isset($_REQUEST["answers"])) {
    $answers = json_decode($_REQUEST["answers"], true);
    $data = get_input(count($answers), $answers);
} else {

    switch ($_REQUEST["type"]) {
        case "right":
            $data = get_input(2);
            break;
        case "text":
            $data = get_input(1);
            break;
        default :
            $data = get_input(4);
            break;
    }
}

echo \lib::_ui()->_data($data)->_render();

function get_value($i, $value = "value") {
    $r = "";
    if (isset($_REQUEST["answers"])) {
        $r = $_REQUEST["answers"][$i][$value];
    }

    return $r;
}

function get_input($num, $ns = "") {
    $data = [];
    for ($i = 0; $i < $num; $i++) {
        $v = "";
        $img = "";
        $img = "chec";


        $data["is_right-$i"] = ["name" => "is_right[]", "class" => 'is_right', "title" => 'is_right', "input" => "true", "type" => 'checkbox', "title-ar" => "الاجابه الصحيحه ", "pclass" => 'col2'];




        $data["answer-$i"] = ["name" => "answer[]", "class" => 'answer', "title" => 'answer', "type" => 'textarea', "title-ar" => "الاجابه ", "pclass" => 'col5'];
        $data["images-$i"] = ["name" => "images[]", "class" => 'images', "title" => 'image', "type" => 'image', "title-ar" => "صوره ", "pclass" => 'col5'];
        $data["line-$i"] = [];

        if (is_array($ns)) {
            $data["answer-$i"] ["value"] = $ns[$i]["value"];
            $data["images-$i"] ["value"] = $ns[$i]["image"];
            if ($ns[$i]["is_right"] == "true") {
                $data["is_right-$i"]["checked"] = "checked";
            }
        }
    }
    return $data;
}
