<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of ins_template
 *
 * @author ismail
 */

namespace ins_lib\bp;

class ins_template extends \ins_lib {

    /**
     *
     * @var \ins_lib\eng\EngClass
     */
    var $_eng;
    var $_header = "";
    var $_main;
    var $_menu;
    var $_url;
    var $_url_full;
    var $_pro;
    var $_xml;
    var $_site_setting;
    var $_body_tag, $_inner_title, $_title = "";
    var $_is_home;
    var $_breadcrumb = [];
    var $_logo = [];
    var $_upload_folder = "";
    var $_main_com = "";
    var $_lang = [];
    var $_body_class = "";
    var $_page_data = [];

    function __construct($name) {
        $this->addLibFiles_a();
        parent::__construct();
    }

    public function _update() {



        \lib::_eng()->_updateData();

        $this->_site_setting = $this->__eng->_site_setting;

        $this->_menu = $this->__eng->_getThisMenu;



        if (!\lib::_eng()->_is_ajax) {
            \lib::_data()->_update_data_language("sys_menus_items", $this->_menu);
        }

        $this->template = $this->__eng->_getTemplate();




        $this->_pro = \lib::_data()->_arrayFromDB($this->template["sys_properties"]);

        $this->_xml = $this->__eng->_get_properties_xml($this->template["type"], "", "");


        $this->_is_home = $this->_menu["home"];
        $this->_header .= "<style>" . $this->_menu["more_css"] . "</style>";

        $this->_upload_folder = $this->__app_map->upload_folder;



        $this->_title = $this->_menu["title"];

        $this->_this_lang = $this->__eng->_this_lang;
        $this->_lang = $this->__eng->_get_lang_xml($this->template["type"]);


        $mian_title = $this->__ui->_data(["h1" =>
                    [
                        "class" => "ins_mian_title title_bar",
                        "data" => "<span>" . $this->_title . "</span>"
                    ]
                ])->_render();






        if (!is_array($this->postions_Data)) {
            $this->_get_prostions();
        }


        $this->logo = \lib::_app_map()->upload_folder .
                $this->template["image"];


        $this->_myurl($this->template["type"]);

        $this->_url_full = "/" . \lib::_data()->_get_area() . "/" . $this->_url;
        $this->_url_full = \lib::_data()->_url_clrea($this->_url_full);


        $this->addLibFiles();
        if ($this->_is_home) {
            $this->_body_class .= " home ";
        }


        $page_data = $this->_page_data;

        $page_data["alias"] = $_GET['alias'];
        $page_data["lang"] = $this->__eng->_this_lang;
        $page_data["url"] = $_SERVER["REQUEST_URI"];

        $this->_main = $this->_getmian();

        if (isset($this->_pro["menu_type"])) {
            $this->_body_class .= "  " . $this->_pro["menu_type"];
        }
        if (isset($this->_pro["style"])) {
            $this->_body_class .= "  " . $this->_pro["style"];
        }




        if (\lib::_eng()->_this_lang == "ar") {

            $this->_header .= '<link href = "/ins_lib/css/ins_ui_ar.css" rel = "stylesheet" type = "text/css"/>' . PHP_EOL;
        }



        $cs = explode(",", $this->_menu["classes"]);


        foreach ($cs as $c) {
            $this->_body_class .= " " . $c . " ";
        }
        
        

        $this->_body_tag = ""
                . " data-alias='" . $_GET['alias'] . "'"
                . " data-lang='" . $this->__eng->_this_lang . "'"
                . " class='__" . $this->_menu["id"] . " $this->_body_class ' "
                . ""
                . "";
        $this->import_tamplate();
    }

    var $postions_Data;

    public function _get_prostions() {


        $this->postions_Data = $this->__eng->_getModels($this->_xml["positions"]);
    }

    public function _update_template_properties($name, $value, $id = "") {

        if ($id != "") {
            $odata = \lib::_db()->_get_row("sys_templates", "*", "id=" . $id);
            $p = \lib::_data()->_arrayFromDB($odata["sys_properties"]);
        } else {
            $p = $this->_pro;
            $id = $this->template["id"];
        }
        $p[$name] = $value;

        \lib::_db()->_update("sys_templates", ["sys_properties" => \lib::_data()->_arrayToDB($p)], "id=" . $id);
    }

    public function _getmian($name = null ,$clear=false) {
        
        

        $_g = \lib::_eng()->_get();

        foreach ($_g as $k => $v) {
            $this->_page_data[$k] = $v;
        }

        $this->_page_data["get"] = $_g;

        
        
        
        if ($clear){
                    return $this->__eng->_getThisCom($name);

        }else{
        $data = ["div" =>
            [    "trans" => "false",
                "class" => "ins_main",
                "data-alias" => $_GET['alias'],
                "data-lang" => $this->__eng->_this_lang,
                "data-url" => $_SERVER["REQUEST_URI"],
                "data" => $this->__ui->_data(
                        
                        ["div" =>
                    [
                        "trans" => "false",
                        "class" => "ins_mian_data ",
                     "data" => $this->__eng->_getThisCom($name)
                    ]
                ])->_render()
            ]
        ];


        $page_data = $this->_page_data;
        $page_data["alias"] = $_GET['alias'];
        $page_data["lang"] = $this->__eng->_this_lang;
        $page_data["url"] = $_SERVER["REQUEST_URI"];
        $page_data["clear_url"] = \lib::_eng()->_url("clear");
        $data["div"]["data-data"] = json_encode($page_data);

   
        return $this->__ui->_data($data)->_render();
        
        
        
        }
    }

    public function _myurl($tm) {
        $this->_url = \lib::_app_map()->template_folder . $tm;
    }

    public function _add_to_pagedata($k, $v) {
        $this->_page_data[$k] = $v;
    }

    public function _main() {
        return $this->_main;
    }

    public function _module($postion) {

        return $this->postions_Data[$postion];
    }

    public function _add_class_to_body($class) {

        $this->_body_class .= " " . $class;
    }

    public function _add_to_headr($text) {

        $this->_header .= $text;
    }

    public function _add_to_title($text) {

        $this->_title .= $text;
    }

    public function _inner_title($text) {

        $this->_inner_title = $text;
    }

    public function _add_to_breadcrumb($array) {
        foreach ($array as $k => $v) {
            $this->_breadcrumb[$k] = $v;
        }
    }

    var $add_libs = true;

    public function addLibFiles_a() {
       $file_ver=\ins::_options()->_files_version;
        $this->_header .= '<link href="/ins_lib/includes/font-awesome/css/all.css?'.$file_ver.'" rel="stylesheet" type="text/css"/>' . PHP_EOL;
        $this->_header .= '<link href = "/ins_lib/css/style.css?'.$file_ver.'" rel = "stylesheet" type = "text/css"/>' . PHP_EOL;

        $this->_header .= '<link href = "/ins_lib/css/ins_ui.css?'.$file_ver.'" rel = "stylesheet" type = "text/css"/>' . PHP_EOL;


        $this->_header .= '<link href = "/ins_lib/css/ins_lib.css?'.$file_ver.'" rel = "stylesheet" type = "text/css"/>' . PHP_EOL;
        $this->_header .= '<link href = "/ins_lib/css/ins_lib_phone.css?'.$file_ver.'" rel = "stylesheet" type = "text/css" media="only screen and (min-width: 0px) and (max-width: 800px)" />' . PHP_EOL;
        $this->_header .= '<link href = "/ins_lib/css/ins_ui_phone.css?'.$file_ver.'" rel = "stylesheet" type = "text/css" media="only screen and (min-width: 0px) and (max-width: 800px)" />' . PHP_EOL;


        //     $this->_header .= '<script src = "/ins_lib/includes/jquery-3.1.0.min.js" type = "text/javascript"></script>' . PHP_EOL;

        if ($this->add_libs) {
            $this->_header .= ' ' . PHP_EOL;
            $this->_header .= '<script src="/ins_lib/js/lib/ins.js?'.$file_ver.'" type="text/javascript"></script>' . PHP_EOL;
            $this->_header .= '<script src="/ins_lib/js/lib/eng.js?'.$file_ver.'" type="text/javascript"></script>' . PHP_EOL;
            $this->_header .= '<script src="/ins_lib/js/lib/ui.js?'.$file_ver.'" type="text/javascript"></script>' . PHP_EOL;
        }








        return $this;
    }

    public function addLibFiles() {
        $text = ' <link href="' . $this->_url_full . '/css/style.css?v=109" rel="stylesheet" type="text/css"/> '
                . '<link href="' . $this->_url_full . '/css/style-' . $this->__eng->_this_lang . '.css?v=108" rel="stylesheet" type="text/css"/> '
                . ''
                . ''
        ;


        if (isset($this->_site_setting['facebook_id']) && trim($this->_site_setting['facebook_id']) != "") {
            /*    $text .= '   <!-- Load Facebook SDK for JavaScript -->
              <div id="fb-root"></div>
              <script>(function(d, s, id) {
              var js, fjs = d.getElementsByTagName(s)[0];
              if (d.getElementById(id)) return;
              js = d.createElement(s); js.id = ' . $this->_site_setting['facebook_id'] . ';
              js.src = "https://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v3.0";
              fjs.parentNode.insertBefore(js, fjs);
              }(document, \'script\', \'facebook-jssdk\'));</script>
              '
              . ''
              . ''
              . ''
              . '' . PHP_EOL; */
        }


        $this->_add_to_headr($text);
        return $this;
    }

    function import_tamplate() {
        /* @var $tmp \ins_lib\bp\ins_template */
        $tmp = $this;
        $file = "index";
        $G = $this->__eng->_get();
        if (isset($G["get_tmp_index"]) &&
                ($G["get_tmp_index"] == "ins_main" ||
                $G["get_tmp_index"] == "ins_clear")) {
            $this->_myurl("ins_template");
            $file = $G["get_tmp_index"];
        } else if (isset($G["get_tmp_index"])) {

            $file = $G["get_tmp_index"];
        }
        unset($_GET["get_tmp_index"]);

        require_once( $this->_url . "/" . $file . ".php");
    }

}
