<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace ins_lib\data;

/**
 * Description of emailsClas
 *
 * @author ismail
 */
class emailsClass
{

    function __construct()
    {
    }

    function get_mail_data($id, $lang_data)
    {


        $data = \lib::_db()->_get_row("sys_emails_templates", "*", "id=:var_id", ["var_id" => $id]);
        return \lib::_data()->_lang_trans($data, $lang_data);
    }

    var $_attachment = "";

    function att($separator, $_attachments)
    {
        $eol = PHP_EOL;
        $p = dirname(dirname(dirname(__FILE__)));
        foreach ($_attachments as $_attachment) {
            $file = fopen($p . $_attachment, "r");
            if ($file == false) {
                echo "Error in opening file";
                exit();
            }
            $size = filesize($p . $_attachment);
            $content = fread($file, $size);
            $attachment = chunk_split(base64_encode($content));
            $filename = end(explode("/", $_attachment));

            $body = "--" . $separator . $eol;
            $body .= "Content-Type: application/octet-stream; name=\"" . $filename . "\"" . $eol;
            $body .= "Content-Transfer-Encoding: base64" . $eol;
            $body .= "Content-Disposition: attachment" . $eol . $eol;
            $body .= $attachment . $eol;
        }
        $body .= "--" . $separator . "--";

        return $body;
    }

    function sendemail($to, $id, $lang_data)
    {


        $mdata = $this->get_mail_data($id, $lang_data);


        $mdata["send_to"] = $to . "," . $mdata["send_to"];


        $returndata = "";
        $tos = explode(",", $mdata["send_to"]);


        $type = \lib::_config()->mail["type"];
        foreach ($tos as $to) {
            switch ($type) {
                case "smtp":


                    $returndata .=  $this->send_mail_smtp($to,  $mdata["send_name"], $mdata["subject"], $mdata["message"]);


                    break;
                default:
                    if ($to != "") {
                        $headers = 'From: ' . $mdata["send_name"] . ' <' . $mdata["send_email"] . '>' . "\r\n";
                        $headers .= "Content-type: text/html\r\n";

                        $returndata .= $mdata["subject"];
                        //       $returndata .= $mdata["message"];
                        $status = mail($to, $mdata["subject"], $mdata["message"], $headers);
                        if (!$status) {
                            $returndata .= "<br/> ...send error :(";
                        } else {
                            $returndata .=$to. "<br/> ...sent  :)";
                        }

                        $r .= $returndata;
                    }
                    break;
            }
        }


        return $r;
    }


    function send_mail_smtp($to, $from_name,  $subject, $mesg)
    {

        $out = "";

        $host = \lib::_config()->mail["host"];
        $username = \lib::_config()->mail["user_name"];
        $password = \lib::_config()->mail["password"];
        $from = \lib::_config()->mail["from"];

        $from = $from;
        include_once("/ins_lib/includes/phpmailer/class.phpmailer.php"); //you have to upload class files "class.phpmailer.php" and "class.smtp.php"
        $mail = new \PHPMailer();

        $mail->CharSet = 'UTF-8';
        $mail->IsSMTP();
        $mail->SMTPAuth = true;

        $mail->Host = $host;
        $mail->Username = $username;
        $mail->Password = $password;
        $mail->From = $from;
        $mail->SMTPDebug  = 1;


        $mail->FromName = $from_name;

        $mail->AddAddress($to, $from_name);
        $mail->Subject = $subject;
        $mail->Body = $mesg;
        $mail->WordWrap = 50;
        $mail->IsHTML(true);

        $str1 = "gmail.com";
        $str2 = strtolower($username);

        if (strstr($str2, $str1)) {


            $mail->SMTPSecure = 'tls';
            $mail->Port = 587;
            if (!$mail->Send()) {
                $out .= "Mailer Error: " . $mail->ErrorInfo;
                $out .= "<br><br> * Please double check the user name and password to confirm that both of them are correct. <br><br>";
                $out .= "* If you are the first time to use gmail smtp to send email, please refer to this 
                link :http://www.smarterasp.net/support/kb/a1546/send-email-from-gmail-with-smtp-authentication-but-got-5_5_1-authentication-required-error.aspx?KBSearchID=137388";
            } else {
                $out .= "Message has been sent : $to <br/>";
            }
        } else {


            $mail->Port = 25;
            if (!$mail->Send()) {
                $out .= "Error: " . $mail->ErrorInfo . ".<br/>";
                //  $out .= "<br><BR>* Please double check the user name and password to confirm that both of them are correct. <br>";
            } else {
                $out .= "Message has been sent: $to <br/>";
            }
        }

        return $out;
    }


    function sendemail_a($to, $id, $lang_data, $attachment = [])
    {
        $mdata = $this->get_mail_data($id, $lang_data);
        $mdata["send_to"] = $to . "," . $mdata["send_to"];




        $returndata = "";
        $tos = explode(",", $mdata["send_to"]);
        $type = \lib::_config()->mail["type"];
        $returndata = [];
        foreach ($tos as $to) {
            switch ($type) {
                default:
                    if ($to != "") {
                        $m = $mdata;
                        $m["to"] = $to;
                        $m["attachment"] = $attachment;
                        $r = $this->_send($m);
                        array_push($returndata, json_decode($r, true));
                    }
                    break;
            }
        }
        return $returndata;
    }

    /**
     * 
     * @param type $mdata [send_name,send_email,to,subject,message,attachment[]]
     * @return string
     */
    function _send($mdata)
    {
        $separator = md5(time());
        $eol = PHP_EOL;

        if (!isset($mdata["send_name"]) || $mdata["send_name"] != "") {
            $mdata["send_name"] = \lib::_config()->mail["send_name"];
        }
        if (!isset($mdata["send_email"]) || $mdata["send_email"] != "") {
            $mdata["send_email"] = \lib::_config()->mail["send_email"];
        }

        #header
        $headers = 'From: ' . $mdata["send_name"] . ' <' . $mdata["send_email"] . '>' . "\r\n";
        $headers .= "MIME-Version: 1.0" . $eol;
        $headers .= "Content-Type: multipart/mixed; boundary=\"" . $separator . "\"";
        #body
        $body = "--" . $separator . $eol;
        $body .= "Content-Type: text/html; charset=\"iso-8859-1\"" . $eol;
        $body .= "Content-Transfer-Encoding: 8bit" . $eol . $eol;
        $body .= $mdata["message"] . $eol;

        if (isset($mdata["attachment"])) {
            $body .= $this->att($separator, $mdata["attachment"]);
        }
        $mdata["sent"] = mail($mdata["to"], $mdata["subject"], $body, $headers);
        echo $mdata["to"];
        return json_encode($mdata);
    }




    function send_notifications_from_template($template_id = "", $tk = "", $lang_data)
    {




        $data = \lib::_db()->_get_row("sys_notifications_templates", "*", "id=:var_id", ["var_id" => $template_id]);

        print_R($data);
        $data = \lib::_data()->_lang_trans($data, $lang_data);

        print_R($data);
        $body = $data["body"];
        $title =  $data["title"];


        $data  = '{
"to":"' . $tk . '",
 "notification" : {
  "sound" : "default",
  "body" :  "' . $body . '",
  "title" : "' . $title . '",
  "content_available" : true,
  "priority" : "high"
 },
 "data" : {
  "sound" : "default",
  "body" :    "' . $body . '",
  "title" :  "' . $title . '",
  "content_available" : true,
  "priority" : "high"
 }
}';



        //FCM API end-point
        $url = 'https://fcm.googleapis.com/fcm/send';
        //api_key in Firebase Console -> Project Settings -> CLOUD MESSAGING -> Server key
        $server_key = 'AAAAQcaTrm8:APA91bEFpJVCJkAFvk-hnJtzBsBhAuCYzTSCDvWhSo65hW8dgR7gzdaGh1i5VNw3RBAefy5EyMUs-Dbw0Illo3f483MFLfs2aOFwNJ4HBSsuxwwcsJNPI4W_U9Ps-sj94tmmUtT7vQl_';
        //header with content_type api key
        $headers = array(
            'Content-Type:application/json',
            'Authorization:key=' . $server_key
        );


        //CURL request to route notification to FCM connection server (provided by Google)
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $result = curl_exec($ch);
        if ($result === FALSE) {
            die('Oops! FCM Send Error: ' . curl_error($ch));
        }
        curl_close($ch);
    }
}
