<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of EngClass
 *
 * @author ismail
 */

namespace ins_lib\eng;

class ISDClass extends \ins_lib\eng\siteClass
{

    var $_operations_table = "com_isd_operations";

    public function __construct()
    {
    }

    /**
     * @param array $data $_isd_data = [isd_table => "", isd_table_id => "",   isd_owner => "",  isd_entity => "", data => "", isd_status => "",  isd_info => "",  isd_to => "" ];
     * @return type
     */
    public function _isd_create($data)
    {
        $data["isd_owner"] = $data["isd_owner"] ? $data["isd_owner"] : \ins::_usere()->_get("id");
        if (isset($_SESSION["sys_users_entity"])) {
            $data["isd_job"] = $data["isd_job"] ? $data["isd_owner"] : $_SESSION["sys_users_entity"];
        }
        $data["data"] = json_encode($data);
        \ins::_db()->_insert($this->_operations_table, $data);
        return $this->_isd_getdata($data);
    }

    /**
     * @param array $data $_isd_data = [isd_table => "", isd_table_id => "",   isd_owner => "",  isd_entity => "", data => "", isd_status => "",  isd_info => "",  isd_to => "" ];
     * @return type
     */
    public function _isd_update($data)
    {


        $data["isd_owner"] = $data["isd_owner"] ? $data["isd_owner"] : \ins::_usere()->_get("id");

        if (isset($_SESSION["sys_users_entity"])) {
            $data["isd_job"] = $data["isd_job"] ? $data["isd_job"] : $_SESSION["sys_users_entity"];
        }

        $olddata = $this->_isd_getdata($data);



        if (isset($data["isd_table"])) {
            $w = "isd_table='" . $data["isd_table"] . "' and  isd_table_id='" . $data["isd_table_id"] . "'  ";
        } else {
            $w = "id='" . $data["id"] . "' ";
        }


        $ds = json_decode($olddata["data"], true);

        if (is_array($ds)) {
            $jdata = array_merge($ds, $data);
            $data["data"] = json_encode($jdata);
        } else {
            $data["data"] = json_encode($data);
        }

        if (is_array(\ins::_db()->_get_row($this->_operations_table, "*", $w))) {
            \ins::_db()->_update($this->_operations_table, $data, $w);
        } else {

            \ins::_db()->_insert($this->_operations_table, $data);
        }


        return $this->_isd_getdata($data);
    }

    /**
     * @param array $data $_isd_data = [isd_table => "", isd_table_id => "",   isd_owner => "",  isd_entity => "", data => "", isd_status => "",  isd_info => "",  isd_to => "" ];
     * @return type
     */
    public function _isd_getdata($data)
    {
        if (is_array($data)) {
            $w = "isd_table='" . $data["isd_table"] . "' and  isd_table_id='" . $data["isd_table_id"] . "'  ";
        } else {
            $w = "id='" . $data . "' ";
        }



        $data = \ins::_db()->_get_row($this->_operations_table, "*", $w);
        if (is_array($data)) {
            $data["data"] = json_decode($data["data"], true);
        } else {

            $data = false;
        }



        return $data;
    }



    /**
     * @param  $mode[accept,cancel,start]
     */
    public function _isd_get_status($mode, $get = "")
    {
        $data = \ins::_db()->_get_row("com_isd_status", "*", "mode='$mode'");

        if ($get == "") {
            return $data;
        } else {
            return $data[$get];
        }
    }



    /**
     * @param array $data $_isd_data = [isd_table => "", isd_table_id => "",   isd_owner => "",  isd_entity => "", data => "", isd_status => "",  isd_info => "",  isd_to => "" ];
     * @return type
     */
    public function _isd_gestatus($data)
    {

        $isd_status = $this->_isd_getdata($data)["isd_status"];
        if (isset($isd_status) && $isd_status) {

            $data = \ins::_db()->_get_row("com_isd_status", "*", "id=" . $isd_status);
        } else {
            $data = false;
        }


        return $data;
    }

    /**
     * @param array $data $_isd_data = [isd_table => "", isd_table_id => "",   isd_owner => "",  isd_entity => "", data => "", isd_status => "",  isd_info => "",  isd_to => "" ] || isd id;
     * @return type
     */
    public function _isd_get_enetity($data)
    {
        $data = $this->_isd_getdata($data);
        return $this->_get_enetity($data["data"]["isd_job"]);
    }

    /**
     * @param array $data enetity id;
     * @return enetity row
     */
    public function _get_enetity($data = "")
    {

        /*
        if ($data != "") {
            $w = "id='" . $data . "' ";
        }

        $data = \ins::_db()->_get_row("com_structure_jobs", "*", $w);
        return $data;*/
    }

    /**
     * @param array $data enetity id;
     * @return enetity row
     */
    public function _add_comment($data, $comment)
    {


        $data = \ins::_db()->_insert(
            "com_isd_comment",
            [
                "isd" => $data, "data" => $comment, "user" => \ins::_usere()->_get("id")
            ]
        );
        return $data;
    }

    /**
     * @param array $data enetity id;
     * @return enetity row
     */
    public function _update_title($data, $title)
    {

        $w = "id='" . $data . "' ";


        $data = \ins::_db()->_update($this->_operations_table, ["title" => $title], $w);



        return $data;
    }

    /**
     * @param array $data enetity id;
     * $count [false]
     * @return enetity row
     */
    public function _get_comments($data, $count = false)
    {

        $w = "isd='" . $data . "' order by `id` ";
        if ($count) {

            $data = \ins::_db()->_get_row("com_isd_comment", "count(id) as cid", $w)["cid"];
        } else {
            $data = \ins::_db()->_get_data("com_isd_comment", "*", $w);
        }

        return $data;
    }

    /**
     * @param array $data enetity id;
     * $count [false]
     * @return enetity row
     */
    public function _get_workglow($id, $entity = "")
    {



        $data = \ins::_db()->_get_data("com_workflow", "*", \ins::_data()->_db_create_where_from_array($id));



        foreach ($data as $k => $v) {


            $j = json_decode($v["content"], true);
            $data[$k]["content"] = $j;
        }


        return is_array($id) ? $data : $data[0];
    }

    public function _get_workglow_step_by_entity($id, $entity)
    {


        $data = $this->_get_workglow($id)["content"];



        $rdata = [];
        foreach ($data as $k => $c) {

            if ($entity == $c["isd_job"]) {
                $rdata = $c;
            }
        }
        return $rdata;
    }

    public function _get_workglow_step($id, $step, $key = "")
    {


        $data = $this->_get_workglow($id)["content"][$step];

        return $data = $key ? $data[$key] : $data;
    }

    public function _get_workglow_to_steps($id, $step, $key = "")
    {
        $wdata = $this->_get_workglow_step($id, $step, "to");


        if (!is_array($wdata)) {
            $wdata = [["id" => $wdata]];
        }
        $data = [];

        foreach ($wdata as $v) {

            $vid = is_array($v) ? $v["id"] : $v;
            $wf = $this->_get_workglow_step($id, $vid);

            if (isset($v["title"])) {

                $wf["trans_title"] = $v["title"];
            } else {
                $wf["trans_title"] = $wf["data"];
            }

            $data[] = $key ? $wf[$key] : $wf;
        }


        return $data;
    }



    function _get_list_join_query($get_type = "", $isd_table)
    {

        if ($get_type == "owner") {
            $q  = "com_isd_operations.isd_owner='" . \ins::_usere()->_get("id") . "'  ";
        } else if ($get_type == "department") {
            $q = \lib::_data()->_db_create_where_to_group(\ins::_eng()->_isd()->_get_user("departments"), "com_isd_operations.isd_department");
        } else if ($get_type == "branch") {
            $q = \lib::_data()->_db_create_where_to_group(\ins::_eng()->_isd()->_get_user("branches"), "com_isd_operations.isd_branch");
        } else if ($get_type == "job") {
            $q = ("com_isd_operations.isd_job='" . \ins::_eng()->_isd()->_get_user("job") . "'");
        }
        if ($get_type != "") {
            $query = " INNER JOIN com_isd_operations ON  ( com_isd_operations.isd_table='$isd_table'  and com_isd_operations.isd_table_id=$isd_table.id  and   $q )";
        }
        return $query;
    }









    public function _start_path($id, $table, $table_id)
    {


        $steps = $this->_get_workglow($id)["content"];

        foreach ($steps as $step) {




            if ($step["isd_status"] == $this->_isd_get_status("start")["id"]) {
                $step_options = $step;
                break;
            }
        }



        $step_to = \ins::_eng()->_isd()->_get_workglow_step($id, $step_options["to"]["0"]["id"]);
        $step_to["step"] = $step_to["id"];

        unset($step_to["id"]);
        $step_to["path"] = $id;

        $step_to["isd_table"] = $table;
        $step_to["isd_table_id"] = $table_id;

        $data = \lib::_eng()->_isd()->_isd_update($step_to);
    }

    /**
     * @var  type["job","job_data","departments","branches","$user_input"];
     */
    public function _get_user($type = "")
    {
        $r = "";
        switch ($type) {
            case "job":
                //get job id 
                $r =  $_SESSION[\ins::_usere()->role_session_var_name];
                break;
            case "job_data":
                //get full job data
                //    $r = \ins::_db()->_get_row("com_structure_jobs", "*", "id=" . $_SESSION[\ins::_usere()->role_session_var_name]);
                break;
            case "departments":
                //get all job departments
                $rs = explode(",", $this->_get_user("job_data")["department"]);

                //excluding the department that is user does not in it
                $user_deparments = explode(",", $this->_get_user("department"));
                for ($i = 0; $i < count($rs); $i++) {
                    if (!in_array($rs[$i], $user_deparments)) {
                        unset($rs[$i]);
                    }
                }





                $r = $rs;





                break;
            case "branches":

                $departments = $this->_get_user("departments");
                $rb = [];
                //get all job departments
                foreach ($departments as $department) {
                    $branch =  \ins::_db()->_get_row("com_structure_departments", "*", " id='$department'")["branch"];
                    $rb = array_merge($rb, explode(",",  $branch));
                }

                //excluding the branches that is user does not in it
                $user_branchs = explode(",", $this->_get_user("branch"));
                for ($i = 0; $i < count($rb); $i++) {
                    if (!in_array($rb[$i], $user_branchs)) {
                        print($rb[$i]);
                        unset($rb[$i]);
                    }
                }

                $r = $rb;
                break;
            default:
                //get any user basic information 
                $r = \ins::_usere()->_get($type);
                break;
        }



        return $r;
    }
}
