<?php

namespace ins_lib\files;

class file_csv implements \ins_lib\files\loader {

    var $filename = "test", $options;

    public function __construct($filename, $options) {
        $this->options = $options;
        $this->filename = $filename;
    }

    public function _load($filename) {
        return "csv" . $filename;
    }

    public function _export() {
        $myfile_data = $this->filename;
        $_SESSION[$myfile_data]["data"] = $this->options["data"];
        $_SESSION[$myfile_data]["file_name"] = $this->filename . "_" . uniqid();
        $url = "/csv_export.php?name=" . $myfile_data;
        echo " <meta http-equiv=\"refresh\" content=\"0;url=$url\">";
    }

    public function _import($file) {
        $r = [];
        $row = 1;



        $path = dirname(dirname(__DIR__));


        if (($handle = fopen($path . $file, "r")) !== FALSE) {
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                $num = count($data);
                $row++;
                $row_data = [];
                for ($c = 0; $c < $num; $c++) {
                    $row_data[] = $data[$c];
                }
                $r[] = $row_data;
            }
            fclose($handle);
            return $r;
        }
    }

}
