var rangestatus = 0;

function getDays(
  year,
  month,
  call,
  type,
  selected_date,
  highlight_date,
  options
) {
  //<editor-fold defaultstate="collapsed" desc="helper">

  function update_Act() {
    var change = false;
    ins(".ins_datepicker .ins_td ")
      ._get()
      .forEach(function (item, indx) {
        if (change) {
          ins(item)._addclass("highlight");
        } else {
          ins(item)._removeclass("highlight");
        }
        if (ins(item)._hasclass("start")) {
          change = true;
        }
        if (ins(item)._hasclass("end") || ins(item)._hasclass("hoverd")) {
          change = false;
        }
      });
  }

  function highlight_class(this_date, getdata) {
    var r = "";
    if (ins(getdata)._is_empty()) {
      getdata = "class";
    }

    if (ins(highlight_date)._is_exists()) {
      Object.keys(highlight_date).forEach(function (i) {
        if (highlight_date[i].from.length < 11) {
          highlight_date[i].from += " 00:00:00 ";
        }
        let d_from = new Date(highlight_date[i].from);

        if (highlight_date[i].to.length < 11) {
          highlight_date[i].to += " 00:00:00 ";
        }

        let d_to = new Date(highlight_date[i].to);

        if (
          this_date.getTime() >= d_from.getTime() &&
          this_date <= d_to.getTime()
        ) {
          if (!ins(highlight_date[i][getdata])._is_empty()) {
            var h = "";

            if (typeof highlight_date[i][getdata] == "object") {
              h = " " + highlight_date[i][getdata].join(" ");
            } else {
              h = " " + highlight_date[i][getdata];
            }

            if (d_to.getTime() == d_from.getTime() && getdata == "text") {
              h = "<div class='ins_calendar_event_sday'>" + h + "</div>";
            } else if (
              this_date.getTime() == d_from.getTime() &&
              getdata == "text"
            ) {
              h = "<div class='ins_calendar_event_start'>" + h + "</div>";
            } else if (
              this_date.getTime() == d_to.getTime() &&
              getdata == "text"
            ) {
              h = "<div class='ins_calendar_event_end'>" + h + "</div>";
            } else {
              h = "<div class='ins_calendar_event'>" + h + "</div>";
            }

            r += h;
          }
        }
      });
    }

    return r;
  }

  function highlight_data(this_date, td, getdata) {
    var r = "";
    if (ins(highlight_date)._is_exists()) {
      Object.keys(highlight_date).forEach(function (i) {
        if (highlight_date[i].from.length < 11) {
          highlight_date[i].from += " 00:00:00 ";
        }

        if (highlight_date[i].to.length < 11) {
          highlight_date[i].to += " 00:00:00 ";
        }

        let d_from = new Date(highlight_date[i].from);

        let d_to = new Date(highlight_date[i].to);

        if (
          this_date.getTime() >= d_from.getTime() &&
          this_date <= d_to.getTime()
        ) {
          if (!ins(highlight_date[i]["data"])._is_empty()) {
            let das = highlight_date[i]["data"];

            Object.keys(das).forEach(function (i) {
              ins(td)._setdata(i, das[i]);
            });
          }
        }
      });
    }

    return td;
  }

  function setselected(this_date) {
    var r = "";
    if (ins(selected_date)._is_exists()) {
      let d_from = new Date(selected_date.from + " 00:00:00 ");
      let d_to = new Date(selected_date.to + " 00:00:00 ");
      if (this_date.getTime() === d_from.getTime()) {
        r = " start ins_act  ";
        rangestatus = 1;
      } else if (this_date.getTime() === d_to.getTime()) {
        r = " end ins_act ";
        rangestatus = 2;
      } else if (
        this_date.getTime() >= d_from.getTime() &&
        this_date <= d_to.getTime()
      ) {
        r += " highlight ";
      }
    }

    return r;
  }

  //</editor-fold>

  if (ins(month)._is_empty() || month == 12) {
    month = 0;
  }

  var mos = ins()._data._get("months");
  var day = ins()._data._get("days");

  var today = new Date();
  var g = ins()._ui._create("h2", mos[month] + " " + year, {
    class: " ins_table col12",
  });
  var t = ins()._ui._create("div", "", { class: " ins_table" });
  var tr = t.appendChild(
    ins()._ui._create("div", "", { class: "ins_tr col12" })
  );
  day.forEach(function (d, i) {
    tr.appendChild(ins()._ui._create("div", d, { class: "ins_th" }));
  });
  var firstDay = new Date(year, month, 1);
  var lastDay = new Date(year, month + 1, 0);
  var _index = 0;
  var thisday_index = 0;
  let m = 5;
  if (lastDay.getDate() + firstDay.getDay() > 35) {
    m = 6;
  }
  for (var i = 1; i <= m; i++) {
    var this_tr = ins()._ui._create("div", null, { class: "col12 ins_tr" });
    for (var id = 1; id <= 7; id++) {
      if (_index >= firstDay.getDay() && lastDay.getDate() > thisday_index) {
        thisday_index++;
        var tdclass = "ins_after_today";
        var thisdate = new Date(year, month, thisday_index);
        var today = new Date(
          today.getFullYear(),
          today.getMonth(),
          today.getDate()
        );
        var disable_date = new Date(
          today.getFullYear(),
          today.getMonth(),
          today.getDate()
        );
        disable_date.setDate(disable_date.getDate() + 2);
        if (thisdate.getTime() === today.getTime()) {
          tdclass = "ins_today ins_dark ";
        } else if (thisdate.getTime() < disable_date.getTime()) {
          tdclass = "ins_befor_today ";
        }

        tdclass += highlight_class(thisdate);
        var adddata = highlight_class(thisdate, "text");
        tdclass += setselected(thisdate);

        var td = ins()._ui._create(
          "div",
          "",
          {
            "data-title": "1",
            class: tdclass + " ins_td ",
            "data-ti": thisdate.getTime(),
          },
          " " + thisday_index + adddata
        );

        td = highlight_data(thisdate, td);
        //<editor-fold defaultstate="collapsed" desc="events">
        if (type === "range") {
          ins(td)._event("mouseenter", function (e) {
            if (!ins(e)._hasclass("disabled")) {
              if (rangestatus === 1) {
                ins(".ins_datepicker .ins_td")._removeclass("hoverd");
                ins(e)._addclass("hoverd");
                update_Act();
              }
            }
          });
          ins(td)._event("click", function (e) {
            if (!ins(e)._hasclass("disabled")) {
              ins(e)._getdata("ti");
              if (rangestatus === 0) {
                ins(e)._addclass("ins_act", "start");
                rangestatus = 1;
              } else {
                if (
                  parseFloat(ins(e)._getdata("ti")) <
                  parseFloat(ins(".ins_act.start")._getdata("ti"))
                ) {
                  ins(".ins_datepicker .ins_td")._removeclass(
                    "start",
                    "ins_act",
                    "end",
                    "hoverd",
                    "highlight"
                  );
                  ins(e)._addclass("ins_act", "start");
                  rangestatus = 1;
                } else if (
                  parseFloat(ins(e)._getdata("ti")) ===
                  parseFloat(ins(".ins_act.start")._getdata("ti"))
                ) {
                  ins(".ins_datepicker .ins_td")._removeclass(
                    "start",
                    "ins_act",
                    "end",
                    "hoverd",
                    "highlight"
                  );
                  rangestatus = 0;
                } else {
                  rangestatus = 2;
                  ins(".ins_act.end")._removeclass("end", "ins_act");
                  ins(".ins_datepicker .ins_td")._removeclass("hoverd");
                  ins(e)._addclass("end", "ins_act");
                  update_Act();
                  if (ins(call)._is_exists()) {
                    call(
                      new Date(
                        parseFloat(ins(".ins_act.start")._getdata("ti"))
                      ),
                      new Date(parseFloat(ins(".ins_act.end")._getdata("ti"))),
                      ins(e)
                    );
                  }
                }
              }
            } else {
              if (ins(ins(e)._getdata("msg"))._is_exists()) {
                alert(ins(e)._getdata("msg"));
              }
            }
          });
        } else {
          ins(td)._event("click", function (e) {
            ins(".ins_datepicker .ins_td")._removeclass("start", "ins_act");
            ins(e)._addclass("ins_act", "start");
            call(new Date(parseFloat(ins(".ins_act.start")._getdata("ti"))), e);
          });
        } //</editor-fold>

        this_tr.appendChild(td);
      } else {
        this_tr.appendChild(
          ins()._ui._create("div", "-", { class: " ins_td" })
        );
      }
      _index++;
    }

    t.appendChild(this_tr);
  }

  return ins()._ui._create("div", [g, t], { class: "ins_month" });
}

UI.prototype._datePicker_rest = function () {
  ins(".ins_datepicker .ins_td")._removeclass(
    "start",
    "ins_act",
    "end",
    "hoverd",
    "highlight"
  );
  rangestatus = 0;
};

UI.prototype._do_datePicker = function (t, cl_div, type) {
  var o = ins(t);
  var options = { type: type };
  options.selected = function (d1, d2, e) {
    var dat1 =
      d1.getDate() + "-" + (d1.getMonth() + 1) + "-" + d1.getFullYear();
   
   if (type == "range") {
     var dat2 =
       d2.getDate() + "-" + (d2.getMonth() + 1) + "-" + d2.getFullYear();
     o._setvalue(dat1 + " to " + dat2);
   } else {
     o._setvalue(dat1);
   }
   

      

    ins(cl_div)._css({ "max-height": "0px", opacity: "1" });
    o._get(0).dispatchEvent(new Event("input", { bubbles: true }));
  };

  options.t = o;
  ins(cl_div)._ui._datePicker(options);
  ins(cl_div)._css({ "max-height": "1000px", opacity: "1" });
};

UI.prototype._datePicker = function (attrs) {
  var o = this.o;
  rangestatus = 0;
  var d = new Date();
  let year =
    attrs.showyear === null || attrs.showyear === undefined
      ? d.getFullYear()
      : attrs.showyear;
  let month =
    attrs.shomonth === null || attrs.showyear === undefined
      ? d.getMonth()
      : attrs.shomonth;
  let type =
    attrs.type === null || attrs.type === undefined ? "normal" : attrs.type;
  if (month > 11) {
    month = 0;
    year++;
  } else if (month < 0) {
    month = 11;
    year--;
  }

  if (ins(attrs.select_date)._is_exists()) {
    let d_from = new Date(attrs.select_date.from + " 00:00:00 ");
    month = d_from.getMonth();
  }

  var options = attrs;
  options.type = type;
  options.showyear = year;
  var g = ins()._ui._get(
    [
      {
        name: "i",
        data: "",
        attrs: {
          class: " ins_datePicker_close  fas fa-times",
          style:
            "position: absolute;right: 0; top: 0;background: #00000005;line-height: 20px;",
        },
        event: [
          "click",
          function () {
            ins(o)._css({ "max-height": "0px", opacity: "1" });
          },
        ],
      },
      {
        name: "i",
        data: "",
        attrs: {
          class: " ins_toleft fas fa-angle-left",
          style: "   width: 25px;font-size: 20px;",
        },
        event: [
          "click",
          function () {
            rangestatus = 0;
            options.shomonth = month - 1;
            ins(o)._ui._datePicker(options);
          },
        ],
      },
      {
        name: "i",
        data: "",
        attrs: {
          class: " fas fa-angle-right ins_toright",
          style: "width: 25px;font-size: 20px;",
        },
        event: [
          "click",
          function () {
            rangestatus = 0;
            options.shomonth = month + 1;
            ins(o)._ui._datePicker(options);
          },
        ],
      },
    ],
    "div",
    { class: "col12 ins_date_picker_btns" }
  );
  var t = getDays(
    year,
    month,
    attrs.selected,
    type,
    attrs.select_date,
    attrs.highlight_date,
    attrs
  );
  var nt = null;
  if (type === "range") {
    y = year;
    var m = month + 1;
    if (m === 12) {
      y++;
    }
    nt = getDays(
      y,
      m,
      attrs.selected,
      type,
      attrs.select_date,
      attrs.highlight_date,
      attrs
    );
  }

  ins(o)
    ._get(0)
    .replaceChild(
      ins()._ui._create("div", [g, t, nt], {
        class: "ins_datepicker  " + type + "  ins_text_tocenter",
      }),
      ins(o)._get(0).childNodes[0]
    );
};
