/**
 *
 * @param {type} options {title:$title,url:$url ,style:$style ,class:$class,data:$data,onclose:function(){},onopen:function(){}}
 * @returns {undefined}
 */
class ins_plg_lightbox {
  options = {};
  constructor(o) {
    this.options = o;
  }

  _updateOptions() {
    this.options.body = { class: "ins_lightbox_body" };
    this.options.body.style = "width:60%;height:60%";
    if (!ins(this.options.style)._is_empty()) {
      this.options.body.style = this.options.style;
    }

    this.options.lightbox = { class: "ins_lightbox" };
    if (!ins(this.options.class)._is_empty()) {
      this.options.lightbox.class += " " + this.options.class;
    }

    if (ins(this.options.data)._is_empty()) {
      this.options.data = "";
    }
  }

  _out() {
    this._updateOptions();
    if (!ins(this.options.data.url)._is_empty()) {
      this.options.data = ins()._ui._create("iframe", "loding", {
        src: this.options.data,
      });
      this.options.lightbox.class += " iframe ";
    }

    if (!ins(this.options["title"])._is_empty()) {
      var ltitle = ins()._ui._create("div", this.options.title, {
        class: "ins_title",
      });
    }

    if (ins(this.options.onopen)._is_exists()) {
      this.options.onopen();
    }

    var data_options = { class: "ins_lightbox_data" };
    if (this.options.data_style) {
      data_options.style = this.options.data_style;
    }
    var ldata = ins()._ui._create("div", null, data_options, this.options.data);

    var lclose = ins()._ui._create("i", "", {
      class: "ins_close fas fa-times",
    });

    var lbody = ins()._ui._create(
      "div",
      [lclose, ldata, ltitle],
      this.options.body
    );

    this.node = ins()._ui._create("div", lbody, this.options.lightbox);

    ins(lclose)._event("click", () => {
      ins(this.node)._remove();
      if (ins(this.options.onclose)._is_exists()) {
        this.options.onclose();
      }
    });
    document.getElementsByTagName("body")[0].appendChild(this.node);
  }

  node = null;
  _remove() {
    ins(this.node)._remove();
    if (ins(this.options.onclose)._is_exists()) {
      this.options.onclose();
    }
  }
}
