<?php

if (!isset($_SESSION)) {
    session_start();
}
$url = dirname(dirname(__FILE__)) . "/";
require_once $url . 'ins_config.php';
getFiles(["", "files", "bp", "ui", "pages", "db", "eng", "data", "options"]);

class lib
{

    public static $_area = "";

    /**
     * 
     * @staticvar type $files
     * @return \ins_lib\files\FilesClass
     */

    public static function _files()
    {


        static $files = null;
        if ($files === null) {
            $files = new \ins_lib\files\FilesClass();
        }
        return $files;
    }

    /**
     * 
     * @staticvar type $_datatime
     * @return \ins_lib\data\datatimeClass
     */
    public static function _timedate($data = "")
    {
        static $_datatime = null;
        if ($_datatime === null) {
            $_datatime = new \ins_lib\data\datatimeClass();
        }
        return $_datatime;
    }

    /**
     * 
     * @staticvar type $config
     * @return \ins_lib\bp\ins_template
     */
    public static function _template($data = "")
    {
        static $_template = null;
        if ($_template === null) {
            $_template = new \ins_lib\bp\ins_template($data);
        }
        return $_template;
    }

    /**
     * 
     * @staticvar type $config
     * @return \ins_lib\ConfigClass
     */
    public static function _config()
    {
        static $config = null;
        if ($config === null) {
            $config = new \ins_lib\ConfigClass();
        }


        return $config;
    }

    /**
     * 
     * @staticvar type $options
     * @return \ins_lib\options\OptionsClass
     */
    public static function _options()
    {
        static $options = null;
        if ($options === null) {
            $options = new \ins_lib\options\OptionsClass();
        }
        return $options;
    }

    /**
     * 
     * @staticvar type $_db
     * @return \ins_lib\db\DBClass
     */
    public static function _db()
    {
        static $_db = null;
        if ($_db === null) {
            /* @var $_db \ins_lib\db\DBClass */
            $_db = new \ins_lib\db\DBClass();
        }
        return $_db;
    }

    /**
     * 
     * @staticvar type $_console
     * @return \ins_lib\consoleClass
     */
    public static function _console()
    {
        static $_console = null;
        if ($_console === null) {
            $_console = new \ins_lib\consoleClass();
        }

        return $_console;
    }

    /**
     * 
     * @staticvar type $_ui
     * @param type $data
     * @return \ins_lib\ui\UIClass
     */
    public static function _ui()
    {
        static $_ui = null;
        if ($_ui === null) {
            $_ui = new \ins_lib\ui\UIClass();
        }

        return $_ui;
    }

    /**
     * 
     * @staticvar type $_app_map
     * @return \ins_lib\options\app_mabClass
     */
    public static function _app_map($area = "/")
    {
        static $_app_map = null;
        if ($_app_map === null) {
            $_app_map = new \ins_lib\options\app_mabClass($area);
        }

        return $_app_map;
    }
    /**
     * 
     * @staticvar type $_app_map
     * @return \ins_lib\options\app_mabClass
     */
    public static function _map($area = "/")
    {
        static $_app_map = null;
        if ($_app_map === null) {
            $_app_map = new \ins_lib\options\app_mabClass($area);
        }
        return $_app_map;
    }


    /**
     * 
     * @staticvar type $_data
     * @return \ins_lib\data\DataClass
     */
    public static function _data()
    {
        static $_data = null;
        if ($_data === null) {
            $_data = new \ins_lib\data\DataClass();
        }

        return $_data;
    }

    /**
     * 
     * @staticvar type $_video
     * @return \ins_lib\data\videosClass
     */
    public static function _video()
    {
        static $_video = null;
        if ($_video === null) {
            $_video = new \ins_lib\data\videosClass();
        }

        return $_video;
    }

    /**
     * 
     * @staticvar type $_eng
     * @return \ins_lib\eng\EngClass
     */
    public static function _eng()
    {
        static $_eng = null;
        if ($_eng === null) {
            $_eng = new \ins_lib\eng\EngClass();
        }

        return $_eng;
    }

    /**
     * 
     * @staticvar type $_eng
     * @return \ins_lib\pages\PagesClass
     */
    public static function _pages()
    {
        static $_pages = null;
        if ($_pages === null) {
            $_pages = new \ins_lib\pages\PagesClass();
        }

        return $_pages;
    }

    /**
     * 
     * @staticvar type $_emails
     * @return \ins_lib\data\emailsClass
     */
    public static function _emails()
    {
        static $_emails = null;
        if ($_emails === null) {
            $_emails = new \ins_lib\data\emailsClass();
        }
        return $_emails;
    }

    /**
     * 
     * @staticvar type $_users
     * @return \ins_lib\users\usersClass
     */
    public static function _usere()
    {
        static $_users = null;
        if ($_users === null) {
            $_users = new \ins_lib\users\usersClass();
        }

        return $_users;
    }
}

function getFiles($dirs)
{
    foreach ($dirs as $dir) {
        foreach (glob(dirname(__FILE__) . "/" . $dir . "/*.php") as $filename) {
            require_once $filename;
        }
    }
}
/*
if (isset($_GET["site"])) {
    \lib::_options()->bysit = $_GET["site"];
} else {
    \lib::_options()->bysit = 2;
}

*/




class ins extends lib
{
}
lib::_db();
