<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of PagesClass
 *
 * @author ismail
 */

namespace ins_lib\pages;

class PagesClass
{

    var $data = [];
    var $type = "html";
    var $gat = "";
    var $myname = "";


    public function _render()
    {
        $r = "";
        foreach ($this->data as $d) {
            $this->d = $d;
            $r .= $this->get_page();
        }
        return $r;
    }

    /**
     * 
     * @param type $type page Type [admin , list . form]
     * @param type $myname $type  use for meny like db table
     * @param type $options  like [_myfolder ,_properties_file ,_per_cancel]
     * @return type
     */
    function get_page($type = "", $myname = "", $options = [])
    {


        $className = '\ins_lib\pages\page_' . $type;
        $this->_myname = $myname ?: \lib::_eng()->_getThisMenu["type"];
        if (class_exists($className)) {

            $a = new $className($this->_myname, $options);

            return $a->_render();
        } else {
           \ins::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
    }

    /**
     * 
     * @param type $type page Type [admin , list . form]
     * @param type $myname $type  use for meny like db table
     * @param type $options  like [_myfolder ,_properties_file]
     * @return type
     */
    function _get_class($type = "", $myname = "", $options = [])
    {
        $className = '\ins_lib\pages\page_' . $type;
        if (class_exists($className)) {
            $a = new $className($myname, $options);

            return $a;
        } else {
            \ins::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
    }

    function _meaasge($string, $class = 'success')
    {


        $string .= \lib::_ui()->_data(
            ["type" => "span", "data" => '<i class="fa fa-times-circle-o" aria-hidden="true"></i>', "class" => "message_close"]
        )->_render();


        return \lib::_ui()->_data(
            ["type" => "div", "data" => $string, "class" => "message $class"]
        )->_render();
    }

    /**
     * 
     * @staticvar type $_ui
     * @param type $data
     * @return ins_lib\pages\page_admin
     */
    function _admin($myname = "", $options = [])
    {

        static $admin = null;
        if ($admin === null) {
            $myname = $myname ? $myname : \lib::_eng()->_getThisMenu["type"];
            $admin = new page_admin($myname, $options);
        }


  /** @var ins_lib\pages\page_admin $admin */
        return $admin;
    }
}
