<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

abstract class ins_page extends ins_lib {

    protected $_menu;
    protected $_myname;
    protected $_pro = [];
    protected $_myPath = "";
    protected $_myfolder = "";
    protected $_lib_path = "";
    protected $_dbtable = "";
    protected $_get = "";
    protected $_limit = "12";
    protected $_query_custom_data = "*";
    protected $_query_order_by = "";
    /** @var $_query String(change query to custome query  list) */
    public $_query = "";
    protected $_full_query = "";
    protected $_list_row_class = "";
    protected $_list_row_style = "";
    protected $_title = "";
    protected $_Page = "";
    protected $_list_data = "";
    protected $_get_deleted = false;
    protected $_options = [];
    protected $_render = "all";
    /** @var array(ui_array)   $_list_add_to_action_bar */
    public $_list_add_to_action_bar =[];


    public function __construct($type, $myname = "", $options = []) {
        parent::__construct();



        $this->_options = $options;
        $this->_menu = $this->__eng->_getThisMenu;

        if ($myname == "") {
            $myname = $this->_menu["type"];
        }
        $type = explode("/", $myname);
        $type[1] = $type[1] ? $type[1] : $type[0];
        $this->_myname = $type[1];
        $this->get_sys_component();
        if (isset($this->_options["_myfolder"])) {
            $this->_myfolder = $this->_options["_myfolder"];
        } else {
            $this->_myfolder = $this->_menu["type"];
        }

        $this->_get = \lib::_eng()->_get();
        $this->_myPath = $this->__app_map->coms_folder . $this->_myfolder;
        $this->lodXml();
        $this->update_settings($options);




        if (isset($this->_get["db_table"])) {
            $this->_dbtable = $this->_get["db_table"];
        } else if (isset($this->_options["page"]["db_table"])) {
            $this->_dbtable = $this->_options["page"]["db_table"]["data_value"];
        } else if (isset($this->_options["page"]["dbtable"])) {
            $this->_dbtable = $this->_options["page"]["dbtable"]["data_value"];
        } else {
            $this->_dbtable = $this->_myname;
        }

        $this->_lib_path = \lib::_app_map()->libs_folder . "pages/";
    }

    private function lodXml() {
        $properties_file = "";


        if (isset($this->_get["_properties_file"])) {
            $this->_options["_properties_file"] = $this->_get["_properties_file"];
            $properties_file = $this->_get["_properties_file"];
        } else if (isset($this->_options["_properties_file"])) {
            $properties_file = $this->_options["_properties_file"];
        }


        $this->_pro = $this->__eng->_get_properties_xml($this->_myfolder, $properties_file, "");
    }

    public function getoption($option) {
        $r = "";
        if (isset($this->_pro["page"][$option])) {
            $r = $this->_pro["page"][$option]["data_value"];
        } else if (isset($this->_options[$option])) {
            $r = $this->_options[$option];
        } else if (isset($_GET[$option])) {
            $r = $_GET[$option];
        }
        return $r;
    }

    var $_sys_component = [];

    private function get_sys_component() {
        $this->_sys_component = \lib::_db()->_get_row("sys_component_settings", "*", "name='" . $this->_myname . "'");
        if (isset($this->_sys_component["data"])) {
            $this->_sys_component["data"] = json_decode($this->_sys_component["data"], "true");
        }
    }

    private function update_settings($options) {
        if (is_array($options)) {
            $o = $options;
        }
        foreach ($this->_pro["page"] as $k => $v) {
            $o[$k] = $this->_pro["page"][$k]["data_value"];
        }
        foreach ($this->_get as $k => $v) {
            $o[$k] = $this->_get [$k];
        }


        $this->_limit = $o["_list_rows_per_page"] ? $o["_list_rows_per_page"] : $this->_limit;
        $this->_query_custom_data = $o["_query_custom_data"] ? $o["_query_custom_data"] : $this->_query_custom_data;
        $this->_query_order_by = $o["orderby"] ? $o["orderby"]: $this->_query_order_by;
       $this->_query_order_by = $o["_query_order_by"] ? $o["_query_order_by"] : $this->_query_order_by;



        $this->_query = $o["query"] ? $o["query"] : $this->_query;
        $this->_query = $o["_query"] ? $o["_query"] : $this->_query;
        $this->_full_query = $o["_full_query"] ? $o["_full_query"] : $this->_full_query;
        $this->_show_filter = $o["_show_filter"] ? $o["_show_filter"] : $this->_full_query;
        $this->_list_row_class = $o["_list_row_class"] ? $o["_list_row_class"] : $this->_list_row_class;
        $this->_list_row_style = $o["_list_row_style"] ? $o["_list_row_style"] : $this->_list_row_style;


        $this->_dbtable = $this->_get["db_table"] ? $this->_get["db_table"] : $this->_myname;


        $this->_dbtable = $o["db_table"] ? $o["db_table"] : $this->_myname;
        $this->_dbtable = $o["_db_table"] ? $o["_db_table"] : $this->_myname;


        $this->_render = $o["_render"] ? $o["_render"] : "all";




        if (isset($this->_sys_component["data"][ins::_usere()->_get("id")]["list"])) {

            $this->_list = $this->_sys_component["data"][ins::_usere()->_get("id")]["list"];
        } else if (isset($this->_sys_component["data"]["gen"]["list"])) {
            $this->_list = $this->_sys_component["data"]["gen"]["list"];
        } else {
            foreach ($this->_pro["list"] as $k => $v) {
                $this->_list[$k] = $v;
            }
        }
    }

    var $_list = [];

}
