<?php

namespace ins_lib\pages;

class page_admin extends \ins_page
{

    var $_get = "";

    /**
     * 
     * @param type $myname db-table-name
     * @param type $options   title,mode[add,edit],id <in edit>
     */
    public function __construct($myname = "", $options = [])
    {
        parent::__construct("list", $myname, $options);
        $this->_get = \lib::_eng()->_get();
        $this->_options["adminid"] = uniqid();
    }

    var $_more_stapes = [];
    var $_this_mode = "";
    var $_this_id = 0;
    var $_ajax = 0;

    public function _render($area = "")
    {
        $r = "";


        if (isset($this->_options["_mode"])) {
            $this->_this_mode = $this->_options["_mode"];
        } else if (isset($_GET["mode"])) {
            $this->_this_mode = $_GET["mode"];
        }


        foreach ($this->_more_stapes as $k => $v) {

            if ($this->_this_mode == $k) {
                $r = $v;
            }
        }
        if (isset($this->_get["_properties_file"])) {
            $this->_options["_addtourl"]["_properties_file"] = $this->_get["_properties_file"];
        } else if (isset($this->_options["_properties_file"])) {
            $this->_options["_addtourl"]["_properties_file"] = $this->_options["_properties_file"];
        }

        if (isset($this->_get["_parent_add"])) {
            $this->_options["_addtourl"]["_parent_add"] = $this->_get["_parent_add"];
        } else if (isset($this->_options["_parent_add"])) {
            $this->_options["_addtourl"]["_parent_add"] = $this->_options["_parent_add"];
        }

        if (trim($this->_pro["page"]["action"]["data_value"]) == "ajax") {
            $this->_ajax = true;
        } else {
            $this->_ajax = false;
        }
        $ui_mode = "list";

        if (isset($this->_pro["page"]["default"])) {
            $ui_mode = $this->_pro["page"]["default"]["data_value"];
        }
        $this->_page_options = $this->_pro["page"];

        if (is_array($this->_page_options)) {
            $this->_options = array_merge($this->_options, $this->_page_options);
        }

        if ($r == "") {
            switch ($this->_this_mode) {
                case "add":
                case "edit":
                    $r = $this->getForm();
                    break;
                case "trash":
                    $r = $this->getTrash();
                    break;
                default:
                    $r = $this->getList();
                    break;
            }
        }
        $options = [];
        $options["name"] = $this->_myname;
        if ($this->_this_mode == "trash") {
            $romeurl = ["id"];
        } else {

            $romeurl = ["mode", "id"];
        }




        return $this->__ui->_data(
            [
                ["trans" => "false", "type" => "div", "data-ui_mode" => $ui_mode, "data-url" => $this->__eng->_url($this->_options["_addtourl"], $romeurl), "data-options" => json_encode($options), "class" => "$this->_myname this_admin_mian _" . $this->_options["adminid"], "data" => $r]
            ]
        )->_render();
    }

    private function getForm()
    {




        if (
            ($this->__users->_permission_can("add") && $this->getoption("mode") == "add") ||
            ($this->__users->_permission_can("edit") && $this->getoption("mode") == "edit") ||
            (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)
        ) {


            if ($this->_pro["page"]["hide_buttons"]["data_value"] !== "true") {

                /* @var $form  \ins_lib\pages\page_form  */
                $this->_options["bar_data"] = $this->__ui->_data(
                    [
                        ["type" => "a", "href" => $this->__eng->_url([], ["mode", "parent", "render_type", "id", "main", "type", "data_area"]), "title" => $this->__eng->_get_gen_word("Back"), "data" => $this->icon("chevron-left")]
                    ]
                )->_render();
            }




            $form = $this->__pages->_get_class("form", $this->_myname, $this->_options);

            if ($this->_this_id != 0) {
                $form->_id = $this->_this_id;
            }
            $form->_mode = $this->_this_mode;



            return $form->_render();
        } else {
            return \lib::_ui()->_data(
                [
                    ["type" => "div", "class" => "message error ", "data" => $this->__eng->_get_gen_word("permission_msg_error")]
                ]
            )->_render();
        }
    }

    private function getTrash()
    {

        $r = "";
        \lib::_template()->_add_to_pagedata("table", $this->_dbtable);
        $this->_options["bar_data"] = $this->createbnt([
            ["title" => "restore", "class" => "list_multi_update", "icon" => "reply", "mode" => "restore"],
            ["title" => "restore_all", "class" => "list_multi_update", "icon" => "reply-all", "mode" => "restore_all"],
            ["title" => "remove", "class" => "list_multi_update", "icon" => "times-circle", "mode" => "remove"],
            ["title" => "remove_all", "class" => "list_multi_update", "icon" => "times", "mode" => "clear"],
        ]);
        $this->_options["bar_data"] .= $this->__ui->_data(
            [
                ["type" => "a", "href" => $this->__eng->_url([], ["mode", "id", "main", "render_type", "type", "parent", "data_area"]), "title" => $this->__eng->_get_gen_word("Back"), "data" => $this->icon("chevron-left")]
            ]
        )->_render();
        $list = $this->__pages->_get_class("list", $this->_myname, $this->_options);
        $list->_query = "sys_deleted='1'";
        $stratdata = $this->__ui->_data(["type" => "checkbox", "trans" => "false", "input" => "true", "class" => "check_list_ids", "value" => "@(id)"])->_render();
        $list->_options["start_list"] = ["#" => ["class" => "ins_col_2 ch_list_all rows_select_all   rows_select", "data" => $stratdata]];
        $list->_options["end_list"] = [$this->__eng->_get_gen_word("action") => ["class" => "ins_col_2 ins_text_tocenter end_data_options ", "data" => ""]];




        $list->_get_deleted = true;



        return $list->_render();
    }

    var $_page_option = [];

    function createbnt($data)
    {
        $r = "";
        foreach ($data as $d) {

            $setdata = $d;
            $setdata["type"] = "a";


            if (isset($d["target"])) {
                $setdata["target"] = $d["target"];
            }

            $setdata["data-title"] = $this->__eng->_get_gen_word($d["title"]);

            $setdata["class"] .= "  ";
            //   $setdata["data-insaction"] = "";

            unset($setdata["title"]);
            //  }
            if (isset($d["icon"])) {
                $setdata["data"] = $this->icon($d["icon"]);
                unset($setdata["icon"]);
            }
            if (isset($d["confirm"])) {

                $setdata["data-jsconfirm"] = $this->__eng->_get_gen_word($d["confirm"]);

                unset($setdata["confirm"]);
            }
            if (isset($d["trans"])) {
                $setdata["trans"] = $d["trans"];
            }

            if ($d["mode"] == "spliter") {
                $setdata["class"] = "spliter";
            } else if (isset($d["jsaction"])) {
                $setdata["data-jsaction"] = $d["jsaction"];
            } else if (isset($d["href"])) {
                $setdata["href"] = $d["href"];
                $this->url_toajax($setdata, false, "list");
            } else {

                $setdata["data-mode"] = $d["mode"];
            }


            $r .= $this->__ui->_data([$setdata])->_render();
        }

        return $r;
    }

    private function get_acntions_bar($_render_type = "all")
    {
        $backup = ["get_tmp_index" => "ins_main", "data-jsid" => $this->_options["adminid"], "render_type" => "table_data", "action" => "false", "defaultview" => "backup"];
        $csvexpurl = ["get_tmp_index" => "ins_main", "data-jsid" => $this->_options["adminid"], "render_type" => "table_data", "action" => "false", "defaultview" => "csv"];
        $csvexpurl_all = $csvexpurl;
        $csvexpurl_all["defaultlimit"] = 1000000;
        $databnts = [];
        $view_menu["start"] = ["data" => "ul", "class" => "ins_submenu ins_toolbar"];

        foreach ($this->_pro["list"] as $k => $v) {
            $m = "";
            $icon = "<i class='fas  fa-times'></i>";


            if (key_exists($k, $this->_list)) {
                $icon = "<i class='fas  fa-check'></i>";
                $m = "visabled";
            }
            $view_menu[] = ["type" => "span", "data-app" => $this->_myname, "data-type" => $k, "class" => "ins_list_view_item $m", "data" => $icon . $k];
        }

        $view_menu["end"] = ["data" => "ul"];
        $view_menu_text = \lib::_ui()->_data($view_menu)->_render();
        $sp = ["type" => "span", "class" => "spliter"];

        $menu = [];
        $menu["start"] = ["data" => "ul", "style" => "width: 180px;", "class" => "ins_submenu ins_toolbar"];

        if ($this->__users->_permission_can("add") || (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)) {
            $menu[] = ["type" => "span", "class" => "list_multi_update", "data-mode" => "copy", "data" => "<i class='fas fa-clone'></i>" . $this->__eng->_get_gen_word("copy")];
        }

        $menu[] = [
            "type" => "span", "class" => "insaction", "data-insaction" => "doprint",
            "data" => "<i class='fas fa-print'></i>" . $this->__eng->_get_gen_word("print")
        ];

        if ($this->__users->_permission_can("delete") || (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)) {
            $del = [
                "type" => "span", "class" => "list_multi_update",
                "data-mode" => "delete", "data" => "<i class='fas  fa-times'></i>" . $this->__eng->_get_gen_word("delete")
            ];

            if (isset($this->_pro["page"]["delete"]["callbefor"])) {
                $del["data-bdelete"] = $this->_pro["page"]["delete"]["callbefor"];
            }

            if (isset($this->_pro["page"]["delete"]["callafter"])) {
                $del["data-adelete"] = $this->_pro["page"]["delete"]["callafter"];
            }
            if (isset($this->_pro["page"]["delete"]["call"])) {
                $del["data-cdelete"] = $this->_pro["page"]["delete"]["call"];
            }

            if (isset($this->_pro["page"]["delete"]["condition"])) {
                $del["data-codelete"] = $this->_pro["page"]["delete"]["condition "];
            }

            $menu[] = $del;
        }

        $setdata[] = $sp;
        $menu[] = ["type" => "a", "href" => $this->__eng->_url($csvexpurl), "data" => "<i class='fas  fa-file-excel'></i>" . $this->__eng->_get_gen_word("export_csv"), "target" => "_blank"];
        $menu[] = ["type" => "a", "href" => $this->__eng->_url($csvexpurl_all), "data" => "<i class='fas  fa-table'></i>" . $this->__eng->_get_gen_word("export_csv_all"), "target" => "_blank"];
        $menu[] = ["type" => "a", "href" => $this->__eng->_url($backup), "data" => "<i class='fas  fa-database'></i>" . $this->__eng->_get_gen_word("backup"), "target" => "_blank"];
        $setdata[] = $sp;
        $menu[] = ["type" => "a", "href" => $this->__eng->_url(["mode" => "trash"], ["render_type", "page"]), "data" => "<i class='fas  fa-trash'></i>" . $this->__eng->_get_gen_word("trash"), "target" => "_blank"];

        $menu["end"] = ["data" => "ul"];
        $actions_menu = \lib::_ui()->_data($menu)->_render();

        $setdata = [];


        if (is_array($this->_list_add_to_action_bar)) {
            $setdata = array_merge($setdata, $this->_list_add_to_action_bar);
        }

        $setdata["start"] = ["data" => "span", "class" => "ins_button", "style" => "width: 120px;display: inline-block; font-size:13px;"];
        $setdata[] = ["type" => "a", "class" => "ins_component_add", "href" => $this->__eng->_url(["mode" => "add"]), "data" => "<i class='fas fa-plus'></i>" . $this->__eng->_get_gen_word("add")];
        $setdata[] = $sp;





        $setdata[] = ["type" => "div", "style" => "padding: 0 4px;float: right;", "class" => "ins_submenu_parent", "data" => "<i class='fas  fa-angle-left'></i>" . $actions_menu];

        $setdata["end"] = ["data" => "span"];


        $setdata[] = ["type" => "span", "class" => "", "onclick" => "ins(\".ins_filter_area\")._toggle_class(\"ins_opend\")", "data-title" => $this->__eng->_get_gen_word("filter"), "data" => "<i class='fas fa-search'></i>"];

        $setdata[] = ["type" => "span", "class" => "ins_submenu_parent", "data-title" => $this->__eng->_get_gen_word("view"), "data" => "<i class='fas fa-eye'></i>" . $view_menu_text];



        if (isset($this->_pro["page"]["block_list_swtitch"])) {
            $setdata[] = [
                "type" => "span", "class" => "ins_block_list_swtitch",
                "data-title" => $this->__eng->_get_gen_word("view"), "data" => "<i class='fas fa-th-large'></i>"
            ];
        }






        return \lib::_ui()->_data($setdata)->_render();

        //  return $this->createbnt($databnts);
    }

    private function getList($_render_type = "all")
    {
        $r = "";
        $stratdata = "";

        $mo = "";
        $fileurl = "get_file=pages/list" . $this->_url_s();




        $actions = true;

        if (trim($this->_page_options["dbtable"]["data_value"])) {
            $this->_dbtable = $this->_page_options["dbtable"]["data_value"];
        }
        if (trim($this->_page_options["action"]["data_value"]) == "false" || $this->_get["action"] == "false") {
            $actions = false;
        }

        \lib::_template()->_add_to_pagedata("table", $this->_dbtable);



        if ($actions) {

            $this->_options["start_data"] = "";
            $this->_options["end_data"] = "";
            $moretolink = "";

            $this->_options["bar_data"] = $this->get_acntions_bar($_render_type = "all");


            if (isset($this->_options["_addto_list_toolbar"])) {
                $this->_options["bar_data"] .= $this->_options["_addto_list_toolbar"];
            }



            $stratdata .= $this->__ui->_data(
                ["type" => "checkbox", "trans" => "false", "input" => "true", "class" => "check_list_ids", "value" => "@(id)"]
            )->_render();




            $databntsrow = [];
            if (
                $this->__users->_permission_can("edit") ||
                (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)
            ) {
                array_push($databntsrow, ["title" => "edit", "class" => "ins_component_edit", "trans" => "false", "icon" => "fa-edit", "href" => $this->_url("edit", "@(id)")]);
            }
            if (
                $this->__users->_permission_can("delete") ||
                (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)
            ) {
                array_push($databntsrow, ["title" => "delete", "trans" => "false", "class" => "list_status_update", "icon" => "times", "mode" => "delete", "data-ids" => "@(id)", "confirm" => "delete_message"]);
            }

            if (isset($this->_options["history"]["data_value"])) {

                array_push($databntsrow, [
                    "title" => "history", "trans" => "false",
                    "class" => "list_get_history", "icon" => "history",
                    "data-table" =>  $this->_dbtable,
                    "data-id" => "@(id)"
                ]);
            }


            $enddata = $this->createbnt($databntsrow);

            if (isset($this->_pro["page"]["tree_mode"]) && $this->_pro["page"]["tree_mode"] != "") {
                $p = $this->_pro["page"]["tree_mode"];
                if (
                    $this->__users->_permission_can("add") ||
                    (isset($this->_options["_per_cancel"]) && $this->_options["_per_cancel"] == true)
                ) {
                    $enddata .= $this->createbnt([
                        ["title" => "add_child", "trans" => "false", "icon" => "level-down", "href" => $this->_url("add", "", [$p["data_value"] => "@(id)"])]
                    ]);
                }
            }



            if (isset($this->_options["_addto_row_options"])) {
                $enddata .= $this->_options["_addto_row_options"];
            }




            if ($this->_pro["group"] != null && count($this->_pro["group"]) > 0) {


                $this->_options["start_data"] = ""
                    . "<div class='dropdown right top'>"
                    . "<div   "
                    . "class='dropdown-toggle toright'>"
                    . "<i class=\"fas fa-bars\"></i></div>"
                    . "<ul class='dropdown-menu ins_highlight_area'>";




                foreach ($this->_pro["group"] as $k => $g) {

                    $ks = explode("-", $k);
                    if ($ks[0] == "divider") {
                        $this->_options["start_data"] .= $this->__ui->_data(["li" => ["class" => "divider"]])->_render();
                    } else {

                        $guidata =   [
                            "type" => "a", "class" => " ", "href" => $this->__eng->_url(["alias" => $k]),
                            "data" => \ins::_eng()->_get_gen_word($g["data_value"])
                        ];

                        if (isset($g[trim(\lib::_eng()->_this_lang)])) {

                            $guidata["data"] = $g[trim(\lib::_eng()->_this_lang)];
                        }

                        $aa = $this->__ui->_data($guidata)->_render();

                        $this->_options["start_data"] .= $this->__ui->_data(["li" => ["data" => $aa]])->_render();
                    }
                }

                $this->_options["start_data"] .= "</ul>"
                    . "</div>";
            }

            if ($this->_page_options["readonly"]["data_value"] !== "true") {
                $this->_options["start_list"] = ["#" => ["class" => "ins_col_2   ins_text_tocenter strat_data_options  rows_select rows_select_all", "data" => $stratdata]];
                $this->_options["end_list"] = [$this->__eng->_get_gen_word("action") => ["class" => "ins_col_2 end_data_options ", "data" => $enddata]];
            }
        }


        $this->_options["page"] = $this->_page_options;
        $this->_options["ajax"] = $this->_ajax;
        $this->_options["title"] = true;


        $p = $this->__pages->_get_class("list", $this->_myname, $this->_options);


        if (isset($g["render_type"])) {
            $_render_type = $g["render_type"];
        }
        return $p->_render($_render_type);
    }

    private function url_toajax(&$ldata, $ajax, $type = "")
    {
        if ($this->_ajax) {
            $main_style = "main_style";
            $ldata["data-jsaction"] = 'lightbox';
            $ldata["data-title"] = "";
            if (isset($this->_page_options["title"])) {
                $ldata["data-title"] .= $this->_page_options["title"]["data_value"];
            }
            $ldata["data-title"] .= " " . $ldata["title"];
            if (strpos($ldata["href"], 'do') !== false) {
                $ldata["href"] .= "/get_tmp_index/$main_style/";
            } else {
                $ldata["href"] .= "/do/get_tmp_index/$main_style/";
            }
            /*  if ($type == "list") {

              $ldata["data-close_callback"] = 'update_main_list';
              } */
            $ldata["href"] = \lib::_data()->_url_clrea($ldata["href"]);
        }
    }

    private function icon($icon)
    {
        return $this->__ui->_data(
            [
                ["type" => "wicon", "data" => $icon]
            ]
        )->_render();
    }

    private function _url($mod, $id = "", $morr_array = null)
    {
        $udata = $this->_options["_addtourl"];
        $udata["mode"] = $mod;
        if ($id != "") {

            $udata["id"] = $id;
        }
        if (is_array($morr_array)) {
            $udata = array_merge($udata, $morr_array);
        }


        return $this->__eng->_url($udata, ["render_type"]);
    }

    private function _url_s()
    {
        $udata = $this->_options["_addtourl"];
        $a = "";
        foreach ($udata as $k => $v) {

            $a .= "&$k=" . $v;
        }
        return $a;
    }
}
