<?php

namespace ins_lib\pages;

class page_form extends \ins_page
{

    var $_mode = "add";
    var $_id = "";
    var $_add_success_message = "";
    var $_edit_success_message = "";
    var $_g = "";
    var $_options = [];

    /**
     * 
     * @param type $myname db-table-name
     * @param type $options   title,mode[add,edit],id <in edit>
     */
    public function __construct($myname = "", $options = [])
    {

        parent::__construct("list", $myname, $options);
        $this->_mode = $this->getoption("mode");
        $this->_title = $this->getoption("title");
        $this->_id = $this->getoption("id");
        $this->_g = \lib::_eng()->_get();

        $this->_options = $options;
    }

    private function dbActions($getData = false)
    {
        $r = "";

        if ($data = $this->get_profx_data("sys_properties", $_POST)) {
            $_POST["sys_properties"] = \lib::_data()->_arrayToDB($data);
        }



        if ($data = $this->get_profx_data("custom_fields", $_POST)) {
            $_POST["custom_fields_data"] = \lib::_data()->_arrayToDB($data);
        }


        if ($this->_add_success_message == "") {
            $this->_add_success_message = $this->__eng->_get_gen_word("add_success_message");
        }

        if ($this->_edit_success_message == "") {
            $this->_edit_success_message = $this->__eng->_get_gen_word("edit_success_message");
        }



        if ($getData) {
            $r = $this->__db->_get_disabled()->_get_row($this->db_table, "*", "`id`=:myid", ["myid" => $this->_id]);
        } else {



            if ($_POST["form_mode"] == "add") {

                if ($d = $this->__db->_insert($_POST["form_to"], $_POST)) {
                    $this->upload_db_data($d);
                    $r = $this->__pages->_meaasge($this->_add_success_message);
                    $r .= $this->ex($d);

                    if (isset($this->o["page"]["isd"]["data_value"])) {
                    }
                    if (isset($this->_pro["page"]["isd"]["data_value"])) {

                        $_isd_data = ["isd_table" => $_POST["form_to"], "isd_table_id" => $d];
                        \lib::_eng()->_isd()->_isd_create($_isd_data);
                    }


                    if (isset($this->_options["fun_after_add"])) {


                        call_user_func($this->_options["fun_after_add"], $d);
                    };
                    if (isset($this->_options["on_add"])) {


                        call_user_func($this->_options["on_add"], $d);
                    };
                };
            } else if ($_POST["form_mode"] == "edit") {

                if (!isset($this->_id) || $this->_id == "") {
                    $this->_id = $_GET["id"];
                }

                if ($d = $this->__db->_update($_POST["form_to"], $_POST, "`id`='" . $this->_id . "'")) {
                    $this->upload_db_data($this->_id);
                    $r = $this->__pages->_meaasge($this->_edit_success_message);


                    if (isset($this->_pro["page"]["isd"]["data_value"])) {

                        $_isd_data = ["isd_table" => $_POST["form_to"], "isd_table_id" => $this->_id];
                        \lib::_eng()->_isd()->_isd_update($_isd_data);



                    }

                    if (isset($this->_options["on_update"])) {

                        
                        call_user_func($this->_options["on_update"], $d);
                    };

                };
                $r .= $this->ex($this->_id);
            }
        }





        return $r;
    }

    private function ex($id)
    {

        if (isset($this->_g["ins_appendto_combo"])) {

            $data = [
                "select_type" => "db",
                "select_table" => $_POST["form_to"],
                "select_text" => "title",
                "select_value" => "id",
            ];


            if (isset($this->_g["select_text"])) {
                $data["select_text"] = $this->_g["select_text"];
            }
            if (isset($this->_g["select_value"])) {
                $data["select_value"] = $this->_g["select_value"];
            }

            $h = \lib::_ui()->_get_class();
            $hd = $h->getOptions($data);

            $r = '<script> '
                . ' let p = ins("' . $this->_g["ins_appendto_combo"] . '")._get(0, true); '
                . " ins(p)._sethtml('$hd');"
                . " ins(p)._setvalue('$id'); ";


            if (isset($this->_g["onclose"])) {
                $r .= "parent[\"" . $this->_g["onclose"] . "\"](p) ;";
            }

            $r .= ' let l = ins(\'.ins_lightbox\')._get(0, true); '
                . ' ins(l)._remove();
            
            
            </script> ';
        } else if (isset($this->_g["onclose"])) {
            $r = '<script> ';
            $r .= "parent[\"" . $this->_g["onclose"] . "\"]() ;";
            $r .= ' let l = ins(\'.ins_lightbox\')._get(0, true); '
                . ' ins(l)._remove();
                        </script> ';
        }


        if ($_POST["from_save_type"] == "save_and_back") {
            $r = '<script>';
            $url = \lib::_eng()->_url([], ["mode"]);
            $r .= ' window.location="' . $url . '"';
            $r .= ' </script> ';
        }

        if ($_POST["from_save_type"] == "save_go_edit") {
            $r = '<script>';
            $url = \lib::_eng()->_url(["mode" => "edit", "id" => $id], []);
            $r .= ' window.location="' . $url . '"';
            $r .= ' </script> ';
        }

        return $r;
    }

    private function upload_db_data($obj_id)
    {



        $fields = $this->_pro["fields"];

        foreach ($fields as $k => $v) {
            if ($v["type"] == "admin") {
                if (!isset($v["name"])) {
                    $v["name"] = $k;
                }
                if (!isset($v["dbtable"])) {
                    $v["dbtable"] = $v["name"];
                }


                foreach ($_POST[$v["name"]] as $xid) {
                    $this->__db->_update($v["dbtable"], [$v["xref"] => $obj_id], "id=:myid", ["myid" => $xid]);
                }
            }
        }
    }

    private function get_profx_data($prfix, $data)
    {
        $r = false;
        foreach ($data as $k => $v) {
            $ndata = explode("__", $k);
            if (trim($ndata[0]) === trim($prfix)) {

                $r[$ndata[1]] = $v;
            }
        }
        return $r;
    }

    private function header()
    {



        $toolbar = $this->_options["bar_data"];

        $r .= $toolbar ? $this->__ui->_data(
            ["type" => "div", "class" => "toolbar  btn-group", "data" => $toolbar]
        )->_render() : "";


        $r .= $this->_options["start_data"] ? $this->__ui->_data(
            ["type" => "div", "class" => "start_data", "data" => $this->_options["start_data"]]
        )->_render() : "";
        return $r;
    }

    public function _update_data($dbdata)
    {


        $_g = $this->__eng->_get();


        $fields = $this->_pro["fields"];
        foreach ($fields as $k => $v) {
            if (isset($this->_pro["page"]["tree_mode"]) && $this->_pro["page"]["tree_mode"]["data_value"] == $k && isset($_g[$k]) && $this->_mode == "add") {
                $this->_pro["fields"][$k]["value"] = $_g[$k];
            }


            if (!isset($v["name"])) {
                $v["name"] = $k;
            }


            if ($dbdata != null) {
                if ($v["name"] != "password") {

                    if ($this->_pro["fields"][$k]["type"] == "datetime-local") {

                        $this->_pro["fields"][$k]["value"] = date("Y-m-d\TH:i:s", strtotime($dbdata[$v["name"]]));
                    } else if ($this->_pro["fields"][$k]["type"] == "date") {

                        $this->_pro["fields"][$k]["value"] = date("Y-m-d", strtotime($dbdata[$v["name"]]));
                    } else {
                        $this->_pro["fields"][$k]["value"] = $dbdata[str_replace("[]", "", $v["name"])];
                    }
                }



                // date("Y-m-d\TH:i:s", strtotime($yourdate))
            }
        }
    }

    private function c_array($fields)
    {
        $tmp = [""];
        $s = false;
        $src_name = $field["name"] . "_src";

        foreach ($fields as $k => $field) {
            foreach ($fields as $k => $field) {
                if ($field['type'] == "ins_array" || $k == "ins_array") {
                    $src_name = $field["name"];

                    $field["class"] = $src_name . "_src";
                    $s = true;
                }

                if ($s) {
                    $tmp[$k] = $field;
                    unset($fields[$k]);
                }
                if ($field['type'] == "ins_endarray" || $k == "ins_endarray") {
                    $s = false;
                }
            }
        }

        $tmp["ins_array"] = "div";

        $tmp["ins_endarray"] = ["type" => "div", "data" => "remove", "class" => "col12   ns_text_tocenter button", " data-jsaction" => "remove", "data-remove" => "parent"];


        $tmp[] = ["type" => "end"];


        $fields = array_merge($fields, $tmp);
        return $fields;
    }

    private function preparData()
    {

        $fields = $this->_pro["fields"];
        foreach ($fields as $k => $field) {
            if (isset($field['lang']) && $field['lang'] == "true" && $this->_mode == "edit") {
                $fields[$k]['lang_type'] = $this->_myname;
                $fields[$k]['lang_id'] = $this->_id;
            }



            $field["type"] = $field["type"] ? $field["type"] : $k;

            if ($field['type'] == "app_oject") {



                /*
                  } else if ($field['type'] == "admin") {
                  if (isset($field['xref'])) {
                  $xid = $this->_id;
                  if ($this->_mode == "add") {
                  $fields[$k]['parent_add'] = true;
                  $xid = $this->__db->_get_max_id($this->_dbtable) + 1000;
                  }
                  $fields[$k]['query'] = '`' . $field['xref'] . '`=' . $xid;
                  $fields[$k]['addtourl'] = [$field['xref'] => $xid];
                  } */
            } else if ($field['type'] == "isd") {
                $field["area"] = "root";
                $field["isd_table"] = $this->_dbtable;
                $field["isd_table_id"] = $this->_id;
                $field["data"] = "plg_sys_isd";
                $field["type"] = "plugin";
                if (isset($data["path"])) {
                    $isd["path"] = $data["path"];
                }
                $fields[$k] = $field;
            } else if ($field["type"] == "plugin") {
                $field["_table"] = $this->_dbtable;
                $field["_id"] = $this->_id;
                $field["area"] = $field["area"] ? $field["area"] : "root";

                $fields[$k] = $field;
            } else if ($field['type'] == "custom_fields") {

                $field["area"] = "root";
                $field["table"] = $this->_dbtable;
                $field["table_id"] = $this->_id;
                $field["data"] = "plg_custom_fields";
                $field["type"] = "plugin";
                $fields[$k] = $field;
            }
        }





        return $fields;
    }

    public function _get_data($dbdata = null)
    {
        //  if ($dbdata != null) {
        $this->_update_data($dbdata);
        //}


        $r = $this->__ui->_data(
            $this->preparData()
        )->_render();



        return $r;
    }

    public function _render()
    {

        $_g = $this->__eng->_get();


        if (isset($this->_pro["page"]["db_table"])) {
            $this->db_table = $this->_pro["page"]["db_table"]["data_value"];
        } else if (isset($this->_pro["page"]["dbtable"])) {
            $this->db_table = $this->_pro["page"]["dbtable"]["data_value"];
        } else {
            $this->db_table = $this->_myname;
        }





        $r = $this->dbActions();

        if ($this->_mode == "edit") {
            $dbdata = $this->dbActions(true);
        } else {
        }
        $r .= $this->header();
        $h = $this->_get_data($dbdata);





        if ($this->_pro["page"]["hide_buttons"]["data_value"] !== "true") {
            $uidata = [
                [
                    "type" => "hidden",
                    "name" => "form_to",
                    "input" => "true",
                    "value" => $this->db_table
                ],
                [
                    "type" => "hidden",
                    "name" => "form_mode",
                    "input" => "true",
                    "value" => $this->_mode
                ],
                [
                    "pclass" => "ins_col_2 ins_float_left",
                    "type" => "reset",
                    "name" => $this->db_table,
                    "input" => "true",
                    "value" => $this->__eng->_get_gen_word("reset")
                ],
                [
                    "pclass" => "ins_col_7 ",
                    "type" => "span"
                ],
                ["type" => "start", "class" => "ins_button  ins_col_2 ins_grid"],



                ["type" => "start", "class" => "ins_submenu_parent ins_to_top ins_col_3"],
                ["type" => "i", "class" => "fas  ins_col_12  fa-angle-left", "style" => "text-align: CENTER;line-height: 34px;"],
                ["type" => "start", "data" => "ul", "class" => "ins_submenu ins_toolbar", "style" => "    width: 183px;"],
                ["type" => "button", "name" => "from_save_type", "value" => "save_and_back", "data" => $this->__eng->_get_gen_word("list_send_and_back")],
                ["type" => "button", "name" => "from_save_type", "value" => "save_go_edit", "data" => $this->__eng->_get_gen_word("list_send_and_edit")],
                ["type" => "end", "data" => "ul"],
                ["type" => "end"],
                [
                    "pclass" => "ins_col_9 ins_float_right",
                    "type" => "submit", "data-myform" => $this->db_table,
                    "name" => $this->db_table,
                    "input" => "true",
                    "data-id" => $this->_id,
                    "class" => $this->_mode,
                    "data-status" => $this->_mode,
                    "value" => "" . $this->__eng->_get_gen_word("send")
                ],
                ["type" => "end"],
                ["class" => "clearfix", "type" => "div",]
            ];


            if (isset($this->_options["from_save_type"]["data_value"])) {
                $uidata["from_save_type"] = [
                    "type" => "hidden",
                    "name" => "from_save_type",
                    "input" => "true",
                    "value" => $this->_options["from_save_type"]["data_value"]
                ];
            }


            $h .= $this->__ui->_data(
                [
                    "type" => "div",
                    "class" => "ins_page_actions ins_col12 ins_grid",
                    "data" => $uidata
                ]
            )->_render();
        }



        $r .= $this->__ui->_data(
            [
                "type" => "form",
                "name" => $this->_myname,
                "method" => "post",
                "enctype" => "multipart/form-data",
                "type" => "form", "style" => "grid-gap: 10px;",
                "class" => " ins_grid  _form" . $this->_myname,
                "trans" => "false",
                "data" => $h
            ]
        )->_render();







        $r .= $this->_options["end_data"] ? $this->__ui->_data(
            ["type" => "div", "class" => "end_data", "data" => $this->_options["end_data"]]
        )->_render() : "";


        return $r;
    }
}
