<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of UIClass
 *
 * @author ismail
 */

namespace ins_lib\ui;

class UIClass
{

    var $data = [];
    var $type = "html";
    var $gat = "";

    public function __construct($type = "html")
    {
        if ($type == "") {
            $type = "html";
        }
        $this->type = $type;
    }

    function _render()
    {


        $className = "\ins_lib\ui\ui_" . $this->type;

        if (class_exists($className)) {
            $a = new $className($this->data);
            return $a->_render();
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
    }

    function _get_class()
    {
        $className = "\ins_lib\ui\ui_" . $this->type;
        if (class_exists($className)) {
            $a = new $className($myname, $options);

            return $a;
        } else {
            lib::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
    }

    function _data($uidata, $type = "html")
    {
        $this->type = $type;

        $this->data = $uidata;
        return $this;
    }


    /**
     * 
     * @staticvar type $_ui
     * @param type $data
     * @return \ins_lib\ui\ui_html
     */
    function _html($data = null, $type = "html")
    {
        static $_ui = null;
        if ($_ui === null) {
            $_ui = new \ins_lib\ui\ui_html($data);
        }

        return $_ui;
    }
    /**
     * 
     * @staticvar type $_icon
     * @param type $data
     * @return \ins_lib\ui\Icons
     */
    function _icon($data)
    {
        static $_ui = null;
        if ($_ui === null) {
            $_ui = new \ins_lib\ui\Icons($data);
        }

        return $_ui;
    }
}
