<?php

session_start();
ini_set("display_errors", 1);
error_reporting(E_ERROR | E_PARSE | E_COMPILE_ERROR);
include_once "../../lib.php";

// <editor-fold defaultstate="collapsed" desc="Start">
$h = \lib::_ui()->_get_class();
$pros = [];
if (isset($_REQUEST["pros"])) {
    $pros = json_decode($_REQUEST["pros"], true);
}
$h->update_data($pros);



if (isset($_REQUEST["data_file"])) {
    $h->db_xml_file = $_REQUEST["data_file"];
}

if (isset($_REQUEST["update_date"])) {

    $_REQUEST["data"] = json_decode($_REQUEST["data"], true);
}
if (isset($_REQUEST["update_settings_json"])) {

    $_REQUEST["settings"] = json_decode($_REQUEST["settings"], true);
}

$thisdb_xml_file = "form";
$db_path = \lib::_app_map()->libs_folder . "ui/ui_editor_db/";
$db_all = \lib::_files()->loadfile($db_path . $thisdb_xml_file . ".xml", "", "")->out;
$tmp_xml = \lib::_eng()->_get_properties_xml("tmp_test01", "", "");


$db_items = $db_all["items"];
$db_vars = $db_all["vars"];

$out = "";
// </editor-fold>

switch ($_REQUEST["status"]) {

    case "preview":
        $_SESSION["ui_data_tmp"] = $_REQUEST["data"];
        break;

    case "block":
        $out = $h->get_item($_REQUEST["data"], $_REQUEST["append"]);
        break;
    case "addcolor":
        $v = $_REQUEST["value"];
        unset($_SESSION["ui_colorpanels_data"][$v]);
        $cu = count($_SESSION["ui_colorpanels_data"]);
        if ($cu >= 10) {
            unset($_SESSION["ui_colorpanels_data"][$cu - 1]);
        }
        $_SESSION["ui_colorpanels_data"][$v] = $v;

        break;
    default :
        $out = call_user_func($_REQUEST["status"]);
        break;
}
echo $out;

function ui_editor_update_all_view() {
    global $h;
    if (trim($_REQUEST["data"]) == "" && isset($_SESSION["ui_act_menu"])) {
        $_REQUEST["id"] = $_SESSION["ui_act_menu"];
        $_REQUEST["data"] = uieditor_menu_edit();
    }


    $data = "<style>" . $_REQUEST["css_data"] . "</style>";
    $data .= "<script>" . $_REQUEST["js_data"] . "</script>";


    $data .= $h->_editor_update_data($_REQUEST["data"], $_REQUEST["type"], false);


    return $data;
}

// <editor-fold defaultstate="collapsed" desc="panels">
function update_settings() {
    global $h, $db_items;
    unset($_REQUEST["status"]);

    $settings = $_REQUEST["settings"];


    $properties = $db_items["data_value"][$settings["category"]]["data_value"][$settings["subcategory"]]["data_value"][$settings["type"]]["data_value"]["properties"]["data_value"];
    $h->update_varables_properties($properties);

    $settings = $settings["settings"];
    foreach ($properties as $k => $v) {


        if (isset($settings[$properties[$k]["data-setting"]])) {
            $properties[$k]["value"] = $settings[$properties[$k]["data-setting"]];
        }
    }
    $h->update_date($properties, $settings, $settings);
    return "<div class='ins_settings_panel ins_grid'>" . \lib::_ui()->_data($properties)->_render() . "</div>";
}

function updatepanel() {
    global $h, $db_items;

    $r = "";
    switch ($_REQUEST["panel"]) {
        case "colors":
            $r = color_panel();
            break;
        case "toolbar":
            $r = get_toolbar();
            break;
        case "templates":
            $settings = json_decode($_REQUEST["settings"], true);
            $r = $h->templates_panel($settings);
            break;
        case "settings":
            $r = update_settings();
            break;
    }


    return $r;
}

function color_panel() {
    $data["strat-all"] = ["class='ins_ui_editpanel  ins_ui_colorpanel'"];
    $pdata = ["#000000", "#545454", "#737373", "#a6a6a6", "#d9d9d9", "#ffffff", "#ff5757", "#ff66c4", "#cb6ce6", "#8c52ff", "#5271ff", "#38b6ff", "#5ce1e6", "#7ed957", " #c9e265", "#ffde59", "#ffbd59", "#ff914d"
    ];
    $i = 0;
    $data["li-sp0"] = ["class" => "ins_ui_colorpanle_sp"];
    $data["color"] = ["input" => true, "data-name" => $_REQUEST["name"], "value" => '<i class="fas fa-plus"></i>', "class" => "ins_ui_colorpanle_add ins_ui_colorpanle_item"];

    $data["start"] = ["class" => "ins_ui_seitems", "data" => "ul"];
    if (isset($_SESSION["ui_colorpanels_data"])) {
        foreach ($_SESSION["ui_colorpanels_data"] as $d) {
            $data["li-$i"] = ["class" => "ui_edit_css e_click ins_ui_colorpanle_item", "style" => "background:$d", "data-name" => $_REQUEST["name"], "data-value" => "$d"];
            $i++;
        }
    }
    $data["end"] = ["data" => "ul"];
    $data["li-sp"] = ["class" => "ins_ui_colorpanle_sp"];


    $data["li-em"] = ["class" => "ui_edit_css e_click ins_ui_colorpanle_item",
        "data" => '<i class="far fa-times-circle"></i>', "style" => "background:$d", "data-name" => $_REQUEST["name"], "data-value" => "transparent"];


    foreach ($pdata as $d) {

        $data["li-$i"] = ["class" => "ui_edit_css e_click ins_ui_colorpanle_item", "style" => "background:$d", "data-name" => $_REQUEST["name"], "data-value" => "$d"];
        $i++;
    }

    $data["end-all"] = [];
    return \lib::_ui()->_data($data)->_render();
}

function ui_editor_update_site_config() {
    global $h;
    $data = \lib::_db()->_update("sys_site_config", [$_REQUEST["name"] => $_REQUEST["value"]], "id=" . $h->_site_id);
}

function get_toolbar() {
    global $h;
    $r = "";
    if (isset($_REQUEST["type"]) && $_REQUEST["type"] !== "undefined") {
        $j = json_decode($_REQUEST["settings"], true);
        $data = $data[$_REQUEST["type"]]["data_value"];

        $r = $h->get_toolbar($_REQUEST["type"], $j);
    }
    return $r;
}

function uieditor_update_code() {
    if (isset($_SESSION["ui_act_code"])) {
        $data = \lib::_db()->_update("com_form", ["data" => $_REQUEST["data"]], "id=" . $_SESSION["ui_act_code"]);
    }
}

function ui_editor_update_ui_data() {

    /*   if (isset($_SESSION["ui_act_menu"]) && isset($_REQUEST["image"])) {
      $data = \lib::_db()->_update("sys_menus_items", ["image" => $_REQUEST["image"]], "id=" . $_SESSION["ui_act_menu"]);
      }

      if (isset($_SESSION["ui_act_code"])) {
      $data = \lib::_db()->_update("com_form", ["data" => $_REQUEST["data"], "css_data" => $_REQUEST["css_data"], "js_data" => $_REQUEST["js_data"]], "id=" . $_SESSION["ui_act_code"]);
      } */
    global $h;

    $h->uieditor_db_save();
}

// </editor-fold>
// <editor-fold defaultstate="collapsed" desc="MENU">










function chk_act_menu() {
    $r = "-1";
    if (isset($_SESSION["ui_act_pkg"])) {
        $r = $_SESSION["ui_act_pkg"];
    }
    return $r;
}

function uieditor_menu_update() {
    global $h;
    return $h->uieditor_db_get_data();
}

function uieditor_menu_copy() {
    $pros = json_decode($_REQUEST["pros"], true);

    $table = $pros["_db_data_table"];

    $w = "";
    if (isset($pros["_db_data_cat_table"])) {

        $cat_table = $pros["_db_data_cat_table"];

        $w = "cat_id=" . $_REQUEST["cat_id"];
    }


    $morder = \lib::_db()->_get_row($table, "max(sys_order) morder", $w) ["morder"];




    $dt = \lib::_db()->_get_row($table, "*", "id=" . $_REQUEST["id"]);
    $sys_properties = json_decode($dt["sys_properties"], true);
    $t = $dt["title"] . "_copy";
    unset($dt["id"]);
    $dt["title"] .= "_copy";
    $dt = \lib::_db()->_insert($table, $dt);
    return uieditor_menu_update();
}

function uieditor_menu_delete() {
    global $h;
    return $h->uieditor_db_delete($id);
}

function uieditor_menu_edit($id = "") {
    global $h;
    return $h->uieditor_db_set_act($id);
}

function uieditor_menu_add() {
    global $h;
    return $h->uieditor_db_creat();
}

function uieditor_get_code() {
    $data = \lib::_db()->_get_row("com_form", "*", "id=" . $_SESSION["ui_act_code"]);
    return $data[$_REQUEST["type"]];
}

function uieditor_menu_home() {
    $dt = \lib::_db()->_update("sys_menus_items", ["home" => "0"], "sys_site=" . \lib::_eng()->_site_setting["id"]);
    $dt = \lib::_db()->_update("sys_menus_items", ["home" => "1"], "id=" . $_REQUEST["id"]);
}

// </editor-fold>
// <editor-fold defaultstate="collapsed" desc="items">


function update_items() {
    global $db_vars, $h, $db_items;
    $ub = $db_items["data_value"][$_REQUEST["category"]]["data_value"][$_REQUEST["subcategory"]];
    $rdata .= '<div data-name="' . $_REQUEST["subcategory"] . '" class="">'
            . '<div class="ui_editor_item">'
            . '<h1>' . $ub["title"] . '</h1>';

    foreach ($ub["data_value"] as $k => $v) {
        $allnode = $v;
        $v = $allnode["data_value"];
        unset($allnode["data_value"]);



        if ($v["type"]["data_value"] == "separator") {
            $rdata .= "<div class='line separator'></div>";
        } else {
            $v = $h->update_properties($k, $v, $allnode);
            $settings = $allnode;
            $settings["category"] = $_REQUEST["category"];
            $settings["subcategory"] = $_REQUEST["subcategory"];
            $settings["type"] = $k;

            if (isset($v["settings"])) {
                $settings["settings"] = $v["settings"];
            }
            $rdata .= $h->block_v2($v, $settings, " ins_grid_object ins_light ", false);
        }
    }
    $rdata .= '</div>';
    return $rdata;
}

// </editor-fold>
