<?php

class mod_gustbook extends ins_mod {

    public function __construct($data) {
        parent::__construct($data);
    }

    function _get_data() {
        $datas = $this->__db->_get_data("com_gustbook", "*", "1=1 limit 0,4");
        $url = '/ins_images/ins_sys/imos/';


        foreach ($datas as $d) {
            $h = $this->__ui->_data(
                            [
                                "img" => ["class" => "$mclass gustbook_imo", "src" => "$url/" . $d["imo"], "data-v" => $im]
                                ,
                                "div" => ["class" => "gustbook_comment", "data" => "<span>" . $d["comment"] . "</span>"]
                                , "h2-1" => ["class" => "gustbook_title", "data" => $d["title"]]
                    ])->_render();


            $r .= $this->__ui->_data(["div" => ["class" => "gustbook_row ", "data" => $h]])->_render();
        }





        $menu = $this->__eng->get_menu_by_type("com_gustbook");

        $url = $this->__eng->_url(["alias" => $menu["alias"]]);




        $r .= $this->__ui->_data([
                    "div-2" => ["class" => "clearfix"],
                    "a" => ["class" => "gotomore button col1", "href" => $url, "data" => $this->_lang["more_comments"]],
                    "div" => ["class" => "clearfix"]
                ])->_render();



        return $r;
    }

    function _out() {

        $this->_include("my_style.css");

        $this->_include("gust_.js");

        return $this->_get_data();
    }

}
