<?php

/**
 * Description of mod_menu
 *
 * @author ismail
 */
class plg_conent extends ins_plg
{

    var $_render  = "";
    public function __construct($data)
    {
        parent::__construct($data);
    }

    function _get_categories($req)
    {
        $r = "";
        $data = \ins::_db()->_get_data(
            "sys_content_categories",
            "*",
            \ins::_data()->_db_get_form_group($req["cat_id"]) . " order by `sys_order`"
        );


        foreach ($data as $d) {

            if ($d["image"] != "") {
                $array_data["imimage"] = '
               <img src="' . \ins::_app_map()->upload_folder . $d["image"] . '"> ';
            }

            $array_data["title"] = $d["title"];
            $array_data["des"] = $d["des"];

            $r .= \ins::_ui()->_data(["data_block" => [
                "class" => "ins_col_4 ins_light _plg_conent_cat_data ins_text_tocenter _" . $d["cat_id"],

                "data-cat_id" => $d["id"],

                "data" => $array_data
            ]])->_render();
        }
        return \ins::_ui()->_data(["div" => ["class" => "sys_content_items ins_grid  data_cats", "data" => $r]])->_render();
    }

    function _get_items($req)
    {
        $r = "";

        $data = \ins::_db()->_get_data("sys_content", "*", \ins::_data()->_db_get_form_group($req["cat_id"]) . " order by `sys_order` ");

        foreach ($data as $d) {
            \ins::_data()->_update_language($d);

            if ($d["th_image"] != "") {
                $blockdata["image"] = ins::_app_map()->upload_folder . $d["th_image"];
            }

            $blockdata["title"] = $d["title"] . '<div class=\'ins_module_title_icon\'><i class=\"fas fa-graduation-cap\"></i></div>';
            $blockdata["des"] = $d["des"];

            if ($d["mark"] == "video") {
                $blockdata["hover_effect"] = '<i class="fas fa-video"></i>';
            } else if ($d["mark"] == "image") {
                $blockdata["hover_effect"] = '<i class="fas fa-images"></i>';
            } else {
                $blockdata["hover_effect"] = '<i class="fab fa-readme"></i>';
            }

            $r .= \ins::_ui()->_data(["data_block" => [
                "data" => $blockdata, "data-title" => $d["title"],

                "data-cat_id" => $req["cat_id"],
                "data-id" => $d["id"], "class" => "  _item_block  _plg_conent_item_data  ins_col_4   "
            ]])->_render();
        }

        return  \ins::_ui()->_data(["div" => ["class" => " grid  sys_content_items ", "data" => $r]])->_render();
    }

    function _get_item($req)
    {

        $r = "";
        $d = \ins::_db()->_get_row("sys_content", "*", "id='{$req["id"]}'");
        \ins::_data()->_update_language($d);

        $cdata = \ins::_db()->_get_row("sys_content_categories", "*",  "id='{$req["cat_id"]}'");
        \ins::_data()->_update_language($cdata);

        $ds = \ins::_db()->_get_data("sys_images", "*", "cat_id=:id", ["id" => $d["images_id"]]);

        if (count($ds) > 0) {
            $r .= \ins::_eng()->_get_plgin("plg_ins_images_slideshow", [
                "cat_id" => $d["images_id"], "pages" => "circle"
            ]);
        }


        if ($d["image"] != "") {

            $img = '<div class="content_item_img  _h_bg  " style="padding:20px"><img src="' . \ins::_app_map()->upload_folder . $d["image"] . '" /></div>';
        }


        if ($d["images_id"] != "" && $d["images_id"] != "0") {
            $o["cat_id"] = $d["images_id"];
            $o["theme"] = "light_box_gallery";
            $img = \ins::_eng()->_get_plgin("plg_ins_images_slideshow", $o);
        }



        return  ins::_ui()->_data(
            [
                "start" => ["class" => "  content_item_data "],
                "div" => ["class" => "", "data" => $img],
                "h4" => ["class" => " content_item_title", "data" => $d["title"]],
                "div-des" => ["class" => "   content_item_des   ", "data" => $d["des"]],
                "div-body" => ["class" => "   content_item_body   ", "data" => $d["body"]],

                "end" => []
            ]
        )->_render();
    }




    function _bc($rq, $putthis = false)
    {

        if ($rq["cat_id"] != "0") {
            $d = \ins::_db()->_get_row("sys_content_categories", "*",  "id='{$rq["cat_id"]}'");

            $udata[] =["type" => "strat", "class" => "ins_grid ins_light  _plg_conent_bc"];
            $udata[] =
            ["type" => "li",  "class" => "_plg_conent_cat_data ins_col_2  _" . $d["cat_id"],    "data-cat_id" => $d["id"], "data" =>  $d["title"]];

            if ($putthis == true) {
                $udata[] =
                    ["type" => "li",  "class" => "_plg_conent_cat_data ins_col_2  _" . $rq["cat_id"],    "data-cat_id" => $rq["id"], "data" =>  $rq["title"]];
            }
           

                $udata[] =["type" => "end"];


            return  \ins::_ui()->_data($udata)->_render();
        }
    }

    function _category($rq)
    {
        $cdata = \ins::_db()->_get_row("sys_content_categories", "*",  "id='{$rq["cat_id"]}'");
        \ins::_data()->_update_language($cdata);

        $uidata = [
            "start" => ["class" => "ins_grid", "style" => "padding:20px"],
            ["type" => "div", "class" => "ins_col_12", "style" => "text-align: left;",  "data" => plg_conent::_bc($cdata)],


            "h2" => ["class" => "ins_col_12",    "data" => $cdata["title"]],
            ["type" => "div", "class" => "ins_col_12", "style" => "padding:20px;text-align: center;",  "data" => plg_conent::_get_categories($rq)],
            ["type" => "div", "class" => "ins_col_12", "style" => "padding:20px;text-align: center;",   "data" => plg_conent::_get_items($rq)],
            "end" => [],

        ];

        return ins::_ui()->_data($uidata)->_render();
    }

    function _item($rq)
    {


        $cdata = \ins::_db()->_get_row("sys_content_categories", "*",  "id='{$rq["cat_id"]}'");
        \ins::_data()->_update_language($cdata);

        $uidata = [
            "start" => ["class" => "ins_grid", "style" => "padding:20px"],
            ["type" => "div", "class" => "ins_col_12", "style" => "text-align: left;",  "data" => plg_conent::_bc($cdata, true)],


            "h2" => ["class" => "ins_col_12",    "data" => $cdata["title"]],
            ["type" => "div", "class" => "ins_col_12", "style" => "padding:20px;text-align: center;",  "data" => plg_conent::_get_item($rq)],
            "end" => [],

        ];

        return ins::_ui()->_data($uidata)->_render();
    }
    function _out()
    {
        $this->_include("my_style.css");
        $this->_include("my_script.js");

        $this->_render = $this->_category($this->_pro);

        return ins::_ui()->_data(
            [
                "div" => [
                    "data-_myname" => $this->_myname,
                    "data-_myPath" => $this->_myPath,
                    "class" => "plg_conent_data", "data-_lang" => ins::_eng()->_this_lang,
                    "data" => $this->_render
                ]
            ]
        )->_render();
    }
}
