<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mod_menu
 *
 * @author ismail
 */

/*
  (
    [type] =&gt; plugin
    [data] =&gt; plg_ins_chat
    [pclass] =&gt; ins_col_12
    [from_type] =&gt; user
    [from_id] =&gt; 6
    [from_user_type] =&gt; com_school_subjects
    [area] =&gt; root
    [chat_type] =&gt; message
    [to_type] =&gt; user
    [to_id] =&gt; 4
    [to_user_type] =&gt; com_school_teachers
    [name] =&gt; 1
    [plg_name] =&gt; plg_ins_chat
    [plg_area] =&gt; root
    [plg_path] =&gt; /ins_plgs/plg_ins_chat
)

*/
class plg_ins_chat extends ins_plg
{
    var $_get;
    var $_out;
    public function __construct($data)
    {
        parent::__construct($data);
        $this->_get = \lib::_eng()->_get();
    }

    var $h;
    var $path = [];


    function _save_message($rq)
    {
        \ins::_db()->_insert("plg_chat", $rq);
        return plg_ins_chat::ui_main_chat_body($rq);
    }

    function _plg_ins_chat_messages($rq)
    {
        return plg_ins_chat::ui_main_chat_body($rq);
    }

    function _user_ui($rq, $only_image = false)
    {

        $fdata =  ins::_db()->_get_row($rq["type"], "*", "id='{$rq["id"]}'");
        if (isset($fdata["name"]) && $fdata["name"] != "") {
            $fdata["title"] = $fdata["name"];
        }

        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
        $uidata[] = ["type" => "img", "data" => $fdata["image"], "style" => "height:50px;width:50px", "class" => " ins_circle_tiny",];
        if (!$only_image) {
            $uidata[] = ["type" => "h4", "data" => $fdata["title"], "class" => "ins_col_8", "style" => "align-items: start;"];
        }
        $uidata[] = ["type" => "end"];
        return   \ins::_ui()->_data($uidata)->_render();
    }

    function _from_ui()
    {
        return   $this->_user_ui(["type" => $this->_pro["from_user_type"], "id" => $this->_pro["from_id"]]);
    }
    function _to_ui()
    {

        return   $this->_user_ui(["type" => $this->_pro["to_user_type"], "id" => $this->_pro["to_id"]]);
    }


    function ui_main_chat_top()
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
        $uidata[] = ["type" => "div", "class" => "ins_col_6", "data" => $this->_from_ui()];
        $uidata[] = ["type" => "div", "class" => "ins_col_6", "data" => $this->_to_ui()];

        $uidata[] = ["type" => "end"];
        return   \ins::_ui()->_data($uidata)->_render();
    }

    function ui_main_chat_body($rq)
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid_24", "style" => "align-items: start;"];
        $w = " chat_type='{$rq["chat_type"]}'  and (
            ( from_id='{$rq["from_id"]}' 
            and  from_type='{$rq["from_type"]}'  and  from_user='{$rq["from_user"]}' and  from_user_type='{$rq["from_user_type"]}'
            and  to_user='{$rq["to_user"]}'  and  to_id='{$rq["to_id"]}' and  to_type='{$rq["to_type"]}' and  to_user_type='{$rq["to_user_type"]}')
            or
            (
                from_id='{$rq["to_id"]}' and  from_type='{$rq["to_type"]}'   and  from_user='{$rq["to_user"]}'  and  from_user_type='{$rq["to_user_type"]}'  
                and  to_user='{$rq["from_user"]}'  and  to_id='{$rq["from_id"]}' and  to_type='{$rq["from_type"]}' and  to_user_type='{$rq["from_user_type"]}')
            ) order by `id` ";
        $data = \ins::_db()->_get_data("plg_chat", "*", $w);

        foreach ($data as $d) {
            if ($d["from_id"] == $rq["from_id"] &&  $d["from_type"] == $rq["from_type"] &&  $d["from_user_type"] == $rq["from_user_type"]) {
                $is_from_me = true;
            } else {
                $is_from_me = false;
            }
            $umessage = "<span class='plg_chat_message_user'>" . plg_ins_chat::_user_ui(["type" =>  $d["from_user_type"], "id" =>  $d["from_id"]], true) . "</span>";
            $ttch = "";
            if ($d["attachment"]) {



                $t = "<i class='fas fa-paperclip'></i>";

                $path = "/ins_upload/{$d["attachment"]}";


                if (ins::_data()->_is_image($path)) {
                    $t = "<img style='max-width: 80px;
                    max-height: 80px;' src='$path' />";
                }
                $ttch = "<a target='_blank' style='font-size: 37px;
                margin: 0 10px;' href='$path'> $t</a>";
            }




            if ($is_from_me) {
                $uidata[] = ["type" => "div", "data" =>  $ttch . $umessage . $d["message"], "class" => "ins_col_12 plg_chat_message_from_user ins_dark"];
                $uidata[] = ["type" => "div", "class" => "ins_col_10", "style" => ""];
            } else {
                $uidata[] = ["type" => "div", "class" => "ins_col_10", "style" => ""];
                $uidata[] = ["type" => "div", "data" =>  $ttch . $d["message"] . $umessage, "class" =>   "ins_col_12 plg_chat_message_to_user ins_dark"];
            }
            $uidata[] = ["type" => "div", "class" =>   "ins_col_24 ins_dark ", "style" => "opacity: 0.1;height: 1px;margin: 15px 0;"];
        }
        $uidata[] = ["type" => "end"];
        return  \ins::_ui()->_data($uidata)->_render();
    }

    function ui_main_chat_bottom()
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;"];
       $uidata[] = [
            "type" => "span",
            "data" => ' 
            <i class="fas ins_icon_button fa-microphone-alt"></i>',"style"=>"    text-align: CENTER;", "class" => "  ins_col_1"
        ];

        $uidata[] = [
            "type" => "ajax_upload_file", "name" => "upload",
            "class" => "fileuploadwe", "data-path" => "chat_attachments",
            "ondelete"=>"on_attchment_delete",
            "data-oncomplete" => "on_attchment_upload","icon" => '<i  style="  " class="fas attachfile  ins_icon_button fa-paperclip"></i> '
        ];

        $uidata[] = ["type" => "div", "contenteditable" => "true",   "pclass" => "ins_col_9 plg_chat_message ins_light"];
        $uidata["plg_chat_btn_save_message"] = [
            "type" => "span",
            "style" => "line-height: 26px;font-size: 22px;",
            "data" => ' <i  style="  margin: 0 16px;" class="fas ins_icon_button fa-paper-plane"></i>',
            "class" => "ins_col_1 plg_chat_btn_save_message"
        ];


        $pp = $this->_pro;

        unset($pp["name"]);
        unset($pp["path"]);
        unset($pp["area"]);

        unset($pp["plg_name"]);
        unset($pp["plg_path"]);
        unset($pp["plg_area"]);
        unset($pp["type"]);
        unset($pp["data"]);



        foreach ($pp as $k => $v) {

            $uidata["plg_chat_btn_save_message"]["data-$k"] = $v;
        }

        $uidata[] = ["type" => "end"];
        return \ins::_ui()->_data($uidata)->_render();
    }

    function ui_main_chat()
    {
        $uidata[] = ["type" => "start", "class" => "ins_grid", "style" => "align-items: start;min-height:450px"];
        $uidata[] = ["type" => "div", "class" => "ins_col_12 plg_chat_ui_top ins_dark",  "data" => $this->ui_main_chat_top()];
        $uidata["plg_chat_ui_min"] = ["type" => "div", "class" => "ins_col_12 plg_chat_ui_min ins_light",  "data" => $this->ui_main_chat_body($this->_pro)];
        $uidata[] = ["type" => "div", "class" => "ins_col_12 plg_chat_ui_bottom ins_dark",  "data" => $this->ui_main_chat_bottom()];
        $uidata[] = ["type" => "end"];


        $pp = $this->_pro;

        unset($pp["name"]);
        unset($pp["path"]);
        unset($pp["area"]);

        unset($pp["plg_name"]);
        unset($pp["plg_path"]);
        unset($pp["plg_area"]);
        unset($pp["type"]);
        unset($pp["data"]);



        foreach ($pp as $k => $v) {

            $uidata["plg_chat_ui_min"]["data-$k"] = $v;
        }
        $this->_out = \ins::_ui()->_data($uidata)->_render();
    }

    function _out()
    {
        if (isset($this->_pro["import_file_only"])) {
            $this->_include("mystyle.css");
            $this->_include("my.js");


            return "";
        } else {
            $this->ui_main_chat();
            return ins::_ui()->_data(
                [
                    "div" => [
                        "data-_myname" => $this->_myname,
                        "data-_myPath" => $this->_myPath,
                        "class" => "plg_chat_data ", "data-_lang" => ins::_eng()->_this_lang,
                        "data" => $this->_out
                    ]
                ]
            )->_render();
        }
    }
}
