<!DOCTYPE html>
<?php
/* @var $tmp \ins_lib\bp\ins_template */
?>
<html>
    <head>
        <link rel="dns-prefetch" href="//fonts.googleapis.com" /><link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat%3A400%2C700%7CPT+Sans%3A400%2C700%2C400italic%2C700italic%7CMontserrat%3A700%7CPT+Sans%3A700%2C400" />
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link href="<?= $tmp->_url_full ?>/css/layout.css" rel="stylesheet" type="text/css"/>


        <?= $tmp->_header ?>
        <script src="<?= $tmp->_url_full ?>/js/script.js" type="text/javascript"></script>

        <link   href="<?= $tmp->_url_full ?>/css/phone.css" rel="stylesheet" type="text/css" media="only screen and (min-width: 0px) and (max-width: 800px)" />

        <link   href="<?= $tmp->_url_full ?>/css/phone-<?= $this->__eng->_this_lang ?>.css" rel="stylesheet" type="text/css" media="only screen and (min-width: 0px) and (max-width: 800px)" />

        <title><?= $tmp->_title ?></title>

        <script>


            $(function () {
                var url = "<?= $_SERVER['REQUEST_URI'] ?>";
                url = url.replace("/site/ar", "");
                url = url.replace("/site/en", "");


                $("._27 a ").click(function () {


                    var attr = $(this).attr("href");
                    attr = attr.replace("/home/", url);
                    window.location = attr;

                    return false;
                })

            })
        </script>
    </head>
    <body  <?= $tmp->_body_tag ?> >  
        <!--smenu-->
        <section class=' body <?= $tmp->_is_home ? "home" : ""; ?> '>
            <header>   
                <div class='menu_bt'> <i class="fa fa-bars" aria-hidden="true"></i></div>

                <div class='inner_data container'>
                    <div class='logo toleft '>
                        <a href='/<?= $_GET["site"] ? "site/" . $_GET["site"] . "/" : "" ?>'> <img src="<?= $tmp->logo ?>"/> </a>
                    </div>   
                    <div class='module header'>
                        <?= $tmp->_module("header") ?> 
                    </div>   
                </div>
            </header>
            <section class='content-page main_data '>
                <div class='inner_data'>
                    <div class='module toleft left_data'>
                        <?= $tmp->_module("left") ?>
                    </div>
                    <div class='mid_data'>
                        <?php if ($tmp->_is_home != true) { ?>
                            <h1 class="ins_mian_title title_bar  h1" name="h1"><span>
                                    <span class='_title'><?= $tmp->_title ?></span> 
                                    <span class='sub_title'><?= $tmp->_inner_title ?></span> 

                                </span> 
                            </h1>
                        <?php } ?>
                        <div class='module top'>
                            <?= $tmp->_module("top") ?> 
                        </div>
                        <div class='module container  mian-top'>
                            <?= $tmp->_module("mian-top") ?> 
                        </div>
                        <div class='main '>

                            <?php if ($tmp->_is_home != true) { ?>
                                <?= $tmp->_main ?>
                            <?php } ?>
                        </div>
                        <div class='module container  mian-bottom'>
                            <?= $tmp->_module("mian-bottom") ?> 
                        </div>
                        <div class='module bottom'>
                            <?= $tmp->_module("bottom") ?> 
                        </div>
                    </div>
                    <div class='module toright right_data'>
                        <?= $tmp->_module("toright") ?>
                    </div>
                </div>
            </section>
            <footer class='drak'>
                <div class='inner_data container'>
                    <div class='module follow '> <div class='container'>
                        <?= $tmp->_module("follow") ?>
   </div> 
                    </div>  

                    <div class='module footer '>        <div class='container'>
                            <?= $tmp->_module("footer") ?>
                        </div>
                    </div>       
                </div>
            </footer>
            <div class='copy_right module'>   
                <div class='container'>
                    <?= $tmp->_module("copy_right") ?></div>
            </div>
        </section>
    </body>
</html>


