<?php


class Farmer
{

    public function __construct()
    {
    }

    static function getContracts($request)
    {
        $qdata = \ins::_db()->_get_query("select com_moz_farmer_contracts.*,com_moz_crops.image
        from com_moz_farmer_contracts join 
        com_moz_crops on  com_moz_farmer_contracts.fk_crops_id =com_moz_crops.id where 
        com_moz_farmer_contracts.fk_farmer_id ={$request["obj_id"]}
        ");
        foreach ($qdata as $k => $q) {
            $sum = \ins::_db()->_get_row("com_moz_crop_deliveries", "sum(accepted_qty) as q", "`farmer_contract_id`={$q['id']} ");
            if (!is_array($sum) || $sum["q"] == null) {
                $sum["q"] = "0";
            }
            $qdata[$k]["delivered_qty"] =   $sum["q"];
            $qdata[$k]["accepted_qty"] =   $sum["q"];
        }
        \ins::_data()->_update_language_array($qdata, $request["lang"], true);
        return  Shared::unset_data($qdata);
    }

    static function updateContract($request)
    {

        \ins::_db()->_update("com_moz_farmer_contracts", $request, "id='{$request["contract_id"]}'");
        return  Farmer::getContracts($request);
    }

    static function getOpportunities($request)
    {
        $qdata = \ins::_db()->_get_query("select com_moz_farmer_opportunities.*,com_moz_crops.image,com_moz_crops.title,
        com_moz_crops.sys_languages  from   com_moz_farmer_opportunities  join 
        com_moz_crops on  com_moz_farmer_opportunities.fk_crops_id =com_moz_crops.id ");



        \ins::_data()->_update_language_array($qdata, $request["lang"], true);

        foreach ($qdata as $k => $v) {
            $w = " fk_farmer_opportunities_id='{$v["id"]}' and   fk_farmer_id='{$request["obj_id"]}'";
            $xqdata = \ins::_db()->_get_row("com_moz_farmer_opportunities_xref", "*", $w);
            if (!is_array($xqdata) || count($xqdata) < 1) {
                $qdata[$k]["join"] = "0";
            } else {
                $qdata[$k]["join"] = "1";
            }
        }

        \ins::_data()->_update_language_array($qdata, $request["lang"], true);


        return  Shared::unset_data($qdata);
    }

    static function jonOpportunity($request)
    {

        $w = " fk_farmer_opportunities_id='{$request["opportunity_id"]}' and   fk_farmer_id='{$request["obj_id"]}'";
        $qdata = \ins::_db()->_get_row("com_moz_farmer_opportunities_xref", "*", $w);
        if (!is_array($qdata) || count($qdata) < 1) {
            $request["fk_farmer_id"] = $request["obj_id"];
            $request["fk_farmer_opportunities_id"] = $request["opportunity_id"];
            $id = \ins::_db()->_insert("com_moz_farmer_opportunities_xref", $request);
            $qdata = \ins::_db()->_get_row("com_moz_farmer_opportunities_xref", "*", "id='{$id}'");
        }

        return   Farmer::getOpportunities($request);
    }

    static function getShippment($request)
    {
        $qdata = \ins::_db()->_get_query("select 
        com_moz_crop_deliveries.* ,  com_moz_farmer_contracts.price as price  from com_moz_crop_deliveries join 
        com_moz_farmer_contracts on  com_moz_farmer_contracts.id = com_moz_crop_deliveries.farmer_contract_id
        where farmer_contract_id='{$request["contract_id"]}'  and com_moz_crop_deliveries.status='accepted'  ");

        \ins::_data()->_update_language_array($qdata, $request["lang"], true);

        return  Shared::unset_data($qdata);
    }


    static function   scheduleUpdateStatus($request)
    {

        \ins::_db()->_update("com_moz_parent_schedule", ["status" => $request["status"], "reschedule_reason" => $request["reschedule_reason"]], "id='{$request["schedule_id"]}'");
        return   Farmer::get_schedule($request);
    }


    static  function new($req)
    {
        $id = \ins::_db()->_insert("com_moz_farmer", $req);
        $req["ex_data"] = '[{"object":"com_moz_farmer","id":"' . $id . '"}]';
        $req["title"] = $req["name"];
        $data["user"] = \ins::_db()->_insert("sys_users", $req);

        return  Farmer::Login($req);
    }


    static  function Login($req)
    {
        $data["user"] = \ins::_db()->_get_row("sys_users", "*", "phone='{$req['phone']}'");
        if (is_array($data["user"])) {
            $ex_data = json_decode($data["user"]["ex_data"], true);
            $data["framer"] = \ins::_db()->_get_row($ex_data[0]["object"], "*", "id='{$ex_data[0]["id"]}'");
            $data = array_merge($data, Farmer::getdata($data, $req));
        } else {
            $data = [];
            $data["error"] = "-1";
        }
        return    $data;
    }



    static function getfinnince($request)
    {
        $qdata = \ins::_db()->_get_query("select * from  com_moz_transaction_ledger    where
        
        ( com_moz_transaction_ledger.stakeholder1_id ={$request["obj_id"]} or
        com_moz_transaction_ledger.stakeholder2_id ={$request["obj_id"]} ) order by `date_time` DESC
        
        
        ");

        \ins::_data()->_update_language_array($qdata, $request["lang"], true);

        return  Shared::unset_data($qdata);
    }




    static function get_week_updateData($qdata, $request, $s = "")
    {


        if ($request["lang"] == null) {
            $request["lang"] = "ar";
        }

        $qdata["from_title"] = $qdata["days"][0];
        $qdata["to_title"] =  $qdata["days"][6];




        $schedule_parent   = \ins::_db()->_get_data("com_moz_parent_schedule", "*", "`fk_week_id`='{$qdata["id"]}' and 
         `obj_id`='{$request["obj_id"]}' and `obj_type`='{$request["obj_type"]}'   $s  ");



        if (count($schedule_parent) > 0) {

            $qdata["schedule_parent"] = $schedule_parent;

            foreach ($qdata["schedule_parent"] as $sk => $sd) {
                if (trim($sk) != "") {



                    $qdata["schedule_parent"][$sk]["schedule"] = \ins::_db()->_get_query("select 
                 com_moz_delivery_schedule.*,
                 com_moz_crops.image,com_moz_crops.title,com_moz_crops.sys_languages,
                com_moz_offtaker_stations.city as station_city,
                com_moz_offtaker_stations.name as station_name,  com_moz_offtaker_stations.sys_languages as  station_sys_languages,
                com_moz_offtaker.company_name as offtaker_company_name,  com_moz_offtaker.sys_languages as  offtaker_sys_languages
                from com_moz_delivery_schedule
                join  com_moz_crops on  com_moz_delivery_schedule.fk_crops_id = com_moz_crops.id 
                join  com_moz_offtaker_stations  on  com_moz_delivery_schedule.fk_offtaker_stations_id = com_moz_offtaker_stations.id 
                join  com_moz_offtaker  on  com_moz_delivery_schedule.fk_offtaker_id = com_moz_offtaker.id 
           
                where " . \ins::_data()->_db_create_where_to_group($sd["id"], "fk_parent_schedule_ids"));

                    foreach ($qdata["schedule_parent"][$sk]["schedule"] as $k => $d) {


                        $accepted_qty =  "0";
                        if ($d["status"] == "delivered" && $d["fk_crop_deliveries_id"] != "0") {

                            $dl =  \ins::_db()->_get_row("com_moz_crop_deliveries", "*", "id='{$d["fk_crop_deliveries_id"]}'");
                            $accepted_qty = $dl["accepted_qty"];
                        }

                        $d["accepted_qty"] = $accepted_qty;
                        $d["farmer_name"] = \ins::_db()->_get_row(
                            "com_moz_farmer",
                            "name",
                            "id ='{$d["fk_farmer_id"]}'"
                        )["name"];


                        $qdata["schedule_parent"][$sk]["schedule"][$k] = $d;
                    }



                    $s = $qdata["schedule_parent"][$sk]["schedule"];
                    \ins::_data()->_update_language_array($s, $request["lang"], true);
                    // \ins::_data()->_update_language_array($s, $request["lang"], true, "sys_languages", "station_");
                    \ins::_data()->_update_language_array($s, $request["lang"], true, "sys_languages", "offtaker_");
                    $qdata["schedule_parent"][$sk]["schedule"] = $s;
                } else {


                    unset($qdata["schedule_parent"][$sk]);
                }
            }
        }

        return $qdata;
    }


    static function get_schedule($request)
    {
        $data["current_week"]  =  \ins::_data()->_datetime()->_week_information("this week");
        $data["next_week"] =  \ins::_data()->_datetime()->_week_information("next week");
        $data["current_week"] =  Farmer::get_week_updateData($data["current_week"], $request, "  and `status`='accepted'");
        $data["next_week"] =  Farmer::get_week_updateData($data["next_week"], $request, " and `status`<>'reschedule' and  `status`<>'draft' and  `status`<>''  ");

        return  Shared::unset_data($data);
    }







    static  function getdata($data, $req)
    {
        $req["obj_id"] = $data["framer"]["id"];
        $req["obj_type"] = "com_moz_farmer";

        $data["opportunities"]  = Farmer::getOpportunities($req);
        $data["contracts"]  =  Farmer::getContracts($req);
        $data["deals"]  =  Shared::getDeals($req);




        $data["videos"]  =  Shared::getVideos($req);
        $data["content"]  =  Shared::getContent($req);
        $data["supports"]  =  Shared::getSupports($req);
        $data["finance"]  =  Farmer::getfinnince($req);
        $data["schedule"]  =  Farmer::get_schedule($req);





        return   $data;
    }
}
