<?php


class Player
{

    public function __construct()
    {
    }


    function get_player_data_by_user_id($data)
    {
        $user_data = \ins::_db()->_get_row("sys_users", "*", "id ='{$data["id"]}'");


        $ex_data = \ins::_db()->_get_row("com_htrk_players", "*",  "id ='{$user_data["ex_id"]}'");
        return array_merge($user_data, $ex_data);
    }


    function get_player_data_by_player_id($data)
    {

        $ex_data = \ins::_db()->_get_row("com_htrk_players", "*",  "id ='{$data["id"]}'");

        $user_data = \ins::_db()->_get_row("sys_users", "*", "ex_table ='com_htrk_players' and ex_id ='{$ex_data["id"]}'");
        return array_merge($user_data, $ex_data);
    }

    function get_videos($data)
    {
        $qdata = \ins::_db()->_get_query("select com_htrk_videos.title, com_htrk_videos.sys_languages,com_htrk_videos.video_tag , com_htrk_videos.video_url ,com_htrk_videos.id 
             ,com_htrk_videos.image  , com_htrk_players.image as player_image ,com_htrk_players.first_name  as player_first_name , 
             com_htrk_players.last_name  as player_last_name from com_htrk_videos join com_htrk_players on  com_htrk_players.id =com_htrk_videos.player_id where  com_htrk_videos.player_id='{$data["player_id"]}'");
        foreach ($qdata as $k => $v) {
            $qdata[$k]["likes"] = \ins::_files()->_json()->_count_value_by_durationt("video_{$v["id"]}", "likes");
            $qdata[$k]["views"] = \ins::_files()->_json()->_count_value_by_durationt("video_{$v["id"]}", "views");
            $qdata[$k]["likes_data"] = \ins::_files()->_json()->_get_value_by_durationt("video_{$v["id"]}", "likes");
            $qdata[$k]["views_data"] = \ins::_files()->_json()->_get_value_by_durationt("video_{$v["id"]}", "views");
        }

        return  Player::unset_data($qdata);
    }

    function get_views_and_likes($PlayerVideos)
    {
        $r = [];
        $r["views_player_count"] = 0;
        $r["views_club_count"] = 0;
        $r["likes_player_count"] = 0;
        $r["likes_club_count"] = 0;

        foreach ($PlayerVideos as $k => $v) {
            foreach ($v["views_data"] as $vids) {
                $count = count(array_filter($vids, function ($a) {
                    return strpos($a, "p") !== false;
                }));
                $r["views_player_count"] +=    $count;
                $r["views_club_count"] +=   count($vids) -  $count;
            }
            foreach ($v["likes_data"] as $vids) {
                $count = count(array_filter($vids, function ($a) {
                    return strpos($a, "p") !== false;
                }));
                $r["likes_player_count"] +=    $count;
                $r["likes_club_count"] +=   count($vids) -  $count;
            }
        }

        return $r;
    }

    /**
     * $req[player_id, where ="" ,status=invite]
     */
    function is_player_have_status($req)
    {
        $req["where"] = $req["where"] ?  $req["where"]  :  "1=1";
        $req["status"] = $req["status"] ?  $req["status"]  :  "invite";
        $r = false;
        $w =  "{$req["where"]}";
        $w .= $req["player_id"] ?  " and `player_id` ='{$req["player_id"]}' " : "";

      



        $com_htrk_clubs_payers = \ins::_db()->_get_data("com_htrk_clubs_players", "*", $w);


        foreach ($com_htrk_clubs_payers as $com_htrk_clubs_payer) {
            $statuses =  json_decode($com_htrk_clubs_payer["player_status"], true);


            foreach ($statuses  as $status) {

                if (isset($req["date_offest"])){
                $remove_end_date = strtotime($status["data"] . "+" . $req["date_offest"]. " day");
            }

                if (
                    (!isset($req["date_offest"]) &&  $status["status"] == $req["status"])
                   || (isset($req["date_offest"]) &&  $remove_end_date > strtotime("now") && $status["status"] == $req["status"])
                ) {
                    return  true;
                    break;
                }
            }
        }
        return $r;
    }



    function get_players_act_status($player_status)
    {




        $status = json_decode($player_status, true);
        $r = [];
        foreach ($status as $s) {
            if ($s["active"] == "1") {
                $r = $s;
            }
        }
        return $r;
    }




    function get_players_video($req)
    {



  
        $sqdata = \ins::_db()->_get_query("select com_htrk_videos.id,com_htrk_videos.video_url,com_htrk_videos.title  ,com_htrk_videos.image  ,com_htrk_players.id  as player_id
        ,com_htrk_players.dob  , com_htrk_players.position ,com_htrk_players.enrolled ,com_htrk_videos.video_tag ,  com_htrk_players.city , com_htrk_players.area , com_htrk_players.recommendation
        , com_htrk_players.image as player_image ,com_htrk_players.first_name  as player_first_name , com_htrk_players.last_name  as player_last_name 
        from com_htrk_videos join com_htrk_players on  com_htrk_players.id =com_htrk_videos.player_id where  com_htrk_videos.id = {$req["id"]} ORDER BY com_htrk_videos.sys_created DESC ");

        $qdata = $sqdata[0];

        $qdata["row_type"] = "video";

        $qdata["likes"] = \ins::_files()->_json()->_count_value_by_durationt("video_{$req["id"]}", "likes");
        $qdata["views"] = \ins::_files()->_json()->_count_value_by_durationt("video_{$req["id"]}", "views");
        $qdata["likes_data"] = \ins::_files()->_json()->_get_value_by_durationt("video_{$req["id"]}", "likes");
        $qdata["views_data"] = \ins::_files()->_json()->_get_value_by_durationt("video_{$req["id"]}", "views");


        if (Player::is_player_have_status(["player_id" => $qdata["player_id"]])) {

            $qdata["invited"] = "1";
        } else {
            $qdata["invited"] = "0";
        }

        
        $r = Player::unset_data([$qdata])[0];

        return $r;
    }

    function get_message($req)
    {

        $qdata = \ins::_db()->_get_data("com_htrk_messags", "*", \ins::_data()->_db_get_form_group("p{$req["player_id"]}", "`to`")  ." ORDER BY sys_created DESC ");

        $j = $req["j"];

        foreach ($qdata  as $k => $v) {
            if ($j["PlayerClubsLastSeen"] != "" &&   strtotime($v["sys_created"]) > strtotime($j["PlayerClubsLastSeen"])) {
                $qdata[$k]["seen"] = "0";
            } else {
                $qdata[$k]["seen"] = "1";
            }
        }


        return  Player::unset_data($qdata);
    }

    function unset_data($ds)
    {
        $nuf = ["sys_order", "sys_deleted", "sys_modified", "sys_disabled", "sys_languages"];

        if (is_array($ds)) {
            foreach ($ds as $k => $v) {
                foreach ($nuf as $f) {
                    unset($ds[$k][$f]);
                }
            }
        }
        return $ds;
    }

    function  updateRankData(&$data)
    {


        $pid = "p{$data["ex_data"]["id"]}";
        $score = 0;

        foreach ($data["player_videos"]  as $player_views) {
            $score += $player_views["views"];
            $score += $player_views["likes"] *  3;
        }

        $score +=  count($data["player_status"]) * 10;

        if (!\ins::_files()->_json()->_check_duration("ranks")) {
            $oldata = \ins::_files()->_json()->_get_data("ranks");
            $newdur = \ins::_files()->_json()->get_dur();
            $oldata[$newdur] = end($oldata);
            \ins::_files()->_json()->_file_put("ranks.json", $oldata);
        }
        \ins::_files()->_json()->_add_by_duration("ranks", $pid, "score", $score);

        $re =  Player::updateRanks();

        $data["ex_data"]["score"] = $re[$pid]["score"];
        $data["ex_data"]["rank"] = $re[$pid]["rank"];
    }

    function updateRanks()
    {

        $data = \ins::_files()->_json()->_get_data("ranks");

        $key = end(array_keys($data));

        $l = $data[$key];

        foreach ($l  as $k => $v) {
            $l[$k]["key"] = $k;
        }

        usort($l, function ($a, $b) {
            return  $b['score'] <=> $a['score'];
        });

        $e = [];
        foreach ($l  as $k => $v) {
            $v["rank"] = $k + 1;
            $k = $v["key"];
            unset($v["key"]);
            $e[$k] = $v;
        }


        $data[$key] = $e;
        \ins::_files()->_json()->_file_put("ranks.json", $data);

        return $data[$key];
    }

    function get_player_status($data)
    {


        $w = " com_htrk_clubs_players.player_id='{$data["player_id"]}' ";
        $qdata = \ins::_db()->_get_query("select com_htrk_clubs.*,com_htrk_clubs_players.id as status_id,com_htrk_clubs_players.player_status,com_htrk_clubs_players.player_action from com_htrk_clubs_players join com_htrk_clubs  on  com_htrk_clubs.id=com_htrk_clubs_players.clube_id  where {$w} ");


        $j = $data["j"];

        foreach ($qdata as $k => $v) {
            $player_status =  json_decode($v["player_status"], true);
            $qdata[$k]["seen"] = "1";

            $f = false;
            foreach ($player_status as $sk => $sv) {

                if ($j["PlayerClubsLastSeen"] != "" &&  $sv["active"] == "1" && $sv["action"] != "saved" && strtotime($sv["data"]) > strtotime($j["PlayerClubsLastSeen"])) {
                    $qdata[$k]["seen"] = "0";
                }
                if ($sv["followup"] == "start") {
                    $f = true;
                    break;
                }
            }
            if ($f) {

                $qdata[$k]["followup"] = Player::get_follow_up(["status" => $v["status_id"]]);
            } else {
                $qdata[$k]["followup"] = false;
            }
        }



        return  Player::unset_data($qdata);
    }

    function get_follow_up($request)
    {


        $days = 3;
        $r = "";
        $w = "status='{$request["status"]}'";
        $data = \ins::_db()->_get_row("com_htrk_followup", "*", $w);

        if (is_array($data)) {
            $fdata = json_decode($data["data"], true);
            $e = end($fdata);
            $origin = date_create($e["action_data"]);
            $target = new DateTime("now");

            if ($origin->diff($target)->format("%a") >= $days && $data["closed"] != "1") {
                $r = $e;
            } else {
                $r = false;
            }
        } else {
            $r = ["action" => "start"];
        }

        return $r;
    }
    function update_follow_up($request)
    {
        global $request;
        $w = "status='{$request["status"]}' ";
        $data = \ins::_db()->_get_row("com_htrk_followup", "*", $w);

        $fdata = [];
        $r = [];
        if (is_array($data)) {
            $v = [];
            $v["action"] = $request["action"];
            $v["action_data"] = \lib::_data()->_datetime->_craeteDBDateTime();
            $fdata = json_decode($data["data"], true);
            $fdata[] = $v;

            $sqlupdata = ["data" => json_encode($fdata)];

            if (isset($request["close"]) && $request["close"] == "1") {
                $sqlupdata["closed"] = "1";
            }

            $data = \ins::_db()->_update("com_htrk_followup", $sqlupdata, $w);
            $r["op"] = ["updated"];
            $r["status"] = "success";
        } else {

            $v["action"] = $request["action"];
            $v["action_data"] = \lib::_data()->_datetime->_craeteDBDateTime();
            $fdata[] = $v;

            $sqlupdata = ["data" => json_encode($fdata), "status" => $request["status"]];

            if (isset($request["close"]) && $request["close"] == "1") {
                $sqlupdata["closed"] = "1";
            }


            $data = \ins::_db()->_insert("com_htrk_followup", $sqlupdata);
            $r["op"] = ["insert"];
            $r["status"] = "success";
        }


        return  $r;;
    }

    function get_points($request)
    {

        $r["sumpoint"] = \ins::_db()->_get_row("com_htrk_player_questions", "sum(points) as spoint", "player_id='{$request["player_id"]}'")["spoint"];
        $r["lastdate"] = \ins::_db()->_get_row("com_htrk_player_questions", "max(sys_created) as max_sys_created", "player_id='{$request["player_id"]}'")["max_sys_created"];


        return $r;
    }

    function notifications($request)
    {
        $j = \ins::_files()->_json()->_file_get("user{$request["user_id"]}.json");

        $w = ' json_contains(com_htrk_notifications.to ,\'{"id":"' . $request["user_id"] . '"}\')  and `date`<="' . ins::_timedate()->_now() . '" order by `date` DESC';
        $qdata = \ins::_db()->_get_query("select 
        sys_notifications_templates.title, sys_notifications_templates.body,sys_notifications_templates.sys_languages,
        com_htrk_notifications.date, com_htrk_notifications.lang 
        from com_htrk_notifications join sys_notifications_templates  on  sys_notifications_templates.id=com_htrk_notifications.template 
        where {$w}  ");
        foreach ($qdata  as $k => $v) {

            $l = json_decode($v["lang"], true);
            $qdata[$k] = \lib::_data()->_lang_trans($v, $l);

            if (strtotime($v["date"]) > strtotime($j["PlayerNotificationsLastSeen"])) {
                $qdata[$k]["seen"] = "0";
            } else {
                $qdata[$k]["seen"] = "1";
            }
        }
        return  Player::unset_data($qdata);
    }

    function competitions($request)
    {


        $date = $request["j"]["PlayerCompetitionsLastSeen"];
        $data = \ins::_db()->_get_row("com_htrk_competitions", "*", " sys_created > '$date'");
        if (is_array($data)) {
            $data["seen"] = "0";
        }else{
            $data["seen"] = "1";
        }
        $qdata[0] =$data;
        return  Player::unset_data($qdata);
    }
    function data($request)
    {
        $data = [];
        $ex_data = \ins::_db()->_get_row("com_htrk_players", "*", "id ='{$request["player_id"]}'");
        $user_data = \ins::_db()->_get_row("sys_users", "*", "ex_table ='com_htrk_players' and ex_id ='{$ex_data["id"]}'");

        $j = \ins::_files()->_json()->_file_get("user{$user_data["id"]}.json");


        $ds = ["PlayerNotificationsLastSeen", "PlayerClubsLastSeen", "PlayerNewsLastSeen", "PlayerCompetitionsLastSeen"];


        $u = false;
        foreach ($ds as $d) {
            if ($j[$d] == null || $j[$d] == "") {
                $j[$d] = ins::_timedate()->_now();
                $u = true;
            }
        }

        if ($u) {
            $j = \ins::_files()->_json()->_file_put("user{$user_data["id"]}.json", $j);
        }

        $request["user_id"]  = $user_data["id"];
        $request["j"]  = $j;
        $data["LastSeen"] = $j;
        $data["user_data"] = $user_data;
        $data["player_videos"] = Player::get_videos($request);
        $data["ex_data"] =  array_merge($ex_data, Player::get_views_and_likes($data["player_videos"]));
        $data["player_status"] = Player::get_player_status($request);

        $data["points"] = Player::get_points($request);
        $data["messages"] = Player::get_message($request);
        $data["json"] = \ins::_files()->_json()->_file_get("user{$user_data["id"]}.json");
        $data["notifications"] = Player::notifications(["user_id" => $user_data["id"]]);

        $data["competitions"] =  Player::competitions($request);

        $data["videos"] =  Shared::get_videos($request);
        $data["news"] =  Shared::get_news($request);
        $data["clubs"] =  Shared::get_clubs($request);


        Player::updateRankData($data);


        return  $data;
    }



}
