<?php

class com_calendar extends ins_com {

    public function __construct() {
        parent::__construct();
    }

    function _delete_event($rq) {

        ins::_db()->_delete("com_calendar", "id=" . $rq["id"]);
    }

    function _updateevent_save($rq) {

        ins::_db()->_update("com_calendar", $rq, "id=" . $rq["id"]);
    }

    function _addevent_save($rq) {

        ins::_db()->_insert("com_calendar", $rq);
    }

    function _editvent($rq) {

        $data = ins::_db()->_get_row("com_calendar", "*", "id=" . $rq["id"]);


        // $data["c_from"] = date("Y-m-d" . "T00:00");

        $data["c_from"] = ins::_data()->_datetime()->dateFromdb($data["c_from"], "Y-m-d\TH:i");
        $data["c_to"] = ins::_data()->_datetime()->dateFromdb($data["c_to"], "Y-m-d\TH:i");


        $uidata = [
            "start" => ["class" => "ins_grid"],
            "c_from" => ["input" => "true", "value" => $data["c_from"], "pclass" => "ins_col_6", "type" => "datetime-local", "title" => "From"],
            "c_to" => ["input" => "true", "value" => $data["c_to"], "pclass" => "ins_col_6", "type" => "datetime-local", "title" => "To"],
            "calendar_event_type" => ["value" => $data["calendar_event_type"], "input" => "true", "pclass" => "ins_col_12", "type" => "editable_select", "name" => "calendar_event_type", "title" => "Event"],
            "color" => ["value" => $data["color"], "input" => "true", "pclass" => "ins_col_12", "type" => "color", "name" => "color", "title" => "Event"],
            "icon" => ["value" => $data["icon"], "pclass" => "ins_col_12", "type" => "icon_input", "name" => "icon", "title" => "Event"],
            "des" => ["value" => $data["des"], "input" => "true", "pclass" => "ins_col_12", "type" => "textarea", "title" => "des", "style" => "height:100px;"],
            "button" => ["data-id" => $rq["id"], "class" => "ins_col_6 ins_button _calendar_update_event", "data" => "Update Event"],
            "button-delete" => ["data-id" => $rq["id"], "class" => "ins_col_6 ins_button _calendar_delete_event", "data" => "Delete Event"],
            "end" => []
        ];

        return ins::_ui()->_data($uidata)->_render();
    }

    function _addevent($rq) {


        $uidata = [
            "start" => ["class" => "ins_grid"],
            "c_from" => ["input" => "true", "value" => $rq["date"], "pclass" => "ins_col_6", "type" => "datetime-local", "title" => "From"],
            "c_to" => ["input" => "true", "value" => $rq["date"], "pclass" => "ins_col_6", "type" => "datetime-local", "title" => "To"],
            "calendar_event_type" => ["input" => "true", "pclass" => "ins_col_12", "type" => "editable_select", "name" => "calendar_event_type", "title" => "Event"],
            "color" => ["input" => "true", "pclass" => "ins_col_12", "type" => "color", "name" => "color", "title" => "Event"],
            "icon" => ["pclass" => "ins_col_12", "type" => "icon_input", "name" => "icon", "title" => "Event"],
            "des" => ["input" => "true", "pclass" => "ins_col_12", "type" => "textarea", "title" => "des", "style" => "height:100px;"],
            "button" => ["class" => "ins_col_12 ins_button _calendar_save_event", "data" => "add Event"],
            "end" => []
        ];

        return ins::_ui()->_data($uidata)->_render();
    }

    function _out() {


        $data = \ins::_db()->_get_data("com_calendar");





        foreach ($data as $d) {

            
            echo ins::_data()->get_ins_list("calendar_event_type", $d["calendar_event_type"])["text"];
            
            

            $mstyle = "";
            if ($d['color'] != "") {
                $mstyle.=' style="background:'.$d['color'].'" ';
                
            }

            $v = "<b  $mstyle class=\"ins_calendar_event_data\" data-id=\"" . $d['id'] . "\">" . $d["icon"] . " " . ins::_data()->get_ins_list("calendar_event_type", $d["calendar_event_type"])["text"] . "</b>";

            $cldata[] = [
                "from" => $d["c_from"],
                "to" => $d["c_to"],
                "text" => $v
            ];
        }






        $uidata = [
            "type" => "div",
            "data-cl" => json_encode($cldata), "class" => "mycal ins_calendar", "data" => "<span></span>"
        ];

        $this->_r = ins::_ui()->_data($uidata)->_render();
        return $this->_r;
    }

}
