<?php

class com_finance_pays extends ins_com
{
    public function __construct()
    {
        parent::__construct();
    }


    
    function _get_for_type($rq)
    {


        if ($rq["type"] == "dormitory") {
            $data = [
                "for_type" => [
                    "name" => "for_type[]",
                    "title" => 'dormitory',
                    "select_type" => "db", "select_table" => "com_school_dormitories", "style" => "height:100px",
                    "title-ar" => "التسكين", "type" => 'list', "pclass" => 'ins_col_12'
                ]
            ];
        } else if ($rq["type"] == "class") {
            $data = [
                "for_type" => [
                    "name" => "for_type[]",
                    "title" => 'class', "title-ar" => "الصف", "pclass" => 'ins_col_12', "style" => "height:100px",
                    "type" => 'list', "select_type" => "db", "select_table" => "com_school_classes"
                ]
            ];
        }


        if (isset($rq["id"])) {
            $dbdata  = \ins::_db()->_get_row("com_school_activities", "*", "id={$rq["id"]}");
            $data["for_type"]["value"] =  $dbdata["for_type"];
        }


        return  \ins::_ui()->_data($data)->_render();
    }

    function _out()
    {
       return  lib::_pages()->_get_class("admin", "com_school_activities")->_render();
    }
}
