<?php

class com_hr_finance extends ins_com
{
    public function __construct()
    {
        parent::__construct();
    }


    function _print_advan($rq)
    {
        $fdata = \ins::_db()->_get_row("com_hr_advance", "*", "id={$rq["id"]}");

        $fdata["user"] =  \ins::_db()->_get_row("com_hr_employees", "*", "id={$fdata["em_id"]}")["name"];

        $fdata["total"] = $fdata["value"];
        $f = new \NumberFormatter("ar", \NumberFormatter::SPELLOUT);
        $fdata["total_text"] = $f->format($fdata["total"]) . " جنيها لا غير ";
        $fdata["des"] = " - ";
        $_SESSION["f_pay_advb_print"] = $fdata;
    }

    function _salary_update_op($rq, $salary,  &$total, $op = "+", &$thtis_value = 0)
    {


        if ($rq["value_type"] == "fixed") {
            $es = $op .  $rq["value"];
        } else {
            $es =  $op .  ($salary * ($rq["value"] / 100));
        }

        $thtis_value = $es;
        $total += $es;
    }

    function _salary_update($rq)
    {
        $r_data = [];
        $month = $rq["month"] ? $rq["month"] : date("Y-m");

        $em_id =  $rq["em_id"];
        $data_employee = \ins::_db()->_get_row("com_hr_employees", "*", "id='$em_id'");

        /** 
slaary _op */
        $data = com_hr_finance::_get_date($rq);
        $deduction = json_decode($data["deduction"], true);
        $earning = json_decode($data["earning"], true);

        $r_data["salary"] =  $data_employee["salary"];
        $total =  $data_employee["salary"];


        foreach ($deduction as  $k => $v) {
            $deduction[$k]["title"] =  \ins::_db()->_get_row("com_hr_salary_component", "*", " id='{$v["id"]}' ")["title"];
            com_hr_finance::_salary_update_op($v, $r_data["salary"],  $total, "-");
        }
        foreach ($earning as  $k => $v) {
            $earning[$k]["title"] =  \ins::_db()->_get_row("com_hr_salary_component", "*", " id='{$v["id"]}' ")["title"];
            com_hr_finance::_salary_update_op($v, $r_data["salary"], $total);
        }

        $r_data["deductions"] = $deduction;
        $r_data["earnings"] = $earning;

        /** 
slaary  monthy_op */



        $mdeductions  = json_decode($data_employee["salary_deduction"], true);
        $mearnings = json_decode($data_employee["salary_earning"], true);

        $monthy_earnings = [];
        $monthy_deductions = [];

        foreach ($mdeductions as  $monthy_deduction) {
            $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $monthy_deduction]), true);

            $v = [
                "id" => $component_data["id"], "title" => $component_data["title"],
                "value" => $component_data["value"], "value_type" => $component_data["value_type"]
            ];
            $monthy_deductions["_" . uniqid()] =  $v;
            com_hr_finance::_salary_update_op($v, $r_data["salary"], $total, "-");
        }


        foreach ($mearnings as $monthy_earning) {

            $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $monthy_earning]), true);
            $v =  ["id" => $component_data["id"], "title" => $component_data["title"],  "value" => $component_data["value"], "value_type" => $component_data["value_type"]];

            $monthy_earnings["_" . uniqid()] =  $v;
            com_hr_finance::_salary_update_op($v, $r_data["salary"], $total);
        }

        $r_data["monthy_deductions"] = $monthy_deductions;
        $r_data["monthy_earnings"] = $monthy_earnings;
        /** slary monthy_op */

        /** 
slary advance_deductions 
         * */
        $advance_deductions = [];
        $data_advans = \ins::_db()->_get_data("com_hr_advance", "*", "em_id='$em_id'");



        foreach ($data_advans  as $d) {
            $av_data = json_decode($d["data"], true);
            $i = 0;
            foreach ($av_data  as $vd) {
                $i++;
                if ($vd["month"] == $month) {
                    $vd["title"] = " الدفعه " . "<strong>" . $i . "</strong>" . " من سلفه بتارخ " . "بتاريخ" . "<strong> " . \ins::_map()->_format("date", $d["date"]) . "  </strong>";
                    $vd["value_type"] = "fixed";
                    com_hr_finance::_salary_update_op($vd, $r_data["salary"], $total, "-");
                    $advance_deductions["_" . uniqid()] = $vd;
                }
            }
        }
        $r_data["advance_deductions"] = $advance_deductions;
        $c_status_id = \ins::_eng()->_isd()->_isd_get_status("accept", "id");


        /**
leavs_deductions
         */

        $sql = "select com_hr_leaves.*,com_isd_operations.isd_status,com_hr_leaves_types.paid from  
        com_hr_leaves INNER JOIN com_isd_operations ON  (com_isd_operations.isd_table='com_hr_leaves'  "
            . " and com_isd_operations.isd_table_id=com_hr_leaves.id and  com_hr_leaves.sys_deleted=0 "
            . " and com_hr_leaves.employee_id='" . $em_id . "' and com_isd_operations.isd_status= $c_status_id)
        INNER JOIN com_hr_leaves_types on(com_hr_leaves.leave_type=com_hr_leaves_types.id and com_hr_leaves_types.paid=0)

        ";

        $olddata = ins::_db()->_get_query($sql);

        $leavs_deductions = [];
        foreach ($olddata  as $l) {

            $l_number = 0;
            $from_month = \ins::_map()->_format("db_month", $l["from"]);
            $to_month = \ins::_map()->_format("db_month", $l["to"]);
            $to =  $l["to"];
            $from =  $l["from"];
            if ($rq["month"] == $from_month  && $from_month  == $to_month) {
                $l_number = ins::_data()->_datetime()->_diff($from, $to);
            } else if ($rq["month"] == $from_month) {
                $l_number = ins::_data()->_datetime()->_diff($from, \ins::_map()->_format("db_date", "last day of this month"));
                $to = \ins::_map()->_format("db_date", "last day of this month");
            } else if ($rq["month"] == $to_month) {
                $l_number = ins::_data()->_datetime()->_diff(\ins::_map()->_format("db_date", "first day of next month"), $to);
                $from = \ins::_map()->_format("db_date", "first day of next month");
            }

            if ($l_number > 0) {
                $day_salary =  $r_data["salary"] / 30;
                $l_ded = round(($l_number * $day_salary), 2);

                $vd["title"] = "  " . "<strong>" .  $l_number . "</strong>" . "     " . " أيام" . "
             من  <strong>" . \ins::_map()->_format("", $from) . " </strong>  الى <strong> " . \ins::_map()->_format("", $to) . "   </strong> ";
                $vd["value_type"] = "fixed";
                $vd["value"] =   $l_ded;
                com_hr_finance::_salary_update_op($vd, $r_data["salary"], $total, "-");
                $leavs_deductions["_" . uniqid()] = $vd;
            }
        }
        $r_data["leavs_deductions"] = $leavs_deductions;

        /**
leavs_deductions
         */




        $r_data["total"] = $total;


        /** slary advance_deductions */
        return  $r_data;
    }


    static function _summray_date($rq)
    {

        $ui_data = [];

        $rq["no_input"] = true;

        $data = com_hr_finance::_get_date($rq);
        $ui_data[] =  ["type" => "strat", "style" => "padding:25px", "class" => "ins_col_12 ins_grid salary_summray_print_date"];

        $data_employee = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$rq["em_id"]}'");


        if ($data["is_paid"] == "1") {

            $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid  ins_light", "style" => "padding:10px;"];
            $ui_data[] =  ["type" => "month", "value" => $data["month"], "input" => "true", "data-id" => $data["em_id"], "class" => "ins_col_12 get_summray_bymonth"];

            $ui_data[] =  ["type" => "h4",  "data" => "تم الدفع ", "class" => "ins_col_4 ins_text_tocenter ins_color_green"];


            $ui_data[] =  ["type" => "start", "class" => "ins_grid ins_col_6 ins_text_tocenter"];
            $ui_data[] =  ["type" => "div", "data" => "pay date", "data-ar" => "تاريخ الدفع  ", "class" => "ins_col_12"];
            $ui_data[] =  ["type" => "div",  "data" =>  $data["pay_date"], "class" => "ins_col_12"];
            $ui_data[] =  ["type" => "end"];

            $ui_data[] = ["type" => "i", "data-insaction" => "print_area", "data-area" => ".salary_summray_print_date",  "class" => "fas fa-print"];

            $ui_data[] =  ["type" => "end"];

            $ui_data[] =  ["type" => "h2", "data" => $data_employee["name"], "class" => "ins_col_12"];



            $ui_data[] =  ["type" => "div", "data" => com_hr_finance::_get_salary_summray($data, json_decode($data["summery"], true)), "class" => "  ins_col_12"];
        } else {



            $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid  ins_light", "style" => "padding:10px;"];
            $ui_data[] =  ["type" => "month", "value" => $data["month"], "input" => "true", "data-id" => $data["em_id"], "class" => "ins_col_12 get_summray_bymonth"];
            $ui_data[] =  ["type" => "h4",  "data" => "لم يتم الدفع بعد    ", "class" => "ins_col_8 ins_text_tocenter ins_color_red"];
            $ui_data[] =    [
                "type" => "i", "color:green !important",  "data-em_id" => $data["id"], "class" => "ins_salary_summray_pay ins_color_red fas  fa-credit-card",  "data-title" => "",

            ];
            $ui_data[] = ["type" => "i", "data-insaction" => "print_area", "data-area" => ".salary_summray_print_date",  "class" => "   fas fa-print"];
            $ui_data[] =  ["type" => "end"];
            $ui_data[] =  ["type" =>  "h2", "data" => $data_employee["name"], "class" => "ins_col_12"];
            $ui_data[] =  ["type" => "div", "data" => com_hr_finance::_get_salary_summray($rq), "class" => "ins_col_12 "];
        }



        $ui_data[] =  ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }



    function _get_salary_summray($rq, $s_data = null)
    {


        if ($s_data == null) {
            $s_data =  com_hr_finance::_salary_update($rq);
        }
        $salary = $s_data["salary"];
        $ui_data = [];
        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid"];

        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid sum_component_salary_salary"];
        $ui_data[] =  ["type" => "h4", "data" => "salary", "data" => "الراتب", "class" => "ins_col_10"];
        $ui_data[] =  ["type" => "span", "data" => $salary, "class" => "ins_col_2"];
        $ui_data[] =  ["type" => "end"];

        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid ins_light"];

        $ui_data[] =  ["type" => "h4", "data" => "Monthy deductions", "data" => "المستقطعات الشهرية", "class" => "ins_col_10"];

        if (count($s_data["monthy_deductions"]) > 0) {
            foreach ($s_data["monthy_deductions"] as $d) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $d, "-"));
            }
        } else {

            $ui_data[] =  ["type" => "h4", "data" => "adv", "data" => "no data ", "style" => "    text-align: center;
            font-weight: bold;", "class" => "ins_col_12 "];
        }

        $ui_data[] =  ["type" => "end"];



        $ui_data[] =  ["type" => "line"];




        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid"];

        $ui_data[] =  ["type" => "h4", "data" => "Monthy deductions", "data" => "المستقطعات ", "class" => "ins_col_10"];



        if (count($s_data["deductions"]) > 0) {
            foreach ($s_data["deductions"] as $d) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $d, "-"));
            }
        } else {
            $ui_data[] =  ["type" => "h4", "data" => "no data", "data" => "لا يوجد ", "style" => "    text-align: center;
            font-weight: bold;", "class" => "ins_col_12 "];
        }



        $ui_data[] =  ["type" => "end"];



        $ui_data[] =  ["type" => "line"];

        if (count($s_data["advance_deductions"]) > 0) {
            $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid ins_light"];
            $ui_data[] =  ["type" => "h4", "data" => "adv", "data" => "السلف", "class" => "ins_col_10 "];
            foreach ($s_data["advance_deductions"] as $d) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $d, "-"));
            }
            $ui_data[] =  ["type" => "end"];
            $ui_data[] =  ["type" => "line"];
        }

        if (count($s_data["leavs_deductions"]) > 0) {
            $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid ins_light"];
            $ui_data[] =  ["type" => "h4", "data" => "adv", "data" => "الاجازات بدون مرتب", "class" => "ins_col_10 "];
            foreach ($s_data["leavs_deductions"] as $d) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $d, "-"));
            }
            $ui_data[] =  ["type" => "end"];
            $ui_data[] =  ["type" => "line"];
        }






        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid  "];
        $ui_data[] =  ["type" => "h4", "data" => "Monthy deductions", "data" => "الاضافات  الشهرية", "class" => "ins_col_10"];



        if (count($s_data["monthy_earnings"]) > 0) {
            foreach ($s_data["monthy_earnings"] as $e) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $e));
            }
        } else {

            $ui_data[] =  ["type" => "h4", "data" => "no data", "data" => "لا يوجد ", "style" => "    text-align: center;
            font-weight: bold;", "class" => "ins_col_12 "];
        }




        $ui_data[] =  ["type" => "end"];
        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid ins_light"];
        $ui_data[] =  ["type" => "h4", "data" => "Monthy deductions", "data" => "الاضافات  ", "class" => "ins_col_10"];


        if (count($s_data["earnings"]) > 0) {
            foreach ($s_data["earnings"] as $e) {
                $ui_data = array_merge($ui_data, com_hr_finance::_imp_sallary_component($salary, $e));
            }
        } else {

            $ui_data[] =  ["type" => "h4", "data" => "no data", "data" => "لا يوجد ", "style" => "    text-align: center;
            font-weight: bold;", "class" => "ins_col_12 "];
        }



        $ui_data[] =  ["type" => "end"];
        $ui_data[] =  ["type" => "line"];


        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid sum_component_salary_total"];
        $ui_data[] =  ["type" => "h4", "data" => "الصافى", "class" => "ins_col_10"];
        $ui_data[] =  ["type" => "span", "data" => $s_data["total"], "class" => "ins_col_2"];
        $ui_data[] =  ["type" => "end"];
        $ui_data[] =  ["type" => "end"];

        return ins::_ui()->_data($ui_data)->_render();
    }


    //#region helper
    /**
     * @var $rq[month,year]
     */
    static function _get_date($rq)
    {

        $month = $rq["month"] ? $rq["month"] : date("Y-m");
        $data = \ins::_db()->_get_row("com_hr_payruns", "*", "month='$month'  and   em_id='{$rq["em_id"]}' ");

        if (!is_array($data)) {
            $insert_id = \ins::_db()->_insert("com_hr_payruns", ["month" => $month, "em_id" => $rq["em_id"]]);
            $data = \ins::_db()->_get_row("com_hr_payruns", "*", "id='$insert_id'");
        }

        return $data;
    }

    static function _get_salary_component_data($rq)
    {
        $data = \ins::_db()->_get_row("com_hr_salary_component", "*", " id='{$rq["id"]}' ");
        return json_encode($data);
    }


    function _add_salary_commponent($rq, $t = "deduction")
    {
        $rq["date"] = $rq["date"] ? $rq["date"] : ins::_data()->_datetime()->_craeteDBDateTime();
        $data = com_hr_finance::_get_date($rq);
        $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $rq["id"]]), true);
        $field = json_decode($data[$t], true);
        $field["_" . uniqid()] = ["id" => $rq["id"], "value" => $rq["value"], "value_type" => $component_data["value_type"], "date" => $rq["date"]];
        return  \ins::_db()->_update("com_hr_payruns", [$t => json_encode($field)], "id='{$data["id"]}'");
    }

    function _add_salary_commponent_ui($rq, $t = "deduction", $t_ar = "المستقطع")
    {




        if ($rq["lang"] == "ar") {

            $msg = "تم عمل خصم بنجاح";
            if ($t != "deduction") {
                $msg = "تم عمل اضافه بنجاح";
            }
        } else {

            $msg = "add deduction done successfully";
            if ($t != "deduction") {
                $msg = "add earning done successfully";
            }
        }

        $ui_data = [
            ["type" => "start", "class" => "ins_grid"],
            [
                "type" => "select", "name" => "id", "select_type" => "db", "select_table" => "com_hr_salary_component",
                "select_query" => "is_monthly<>'1' and type='$t'",
                "title" => "$t",
                "title-ar" => $t_ar,
                "full" => "true",
                "pclass" => "ins_col_12"
            ],
            [
                "type" => "text", "input" => "true",
                "title" => "value",
                "name" => "value",
                "title-ar" => "  قيمة $t_ar",
                "pclass" => "ins_col_8"
            ], [
                "type" => "span", "style" => "line-height: 36px;",
                "pclass" => "ins_col_4 value_type"
            ],
            [
                "type" => "button",
                "data" => "save",                "data-ar" => "حفظ",

                "data-id" => $rq["em_id"],
                "data-type" => "_add_$t",
                "data-msg" => $msg,
                "pclass" => "ins_col_12 ins_button ins_add_salary_component_save ins_add_$t"
            ],  ["type" => "end"]

        ];




        return ins::_ui()->_data($ui_data)->_render();
    }

    static function _get_value_type($type = "")
    {

        $r = "";
        switch ($type) {
            case "percentage":
                $r = '<i class="fas fa-percent"></i>';
                break;
            default:
                $r = '<i class="far fa-money-bill-alt"></i>';

                break;
        }

        return $r;
    }

    //#endregion halper


    //#region ajax functions 

    function _add_deduction_ui($rq)
    {
        return com_hr_finance::_add_salary_commponent_ui($rq, "deduction",  "المستقطع");
    }

    function _add_earning_ui($rq)
    {
        return com_hr_finance::_add_salary_commponent_ui($rq, "earning",  "المكافاءة");
    }


    function _add_deduction($rq)
    {
        return  com_hr_finance::_add_salary_commponent($rq);
    }


    function _add_earning($rq)
    {
        return  com_hr_finance::_add_salary_commponent($rq, "earning");
    }


    static function _imp_sallary_component($salary, $e, $type = "+")
    {
        if ($e["value_type"] == "fixed") {
            $es = $e["value"];
        } else {
            $es = ($salary * ($e["value"] / 100));
        }
        if ($type == "+") {
            $value_class = "sum_earning_value ";
        } else {
            $value_class = "sum_deduction_value ";
        }
        $ui_data[] =  ["type" => "strat", "class" => "ins_col_12 ins_grid sum_component_salary"];
        $ui_data[] =  ["type" => "h4", "data" => $e["title"], "class" => "ins_col_8"];
        $ui_data[] =  ["type" => "span", "data" => $e["value"], "class" => "ins_col_1"];
        $ui_data[] =  ["type" => "span", "data" => com_hr_finance::_get_value_type($e["value_type"]), "class" => "ins_col_1"];
        $ui_data[] =  ["type" => "span", "data" => $type .  $es, "class" => " $value_class ins_col_2"];
        $ui_data[] =  ["type" => "end"];
        return $ui_data;
    }



    //#endregion ajax functions 

    //#region list_functions


    function _ins_advance_op($rq)
    {

        $a_data = \ins::_db()->_get_row("com_hr_advance", "*", "id='{$rq["id"]}'");
        $em_data = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$a_data["em_id"]}'");



        $data = json_decode($a_data["data"], true);

        if ($rq["op_status"] == "delete") {
            \ins::_db()->_delete("com_hr_advance",  "id='{$rq["id"]}'");
        } else if ($rq["op_status"] == "info") {
            $table[] = [
                ["data" => "Month", "data-ar" => "شهر", "class" => "ins_col_10"],
                ["data" => "Value", "data-ar" => "الدفعة",  "class" => "ins_col_8"],
                ["data" => "Is Paid", "data-ar" => " تم التسديد",  "class" => "ins_col_6"]
            ];

            foreach ($data as  $d) {
                $is_paid = '<i class="fas ins_color_red  fa-times"></i>';

                if ($d["is_paid"] == "1") {
                    $is_paid = '<i class="fas ins_color_green  fa-check"></i>';
                }

                $table[] = [
                    ["data" => $d["month"], "class" => "ins_col_10"],
                    ["data" => $d["value"], "class" => "ins_col_8"],
                    ["data" => $is_paid, "class" => "ins_col_6 ins_text_tocenter"]
                ];
            }

            $uidata = [
                "h2" => ["data" => $em_data["name"], "class" => "ins_col_12"],
                "h5" => ["data" => $a_data["value"], "class" => "ins_col_6"],
                "h4" => ["data" => $a_data["date"], "class" => "ins_col_6"],
                "table_divs" => ["data" => $table, "class" => "ins_col_12"]
            ];

            return \ins::_ui()->_data($uidata)->_render();
        } else if ($rq["op_status"] == "edit") {

            $rq = $a_data;
            $rq["data"] =  $data;
            $rq["em_id"] = $a_data["em_id"];
            $rq["mode"] = "edit";

            return com_hr_finance::_salary_advance_ui($rq);
        }
    }

    function _ins_status_ui($rq)
    {

        $em_data = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$rq["em_id"]}'");
        $a_data = \ins::_db()->_get_data("com_hr_advance", "*", "em_id='{$rq["em_id"]}'");

        /**
advance _date
         */
        $table[] = [
            ["data" => "date", "data-ar" => "التاريخ", "class" => "ins_col_10"],
            ["data" => "value", "data-ar" => "القيمة", "class" => "ins_col_8"],
            ["data" => "actions", "data-ar" => "خيارات",  "class" => "ins_col_6"]
        ];
        $delete_done_msg = "Advance deleted successfully";
        $delete_msg = "Are you sure want to delete advance?";
        foreach ($a_data as $d) {
            $table[] = [
                ["data" => \ins::_map()->_format("date", $d["date"]), "class" => "ins_col_10"],
                ["data" => $d["value"], "class" => "ins_col_8"],
                ["data" => '
                <i data-op_status="print" data-id="' . $d["id"] . '"  class="fas _print_advan fa-print"></i>

                <i data-op_status="edit" data-id="' . $d["id"] . '"  class="fas ins_advance_op_btn fa-edit"></i>
                 <i data-op_status="info" data-id="' . $d["id"] . '" class="fas ins_advance_op_btn fa-info-circle"></i>
                <i data-op_status="delete" data-delete_done_msg="' . $delete_done_msg . '" data-delete_msg="' . $delete_msg . '" data-id="' . $d["id"] . '" class="fas  ins_advance_op_btn fa-times"></i>
                ', "class" => "ins_col_6 ins_text_tocenter"]
            ];
        }


        /**
advance _payrun
         */

        $p_data = \ins::_db()->_get_data("com_hr_payruns", "*", "em_id='{$rq["em_id"]}'");

        $mtable = [];
        $tablep = [];

        $mtable[] = [
            ["data" => "type", "data-ar" => "نوع", "class" => "ins_col_4"],
            ["data-ar" => "شهر", "data" => "month", "class" => "ins_col_3"],
            ["data-ar" => "الاسم", "data" => "name", "class" => "ins_col_8"],
            ["data-ar" => "القيمه", "data" => "value", "class" => "ins_col_6"],
            ["data-ar" => "تم نفيذها", "data" => "done", "class" => "ins_col_3"],
        ];

        $mtable[] = [
            ["data" => " ",  "class" => "ins_col_4 ins_th"],
            ["data" => " ", "class" => "ins_col_3 ins_th"],
            ["data" => " ", "class" => "ins_col_8 ins_th"],
            ["data" => "value", "data-ar" => "قيمة", "class" => "ins_col_4 ins_th"],
            ["data" => "type", "data-ar" => "نوع", "class" => "ins_col_2 ins_th"],
            ["data" => " ", "class" => "ins_col_3 ins_th"],
        ];

        $tablep[] = [
            ["data" => "date", "data-ar" => "رقم", "class" => "ins_col_3"],
            ["data" => "date", "data-ar" => "التاريخ", "class" => "ins_col_8"],
            ["data" => "date", "data-ar" => "عن شهر", "class" => "ins_col_4"],
            ["data" => "value", "data-ar" => "الصافى", "class" => "ins_col_6"],
            ["data" => "actions", "data-ar" => "خيارات",  "class" => "ins_col_3"]
        ];
        foreach ($p_data as $d) {
            $tablep[] = [
                ["data" => $d["pay_id"], "class" => "ins_col_3"],
                ["data" => ins::_map()->_format("datetime", $d["pay_date"]), "class" => "ins_col_8"],
                ["data" => $d["month"], "class" => "ins_col_4"],
                ["data" => $d["total"], "class" => "ins_col_6"],
                ["data" => '
                 <i data-op_status="info" data-id="' . $d["id"] . '" data-month="' . $d["month"] . '"  data-em_id="' . $rq["em_id"] . '" class="fas ins_salary_summray  fa-info-circle"></i>
                ', "class" => "ins_col_3 ins_text_tocenter"]
            ];



            $deduction =  json_decode($d["deduction"], true);
            $earning =  json_decode($d["earning"], true);

            foreach ($earning  as $ea) {
                $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $ea["id"]]), true);
                $mtable[] = [
                    ["data" => "earning", "data" => "مكافئه", "class" => "ins_col_4"],
                    ["data" => $d["month"], "class" => "ins_col_3"],
                    ["data" => $component_data["title"], "class" => "ins_col_8"],
                    ["data" => $component_data["value"], "class" => "ins_col_4"],
                    ["data" => com_hr_finance::_get_value_type($component_data["value_type"]), "class" => "ins_col_2"],
                    ["data" => $d["is_paid"] == "0" ? "لم يتم " : "تم", "class" => "ins_col_3"],
                ];
            }


            foreach ($deduction as $ded) {
                $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $ded["id"]]), true);
                $mtable[] = [
                    ["data" => "deduction", "data" => "خصم", "class" => "ins_col_4"],
                    ["data" => $d["month"], "class" => "ins_col_3"],
                    ["data" => $component_data["title"], "class" => "ins_col_8"],
                    ["data" => $component_data["value"], "class" => "ins_col_4"],
                    ["data" => com_hr_finance::_get_value_type($component_data["value_type"]), "class" => "ins_col_2"],
                    ["data" => $d["is_paid"] == "0" ? "لم يتم " : "تم", "class" => "ins_col_3"],
                ];
            }
        }




        /**
advance salary
         */
        $total = $em_data["salary"];

        $uidata_salary = [];
        $uidata_salary[] = ["type" => "line"];
        $uidata_salary[] = ["type" => "h4", "data" => "selary", "data-ar" => "الرتب", "class" => "ins_col_7"];
        $uidata_salary[] = ["type" => "div", "data" => $em_data["salary"], "class" => "ins_col_5"];

        $uidata_salary[] = ["type" => "line"];
        $mdeductions  = json_decode($em_data["salary_deduction"], true);
        $uidata_salary[] = ["type" => "h4", "data" => "Deductions", "data" => "خصومات", "class" => "ins_col_12"];
        foreach ($mdeductions as $d) {
            $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $d]), true);
            com_hr_finance::_salary_update_op($component_data, $em_data["salary"], $total, "-", $this_value);
            $uidata_salary[] = ["type" => "div", "data" => $component_data["title"], "class" => "ins_col_4"];
            $uidata_salary[] = ["type" => "div", "data" => $component_data["value"], "class" => "ins_col_2"];
            $uidata_salary[] = ["type" => "div", "data" => com_hr_finance::_get_value_type($component_data["value_type"]), "class" => "ins_col_1"];
            $uidata_salary[] = ["type" => "div", "data" => $this_value, "class" => "ins_color_red ins_col_4"];
        }

        $uidata_salary[] = ["type" => "line"];

        $uidata_salary[] = ["type" => "h4", "data" => "earning", "data" => "اضافات", "class" => "ins_col_12"];
        $mearnings = json_decode($em_data["salary_earning"], true);
        foreach ($mearnings as $d) {
            $component_data = json_decode(com_hr_finance::_get_salary_component_data(["id" => $d]), true);
            com_hr_finance::_salary_update_op($component_data, $em_data["salary"], $total, "+", $this_value);
            $uidata_salary[] = ["type" => "div", "data" => $component_data["title"], "class" => "ins_col_4"];
            $uidata_salary[] = ["type" => "div", "data" => $component_data["value"], "class" => "ins_col_2"];
            $uidata_salary[] = ["type" => "div", "data" => com_hr_finance::_get_value_type($component_data["value_type"]), "class" => "ins_col_1"];
            $uidata_salary[] = ["type" => "div", "data" => $this_value, "class" => "ins_color_green ins_col_4"];
        }
        $uidata_salary[] = ["type" => "line"];
        $uidata_salary[] = ["type" => "start", "class" => "ins_col_12 ins_grid  ins_light"];
        $uidata_salary[] = ["type" => "h4", "data" => "selary", "data-ar" => "صافى الرتب", "class" => "ins_col_7 "];
        $uidata_salary[] = ["type" => "div", "data" => $total, "class" => "ins_col_5 "];
        $uidata_salary[] = ["type" => "end"];
        $uidata_salary[] = ["type" => "line"];






        $uidata = [
            ["type" => "h4", "data" =>  $em_data["name"], "class" => "ins_col_6"],
            ["type" => "h4", "data" =>  ins::_db()->_get_row("com_structure_jobs", "title", "id='{$em_data["job"]}'")["title"], "class" => "ins_col_5"],

            ["type" => "i", "data-insaction" => "print_area", "data-area" => ".ins_lightbox_data",  "class" => "fas fa-print"],

            ["type" => "line"],

            "ins_tabs" => ["data" => '[
                {"data":"salary" ,"data-ar":"مفردات المرتب" ,"class":"ins_col_3" ,"data-show":".salary_component_tabs"},
                {"data":"salary" ,"data-ar":"القبض" ,"class":"ins_col_3" ,"data-show":".salary_tabs"},
                {"data":"more" ,"data-ar":"الخصومات والمكافات " ,"class":"ins_col_3" ,"data-show":".more_tabs"},
                {"data":"advances" ,"data-ar":"السلف" ,"class":"ins_col_3" ,"data-show":".advances_tabs"}
                ]', "class" => "ins_col_12", "data-show" => ".salary_tabs"],
            ["type" => "start", "class" => "ins_col_12 advances_tabs"],
            ["type" => "table_divs", "data" => $table, "class" => "ins_col_12"],
            ["type" => "end"],
            ["type" => "start", "class" => "ins_col_12 salary_tabs"],
            ["type" => "table_divs", "data" => $tablep, "class" => "ins_col_12"],
            ["type" => "end"],
            ["type" => "start", "class" => "ins_col_12 more_tabs"],
            ["type" => "table_divs", "data" => $mtable, "class" => "ins_col_12"],
            ["type" => "end"],
            ["type" => "start", "class" => "ins_col_12 salary_component_tabs"],
            ["type" => "div", "data" => \ins::_ui()->_data($uidata_salary)->_render(), "class" => "ins_col_12 ins_grid"],
            ["type" => "end"],
            ["type" => "end"],
        ];

        return \ins::_ui()->_data($uidata)->_render();
    }
    function _salary_reports($data, $dbdata)
    {

        $lb_title = "الحالة الماليه";
        $data = [

            [
                "type" => "strong",
                "data" => '<i class="fas  fa-chart-line"></i>' . " مفردات المرتب",
                "data-ar" => '<i class="fas  fa-chart-line"></i>' . " مفردات المرتب",
                "data-em_id" => $dbdata["id"], "class" => " ins_label_button ins_salary_summray"
            ],
            [
                "type" => "strong",
                "data-lb_title" => $lb_title,
                "data" => '<i class="fas  fa-chart-line"></i>' . "status ",
                "data-ar" => '<i class="fas  fa-chart-line"></i>' . "الحالة الماليه",
                "data-em_id" => $dbdata["id"], "class" => " ins_label_button ins_status_btn"
            ]
        ];
        return \ins::_ui()->_data($data)->_render();
    }

    function _salary_function($data, $dbdata)
    {

        $lb_title = " عمل سلفه جديدة";

        $data = [

            [
                "type" => "strong", "data-id" => $dbdata["id"],
                "data" => '<i class="fas ins_label_button  fa-file-upload"></i>' . "استقطاع",
                "data-ar" => '<i class="fas  fa-file-upload"></i>' . "استقطع", "data-type" => "deduction",
                "class" => "ins_add_salary_component ins_label_button "
            ],



            [
                "type" => "strong", "data-id" => $dbdata["id"],
                "data" => '<i class="fas  fa-file-upload"></i>' . "اضافه",

                "data-ar" => '<i class="fas  fa-file-upload"></i>' . "اضافه",
                "data-type" => "earning", "class" => "ins_label_button ins_add_salary_component "
            ],


            [
                "type" => "strong",
                "data" => '<i class="fas  fa-hand-holding-usd "></i>' . "Advance",

                "data-ar" => '<i class="fas  fa-hand-holding-usd "></i>' . "سلفه",

                "data-lb_title" => $lb_title,
                "data-id" => $dbdata["id"], "data-type" => "earning",
                "class" => " ins_label_button   ins_salary_advance_btn "
            ]

        ];
        return \ins::_ui()->_data($data)->_render();
    }

    function ins_advance_save($rq)
    {

        $data = $rq;

        $data["fee_month"] = explode(",", $data["fee_month"][0]);
        $data["fee_value"] = explode(",", $data["fee_value"][0]);
        $feedata = [];
        for ($i = 0; $i < count($data["fee_month"]); $i++) {
            $feedata["_" . uniqid()] = [
                "is_paid" => "0",

                "month" => $data["fee_month"][$i], "value" => $data["fee_value"][$i]
            ];
        }
        $data["data"] = json_encode($feedata);

        if ($rq["op_mode"] == "edit") {
            \ins::_db()->_update("com_hr_advance", $data, "id='{$rq["id"]}'");
        } else {

            \ins::_db()->_insert("com_hr_advance", $data);
        }
    }

    function _salary_advance_fee_ui($rq)
    {
        $ui_data = [];
        $number = $rq["number"];
        $value = $rq["value"];

        $valuenum = ($value / $number);

        for ($i = 0; $i <  $number; $i++) {
            $ui_data[] = [
                "type" => "month",
                "input" => "true",
                "title" => "Month",
                "name" => "fee_month[]",
                "value" =>   \ins::_data()->_datetime()->_date("+$i months", ins::_data()->_datetime()->_db_month_format),
                "title-ar" => "الشهر ",
                "pclass" => "ins_col_6"
            ];
            $ui_data[] = [
                "type" => "text",
                "input" => "true", "value" => "",
                "title" => "fee value",
                "name" => "fee_value[]",
                "value" =>  round($valuenum, 2),
                "title-ar" => "  قيمة ",
                "pclass" => "ins_col_6"
            ];
        }

        return ins::_ui()->_data($ui_data)->_render();
    }

    function _salary_advance_ui($rq)
    {
        if ($rq["lang"] == "ar") {

            $msg = "تم   عمل السلفه بنجاح";
        } else {

            $msg = "add advance  done successfully";
        }

        $defvalue = "100";
        $em_data = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$rq["em_id"]}'");


        $ui_data = [
            ["type" => "start", "class" => "ins_grid"],
            "employee_title" =>  [
                "type" => "text", "input" => "true", "title" => "employee", "title-ar" => "  الموظف ",
                "value" => $em_data["name"], "pclass" => "ins_col_12"
            ],
            "date" =>   [
                "type" => "datetime-local", "input" => "true", "title" => "value",
                "value" => \ins::_data()->_datetime()->_date_time("", \ins::_data()->_datetime()->_html_datetime_format),
                "title-ar" => "  تاريخ ", "pclass" => "ins_col_6"
            ],
            "value" => [
                "type" => "text", "input" => "true", "title" => "value",
                "value" => $defvalue, "title-ar" => "قيمة", "pclass" => "ins_col_6"
            ],
            ["type" => "start", "style" => "padding:20px", "class" => "ins_grid ins_col_12 ins_light"],
            "fee_number" =>   [
                "type" => "number", "input" => "true", "value" => "1", "title" => "number ",
                "title-ar" => "  عدد دفع الرد ", "pclass" => "ins_col_12"
            ],
            ["type" => "line", "pclass" => "ins_col_12"],
            ["type" => "start", "class" => "ins_grid fee_data ins_col_12"]

        ];

        if ($rq["mode"] == "edit") {
            foreach ($rq["data"] as $d) {

                $is_paid = '<i class="fas ins_color_red  fa-times"></i>';
                if ($d["is_paid"] == "1") {
                    $is_paid = '<i class="fas ins_color_green  fa-check"></i>';
                }
                $ui_data[] = [
                    "type" => "month", "input" => "true", "title" => "Month", "name" => "fee_month[]",
                    "value" =>  $d["month"], "title-ar" => "الشهر ", "pclass" => "ins_col_5"
                ];

                $ui_data[] = [
                    "type" => "text", "input" => "true", "title" => "fee value",
                    "name" => "fee_value[]", "value" => $d["value"], "title-ar" => "  قيمة ", "pclass" => "ins_col_5"
                ];
                $ui_data[] = [
                    "type" => "div", "data" => $is_paid, "style" => "line-height: 36px;", "pclass" => "ins_col_2 ins_text_tocenter"
                ];
            }
        } else {
            $ui_data[] = [
                "type" => "month", "input" => "true", "title" => "Month", "name" => "fee_month[]",
                "value" =>   \ins::_data()->_datetime()->_date("", ins::_data()->_datetime()->_db_month_format),
                "title-ar" => "الشهر ", "pclass" => "ins_col_6"
            ];

            $ui_data[] = [
                "type" => "text", "input" => "true", "title" => "fee value",
                "name" => "fee_value[]", "value" => $defvalue, "title-ar" => "  قيمة ", "pclass" => "ins_col_6"
            ];
        }


        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "line", "pclass" => "ins_col_12"];
        $ui_data[] = ["type" => "end"];

        if ($rq["mode"] == "edit") {

            $ui_data[] = [
                "type" => "button", "data" => "update", "data-ar" => "تعديل", "data-em_id" => $rq["em_id"], "data-id" => $rq["id"],
                "data-msg" => $msg, "data-op_mode" => "edit", "pclass" => "ins_col_12 ins_button ins_advance_save_btn "
            ];
        } else {

            $ui_data[] = [
                "type" => "button", "data" => "save", "data-ar" => "حفظ", "data-em_id" => $rq["em_id"],
                "data-msg" => $msg, "data-op_mode" => "add", "pclass" => "ins_col_12 ins_button ins_advance_save_btn "
            ];
        }
        $ui_data[] = ["type" => "end"];


        if ($rq["mode"] == "edit") {

            $ui_data["value"]["value"] = $rq["value"];
            $ui_data["fee_number"]["value"] = count($rq["data"]);
        }

        return ins::_ui()->_data($ui_data)->_render();
    }




    //#endregion list_functions


    //#region out

    function _out()
    {
        /** @var ins_lib\pages\page_admin  $admin*/
        $admin = \lib::_pages()->_admin("com_hr_employees");

        return $admin->_render();
    }
    //#endregion out
}
