<?php

class com_hr_payruns extends ins_com
{
    public function __construct()
    {
        parent::__construct();
    }


    static function _edit_date($rq)
    {

        require("ins_admin/ins_coms/com_hr/com_hr_finance/com_hr_finance.php");

        $rq["no_input"] = true;

        $data = com_hr_payruns::_get_date($rq);
        $ui_data[] =  ["type" => "strat","style"=>"width: 550px; padding: 20px;margin: auto;float: none;",  "class" => "ins_col_12 salary_summray_print_date ins_grid"];
        $ui_data[] = ["type" => "i", "data-insaction" => "print_area", "data-area" => ".salary_summray_print_date",  "class" => "   fas fa-print"];

        if ($data["is_paid"] == "1") {
            $ui_data[] =  ["type" => "div", "data" => com_hr_finance::_get_salary_summray($data, json_decode($data["summery"], true)), "class" => "ins_col_12 salary_summray_print_date"];
        } else {
            $ui_data[] =  ["type" => "div", "data" => com_hr_finance::_get_salary_summray($rq), "class" => "ins_col_12"];
        }

        $ui_data[] =  ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }


    function _salary_reports($data, $dbdata)
    {
        $data = [

            [
                "type" => "strong",
                "data" => '<i class="fas  fa-chart-line"></i>',
                "data-id" => $dbdata["id"], "class" => " ins_label_button ins_salary_summray"
            ],

        ];
        return \ins::_ui()->_data($data)->_render();
    }

    static function _get_salary_component_data($rq)
    {
        $data = \ins::_db()->_get_row("com_hr_salary_component", "*", " id='{$rq["id"]}' ");
        return json_encode($data);
    }



    //#endregion ajax functions 

    //#region list_functions

    function _print($rq)
    {
        $fdata = \ins::_db()->_get_row("com_hr_payruns", "*", "id={$rq["id"]}");

        $fdata["user"] =  \ins::_db()->_get_row("com_hr_employees", "*", "id={$fdata["em_id"]}")["name"];

        $fdata["total"] = $fdata["total"];


        $f = new \NumberFormatter("ar", \NumberFormatter::SPELLOUT);
        $fdata["total_text"] = $f->format($fdata["total"]) . " جنيها لا غير ";
        $fdata["des"] = " - ";
        $_SESSION["f_pay_print"] = $fdata;
    }


    static function _get_date($rq)
    {

        $month = $rq["month"] ? $rq["month"] : date("Y-m");
        $data = \ins::_db()->_get_row("com_hr_payruns", "*", "month='$month'  and   em_id='{$rq["em_id"]}' ");

        if (!is_array($data)) {
            $insert_id = \ins::_db()->_insert("com_hr_payruns", ["month" => $month, "em_id" => $rq["em_id"]]);
            $data = \ins::_db()->_get_row("com_hr_payruns", "*", "id='$insert_id'");
        }

        return $data;
    }


    function _salary_function($data, $dbdata)
    {
        $data = [
            ["type" => "i", "data-em_id" => $dbdata["em_id"], "data-month" => $dbdata["month"], "class" => "ins_salary_summray fas fa-chart-line"]
        ];
        return \ins::_ui()->_data($data)->_render();
    }

    function _salary_mian($data, $dbdata)
    {
        $data_employee = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$dbdata["em_id"]}'");



        return $data_employee["salary"];
    }

    function _salary_totle($data, $dbdata)
    {

        require_once($_SERVER['DOCUMENT_ROOT'] . "/ins_admin/ins_coms/com_hr/com_hr_finance/com_hr_finance.php");
        $data =  com_hr_finance::_salary_update($dbdata);
        return $data["total"];
    }


    function _salary_pay($data, $dbdata)
    {
        $pdata = [];
        $pdata[] = ["type" => "start", "class" => "td_pay_options_{$dbdata["id"]}"];

        if ($dbdata["is_paid"] == "1") {
            $pdata[] = ["type" => "i", "class" => " fas fa-user-check  ins_color_green",  "data-title" => "",];
            $pdata[] = ["type" => "i", "data-id" => $dbdata["id"], "class" => "  _btn_print  fas fa-print",  "data-title" => "",];
        } else {
            $pdata[] = ["type" => "i", "color:green !important",  "data-id" => $dbdata["id"], "class" => "ins_salary_summray_pay ins_color_red fas  fa-credit-card",  "data-title" => "",];
            $pdata[] = ["type" => "i", "data-id" => $dbdata["id"], "class" => "_ins_salary_summray_pay_btn fas  fa-cog ins_color_red ",  "data-title" => "",];
        }
        $pdata[] = ["type" => "end"];

        return \ins::_ui()->_data($pdata)->_render();
    }


    function _ins_pay_ui($rq)
    {


        $paydata = \ins::_db()->_get_row("com_hr_payruns", "*",   "id='{$rq["id"]}' ");

        $data_employee = \ins::_db()->_get_row("com_hr_employees", "*", "id='{$paydata["em_id"]}'");

        $data = [
            "start" => ["class" => "ins_grid"],

            "pay_id" => ["input" => true, "value" => $paydata["id"], "title-ar" => "رقم",  "title" => "number", "type" => "text", "pclass" => "ins_col_6"],
            "pay_date" => ["input" => true, "value" => date("Y-m-d"), "title-ar" => "التاريخ",  "title" => "التاريخ", "type" => "date", "pclass" => "ins_col_6"],
            "user" => ["input" => true, "value" => $data_employee["name"], "title-ar" => "الموظف", "title" => "الموظف", "type" => "text", "pclass" => "ins_col_12"],
            "currency" => ["type" => "currencies", "title" => "currency", "title-ar" => "العملة",  "pclass" => "ins_col_6"],
            "payment_method" => ["type" => "payment_methods", "title" => "payment method", "title-ar" => "طرقه الدفع",  "pclass" => "ins_col_6"],
            "des" => ["style" => "height:110px",  "title-ar" => "ملاحظات", "title" => "ملاحظات", "type" => "textarea", "class" => "des", "pclass" => "ins_col_12"],
            "button" => [
                "data-id" => $rq["id"],
                "type" => "text", "data" => "pay", "data" => "دفع", "class" => "_ins_pay_ui_btn ins_button ins_col_12"
            ],
            "end" => [],

        ];

        return  \lib::_ui()->_data($data)->_render();
    }

    function _dopays($rq)
    {
        $ids = explode(",", $rq["id"]);
        array_filter($ids);
        foreach ($ids as $id) {
            if ($id != "") {
                com_hr_payruns::_dopay(["id" => $id]);
            }
        }
    }


    function _dopay($rq)
    {


        require_once($_SERVER['DOCUMENT_ROOT'] . "/ins_admin/ins_coms/com_hr/com_hr_finance/com_hr_finance.php");

        $dbdata = \ins::_db()->_get_row("com_hr_payruns", "*", "id='{$rq["id"]}'");
        $data =  com_hr_finance::_salary_update($dbdata);
        $sqldate = array_merge($dbdata, $rq);
        $sqldate["is_paid"] = "1";
        $sqldate["total"] = $data["total"];
        $sqldate["summery"] = json_encode($data);
        $sqldate["pay_date"] = \ins::_data()->_datetime()->_date_time();
        if (isset($sqldate["currency"])) {
            $sqldate["currency"] = ins::_map()->_org("default_currency");
        }
        if (isset($sqldate["payment_method"])) {
            $sqldate["payment_method"] = ins::_map()->_org("default_payment_method");
        }


        $data_employee = \ins::_db()->_update("com_hr_payruns", $sqldate, "id='{$rq["id"]}'");

        return   com_hr_payruns::_salary_pay(null, ["is_paid" => "1", "id" => $rq["id"]]);;
    }

    function  _prepare_month($rq)
    {
        $data_employees = \ins::_db()->_get_data("com_hr_employees");
        foreach ($data_employees  as  $_employee) {
            $rq["em_id"] = $_employee["id"];
            com_hr_payruns::_get_date($rq);
        }
    }

    function  _prepare_month_ui($data)
    {


        $data = [

            [
                "type" => "start", "class" => "ins_grid"

            ],

            [
                "type" => "month", "name" => "prepare_month", "input" => "true", "title" => "month",
                "pclass" => "ins_col_12 "
            ],
            [
                "type" => "button",
                "data" => "update",
                "pclass" => "ins_col_12 ins_button ins_btn_prepare_month "
            ],  ["type" => "end"]



        ];


        return \ins::_ui()->_data($data)->_render();
    }
    //#endregion list_functions


    //#region out

    function _out()
    {
        /** @var ins_lib\pages\page_admin  $admin*/
        $admin = \lib::_pages()->_admin("com_hr_payruns");
        $admin->_list_add_to_action_bar = [
            [
                "type" => "span", "class" => "ins_toleft ins_label_button ins_btn_prepare_month_ui",
                "data" => '<i class="fas fa-calendar-day"></i> perpare Month to Pay',
                "data-ar" => '<i class="fas fa-calendar-day"></i> تحضير مرتبات الشهر'
            ],

            [
                "type" => "span", "class" => "ins_toleft ins_label_button ins_btn_pays",
                "data" => '<i class="fas fa-credit-card"></i> Pay',
                "data-ar" => '<i class="fas fa-credit-card"></i> دفع'
            ]

        ];
        return $admin->_render();
    }
    //#endregion out
}
