<?php

class com_moz_farmer extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }


    static function _fillRegionCombobox($rq)
    {
        $lang  = $rq["lang"];
        $r = "<option></option>";
        $json = \ins::_data()->_load_json("egystates");
        foreach ($json as $k => $re) {
            $r .= "<option value='$k' >{$re[$lang]}</option>";
        }
        return     $r;
    }


    static function _fillGovernorateCombobox($rq)
    {
        $lang  = $rq["lang"];
        $regionValue  = $rq["value"];

        $json = \ins::_data()->_load_json("egystates");
        $r = "<option></option>";
        foreach ($json[$regionValue]["data"] as $k => $re) {
            $r .= "<option value='$k' >{$re[$lang]}</option>";
        }
        return     $r;
    }

    static function _fillCityCombobox($rq)
    {
        $lang  = $rq["lang"];
        $regionValue  = $rq["rvalue"];
        $governorateValue  = $rq["value"];
        $r = "<option></option>";
        $json = \ins::_data()->_load_json("egystates");
        foreach ($json[$regionValue]["data"][$governorateValue]["data"] as $k => $re) {
            $r .= "<option value='$k' >{$re[$lang]}</option>";
        }
        return   $r;
    }



    /**
     *@param int  id 
     *@param string type [bal_income,bal_purchases,bal_transfers]
     *@param string  status [(add),remove,change,revchange]
     *@param float  value  if change status put ,
     *@param float  thvalue  
     */
    static  function _update_balance(int $id, string $type, string $value = "",   string $status = "add")
    {
        $w = "id='{$id}'";
        $olddata =  \ins::_db()->_get_row("com_moz_farmer", "*", $w);

        if ($status == "add") {
            $olddata[$type] += $value;
        } else  if ($status == "change") {
            $values =  explode(",", $value);
            $olddata[$type] -= $values[0];
            $olddata[$type] += $values[1];
        } else  if ($status == "revchange") {
            $values =  explode(",", $value);
            $olddata[$type] += $values[0];
            $olddata[$type] -= $values[1];
        } else {
            $olddata[$type] -= $value;
        }

        \ins::_db()->_update("com_moz_farmer", [$type => $olddata[$type]], $w);
    }

    function _out()
    {
        return  lib::_pages()->_get_class("admin", "com_moz_farmer")->_render();
    }
}
