ins(function (e) {
  ins(".ins_sub_components")._each(function (obj) {
    _sub_component(obj);
  });
})._load();

function _sub_component_updata(obj) {
  var url = obj._getdata("url");
  ins()._ajax._send(url, {}, "POST", function (data) {
    obj._sethtml(data);
  });
}

function _sub_component(obj) {
  var id = ins()._data._get_unique_id();
  obj._setattr("id", id);
  var table = obj._getdata("table");

  _sub_component_updata(obj);

  ins("#" + id + " a.ins_component_add")._on(
    "click",
    function (a, ev) {
      ev.preventDefault();
      var href = a._getattr("href");
      var light_box_options = {
        url: href,
        data_style: "height:500px",
        onclose: function () {
          _sub_component_updata(obj);
        },
      };
      ins()._ui._ins_lightbox(light_box_options);
    },
    true
  );

  ins("#" + id + " a.ins_component_edit")._on(
    "click",
    function (a, ev) {
      ev.preventDefault();
      var href = a._getattr("href");
      var light_box_options = {
        url: href,
        data_style: "height:500px",
        onclose: function () {
          _sub_component_updata(obj);
        },
      };
      ins()._ui._ins_lightbox(light_box_options);
    },
    true
  );

  ins("#" + id + " .list_multi_update")._on(
    "click",
    function (e) {
      var mode = e._getdata("mode");

      if (!ins(e._getdata("jsconfirm"))._is_empty()) {
        if (confirm(e._getdata("jsconfirm"))) {
          list_multi_update(obj, mode, e);
        }
      } else {
        list_multi_update(obj, mode, e);
      }
    },
    true
  );

  ins("#" + id + " .list_status_update")._on(
    "click",
    function (e) {
      var mode = e._getdata("mode");
      var ids = "";
      if (!ins(e._getdata("jsconfirm"))._is_empty()) {
        if (confirm(e._getdata("jsconfirm"))) {
          if (!ins(e._getdata("ids"))._is_empty()) {
            ids = e._getdata("ids");
          }
          var options = {
            get_file: "pages/list",
            mode: mode,
            ids: ids,
            table: table,
          };
          return ins()._ajax._send(
            "/ins_ajax.php",
            options,
            "POST",
            function () {
              _sub_component_updata(obj);
            }
          );
        }
      } else {
        if (!ins(e._getdata("ids"))._is_empty()) {
          ids = e._getdata("ids");
        }
        var options = {
          get_file: "pages/list",
          mode: mode,
          ids: ids,
          table: table,
        };
        return ins()._ajax._send("/ins_ajax.php", options, "POST", function () {
          _sub_component_updata(obj);
        });
      }
    },
    true
  );
}

function list_multi_update(obj, mode, e) {
  var ids = "";
  var table = obj._getdata("table");

  var m = "";

  var a = obj._find(".check_list_ids:checked");

  a._each(function (e) {
    ids += m + e._getvalue();
    m = ",";
  });

  if (ids == "") {
    alert("no items chosen");
  } else {
    var c = { mode: mode, ids: ids, table: table };
    var options = {
      get_file: "pages/list",
      mode: mode,
      ids: ids,
      table: table,
    };
    return ins()._ajax._send("/ins_ajax.php", options, "POST", function () {
      _sub_component_updata(obj);
    });
  }
}
