<?php
class com_moz_vists_schedule extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    static  function _fill_farmer_contracts($req)
    {

        $data = \ins::_db()->_get_query(" select  com_moz_farmer_contracts.* , com_moz_crops.title as crop_title  from com_moz_farmer_contracts
            join  com_moz_crops on  com_moz_crops.id = com_moz_farmer_contracts.fk_crops_id
                where  fk_farmer_id='{$req["id"]}' and  `status`='accepted' ");


        $r = "<option></option>";
        foreach ($data as $k => $v) {
            $selected = "";
            if ($req["value"] == $v["id"]) {
                $selected = "selected='selected'";
            }
            $r .= "<option  $selected value='{$v["id"]}' >{$v["contract_title"]} , {$v["crop_title"]} </option>";
        }
        return  $r;
    }


    function _sc($rq)
    {
        $v = ins::_db()->_get_row("com_moz_visits_schedule", "*", "id='{$rq["id"]}'");
        $day_title = explode(",", $v["day_title"]);
        $week = $v["week"];
        $startDate = new \DateTime($v["start"]);
        $endDate = new \DateTime($v["end"]);
        $days = array();
        $tmp = $day_title;
        while ($startDate <= $endDate) {

            $w = $startDate->format('w');
            $ex = 1;
            if (in_array($w,  $tmp)) {
                $po = array_search($w, $tmp);
                unset($tmp[$po]);
                if (count($tmp) == 0) {
                    $tmp = $day_title;
                }
                $days[] = $startDate->format("Y-m-d l");


                if ($week > 1) {
                    $ex = ($week) * (6   - $w);
                }
            }

            $startDate->modify('+' . $ex . ' day');
        }
        $data = \ins::_db()->_get_data("com_moz_visits_schedule_information", "*", "schedule_id={$rq["id"]}  and status='add' ");

        foreach ($data as $d) {
            if (!in_array($d["date"], $days)) {
                $days[] = $d["date"];
            }
        }
        $rdata = [];

        $rdata[] = ["type" => "start", "class" => "ins_grid data_cal"];



        $days = array_unique($days);
        sort($days);

        foreach ($days as $day) {
            $Date = new \DateTime($day);


            $info = \ins::_db()->_get_row("com_moz_visits_schedule_information", "*", "schedule_id={$rq["id"]} and `date`='$day' ");


            $rdata[] = ["type" => "start", "class" => "ins_col_3 data_cal_item", "style" => "   position: relative;"];
            $rdata[] = ["type" => "h4", "data" =>   $Date->format("l"), "style" => "", "class" => ""];
            $rdata[] = ["type" => "span", "data" => $Date->format("Y-m-d"), "style" => "", "class" => ""];


            $color = "green";
            $icon = "fas fa-search-location";
            $h = "";
            $title = $info["status"];

            switch ($info["status"]) {
                case "visit":
                    $color = "#4caf50";
                    $icon = "fas fa-search-location";

                    $h = ins::_app_map()->_url(["alias" => "visits", "id" => $info["object_id"], "mode" => "view"]);

                    break;
                case "cancel":
                    $color = "#ff5722";
                    $icon = "fas fa-retweet";
                    $rd = \ins::_db()->_get_row("com_moz_visits_schedule_information", "*", "id={$info["object_id"]}");
                    $title = " Rescheuled To  " . $rd["date"];
                    break;
                case "add":
                    $color = "#2196f3";
                    $icon = "fas fa-map-pin";
                    $rd = \ins::_db()->_get_row("com_moz_visits_schedule_information", "*", "object_id={$info["id"]} and status='cancel'");
                    $title = " Rescheuled From  " . $rd["date"];
                    break;
                default:
                    $color = "#bfb6b6";
                    $icon = "fas fa-times";
                    break;
            }


            $rdata[] = ["type" => "start", "data" => "a", "href" => $h];

            $rdata[] = ["type" => "i", "title" =>  $title, "style" => "
                color: $color;
                position: absolute;
                right: 10px;
                bottom: 10px;
                font-size: 25px;", "class" =>  $icon];


            $rdata[] = ["type" => "end", "data" => "a"];

            $rdata[] = ["type" => "end"];
        }



        return ins::_ui()->_data($rdata)->_render();
    }




    static function show_sc($data, $db_data)
    {

        return '<i data-id="' . $db_data["id"] . '" class="far  show_sc fa-calendar-alt"></i>';
    }

    function _out()
    {

        $data = ins::_map()->_get();


        $r = \ins::_pages()->_get_class("admin", "com_moz_visits_schedule")->_render();

        if ($data["mode"] == "edit") {
            $r .=  $this->_sc($data);
        }

        return   $r;
    }
}
