<?php

class com_school_activities extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }


    function _delete_groups($rq)
    {

        \ins::_db()->_delete("com_school_activity",  "id={$rq["act_id"]}");

        return com_school_activities::_get_groups($rq);
    }
    function _get_groups($rq)
    {


        $data = \ins::_db()->_get_data("com_school_activity", "*", "act_id={$rq["id"]}");
        $da = \ins::_db()->_get_row("com_school_activities", "*", "id={$rq["id"]}");

        $uidata[] = ["type" => "start", "class" => "ins_grid ", "style" => "padding:25px;text-align:center"];

        $uidata[] = [
            "type" => "start",
            "data-lb_style" => "height:500px;width:60%",
            "data-url" => "/ins_admin/activity/add/do/act_id/{$rq["id"]}/get_tmp_index/main_style/",
            "class" => "ins_col_3 ins_card_btn h_btn_get_url ins_light "
        ];

        $uidata[] = ["type" => "span",   "data" => "<i class='fas fa-plus' ></i>"];

        $uidata[] = ["type" => "li",  "data" => "add", "data-ar" =>  "أضافة"];
        $uidata[] = ["type" => "end"];
        foreach ($data as $d) {
            $uidata[] = [
                "type" => "start","style" => "position: relative;",
                "class" => "ins_col_3 ins_card_btn  ins_light "
            ];
            $uidata[] = ["type" => "i","data-act_id"=>$d["id"], 
            "style" => "z-index:11;position: ABSOLUTE; left: 10px; top: 10px;", 
              "class" => "fas delete_act fa-trash"];

            $uidata[] = [
                "type" => "start", "style"=>"position: relative ",
                "data-lb_style" => "height:500px;width:60%",
                "data-url" => "/ins_admin/activity/edit/{$d["id"]}/do/act_id/{$rq["id"]}/get_tmp_index/main_style/",
                "class" => "  h_btn_get_url  "
            ];


            $uidata[] = ["type" => "span",  "data" => $da["icon"]];
            $uidata[] = ["type" => "li",  "data" => "add", "data-ar" =>  $d["title"]];

            $uidata[] = ["type" => "end"];

            $uidata[] = ["type" => "end"];
        }

        $uidata[] = ["type" => "end"];

        return \ins::_ui()->_data($uidata)->_render();
    }



    function _get_for_type($rq)
    {


        if ($rq["type"] == "dormitory") {
            $data = [
                "for_type" => [
                    "name" => "for_type[]",
                    "title" => 'dormitory',
                    "select_type" => "db", "select_table" => "com_school_dormitories", "style" => "height:100px",
                    "title-ar" => "التسكين","auto"=>"true", "type" => 'list', "pclass" => 'ins_col_12'
                ]
            ];
        } else if ($rq["type"] == "class") {
            $data = [
                "for_type" => [
                    "name" => "for_type[]",
                    "title" => 'class', "title-ar" => "الصف", "pclass" => 'ins_col_12', "style" => "height:100px",
                    "type" => 'list', "select_type" => "db", "auto"=>"true","select_table" => "com_school_classes"
                ]
            ];
        }


        if (isset($rq["id"])) {
            $dbdata  = \ins::_db()->_get_row("com_school_activities", "*", "id={$rq["id"]}");
            $data["for_type"]["value"] =  $dbdata["for_type"];
        }


        return  \ins::_ui()->_data($data)->_render();
    }



    function check_group($id)
    {
        if (isset($_POST["title"])) {
            $dbdata  = \ins::_db()->_get_row("com_school_activity", "*", "act_id={$id}");
            if (!is_array($dbdata)) {
                $dbdata  = \ins::_db()->_get_row("com_school_activities", "*", "id={$id}");
                $$ins  = \ins::_db()->_insert("com_school_activity", [
                    "resp" => $dbdata["resp"],
                    "title" => "gneral", "act_id" => $id
                ], "act_id={$id}");
            }
        }
    }

    function _out()
    {
        $options["on_add"]  = "com_school_activities::check_group";
        $options["on_update"]  = "com_school_activities::check_group";
        $admin = \ins::_pages()->_admin("com_school_activities", $options);
        return  $admin->_render();
    }
}
