ins("select.class")._on("change", function (o) {
  ins("_get_dormitories")._ajax._class({ class: o._getvalue() }, function (
    data
  ) {
    ins("select.dormitory")._sethtml(data);
  });
});

ins("select.dormitory")._on(
  "change",
  function (o) {
    ins("_get_students")._ajax._class({ dormitory: o._getvalue() }, function (
      data
    ) {
      ins("select.student_id")._sethtml(data);
    });
  },
  true
);

ins(".ins_student_add_ui")._on(
  "click",
  function (o, e) {
    ins("_student_ui_add")._ajax._class({}, function (data) {
      ins()._ui._lightbox("", data, "", "width:500px;height:auto");
    });
  },
  true
);
ins(".ins_student_delete")._on(
  "click",
  function (o, e) {
    ins("_student_add")._ajax._class(o._getdata(), function (data) {
      update_students_area();
    });
  },
  true
);

ins(".btn_add_student")._on(
  "click",
  function (o) {
    var options = {};
    options.student_id = ins("select.student_id")._getvalue();

    ins("_student_add")._ajax._class(options, function (data) {
      ins()._ui._lightbox_remove();

      update_students_area();
    });
  },
  true
);

function update_students_area() {
  ins("_get_students_area")._ajax._class({}, function (data) {
    ins(".students_area")._sethtml(data);
  });
}

/**
 * calender
 */

ins(".ins_weekly_calendar .ins_col_1.ins_td")._on("click", function (o) {
  var options = o._getdata();
  options["from"] = o._getdata("t");
  ins("_calender_add")._ajax._class(options, function (data) {
    ins()._ui._lightbox("", data, "", "width:500px;height:auto");
  });
});

function update_calender(options) {
  ins("_calender_update")._ajax._class(options, function (data) {
    ins(".tabcal_data")._sethtml(data);
    ins()._ui._lightbox_remove();
  });
}

ins(".add_item_calender")._on(
  "click",
  function (o) {
    var options = ins(".ins_lightbox_data")._data._get_inputs();
    update_calender(options);
  },
  true
);

ins(".btn_calender_remove")._on(
  "click",
  function (o, e) {
    e.preventDefault();
    var options = o._getdata();
    ins("_calender_remove")._ajax._class(options, function (data) {
      ins(".tabcal_data")._sethtml(data);
    });
  },
  true
);

ins(".btn_calender_edit")._on(
  "click",
  function (o, e) {
    e.preventDefault();
    var options = o._getdata();
    ins("_calender_edit")._ajax._class(options, function (data) {
      ins()._ui._lightbox("", data, "", "width:500px;height:auto");
    });
  },
  true
);

ins(".update_item_calender")._on(
  "click",
  function (o) {
    var options = ins(".ins_lightbox_data")._data._get_inputs();
    options["index"] = o._getdata("index");

    ins("_calender_item_update")._ajax._class(options, function (data) {
      ins(".tabcal_data")._sethtml(data);

      ins()._ui._lightbox_remove();
    });
  },
  true
);



/**
 * calender
 */

/**
map
 */

var Path = null;
var thismarker = null;
var my_markers = null;

function get_markers_data() {
  var data = [];
  my_markers.forEach((m) => {
    data.push({
      title: m.title,
      lat: m.getPosition().lat(),
      lng: m.getPosition().lng(),
    });
  });

  return data;
}

function update_path(map) {
  if (Path != null) {
    Path.setMap(null);
  }
  const jdata = get_markers_data();

  Path = new google.maps.Polyline({
    path: jdata,
    geodesic: true,
    strokeColor: "#FF0000",
    strokeOpacity: 1.0,
    strokeWeight: 2,
  });

  Path.setMap(map);

  ins("_set_Loctions")._ajax._class(
    { locations: JSON.stringify(jdata) },
    function () {}
  );
}
function remove_marker(map, marker) {
  const index = my_markers.indexOf(marker);
  if (index > -1) {
    my_markers.splice(index, 1);
  }

  marker.setMap(null);
  update_path(map);
}

function add_marker(map, position, title) {
  var add_marker = new google.maps.Marker({
    position: position,
    title: title,
  });
  add_marker.setMap(map);

  marker_options(map, add_marker);
  my_markers.push(add_marker);
  update_path(map);
  // ins()._ui._lightbox_remove();
}

function marker_options(map, marker) {
  marker.addListener("click", function (e, i) {
    thismarker = this;

    ins("_ui_edit_marker")._ajax._class({ title: thismarker.title }, function (
      uidata
    ) {
      ins()._ui._lightbox_remove();
      var o = {
        data: uidata,
      };
      ins()._ui._ins_lightbox(o);
    });
  });

  ins(".bt_map_delete_m")._on("click", function (o, e) {
    e.preventDefault();
    remove_marker(map, thismarker);
    thismarker = null;
    ins()._ui._lightbox_remove();
  });

  ins(".bt_map_update_m")._on("click", function (o, e) {
    e.preventDefault();
    add_marker(map, thismarker.position, ins(".map_m_title")._getvalue());
    remove_marker(map, thismarker);
    thismarker = null;
    ins()._ui._lightbox_remove();
  });
}

/**
mapend
 */

ins(function () {
  ins("_get_Loctions")._ajax._class({}, function (data) {
    var flightPlanCoordinates = [];
    if (!ins(data)._is_empty()) {
      flightPlanCoordinates = JSON.parse(data);
    }
    ins("#act_map")._ui._map({
      zoom: 13,
      center: {
        lat: 30.323261,
        lng: 30.964464,
      },

      onaddmarker: function (map, m) {
        marker_options(map, m);
      },
      onload: function (map, markers, path) {
        my_markers = markers;
        Path = path;
        map.addListener("rightclick", function (e) {
          ins("_ui_add_marker")._ajax._class({}, function (uidata) {
            ins()._ui._lightbox_remove();
            var o = {
              data: uidata,
            };
            ins()._ui._ins_lightbox(o);
          });
          ins(".bt_map_add_m")._on("click", function (o) {
            add_marker(map, e.latLng, ins(".map_m_title")._getvalue());
          });
        });
      },
      markers: flightPlanCoordinates,
      path: { data: flightPlanCoordinates },
    });
  });

  
  update_students_area();
  update_calender({});
  /*

    if (ins("select.for")._getvalue() == "all") {
        ins("._ui_for_type")._sethtml("");
    } else {
        ins("_get_for_type")._ajax._class(
            { type: ins("select.for")._getvalue() },
            function (data) {
                ins("._ui_for_type")._sethtml(data);
            }
        );
    }*/
})._load();
