/* global ins */

var jo_ = null;
function update_view() {
  var j = ins("textarea.wf_textarea")._getvalue();
  j = JSON.parse(j);
  var jo_id = "";
  if (jo_ !== null) {
    jo_id = jo_._getattr("id");
  }
  var options = j.options;
  delete j.options;

  if (ins(ins(".wf_options_textarea")._getvalue())._is_empty()) {
    ins(".wf_options_textarea")._setvalue(JSON.stringify(options));
  }
  Object.keys(j).forEach(function (k) {
    j[k].onclick = function (o, e) {
      view_options(o);
    };

    j[k]["id"] = k;
  });

  ins(".do_view_data")._sethtml("");
  ins(".do_view_data")._drawing._workflow(j, options);

  if (jo_id !== "") {
    ins(".do_view_data foreignObject")._each(function (k) {
      if (jo_id == k._getattr("id")) {
        jo_ = k;

        jo_._addclass("ins_act");
      }
    });
  }
}

function update_to_text(newitem = null) {
  var j = {};

  var ii = 0;

  ins("foreignObject")._each(function (o) {
    var jo = JSON.parse(o._getdata("d"));
    ii++;

    delete jo.width;
    delete jo.style;
    delete jo.height;
    j[jo.id] = jo;
  });

  if (newitem != null) {
    ii++;
    newitem.id = ii;
    j[ii] = newitem;
  }

  if (ins(ins(".wf_options_textarea")._getvalue())._is_empty()) {
    ins(".wf_options_textarea")._setvalue('{"width":130,"height":50}');
  }
  j.options = JSON.parse(ins(".wf_options_textarea")._getvalue());

  ins("textarea.wf_textarea")._setvalue(JSON.stringify(j, null, 1));
}


function settings_update() {
  var a = ins(".wf_psettings_data")._data._get_inputs();
  delete a.error;
  delete a.error_inputs;

  if (ins(a.to)._is_empty()) {
    a.to = "[]";
  }
  a.to = JSON.parse(a.to);
  if (jo_ == null) {
    update_to_text(a);
  } else {
    jo_._setdata("d", JSON.stringify(a));
    update_to_text();
  }

  update_view();
}


function view_options(o) {
  ins(".wf_row_data")._data._clear_inputs();

  var h = ins(".wf_row_data")._gethtml();
  var data = "<div class='ins_grid wf_row ins_col_6'>" + h + "</div>";

  ins(".wf_psettings_data")._sethtml(data);
  ins(".wf_settings_panel")._removeclass("ins_closed");

  if (!ins(o._getdata("d"))._is_empty()) {
    var j = JSON.parse(o._getdata("d"));
    ins(".wf_psettings_data")._data._update_inputs(j);
  }

  if (ins(jo_)._is_exists()) {
    jo_._removeclass("ins_act");
  }
  jo_ = o;
  jo_._addclass("ins_act");
}

ins(".wf_psettings_data input ,.wf_psettings_data ui_textarea ")._on(
  "keyup",
  function (o, e) {
    if (e.altKey == true && e.keyCode == 85) {
      settings_update();
    }
  }
);



ins(".ins_fill_list")._on("change", function (o,e) { 
    var options = o._getdata();
    options["value"] = o._getvalue(); 
    ins("_fill_list")._ajax._class(options, function (ui_data) { 
        ins(o._getdata("to"))._sethtml(ui_data);
    })
})



ins(".wf_row_item_update")._on(
  "click",
  function () {
    settings_update();
  },
  true
);

ins(".wf_settings_panel_close")._on(
  "click",
  function () {
    ins(".wf_settings_panel")._addclass("ins_closed");
    jo_._removeclass("ins_act");
    jo_ = null;
  },
  true
);

ins(".do_view")._on(
  "click",
  function () {
    update_view();
  },
  true
);

ins(".wf_row_item_detele")._on(
  "click",
  function (o) {
    jo_._remove();
    update_to_text();
    update_view();
  },
  true
);

ins(".wf_row_item_add")._on("click", function () {
  jo_ = null;
  ins(".wf_row_data")._data._clear_inputs();
  var h = ins(".wf_row_data")._gethtml();
  var data = "<div class='ins_grid wf_row ins_col_6'>" + h + "</div>";

  ins(".wf_psettings_data")._sethtml(data);
  ins(".wf_settings_panel")._removeclass("ins_closed");
});

ins(".wf_row_item_adv")._on(
  "click",
  function (o) {
    var p = o._parents(".wf_row");
    if (ins(p)._find(".wf_row_data_adv")._hasclass("ins_hidden")) {
      ins(p)._find(".wf_row_data_adv")._removeclass("ins_hidden");
    } else {
      ins(p)._find(".wf_row_data_adv")._addclass("ins_hidden");
    }
  },
  true
);

ins(".wf_show_hide_isd")._on(
  "click",
  function (o) {
    if (ins(".ins_isd_options")._hasclass("ins_hidden")) {
      ins(".ins_isd_options")._removeclass("ins_hidden");
      ins(".wf_settings_panel")._addclass("ins_isd_options_show");
    } else {
      ins(".ins_isd_options")._addclass("ins_hidden");

      ins(".wf_settings_panel")._removeclass("ins_isd_options_show");
    }
  },
  true
);

ins(".isd_entity")._on(
  "change",
  function (o) {
    ins("_get_owners")._ajax._class({ entity: o._getvalue() }, function (
      ui_data
    ) {
      ins(".isd_owner")._sethtml(ui_data);
    });
  },
  true
);

//<editor-fold defaultstate="collapsed" desc="TO">

ins(".wf_row_to_mang")._on(
  "click",
  function (o) {
    ins("_transactions")._ajax._class(
      {
        data: ins("textarea.wf_textarea")._getvalue(),
        data_to: ins("textarea.data_to")._getvalue(),
      },
      function (ui_data) {
        ins()._ui._lightbox("", ui_data, "", "height:auto;width:60%");
      }
    );
  },
  true
);

ins(".wf_row_to_add ")._on(
  "click",
  function (o) {
    ins("_transactions_row_form")._ajax._class(
      { data: ins("textarea.wf_textarea")._getvalue() },
      function (ui_data) {
        ins(".wf_to_data")._append(ui_data);
      }
    );
  },
  true
);

ins(".wf_row_to_add ")._on(
  "click",
  function (o) {
    ins("_transactions_row_form")._ajax._class({}, function (ui_data) {
      ins(".wf_to_data")._append(ui_data);
    });
  },
  true
);

ins(".wf_row_to_remove ")._on(
  "click",
  function (o) {
    o._parents(".wf_row_data")._remove();
  },
  true
);

ins(".wf_row_to_update ")._on(
  "click",
  function (o) {
    var data = [];
    ins(".wf_row_data")._each(function (o) {
      var c = ins(o)._data._get_inputs();
      delete c.error;
      delete c.error_inputs;
      if (ins(c["id"])._is_exists()) {
        data.push(c);
      }
    });
    ins("textarea.data_to")._setvalue(JSON.stringify(data));

    ins()._ui._lightbox_remove();
    settings_update();
  },
  true
);

//</editor-fold>

ins(function () {
  update_view();
})._load();
