<?php

class com_workflow extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }


    function _fill_list($rq)
    {

        return \ins::_ui()->_html()->_get_select_options([
            "select_type" => "db", "select_table" => $rq["type"],
            "select_query" => \ins::_data()->_db_create_where_to_group($rq["value"], $rq["by"])
        ]);
    }
    /* function _get_owners($rq)
    {

        return \ins::_ui()->_html()->_get_select_options(["select_type" => "db", "select_table" => "sys_users", "select_query" => \ins::_data()->_db_create_where_to_group($rq["entity"], "entity")]);
    }*/

    function _transactions($rq)
    {

        $data_to = json_decode($rq["data_to"], true);
        $datap = [];
        $datap[] = ["type" => "i", "class" => " ins_col_1 fas wf_row_to_add fa-plus"];
        $datap[] = ["type" => "i", "class" => " ins_col_1 fas wf_row_to_update fa-check"];

        $datap[] = ["type" => "line"];

        $datap[] = ["type" => "start", "class" => "ins_col_12 wf_to_data"];
        $h = "";

        foreach ($data_to as $datato) {
            $h .= com_workflow::_transactions_row_form(["data_to" => $datato, "data" => $rq["data"]]);
        }

        $datap[] = ["type" => "div", "data" => $h, "class" => "ins_col_12 "];

        $datap[] = ["type" => "end"];
        return ins::_ui()->_data($datap)->_render();
    }

    function _transactions_row_form($rq)
    {

        $data = json_decode($rq["data"], true);
        $select_text = "";
        $select_value = "";
        $sp = "";
        foreach ($data as $d) {
            $select_value .= $sp . $d["id"];
            $select_text .= $sp . $d["data"];

            $sp = ",";
        }


        $datato = $rq["data_to"];
        $datap = [];
        $datap[] = ["type" => "start", "class" => "ins_grid  wf_row_data ins_col_12"];
        $datap[] = ["type" => "text", "value" => $datato["title"], "name" => "title", "pclass" => "ins_col_5", "title" => "Title", "input" => "true"];
        $datap[] = ["type" => "select", "value" => $datato["id"], "name" => "id", "pclass" => "ins_col_5", "select_value" => $select_value, "select_text" => $select_text, "title" => "Node"];
        $datap[] = ["type" => "select", "value" => $datato["isd_status"],  "select_type" => "db", "select_table" => "com_isd_status", "name" => "isd_status", "pclass" => "ins_col_2", "title" => "الحالة ", "title" => "Status ",];
        $datap[] = ["type" => "select", "value" => $datato["from"], "name" => "from", "pclass" => "ins_col_3", "title" => "conect From ", "select_text" => "top,bottom,right,left"];
        $datap[] = ["type" => "select", "value" => $datato["to"], "name" => "to", "pclass" => "ins_col_3", "title" => "conect to ", "select_text" => "top,bottom,right,left"];
        $datap[] = ["type" => "number", "value" => $datato["c_y"], "name" => "c_y", "pclass" => "ins_col_2", "title" => "Center Y ", "input" => "true"];
        $datap[] = ["type" => "number", "value" => $datato["c_x"], "name" => "c_x", "pclass" => "ins_col_2", "title" => "Center X ", "input" => "true"];


        $datap[] = [
            "type" => "span", "data" => "<i style='width:25px' class=' fas wf_row_to_remove fa-times'></i>",
            "class" => " ins_col_2", "style" => "line-height: 35px;     text-align: center;"
        ];
        $datap[] = ["type" => "end"];
        return ins::_ui()->_data($datap)->_render();
    }

    function _out()
    {
        $this->_include("com_workflow.css");
        $this->_include("com_workflow.js");
        if (isset($_POST["id"])) {
            unset($_POST["id"]);
        }

        if (isset($_POST["title"])) {

            foreach ($_POST as $k => $v) {
                if ($v == "") {

                    unset($_POST[$k]);
                }
            }
        }

        return \lib::_ui()->_data(["div" => ["data" => lib::_pages()->get_page("admin"), "class" => "ins_block col12"]])
            ->_render();
    }
}
