<?php

class sys_history extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    // <a class="list_multi_update insaction  insaction  " title="" mode="copy" data-title="نسخ" data-insaction="ins_tooltip" data-mode="copy"> <i class="fa fa-clone" aria-hidden="true"></i></a> 


    function _table($data, $olddata)
    {

        $t = $olddata["table_name"];


        $mdata  = \lib::_db()->_get_row("sys_menus_items", "*", "`type` like '%$t%'");


        if (is_array($mdata)) {
            \lib::_data()->_update_data_language("sys_menus_items", $mdata);
            $mdata["title"] = ($mdata["title"]) ? $mdata["title"] : $t;
        } else {
            $mdata["title"]=$olddata["table_name"];

        }


        return $mdata["title"];
    }

    function _get_full_info($rq)
    {

        $data = \lib::_db()->_get_row("sys_history", "*", "id=" . $rq["id"]);

        $old_data = json_decode($data["old_data"], true);
        $new_data = json_decode($data["new_data"], true);





        if (strtolower($data["operation"]) == "update") {

            $tddata = $tddata;
            $tddata = [];
            foreach ($old_data as $k => $v) {
                $tddata[] = '<li style="   " class="ins_grid"><span style="padding:0 10px" class="ins_col_4 "> ' . $k . '</span> <span style="padding:0 10px" class="ins_col_8 ins_light">' . $v . '</span>  </li>';
            }


            $tddata2 = [];
            foreach ($new_data as $k => $v) {
                $c = "";
                if ($new_data[$k] != $old_data[$k]) {
                    $c = "color:red !important ;";
                }
                $tddata2[] = '<li style="' . $c . '" class="ins_grid"><span style="padding:0 10px" class="ins_col_4 "> ' . $k . '</span> <span style=" ' . $c . ' padding:0 10px" class="ins_col_8 ins_light">' . $v . '</span>  </li>';
            }



            $tabledata["tr -2"] = [
                "data" => [
                    "td-21" => ["data" => "NewData", "class" => "ins_col_12"],
                    "td-22" => ["data" => "Old Data", "class" => "ins_col_12"],
                ]
            ];


            foreach ($tddata as $k => $v) {
                $tabledata["tr-sub$k"] = [
                    "data" => [
                        "td-1" => ["data" => $v, "class" => "ins_col_12"],
                        "td-2" => ["data" => $tddata2[$k], "class" => "ins_col_12"],
                    ]
                ];
            }
        } else {



            $tabledata["tr -2"] = [
                "data" => [
                    "td-21" => ["data" => "Data", "class" => "ins_col_12"],
                ]
            ];



            foreach ($new_data as $k => $v) {
                $tabledata["tr-sub$k"] = [
                    "data" => [
                        "td-1" => ["data" => '<li  class="ins_grid"><span style="padding:0 10px" class="ins_col_4 "> ' . $k . '</span> <span style=" padding:0 10px" class="ins_col_8 ins_light">' . $v . '</span>  </li>', "class" => "ins_col_12"],
                    ]
                ];
            }
        }


        $uidata = [
            "table_divs" => ["style" => "width: 100%;margin-top: 25px;", "data" => $tabledata, "class" => "ins_block ins_col_12"],
        ];

        return \lib::_ui()->_data($uidata)->_render();
    }

    function _get_data($data, $olddata)
    {

        $r = '<i  data-lightbox_style="width:50%;height:auto"  data-insaction="ins_tooltip"     data-id="' . $olddata["id"] . '"  class="fas fa-info-circle get_full_data"></i>';




        return $r;
    }

    function _get_olddata($data, $olddata)
    {

        $mydata = json_decode($olddata["old_data"], true);
        unset($mydata["sys_status"]);
        $mydata_l = "";
        foreach ($mydata as $k => $v) {
            $mydata_l .= '<p><b> ' . $k . " </b>: " . $v . ' </p>';
            $mydata .= $k . ": " . $v . ',';
        }
        $mydata = str_replace(["'", "`", '"'], "", $mydata);
        $r = '<i  onclick="ins(\'' . $mydata_l . '\')._ui._to_lightbox(this)" data-lightbox_style="width:50%;height:auto"  data-insaction="ins_tooltip"   data-title="' . $mydata . '"  class="fas fa-info-circle insaction"></i>';
        return $r;
    }

    function _get_newdata($data, $olddata)
    {

        $mydata = json_decode($olddata["new_data"], true);
        unset($mydata["sys_status"]);
        $mydata_l = "";
        foreach ($mydata as $k => $v) {
            $mydata_l .= '<p><b> ' . $k . " </b>: " . $v . ' </p>';
            $mydata .= $k . ": " . $v . ',';
        }
        $mydata = str_replace(["'", "`", '"'], "", $mydata);
        $r = '<i  onclick="ins(\'' . $mydata_l . '\')._ui._to_lightbox(this)" data-lightbox_style="width:50%;height:auto"  data-insaction="ins_tooltip"   data-title="' . $mydata . '"  class="fas fa-info-circle insaction"></i>';
        return $r;
    }

    function _out()
    {
        /*
       
        $admin = $this->__pages->get_page("admin","sys_history");
        return $admin;*/
        $this->_include('h_s.js');

        return lib::_pages()->get_page("admin", "sys_history");
    }
}
