<?php

class com_upload_data extends ins_com {

    public function __construct() {
        parent::__construct();
    }

    function _do_update($o) {
        $r = "";

        $filepath = $o["filepath"];
        $csv = \lib::_files()->_get_class("csv");
        $data = $csv->_import($filepath);
        $seetings = [];
        foreach ($data[0] as $v) {
            $tmp = explode(":", $v);
            $seetings[$tmp[0]] = $tmp[1];
        }
        $indx = 0;

        if ($o["clear"] == "1") {
            $indx++;
            \lib::_db()->_delete($seetings["table"], '1=1');
            $r = "<div class='c_row_cancel ins_col_4'> $indx -  Old Data  ........ Cleared " . "</div>";
        }



        for ($i = 2; $i < count($data); $i++) {
            $indx++;

            $update_data = [];
            for ($is = 0; $is < count($data[$i]); $is++) {
                $update_data[$data[1][$is]] = $data[$i][$is];
            }



            if (is_numeric($update_data["id"])) {


                if ($update_data["id"] !== "") {
                    $old_row = \lib::_db()->_get_deleted()->_get_disabled()->_get_row($seetings["table"], "*", '`id`="' . $update_data["id"] . '"');
                }


                if (is_array($old_row) && $update_data["id"] !== "") {
                    if ($o["exists_row"] == "update") {



                        \lib::_db()->_update($seetings["table"], $update_data, 'id=' . $update_data["id"]);

                        $r .= "<div class='c_row_update ins_col_4'>$indx - Row Id: " . $update_data["id"] . "........ Updated " . "</div>";
                    } else if ($o["exists_row"] == "skip") {
                        $r .= "<div class='c_row_skip ins_col_4'>$indx -Row Id: " . $update_data["id"] . "........ Skipped" . "</div>";
                    } else if ($o["exists_row"] == "cancel") {
                        $r .= "<div class='c_row_cancel ins_col_4'>$indx - Row Id: " . $update_data["id"] . "........ Cancelled operation " . "</div>";
                        break;
                    }
                } else {
                    $id = \lib::_db()->_insert($seetings["table"], $update_data);
                    $r .= "<div class='c_row_insert ins_col_4'>$indx - Row Id: " . $update_data["id"] . "........ Inserted </div>";
                }
            }
        }
        return $r;
    }

    function _upload_data($r) {

        $filepath = "/" . $r["filepath"]; //"ins_upload/5e454c71ee354_com_aca_student_schedule_5e454c5a71d4a.csv";
        $csv = \lib::_files()->_get_class("csv");


        $data = $csv->_import($filepath);


        $seetings = [];
        foreach ($data[0] as $v) {
            $tmp = explode(":", $v);
            $seetings[$tmp[0]] = $tmp[1];
        }




        $data = [
            "start" => ["class" => " ins_grid bu_data_info"],
            "start-row1" => ["class" => " ins_grid ins_col_12", ""],
            "span-1" => ["class" => "ins_col_2", "data" => "Table", "data-ar" => "جدول"],
            "h4-1" => ["class" => "ins_col_6", "data" => $seetings["table"]],
            "end-row1" => ["class" => ""],
            "start-row2" => ["class" => " ins_grid ins_col_12", ""],
            "span-2" => ["class" => "ins_col_2", "data" => "Created Date", "data-ar" => "تاريخ انشاء البيانات"],
            "h4-2" => ["class" => "ins_col_6", "data" => $seetings["date"]],
            "end-row2" => ["class" => "blks_data"],
            "start-row3" => ["class" => " ins_grid ins_col_12", ""],
            "span-3" => ["class" => "ins_col_2", "data" => "Created User" , "data-ar" => "  المستخدم الذى انشئ البيانات"],
            "h4-3" => ["class" => "ins_col_6", "data" => $seetings["user_title"]],
            "end-row3" => ["class" => ""],
            "line-5" => ["class" => "   ins_col_12"],
            "clear-row3" => ["title" => "Clear all data before upload",
            
            "title-ar" => "حذف البيانات القديمة قبل الرفع",
            
            "type" => "bool", "class" => "clear_all_data", "value" => "0", "pclass" => "ins_col_12"],
            "start-3" => ["class" => " ins_grid ins_col_6 ins_update_options"],
            "h4-row3" => ["data" => "If row exists","data-ar" => "إذا كان  صف البيانات موجود من قبل  ", "class" => "ins_col_12 ui_label"],
            "exists_row-update" => ["checked" => "checked", "style" => 'width: 25px;', "input" => true, "type" => "radio", "value" => "update", "title" => "Update row", "title-ar" => "تحديث الصف  ", "pclass" => "ins_col_4 ins_inline"],
            "exists_row-Skip" => ["style" => 'width: 25px;', "input" => "true", "type" => "radio", "value" => "skip", "title" => "Skip row", "title-ar" => "تخطى الصف ", "pclass" => "ins_col_4 ins_inline"],
            "exists_row-Cancel" => ["style" => 'width: 25px;', "input" => "true", "type" => "radio", "value" => "cancel", "title" => "Cancel operation", "title-ar" => "الغاء العمليه ", "pclass" => "ins_col_4 ins_inline", "class" => "ins_col_4"],
            "end-3" => [],
            "line-2" => ["class" => "   ins_col_12"],
            "button-row3" => ["class" => "do_update_button ins_col_4", "data" => "Update", "data-ar" => "تحديث", "data-filepath" => $filepath],
            "end" => [],
            "line-2333" => ["class" => "   ins_col_12"],
            "start-2" => ["class" => " ins_grid bu_console ins_col_12 ins_light ", "style" => "padding:25px;"],
            "end-2" => []
        ];

        return \lib::_ui()->_data($data)->_render();
    }

    function _upload_form() {
        $data = [
            "start" => ["class" => " ins_grid", ""],
            "image" => ["type" => "image", "pclass" => "ins_col_12", "name" => "upload", "class" => "fileuploadwe", "data-path" => "$path", "data-oncomplete" => "af_upload"],
            "button" => ["class" => "ins_col_12 upload_data_btn", "style" => "font-size: 16px;", "data-ar" => 'رفع ملف', "data" => '  Upload File   '],
            "end" => []
        ];

        return \lib::_ui()->_data($data)->_render();
    }

    function _out() {


        $data = [
            "start" => ["class" => " ins_grid bu_data", ""],
            "start-bar" => ["class" => " ins_grid ins_col_12 ins_toolbar ", "style" => "padding:10px;"],
            "span" => [
                "data-lb_style" => "height:250px;width:500px;",
                "data-lb_title" => "Upload File",
                
                
                "class" => "ins_col_6 upload_file_btn",
                "style" => "font-size: 16px;", "data" => '<i class="fas fa-file-upload"></i> Upload File   '
            
            
                , "data-ar" => '<i class="fas fa-file-upload"></i> ' .'رفع ملف'
            
          
            ],
            "end-bar" => [],
            "div" => ["class" => "blks_data ins_col_12", "data" => ""]
        ];

        $this->_r = \lib::_ui()->_data($data)->_render();

        $this->_include("my_style.css");
        $this->_include("sg.js");

        return $this->_r;
    }

}
