<?php

class sys_menus_items extends ins_com {

    public function __construct() {
        parent::__construct("sys_menus/sys_menus_items");
    }

    function _get_parents($rq) {

        return \ins::_ui()->_html()->_get_select_options([
                    "tree" => "true", "tree_field" => "parent_id",
                    "select_type" => "db", "select_table" => "sys_menus_items", "select_query" => "cat_id='" . $rq["cat_id"] . "'"]);

       
    }

   static function _get_modules($rq) {
   $area = $rq["area"];
        $coms = \lib::_app_map("/")->coms_folder;
        if ($area != "root") {
            $coms = "/" . $area . $coms;
        }



    $ls= \lib::_files()->_get_folder_links($coms, $rq["area"], "com_", true, "com");


  return ins::_ui()->_data(
                        [
                            "start" => ["class" => "ins_op_blocks"],
                            "h4" => ["style" => "text-align: center;width: 100%;", "data" => " please choose type for ad Block to  " . $rq["area_title"] . " area or <span class='ins_dark ins_change_area'> change area</span>"],
                            "div" => ["data" =>   $ls]
                            ,
                            "end" => []
                        ]
                )->_render();




    }

static    function _get_areas() {
        $r = "";
        $rs = \lib::_options()->areas;

        $data = [
            "start" => ["class" => "ins_op_blocks ins_grid"],
            "h4" => ["style" => "text-align: center;", "class" => "ins_col_12", "data" => " please choose area to add Block t"],
        ];
        foreach ($rs as $k => $v) {
            $data[] = ["type" => "div", "data" => $k, "data-area" => $v["url"], "class" => 'ins_card ins_col_6 ins_text_tocenter  ins_m_area'];
        }
        $data[] = ["type" => "end"];


        return ins::_ui()->_data(
                        $data
                )->_render();

        return $r;
    }

    function _out() {
        $_GET = \lib::_eng()->_get();

        if ($_GET["mode"] == "edit" && $_GET["type"] != "get_apps") {
            $data = \lib::_db()->_get_disabled()->_get_row($this->thisCom, "*", "id=:myid", ["myid" => $_GET["id"]]);

         
         
            if (is_array($data)) {
              
                if (!isset($_GET["type"])) {
                    echo $data["type"];
                    $_GET["type"] = $data["type"];
                }
                if (!isset($_GET["data_area"])) {
                    $_GET["data_area"] = $data["sys_area"];
                }
            }


            print_R($_GET);
        }



 

        $page_admin = lib::_pages()->_get_class("admin", "sys_menus_items");

      

        if ((isset($_GET["type"]) || $_GET["type"] !== "")) {
            $_POST["type"] = "";
            if ((isset($_GET["parent"]) || $_GET["parent"] !== "")) {
                $_POST["type"] = $_GET["parent"] . "/";
            }


            $_POST["type"] .= $_GET["type"];
        }

        
         if (isset($_POST["title"])) {

            foreach ($_POST as $k => $v) {
                if ($v == "") {

                    unset($_POST[$k]);
                }
            }
        }
        
        return $this->__ui->
                        _data(["div" => ["data" => $page_admin->_render(), "class" => "ins_block col12"]])
                        ->_render();
    }

    function get_areas() {
        $r = "";
        $rs = \lib::_options()->areas;

        $r = "<div class='areas_blocks blocks'>"
                . "<ul>";
        foreach ($rs as $k => $v) {
            $r .= "<li class='items_block'><a href='" . \lib::_eng()->_url(["data_area" => $v["url"], "type" => "get_apps"]) . "'>$k</a></li>";
        }
        $r .= "</ul></div>";
        return $r;
    }

}
