<?php

class sys_modules extends ins_com {

    public function __construct() {
        parent::__construct("sys_modules");
    }

    function _get_modules($rq) {
        $area = $rq["area"];
        $mods = \lib::_app_map("/")->mods_folder;
        if ($area != "root") {
            $mods = "/" . $_GET["data_area"] . $mods;
        }


        return ins::_ui()->_data(
                        [
                            "start" => ["class" => "ins_op_blocks"],
                            "h4" => ["style" => "text-align: center;width: 100%;", "data" => " please choose type for ad Block to  " . $rq["area_title"] . " area or <span class='ins_dark ins_change_area'> change area</span>"],
                            "div" => ["data" => \lib::_files()->_get_folder_links($mods, $rq["area"], "mod_",true,"mod")]
                            ,
                            "end" => []
                        ]
                )->_render();
    }

    function _get_areas() {
        $r = "";
        $rs = \lib::_options()->areas;

        $data = [
            "start" => ["class" => "ins_op_blocks ins_grid"],
            "h4" => ["style" => "text-align: center;", "class" => "ins_col_12", "data" => " please choose area to add Block t"],
        ];
        foreach ($rs as $k => $v) {
            $data[] = ["type" => "div", "data" => $k, "data-area" => $v["url"], "class" => 'ins_card ins_col_6 ins_text_tocenter  ins_m_area'];
        }
        $data[] = ["type" => "end"];


        return ins::_ui()->_data(
                        $data
                )->_render();

        return $r;
    }

    function _out() {

        $_f = \lib::_data()->_get_filter_toarray();
        $_GET = \lib::_eng()->_get();
        if (!isset($_GET["data_area"])) {
            if (isset($_f["for_area"])) {
                $_SESSION["data_area"] = $_f["for_area"];
            } else {
                $_SESSION["data_area"] = "root";
            }
        } else {

            $_SESSION["data_area"] = $_GET["data_area"];
        }


        if ($_GET["mode"] == "edit" && $_GET["type"] != "get_apps") {
            $data = \lib::_db()->_get_disabled()->_get_row($this->thisCom, "*", "id=:myid", ["myid" => $_GET["id"]]);

            if (is_array($data)) {
                if (!isset($_GET["type"])) {
                    $_GET["type"] = $data["type"];
                }
                if (!isset($_GET["data_area"])) {
                    $_GET["data_area"] = $data["sys_area"];
                }
            }
        }

        $page_admin = lib::_pages()->_get_class("admin", "sys_modules");
        return ins::_ui()->_data(["div" => ["data" => $page_admin->_render(),
                        "data-url" => ins::_app_map()->_url([], ["type", "data_area", "parent"]),
                        "class" => " ins_s_mod_data"]]
                )->_render();
    }

    function get_areas() {
        $r = "";



        //   $this->_include()
        $rs = \lib::_options()->areas;


        $r = "<div class='areas_blocks blocks'>"
                . "<ul>";

        foreach ($rs as $k => $v) {
            $r .= "<li class='items_block'><a href='" . \lib::_eng()->_url(["data_area" => $v["url"], "type" => "get_apps"]) . "'>$k</a></li>";
        }
        $r .= "</ul></div>";

        return $r;
    }

}
