<?php

class users_data_report extends ins_com {

    public function __construct() {
        parent::__construct();
    }

    function updateassword() {
        if (isset($_POST["password"]) && !isset($_POST['dologin'])) {

            if (isset($_POST["password"])) {
                if ($_POST["password"] != "") {
                    $_POST["password"] = md5($_POST["password"]);
                } else {
                    unset($_POST["password"]);
                }
            }
        }
    }

    function _charts($end_ColumnChart, $all) {

        $r = '<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
';

        $r .= lib::_ui()->_data(["h3" => ["class" => "col9",
                        "style" => '    
                text-align: center;
    margin-bottom: -63px;
    position: RELATIVE;
    padding-top: 43px;
    z-index: 1;'
                        , "data" => $this->_lang["reg_number"] . $all]])->_render();

        $r .= lib::_ui()->_data(["h3" => ["class" => "col8",
                        "style" =>
                        ' text-align: right;
    margin-bottom: -90px;
    position: RELATIVE;
    padding-top: 90px;
    z-index: 1;
    right: 36px;'
                        , "data" => $this->_lang["top_10"]]])->_render();

        $r .= \lib::_ui()->_data(
                        ["type" => "ColumnChart", "class" => "col9", "data" => $end_ColumnChart, "style" => "height:300px;", "limit" => 10]
                        , "chart")->_render();
        $r .= \lib::_ui()->_data(
                        ["PieChart" => ["class" => "col3", "data" => $end_ColumnChart, "3d" => "true", "style" => "height:300px;", "limit" => 10]]
                        , "chart")->_render();


        $r .= lib::_ui()->_data(["h3" => ["class" => "col9",
                        "style" => '    
                text-align: center;
    margin-bottom: -40px;
    position: RELATIVE;
    padding-top: 43px;
    z-index: 1;'
                        , "data" => $this->_lang["reg_number"] . $all]])->_render();




        $r .= \lib::_ui()->_data(
                        ["type" => "ColumnChart", "class" => "col9", "data" => $end_ColumnChart, "style" => "height:300px;"]
                        , "chart")->_render();

        $r .= \lib::_ui()->_data(
                        ["PieChart" => ["class" => "col3", "data" => $end_ColumnChart, "3d" => "true", "style" => "height:300px;"]]
                        , "chart")->_render();

        return $r;
    }

    function report($rpdata, $all) {

        $r = "";
        foreach ($rpdata as $k => $v) {
            $url = $this->__eng->_url(["filter" => 'country;' . $k]);
            $chref = lib::_ui()->_data(["a" => ["href" => $url, "data" => $v]])->_render();
            $r .= lib::_ui()->_data([
                        "start" => ["class" => "report  exm "],
                        "label" => ["data" => $k],
                        "span" => ["data" => $chref],
                        "end" => []
                    ])->_render();
        }
        $r .= lib::_ui()->_data([
                    "start" => ["class" => "report col12 light exm"],
                    "label" => ["data" => $this->_lang["all"]],
                    "span" => ["data" => $all],
                    "end" => []
                ])->_render();

        return $r;
    }

    function admin() {


        $this->updateassword();
        $get = \lib::_eng()->_get();

        if ($get["mode"] == "edit") {
            $act_data = \lib::_db()->_get_row("com_user_activity", "*", "user_id=:user_id and objct_type=:objct_type", ["objct_type" => "acception_exam", "user_id" => $get["id"]]);
            if (is_array($act_data)) {
                $act_sub_data = \lib::_db()->_get_data("com_user_sub_activity", "*", "act_id=:id", ["id" => $act_data["id"]]);
                foreach ($act_sub_data as $d) {
                    $allr += $d["result"];
                }
                $data["exam_status"] = $act_data["act_status"];
                $data["exam_q_numbers"] = count($act_sub_data);
                $data["exam_result"] = $allr . "/" . count($act_sub_data);
                $data["exam_result_per"] = (( $allr / count($act_sub_data)) * 100) . "%";
            } else {
                $data["exam_status"] = "no_eaxm";
            }






            foreach ($data as $k => $v) {

                $r .= lib::_ui()->_data([
                            "start" => ["class" => "report exm"],
                            "label" => ["data" => $this->_lang[$k]],
                            "span" => ["data" => $v],
                            "end" => []
                        ])->_render();
            }
        }

        return $r . lib::_pages()->get_page("admin", "sys_users");
    }

    function _out() {


        $this->_include("myscript.js", "", "head");


        $countries = \lib::_db()->_get_query(" select `country`, count(country) as mycount from `sys_users` group by `country`");
        //  $r .= $this->geochart($countries);

        $path = "/ins_lib/includes/xml/";
        $path .= "countries.xml";
        $cccs = \lib::_files()->loadfile($path, "properties")->out["countries"];


        $rpdata = [];
        foreach ($countries as $k => $c) {

            if (isset($cccs[$c["country"]]["data_value"])) {
                $c["country"] = $cccs[$c["country"]]["data_value"];
            }

            $rpdata[$c["country"]] = $c["mycount"];
        }
        $rpdata_order = [];


        $m = 0;
        foreach ($countries as $k => $c) {



            if (isset($cccs[$c["country"]]["data_value"])) {
                $c["country"] = $cccs[$c["country"]]["data_value"];
            }


            $rpdata[$c["country"]] = $c["mycount"];
        }


        $all = 0;
        foreach ($rpdata as $k => $v) {
            if (empty($k)) {
                unset($rpdata[$k]);
                $rpdata[$this->_lang["no_country"]] = $v;
            }
            $all += $v;
        }

        arsort($rpdata);


        $end_ColumnChart[0] = ['"Element"', '"Density"', "{ role: 'style'}"];
        foreach ($rpdata as $k => $v) {
            array_push($end_ColumnChart, ["'$k'", "$v", "'#08778b'"]);
        }




        $r .= lib::_ui()->_data([
                    "div" => ["class" => "print_area charts_area", "data" => $this->bar("charts_area") . $this->_charts($end_ColumnChart, $all)]
                ])->_render();

        $r .= lib::_ui()->_data([
                    "div" => ["class" => "print_area reportr_area", "data" => $this->bar("reportr_area") . $this->report($rpdata, $all)]
                ])->_render();

        $r .= lib::_ui()->_data([
                    "div" => ["class" => "print_area admin_area", "data" => $this->admin($end_ColumnChart, $all)]
                ])->_render();

        return $r;
    }

    function bar($type) {

        $ldata[22525] = ["type" => "a",
            "href" => "#",
            "class" => "print_area", "data-print" => $type,
            "title" => $this->__eng->_get_gen_word("export csv"),
            "data" => $this->icon("fa-print")];


        $ldata[2255] = ["type" => "a",
            "href" => $this->__eng->_url(["get_tmp_index" => "ins_main",
                "render_type" => "table_data", "action" => "false", "defaultview" => "csv"]),
            "title" => $this->__eng->_get_gen_word("export csv"),
            "data" => $this->icon("fa-file-excel-o")];

        $ldata[225] = ["type" => "a",
            "href" => $this->__eng->_url(["get_tmp_index" => "ins_main",
                "render_type" => "table_data", "action" => "false", "defaultview" => "csv"]),
            "title" => $this->__eng->_get_gen_word("export csv"),
            "data" => $this->icon("fa-angle-down")];




        return $this->__ui->_data(["div" => ["style" => "    clear: both;
    text-align: right;
    font-size: 16px;
    margin: 10px 0; padding: 10px;
    background: #eee;", "data" => $this->__ui->_data($ldata)->_render()]])->_render();
    }

    private function icon($icon) {


        return $this->__ui->_data(
                        [
                            ["type" => "icon", "data" => $icon]
                        ]
                )->_render();
    }

}
?>


<div class='data_style'>
</div>



<style>

    @page {
        size: A4;
        margin: 0;
    }
    @media print {
        html, body {

        }
        /* ... the rest of the rules ... */
    }

</style>