<?php

class sys_wiki_help extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    var $_cat = "0";
    var $_r = "";

    function _bc_cat(&$data, $_Cat_id)
    {

        $data_sql = ins::_db()->_get_row("sys_wiki_help_categories", "*", "id=$_Cat_id ");


        if (is_array($data_sql)) {
            $data[] = $data_sql;
            $this->_bc_cat($data, $data_sql["cat_id"]);
        }
    }

    function _bc()
    {

        $data = [];

        $data[] = ["title" => "home", "alias" => ""];
        $this->_bc_cat($data, $this->_cat);
        $rdata = [];


        $rdata[] = ["type" => "start", "class" => "ins_col_12 ins_bc"];



        foreach ($data as $d) {
            $rdata[] = ["type" => "a", "href" => ins::_app_map()->_url(["mode" => $d["alias"]], ["id"]), "data" => $d["title"] . "<span> / </span>"];
        }
        $rdata[] = ["type" => "end"];
        $this->_r .= ins::_ui()->_data($rdata)->_render();
    }

    function get_categores()
    {

        $r = "";
        $data_sql = ins::_db()->_get_data("sys_wiki_help_categories", "*", "  cat_id=$this->_cat   order by `sys_order`");

        $rdata = [];
        $rdata[] = ["type" => "start", "data" => "ul", "class" => "ins_col_12  ins_wiki_categories ins_texttocenter"];

        foreach ($data_sql as $d) {


            $rdata[] = ["type" => "a", "href" => ins::_app_map()->_url(["mode" => $d["alias"]]), "data" => $d["title"], "class" => "ins_col_3 ins_light", "style" => "margin: 4px 0;float:none;padding:10px"];
        }
        $rdata[] = ["type" => "end", "data" => "ul"];


        $this->_r .= ins::_ui()->_data($rdata)->_render();
    }

    function get_content()
    {
        $r = "";
        $data_sql = ins::_db()->_get_data("sys_wiki_help", "*", ins::_data()->_db_create_where_to_group($this->_cat) . "   order by `sys_order`");
        $rdata = [];

        if (count($data_sql) > 0) {
            $rdata[] = ["type" => "start", "data" => "ul", "class" => "ins_col_12  ins_wiki_content ins_texttocenter"];
            foreach ($data_sql as $d) {
                $rdata[] = ["type" => "a", "href" => ins::_app_map()->_url(["id" => $d["alias"]]), "data" => $d["title"], "class" => "ins_col_12 "];
            }
            $rdata[] = ["type" => "end"];
        }



        $this->_r .= ins::_ui()->_data($rdata)->_render();
    }

    function get_item()
    {

        $data_sql = ins::_db()->_get_row("sys_wiki_help", "*", "  alias='" . ins::_app_map()->_get()["id"] . "'");

        $rdata = [];
        $rdata[] = ["type" => "start", "data" => "ul", "class" => "ins_col_12  ins_wiki_item"];
        $rdata[] = ["type" => "h2", "data" => $data_sql["title"], "class" => "ins_col_12 "];
        $rdata[] = ["type" => "div", "data" => $data_sql["content"], "class" => "ins_col_12 "];
        $rdata[] = ["type" => "end"];

        $this->_r .= ins::_ui()->_data($rdata)->_render();
    }

    function _side_bar_content(&$rdata, $cat_id, $rq)
    {


        $data_sql = ins::_db()->_get_data("sys_wiki_help_categories", "*", "  cat_id=$cat_id   order by `sys_order`");
        if (count($data_sql) > 0) {
            $rdata[] = ["type" => "start", "data" => "ul", "class" => "ins_tree_list"];
            foreach ($data_sql as $d) {
                $pmclass = "";
                if (isset($rq["mode"]) && $rq["mode"] == $d["alias"]) {
                    $pmclass = "ins_act";
                }
                $rdata[] = ["type" => "start", "class" => "$pmclass wi_category", "data" => "li"];
                $rdata[] = ["type" => "span", "class" => "", "data" => $d["title"]];


                sys_wiki_help::_side_bar_content($rdata, $d["id"], $rq);
                $rdata[] = ["type" => "start", "data" => "ul"];
                $data_c_sql = ins::_db()->_get_data("sys_wiki_help", "*", ins::_data()->_db_create_where_to_group($d["id"]) . "   order by `sys_order`");
                foreach ($data_c_sql as $sd) {
                    $mclass = "";
                    if (isset($rq["id"]) && $rq["id"] == $sd["alias"]) {
                        $mclass = "ins_act";
                    }
                    $rdata[] = ["type" => "li", "class" => "wi_content $mclass", "data" => "<a href='" . ins::_app_map()->_url(["id" => $sd["alias"], "mode" => $d["alias"]]) . "' >" . $sd["title"] . "</a>"];
                }
                $rdata[] = ["type" => "end", "data" => "ul"];
                $rdata[] = ["type" => "end", "data" => "li"];
            }
            $rdata[] = ["type" => "end", "data" => "ul"];
        }
    }

    function _side_bar_data($rq)
    {

        $rdata = [];
        sys_wiki_help::_side_bar_content($rdata, 0, $rq);

        return ins::_ui()->_data($rdata)->_render();
    }

    function _side_bar($rq)
    {

        $rdata[] = ["type" => "start", "class" => "ins_col_12 wi_side_bar  ins_light", "style" => "padding:5px"];
        $rdata[] = [
            "type" => "search", "placeholder" => 'Search...', "input" => true,

            "data-id" => $rq["id"],
            "data-mode" => $rq["mode"],

            "data" => $data_sql["title"], "class" => "ins_wiki_search ins_col_12 "
        ];



        $rdata[] = ["type" => "start", "class" => "ins_side_bar_data"];
        $rdata[] = ["type" => "div", "data" => $this->_side_bar_data($rq)];
        $rdata[] = ["type" => "end"];
        $rdata[] = ["type" => "end"];
        return ins::_ui()->_data($rdata)->_render();
    }

    function _search($rq)
    {

        $rdata = [];
        $q = $rq["w"];
        $rdata[] = ["type" => "start", "class" => "ins_col_12 wi_side_bar  ins_light", "style" => "padding:5px"];
        $rdata[] = [
            "type" => "i", "class" => "ins_col_12 ins_text_toceneter ins_wiki_search_clear  fas fa-arrow-left ",

            "data-id" => $rq["id"],
            "data-mode" => $rq["mode"],
            "style" => "text-align: center;"
        ];

        if ($q != "") {
            $data_sql = ins::_db()->_get_data("sys_wiki_help", "*", " title like'%$q%'  || content like'%$q%'   order by `sys_order`");


            if (count($data_sql) > 0) {
                $rdata[] = ["type" => "start", "data" => "ul", "class" => "ins_col_12   ins_texttocenter"];
                foreach ($data_sql as $d) {
                    $data_cat_sql = ins::_db()->_get_row("sys_wiki_help_categories", "*", "  id='" . $d["cat_id"] . "'   order by `sys_order`");

                    $rdata[] = ["type" => "a", "href" => $rq["clear_url"] . ins::_app_map()->_url(["id" => $d["alias"], "mode" => $data_cat_sql["alias"]]), "data" => $d["title"], "class" => "ins_col_12 "];
                }
                $rdata[] = ["type" => "end"];
            }
        }
        $rdata[] = ["type" => "end"];
        return ins::_ui()->_data($rdata)->_render();
    }

    function _out()
    {
        if (isset(ins::_app_map()->_get()["mode"])) {
            $data_cat = ins::_db()->_get_row("sys_wiki_help_categories", "*", "  alias='" . ins::_app_map()->_get()["mode"] . "'   order by `sys_order`");
            $this->_cat = $data_cat["id"];
        }



        $this->_bc();



        if (isset(ins::_app_map()->_get()["id"])) {
            $this->get_item();
        } else {
            $this->get_categores();
            $this->get_content();
        }



        return ins::_ui()->_data([
            "div-s" => ["data" => $this->_side_bar(ins::_app_map()->_get()), "class" => "ins_col_4"],
            "div" => ["data" => $this->_r, "class" => "ins_col_8", "style" => "padding:25px"]
        ])->_render();
    }
}
