

<!DOCTYPE html>
<?php
/* @var $tmp \ins_lib\bp\ins_template */

/*
  Array
  (
  [menu_type] => nmenu
  [side_background_] => #1a3048
  [sub_side_background] => #131f2b
  [top_bar_background] => #e3eaf4
  [table_header_background] => #e3e9f5
  )
 */

function create_tmp_style($id) {
    $r = "";

    $data = [
        "ins_style_dark" => ["title" => "dark", "color" => "#333", "color_sub" => "#565656"],
        "ins_style_insya" => ["title" => "insya", "color" => "#1a3048", "color_sub" => "#e3eaf4"],
        "ins_style_bluelight" => ["title" => "darkblue", "color" => "#4d79f6", "color_sub" => "#fff"],
        "ins_style_light" => ["title" => "light", "color" => "#fff", "color_sub" => "#eee"],
    ];
    $uidata = ["start" => ["data" => "ui", "class" => "options_style_list"]];


    foreach ($data as $k => $v) {
        $uidata["li-" . $k] = ["style" => 'background:' . $v["color"], "class" => "ins_col_4 ins_update_temp", "data-id" => $id, "data-name" => "style", "data-value" => $k, "data" => "<span style='background:" . $v["color_sub"] . "'></span>"];
    }
    $uidata["li-w1333"] = ["class" => " line", "data" => ''];



    $uidata["li-w1"] = ["class" => "ins_col_6 temp_width ins_update_temp", "data-id" => $id, "data-name" => "width", "data-value" => "ins_container", "data" => '<i class="fas fa-compress-arrows-alt"></i>'];
    $uidata["li-w2"] = ["class" => "ins_col_6 temp_width ins_update_temp", "data-id" => $id, "data-name" => "width", "data-value" => "ins_fullwidth", "data" => '<i class="fas fa-expand-arrows-alt"></i>'];
    $uidata["li-w13"] = ["class" => " line", "data" => ''];

    if (trim(lib::_eng()->_this_lang) == "ar") {
        $uidata["li-en"] = ["class" => "ins_col_6  sys_site_status", "data-name" => "en", "data-value" => "ins_fullwidth", "data" => 'EN'];
    } else {
        $uidata["li-ar"] = ["class" => "ins_col_6  sys_site_status", "data-name" => "ar", "data-value" => "ins_container", "data" => 'ع'];
    }


    $uidata["end"] = ["data" => "ui"];
    $r = \lib::_ui()->_data($uidata)->_render();

    return $r;
}
?>
<html>
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> 

        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link href="<?= $tmp->_url_full ?>/css/layout.css" rel="stylesheet" type="text/css"/>
        <?= $tmp->_header ?>
        <script src="<?= $tmp->_url_full ?>/js/script.js" type="text/javascript"></script>
        <title>admin - <?= $tmp->_title ?></title>
        <link   href="<?= $tmp->_url_full ?>/css/phone.css" rel="stylesheet" type="text/css" media="only screen and (min-width: 0px) and (max-width: 990px)" />
        <link   href="<?= $tmp->_url_full ?>/css/phone-<?= $this->__eng->_this_lang ?>.css" rel="stylesheet" type="text/css"   media="only screen and (min-width: 0px) and (max-width: 990px)"  />

    </head>
    <body  <?= $tmp->_body_tag ?>  >  
        <?php ?>

        <div  data-uiaction="tocenter" class="body_loader">
            <i class="fa fa-circle-o-notch fa-spin fa-3x fa-fw"></i>
        </div>



        <!--smenu-->
        <section class='   '>
            <?php if (\lib::_usere()->security_area($u, ["login", "forget"])) { ?>
                <div class='top_bar  ins_border_bottom     ins_toolbar'>

                    <span class='ins_data_loader'> </span>

                    <div class='mod notifications  ins_col_1'>
                        <?= $tmp->_module("notifications") ?>
                    </div>


                    <div class='mod users ins_col_2'>
                        <?= $tmp->_module("users") ?>
                    </div>


                    <div class='toceneter bar '>
                        <ul>

                            <li>
                                <i class="fas fa-heart"></i>
                                <div class='mod favorite ins_menu'>
                                    <?= $tmp->_module("favorite") ?>
                                </div>
                            </li>
                            <li><i class="fas fa-cog"></i>
                                <div class='mod setting ins_menu'>
                                    <?= $tmp->_module("setting") ?>
                                </div>
                            </li>
                            <li><i class="fas fa-question-circle "></i>
                                <div class='mod help ins_menu'>
                                    <?= $tmp->_module("help") ?>
                                </div>
                            </li>
                        </ul>
                    </div>


                    <i class="fa _btn_phone_menu fa-bars" aria-hidden="true"></i>

                </div>


                <div class='  side ins_fixed_left ins_panel ins_dark_toolbar'>
                    <span class='side_bt'></span>
                    <div class='ins_app_title ins_border_bottom ins_dark         '>
                        <a href="/ins_admin/">
                            <img src='<?= \lib::_app_map()->upload_folder . $tmp->_site_setting["image"] ?>'/>

                        </a> 
                    </div>


                    <div class='ins_app_sidebar'>

                        <?= $tmp->_module("side") ?>


                        <div class="ins_menu_setting_area ins_dark">

                            <?= create_tmp_style($tmp->template["id"]) ?>
                        </div> 

                        <ul class="bottom_menu">
                            <li class="">      <a href="/ins_admin/"><i class="fas fa-home"></i> </a></li>
                            <li class="ins_menu_setting_btn"><i class="fas fa-cog"></i></li>
                            <li data-id='<?= $tmp->template["id"] ?>' class="menu_mode"><i class="fas fa-bars"></i></li>
                        </ul>

                    </div>

                </div>


                <div class='content-page <?= $tmp->_pro["width"] ?>   '>
                    <h1 class='ins_page_title '>
                        <?= $tmp->_title ?>
                    </h1>

                    <?= $tmp->_main ?>
                </div>
                <div>
                    <?= $tmp->_module("ad_header") ?>
                </div>
                <div>
                    <?= $tmp->_module("footer") ?>
                </div>
                <?php
            } else {
                echo ''
                . ' <div class="ins_login_data ins_border ins_col_5" >'
                . '<img style="max-width: 100%;
    margin: auto;display:block; max-height:300px;"  src="' . \lib::_app_map()->upload_folder . $tmp->_site_setting["image"] . '"/>'
                . '<h2 class="title">' . $tmp->_site_setting["site_title"] . '</h2> <br/>' . $u . '</div>';
                // . '</div>';
            };
            ?>
        </section>

        <div class="ins_message_area"></div>
    </body>
</html>
<style>







</style>


<?php




