<?php

if ($_REQUEST['status'] == "delete") {
    $myFile = $_REQUEST["file"];
    unlink($myFile) or die("Couldn't delete file");
} else {
    $out = [];
    $image_path = \lib::_app_map()->upload_folder;

    $f = substr($image_path, 0, 1);
    if ($f == "/") {
        $image_path = substr($image_path, 1);
    }

    if (isset($_REQUEST['dir'])) {
        $target_dir = $_REQUEST['dir'];
    } else {
        $target_dir = $image_path;
    }
    if (isset($_REQUEST['path'])) {
        $target_dir .= $_REQUEST['path'] . "/";
    }

    $target_dir = str_replace("//", "/", $target_dir);

    if (!file_exists($target_dir)) {
        mkdir($target_dir, 0777, true);
        $out["msg"] .= " ($target_dir) Created.<br/>";
    }
    if (!is_writable($target_dir)) {
        if (!chmod($target_dir, 0666)) {
            $out["msg"] .= "Cannot change the mode of file ($target_dir).<br/>";
        };
    }
    foreach ($_FILES as $F) {


        $ffname = explode(".", $F["name"]);
        $ffname = end($ffname);

        if (isset($_REQUEST['prefix']) || \lib::_config()->site["upload_prefix"]) {
            $F["name"] = uniqid() . "_" . $F["name"];
        }
        if (isset($_REQUEST['perfix'])) {

            $F["name"] = $_REQUEST['perfix'] . "_" . $F["name"];
        }

        $F["name"] = $_REQUEST["filename"] ? $_REQUEST["filename"] . "." . $ffname : $F["name"];




        $target_file = $target_dir . basename($F["name"]);

        $out["status"] = 1;
        $imageFileType = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));
// Check if image file is a actual image or fake image



        $check = getimagesize($F["tmp_name"]);
        /*  if ($check !== false) {
          $out["msg"] .= "File is an image - " . $check["mime"] . ".<br/>";
          $out["status"] = 1;
          } else {
          //  $out["msg"] .= "File is not an image.";
          $out["status"] = 0;
          } */

        if ($_FILES["fileToUpload"]["size"] > 500000) {
            $out["msg"] .= "Sorry, your file is too large.";
            $out["status"] = 0;
        }

        if ($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg" && $imageFileType != "svg" && $imageFileType != "gif" && $imageFileType != "pdf" && $imageFileType != "csv") {
            $out["msg"] .= "Sorry, only JPG, JPEG, PNG & GIF files are allowed.";
            $out["status"] = 0;
        }
        if ($out["status"] == 0) {
            $out["msg"] .= " , Sorry, your file was not uploaded. ";
        } else {

            $out["filepath"] = $target_file;
            $out["name"] = $F["name"];

            if (isset($_REQUEST["path"])) {
                $out["location"] = $_REQUEST["path"] . "/" . $F["name"];
            } else {
                $out["location"] = $F["name"];
            }
            $out["location"] = str_replace("C:\\fakepath\\", "", $out["location"]);
            $out["filepath"] = str_replace("C:\\fakepath\\", "", $out["filepath"]);

            $out["location"] = str_replace("//", "/", $out["location"]);
            $out["filepath"] = str_replace("//", "/", $out["filepath"]);

            if (move_uploaded_file($F["tmp_name"], $target_file)) {
                $out["msg"] .= "The file " . basename($F["name"]) . " has been uploaded.<br/>";
            } else {
                $out["msg"] .= "Sorry, there was an error uploading your file.<br/>";
            }
        }
    }

    echo json_encode($out);
}


