<?php

ini_set("display_errors", 1);
error_reporting(E_ERROR | E_PARSE | E_COMPILE_ERROR);
session_start();


if ($_REQUEST['status'] == "save") {



    $d = $_REQUEST;
    if ($d["attached"] != "1") {
        $d["type"] = "gen";
    }

    \lib::_db()->_insert("mod_labels", $d);
    echo get_labels();
} else if ($_REQUEST['status'] == "delete") {
    \lib::_db()->_delete("mod_labels", "id=:id ", ["id" => $_REQUEST["id"]]);

    echo get_labels();
} else if ($_REQUEST['status'] == "delete_from_obj") {
    obj_labels_update("delete");
} else if ($_REQUEST['status'] == "update") {

    \lib::_db()->_update("mod_labels", $_REQUEST, "id=:id ", ["id" => $_REQUEST["id"]]);
    echo get_labels();
} elseif ($_REQUEST['status'] == "get_labels") {
    echo get_labels();
} elseif ($_REQUEST['status'] == "edit") {
    echo edit();
} elseif ($_REQUEST['status'] == "add") {
    echo add();
} elseif ($_REQUEST['status'] == "add_to_obj") {

    obj_labels_update("add");
} elseif ($_REQUEST['status'] == "update_obj") {
    echo update_obj();
}

function obj_labels_update($action) {


    $w = " `id`='" . $_REQUEST["obj_id"] . "'";

    $old_data = \lib::_db()->_get_row($_REQUEST["type"], "*", " `id`='" . $_REQUEST["obj_id"] . "'");

    $sys_labels = explode(",", $old_data["sys_labels"]);




    switch ($action) {
        case "delete":
            $k = array_search($_REQUEST["id"], $sys_labels);

            unset($sys_labels[$k]);
            break;
        case "add":
            array_push($sys_labels, $_REQUEST["label_id"]);
            break;
    }


    $sys_labels = array_unique(array_filter($sys_labels));



    \lib::_db()->_update($_REQUEST["type"], ["sys_labels" => implode(",", $sys_labels)], $w);
}

function update_obj() {

    // $Data = \lib::_db()->_get_data("mod_labels_xref", "*", "obj_id=:obj_id and obj_type=:obj_type ", ["obj_id" => $_REQUEST["obj_id"], "obj_type" => $_REQUEST["obj_type"]]);
    $r = "";


    $old_data = \lib::_db()->_get_row($_REQUEST["obj_type"], "*", " `id`='" . $_REQUEST["obj_id"] . "'");

    $sys_labels = explode(",", $old_data["sys_labels"]);

    $sys_labels = array_unique(array_filter($sys_labels));


    foreach ($sys_labels as $d) {
        $Datal = \lib::_db()->_get_row("mod_labels", "*", "id='" . $d . "'");

        $r .= \lib::_ui()->_data(["div" => [
                        "class" => "tag_obj_item", "style" => "background-color:" . $Datal["color"], "data" =>
                        '<div  class="tip">'
                        . ''
                        . ''
                        . '<i data-id="' . $Datal["id"] . '" data-objid="' . $old_data["id"] . '"  class="fa fa-times-circle delete_from_obj" aria-hidden="true"></i> ' . $Datal["title"]
                        . '</div>']])->_render();
    }
    return $r;
}

function get_labels() {
    $Data = \lib::_db()->_get_data("mod_labels", "*", " `type`='" . $_REQUEST["type"] . "'   or  `type`='gen' ");

    $r = "";


    $uidata = [];


    $uidata["div-001"] = ["class" => "tag_item ins_light ins_col_1 mod_labels_add", "data" => '<i class="mod_labels_add fa fa-plus" aria-hidden="true"></i>'];


    
    
    foreach ($Data as $d) {
        $uidata["div-" . $d["id"]] = [
            "data-id" => $d["id"],
            "class" => "tag_item ins_col_3", "style"=>"border: 1px solid ". $d["color"] . ";",
            "data" =>
            '<span style="background-color:' . $d["color"] . '"></span>'
            . '<ul><li><i data-id="' . $d["id"] . '"  class="fa fa-cog get_settings" aria-hidden="true"></i></li>' .
            '<li><i   data-filter_field="sys_labels"    data-filter_value="' . $d["id"] . '" class="fa fa-search  bt_item_search  " aria-hidden="true"></i></li></ul>'.
            "<b>". $d["title"]."</b>"];
    }

    $r .= \lib::_ui()->_data($uidata)->_render();



    return $r;
}

function add() {
    return foractions("save","");
}

function edit() {

    $Data = \lib::_db()->_get_row("mod_labels", "*", "id=:id", ["id" => $_REQUEST["id"]]);
    $from = foractions("update", $Data);
    return $from;
}

function foractions($status, $oldata) {
    $data["form_start"] = ["class" => "mod_labels_form grid"];


    if (isset($_REQUEST["id"])) {
        $data["hidden-id"] = ["class" => "co12", "input" => "true", "name" => "id", "value" => $_REQUEST["id"]];
    }

    $data["hidden"] = ["class" => "co12", "input" => "true", "name" => "status", "value" => $status];
    $data["text"] = ["pclass" => "ins_col_12", "input" => "true", "name" => "title", "title" => "title"];
    $data["hidden-2"] = ["class" => "co12", "value" => $_REQUEST["type"], "input" => "true", "name" => "type"];

    if (isset($oldata["title"])) {
        $data["text"]["value"] = $oldata["title"];
    }
    $data["color"] = ["pclass" => "ins_col_12", "input" => true, "type" => "color", "name" => "color", "title" => "Color"];
    if (isset($oldata["color"])) {
        $data["color"]["value"] = $oldata["color"];
    }
    $data["icons"] = ["pclass" => "ins_col_12", "name" => "title", "title" => "title"];
    if (isset($oldata["title"])) {
        $data["icons"]["value"] = $oldata["icons"];
    }

    $data["checkbox"] = ["pclass" => "ins_col_12", "input" => "true", "value" => "1", "name" => "attached", "title" => "only for this component"];


    $data["submit"] = ["pclass" => "ins_col_6", "input" => "true", "value" => "send"];


    if (isset($_REQUEST["id"])) {

        $data["button"] = ["class" => "mod_labels_delete ins_col_6", "data" => "Delete", "data-id" => $_REQUEST["id"]];
    }

    $data["form_end"] = [];

    return \lib::_ui()->_data(
                    $data
            )->_render();
}
