<?php
class com_auc_game extends ins_com
{
    const TBALE_NAME = "com_auc_game";
    const SESSION_GAME = "game";
    const SESSION_DB_GAME =  "game_db_data";
    public function __construct()
    {
        parent::__construct();
    }
    function game_login_form()
    {
        $ui_data[] = ["type" => "start", "class" => "game_login_form ins_grid", "style" => "width: 50%;
        margin: auto;"];
        $ui_data[] = ["type" => "div", "class" => "sp_20 ins_col_12"];
        $ui_data[] = ["type" => "start", "class" => "game_login_form_header ins_grid ins_col_12"];
        $ui_data[] = ["type" => "div", "data-show" => ".new_game", "data" => "Start new game", "class" => "ins_button ins_col_6 ins_act"];
        $ui_data[] = ["type" => "div", "data-show" => ".pervious_game", "data" => "Continue previous game", "class" => "ins_button ins_col_6"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "start", "class" => "new_game_body ins_col_12"];
        $ui_data[] = ["type" => "start", "method" => "post",  "data" => "form", "class" => "new_game"];
        $ui_data[] = [
            "type" => "hidden", "input" => "true",  "name" => "action", "value" => "new_game"
        ];
        $ui_data[] = [
            "type" => "select", "required" => "true",  "title" => "Teacher gender", "name" => "teacher_gender",
            "select_value" => "male,female", "select_text" => "Male,Female"
        ];
        $ui_data[] = [
            "type" => "select", "required" => "true", "title" => "Subject", "name" => "subject",
            "select_value" => "Science,Maths,Languages", "select_text" => "Science,Maths,Languages"
        ];
        $ui_data[] = [
            "type" => "select", "required" => "true", "title" => "Years of experience", "name" => "experience",
            "select_text" => "1-5 years,6-10 years,11-15 years ,11-15 years,More than 16"
        ];
        $ui_data[] = [
            "type" => "select",  "required" => "true", "title" => "Region of teaching", "name" => "region",
            "select_text" => "Cairo,Upper Egypt,Suez Canal Area,North Egypt"
        ];
        $ui_data[] = [
            "type" => "select",  "required" => "true", "title" => "Are you teaching in a STEM school", "name" => "teaching_stem",
            "select_text" => "Yes,No"
        ];
        $ui_data[] = [
            "type" => "textarea", "style" => "height:150px;", "title" => "Why did you choose teaching this unit?", "name" => "unit",
        ];
        $ui_data[] = ["type" => "div", "class" => "sp_20 ins_col_12"];
        $ui_data[] = ["type" => "button", "data" => "Continue", "class" => "ins_to_right"];
        $ui_data[] = ["type" => "end", "data" => "form"];
        $ui_data[] = ["type" => "start", "data" => "form", "method" => "post", "class" => "pervious_game ins_grid ins_hidden ins_col_12"];
        $ui_data[] = [
            "type" => "hidden", "input" => "true",  "name" => "action", "value" => "pervious_game"
        ];
        $ui_data[] = ["type" => "div", "class" => "sp_20 ins_col_12"];
        $ui_data[] = ["type" => "div", "class" => " ins_col_2"];
        $ui_data[] = [
            "type" => "text", "input" => "true", "required" => "true",  "name" => "code", "pclass" => "ins_col_8",
            "title" => "Enter Your game code?",
        ];
        $ui_data[] = ["type" => "div", "class" => " ins_col_4"];
        $ui_data[] = ["type" => "button", "data" => "Continue", "class" => "ins_to_right ins_col_4"];
        $ui_data[] = ["type" => "end", "data" => "form"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    /**
Messages
     */
    static function _msg($rq)
    {
        $ui_data[] = ["type" => "start", "class" => "_g_msg_cont"];
        $ui_data[] = ["type" => "start", "class" => "_g_msg"];
        $ui_data[] = ["type" => "icon", "data" => "x", "color" => "#fff", "pstyle" => "position: absolute;right: 13px;top: 13px;"];
        $ui_data[] = ["type" => "div", "class" => "sp_60"];
        $ui_data[] = ["type" => "h2", "data" => $rq["title"]];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $ui_data[] = ["type" => "button", "data" => "Close", "class" => "red _g_msg_close"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    static   function _wrong_msg($rq)
    {
        $answers =  json_decode($rq["answers"], true);
        $s_classes = ["", "", ""];
        $i = 0;
        foreach ($answers as $asw) {
            $s_classes[$i] = $asw["status"];
            $i++;
        }
        if (count($answers) < 3) {
            $x_class = "_g_try_again";
        } else {
            $x_class = "_g_next_btn";
        }
        $ui_data[] = ["type" => "start", "class" => "_g_msg_cont"];
        $ui_data[] = ["type" => "start", "class" => "_g_msg"];
        //$ui_data[] = ["type" => "icon", "data" => "x", "color" => "#fff", "data-op" => "$x_class", "pstyle" => "position: absolute;right: 13px;top: 13px;"];
        $ui_data[] = ["type" => "div", "class" => "sp_40"];
        $ui_data[] = ["type" => "start", "style" => "", "class" => ""];
        $ui_data[] = ["type" => "icon", "data" => "star", "class" => $s_classes[0], "color" => "#F5EABD"];
        $ui_data[] = ["type" => "icon", "data" => "star", "class" => $s_classes[1], "color" => "#F5EABD"];
        $ui_data[] = ["type" => "icon", "data" => "star", "class" => $s_classes[2], "color" => "#F5EABD"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "h2", "data" => "Oops Wrong!"];
        if (count($answers) < 3) {
            $ui_data[] = ["type" => "h5", "data" => "You lost a life"];
        } else {
            $ui_data[] = ["type" => "h5", "data" => "You lost all lives"];
        }
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        if (count($answers) < 3) {
            $ui_data[] = ["type" => "button", "data" => "Try again", "class" => "red  _g_try_again"];
        } else {
            $ui_data[] = ["type" => "button", "data" => "Next Team", "class" => "red  _g_next_btn"];
        }
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return  ins::_ui()->_data($ui_data)->_render();
    }
    static function _right_msg($rq)
    {
        $ui_data[] = ["type" => "start", "class" => "_g_msg_cont"];
        $ui_data[] = ["type" => "start", "class" => "_g_msg"];
        //$ui_data[] = ["type" => "icon", "data" => "x", "data-op" => "_g_next_btn", "color" => "#fff", "pstyle" => "position: absolute;right: 13px;top: 13px;"];
        $ui_data[] = ["type" => "div", "class" => "sp_60"];
        $ui_data[] = ["type" => "h2", "data" => "Great Job!"];
        $ui_data[] = ["type" => "h5", "data" => "You’re done with {$rq["level_title"]} "];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $ui_data[] = ["type" => "button", "data" => "Next Team", "class" => "red _g_next_btn"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    static function _start_msg($rq)
    {
        $ui_data[] = ["type" => "start", "class" => "_g_msg_cont"];
        $ui_data[] = ["type" => "start", "class" => "_g_msg"];
        $ui_data[] = ["type" => "icon", "data" => "x", "data-op" => "_g_do_start", "color" => "#fff", "pstyle" => "position: absolute;right: 13px;top: 13px;"];
        $ui_data[] = ["type" => "div", "class" => "sp_60"];
        $ui_data[] = ["type" => "h2", "data" => $rq["team"] . "'s Turn"];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $ui_data[] = ["type" => "button", "data" => "Let’s go!", "class" => "red _g_do_start"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    static function  _attchevment($rq)
    {
        $type = $rq["type"];
        $title = "Golden";
        $des = "Most Accurate";
        if ($type == "golden") {
            $title = "Golden";
            $des = "Most Accurate";
        } else if ($type == "silver") {
            $title = "Silver";
            $des = "Fastest Team";
        } else if ($type == "thanks") {
            $title = "Distinguished";
            $des = "Player";
        }
        $ui_data[] = ["type" => "start", "class" => "_g_achievement ins_col_6 $type"];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $ui_data[] = ["type" => "div", "class" => "image"];
        $ui_data[] = ["type" => "h4", "data" => $title];
        $ui_data[] = ["type" => "h5", "data" => $des];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    static function  _end_level_msg($rq)
    {
        $game_data =  $_SESSION["game"];

     
        $levels =   json_decode($rq["answers"], true);
        $db_data = ["game" => $_SESSION["game"], "answers" => $rq["answers"], "points" => $rq["points"], "level" => $rq["next"]];
        ins::_db()->_update(self::TBALE_NAME, ["data" => json_encode($db_data)], "id=" . $_SESSION[self::SESSION_DB_GAME]["id"]);
        $ui_data[] = ["type" => "start", "class" => "_g_msg_cont"];
        $ui_data[] = ["type" => "start", "style" => "padding:40px;    width: 1224px;
                height: 629px;", "class" => "_g_msg"];


        if ($rq["title"] != "Level 4") {

            $ui_data[] = ["type" => "icon", "data" => "x", "color" => "#fff", "data-op" => "_g_next_level_btn",  "pstyle" => "position: absolute;right: 13px;top: 13px;"];
        }

        $ui_data[] = ["type" => "div", "class" => "sp_60"];
        $ui_data[] = ["type" => "h5", "class" => "ins_text_toleft", "data" => "<span class='color_yellow '>{$rq["title"]}:</span> Results"];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $ui_data[] = ["type" => "start", "class" => "ins_grid"];
        $_wrongs = [];
        $_all_answers = [];
        $_times = [];

        foreach ($levels as $level) {

            for ($t = 0; $t < count($game_data); $t++) {
                if (isset($_all_answers[$t])) {
                    $_all_answers[$t] += count($level[$t]);
                } else {
                    $_all_answers[$t] = count($level[$t]);
                }
                foreach ($level[$t] as $ns) {
                    $aim = explode(":", $ns["time"]);
                    $ms = (trim($aim[0]) * 60);
                    $ms += trim($aim[1]);
                    $_times[$t] +=  $ms;
                    if ($ns["status"] == "wrong") {
                        if (isset($_all_answers[$t])) {
                            $_wrongs[$t] += 1;
                        } else {
                            $_wrongs[$t] = 1;
                        }
                    }
                }
            }
        }







        $t = 0;
        foreach ($game_data as $g) {





            if (!isset($_wrongs[$t])) {
                $_wrongs[$t] = 0;
            }



            $p = round(((3 * count($levels)) - $_wrongs[$t]) / $_all_answers[$t] * 100);


            $is_faster = true;
            foreach ($_times as $it) {
                if ($_times[$t] > $it) {
                    $is_faster = false;
                }
            }
            $ui_data[] = ["type" => "start", "class" => "  ins_col_3 ins_container_border_r10"];
            $ui_data[] = ["type" => "start", "class" => "   bg_red ins_grid"];
            $ui_data[] = [
                "type" => "h4", "data" =>   $p . "% " . $g["title"],
                "class" => "   ins_col_6 ins_text_toleft  color_white", "style" => "padding:16px 8px ;    font-size: 18px;"
            ];
            $ui_data[] = ["type" => "start", "style" => "    font-weight: normal;", "class" => "ins_col_6 padding_left_16 border_left"];
            $cls = ["right", "right", "right"];
            if ($p < 100) {
                $cls[2] = "wrong";
            }
            if ($p < 50) {
                $cls[1] = "wrong";
            }
            if ($p < 20) {
                $cls[0] = "wrong";
            }
            $a = "";
            if ($p == 100) {
                $a = com_auc_game::_attchevment(["type" => "golden"]);
            }
            if ($is_faster) {
                $a .= com_auc_game::_attchevment(["type" => "silver"]);
            }

            if ($a == "") {
                $a = com_auc_game::_attchevment(["type" => "thanks"]);
            }


            print_R($levels[0][$t]);
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => $cls[0]];
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => $cls[1]];
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => $cls[2]];
            if (isset($rq["next"])  && $rq["next"] == "end") {
                $ui_data[] = ["type" => "span", "style" => "    top: -5px;
            position: relative;
            font-size: 23px;
            margin-left: 5px;
            margin-right: 5px;
            font-weight: bold;", "data" => $levels[0][$t][0]["points"]];
            }

            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "div", "data" => $a,   "class" => "white_bg   ins_grid ins_col_12   ", "style" => "align-items: start;padding:16px;height:300px ;    background: #fff;"];
            $ui_data[] = ["type" => "end"];;
            $t++;
        }
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "div", "class" => "sp_20"];
        $next_title = "Next Level";
        if (isset($rq["next_title"])) {
            $next_title = $rq["next_title"];
        }
        if (isset($rq["next"])  && $rq["next"] == "end") {


            $url = ins::_map()->_url([], ["alias", "mode"]);

            $ui_data[] = ["type" => "a", "style" => "margin-left:8px;", "href" => "#", "data" => "End", "class" => "red _go_end  ins_button _g_next_level_btn ins_toright"];

            $url = ins::_map()->_url(["alias" => "game", "mode" => "l4"]);
            $ui_data[] = ["type" => "a", "href" => $url, "data" => $next_title, "class" => "red ins_button _g_next_level_btn ins_toright"];
        } else {
            $url = ins::_map()->_url(["alias" => "game", "mode" => $rq["next"]]);
            $ui_data[] = ["type" => "a", "href" => $url, "data" => $next_title, "class" => "red ins_button _g_next_level_btn ins_toright"];
        }


        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    /**
Helpar
     */
    static function _stage_data($levels, $body, $footer, $time = true, $show_footer = true, $show_buttons = true)
    {
        if ($time) {
            /** Timer */
            $ui_data[] = ["type" => "start", "class" => "_controls ins_text_right a_right  ", "style" => "width:124px"];
            $ui_data[] = ["type" => "h4", "class" => "_g_timer", "data" => "00 : 00", "style" => "display: inline-block; padding: 0 10px;"];
            $ui_data[] = ["type" => "icon", "data" => "arrow", "fill" => "#fff", "pstyle" => " 
        background: #1D8561;  height: 24px;  width: 24px; display: inline-block;  text-align: center;
        line-height: 24px; border-radius: 50%; padding: 3px; padding-left: 6px;
                        "];
            $ui_data[] = ["type" => "end"];
        }
        /** Timer */
        /** body */
        $ui_data[] = ["type" => "div", "class" => "ins_col_12 ", "data" => $body];
        if ($show_footer) {
            /** footer */
            $ui_data[] = ["type" => "start", "class" => "a_bottom ins_col_12"];
            $ui_data[] = ["type" => "div", "class" => "line", "style" => "margin: 0 -20px;width: calc(100% + 40px);"];
            $ui_data[] = ["type" => "div", "class" => "sp_20"];
            $ui_data[] = ["type" => "strong", "data" => "Your turn ", "class" => "color_red _f_18"];
            if ($show_buttons) {
                $ui_data[] = ["type" => "start", "class" => "ins_grid "];
                $ui_data[] = ["type" => "div", "class" => "ins_col_9 _bottom_from ", "data" => $footer];
                $ui_data[] = ["type" => "div", "class" => " ins_col_1"];
                $ui_data[] = ["type" => "start", "class" => "ins_grid ins_col_2"];
                $ui_data[] = ["type" => "button", "data" => "Start", "class" => " _g_start ins_col_6"];
                $ui_data[] = ["type" => "button", "data" => "Go >",  "class" => "_g_go green ins_col_6"];
                $ui_data[] = ["type" => "end"];
                $ui_data[] = ["type" => "end"];
            } else {
                $ui_data[] = ["type" => "start", "class" => "ins_grid "];
                $ui_data[] = ["type" => "div", "class" => "ins_col_12 _bottom_from ", "data" => $footer];
                $ui_data[] = ["type" => "end"];
            }
            /** bottom bar  */
            $ui_data[] = ["type" => "div", "class" => "sp_20"];
            /** end footer */
            $ui_data[] = ["type" => "end"];
        }
        return ins::_ui()->_data($ui_data)->_render();
    }
    function _stage($levels, $body, $footer, $time = true, $show_footer = true, $show_buttons = true)
    {
        $ui_data[] = ["type" => "div", "data" => $this->_header($levels)];
        $ui_data[] = ["type" => "div", "data" => com_auc_game::_stage_data($levels, $body, $footer, $time, $show_footer, $show_buttons), "class" => "info_box stage", "style" => "position: absolute; width: calc(100% - 48px); left: 24px; bottom: 24px;  top:  180px;"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    static function _create_game($rq)
    {
        $_SESSION["game"] = json_decode($rq["game_data"], true);
    }
    static function _g_exit($rq)
    {
        unset($_SESSION[self::SESSION_GAME]);
        unset($_SESSION[self::SESSION_DB_GAME]);
    }
    /**
Intro
     */
    function _s()
    {
        $ui_data = [];
        $ui_data[] = ["type" => "start", "class" => "ins_grid", "style" => "    align-items: start;"];
        $ui_data[] = ["type" => "div", "class" => "sp_20  ins_col_12  "];
        for ($i = 0; $i <= 3; $i++) {
            $ui_data[] = ["type" => "start", "class" => "ins_col_3 ins_container_border_r10 ins_text_tocenter _s_team"];
            $ui_data[] = ["type" => "start", "class" => "bg_red _s_team_title", "style" => "padding:16px"];
            $ui_data[] = ["type" => "h4", "data" => "Team Name", "class" => "color_white"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "strong", "data" => "Add Team member", "class" => "_s_name _label"];
            $ui_data[] = ["type" => "div", "data" => "<span class='inc_plus'></span><a>Create team</a>", "class" => "add_s_name_btn", "style" => "padding:16px"];
            $ui_data[] = ["type" => "end"];
        }
        $ui_data[] = ["type" => "start", "class" => "ins_col_12 info_box a_bottom ins_grid"];
        $ui_data[] = ["type" => "h5", "data" => "Setting up the team", "class" => "title ins_col_12",];
        $ui_data[] = [
            "type" => "div",
            "data" => "Create up to four teams, select a unique name for each team and list the names of each team member. Click on the red header to enter the team name.",
            "class" => "des ins_col_10",
        ];
        $ui_data[] = ["type" => "start", "class" => "ins_col_2   "];
        $url = ins::_map()->_url(["mode" => "l1"]);
        $ui_data[] = ["type" => "button", "data-url" => $url, "data" => "Done", "class" => "  ins_to_right gray _s_done ",];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "end"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    /**
Levels
     */
    static  function _get_game_data($rq)
    {
        $game_data =  $_SESSION["game"];
        return json_encode($game_data);
    }
    function _header($levels)
    {
        $data =  \ins::_db()->_get_row(self::TBALE_NAME, "*", "id=" . $_SESSION[self::SESSION_DB_GAME]["id"]);
        $points = [];
        if (is_array($data)) {
            $oldata = json_decode($data["data"], true);
            $points = json_decode($oldata["points"], true);
        }
        $game_data =  $_SESSION["game"];
        $ui_data[] = [
            "type" => "start", "class" => "ins_grid border_bottom _g_game_data ",
            "style" => "margin:0 -20px;width: calc(100% + 40px);  padding: 0 ;"
        ];
        $ui_data[] = ["type" => "start", "class" => "ins_grid ins_col_11  _g_teams", "style" => "grid-gap: 0;"];
        $i = 0;
        foreach ($game_data  as $d) {
            $fnames = implode(" , ", $d["names"]);
            $names = $fnames;
            if (strlen($fnames) > 35)
                $names  = substr($fnames, 0, 35) . '...';
            $point = 0;
            if (isset($points[$i])) {
                $point = $points[$i];
            }
            $ui_data[] = ["type" => "start",  "class" => "ins_grid padding_left_16 _g_team  ins_col_3 border_left"];
            $ui_data[] = ["type" => "h4", "data" => $d["title"], "class" => "ins_col_6 "];
            $ui_data[] = ["type" => "start", "style" => "", "class" => "ins_col_6 padding_left_16 border_left ins_grid "];
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => "ins_col_3"];
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => "ins_col_3"];
            $ui_data[] = ["type" => "icon", "data" => "star", "class" => "ins_col_3"];
            $ui_data[] = ["type" => "h5", "data" => $point, "style" => "text-align: center;font-weight: bold;margin-top: -7px;", "class" => "ins_col_3 _g_team_points"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "span", "title" =>  $fnames, "data" => $names, "class" => "ins_col_11 _g_header_names"];
            $ui_data[] = ["type" => "end"];
            $i++;
        }
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "icon", "data" => 'arrow', "color" => "red", "direction" => "bottom", "size" => "1"];
        $ui_data[] = ["type" => "end"];
        $ui_data[] = ["type" => "div", "data" => html_entity_decode($levels[0]["title"]), "class" => "_g_title"];
        return ins::_ui()->_data($ui_data)->_render();
    }
    /**
Level One
     */
    static  function _level_one_data($rq)
    {
        return   ins::_db()->_get_row("com_options", "*", "id=19")["data"];
    }
    function _l1()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_one_data(null), true);
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area  ins_col_12"];
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area_main  ins_col_12"];
        $ui_data_body[] = ["type" => "div", "class" => "_ball  ins_col_12"];
        $ui_data_body[] = ["type" => "div", "data" => '', "class" => "_g_ru_"];
        $ui_data_body[] = ["type" => "div", "data" => "A", "class" => "color_red _g_work_area_a"];
        $ui_data_body[] = ["type" => "div", "data" => "B", "class" => "color_red _g_work_area_b"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $body =  ins::_ui()->_data($ui_data_body)->_render();
        foreach ($levels[0]["inputs"] as $l) {
            $ui_data[] = ["type" => "start", "class" => $l["class"] . "  _g_input_cont  "];
            $ui_data[] = ["type" => "start", "class" => "_g_q_" . $l["name"] . "  _g_input_disabled ", "style" => "width:" . $l["width"]];
            $ui_data[] = ["type" => "icon", "data" => "lock", "class" => ""];
            $ui_data[] = ["type" => "input", "autocomplete" => "off", "readonly" => "true", "title" => $l["title"], "pclass" => " _g_input"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "end"];
        }
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return $this->_stage($levels,  $body, $footer);
    }
    /**
Level Two
     */
    static   $frictions = [];
    static function getsp($backgeound = " #a58c7b")
    {
        $sp = '<span style="    width: 35px;
        height: 27px;
        display: block;
        float: left;
        border: 0.3px solid #000000;
        background-color: ' . $backgeound . ' ;
        margin: 5px;
        margin-top: 9px;"></span>';
        return $sp;
    }
    static  function _level_two_data($rq)
    {
        com_auc_game::$frictions = [
            "ice" => ["value" => "0.1", "color" => "#ffffff", "title" => self::getsp("#ffffff") . " Ice"],
            "grass" => ["value" => "0.35", "color" => "#31a483",  "title" => self::getsp("#31a483") . " Grass"],
            "wood" => ["value" => "0.5", "color" => "#523f37",  "title" => self::getsp("#523f37") .  "  Wood "],
            "sand" => ["value" => "0.6", "color" => "#d3be92",  "title" => self::getsp("#d3be92") . " Sand"],
            "asphalt" => ["value" => "0.65", "color" => "#76777a",  "title" => self::getsp("#76777a") . " Asphalt"],
            "dirt" => ["value" => "0.75",  "color" => "#a58c7b", "title" => self::getsp("#a58c7b") . " Dirt"],
        ];
        $levels =  [
            [
                "data" => [
                    ["velocity" => "8", "block" => "D", "answer" =>  com_auc_game::$frictions["wood"]["value"]],
                    ["velocity" => "6", "block" => "C", "answer" =>  com_auc_game::$frictions["grass"]["value"]],
                    ["velocity" => "4", "block" => "E", "answer" =>  com_auc_game::$frictions["ice"]["value"]],
                    ["velocity" => "3", "block" => "B", "answer" =>  com_auc_game::$frictions["ice"]["value"]],
                    ["velocity" => "10", "block" => "E", "answer" =>  com_auc_game::$frictions["asphalt"]["value"]],
                    ["velocity" => "11", "block" => "E", "answer" =>  com_auc_game::$frictions["dirt"]["value"]],
                ],
                "name" => "level 2",
                "title"
                => htmlentities('<b>Level 2:</b><span>Select the <strong>surface (u)</strong> of the floor to make the ball stop at <strong> Block “<i>block</i>”</strong></span>')
            ]
        ];
        return  json_encode($levels);
    }
    function _l2()
    {
        $levels = json_decode(com_auc_game::_level_two_data(null), true);
        $ui_data_body = [];
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area  ins_col_12"];
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area_main  ins_col_12", "style" => "border-left:none"];
        $ui_data_body[] = [
            "type" => "div", "class" => "_ball  ins_col_12",
            "style" => "right: 60px;transition: 0.5s;top: -10px;"
        ];
        $ui_data_body[] = ["type" => "div", "data" => '', "class" => "_g_ru_", "style" => '    width: calc(100% - 60px);
    margin-left: 30px;'];
        $ui_data_body[] = ["type" => "div", "data" => "", "class" => " _g_work_area_bar"];
        $ui_data_body[] = [
            "type" => "start",
            "style" => "",
            "data" => "svg", "height" => "200", "width" => "80", "class" => "_g_hammer"
        ];
        $ui_data_body[] = [
            "type" => "line",   "x1" => "50%", "x2" => "50%", "y1" => "0", "y2" => "200",
            "style" => "stroke:#333;stroke-width:2"
        ];
        $ui_data_body[] = ["type" => "circle", "r" => "16",  "cx" => "50%", "cy" => "16", "fill" => "#1d3085", "stroke-width" => "3", "stroke-fill" => "red"];
        $ui_data_body[] = ["type" => "rect", "y" => "165", "height" => "35", "width" => "100%", "fill" => "#1D3085", "stroke-width" => "3", "stroke-fill" => "red"];
        $ui_data_body[] = ["type" => "end", "data" => "svg"];
        $ui_data_body[] = ["type" => "start", "class" => "color_red _g_data_letters"];
        $ui_data_body[] = ["type" => "li", "data" => "F"];
        $ui_data_body[] = ["type" => "li", "data" => "E"];
        $ui_data_body[] = ["type" => "li", "data" => "D"];
        $ui_data_body[] = ["type" => "li", "data" => "C"];
        $ui_data_body[] = ["type" => "li", "data" => "B"];
        $ui_data_body[] = ["type" => "li", "data" => "A"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $body =  \ins::_ui()->_data($ui_data_body)->_render();
        $ui_data_footer = [];
        $ui_data_footer[] = ["type" => "start", "class" => "_input_40  _g_input_cont  "];
        $ui_data_footer[] = ["type" => "start", "class" => "  _g_q_velocity  _g_input_disabled ", "style" => "  width: 325px;"];
        $ui_data_footer[] = ["type" => "icon", "data" => "lock", "class" => ""];
        $ui_data_footer[] = ["type" => "input", "autocomplete" => "off", "readonly" => "true", "title" => "The Initial Velocity:", "pclass" => " _g_input"];
        $ui_data_footer[] = ["type" => "end"];
        $ui_data_footer[] = ["type" => "end"];
        $ui_data_footer[] = ["type" => "start", "class" => "  _input_50 _g_input_cont _g_q_friction  _g_input_list  _g_disabled", "style" => "    position: relative; "];
        $ui_data_footer[] = ["type" => "start", "class" => "  _g_input_enabled ", "style" => "  width: 290px;"];
        $ui_data_footer[] = ["type" => "div", "data" => " Surface:", "class" => "ui_label  ", "style" => "width: 50px;height:44px;line-height:44px"];
        $ui_data_footer[] = ["type" => "div",  "class" => " _g_input_ui", "style" => "    margin-left: 123px;width: 150px;height:44px;line-height:44px"];
        $ui_data_footer[] = ["type" => "hidden",  "input" => "true",  "pclass" => " _g_input"];
        $ui_data_footer[] = ["type" => "icon", "data" => 'arrow', "color" => "", "direction" => "bottom", "size" => "1.3"];
        $ui_data_footer[] = ["type" => "start", "class" => "  _g_input_list_data  "];
        foreach (com_auc_game::$frictions as $f) {
            $ui_data_footer[] = ["type" => "li", "data-value" => $f["value"], "data-color" => $f["color"], "data" => $f["title"]];
        }
        $ui_data_footer[] = ["type" => "end"];
        $ui_data_footer[] = ["type" => "end"];
        $ui_data_footer[] = ["type" => "end"];
        $footer =  ins::_ui()->_data($ui_data_footer)->_render();
        return $this->_stage($levels,  $body, $footer);
    }
    /**
Level Three
     */
    static  function _level_three_data($rq)
    {
        return   \ins::_db()->_get_row("com_options", "*", "id=20")["data"];
    }
    static  function _l32_form($rq)
    {
        $levels = json_decode(com_auc_game::_level_three_data(null), true);
        foreach ($levels[1]["inputs"] as $l) {
            $ui_data[] = ["type" => "start", "class" => "  _g_input_cont  "];
            $ui_data[] = ["type" => "start", "class" => "_g_q_" . $l["name"] . "  _g_input_disabled ", "style" => "width:" . $l["width"]];
            $ui_data[] = ["type" => "icon", "data" => "lock", "class" => ""];
            $ui_data[] = ["type" => "input", "autocomplete" => "off", "style" => "max-width:30%", "readonly" => "true", "title" => $l["title"], "pclass" => " _g_input"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "end"];
        }
        return  ins::_ui()->_data($ui_data)->_render();
    }
    function _l3()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_three_data(null), true);
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area  ins_col_12"];
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area_main  ins_col_12", "style" => "border:none"];
        $ui_data_body[] = ["type" => "start", "class" => "f_car_info"];
        $ui_data_body[] = ["type" => "data", "data" => "Air Resistance<span class='ar_left'></span>", "class" => "ar_left_data "];
        $ui_data_body[] = ["type" => "data", "data" => "Friction <span class='ar_left'></span>", "class" => "ar_left_data _bottom "];
        $ui_data_body[] = ["type" => "data", "data" => "<span class='ar_right'></span>Driving Force ", "class" => "ar_right_data"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "div", "class" => "_ball _car_3  ins_col_12", "style" => "right:50%", "data-start" => "50%"];
        $ui_data_body[] = ["type" => "div", "data" => '', "class" => "_g_ru_"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $body =  ins::_ui()->_data($ui_data_body)->_render();
        foreach ($levels[0]["inputs"] as $l) {
            $ui_data[] = ["type" => "start", "class" => "  _g_input_cont   _g_input_cont_l3"];
            $ui_data[] = ["type" => "start", "class" => "_g_q_" . $l["name"] . "  _g_input_disabled ", "style" => "width:" . $l["width"]];
            $ui_data[] = ["type" => "icon", "data" => "lock", "class" => ""];
            $ui_data[] = ["type" => "input", "autocomplete" => "off", "readonly" => "true", "title" => $l["title"], "pclass" => " _g_input", "style" => "max-width:30%"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "end"];
        }
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return $this->_stage($levels,  $body, $footer);
    }
    function _l32()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_three_data(null), true);
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area  ins_col_12"];
        $ui_data_body[] = ["type" => "start", "class" => "_g_work_area_main  ins_col_12", "style" => "border:none"];
        $ui_data_body[] = ["type" => "div", "class" => "_ball _car_3  ins_col_12", "data-start" => "50%"];
        $ui_data_body[] = ["type" => "div", "data" => '', "class" => "_g_ru_"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $body =  ins::_ui()->_data($ui_data_body)->_render();
        foreach ($levels[0]["inputs"] as $l) {
            $ui_data[] = ["type" => "start", "class" => "  _g_input_cont  "];
            $ui_data[] = ["type" => "start", "class" => "_g_q_" . $l["name"] . "  _g_input_disabled ", "style" => "width:" . $l["width"]];
            $ui_data[] = ["type" => "icon", "data" => "lock", "class" => ""];
            $ui_data[] = ["type" => "input", "title" => $l["title"], "pclass" => " _g_input"];
            $ui_data[] = ["type" => "end"];
            $ui_data[] = ["type" => "end"];
        }
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return $this->_stage($levels,  $body, $footer);
    }
    static  function update_game_data($rq)
    {
        $game_data =  $_SESSION["game"];
        if ($rq["type"] == "car_data") {
            $cars_data = json_decode($rq["cars_data"], true);
            $i = 0;
            foreach ($cars_data as $cars) {
                $game_data[$i]["car"] = $cars;
                $i++;
            }
            $_SESSION["game"] = $game_data;
            return   self::_l4_select_surface();
        } else  if ($rq["type"] == "surface") {
            $cars_data = json_decode($rq["surface"], true);
            $i = 0;
            foreach ($cars_data as $cars) {
                $game_data[$i]["surface"] = $cars["surface"];
                $i++;
            }
            $_SESSION["game"] = $game_data;
            return   self::_l4_race();
        } else {
        }
    }
    /**
Level Four
     */
    static function _l4_select_car()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_20"];
        $ui_data_body[] = ["type" => "start", "class" => "  ins_col_12"];
        $ui_data_body[] = ["type" => "strong", "data" => 'Select the front:', "class" => "color_red _f_18 ins_col_12"];
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_10"];
        $ui_data_body[] = ["type" => "start", "class" => "  ins_col_12",];
        $cars = [1, 2, 3, 4, 5, 6, 7, 8];
        $level = 0;
        foreach ($cars as $car) {
            $tooltip = "";
            $tooltip .= "<label>Air Resistance :</label> {$levels[$level]["cars_fornt"][$car]["air"]}<label>N</label><br/>";
            $tooltip .= "<label>Weight :</label> {$levels[$level]["cars_fornt"][$car]["weight"]}<label>N</label> <br/>";
            $tooltip .= "<label>Driving Force :</label> {$levels[$level]["cars_fornt"][$car]["engine"]}<label>N</label> <br/>";
            $ui_data_body[] = ["type" => "div", "data-title" =>    $tooltip, "data-insaction" => "ins_tooltip", "data" => "", "data-type" => "$car", "class" => "insaction car_fornt  _$car"];
        }
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_20"];
        $ui_data_body[] = ["type" => "strong", "data" => 'Select the back:', "class" => "color_red _f_18 ins_col_12"];
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_10"];
        $ui_data_body[] = ["type" => "start", "class" => "  ins_col_12",];
        foreach ($cars as $car) {
            $tooltip = "";
            $tooltip .= "<label>Air Resistance :</label> {$levels[$level]["cars_back"][$car]["air"]}<label>N</label><br/>";
            $tooltip .= "<label>Weight :</label> {$levels[$level]["cars_back"][$car]["weight"]}<label>N</label> <br/>";
            //$tooltip .= "<label>Engine Power :</label> {$levels[$level]["cars_back"][$car]["engine"]} <br/>";
            $ui_data_body[] = ["type" => "div", "data-title" =>    $tooltip, "data-insaction" => "ins_tooltip", "data" => "", "data-type" => "$car", "class" => "car_back  _$car"];
        }
        $ui_data_body[] = ["type" => "end"];
        $game_data =  $_SESSION["game"];
        $body =  ins::_ui()->_data($ui_data_body)->_render();
        $ui_data[] = ["type" => "start", "class" => "   ins_grid "];
        foreach ($game_data as $l) {
            $ui_data[] = ["type" => "start",  "style" => "    position: relative;", "class" => " _g_team_car ins_col_3  "];
            $ui_data[] = ["type" => "h4 :", "data" => $l["title"]];
            $ui_data[] = ["type" => "div", "style" => "right: 0px;", "class" => "_surface_car_data "];
            $ui_data[] = ["type" => "end"];
        }
        $ui_data[] = ["type" => "end"];
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return self::_stage_data($levels,  $body, $footer, false, true, false);
    }
    static  function _l4_select_surface()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_20"];
        $ui_data_body[] = ["type" => "start", "class" => "  ins_col_12"];
        $ui_data_body[] = ["type" => "strong", "data" => 'Select the surface:', "class" => "color_red _f_18 ins_col_12"];
        $ui_data_body[] = ["type" => "div", "class" => "  _sp_20"];
        $level = "0";
        $surfaces = ["dirt", "asphalt", "sand", "grass", "clay"];
        foreach ($surfaces as $surface) {
            $tooltip = "";
            $tooltip .= "<label>$surface :</label> {$levels[$level]["surface"][$surface]}<br/>";
            $ui_data_body[] = ["type" => "div", "data" => "", "data-title" => $tooltip, "data-insaction" => "ins_tooltip",   "data-type" => "$surface", "class" => "_car_surface  _$surface"];
        }
        $ui_data_body[] = ["type" => "end"];
        $game_data =  $_SESSION["game"];
        $body =  ins::_ui()->_data($ui_data_body)->_render();
        $ui_data[] = ["type" => "start", "class" => "  ins_col_12  ins_grid "];
        foreach ($game_data as $l) {
            $ui_data[] = ["type" => "start", "style" => "    position: relative;",  "class" => "  ins_col_3  _g_team_car "];
            $ui_data[] = ["type" => "h4 :", "data" => $l["title"]];
            $ui_data[] = ["type" => "div", "style" => "right: 0px;", "class" => "_surface_car_data  _back_{$l["car"]["back"]}   _fornt_{$l["car"]["fornt"]} "];
            $ui_data[] = ["type" => "div", "data" => "", "class" => "_surface_data ins_clo_12"];
            $ui_data[] = ["type" => "end"];
        }
        $ui_data[] = ["type" => "end"];
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return com_auc_game::_stage_data($levels,  $body, $footer, false, true, false);
    }
    static function get_speed($data)
    {
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        $fornt = $levels[0]["cars_fornt"][$data["car"]["fornt"]];
        $back = $levels[0]["cars_back"][$data["car"]["back"]];
        $o = "";
        $m = floatval($fornt["weight"] + $back["weight"]);
        $u = floatval($levels[0]["surface"][$data["surface"]]);
        $r = floatval($fornt["air"]);
        $fd = floatval($fornt["engine"]);
        $o .=  print_R($fornt, true);
        $o .=  print_R($back, true);
        $a =
            floatval(($fd - ($u * $m * 10) - $r) / $m);
        return $a;
    }
    static function all_get_speed()
    {
        $game_data =  $_SESSION["game"];
        foreach ($game_data  as $k => $data) {
            $game_data[$k]["acceleration"] = self::get_speed($data);
        }
        $_SESSION["game"] = $game_data;
    }
    static  function _road_udata($data)
    {
        $game_data =  $_SESSION["game"];
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        $level = 0;
        $surface = $levels["surface"][$data["surface"]];
        $back_car = $data["car"]["back"];
        $fornt_car = $data["car"]["fornt"];


        $fornt = json_encode($levels[0]["cars_fornt"][$back_car]);
        $back = json_encode($levels[0]["cars_back"][$fornt_car]);
        $smtime = 1000000000000000;
        foreach ($game_data  as $k => $adata) {
            $thistime = sqrt(200 / floatval($adata["acceleration"]));
            if ($smtime > $thistime) {
                $smtime = $thistime;
            }
        }
        $d  = (0.5 *  floatval($data["acceleration"]) *   floatval($smtime) *   floatval($smtime));
        $tooltip = "";
        $air = $levels[$level]["cars_back"][$back_car]["air"] + $levels[$level]["cars_fornt"][$fornt_car]["air"];
        $weight = $levels[$level]["cars_back"][$back_car]["weight"] + $levels[$level]["cars_fornt"][$fornt_car]["weight"];
        $engine = $levels[$level]["cars_back"][$back_car]["engine"] + $levels[$level]["cars_fornt"][$fornt_car]["engine"];


        $tooltip .= "<label>Air Resistance :</label> {$air}<br/>";
        $tooltip .= "<label>Weight :</label> {$weight} <br/>";
        $tooltip .= "<label>Engine Power :</label>{$engine} <br/>";
        $tooltip .= "<label>acceleration :</label>{$data["acceleration"]} <br/>";
        $ui_data[] = [
            "type" => "div",  "data-fornt" => $fornt, "data-back" => $back, "data-surface" => $surface, "style" => "
        transition: {$smtime}s ;",
            "data-a" => $data["acceleration"],
            "data-d" => $d,
            "data-to" => "calc( $d% + 20px) ",  "data-team" => $data["title"], "class" => "_surface_car_data _car_race  _back_{$back_car}   _fornt_{$fornt_car}"
        ];
        return  ins::_ui()->_data($ui_data)->_render();
    }
    static  function _level_four_data($rq)
    {
        return   ins::_db()->_get_row("com_options", "*", "id=21")["data"];
    }
    static function _l4_race()
    {
        $ui_data = [];
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        self::all_get_speed();
        $game_data =  $_SESSION["game"];
        $ui_data_body[] = ["type" => "div", "class" => "  _tress ins_col_12"];
        $ui_data_body[] = ["type" => "div", "class" => "  _road_v ins_col_12"];
        $ui_data_body[] = ["type" => "start", "class" => "  ins_col_12", "style" => "    position: relative;"];
        $level = 0;
        foreach ($game_data  as $data) {
            $tooltip = "";
            $tooltip .= "<label>{$data["surface"]} :</label> {$levels[$level]["surface"][$data["surface"]]}<br/>";
            $ui_data_body[] = [
                "type" => "div", "data-title" =>    $tooltip, "data-insaction" => "ins_tooltip", "data" => '<span style="    line-height: 50px;" class="t_title">' . $data["title"] . '</span>',
                "class" => "_car_surface _road _{$data["surface"]}"
            ];
        }
        $ui_data_body[] = ["type" => "start",  "class" => "_car_surface_road_cars "];
        foreach ($game_data  as $data) {
            $ui_data_body[] = [
                "type" => "div", "data" => self::_road_udata($data) . '<span class="_car_surface_road_line"></span>',
                "class" => "_car"
            ];
        }
        $ui_data_body[] = ["type" => "end"];
        $c = count($game_data);
        $ui_data_body[] = ["type" => "start", "style" => "height: calc($c * 66px - 21px)",  "class" => "_car_surface_road_parent "];
        $ui_data_body[] = ["type" => "div",  "class" => "_car_surface_road_start_line "];
        $ui_data_body[] = ["type" => "div", "data" => "", "class" => "_car_surface_road_end"];
        $ui_data_body[] = ["type" => "div", "data" => "", "class" => "_car_surface_road_end_2"];
        foreach ($game_data  as $surface) {
            // $ui_data_body[] = ["type" => "div", "data" => "", "class" => "_car_surface_road_line"];
        }
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $ui_data_body[] = ["type" => "end"];
        $game_data =  $_SESSION["game"];


        $body =  ins::_ui()->_data($ui_data_body)->_render();
        $ui_data[] = ["type" => "start", "class" => "  ins_col_12  ins_grid "];
        $ui_data[] = ["type" => "end"];
        $footer =  ins::_ui()->_data($ui_data)->_render();
        return self::_stage_data($levels,  $body, $footer, false, false);
    }
    function _l4()
    {
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        return $this->_stage($levels,  "", "", false);
    }
    function newCode()
    {
        $maxid = \ins::_db()->_get_row("com_auc_game", "max(id) as mid")["mid"];
        $maxid++;
        return $maxid;
    }
    /**
out
     */
    function _out()
    {
        $levels = json_decode(com_auc_game::_level_four_data(null), true);
        // return $o;
        $this->_get =  ins::_map()->_get();
        if (isset($this->_get["mode"])  && $this->_get["mode"] == "l1" && isset($_SESSION["game"]) && isset($_SESSION[self::SESSION_DB_GAME])) {
            $this->_include(["helper.js",  "level_one.js"]);
            return  $this->_l1();
        } else    if (isset($this->_get["mode"])  && $this->_get["mode"] == "l2" && isset($_SESSION["game"]) && isset($_SESSION[self::SESSION_DB_GAME])) {
            $this->_include(["helper.js", "level_two.js"]);
            return  $this->_l2();
        } else    if (isset($this->_get["mode"])  && $this->_get["mode"] == "l3" && isset($_SESSION["game"]) && isset($_SESSION[self::SESSION_DB_GAME])) {
            $this->_include(["helper.js", "level_three.js"]);
            return  $this->_l3();
        } else    if (isset($this->_get["mode"])  && $this->_get["mode"] == "l4" && isset($_SESSION["game"]) && isset($_SESSION[self::SESSION_DB_GAME])) {
            $this->_include(["helper.js", "level_4.js"]);
            return  $this->_l4();
        } else {
            $this->_include(["helper.js", "intro.js"]);
            if (isset($_POST["action"]) && $_POST["action"] == "new_game") {
                $_POST["code"] = $this->newCode();
                \ins::_db()->_insert("com_auc_game", $_POST);
                $_SESSION[self::SESSION_DB_GAME] = \ins::_db()->_get_row("com_auc_game", "*", "code='{$_POST["code"]}'");
            } else if (isset($_POST["action"])) {
                $_SESSION[self::SESSION_DB_GAME] = \ins::_db()->_get_row("com_auc_game", "*", "code='{$_POST["code"]}'");
                $dataq = json_decode($_SESSION[self::SESSION_DB_GAME]["data"], true);
                $_SESSION[self::SESSION_GAME] = $dataq["game"];
                $url = ins::_map()->_url(["mode" => $dataq["level"]]);
                ins::_map()->_redirect($url);
            }
            // return   $this->game_login_form();
            if (isset($_SESSION[self::SESSION_DB_GAME])) {
                return  $this->_s();
            } else {
                return   $this->game_login_form();
            }
        }
    }
}
