class Game {
    /* levels = 1;*/
    helper = new Helper();
    _points = [5, 2, 1];


    game_data = {};
    levels_data = {};
    this_levels_data = {};
    this_q_data = {};
    team_answers = {};
    timer_inv = null;
    this_time = "";
    _tries = [];
    _thisTry = -1;
    teams_points = -1;
    teams_answers = [];
    levelQs = [];

    options = {
        levels: 1,
        team: 1,
        level: 1,
        end: false,
        start: true,
        show_ball_after: 0.5,
        show_msg_after: 2,
    };

    game = "three";
    _update() {
            var th = this;
            this.helper._get_game_data(function(d) {
                th.game_data = d;
            });
            this.helper._get_level_data(this.game, function(d) {
                th.levels_data = d;
                th.options.levels = Object.keys(th.levels_data).length;
            });
            ins("._g_go")._addclass("ins_hidden");
            this._clear_q_ui();
        }
        /** hleper */
        /** ui */


    getThisQ() {
        var th = this;
        if (th.levelQs.length == 0) {
            th.levelQs = th.this_levels_data["data"];
        }
        var thi_data_k = Math.floor(
            Math.random() * th.levelQs.length
        );

        th.this_q_data = th.levelQs[thi_data_k];
        delete th.levelQs[thi_data_k];

        var tmp = [];
        Object.keys(th.levelQs).forEach(function(k) {

            if (th.levelQs[k] != null && th.levelQs[k] != "") {
                tmp.push(th.levelQs[k])
            }
        })
        th.levelQs = tmp;

    }



    _update_q_ui() {
        var th = this;

        /*  var thi_data_k = Math.floor(
            Math.random() * th.this_levels_data["data"].length
        );
        th.this_q_data = th.this_levels_data["data"][thi_data_k];
*/

        th.getThisQ();
        if (th.this_q_data["active"] != null) {
            th.this_levels_data["active"] = th.this_q_data["active"];
        }

        Object.keys(th.this_levels_data["inputs"]).forEach((key) => {
            var input = th.this_levels_data["inputs"][key];

            var element = input["name"];
            var unit = input["unit"];

            var f = "._g_q_" + element;

            if (th.this_levels_data["active"] != element) {
                ins(f)._addclass("_g_input_disabled");
                ins(f)._removeclass("_g_input_enabled");
                ins(f + " input")._setattr("readonly", "true");

                ins(f + " input")._setattr("type", "text");


                ins(f + " input")._setvalue(th.this_q_data[element] + unit);
            } else {
                ins(f)._addclass("_g_input_enabled");
                ins(f)._removeclass("_g_input_disabled");
                ins(f + " input")._setvalue("");
                ins(f + " input")._removeattr("readonly");
                ins(f + " input")._setattr("type", "number");
                ins(f + " input")._setattr("placeholder", unit);
            }
        });
    }
    _clear_q_ui() {
        var inps = ["distance", "speed", "time"];
        inps.forEach((element) => {
            var f = "._g_q_" + element;
            ins(f + " input")._setvalue("");
            ins(f)._addclass("_g_input_disabled");
            ins(f)._removeclass("_g_input_enabled");
        });
    }

    _update_team_stars() {
        var th = this;

        var te = ins("._g_team")._get(th.options.team - 1);

        th._tries.forEach(function(tr, indx) {
            var _s = ins(te)._find("._star")._get(indx);
            ins(_s)._addclass(tr["status"]);
        });

        var c = th._tries[th._thisTry];

        var old = ins(te)._find("._g_team_points")._gethtml();
        if (c["status"] == "right") {
            var n = parseFloat(old) + th._points[th._thisTry];
            th.teams_points[th.options.team - 1] = n;

            ins(te)._find("._g_team_points")._sethtml(n);
            th._thisTry = -1;
        } else {
            th.teams_points[th.options.team - 1] = parseFloat(old);
        }
    }

    _update_ui() {
        var th = this;

        var act_team = ins("._g_team")._get(th.options.team - 1);
        ins("._g_team")._removeclass("act");
        ins(act_team)._addclass("act");
        if (!th.end) {
            ins("._g_title")._sethtml(
                th.helper._htmlDecode(th.this_levels_data["title"])
            );
        } else {
            ins("._g_title")._sethtml("End");
        }

        th._update_q_ui();
    } /** ball */

    _run_ball(act_answer, user_answer) {
        ins(".f_car_info")._css({
            opacity: "0",
        });

        ins("._ball")._css({
            right: "100%",
        });
    }

    _ball_start_animation() {
        var th = this;

        th._run_ball(100, 100);

        setTimeout(function() {
            th._rest_ball();
        }, th.options.show_ball_after * 4000);
    }

    _rest_ball() {
            //car_start;
            var th = this;

            var d = th.this_levels_data["car_start"];
            ins("._ball")._css({ right: d });

            var th = this;
            ins(".f_car_info")._css({
                opacity: "1",
            });
        }
        /** ball end */
        /** ui */

    /** mechanic  */
    _clean() {
        var th = this;
        th.helper._remove_msg();
        // th._remove_ru_ui();
        th._rest_ball();
        // th._timer();

        th.helper._timer(function(t) {
            th.this_time = t;
        });
    }

    _start() {
        var th = this;
        ins("._g_start ")._addclass("ins_hidden");
        ins("._g_go")._removeclass("ins_hidden");

        th.options.team = 1;
        th.options.level = 1;
        th.options.end = false;
        th.options.start = true;
        th.teams_answers = [];
        th.teams_points = [];

        th._clean();
        th._update_level();
        th._update_ui();
    }

    _end() {
        var th = this;

        th.options.end = true;

        th.helper._get_msg("_end_level_msg", {
            title: "Level 1",
            next: "l4",
            answers: JSON.stringify(th.teams_answers),
            points: JSON.stringify(th.teams_points),

        });

        ins("._g_start ")._removeclass("ins_hidden");
        ins("._g_go")._addclass("ins_hidden");

        th._rest_ball();

        th.helper._timer(function(t) {
            th.this_time = t;
        });
        th._clear_q_ui();
    }

    _update_level() {
        var th = this;

        var this_key = Object.keys(this.levels_data)[th.options.level - 1];
        this.this_levels_data = this.levels_data[this_key];
        th.levelQs = th.this_levels_data["data"];


        if (this.this_levels_data["show_ru"] == "true") {
            th.helper._ru_ui_s();
        }

        if (this.this_levels_data["hide_info"] == "true") {
            ins(".f_car_info")._addclass("ins_hidden");
        }

        th._tries = [];
        ins("._g_team  ._star")._removeclass("right");

        ins("._g_team  ._star")._removeclass("wrong");
        if (this.this_levels_data["name"] == "level 3.2") {
            th.helper._ajax(`_l32_form`, {}, function(data) {
                ins("._bottom_from ")._sethtml(data);
                th._update_ui();
            });
        }
    }

    _answer() {
        var th = this;
        th.helper._timer_stop();
        var act = th.this_levels_data["active"];
        var act_answer = th.this_q_data[act];

        var user_answer = ins("._g_q_" + act + " input")._getvalue();

        if (ins(user_answer)._is_empty()) {
            alert("Please enter answer to continue!");
            ins("._g_go")._removeclass("ins_hidden");
        } else {
            if (th.teams_answers[th.options.level - 1] == null) {
                th.teams_answers[th.options.level - 1] = [];
            }

            var _msg_type = "_right_msg";

            if (th.this_levels_data["ball_animation_type"] == "always") {
                th._ball_start_animation();
            }

            th._thisTry++;
            if (user_answer == act_answer) {
                if (th.this_levels_data["ball_animation_type"] == "right_answer") {
                    th._ball_start_animation();
                }
                th._tries.push({
                    answer: user_answer,
                    status: "right",
                    time: th.this_time,
                });

                for (var i = 0; i < 3; i++) {
                    if (th._tries[i] == null) {
                        th._tries[i] = { answer: "0", status: "right", time: "00:00" };
                    }
                }

                th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;
            } else {
                th._tries.push({
                    answer: user_answer,
                    status: "wrong",
                    time: th.this_time,
                });
                _msg_type = "_wrong_msg";
                th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;

            }

            th._update_team_stars();
            if (
                th.this_levels_data["ball_end_animation"] != null &&
                th.this_levels_data["ball_end_animation"] == "true"
            ) {
                setTimeout(function() {
                    th._run_ball(act_answer, user_answer);
                }, th.options.show_ball_after * 1000);
            }
            setTimeout(function() {
                th.helper._get_msg(_msg_type, {
                    answers: JSON.stringify(th._tries),
                    level_title: th.this_levels_data["name"],
                }, () => {});


            }, th.options.show_msg_after * 1000);


        }
        var inputs = th.this_levels_data["inputs"][act];
        ins("._g_q_" + act + " input")._setvalue(user_answer + inputs["unit"]);



    }

    _next() {
        ins("._g_go")._removeclass("ins_hidden");

        var th = this;
        th._tries = [];
        th._thisTry = -1;
        if (th.options.end) {
            alert("ended");
        } else {
            th.options.team++;
            if (th.options.team > Object.keys(this.game_data).length) {
                th.options.team = 1;
                th.options.level++;
                if (th.options.level > th.options.levels) {
                    th._end();
                } else {
                    th._update_level();
                }
            }
        }
        if (!th.options.end) {
            th._clean();
            th._update_ui();
        }
    }

    _try_again() {
            ins("._g_go")._removeclass("ins_hidden");
            this._clean();
            this._update_ui();
        }
        /** mechanic  */

    run() {
        var th = this;

        th._update();

        ins("._g_msg ._x")._on(
            "click",
            function(o) {
                th.helper._remove_msg();

                var op = o._getdata("op");

                switch (op) {
                    case "_g_next_btn":
                        th._next();
                        break;

                    case "_g_try_again":
                        th._try_again();
                        break;

                    case "_g_next_level_btn":
                        break;

                    case "_g_do_start":
                        th._start();

                        break;
                }
            },
            true
        );

        ins("._g_go")._on("click", function(o) {
            ins("._g_go")._addclass("ins_hidden");

            th._answer();
        });

        ins("._g_try_again")._on("click", function(o) {
            th._try_again();
        });
        ins("._g_next_btn")._on("click", function(o) {
            th._next();
        });

        ins("._g_next_level_btn")._on("click", function(o) {
            th.helper._remove_msg();
        });

        ins("._g_start")._on("click", function(o) {
            th.helper._get_msg("_start_msg", { team: th.game_data[0]["title"] });
        });

        ins("._g_do_start")._on("click", function(o) {
            th._start();
        });
    }
}