class GameTwo {
  /* levels = 1;*/
  game_data = {};
  levels_data = {};
  this_levels_data = {};
  this_q_data = {};
  team_answers = {};
  timer_inv = null;
  _tries = [];

  helper = new Helper();

  options = {
    levels: 1,
    team: 1,
    level: 1,
    end: false,
    start: true,
    show_ball_after: 0.5,
    show_msg_after: 2,
  };
  this_time = "";

  _run_ball(p) {
    ins("._ball")._css({
      right: p + "%",
    });
  }
  _rest_ball() {
    ins("._ball")._css({ right: "60px" });

    setTimeout(() => {
      ins("._g_hammer")._css({ transform: "rotate(-20deg)" });
      ins("._g_work_area_main")._css({
        "border-right": "2px solid #000000",
      });
    }, 250);
  }

  _run_animation(p) {
    var th = this;

    ins("._g_work_area_main")._css({ "border-right": "none" });

    ins("._g_hammer")._css({ transform: "rotate(-60deg)" });

    setTimeout(function () {
      ins("._g_hammer")._css({ transform: "rotate(-0deg)" });
    }, 200);
    setTimeout(function () {
      th._run_ball(p);
    }, 450);
  }
  _ru_ui() {
    var act_answer = 10;
    var top = 40;
    var u_height = 20;
    var hu_height = 10;

    var main_stroke_width = 1;
    var main_stroke_uwidth = 1;

    var main_stroke_color = "stroke:rgb(0,0,0)";

    var main_line_style = `style ="${main_stroke_color};stroke-width:${main_stroke_width}"`;
    var main_u_style = `style ="${main_stroke_color} ;stroke-width:${main_stroke_uwidth}"`;
    var main_hu_style = `style ="${main_stroke_color};stroke-width:${main_stroke_uwidth}"`;

    u_height = top + u_height;
    hu_height = top + hu_height;

    var r =
      ' <svg width="100%;" style="   margin-top: -15px;    overflow: visible;">';

    /** sp data */
    for (var i = 1; i <= act_answer; i++) {
      var sp = 100 / act_answer;
      var ui = 100 - i * sp;
      r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${
        top - 10
      }"  ${main_u_style} />`;
      r += `<text  style='fill:rgb(29, 48, 133);' x="${ui}%" text-anchor="middle"  y="${
        top - 20
      }">${i}M</text>`;
    }

    for (var i = 0; i < act_answer; i++) {
      var sp = 100 / act_answer;
      var ui = 100 - i * sp - 5;
      r += `<line x1="${ui}%" x2="${ui}%"   y1="${top}"  y2="${hu_height}"  ${main_hu_style} />`;
    }
    r += `<line x1="100%"  x2="0" y1="${top}" y2="${top}" ${main_line_style} />`;
    r += "</svg>";

    ins("._g_ru_")._sethtml(r);
  }

  _update() {
    var th = this;
    this.helper._get_game_data(function (d) {
      th.game_data = d;
    });

    this.helper._get_level_data("two", function (d) {
      th.levels_data = d;
    });
    this.options.levels = Object.keys(this.levels_data).length;

    ins("._g_go")._addclass("ins_hidden");

    th._ru_ui();
  }

  _update_level() {
    var th = this;
    var this_key = Object.keys(th.levels_data)[th.options.level - 1];

    th.this_levels_data = th.levels_data[this_key];

    th._tries = [];
    ins("._g_team  ._star")._removeclass("right");
    ins("._g_team  ._star")._removeclass("wrong");
  }

  _start() {
    var th = this;
    ins("._g_start ")._addclass("ins_hidden");
    ins("._g_go")._removeclass("ins_hidden");

    th.options.team = 1;
    th.options.level = 1;
    th.options.end = false;
    th.options.start = true;
    th.teams_answers = [];
    th._clean();
    th._update_level();
    th._update_ui();
  }

  _clean() {
    var th = this;
    th.helper._remove_msg();

    ins("._g_q_friction")._setdata("value", "");
    ins("._g_q_friction input")._setvalue("");
    ins("._g_q_velocity input")._setvalue("");
    th._rest_ball();

    th.helper._timer(function (t) {
      th.this_time = t;
    });
  }

  _end() {
    var th = this;

    th.options.end = true;

    th.helper._get_msg("_end_level_msg", {
      title: "Level 2",
      answers: JSON.stringify(th.teams_answers),
    });

    ins("._g_start ")._removeclass("ins_hidden");
    ins("._g_go")._addclass("ins_hidden");
    th.helper._timer(function (t) {
      th.this_time = t;
    });
  }

  _update_ui() {
    var th = this;
    th._update_q_ui();
    var act_team = ins("._g_team")._get(th.options.team - 1);
    ins("._g_team")._removeclass("act");
    ins(act_team)._addclass("act");
    if (!th.end) {
      ins("._g_title i")._sethtml(th.this_q_data["block"]);
    } else {
      ins("._g_title")._sethtml("End");
    }
  }
  _update_team_stars() {
    var th = this;

    var te = ins("._g_team")._get(th.options.team - 1);

    th._tries.forEach(function (tr, indx) {
      var _s = ins(te)._find("._star")._get(indx);
      ins(_s)._addclass(tr["status"]);
    });
  }
  _answer() {
    var th = this;
    th.helper._timer_stop();

    var act_answer = th.this_q_data["answer"];
    var user_answer = ins("._g_q_friction")._getdata("value");

    if (ins(user_answer)._is_empty()) {
      alert("empty answer");
    } else {
      if (th.teams_answers[th.options.level - 1] == null) {
        th.teams_answers[th.options.level - 1] = [];
      }
      var _msg_type = "_right_msg";

      if (user_answer == act_answer) {
        _msg_type = "_right_msg";

        th._tries.push({
          answer: user_answer,
          status: "right",
          time: th.this_time,
        });

        for (var i = 0; i < 3; i++) {
          if (th._tries[i] == null) {
            th._tries[i] = { answer: "0", status: "right", time: "00:00" };
          }
        }

        th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;
      } else {
        th._tries.push({
          answer: user_answer,
          status: "wrong",
          time: th.this_time,
        });
        _msg_type = "_wrong_msg";

        th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;
      }

      th._update_team_stars();

      var v = parseFloat(th.this_q_data["velocity"]);
      var d = (v * v) / (2 * 9.8 * parseFloat(user_answer));

      th._run_animation(d * 100);

      setTimeout(function () {
        th.helper._get_msg(_msg_type, {
          answers: JSON.stringify(th._tries),
          level_title: th.this_levels_data["name"],
        });
      }, th.options.show_msg_after * 1000);
    }
  }

  _update_q_ui() {
    var th = this;
    var thi_data_k = Math.floor(
      Math.random() * th.this_levels_data["data"].length
    );
    th.this_q_data = th.this_levels_data["data"][thi_data_k];
    ins("._g_q_velocity input")._setvalue(th.this_q_data["velocity"] + "m/s");
  }

  _clear_q_ui() {}

  _try_again() {
    this._clean();
    this._update_ui();
  }
  _next() {
    var th = this;
    th._tries = [];

    if (th.options.end) {
      alert("ended");
    } else {
      th.options.team++;
      if (th.options.team > Object.keys(this.game_data).length) {
        th.options.team = 1;
        th.options.level++;
        if (th.options.level > th.options.levels) {
          th._end();
        } else {
          // th._update_level();
        }
      }
    }
    if (!th.options.end) {
      th._clean();
      th._update_ui();
    }
  }

  run() {
    var th = this;

    th._update();

    ins("._g_msg ._x")._on(
      "click",
      function (o) {
        th.helper._remove_msg();

        var op = o._getdata("op");

        switch (op) {
          case "_g_next_btn":
            th._next();
            break;

          case "_g_try_again":
            th._try_again();
            break;

          case "_g_next_level_btn":
            break;

          case "_g_do_start":
            th._start();

            break;
        }
      },
      true
    );

    ins("._g_go")._on("click", function (o) {
      th._answer();
    });

    ins("._g_try_again")._on("click", function (o) {
      th._try_again();
    });
    ins("._g_next_btn")._on("click", function (o) {
      th._next();
    });

    ins("._g_next_level_btn")._on("click", function (o) {
      th.helper._remove_msg();
    });

    ins("._g_start")._on("click", function (o) {
      th.helper._get_msg("_start_msg", { team: th.game_data[0]["title"] });
    });

    ins("._g_do_start")._on("click", function (o) {
      th._start();
    });
  }
}
