class GameTwo {
    /* levels = 1;*/
    game_data = {};
    levels_data = {};
    this_levels_data = {};
    this_q_data = {};
    team_answers = {};
    timer_inv = null;
    _tries = [];
    _points = [5, 2, 1];
    _thisTry = -1;
    teams_points = -1;
    teams_answers = [];

    helper = new Helper();


    this_answer = "";
    options = {
        levels: 1,
        team: 1,
        level: 1,
        end: false,
        start: true,
        show_ball_after: 0.5,
        show_msg_after: 2,
    };
    this_time = "";

    _run_ball(p) {
        ins("._ball")._css({
            right: p + "%",
        });
    }
    _rest_ball() {
        ins("._ball")._css({ right: "60px" });

        setTimeout(() => {
            ins("._g_hammer")._css({ transform: "rotate(-20deg)" });
            ins("._g_work_area_main")._css({
                "border-right": "2px solid #000000",
            });
        }, 250);
    }

    _run_animation(p) {
        var th = this;

        ins("._g_work_area_main")._css({ "border-right": "none" });

        ins("._g_hammer")._css({ transform: "rotate(-60deg)" });

        setTimeout(function() {
            ins("._g_hammer")._css({ transform: "rotate(-0deg)" });
        }, 200);
        setTimeout(function() {
            th._run_ball(p);
        }, 450);
    }

    _update() {
        var th = this;
        this.helper._get_game_data(function(d) {
            th.game_data = d;
        });

        this.helper._get_level_data("two", function(d) {
            th.levels_data = d;
        });
        this.options.levels = Object.keys(this.levels_data).length;

        ins("._g_go")._addclass("ins_hidden");

        th.helper._ru_ui_s();
    }

    _update_level() {
        var th = this;
        var this_key = Object.keys(th.levels_data)[th.options.level - 1];

        th.this_levels_data = th.levels_data[this_key];
        th.levelQs = th.this_levels_data["data"];

        th._tries = [];
        ins("._g_team  ._star")._removeclass("right");
        ins("._g_team  ._star")._removeclass("wrong");
    }

    _start() {
        var th = this;
        ins("._g_start ")._addclass("ins_hidden");
        ins("._g_go")._removeclass("ins_hidden");
        ins("._g_input_list")._removeclass("_g_disabled");




        th.options.team = 1;
        th.options.level = 1;
        th.options.end = false;
        th.options.start = true;
        th.teams_answers = [];
        th.teams_points = [];

        th._clean();
        th._update_level();
        th._update_ui();
    }

    _clean() {
        var th = this;
        th.helper._remove_msg();

        ins("._g_q_friction")._setdata("value", "");
        ins("._g_q_friction input")._setvalue("");
        ins("._g_q_velocity input")._setvalue("");
        th._rest_ball();

        th.helper._timer(function(t) {
            th.this_time = t;
        });
    }

    _end() {
        var th = this;

        th.options.end = true;

        th.helper._get_msg("_end_level_msg", {
            title: "Level 2",
            next: "l3",
            answers: JSON.stringify(th.teams_answers),
            points: JSON.stringify(th.teams_points)

        });

        ins("._g_start ")._removeclass("ins_hidden");
        ins("._g_go")._addclass("ins_hidden");
        th.helper._timer(function(t) {
            th.this_time = t;
        });
    }

    _update_ui() {
        var th = this;
        th._update_q_ui();
        var act_team = ins("._g_team")._get(th.options.team - 1);
        ins("._g_team")._removeclass("act");
        ins(act_team)._addclass("act");
        if (!th.end) {
            ins("._g_title i")._sethtml(th.this_q_data["block"]);
        } else {
            ins("._g_title")._sethtml("End");
        }
    }
    _update_team_stars() {
        var th = this;

        var te = ins("._g_team")._get(th.options.team - 1);

        th._tries.forEach(function(tr, indx) {
            var _s = ins(te)._find("._star")._get(indx);
            ins(_s)._addclass(tr["status"]);
        });


        var c = th._tries[th._thisTry];

        var old = ins(te)._find("._g_team_points")._gethtml();

        if (c["status"] == "right") {
            var n = parseFloat(old) + th._points[th._thisTry];
            th.teams_points[th.options.team - 1] = n;
            ins(te)._find("._g_team_points")._sethtml(n);
            th._thisTry = -1;
        } else {
            th.teams_points[th.options.team - 1] = parseFloat(old);
        }



    }
    _answer() {
        var th = this;
        th.helper._timer_stop();

        var act_answer = th.this_q_data["answer"];
        var user_answer = ins("._g_q_friction")._getdata("value");
        var color = ins("._g_q_friction")._getdata("color");

        ins("._g_work_area_bar")._css({
            background: color,
        });


        if (ins(user_answer)._is_empty()) {
            alert("Please select value of Friction(u)");
            ins("._g_go")._removeclass("ins_hidden");

        } else {


            if (th.teams_answers[th.options.level - 1] == null) {
                th.teams_answers[th.options.level - 1] = [];
            }
            var _msg_type = "_right_msg";
            th._thisTry++;
            if (user_answer == act_answer) {
                _msg_type = "_right_msg";
                th.this_answer = "right";
                th._tries.push({
                    answer: user_answer,
                    status: "right",
                    time: th.this_time,
                });

                for (var i = 0; i < 3; i++) {
                    if (th._tries[i] == null) {
                        th._tries[i] = { answer: "0", status: "right", time: "00:00" };
                    }
                }

                th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;
            } else {

                th.this_answer = "wrong";

                th._tries.push({
                    answer: user_answer,
                    status: "wrong",
                    time: th.this_time,
                });
                _msg_type = "_wrong_msg";

                th.teams_answers[th.options.level - 1][th.options.team - 1] = th._tries;
            }


            th._update_team_stars();

            var v = parseFloat(th.this_q_data["velocity"]);

            var d = (v * v) / (2 * 10 * parseFloat(user_answer));
            th._run_animation(d * 10);

            setTimeout(function() {
                th.helper._get_msg(_msg_type, {
                    answers: JSON.stringify(th._tries),
                    level_title: th.this_levels_data["name"],
                });
            }, th.options.show_msg_after * 1000);
        }
    }


    thi_data_k = 0;



    levelQs = [];





    getThisQ() {
        var th = this;

        if (th.this_answer != "wrong") {
            if (th.levelQs.length == 0) {
                th.levelQs = th.this_levels_data["data"];
            }


            var thi_data_k = Math.floor(
                Math.random() * th.levelQs.length
            );
            th.this_q_data = th.levelQs[thi_data_k];
            delete th.levelQs[thi_data_k];


            var tmp = [];
            Object.keys(th.levelQs).forEach(function(k) {

                if (th.levelQs[k] != null && th.levelQs[k] != "") {
                    tmp.push(th.levelQs[k])
                }
            })
            th.levelQs = tmp;
        }
    }

    _update_q_ui() {
        var th = this;
        /*
                if (th.this_answer != "wrong") {
                    th.thi_data_k = Math.floor(
                        Math.random() * th.this_levels_data["data"].length
                    );
                }
                th.this_q_data = th.this_levels_data["data"][th.thi_data_k];
        */

        th.
        getThisQ();

        ins("._g_q_velocity input")._setvalue(th.this_q_data["velocity"] + "m/s");


    }

    _clear_q_ui() {}

    _try_again() {

        ins("._g_go")._removeclass("ins_hidden");
        ins("._g_input_list")._find("._g_input_ui")._sethtml("");

        this._clean();
        this._update_ui();
    }
    _next() {

        ins("._g_go")._removeclass("ins_hidden");
        ins("._g_input_list")._find("._g_input_ui")._sethtml("");

        var th = this;
        th._tries = [];
        th._thisTry = -1;
        if (th.options.end) {
            alert("ended");
        } else {
            th.options.team++;
            if (th.options.team > Object.keys(this.game_data).length) {
                th.options.team = 1;
                th.options.level++;
                if (th.options.level > th.options.levels) {
                    th._end();
                } else {
                    // th._update_level();
                }
            }
        }
        if (!th.options.end) {
            th._clean();
            th._update_ui();
        }
    }

    run() {
        var th = this;

        th._update();

        ins("._g_msg ._x")._on(
            "click",
            function(o) {
                th.helper._remove_msg();

                var op = o._getdata("op");

                switch (op) {
                    case "_g_next_btn":
                        th._next();
                        break;

                    case "_g_try_again":
                        th._try_again();
                        break;

                    case "_g_next_level_btn":
                        break;

                    case "_g_do_start":
                        th._start();

                        break;
                }
            },
            true
        );

        ins("._g_go")._on("click", function(o) {
            ins("._g_go")._addclass("ins_hidden");

            th._answer();
        });

        ins("._g_try_again")._on("click", function(o) {
            th._try_again();
        });
        ins("._g_next_btn")._on("click", function(o) {
            th._next();
        });

        ins("._g_next_level_btn")._on("click", function(o) {
            th.helper._remove_msg();
        });

        ins("._g_start")._on("click", function(o) {
            th.helper._get_msg("_start_msg", { team: th.game_data[0]["title"] });
        });

        ins("._g_do_start")._on("click", function(o) {
            th._start();
        });
    }
}