<?php

class com_resrevations extends ins_com {

    var $__render = "";

    public function __construct($data = null) {
        parent::__construct($data);

        $this->_g = \lib::_eng()->_get();
    }

    var $data = [];
    var $users = [];

// <editor-fold defaultstate="collapsed" desc="group_details">

    function get_attr($v) {

        return $v ? $v : "";
    }

    function group_details() {


        $arrival_date = $this->get_attr($this->data["group_arrival_date"]);
        $departure_date = $this->get_attr($this->data["group_departure_date"]);

        $arrival_date_text = $arrival_date ? \lib::_timedate()->dateFromdb($arrival_date, "d M Y") : "Select Date";
        $departure_date_text = $departure_date ? \lib::_timedate()->dateFromdb($departure_date, "d M Y") : "Select Date";


        $highlight_date = $this->setting["date_highlight"]; //json_encode($highlight_datej);


        $data = [
            //   "ajax_upload_file-" => ["name" => "ufile", "pclass" => "col12", "title" => '<i class="fas fa-file-upload"></i>'],
            "strat-topdate" => ["class" => "col12 ins_text_tocenter res_area topdate"],
            "strat-arriving" => ["class" => "col5 arriving_area"],
            "label-arriving" => ["class" => "col12", "data" => "Arriving"],
            "h2-arriving" => ["class" => "col12", "data-date" => $arrival_date, "data" => $arrival_date_text],
            "end-arriving" => [],
            "h2-sp" => ["class" => "col2", "data" => "-"],
            "strat-departing" => ["class" => "col5 departing_area"],
            "label-departing" => ["class" => "col12", "data" => "Departing"],
            "h2-departing" => ["class" => "col12", "data-date" => $departure_date, "data" => $departure_date_text],
            "end-departing" => [],
            "end-topdate" => [],
            "div-datepicker" => ["class" => "col12 datepicker_area", "data-highlight_date" => $highlight_date,
                "data-from_date" => $arrival_date, "data-to_date" => $departure_date],
            "div-data" => ["class" => "col12 res_mssage"],
            "strat-data" => ["class" => "col12 res_area data_area"],
            "text-Contact" => ["autocomplete" => "false", "required" => true, "pclass" => "col4", "title" => "Contact Number", "value" => $this->get_attr($this->data["mobile"]), "data-title" => "Contact Number", "name" => "mobile", "input" => true],
            "text-email" => ["autocomplete" => "false", "required" => true, "pclass" => "col4", "value" => $this->get_attr($this->data["email"]), "title" => "Email Address", "data-title" => "Email Address", "name" => "email", "input" => true],
            "text-vemail" => ["autocomplete" => "false", "required" => true, "pclass" => "col4", "value" => $this->get_attr($this->data["email"]), "title" => "Verify Email", "data-title" => "Verify Email", "name" => "v_email", "input" => true],
            "strat-table_area" => ["class" => "col12 res_area table_area"],
            "strat-table_data" => ["class" => "table_data"],
            "end-data_table" => [],
            "h3-data_table" => ["class" => "col12", "data" => " Add New Section"],
            "text-its" => ["pclass" => "col5", "title" => " ", "name" => "its_id", "placeholder" => "ITS ID", "input" => true],
            "button-add" => ["pclass" => "col2", "title" => "", "name" => "add", "data" => "Add"],
            "textarea-rem" => ["pclass" => "col12", "title" => " ", "value" => $this->data["remarks"], "name" => "remarks", "placeholder" => "Remarks", "style" => "height:100px;"],
            "end-data_table" => [],
            "end-data" => [],
            "strat-data_end" => ["class" => "col12 res_area"],
            "button-CONTINUE" => ["class" => "continue", "title" => "", "name" => "continue", "data" => "CONTINUE <i class=\"fas fa-chevron-right\"></i>"],
            "end-data_end" => [],
        ];
        $this->_render .= \lib::_ui()->_data($data)->_render();
    }

    // </editor-fold>
// <editor-fold defaultstate="collapsed" desc="review_details">

    function review_details() {






        $this->data["group_arrival_time"] = $this->data["arrival_time"] . ":" . $this->data["arrival_time_m"];
        $this->data["group_departure_time"] = $this->data["departure_time"] . ":" . $this->data["departure_time_m"];

        $this->data["group_arrival_date"] = trim(str_replace("00:00:00", "", $this->data["group_arrival_date"]));
        $this->data["group_departure_date"] = trim(str_replace("00:00:00", "", $this->data["group_departure_date"]));





        $d = $_SESSION["reservation"]["data"];
        $this->data["nights"] = \lib::_timedate()->howManyDays($this->data["group_arrival_date"], $this->data["group_departure_date"]);
        $arriving_date = \lib::_timedate()->create_date($this->data["group_arrival_date"]);
        $departing_date = \lib::_timedate()->create_date($this->data["group_departure_date"]);
        $f = \lib::_files()->_get_class("xml");
        $data = $f->_load("ins_lib/includes/xml/airlines.xml");
        $group_airline = $data["airlines"]["data_value"][$this->data["group_airline"]]["data_value"];

        $nightstable = [
            "th-header" => [
                ["data" => "TRAVEL DATES", "colspan" => "3", "class" => "col12"]
            ],
            "th" => [
                ["data" => "Check in Arrival Date ", "class" => "col4"],
                ["data" => "Check out", "class" => "col4"],
                ["data" => "Night", "class" => "col4"]
            ],
            "td" => [
                ["data" => $arriving_date->format("d/m/Y"), "class" => "col4"],
                ["data" => $departing_date->format("d/m/Y"), "class" => "col4"],
                ["data" => $this->data["nights"], "class" => "col4"]
            ]
        ];






        if ($d["airport_pickup"] == "0") {
            $pickup = "NO";


            $arrivel = [
                "th-header" => [
                    ["data" => "ITINERARY DETAILS", "colspan" => "3", "class" => "col12"]
                ],
                "th" => [
                    ["data" => "Arriving Time", "class" => "col4"],
                    ["data" => "Departing Time", "class" => "col4"],
                    ["data" => "Airport Pick Up", "class" => "col4"]
                ],
                "td" => [
                    ["data" => $this->data["group_arrival_time"], "class" => "col4"],
                    ["data" => $this->data["group_departure_time"], "class" => "col4"],
                    ["data" => $pickup, "class" => "col4"]]
            ];
        } else {

            $pickup = "YES";


            $arrivel = [
                "th-header" => [
                    ["data" => "ITINERARY DETAILS", "colspan" => "3", "class" => "col12"]
                ],
                "th" => [
                    ["data" => "AIRLINE", "class" => "col2"],
                    ["data" => "FLIGHT NO", "class" => "col2"],
                    ["data" => "Arriving From", "class" => "col2"],
                    ["data" => "Arriving Time", "class" => "col2"],
                    ["data" => "Departing Time", "class" => "col2"],
                    ["data" => "Airport Pick Up", "class" => "col2"]
                ],
                "td" => [
                    ["data" => $group_airline, "class" => "col2"],
                    ["data" => $this->data["group_airline_code"], "class" => "col2"],
                    ["data" => $this->data["group_arriving_from"], "class" => "col2"],
                    ["data" => $this->data["group_arrival_time"], "class" => "col2"],
                    ["data" => $this->data["group_departure_time"], "class" => "col2"],
                    ["data" => $pickup, "class" => "col2"]]
            ];
        }


        $CONTACT = [
            "th-header" => [
                ["data" => "CONTACT DETAILS", "colspan" => "3", "class" => "col12"]
            ],
            "th" => [
                ["data" => "Email ", "class" => "col6"],
                ["data" => "Mobile", "class" => "col6"],
            ],
            "td" => [
                ["data" => $d["email"], "class" => "col6"],
                ["data" => $d["mobile"], "class" => "col6"],
            ]
        ];



        $GUEST = [
            "th-header" => [
                ["data" => "GUEST DETAILS", "class" => "col12"]
            ],
            "th" => [
                ["data" => "ITS ID", "class" => "col2"],
                ["data" => "Name", "class" => "col4"],
                ["data" => "Type", "class" => "col2"],
                ["data" => "Package Name", "class" => "col2"],
                ["data" => "Lawazim", "class" => "col2"],
            ]
        ];



        $_SESSION["reservation"]["users"] = array_filter($_SESSION["reservation"]["users"]);

        foreach ($_SESSION["reservation"]["users"] as $k => $v) {


            $usersData = \lib::_db()->_get_row("com_users_fiz", "*", "id='" . $v["user_id"] . "'");

            if (is_array($usersData)) {
                if ($usersData['Age'] > 11) {
                    $users_data["type"] = "Adult";
                } else if ($usersData['Age'] < 2) {
                    $users_data["type"] = "Infant";
                } else if ($usersData['Age'] < 12) {
                    $users_data["type"] = "Child";
                }
            }
            $pkgData = \lib::_eng()->_get_plgin("plg_fiz_lawazim_packages", ["nights" => $this->data["nights"], "type" => $users_data["type"], "settings" => $this->_pro["settings"]]);

            $GUEST["th-" . $k] = [
                ["data" => $usersData["Mumin_id"], "class" => "col2"],
                ["data" => $usersData["FullName"], "class" => "col4"],
                ["data" => $users_data["type"], "class" => "col2"],
                ["data" => $pkgData["package_name"], "class" => "col2"],
                ["data" => "$" . $pkgData['ex_lawazim'], "class" => "col2"],
            ];

            $_SESSION["reservation"]["users"][$k]["ex_lawazim"] = $pkgData['ex_lawazim'];
            $_SESSION["reservation"]["users"][$k]["type"] = $users_data['type'];
            $_SESSION["reservation"]["users"][$k]["package_name"] = $pkgData['package_name'];
            $all_lawazim += $pkgData['ex_lawazim'];
        }


        $GUEST["th-Total"] = [
            ["data" => "Total", "class" => "col10 ins_text_toright"],
            ["data" => "$" . $all_lawazim, "class" => "col2"],
        ];

        $this->data["lawazim"] = $all_lawazim;

        $data = [
            "start" => ["class" => "data_container review_details"],
            "table_divs-Airline" => ["data" => $nightstable, "class" => "col12 ins_text_tocenter"],
            "table_divs-arrivel" => ["data" => $arrivel, "class" => "col12 ins_text_tocenter"],
            "table_divs-CONTACT" => ["data" => $CONTACT, "class" => "col12 ins_text_tocenter"],
            "table_divs-GUEST" => ["data" => $GUEST, "class" => "col12 ins_text_tocenter"]
        ];






        $data["strat-data_end"] = ["class" => "col12 grid res_area"];
        $data["button-previous"] = ["class" => "previous col3", "name" => "continue", "data" => " <i class=\"fas fa-chevron-left\"></i> PERVIOUS"];
        $data["button-CONTINUE"] = ["class" => "continue col4", "data" => "CONFRIM RESERVATION  <i class=\"fas fa-check\"></i>"];


        $data["end-data_end"] = [];
        $data["end"] = [];

        $_SESSION["reservation"]["data"] = $this->data;


        $this->_render .= \lib::_ui()->_data($data)->_render();
        // print_R($_SESSION["reservation"]);
    }

// </editor-fold>
// <editor-fold defaultstate="collapsed" desc="arrival_details">




    function arrival_details() {
        echo $_SESSION["airport_pickup"];
        print_R($_SESSION);


        $data = [
            "start" => ["class" => "data_container arrival_details"],
            "h2" => ["data" => "Do you need Airport Pickup from Cairo International Airport?"],
            "line" => [],
            "radio-y" => ["title" => "yes", "input" => "true", "pclass" => "col2", "value" => "1", "name" => "airport_pickup"],
            "radio-n" => ["title" => "No, I will arrive directly at Faiz-e-Haakimi", "pclass" => "col10", "input" => "true", "value" => "0", "name" => "airport_pickup"],
            "start-data" => ["class" => "pickup_data"],
            "end-data" => [],
            "end" => []
        ];


        if (isset($this->data["airport_pickup"])) {
            if ($this->data["airport_pickup"] == "1") {
                $data["radio-y"]["checked"] = "checked";
            } if ($this->data["airport_pickup"] == "0") {
                $data["radio-n"]["checked"] = "checked";
            }
        }



        $this->_render .= \lib::_ui()->_data($data)->_render();
    }

    // </editor-fold>
// <editor-fold defaultstate="collapsed" desc="Save">


    function save_res() {
        $this->data["reservation_id"] = $this->reservation_id;
        $this->data["users_data"] = json_encode($this->users);

        $raza_status = "";

        if ($_SESSION["reservation"]["status"] == "edit") {

            $_reservation_olddata = $this->__db->_get_row("fiz_reservation", "*", "reservation_id=:myid", ["myid" => $_SESSION["reservation"]["data"]['reservation_id']]);
            $this->__db->_update("fiz_reservation", $this->data, "reservation_id=:myid", ["myid" => $_SESSION["reservation"]["data"]['reservation_id']]);

            $_reservation_olddata_u = $this->__db->_get_data("fiz_reservation_users_xref", "*", "reservation_id=:myid", ["myid" => $_SESSION["reservation"]["data"]['reservation_id']]);
            $this->__db->_delete("fiz_reservation_users_xref", "reservation_id=:myid", ["myid" => $_SESSION["reservation"]["data"]['reservation_id']]);


            $_email_tamplet = $this->setting["edit_email_template"];
        } else {

            $_email_tamplet = $this->setting["new_email_template"];
            $this->__db->_insert("fiz_reservation", $this->data);
        }





        $emaildata = $this->data;

        if (!isset($this->data["schedule_message"])) {

            $emaildata["schedule_message"] = "&nbsp;";
        }
        $emaildata["group_departure_date"] = lib::_data()->_datetime->dateFromdb($emaildata["group_departure_date"]);
        $emaildata["group_arrival_date"] = lib::_data()->_datetime->dateFromdb($emaildata["group_arrival_date"]);



        $f = \lib::_files()->_get_class("xml");
        $data = $f->_load("ins_lib/includes/xml/airlines.xml");
        $emaildata["group_airline"] = $data["airlines"]["data_value"][$emaildata["group_airline"]]["data_value"];
        print_R($this->razaOwnerData);
        $emaildata["owner-name"] = $this->razaOwnerData["FullName"];



        $table_style = "width: 100%; text-align: center; color: white; border-collapse: collapse;";
        $tr_style = "background: #ededed;";
        $td_style = "border: 1px solid #e0dede; padding: 20px 5px; color: #000000;";


        if ($emaildata["airport_pickup"] == "1") {
            $emaildata["airport_pickup"] = "Yes";


            $emaildata["table-itinerary"] .= '   

<table style="' . $table_style . '">
<tbody>
<tr>
<td style="background:#df7f57;padding:10px;font-size:small"><strong>Itinerary Details</strong></td>
</tr>
</tbody>
</table>
<table style="width: 100%; border-collapse: collapse;">
<tbody>
<tr style="' . $tr_style . '">
<td style="' . $td_style . '"><strong>Airline: </strong></span><br />' . $emaildata["group_airline"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Flight No: </strong></span> <br />' . $emaildata["group_airline_code"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Arriving from: </strong></span><br /> ' . $emaildata["group_arriving_from"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Arrival Time: </strong></span><br /> ' . $emaildata["group_arrival_time"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Departure Time: </strong></span><br />' . $emaildata["group_departure_time"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Airport Pickup: </strong></span><br />' . $emaildata["airport_pickup"] . '</td>
</tr>
</tbody>
</table>
';
        } else {
            $emaildata["airport_pickup"] = "No";



            $emaildata["table-itinerary"] .= '   

<table style="' . $table_style . '">
<tbody>
<tr>
<td style="background:#df7f57;padding:10px;font-size:small"><strong>Itinerary Details</strong></td>
</tr>
</tbody>
</table>
<table style="width: 100%; border-collapse: collapse;">
<tbody>
<tr style="' . $tr_style . '">
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Arrival Time: </strong></span><br /> ' . $emaildata["group_arrival_time"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Departure Time: </strong></span><br />' . $emaildata["group_departure_time"] . '</td>
<td style="' . $td_style . '"><span style="color: #000000;"><strong>Airport Pickup: </strong></span><br />' . $emaildata["airport_pickup"] . '</td>
</tr>
</tbody>
</table>
';
        }


        $emaildata["table-data"] .= "<table style='width:100%;border-collapse:collapse'>";
        $emaildata["table-data"] .= "<tr  style='$tr_style'>"
                . "<th  style='$td_style' ><span style=''> SNo</span></th>"
                . "<th style='$td_style'><span style=''> ITS ID</span></th>"
                . "<th style='$td_style' ><span style=''> Name</span></th>"
                . "<th style='$td_style ' ><span style=''> Document Status</span></th>"
                . "</tr>";

        foreach ($this->users as $xrefData) {

            $usersData = \lib::_db()->_get_row("com_users_fiz", "*", "id='" . $xrefData["user_id"] . "'");

            $ii++;

            $emaildata["table-data"] .= "<tr  style='$new;$tr_style; font-size:13px'>"
                    . "<td style='$td_style'  >$ii</td>"
                    . "<td style='$td_style' >" . $usersData["Mumin_id"] . "</td>"
                    . "<td style='$td_style' >" . $usersData["FullName"] . "</td>"
                    . "<td style='$td_style' >" . $xrefData["ex_lawazim"] . "</td>"
                    . "</tr>";
            $all_lawazim += $xrefData["ex_lawazim"];
        }


        $emaildata["table-data"] .= '
        <tr style="' . $tr_style . '">
                            <td style="' . $td_style . '"><span ></span> </td>    
                            <td style="' . $td_style . '"><span ></span> </td>    
                            <td style="' . $td_style . '"><span >Total</span> </td>  
                            <td style="' . $td_style . '"></span> $' . $all_lawazim . '</td>    

                        </tr>';




        $emaildata["table-data"] .= "</table>";




        $this->_render = \lib::_ui()->_data(["div" => ["data" => $this->_lang["success_msg"], "class" => "msg succ success"]])->_render();
        \lib::_emails()->sendemail($this->data["email"], $_email_tamplet, $emaildata);
        //unset($_SESSION["reservation"]);
    }

    function update_data() {


        if ($_SESSION["reservation"]["status"] == "edit") {
            $this->reservation_id = sprintf("%04s", $_SESSION["reservation"]["data"]['reservation_id']);
        } else {
            $mdata = $this->__db->_get_custom_row("fiz_reservation", "max", "reservation_id"); // $lib->db->get_maxrow("fiz_reservation");
            $resID = $mdata['reservation_id'];
            $resID++;

            $this->clean_res_id = $resID;
            $this->reservation_id = sprintf("%04s", $resID);
        }
        $this->data = $_SESSION["reservation"]["data"];
        $this->users = $_SESSION["reservation"]["users"];
    }

    function confrim_data() {
        $this->update_data();
        $this->save_res();


        /// Array ( [status] => continue [airport_pickup] => 0 [arrival_time] => 01 [arrival_time_m] => 15 [departure_time] => 01 [departure_time_m] => 30 [myname] => com_resrevations [arriving_date] => 2019-6-2 [departing_date] => 2019-6-19 [contact_number] => 1010666918 [email_address] => empcland@gmail.com [v_email_address] => empcland@gmail.com )
    }

    // </editor-fold>
// <editor-fold defaultstate="collapsed" desc="Home">


    function get_items($cat_id, $class) {
        $data = $this->__db->_get_data("sys_content", "*", $this->__data->_db_get_form_group($cat_id) . " order by `sys_order` ");
        if (count($data) == 0) {
            return false;
        }

        foreach ($data as $d) {
            if ($d["th_image"] != "") {

                $blockdata["image"] = $this->__app_map->upload_folder . $d["th_image"];
            }


            if ($d["ex_url"] != "") {
                $blockdata["url"] = $d["ex_url"];
            }


            $menu = $this->__eng->get_menu_by_type();

            $blockdata["title"] = $d["title"];
            $blockdata["des"] = $d["des"];

            $r .= $this->__ui->_data(["data_block" => ["data" => $blockdata, "data-title" => $d["title"], "data-id" => $d["id"], "class" => "$class  get_content ins_text_tocenter"]])->_render();
        }

        return $this->__ui->_data(["div" => ["class" => "  sys_content_items ins_text_tocenter ", "data" => $r]])->_render();
    }

    function getreRows() {

        $ds = $this->__db->_get_data("fiz_reservation", "*", "booking_owner=:myid order by `id` DESC", ["myid" => $this->razaOwnerData["id"]]);
        // print_R($ds);

        $nightstable = [
            "th-header" => [
                ["data" => "Active Reservations", "class" => "col12"]
            ],
            "th" => [
                ["data" => "Reservation ID ", "class" => "col2"],
                ["data" => "No of Persons ", "class" => "col4"],
                ["data" => "Arrival Date", "class" => "col2"],
                ["data" => "Departure Date", "class" => "col2"],
                ["data" => "actions", "class" => "col2"]
            ]
        ];




        foreach ($ds as $d) {

            if (\lib::_data()->_datetime->howManyDaysTime(date("Y-m-d") . " 00:00:00", $d['group_arrival_date']) > 0) {
                $users_data = json_decode($d['users_data']);

                $btns = \lib::_ui()->_data([
                            "button" => ["title" => "Edit", "data" => '<i class="fas fa-edit"></i>', "data-id" => $d['reservation_id'], "data-status" => "edit", "class" => "edit_res ", "style" => "padding: 5px;"],
                            "button-1" => ["title" => "Delete", "data" => '<i class="fas fa-trash-alt"></i>', "data-id" => $d['reservation_id'], "data-status" => "delete", "class" => "delete_res ", "style" => "padding: 5px;"]
                        ])->_render();

                $nightstable["td-" . $d['reservation_id']] = [
                    ["data" => sprintf("%04s", $d['reservation_id']), "class" => "col2"],
                    ["data" => count($users_data), "class" => "col4"],
                    ["data" => $this->__data->_datetime->dateFromdb($d['group_arrival_date']), "class" => "col2"],
                    ["data" => $this->__data->_datetime->dateFromdb($d['group_departure_date']), "class" => "col2"],
                    ["data" => "$btns", "class" => "col2"]
                ];
            }
        }

        $data = [
            "start" => ["class" => "data_container review_details"],
            "table_divs-Airline" => ["data" => $nightstable, "class" => "col12 ins_text_tocenter"],
            "end" => []
        ];

        return $this->_render = \lib::_ui()->_data($data)->_render();
    }

    function home() {

        $get_items = $this->get_items($this->_pro["important_notices"], "col6");
        
        if ($get_items != false) {
            $data = [
                "start-important_notices" => ["class" => "content_area col12"],
                "start-container" => ["class" => "container"],
                "div-line" => ["class" => "fline"],
                "h2-important_notices" => ["data" => "Important Notices", "class" => "ins_text_tocenter col12"],
                "div-important_notices" => ["data" => $get_items, "class" => "col12"],
                "div-clearf" => ["class" => "clearfix"],
                "end-container" => [],
                "end-important_notices" => [],
            ];
        }



        if (isset($_SESSION["razaOwnerID"])) {
            $data ["start-table"] = ["class" => "content_area col12"];
            $data ["start-table_c"] = ["class" => "container"];
            $data ["div-table"] = ["data" => $this->getreRows(), "class" => "col12"];
            $data ["div-table_cc"] = ["class" => "clearfix"];
            $data ["end-table_c"] = [];

            $data ["end-table"] = [];
        }

        $data ["start-reservations"] = ["class" => "content_area col12"];
        $data ["start-container_reservations"] = ["class" => "container"];
        $data ["div-linereservations"] = ["class" => "fline"];
        $data ["h2-reservations"] = ["data" => "Reservations", "class" => "ins_text_tocenter col12"];
        $data ["div-reservations"] = ["data" => $this->get_items($this->_pro["reservations"], "col4"), "class" => "col12"];
        $data ["div-clearfreservations"] = ["class" => "clearfix"];
        $data ["end-containereservations"] = [];
        $data ["end-reservations"] = [];
        $data ["start-important_information"] = ["class" => "content_area  col12"];
        $data ["start-container_information"] = ["class" => "container"];
        $data ["div-lineimportant_information"] = ["class" => "fline"];
        $data ["h2-important_information"] = ["data" => "Important Information", "class" => "ins_text_tocenter col12"];
        $data ["div-important_information"] = ["data" => $this->get_items($this->_pro["important_information"], "col4"), "class" => "col12"];
        $data ["div-clearimportant_information"] = ["class" => "clearfix"];
        $data ["end-reservations_information"] = [];
        $data ["end-important_information"] = [];

        $this->_render = \lib::_ui()->_data($data)->_render();
    }

    // </editor-fold>

    function _out() {


        $this->_include("res_style.css");
        $this->setting = $this->__db->_get_row("com_fiz_reservation_settings", "*", "id='" . $this->_pro["settings"] . "'");

        if (isset($_SESSION["razaOwnerID"])) {
            $this->razaOwnerData = \lib::_db()->_get_row("com_users_fiz", "*", "id='" . $_SESSION["razaOwnerID"] . "'");
            $_SESSION["reservation"]["data"]["booking_owner"] = $this->razaOwnerData["id"];
            $this->razaOwnerID = $_SESSION["razaOwnerID"];
        }

        if (!isset($_SESSION["reservation"]["data"])) {
            $this->_g["mode"] = "";
        } else {

            $this->data = $_SESSION["reservation"]["data"];
        }


        switch ($this->_g["mode"]) {
            case "arrival_details":

                \lib::_template()->_add_class_to_body("resrevations_page");
                $this->_include("arrival_details.js");

                $data = [
                    "start" => ["data" => "ul", "class" => "steps_guide"],
                    "li-1" => ["data" => "-"],
                    "li-2" => ["data" => '<i class="fas fa-check"></i> Step 2 ', "class" => "act"],
                    "li-3" => ["data" => "-"],
                    "li-4" => ["data" => "-"],
                    "end" => ["data" => "ul"],
                ];
                $this->_render = \lib::_ui()->_data($data)->_render();
                $this->arrival_details();
                break;

            case "review_details":
                \lib::_template()->_add_class_to_body("resrevations_page");
                $this->_include("review_details.js");
                $data = [
                    "start" => ["data" => "ul", "class" => "steps_guide"],
                    "li-1" => ["data" => "-"],
                    "li-2" => ["data" => "-"],
                    "li-3" => ["data" => '<i class="fas fa-check"></i> Step 3', "class" => "act"],
                    "li-4" => ["data" => "-"],
                    "end" => ["data" => "ul"],
                ];
                $this->_render = \lib::_ui()->_data($data)->_render();
                $this->review_details();
                break;

            case "confrim_data":
                \lib::_template()->_add_class_to_body("resrevations_page");
                $this->_include("confrim_data.js");

                $data = [
                    "start" => ["data" => "ul", "class" => "steps_guide"],
                    "li-1" => ["data" => "-"],
                    "li-2" => ["data" => "-"],
                    "li-4" => ["data" => "-"],
                    "li-3" => ["data" => '<i class="fas fa-check"></i>  Step 4', "class" => "act"],
                    "end" => ["data" => "ul"],
                ];
                $this->_render = \lib::_ui()->_data($data)->_render();


                $this->confrim_data();
                break;

            case "group_details":
                \lib::_template()->_add_class_to_body("resrevations_page");
                $this->_include("droup_details.js");
                $data = [
                    "start" => ["data" => "ul", "class" => "steps_guide"],
                    "li-1" => ["data" => '<i class="fas fa-check"></i> Step 1', "class" => "act"],
                    "li-2" => ["data" => "-"],
                    "li-3" => ["data" => "-"],
                    "li-4" => ["data" => "-"],
                    "end" => ["data" => "ul"],
                ];
                $this->_render = \lib::_ui()->_data($data)->_render();
                $this->group_details();

                break;
            default :
                \lib::_template()->_add_class_to_body("full_container");
                $this->_include("home.js");
                $this->home();
                break;
        }

        $data = [
            "div" => ["class" => "com_reervtion_data",
                "data-_myname" => $this->_myname, "data-alias" => $this->_g["alias"],
                "data-url" => \lib::_eng()->_url([], ["mode"]),
                "data-_mypath" => $this->_myPath,
                "data" => $this->_render]
        ];

        return \lib::_ui()->_data($data)->_render(["mode"]);
    }

}
