<?php

class com_admissions extends ins_com {

    var $_g = [];

    public function __construct() {
        parent::__construct();
        $this->_g = ins::_app_map()->_get();
    }

    function ad_confirm($rq) {
        ins::_db()->_insert("app_school_students", $_SESSION["app_admissions_data"]);
        unset($_SESSION["app_admissions_data"]);
    }

    function _add_data($rq) {
        unset($rq["status"], $rq["_myname"], $rq["_mypath"], $rq["error_inputs"], $rq["get_file"], $rq["site"]);
        if (isset($_SESSION["app_admissions_data"])) {
            $_SESSION["app_admissions_data"] = array_merge($_SESSION["app_admissions_data"], $rq);
        } else {
            $_SESSION["app_admissions_data"] = $rq;
        }
    }

    function _get_phase_data($rq) {

        $r = "";


        if ($rq["phase"] == "grade") {
            $data = ["grade 1" => "grade 1", "grade 2" => "grade 2", "grade 3" => "grade 3", "grade 4" => "grade 4", "grade 5" => "grade 5", "grade 6" => "grade 6"];
        } else if ($rq["phase"] == "kindergarten") {
            $data = ["kg1" => "kg1", "kg2" => "kg2"];
        } else if ($rq["phase"] == "preschool") {
            $data = ["preschool" => "preschool"];
        }







        $r = "<option value=''></option>";

        foreach ($data as $k => $v) {
            $r .= "<option value='$k'>$v</option>";
        }


        return $r;
    }

    function _w_map() {

        $s_data = [
            "_terms" => ["icon" => "fas fa-scroll", "class" => "ins_col_2"],
            "_student" => ["icon" => "fas fa-user-graduate", "class" => "ins_col_2"],
            "_address" => ["icon" => "fas fa-map-marker-alt", "class" => "ins_col_2"],
            "_father" => ["icon" => "fas fa-male", "class" => "ins_col_2"],
            "_mother" => ["icon" => "fas fa-female", "class" => "ins_col_2"],
            "_crown" => ["icon" => "fas fa-user-friends", "class" => "ins_col_2"],
        ];






        $sp_class = "_h_border";

        $ad_Class = "ins_ad_done _h_border_after";

        $data = ["start" => ["class" => "ins_stepper ins_grid"]];

        if (!isset($this->_g["mode"])) {

            $this->_g["mode"] = "_terms";
        }
        foreach ($s_data as $k => $v) {
            if ($k == $this->_g["mode"]) {

                $ad_Class = " ins_ad_act _h_border_after   _h_color";
                $sp_class = "_h_bg _h_border ";
            }
            $v["class"] .= " " . $ad_Class;
            $data[] = ["type" => "li", "data" =>
                "<span class='" . $sp_class . "'><i class=\"" . $v["icon"] . "\"></i></span> "
                . "<h4> " . $this->_lang[$k] . " </h4>", "class" => $v["class"]];

            if ($k == $this->_g["mode"]) {
                $sp_class = "";
                $ad_Class = "";
            }
        }
        $data["end"] = [];


        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _terms() {


        $data = [
            "start" => ["class" => " ins_grid _terms"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_terms"]],
            "div" => ["class" => "ad_step_title ins_col_12", "data" => ins::_eng()->_get_plgin("plg_html", ["id" => $this->_pro["intro"]])],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright  ins_col_3", "data-to" => "_student", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];

        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _student() {

        $data = [
            "start" => ["class" => " ins_grid _student_from_area"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_student"]],
            "en_name" => ["title" => $this->_lang["name_en"], "required" => "required", "input" => "true", "pclass" => " ins_col_12", "type" => "text"],
            "name" => ["title" => $this->_lang["name_ar"], "required" => "required", "input" => "true", "pclass" => " ins_col_12", "type" => "text"],
            "gender" => ["title" => $this->_lang["gender"], "required" => "required", "select_value" => $this->_lang["gender_select_value"], "select_text" => $this->_lang["gender_select_text"], "pclass" => " ins_col_6", "type" => "select"],
            "department" => ["title" => $this->_lang["department"], "required" => "required", "select_value" => $this->_lang["department_select_value"], "select_text" => $this->_lang["department_select_text"], "pclass" => " ins_col_6", "type" => "select"],
            "phase" => ["title" => $this->_lang["phase"], "required" => "required", "select_value" => $this->_lang["phase_select_value"], "select_text" => $this->_lang["phase_select_text"], "pclass" => " ins_col_6", "type" => "select"],
            "grade" => ["title" => $this->_lang["grade"], "required" => "required", "select_value" => $this->_lang["grade_select_value"], "select_text" => $this->_lang["grade_select_text"], "pclass" => " ins_col_6", "type" => "select"],
            "dob" => ["title" => $this->_lang["dob"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "date"],
            "religion" => ["title" => $this->_lang["religion"], "required" => "required", "select_value" => $this->_lang["religion_select_value"], "select_text" => $this->_lang["religion_select_text"], "pclass" => " ins_col_6", "type" => "select"],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_address", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright    ins_col_3", "data-add" => "_student_from_area", "data-to" => "_address", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];

        foreach ($data as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $data["$k"]["value"] = $_SESSION["app_admissions_data"][$k];
            }
        }
        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _address() {

        $data = [
            "start" => ["class" => "_address_from_area ins_grid"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_address"]],
            "home_address" => ["title" => $this->_lang["home_address"], "required" => "required", "pclass" => " ins_col_12", "type" => "textarea", "style" => "height:150px;"],
            "phone_number" => ["title" => $this->_lang["phone_number"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "home_phone" => ["title" => $this->_lang["home_phone"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "zipcode" => ["title" => $this->_lang["zipcode"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "student_email" => ["title" => $this->_lang["student_email"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "last_school" => ["title" => $this->_lang["last_school"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "governorate" => ["title" => $this->_lang["governorate"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "town" => ["title" => $this->_lang["town"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "village" => ["title" => $this->_lang["village"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_student", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright    ins_col_3", "data-add" => "_address_from_area", "data-to" => "_father", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];
        foreach ($data as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $data["$k"]["value"] = $_SESSION["app_admissions_data"][$k];
            }
        }


        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _father() {

        $data = [
            "start" => ["class" => "_father_from_area  ins_grid"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_father"]],
            "father_full_name" => ["title" => $this->_lang["full_name"], "required" => "required", "input" => "true", "pclass" => " ins_col_12", "type" => "text"],
            "father_home_address" => ["title" => $this->_lang["home_address"], "required" => "required", "pclass" => " ins_col_12", "type" => "textarea", "style" => "height:150px;"],
            "father_national_id" => ["title" => $this->_lang["national_id"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "father_email" => ["title" => $this->_lang["email"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "father_phone" => ["title" => $this->_lang["phone"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "father_work" => ["title" => $this->_lang["work"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "father_office_phone" => ["title" => $this->_lang["office_phone"], "required" => "required", "input" => "true", "pclass" => " ins_col_12", "type" => "text"],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_address", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft  ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright    ins_col_3", "data-add" => "_father_from_area", "data-to" => "_mother", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];

        foreach ($data as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $data["$k"]["value"] = $_SESSION["app_admissions_data"][$k];
            }
        }

        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _mother() {

        $data = [
            "start" => ["class" => "_mother_from_area ins_grid"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_mother"]],
            "mother_full_name" => ["title" => $this->_lang["full_name"], "required" => "required", "input" => "true", "pclass" => " ins_col_12", "type" => "text"],
            "mother_home_address" => ["title" => $this->_lang["home_address"], "required" => "required", "pclass" => " ins_col_12", "type" => "textarea", "style" => "height:150px;"],
            "mother_national_id" => ["title" => $this->_lang["national_id"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "mother_email" => ["title" => $this->_lang["email"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "mother_phone" => ["title" => $this->_lang["phone"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "mother_work" => ["title" => $this->_lang["work"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "mother_office_phone" => ["title" => $this->_lang["office_phone"], "required" => "required", "input" => "true", "pclass" => " ins_col_6", "type" => "text"],
            "start-btns" => ["class" => "ad_btns_bar  ins_col_12"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_father", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft  ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright    ins_col_3", "data-add" => "_mother_from_area", "data-to" => "_crown", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];

        foreach ($data as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $data["$k"]["value"] = $_SESSION["app_admissions_data"][$k];
            }
        }
        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _crown() {

        $data = [
            "start" => ["class" => "_crown_from_area  ins_grid"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_crown"]],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "crown_ordered" => ["title" => $this->_lang["crown_ordered"], "required" => "required", "select_value" => $this->_lang["crown_ordered_select_value"], "select_text" => $this->_lang["crown_orderedselect_text"], "pclass" => " ins_col_6", "type" => "select"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_mother", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft   ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_next  ins_button   ins_toright    ins_col_3", "data-add" => "_crown_from_area", "data-to" => "_confirm", "data" => $this->_lang["next"]],
            "end-btns" => [],
            "end" => []
        ];
        foreach ($data as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $data["$k"]["value"] = $_SESSION["app_admissions_data"][$k];
            }
        }

        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _confirm() {



        $udata = [
            "start" => ["class" => " ins_grid _student_data_info"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_student"]],
            "en_name" => ["data" => $this->_lang["name_en"], "pclass" => " ins_col_12", "type" => "div"],
            "name" => ["data" => $this->_lang["name_ar"], "pclass" => " ins_col_12", "type" => "div"],
            "gender" => ["data" => $this->_lang["gender"], "pclass" => " ins_col_6", "type" => "div"],
            "department" => ["data" => $this->_lang["department"], "pclass" => " ins_col_6", "type" => "div"],
            "phase" => ["data" => $this->_lang["phase"], "pclass" => " ins_col_6", "type" => "div"],
            "grade" => ["data" => $this->_lang["grade"], "pclass" => " ins_col_6", "type" => "div"],
            "dob" => ["data" => $this->_lang["dob"], "pclass" => " ins_col_6", "type" => "div"],
            "religion" => ["data" => $this->_lang["religion"], "pclass" => " ins_col_6", "type" => "div"],
            "h3-2" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_address"]],
            "home_address" => ["data" => $this->_lang["home_address"], "pclass" => " ins_col_12", "type" => "div"],
            "phone_number" => ["data" => $this->_lang["phone_number"], "pclass" => " ins_col_6", "type" => "div"],
            "home_phone" => ["data" => $this->_lang["home_phone"], "pclass" => " ins_col_6", "type" => "div"],
            "zipcode" => ["data" => $this->_lang["zipcode"], "pclass" => " ins_col_6", "type" => "div"],
            "student_email" => ["data" => $this->_lang["student_email"], "pclass" => " ins_col_6", "type" => "div"],
            "last_school" => ["data" => $this->_lang["last_school"], "pclass" => " ins_col_6", "type" => "div"],
            "governorate" => ["data" => $this->_lang["governorate"], "pclass" => " ins_col_6", "type" => "div"],
            "town" => ["data" => $this->_lang["town"], "pclass" => " ins_col_6", "type" => "div"],
            "village" => ["data" => $this->_lang["village"], "pclass" => " ins_col_6", "type" => "div"],
            "h3-3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_father"]],
            "father_full_name" => ["data" => $this->_lang["full_name"], "pclass" => " ins_col_12", "type" => "div"],
            "father_home_address" => ["data" => $this->_lang["home_address"], "pclass" => " ins_col_12", "type" => "div"],
            "father_national_id" => ["data" => $this->_lang["national_id"], "pclass" => " ins_col_6", "type" => "div"],
            "father_email" => ["data" => $this->_lang["email"], "pclass" => " ins_col_6", "type" => "div"],
            "father_phone" => ["data" => $this->_lang["phone"], "pclass" => " ins_col_6", "type" => "div"],
            "father_work" => ["data" => $this->_lang["work"], "pclass" => " ins_col_6", "type" => "div"],
            "father_office_phone" => ["data" => $this->_lang["office_phone"], "pclass" => " ins_col_12", "type" => "div"],
            "h3-55" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_mother"]],
            "mother_full_name" => ["data" => $this->_lang["full_name"], "pclass" => " ins_col_12", "type" => "div"],
            "mother_home_address" => ["data" => $this->_lang["home_address"], "pclass" => " ins_col_12", "type" => "div"],
            "mother_national_id" => ["data" => $this->_lang["national_id"], "pclass" => " ins_col_6", "type" => "div"],
            "mother_email" => ["data" => $this->_lang["email"], "pclass" => " ins_col_6", "type" => "div"],
            "mother_phone" => ["data" => $this->_lang["phone"], "pclass" => " ins_col_6", "type" => "div"],
            "mother_work" => ["data" => $this->_lang["work"], "pclass" => " ins_col_6", "type" => "div"],
            "mother_office_phone" => ["data" => $this->_lang["office_phone"], "pclass" => " ins_col_6", "type" => "div"],
            "end" => [],
        ];




        foreach ($udata as $k => $v) {
            if (isset($_SESSION["app_admissions_data"][$k])) {
                $udata["$k"]["data"] = "<strong>".  $udata["$k"]["data"]."</strong>"."<span> " . $_SESSION["app_admissions_data"][$k] . " </span>";
            }
        }























        $data = [
            "start" => ["class" => " ins_grid"],
            "h3" => ["class" => "ad_step_title ins_col_12", "data" => $this->_lang["_confirm"]],
            "div" => ["data" => ins::_ui()->_data($udata)->_render(), "class" => "ins_col_12"],
            "start-btns" => ["class" => "ad_btns_bar ins_col_12"],
            "button-per" => [style => "width: 150px;border:1px solid;", "data-to" => "_crown", "class" => "ad_btns_next   _bg_light _dark_border  ins_toleft  ins_col_3", "data" => $this->_lang["perv"]],
            "button" => [style => "width: 150px;", "class" => "ad_btns_confirm  ins_button   ins_toright  ins_col_3", "data-to" => "_confirm", "data" => $this->_lang["confirm"]],
            "end-btns" => [],
            "end" => []
        ];

        $this->r .= ins::_ui()->_data($data)->_render();
    }

    function _out() {
        $this->_include("style.css");
        $this->_include("my_script.js");

        $this->_w_map();


        switch ($this->_g["mode"]) {
            case "_student":
                $this->_student();
                break;
            case "_address":
                $this->_address();
                break;
            case "_father":
                $this->_father();
                break;
            case "_mother":
                $this->_mother();
                break;
            case "_crown":
                $this->_crown();
                break;

            case "_confirm":
                $this->_confirm();
                break;




            default :
                $this->_terms();
                break;
        }


        return ins::_ui()->_data(["div" => ["data" => $this->r,
                        "data-msg" => $this->_lang["_add_success_message"],
                        "data-error_msg" => $this->_lang["error_msg"],
                        "data-url" => ins::_app_map()->_url([], ["mode"]),
                        "class" => " app_admissions_data"]]
                )->_render();
    }

}
