<?php

class com_wizard extends ins_com {

    var $r = "";
    var $data = "";
    var $page = "";
    var $next_page = "";
    var $prev_page = "";

    public function __construct($data) {
        parent::__construct($data);

        $this->data = $this->__db->_get_row("com_wizard", "*", "id=:var_id", ["var_id" => $this->_pro["code"]])["data"];
    }

    function update_data() {
        $this->_include("my_style.css");
        $g = $this->__eng->_get();
        $this->data = json_decode($this->data, true);
        $d = array_keys($this->data);
        if (isset($g["mode"])) {
            $tkey = $g["mode"];
        }
        $myi = $this->get_my_array_index($tkey);
        $this->page = $this->data[$d[$myi]];
        $this->next_page = $this->data[$d[$myi + 1]];
        $this->prev_page = $this->data[$d[$myi - 1]];
    }

    function get_my_array_index($tkey) {
        $r = 0;
        $i = 0;
        foreach ($this->data as $d) {
            if ($d["name"] == $tkey) {
                $r = $i;
            }
            $i++;
        }
        return $r;
    }

    function _get_page_block($type, $name, $settings) {
        $r = "";
        switch ($type) {
            case "plugins":
                $r = $this->__eng->_get_plgin($name, $settings);
                break;
            case "modules":
                $r = $this->__eng->_getModels_bytype($name, $settings);
                break;
            default:
                break;
        }
        return $r;
    }

    function _get_page_data() {
        $h = "";

        \lib::_template()->_menu["title"] = $this->page["title"];

        foreach ($this->page as $page) {
            if (is_array($page)) {
                $category = explode(">", $page["category"]);
                $category = array_filter($category);

                if (!isset($page["type"]) || $page["type"] == "") {
                    $page["type"] = $category[2];
                }

                $h .= $this->_get_page_block(strtolower($category[0]), $page["type"], $page["setting"]);
            }
        }

        $this->r .= $this->__ui->_data(["div" => ["data" => $h, "class" => "grid"]])->_render();
        ;
    }

    function _header() {
        $this->r .= "<ul class='col4 w_header toright'>";
        $i = 0;
        $g = $this_page = $this->__eng->_get();




        foreach ($this->data as $d) {
             $i++;
            $m = "";
            if ($g["mode"] == $d["name"]) {
                $m = "act";
            }else

            if (!isset($g["mode"]) && $i == "1") {
                $m = "act";
            }

           
            $this->r .= "<li class='$m'>$i</li>";
        }
        $this->r .= "</ul>";
    }

    function _buttons_bar() {

        if (isset($this->page["next_bt"]) && $this->page["next_bt"] != "") {
            $l .= $this->__ui->_data(["li" => [
                            "class" => "toright",
                            "data" =>
                            $this->__ui->_data(["a" => [
                                    "data" => $this->page["next_bt"], "class" => "ins_wizard_next",
                                    "href" => $this->__eng->_url(["mode" => $this->next_page["name"]])
                                ]
                            ])->_render()
                        ]
                    ])->_render();
        }
        if (isset($this->page["prev_bt"]) && $this->page["prev_bt"] != "") {

            $l .= $this->__ui->_data(["li" => [
                            "class" => "toleft",
                            "data" =>
                            $this->__ui->_data(["a" => [
                                    "data" => $this->page["prev_bt"], "class" => "ins_wizard_prev",
                                    "href" => $this->__eng->_url(["mode" => $this->prev_page["name"]])
                                ]
                            ])->_render()
                        ]
                    ])->_render();
        }

        $this->r .= $this->__ui->_data(["ul" => ["data" => $l, "class" => "w_buttons"]])->_render();
    }

    function _out() {
        $this->update_data();

        $this->_header();
        $this->_get_page_data();
        $this->_buttons_bar();
        return $this->r;
    }

}
