<?php

class sys_content extends ins_com
{

    public function __construct($data = null)
    {
        parent::__construct($data);
    }

    var $_render = "";
    var $_type = "category";
    var $_id = "";
    var $_cat_data = "";

    function updateData()
    {

        $this->_pro["number_per_page"] = $this->_pro["number_per_page"] ? $this->_pro["number_per_page"] : "12";



        $g = $this->__eng->_get();
        if (isset($g["id"])) {
            $this->_type = "item";
            $this->_id = $g["id"];
            $this->_cat_data = $this->__db->_get_row("sys_content_categories", "*", "alias='" . $g["mode"] . "'");
        } else {
            $this->_type = "category";

            if (isset($g["mode"])) {
                $this->_cat_data = $this->__db->_get_row("sys_content_categories", "*", "alias='" . $g["mode"] . "'");
            } else {
                $this->_cat_data = $this->__db->_get_row("sys_content_categories", "*", "id='" . $this->_pro["category"] . "'");
            }
        }
    }

    function get_categories()
    {
        $r = "";
        $data = \ins::_db()->_get_data("sys_content_categories", "*", \ins::_data()->_db_get_form_group($this->_cat_data["id"]) . " order by `sys_order` limit 0," . $this->_pro["number_per_page"]);
        foreach ($data as $d) {
            $array_data["imimage"] = '<span class="squ_img"> <u> <strong> <em> <img src="' . \ins::_app_map()->upload_folder . $d["image"] . '"> </em> </strong></u> </span>';
            $array_data["title"] = $d["title"];

            $array_data["des"] = $d["des"];
            $array_data["url"] = \ins::_eng()->_url(["mode" => $d["alias"]]);

            $r .= \ins::_ui()->_data(["data_block" => ["class" => "_" . $d["cat_id"], "data" => $array_data]])->_render();
        }
        $this->_render .= \ins::_ui()->_data(["div" => ["class" => "sys_content_items   data_cats", "data" => $r]])->_render();
    }

    function get_items()
    {
        $r = "";
        if ($this->_cat_data["id"]) {
            $data = \ins::_db()->_get_data("sys_content", "*", \ins::_data()->_db_get_form_group($this->_cat_data["id"]) . " order by `sys_order` limit 0," . $this->_pro["number_per_page"]);
            $catdata = \ins::_db()->_get_row("sys_content_categories", "*", "id=" . $this->_cat_data["id"]);

            \ins::_data()->_update_language($catdata);
            foreach ($data as $d) {

                \ins::_data()->_update_language($d);

                if ($d["th_image"] != "") {
                    $blockdata["image"] = ins::_app_map()->upload_folder . $d["th_image"];
                }

                if ($d["ex_url"] != "") {
                    $blockdata["url"] = $d["ex_url"];
                }


                $g = ins::_eng()->_get();

                $menu = \ins::_eng()->get_menu_by_type();

                if (\lib::_eng()->_this_lang == "ar") {
                    $date = \ins::_data()->_datetime()->dataFormat($d["start_date"], "y-m-d");
                    $blockdata["info_data"] = \ins::_data()->_datetime()->arabicDate($date);
                } else {

                    $blockdata["info_data"] = \ins::_data()->_datetime()->dataFormat($d["start_date"], " d M");
                }


                $blockdata["title"] = $d["title"] . '<div class=\'ins_module_title_icon\'><i class=\"fas fa-graduation-cap\"></i></div>';
                $blockdata["des"] = $d["des"];
                if ($d["mark"] == "video") {
                    $blockdata["hover_effect"] = '<i class="fas fa-video"></i>';
                } else if ($d["mark"] == "image") {
                    $blockdata["hover_effect"] = '<i class="fas fa-images"></i>';
                } else {

                    $blockdata["hover_effect"] = '<i class="fab fa-readme"></i>';
                }

                $blockdata["url"] = \ins::_eng()->_url(["alias" => $g["alias"], "mode" => $catdata["alias"], "id" => $d["alias"]]);


                $r .= \ins::_ui()->_data(["data_block" => ["data" => $blockdata, "data-title" => $d["title"], "data-id" => $d["id"], "class" => "$class    _item_block  ins_col_4   "]])->_render();
            }


            $this->_render .= \ins::_ui()->_data(["div" => ["class" => " grid  sys_content_items ", "data" => $r]])->_render();
        }
    }

    function get_item()
    {

        $r = "";
        $d = \ins::_db()->_get_row("sys_content", "*", "alias='" . $this->_id . "' limit 0," . $this->_pro["number_per_page"]);
        \ins::_data()->_update_language($d);

        $cdata = \ins::_db()->_get_row("sys_content_categories", "*", "id=" . $d["cat_id"]);
        \ins::_data()->_update_language($cdata);


        \lib::_template()->_menu["title"] = $d["title"];

        $ds = \ins::_db()->_get_data("sys_images", "*", "cat_id=:id", ["id" => $d["images_id"]]);

        if (count($ds) > 0) {
            $r .= \ins::_eng()->_get_plgin("plg_ins_images_slideshow", [
                "cat_id" => $d["images_id"], "pages" => "circle"
            ]);
        }





        if ($d["image"] != "") {

            $img = '<div class="content_item_img  _h_bg  " style="padding:20px"><img src="' . \ins::_app_map()->upload_folder . $d["image"] . '" /></div>';
        }


        if ($d["images_id"] != "" && $d["images_id"] != "0") {

            $o["cat_id"] = $d["images_id"];
            $o["theme"] = "light_box_gallery";
            $img = \ins::_eng()->_get_plgin("plg_ins_images_slideshow", $o);
        }



        if (\lib::_eng()->_this_lang == "ar") {
            $date = \ins::_data()->_datetime()->dataFormat($d["start_date"], "y-m-d");
            $date = str_replace("<br/>", "", \ins::_data()->_datetime()->arabicDate($date));
        } else {

            $date = \ins::_data()->_datetime()->dataFormat($d["start_date"], " d M");
        }
        $count = ins::_db()->_get_row("plg_comments", "count(id) as cid", "obj_type='sys_content' and obj_id='" . $d["id"] . "' ")["cid"];


        $img .= '<div class="content_item_info"> '
            . '<span class="tb-blog-date"> '
            . '<i class="fa fa-calendar"></i><time>' . $date . '</time>'
            . ' </span>'
            . ' <span class="comments-number"><i class="fa fa-comments"></i> ' . $count . " " . $this->_lang["Comment"] . '</span></div>';





        $this->_render .= ins::_ui()->_data(
            [
                "start" => ["class" => "  content_item_data "],
                "div" => ["class" => "", "data" => $img],
                "h4" => ["class" => " content_item_title", "data" => $d["title"]],
                "div-des" => ["class" => "   content_item_des   ", "data" => $d["des"]],
                "div-body" => ["class" => "   content_item_body   ", "data" => $d["body"]],
                "plugin" => ["class" => "ins_col_12", "data" => "plg_social", "area" => "root", "viwtype" => "share"],
                "plugin-2" => [
                    "class" => "ins_col_12", "data" => "plg_comments", "area" => "root", "obj_type" => "sys_content",
                    "title" => $d["title"],
                    "image" => $d["th_image"],
                    "des" => $d["des"],
                    "obj_id" => $d["id"]
                ],
                "end" => []
            ]
        )->_render();
    }

    function _out()
    {

        $this->_include("style.css");
        $this->updateData();


        switch ($this->_type) {
            case "category":

                $this->get_items();

                break;
            default:
                $this->get_item();
                break;
        }





        $data = [
            "div" => [
                "class" => " app_content      " . $this->_pro["block_style"],
                "data-_myname" => $this->_myname,
                "data-_mypath" => $this->_myPath,
                "data" => $this->_render
            ]
        ];

        return \lib::_ui()->_data($data)->_render(["mode"]);
    }
}
