<?php

class sys_images extends ins_com
{

    public function __construct()
    {
        parent::__construct();
    }

    var $cat_id = "0";
    var $type = "category";
    var $render = "";
    var $_cate = "";

    function updateData()
    {
        $g = $this->__eng->_get();

        if (isset($g["mode"])) {
            $this->_type = "item";
            $this->_cate = $this->__db->_get_row("sys_images_categories", "*", "alias=:cat_id", ["cat_id" => $g["mode"]]);
        } else {
            $this->_type = "category";
            $this->_cate = $this->__db->_get_row("sys_images_categories", "*", "alias=:cat_id", ["cat_id" => $this->_pro["cat_id"]]);
        }
    }

    function getcategory()
    {
        $g = $this->__eng->_get();
        $data_sql = $this->__db->_get_data("sys_images_categories", "*", \ins::_data()->_db_create_where_to_group($this->_cate["id"]));
        foreach ($data_sql as $d) {
            $blockdata["image"] = $d["th_image"] ? $this->__app_map->upload_folder . $d["th_image"] : "";
            if ($blockdata["image"] == "" && $d["image"] != "") {
                $blockdata["image"] = $this->__app_map->upload_folder . $d["image"];
            } else if ($blockdata["image"] == "") {
                $data_fsql = \ins::_db()->_get_row("sys_images", "*", \ins::_data()->_db_get_form_group($d["id"]));
                $blockdata["image"] = \ins::_app_map()->upload_folder . $data_fsql["th_image"];
            }
            $data_fsql = \ins::_db()->_get_row("sys_images", "count(id) as cid", \ins::_data()->_db_get_form_group($d["id"]))["cid"];
            $ccount = ins::_db()->_get_row("plg_comments", "count(id) as cid", "obj_type='sys_images_categories' and obj_id='" . $d["id"] . "' ")["cid"];



            $blockdata["info_data"] = '<span>' . $data_fsql . '<i class="fas fa-images"></i>'
                . '</<span>' . '<span class="info_comments">' . $ccount . '<i class="fas fa-comment-dots"></i></<span>';
            $blockdata["title"] = $d["title"];
            $blockdata["hover_effect"] = '<i class="fab fa-readme"></i>';
            $blockdata["url"] = $this->__eng->_url(["alias" => $g["alias"], "mode" => $d["alias"]]);

            $r .= \ins::_ui()->_data(["data_block" => ["data" => $blockdata, "data-title" => $d["title"], "data-cat_id" => $d["id"], "class" => "$class  _item_block  ins_col_4   "]])->_render();
        }

        $this->render .= $this->__ui->_data([
            "div" => ["class" => "ins_grid _images_block  ", "data" => $r],
            "div-2" => ["class" => "clearfix"],
        ])->_render();
    }

    function get_item()
    {

        $o["cat_id"] = $this->_cate["id"];
        $o["theme"] = "light_box_gallery";
        $r = \ins::_eng()->_get_plgin("plg_ins_images_slideshow", $o);


        $this->render = $this->__ui->_data([
            "div" => ["class" => "images_main_area _h_bg ", "style" => "padding:20px", "data" => $r],
            "span" => ["data" => \ins::_data()->_datetime()->dataFormat($d["sys_created"], " d M")],
            "h4" => ["class" => "  ", "data" => $this->_cate["title"]],
            "plugin" => ["class" => "ins_col_12", "data" => "plg_social", "area" => "root", "viwtype" => "share"],
            "plugin-2" => ["class" => "ins_col_12", "data" => "plg_comments", "area" => "root", "obj_type" => "sys_images_categories", "obj_id" => $this->_cate["id"]]
        ])->_render();
    }

    function _out()
    {
        $this->_include("my_style.css");
        $this->_include("my_script.js");

        $this->updateData();


        switch ($this->_type) {
            case "category":
                $this->getcategory();
                break;
            default:
                $this->get_item();
                break;
        }



        return $this->render;
    }
}
