<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace ins_lib\data;

/**
 * Description of DataClass
 *
 * @author ismail
 */
class DataClass
{
    /* @var $_datetime \ins_lib\data\datatimeClass */

    public $_datetime = null;




    public function __construct()
    {
        /* @var $_datetime \ins_lib\data\datatimeClass */
        $this->_datetime = new \ins_lib\data\datatimeClass();
    }

    /**
     * 
     * @staticvar type $_eng
     * @return  \ins_lib\data\datatimeClass
     */
    public static function _datetime()
    {
        static $_r = null;
        if ($_r === null) {
            $_r = new \ins_lib\data\datatimeClass();
        }

        return $_r;
    }

    /**
     * 
     * @param type $arrays or String 
     * @param type $more
     * @param type $field
     * @return type
     */
    function _db_create_where_to_group($value, $field = "cat_id")
    {

        return $w = "( $field like '%,$value' or $field like '$value,%' or $field like '%,$value,%' or $field = '$value')";
    }







    function _load_json($file)
    {


        $data = file_get_contents("http://mozare3.insya.me/ins_lib/includes/json/$file.json");
        return    $json = json_decode($data, true);
    }


    /**
     * 
     * @param type $arrays or String 
     * @param type $more
     * @param type $field
     * @param type $array_key

     * 
     * @return type
     */
    function _db_create_where_from_array($arrays, $more = "or", $field = "id", $array_key = "")
    {

        $r = "";
        $m = "";







        if (!is_array($arrays)) {
            $arrays = explode(",", $arrays);
        }
        $arrays = array_filter($arrays);
        $arrays = array_unique($arrays);

        //print_R($arrays);

        foreach ($arrays as $a) {
            $a = $array_key ? $a[$array_key] : $a;

            $r .= " " . $m . " " . $field . '="' . $a . '"';


            $m = $more;
        }

        if ($r == "") {
            $r = "1<>1";
        }
        $r = "($r)";
        return $r;
    }

    /**
     * 
     * @param type $data []
     * @return string ex: k>v@k>v@k>v@k>v@k>v\\k>v@k>v@k>v@k>v@k>v\\
     */
    public function _arrayToDB($data = [])
    {
        return json_encode($data);
    }

    public function get_ins_list($name, $value = "")
    {
        $_data_json = \lib::_db()->_get_row("sys_lists", "*", "name='" . $name . "'")["data"];
        $d = json_decode($_data_json, true);

        if ($value == "") {

            return $d;
        } else {


            return $d["$value"];
        }
    }

    function _is_json($string)
    {
        $ob = json_decode($string);
        return !($ob === null);
    }

    function date_value()
    {

        return date("Y-m-d");
    }

    function _password($length = 8)
    {
        $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
        $pass = array(); //remember to declare $pass as an array
        $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
        for ($i = 0; $i < $length; $i++) {
            $n = rand(0, $alphaLength);
            $pass[] = $alphabet[$n];
        }
        return implode($pass);
    }

    /**
     * 
     * @param type $data  k>v@k>v@k>v@k>v@k>v\\k>v@k>v@k>v@k>v@k>v\\
     * @return string ex:[]
     */
    public function _arrayFromDB($data = "")
    {
        if ($data != "") {
            return array_filter(json_decode($data, true));
        } else {
            return $data;
        }
    }

    public function _get_number($string)
    {
        $string = strip_tags($string);
        return preg_replace("/[^0-9.-]/", "", $string);
    }

    public function _get_properties_DB($obj_type, $obj_id)
    {
        $data = \lib::_db()->_get_row($obj_type, "sys_properties", " `id`=:obj_id ", ["obj_id" => $obj_id])["sys_properties"];
        return \lib::_data()->_arrayFromDB($data);
    }

    function _encrypt_decrypt($action, $string)
    {
        $output = false;
        $encrypt_method = "AES-256-CBC";
        $secret_key = \lib::_options()->secret_key;
        $secret_iv = \lib::_options()->secret_iv;
        // hash
        $key = hash('sha256', $secret_key);

        // iv - encrypt method AES-256-CBC expects 16 bytes - else you will get a warning
        $iv = substr(hash('sha256', $secret_iv), 0, 16);
        if ($action == 'encrypt') {
            $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
            $output = base64_encode($output);
        } else if ($action == 'decrypt') {
            $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
        }
        return $output;
    }

    private function _lang_update_word($word, $data = [], $lang = "")
    {


        $as = explode(".", $word);
        $dataarray = [];
        $return_word = true;
        if (count($as) > 1) {

            $w = $as[1];
            $type = $as[0];
            switch ($type) {
                case "get":
                    $dataarray = \lib::_eng()->_get();
                    break;
                case "session":
                    $dataarray = $_SESSION;
                    break;
                case "post":
                    $dataarray = $_POST;
                    break;

                case "db":
                    $dataarray = $data;
                    break;
                case "function":
                    $word = call_user_func($as[1]);
                    break;
                default:





                    if (is_array($data[$as[0]])) {

                        $word = $data[$as[0]][$as[1]];
                    }
                    break;
            }
        } else {

            $dataarray = $data;
            $w = $word;
        }




        if (is_array($dataarray) && count($dataarray) > 0) {
            $as = explode(".", $word);
            $r = $this->get_array_value($dataarray, str_replace($as[0] . ".", "", $word));
        }

        if ($r == "" && $return_word && $type != "session" && $type != "db") {

            $r = $word;
        }


        return $r;
    }

    function get_array_value($array, $data)
    {


        $as = explode(".", $data);
        if (count($as) > 1) {
            $w = str_replace($as[0] . ".", "", $data);
            $m = $this->get_array_value($array[$as[0]], $w);
        } else {
            if (isset($array[$as[0]])) {
                $m = $array[$as[0]];
            } else {
                $m = "";
            }
        }

        return $m;
    }

    /**
     * 
     * @param type $String  format @(v)
     * @param type $data
     * @param type $lang
     * @return type
     * 
     */
    public function _lang_trans($String, $data = [], $lang = "")
    {


        if (is_array($String)) {

            foreach ($String as $k => $v) {
                if (is_string($v)) {
                    preg_match_all('/@\\((.*?)\)/', $v, $matches);

                    if (is_array($matches) && count($matches) > 0) {
                        array_filter($matches);
                        if (is_array($matches[0])) {

                            for ($i = 0; $i < count($matches[0]); $i++) {
                                $m = $matches[1][$i];
                                $w = '@(' . $m . ')';
                                $v = str_replace($w, $this->_lang_update_word($m, $data, $lang), $v);
                            }
                        }
                    }
                }
                $String[$k] = $v;
            }
        } else {


            preg_match_all('/@\\((.*?)\)/', $String, $matches);

            if (is_array($matches) &&  count($matches) > 0) {
                array_filter($matches);
                if (is_array($matches[0])) {



                    if ($matches[0] != null) {


                        for ($i = 0; $i < count($matches[0]); $i++) {
                            $m = $matches[1][$i];
                            $w = '@(' . $m . ')';

                            $String = str_replace($w, $this->_lang_update_word($m, $data, $lang), $String);
                        }
                    }
                }
            }
        }




        return $String;
    }

    public function _get_gen_word($name, $file = "general", $lng = "", $defult = null)
    {
        $lng = ($lng != "" ?: \lib::_eng()->_this_lang);


        $v = \lib::_files()->loadfile(\lib::_app_map()->language_folder . "/" . $lng . "/$file.xml", "", "array")->out[$name];

        if ($v == "") {

            if ($defult != null) {
                $v = $defult;
            } else {
                $v = $name;
            }
        }
        return $v;
    }

    /**
     * 
     * @param type $data
     * [obj_id,obj_type,obj_name,data_new,data_old,data_type]
     * @param type $user_id
     * @return type
     */
    function _add_history($data, $user_id = "")
    {
        if ($user_id == "") {
            $user_id = $_SESSION["sys_users_login_data"]["id"];
        }

        return \lib::_db()->_insert("sys_history", [
            "obj_id" => $data["obj_id"],
            "obj_type" => $data["obj_type"],
            "obj_name" => $data["obj_type"],
            "data_new" => $data["data_new"],
            "data_old" => $data["data_old"],
            "data_type" => $data["data_type"],
            "user_id" => $user_id
        ]);
    }

    public function _update_data_language($obj_type, &$data, $obj_id = "", $obj_field = "", $lang = "")
    {
        $adata = $data;
        $lang = ($lang != "" ? $lang : \lib::_eng()->_this_lang);
        if (is_array($adata)) {
            if (isset($adata["sys_languages"])) {
                $languages = json_decode($adata["sys_languages"], true);
                foreach ($adata as $dk => $dv) {
                    if (isset($languages[$dk][$lang])) {
                        $adata[$dk] = $languages[$dk][$lang];
                    }
                }
            }
        } else {
            $data = $this->_get_language_data($obj_type, $obj_field, $obj_id, $lang);
        }


        $data = $adata;

        return $adata;
    }

    public function _update_language(&$data, $lang = "", $clear = false, $fild = "sys_languages",  $prefix = "")
    {
        $adata = $data;
        $lang = ($lang != "" ? $lang : \lib::_eng()->_this_lang);

        if (isset($adata[$prefix . $fild])) {
            $languages = json_decode($adata[$prefix . $fild], true);

            foreach ($adata as $dk => $dv) {
                $lang_name = str_replace($prefix, "", $dk);
                if (isset($languages[$lang_name][$lang])) {

                    $adata[$dk] = $languages[$lang_name][$lang];
                }
            }

            if ($clear) {
                unset($adata[$fild]);
            }
        }

        $data = $adata;

        return $adata;
    }





    public function _update_language_array(&$data, $lang = "", $clear = false, $fild = "sys_languages", $prefix = "")
    {
        $adata = $data;
        $lang = ($lang != "" ? $lang : \lib::_eng()->_this_lang);
        foreach ($adata as $rowk => $rowv) {

            $this->_update_language($rowv, $lang, $clear,   $fild, $prefix);
            $adata[$rowk] = $rowv;
        }
        $data = $adata;
        return $adata;
    }






    public function _get_language_data($obj_type, $obj_field, $obj_id, $lang = "", $old_Value = "")
    {
        $lngs = \lib::_db()->_get_row($obj_type, "*", "id=$obj_id")["sys_languages"];
        $lngs = json_decode($lngs, true);
        if (isset($lngs[$obj_field][$lang])) {
            return $lngs[$obj_field][$lang];
        } else {
            return "";
        }
    }

    public function _set_string_limit($data, $limit = 35)
    {

        $r = substr($data, 0, $limit);
        if (strlen($data) > $limit) {

            $r .= "...";
        }
        return $r;
    }

    public function _set_language_data($lang, $obj_type, $obj_field, $obj_id, $new_value, $old_value = "")
    {
        $w = "id=$obj_id";
        $lngs = \lib::_db()->_get_row($obj_type, "*", $w)["sys_languages"];


        $lngs = json_decode($lngs, true);
        if (!is_array($lngs)) {
            $lngs = [$obj_field => [$lang => $new_value]];
        } else {

            $lngs[$obj_field][$lang] = $new_value;
        }



        $data = \lib::_db()->_update($obj_type, ["sys_languages" => json_encode($lngs)], $w);


        return $data;
    }

    public function _get_filter_toarray(&$qury_c = null, $query_type = " and ")
    {
        $r = [];

        $g = \lib::_eng()->_get();
        if (isset($g["filter"])) {
            $data = explode(";", $g["filter"]);
            $fields = explode(",", $data[0]);
            $values = explode(",", $data[1]);
            $qury = "";
            if (count($fields) > 0) {

                $m = "";
                for ($i = 0; $i < count($fields); $i++) {

                    if ($fields[$i] != "") {
                        $r[$fields[$i]] = $values[$i];
                        $qury .= $m . "`" . $fields[$i] . "` ='" . $values[$i] . "'";
                        $m = $query_type;
                    }
                }

                if ($qury != "") {
                    if ($qury_c) {
                        $qury_c = "($qury)";
                    }
                }
            }
        }

        return $r;
    }

    public function _creat_filter($data, &$filter_data, &$qury_c, $query_type = " and ")
    {


        $filter_data = $this->_get_filter_toarray($qury_c, $query_type);



        $start = ["start" => ["class" => " ins_filter_area"]];

        $end = ["end" => []];


        foreach ($data as $k => $v) {

            if (!isset($data[$k]["name"])) {

                $name = explode("-", $k)[1];
            } else {
                $name = $data[$k]["name"];
            }

            $data[$k]["data-url"] = \lib::_eng()->_url("", ["filter"]);
            $data[$k]["class"] .= "filter_item $name";


            if (isset($filter_data[$name])) {
                $data[$k]["value"] = $filter_data[$name];
            }


            $data[$k]["data-field"] = $name;
            unset($data[$k]["name"]);
        }
        $data = array_merge($start, $data, $end);




        return \lib::_ui()->_data($data)->_render();
    }

    public function is_mod(
        $name
    ) {
        $pre = explode("_", $name)[0];
        return in_array($pre, \lib::_options()->mod_prefs);
    }

    public function is_com(
        $name
    ) {
        $pre = explode("_", $name)[0];
        return in_array($pre, \lib::_options()->com_prefs);
    }

    public function is_tmp(
        $name
    ) {
        $pre = explode("_", $name)[0];
        return in_array($pre, \lib::_options()->template_prefx);
    }

    public function is_plg(
        $name
    ) {
        $pre = explode("_", $name)[0];
        return in_array($pre, \lib::_options()->plg_prefs);
    }

    function _get_img($img, $path = "")
    {

        if ($path == "" || $path == null) {
            $path = \lib::_app_map()->upload_folder;
        }

        return $path . "" . $img;
    }

    function _get_area($area = "")
    {
        if ($area != "") {
            $area = ($area == "root") ? "" : $area;
            $area = $area . "/";
        } else {
            if (\lib::$_area["url"] == "root") {
                $area = "";
            } else {

                $area .= \lib::$_area["url"] . "/";
            }
        }
        return $area;
    }

    function _this_area($option = "")
    {

        $area = \lib::$_area;

        if ($area == "") {
            $area = $area["home"];
        }

        if ($option == "") {
            return $area;
        } else {
            return $area[$option];
        }
    }

    function _this_area_byurl($option = "")
    {
        foreach (\lib::_options()->areas as $rea) {
            if (trim($rea["url"]) == trim($option)) {
                return $rea;
            }
        }
    }

    function _url_clrea($url)
    {
        $url;

        $url = str_replace("//", "/", $url);
        $url = str_replace("do//do", "do", $url);
        $url = str_replace("do/do", "do", $url);

        return $url;
    }

    function limit_text($text, $limit)
    {

        $text = strip_tags($text);
        $words = explode(" ", $text);

        if (count($words) > $limit) {

            $text = implode(" ", array_splice($words, 0, $limit)) . "...";
        }

        return $text;
    }

    function format_currency($v, $currency_type = "")
    {

        setlocale(LC_MONETARY, 'en_US');
        $v = money_format('%i', $v);

        return $currency_type . trim(str_replace(["USD", ".00"], "", $v));
    }

    function _number_to_text($value, $lang = "en")
    {

        $f = new \NumberFormatter($lang, \NumberFormatter::SPELLOUT);
        return $f->format($value);
    }

    function _format_currency($v, $currency_type = "")
    {

        setlocale(LC_MONETARY, 'en_US');
        $v = money_format('%i', $v);

        return $currency_type . trim(str_replace(["USD", ".00"], "", $v));
    }

    function _format_number_to_text($value, $lang = "en")
    {

        $f = new \NumberFormatter($lang, \NumberFormatter::SPELLOUT);
        return $f->format($value);
    }

    function _app_settings_get($pp, $user_id = "")
    {

        \ins::_app_map()->_include_plgin_class("plg_sys_app_settings");


        return \plg_sys_app_settings::_get($pp, $user_id);
    }

    function _app_settings_set($app, $name, $value)
    {

        \ins::_app_map()->_include_plgin_class("plg_sys_app_settings");

        return \plg_sys_app_settings::_set(["app" => $app, "name" => $name, "value" => $value]);
    }

    // <editor-fold defaultstate="collapsed" desc="Old Version">

    /**
     * @param Old Version
     */
    function arrayTofieldDB($arrays, $more = "or", $field = "id")
    {

        return $this->_db_create_where_from_array($arrays, $more, $field);
    }

    /**
     * @param  Old Version
     */
    function _dataToWhereDB($arrays, $more = "or", $field = "id")
    {
        return $this->_db_create_where_from_array($arrays, $more, $field);
    }

    /**
     * @param   Old Version
     */
    function _db_get_form_group($value, $field = "cat_id")
    {
        return $this->_db_create_where_to_group($value, $field);
    }

    function _is_image($path)
    {

        //config_site
        $path =  \ins::_map()->url . $path;
        // $path =  \ins::_map()->_clean($path);

        //echo $path . "<br/>";


        list($width, $height, $type, $attr) = getimagesize($path);
        //print_R($width);

        $a = getimagesize($path);
        //print_R($a);
        $image_type = $a[2];
        //echo $image_type . "<br/>";


        if (in_array($image_type, array(IMAGETYPE_GIF, IMAGETYPE_JPEG, IMAGETYPE_PNG, IMAGETYPE_BMP))) {
            return true;
        }
        return false;
    }


    // </editor-fold>
}
