<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of DBClass
 *
 * @author ismail
 */

namespace ins_lib\db;

class DBClass
{

    public $db;
    public $the_query;
    private $returnCount = false;
    public $_get_deleted = false;
    public $_get_disabled = false;
    public $_history_limit = 20;

    /*
  
    
    function create_history($table_name, $opration, $data, $obj_id = "", $old_data = "", $new_data = "")
    {


        $user_history_limit = \lib::_config()->site["user_history_limit"];

        if (!isset($_SESSION["sys_users_login_data"])) {
            $id = "0";
        } else {

            $id = \lib::_usere()->_get("id");
        }
        if (is_array($obj_id)) {


            $obj_id = $obj_id["id"];
        }


        if ($table_name != "sys_history" && $obj_id != "") {
            $count = \lib::_db()->_get_row("sys_history", "count(id) as c", "user_id=$id")["c"];


            if ($count > $user_history_limit) {
                $limit = $count - $user_history_limit;
                $count = \lib::_db()->_delete("sys_history", "user_id='" . \lib::_usere()->_get("id") . "' ORDER BY `id` LIMIT " . $limit);
            }

            $user_Data = [
                "title" => \lib::_usere()->_get("title"),
                "group" => \lib::_usere()->_get("group")
            ];


            \lib::_db()->_insert("sys_history", [
                "obj_id" => $obj_id,
                "old_data" => $old_data,
                "table_name" => $table_name,
                "operation" => $opration,
                "new_data" => $new_data,
                "data" => $data,
                "user_data" => json_encode($user_Data),
                "user_id" => \lib::_usere()->_get("id")
            ]);
        }
    }
     */
    // <editor-fold defaultstate="collapsed" desc="core">

    public function __construct()
    {
    }

    function sql_updated($sql)
    {
        $the_query = $sql;
        if (\lib::_console()->_is_console()) {
            \lib::_console()->_print_console_item(["type" => "db", "title" => "PDO SQL", "msg" => $sql]);
        }
    }

    function attrs($status = "")
    {
        if ($status == "user") {
            return \lib::_config()->db["username"];
        } else if ($status == "pass") {
            return \lib::_config()->db["password"];
        } else {

            $sql = 'mysql:host=' . \lib::_config()->db["host"] . ';dbname=' . \lib::_config()->db["name"];
            $this->sql_updated($sql);
            return $sql;
        }
    }

    /**
     * 
     * @param type $int [] 
     * @return type
     */
    public function _info()
    {
        $data = [];
        try {
            $db = new \PDO($this->attrs(), $this->attrs("user"), $this->attrs("pass"));
            $db->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);
            $data["PDO::ATTR_AUTOCOMMIT"] = $db->getAttribute(\PDO::ATTR_AUTOCOMMIT);
            $data["PDO::ATTR_CASE"] = $db->getAttribute(\PDO::ATTR_CASE);
            $data["PDO::ATTR_CLIENT_VERSION"] = $db->getAttribute(\PDO::ATTR_CLIENT_VERSION);
            $data["PDO::ATTR_CONNECTION_STATUS"] = $db->getAttribute(\PDO::ATTR_CONNECTION_STATUS);
            $data["PDO::ATTR_DRIVER_NAME"] = $db->getAttribute(\PDO::ATTR_DRIVER_NAME);
            $data["PDO::ATTR_ERRMODE"] = $db->getAttribute(\PDO::ATTR_ERRMODE);
            $data["PDO::ATTR_ORACLE_NULLS"] = $db->getAttribute(\PDO::ATTR_ORACLE_NULLS);
            $data["PDO::ATTR_PERSISTENT"] = $db->getAttribute(\PDO::ATTR_PERSISTENT);
            // $data["PDO::ATTR_PREFETCH"] = $db->getAttribute(\PDO::ATTR_PREFETCH);
            $data["PDO::ATTR_SERVER_INFO"] = $db->getAttribute(\PDO::ATTR_SERVER_INFO);
            $data["PDO::ATTR_SERVER_VERSION"] = $db->getAttribute(\PDO::ATTR_SERVER_VERSION);
            //       $data["PDO::ATTR_TIMEOUT"] = $db->getAttribute(\PDO::ATTR_TIMEOUT);
            $db = null;
            unset($db);
            return '<pre>' . print_R($data, true) . '</pre>';
        } catch (\Exception $exc) {
            $db = null;
            unset($db);
            \lib::_console()->fatal_error($exc->getMessage(), "database", $exc->getMessage(), $exc->getCode());
        } catch (\PDOException $exc) {
            $db = null;
            unset($db);
            \lib::_console()->fatal_error($exc->getMessage(), "database", $exc->getMessage(), $exc->getCode());
        }
    }

    private function _is_field($table_name, $field)
    {
        $fildes = $this->_get_columns($table_name);

        foreach ($fildes as $f) {
            if (($f['Field'] == $field)) {
                return true;
            }
        }
        return false;
    }

    function is_column_exists($table_name = "", $name = "")
    {

        if ($name != "" && $table_name != "") {
            $fildes = $this->_get_columns($table_name);
            return in_array($name, $fildes);
        } else {
            return false;
        }
    }



    private function filter_values($table_name, $values, &$fildes = [])
    {
        $fildes = $this->_get_columns($table_name);

        foreach ($values as $k => $v) {

            if (is_array($v)) {

                $u = "";
                $m = "";
                foreach ($v as $ka => $va) {
                    $u .= $m . $va;

                    $m = ",";
                }

                $values[$k] = $u;
            }

            $a = 0;
            foreach ($fildes as $f) {
                if (($f['Field'] == $k)) {
                    $a = 1;
                }
            }
            if ($a == 0) {


                unset($values[$k]);
            }
        }
        return $values;
    }

    var $close_statment = "con close";

    private function query($query_string)
    {
        try {
            $db = new \PDO($this->attrs(), $this->attrs("user"), $this->attrs("pass"));
            $db->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);
            $data = $db->query($query_string);
            $this->sql_updated($query_string);
            $db = null;
            unset($db);
            $this->sql_updated($this->close_statment);
            return $data;
        } catch (\PDOException $exc) {
            $db = null;
            unset($db);
            \lib::_console()->fatal_error($exc->getMessage(), "database", $query_string, $exc->getCode());
        }
    }

    private function prepare($query_string, $prepareed = null, $return_other = "")
    {


        try {

            $db = new \PDO($this->attrs(), $this->attrs("user"), $this->attrs("pass"));

            $db->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);

            $this->sql_updated($query_string);

            $q = $db->prepare($query_string);

            if (is_array($prepareed)) {
                foreach ($prepareed as $k => $v) {
                    $q->bindValue(":$k", $v);
                }
            }
            $q->execute();
            if ($return_other == "last") {
                $q = $db->lastInsertId();
            }
            $db = null;
            unset($db);
            $this->sql_updated($this->close_statment);

            return $q;
        } catch (\PDOException $exc) {
            $db = null;
            unset($db);


            $query_string .= "{" . print_R($prepareed, true) . "}";

            \lib::_console()->fatal_error($exc->getMessage(), "database", $query_string, $exc->getCode());
        }
    }

    public function _p_get_query($query_string, $prepareed = null)
    {


        try {
            $db = new \PDO($this->attrs(), $this->attrs("user"), $this->attrs("pass"));
            $db->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);
            $db->exec("SET NAMES 'utf8';");


            $q = $db->prepare($query_string);
            $this->sql_updated($query_string);
            if (is_array($prepareed)) {
                foreach ($prepareed as $k => $v) {
                    $q->bindValue(":$k", $v);
                }
            }
            $q->execute();
            if ($this->returnCount) {
                $r = $q->rowCount();
            } else {
                $r = $q->fetchAll(\PDO::FETCH_ASSOC);
            }
            $data = null;
            $q = null;
            $this->sql_updated($this->close_statment);

            return $r;
        } catch (\PDOException $exc) {
            $db = null;
            $q = null;
            unset($db);
            $query_string .= "{" . print_R($prepareed, true) . "}";

            \lib::_console()->fatal_error($exc->getMessage(), "database", $query_string, $exc->getCode());
        }



        $this->_get_deleted = false;
        $this->_get_disabled = true;
    }

    public function _get_query($query_string)
    {


        try {
            $db = new \PDO($this->attrs(), $this->attrs("user"), $this->attrs("pass"));
            $db->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);
            $q = $db->query($query_string);

            $this->sql_updated($query_string);

            if ($this->returnCount) {
                $r = $q->rowCount();
            } else {
                $r = $q->fetchAll(\PDO::FETCH_ASSOC);
            }
            $db = null;
            $q = null;
            unset($db);
            unset($q);
            $this->sql_updated($this->close_statment);

            return $r;
        } catch (\PDOException $exc) {
            $db = null;
            $q = null;
            unset($db);
            unset($q);
            \lib::_console()->fatal_error($exc->getMessage(), "database", $query_string, $exc->getCode());
        }
    }

    public function _get_deleted($bool = true)
    {
        $this->_get_deleted = $bool;
        return $this;
    }

    public function _get_disabled($bool = true)
    {
        $this->_get_disabled = $bool;
        return $this;
    }

    public function _count()
    {
        $this->returnCount = true;
        return $this;
    }

    // </editor-fold>
    // <editor-fold defaultstate="collapsed" desc="meta">




    public function _get_tables()
    {
        return $this->_get_query("SHOW TABLES");
    }

    public function _get_columns($table_name)
    {

        return $this->_get_query('SHOW COLUMNS FROM ' . $table_name);
    }

    // </editor-fold>
    // <editor-fold defaultstate="collapsed" desc="get_data">
    /*
    /**
     * 
     * @param type $rdata
     * @param type $id
     * @param type $table_name
     * @param type $field
     * @param type $return
     */
    public function get_data_uptree_2(&$rdata, $id, $table_name, $tree_field = "cat_id", $return_filed = "title", $return = "")
    {





        if ($id != 0) {


            $data = $this->_get_row($table_name, "$return_filed,$tree_field", "id=" . $id);

            if (is_array($data)) {
                if ($return == "") {
                    array_push($rdata, $data[$return_filed]);
                } else {


                    $rdata = $data[$return_filed] . " $return " . $rdata;
                }

                $this->get_data_uptree_2($rdata, $data[$tree_field], $table_name, $tree_field, $return_filed, $return);
            } else {
                if (is_array($data)) {
                    $rdata = array_filter($rdata);
                } else {

                    $rdata = substr(trim($rdata), 0, -1);
                }
            }
        }
    }

    public function get_data_uptree(&$rdata, $id, $table_name, $field = "cat_id", $return = "")
    {


        if ($id != 0) {
            array_push($rdata, $id);
            $data = $this->_get_row($table_name, "$field", "id=" . $id);
            if (is_array($data)) {
                $this->get_data_uptree($rdata, $data[$field], $table_name, $field);
            } else {
            }
        }
    }

    public function get_data_downtree(&$rdata, $id, $table_name, $field = "cat_id", $return = "")
    {


        if ($id != 0) {

            $data = $this->_get_data($table_name, "$field", "cat_id=" . $id);

            if (is_array($data[0])) {

                foreach ($data as $d) {
                    if ($return == "") {
                        array_push($rdata, $d[$field]);
                    } else {
                        $rdata .= "$return" . $d[$field];
                    }
                    $this->get_data_downtree($rdata, $d[$field], $table_name, $field);
                }
            } else {
            }
        }
    }

    public function _get_data($table_name, $cData = "*", $where = "", $prepareed = null)
    {

        $table_name = trim($table_name);

        $sql = "SELECT $cData From `$table_name` ";

        if ($where == "") {

            $where = " 1 ";
        }


        /*
          if (!$this->_get_deleted  ||  !$this->_get_disabled)  {

          $fildes = $this->_get_columns($table_name);
          }


         */

        if (!$this->_get_deleted) {


            $where = ' `sys_deleted`="0" and ' . $where;
        }


        if (!$this->_get_disabled) {

            $where = ' `sys_disabled`="0" and ' . $where;
        }



        //  $where = ' `sys_deleted`="0" and ' . $where;
        // $where = ' `sys_disabled`="0" and ' . $where;


        $sql .= ' Where ' . $where;




        return $this->_p_get_query($sql, $prepareed);
    }

    public function _get_row($table_name, $cData = "*", $where = "", $prepareed = null)
    {

        $r = FALSE;
        if ($data = $this->_get_data($table_name, $cData, $where, $prepareed)[0]) {


            return $data;
        }
        return $r;
    }

    public function _get_max_id($table_name, $where = "", $prepareed = null)
    {
        $r = FALSE;
        if ($data = $this->_get_data($table_name, "max(`id`) as 'lid'", $where, $prepareed)[0]["lid"]) {
            return $data;
        }
        return $r;
    }

    public function _get_custom_row($table_name, $c, $fild, $where = "", $prepareed = null)
    {

        $r = FALSE;

        if ($where != "") {

            $where .= " and ";
        }

        if ($data = $this->_get_data($table_name, "id,$fild", "$fild=(SELECT $c($fild) FROM  $table_name where  $where   `sys_disabled`=\"0\" and `sys_deleted`=\"0\" )", $prepareed)[0]) {



            $datas = $this->_get_data($table_name, "*", "id=:myid", ["myid" => $data["id"]])[0];


            return $datas;
        }
        return $r;
    }


    function update_history($action = "update", $table_name, $data, $where = "", $wherep = [])
    {

        $fildes = [];
        $data = $this->filter_values($table_name, $data, $fildes);
        $add_history = false;
        foreach ($fildes as $f) {
            if ($f['Field'] == "sys_history") {
                $add_history = true;
                break;
            }
        }
        if ($add_history) {
            $history = [];
            $new_data  = $data;

            if ($where  != "") {
                $old_data  = \lib::_db()->_get_row($table_name, "*", $where, $wherep);
            }


            if ($old_data["sys_history"] != "") {
                $history  = json_decode($old_data["sys_history"], true);
            }
            $new_history["date"]  = \lib::_data()->_datetime->_craeteDBDateTime();
            $new_history["action"] = $action;

            if (!isset($_SESSION["sys_users_login_data"])) {
                $new_history["user_id"] = "0";
            } else {
                $new_history["user_id"] = \lib::_usere()->_get("id");
            }

            $a_old_data = [];
            if ($action == "update") {

                foreach ($new_data as $k => $v) {
                    if ($old_data[$k] == $new_data[$k]) {
                        unset($new_data[$k]);
                    } else {
                        $a_old_data[$k] = $old_data[$k];
                    }
                }
            }
            $new_history["old_data"] = $a_old_data;
            $new_history["new_data"] = $new_data;
            if (count($new_data) > 0) {
                $history[] = $new_history;
            }
            $data["sys_history"] = json_encode($history);
        }
        return $data;
    }
    // </editor-fold>
    // <editor-fold defaultstate="collapsed" desc="Operation">

    public function _insert($table_name, $data)
    {
        $SERVER = [];
        $SERVER["HTTP_USER_AGENT"] = $_SERVER["HTTP_USER_AGENT"];
        $SERVER["REMOTE_ADDR"] = $_SERVER["REMOTE_ADDR"];
        $SERVER["HTTP_COOKIE"] = $_SERVER["HTTP_COOKIE"];
        $SERVER["TIME"] = \lib::_data()->_datetime->_craeteDBDateTime();

        $data["sys_site"] = \lib::_eng()->_site_setting["id"];

        $data["sys_user_id"] = \lib::_usere()->_get("id");
        $data["sys_status"] = json_encode(\lib::_eng()->get_status_field());
        $data["sys_userinfo"] = json_encode($SERVER, true);

        $data["sys_created"] = \lib::_data()->_datetime->_craeteDBDateTime();
        $data = $this->filter_values($table_name, $data);

        $fs = "";
        $vs = "";
        $m = "";

        $data =  $this->update_history("insert", $table_name, $data);

        foreach ($data as $k => $v) {

            $fs .= $m . " `$k` ";
            $vs .= $m . " :$k ";

            $m = " , ";
        }

        if ($rdata = $this->prepare("INSERT INTO $table_name ($fs) VALUES ($vs)", $data, "last")) {
            return $rdata;
        } else {

            return false;
        }
    }





    /**
     * 
     * @param type $table_name
     * @param type $data
     * @param type $where
     * @param type $wherep
     * @param type $history
     * 
     * @return boolean
     */
    public function _update($table_name, $data, $where, $wherep = null, $history = true)
    {

        $data["sys_status"] = json_encode(\lib::_eng()->get_status_field());
        $data = $this->update_history("update", $table_name, $data,  $where, $wherep);
        $data["sys_modified"] = \lib::_data()->_datetime->_craeteDBDateTime();

        $sql_String = "UPDATE  $table_name SET";
        $m = "";
        foreach ($data as $k => $v) {
            $sql_String .= $m . " `$k`=:$k ";
            $m = " , ";
        }
        if (is_array($wherep)) {
            $data = array_merge($data, $wherep);
        }
        $dosql = $sql_String . "  WHERE " . $where;
        try {

            if ($rdata = $this->prepare($dosql, $data)) {
                return $rdata->rowCount();
            } else {
                return false;
            }
        } catch (\Exception $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    public function _delete($table_name, $where, $data = null)
    {
        $sql_String = "Delete From  $table_name " . "  WHERE " . $where;
        if ($data = $this->prepare($sql_String, $data)) {
            return $data;
        } else {
            return false;
        }
    }

    public function _sys_delete($table_name, $where, $adata = null)
    {

        if ($this->_is_field($table_name, "sys_deleted")) {



            $data  = ["sys_deleted" => "1"];


            $data =  $this->update_history("deleted", $table_name, $data, $where, $data);
            if (is_array($adata)) {
                $data = array_merge($data, $adata);
            }

            if ($rdata = $this->_update($table_name, $data, $where, $data, false)) {

                return $rdata;
            } else {

                return false;
            }
        }
    }

    public function _sys_delete_res($table_name, $where, $data = null)
    {

        if ($this->_is_field($table_name, "sys_deleted")) {

            $data  = ["sys_deleted" => "0"];
            $data =  $this->update_history("deleted_reset", $table_name, $data, $where, $data);

            if ($rdata = $this->_update($table_name, $data, $where, $data)) {
                return $rdata;
            } else {

                return false;
            }
        }
    }

    public function _sys_disable($table_name, $where, $data = null)
    {
        if ($this->_is_field($table_name, "sys_disabled")) {

            if ($data = $this->_update($table_name, ["sys_disabled" => "1"], $where, $data)) {
                return $data;
            } else {

                return false;
            }
        }
    }

    public function _sys_enabled($table_name, $where, $data = null)
    {
        if ($this->_is_field($table_name, "sys_disabled")) {
            if ($data = $this->_update($table_name, ["sys_disabled" => "0"], $where, $data)) {
                return $data;
            } else {

                return false;
            }
        }
    }

    public function _copy($table_name, $id = "", $chn_data = null)
    {
        $data = $this->_get_disabled()->_get_row($table_name, "*", "id=:myid", ["myid" => $id]);
        unset($data["id"]);
        if (is_array($chn_data)) {
            $data = array_merge($data, $chn_data);
        }



        return $this->_insert($table_name, $data);
    }

    // </editor-fold>





    public function _test()
    {

        if ($data = $this->_delete("sys_app_settings", "`id`>:myid", ["myid" => "2"])) {
            print($data);
        } else {
            // $this->the_query;
        }
    }
}
