<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of EngClass
 *
 * @author ismail
 */

namespace ins_lib\eng;

class EngClass extends \ins_lib\eng\siteClass
{

    function __construct()
    {

        parent::__construct();
    }

    /*
      public function _admin($bool = true) {

      $this->admin = $bool;
      return $this;
      } */

    /**
     * 
     * @staticvar type $_eng
     * @return \ins_lib\eng\ISDClass
     */
    public static function _isd()
    {
        static $_r = null;
        if ($_r === null) {
            $_r = new \ins_lib\eng\ISDClass();
        }

        return $_r;
    }

    public function redirect($url)
    {
        echo "<meta http-equiv=\"refresh\" content=\"0; url=$url\">";
        die();
    }

    public function reload()
    {
        echo "<meta http-equiv=\"refresh\" content=\"0\">";
        die();
    }

    /**
     * 
     * @param type $typ[com,mod,plg] def:com
     * @param type $lng ex:[ar ,en] 
     * 
     * 
     */
    public function _get_lang_xml($for, $lng = "",$area="")
    {


        $lng = ($lng != "" ? $lng : $this->_this_lang);
        $lng = ($lng != "" ? $lng : "en");

        $path = "";


        $path .= \lib::_data()->_get_area($area);




        $path .= \lib::_files()->_getPath($for) . $for . "/" . $lng . ".xml";



        if (\lib::_files()->_file_exist($path)) {

            return \lib::_files()->loadfile($path, "", "array")->out;
        }
    }

    public function _get_lang_xml_full_path($for, $lng = "")
    {
        $lng = ($lng != "" ? $lng : $this->_this_lang);

        $path = "";




        $path .= $for . "/" . $lng . ".xml";


        if (\lib::_files()->_file_exist($path)) {

            return \lib::_files()->loadfile($path, "", "array")->out;
        }
    }

    public function _get_gen_word($name, $file = "general", $lng = "")
    {
        $lng = ($lng != "" ?$lng: $this->_this_lang );

        $v = \lib::_files()->loadfile(\lib::_app_map()->language_folder . "/" . $lng . "/$file.xml", "", "array")->out[$name];


        if ($v == "") {
            $v = $name;
        }
        return $v;
    }

    var $typ = "";

    public function _get_properties_xml($for, $proName = "", $tag = "properties", $area = "")
    {
        $path = "";

        $path .= "/" . \lib::_data()->_get_area($area);
        $proName = ($proName != "" ? $proName . ".xml" : \lib::_options()->properties_file_name . ".xml");
        $path .= \lib::_files()->_getPath($for) . $for . "/" . $proName;

        $path = str_replace("///", "/", $path);
        $path = str_replace("//", "/", $path);


        if (\lib::_files()->_file_exist($path)) {


            return \lib::_files()->loadfile($path, "properties")->out;
        }
    }

    public function _get_properties_DB($obj_type, $obj_id)
    {



        return \lib::_data()->_get_properties_DB($obj_type, $obj_id);
    }

    public function _set_properties_DB($obj_type, $obj_id, $data)
    {
        /*  /* \lib::_db()->_delete("sys_properies", " obj_id=:obj_id  and obj_type=:obj_type  ", ["obj_type" => $obj_type, "obj_id" => $obj_id]);
         */
        /*
          $data = \lib::_db()->_insert("sys_properies", [
          "obj_type" => $obj_type,
          "obj_id" => $obj_id,
          "obj_data" => \lib::_data()->_arrayToDB($data)
          ]);
          $_POST["sys_properties"]  \lib::_data()->_arrayToDB($data)
          // ]);

          return $data; */
    }

    public function _insert_Layout($obj_type, $title, $data, $default = "0")
    {
        $data = \lib::_db()->_insert("sys_layout", [
            "obj_type" => $obj_type,
            "default" => $default,
            "title" => $title,
            "data" => json_encode($data),
            "user_id" => $_SESSION["sys_users_login"],
        ]);

        return $data;
    }

    public function _update_Layout($id, $data)
    {

        $data = \lib::_db()->_update("sys_layout", [
            "data" => json_encode($data),
        ], "id='" . $id . "'");
        return $data;
    }

    public function _get_Layout($obj_type = "", $id = "", $default = false)
    {
        $w = "";
        if ($id != "") {
            $w = "id='$id'";
        } else {
            $w = " obj_type='$obj_type' and user_id='" . $_SESSION["sys_users_login"] . "'";
            if ($default) {
                $w .= " and  `default`='1' ";
            }
        }

        $data = \lib::_db()->_get_row("sys_layout", "*", $w);


        if ($default) {

            if (!is_array($data)) {
                $w = " obj_type='$obj_type' and user_id='" . $_SESSION["sys_users_login"] . "'";
                $data = \lib::_db()->_get_row("sys_layout", "*", $w);
                if (is_array($data)) {
                    $this->_update_Layout($data["obj_type"], $data["data"], $data["id"], "1");
                }
            }
        }


        if (is_array($data)) {
            $_SESSION["layout_id"] = $data["id"];

            return json_decode($data["data"], true);
        } else {
            return false;
        }
    }

    public function _get_plgin($name, $data = [], $area = "")
    {


        $main = $this->_getThisMenu["type"];
        $plgPath = "";

        $plgPath .= \lib::_data()->_get_area($area);
        $plgPath .= \lib::_app_map()->plgs_folder;
        $plgPath .= $name;
        $plgPath = str_replace("//", "/", $plgPath);



        \lib::_template()->_add_to_headr(\lib::_files()->_include_pkg_files($plgPath));

        $data["plg_name"] = $name;
        $data["plg_area"] = $area;
        $data["plg_path"] = $plgPath;

        if (class_exists($name)) {

            return (new $name($data))->_out();
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", " $name No exist in $plgPath  " . __CLASS__ . "/" . __FUNCTION__, "001");
        }
    }

    public function _getThisCom($options = null)
    {
        if (\lib::_usere()->_permission_chk()) {

            $g = $this->_get();

            if (isset($g["ins_create_admin"])) {
                $g["name"] = $g["ins_create_admin"];

                $g["_per_cancel"] = true;

                return \lib::_ui()->_data(["admin" => $g])->_render();
            } else {
                if ($g["alias"] == "ajax") {
                    $this->_getThisMenu["type"] = "sys_ajax";
                }
                if ($options != null) {
                    $this->_getThisMenu = $options;
                }


                $main = $this->_getThisMenu["type"];
         $comPath = "";
                $comPath .= \lib::_data()->_get_area($this->_getThisMenu["sys_area"]);
                $comPath .= \lib::_app_map()->coms_folder;
                $comPath .= $this->_getThisMenu["type"];
                $comPath = str_replace("//", "/", $comPath);
                \lib::_files()->_include_pkg_files($comPath);
                $mains = explode("/", $main);
              $main = end($mains);



                if (class_exists($main)) {
               return (new $main())->_out();
                } else {
                    \lib::_console()->fatal_error("Class Not found", "libs", " $main No exist in $comPath  EngClass/_getThisCom", "001");
                }
            }
        } else {
            return \lib::_ui()->_data(
                [
                    ["type" => "div", "class" => "message error ", "data" => $this->_get_gen_word("permission_msg_error")]
                ]
            )->_render();
        }
    }

    public function _getTemplate()
    {
        if (\lib::_eng()->_site_setting["template"] == "" || $_GET["area"] == "ins_admin") {
            return \lib::_db()->_get_row("sys_templates", "*", "`default`=1 and sys_area='" . \lib::_data()->_this_area("url") . "'");
        } else {


            return ["type" => \lib::_eng()->_site_setting["template"]];
        }
    }

    public function _getModels_bytype($type, $options)
    {
        $mod = $type;
        $modPath = \lib::_data()->_get_area();
        $modPath .= \lib::_app_map()->mods_folder;
        $modPath .= $mod;





        \lib::_template()->_add_to_headr(\lib::_files()->_include_pkg_files($modPath));


        if (class_exists($mod)) {



            $m["_pro"] = $options;

            $mp = new $mod($m);

            $m["mod_body"] = $mp->_out();
            if ($options["style"] != "") {

                $styledir = \lib::_data()->_get_area() . "/"
                    . \lib::_app_map()->template_folder
                    . $this->_getTemplate()["type"] . "/" . \lib::_app_map()->template_styles_folder;

                $styledir .= $options["style"];
                \lib::_files()->_include_Php_file($styledir);




                $r = (new $options["style"]($m))->_out();
            } else {
                $r = $m["mod_body"];
            }
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", " $mod No exist in $modPath  \n In  " . __CLASS__ . "/" . __FUNCTION__ . "", "001");
        }



        return $r;
    }

    public function _getModels($postion)
    {


        $wdata = ["for_area" => \lib::$_area["url"], "view_all" => "1"];

        if (is_array($postion)) {
            $w = "(";
            $sp = "";
            foreach ($postion as $k => $v) {

                $wdata["$k"] = $k;
                $w .= $sp . 'position=:' . $k . " ";
                $sp = " OR ";
            }
            $w .= ")";
            $r = "";
        } else {
            $wdata["position"] = $postion;
            $w = 'position=:position';
            $r = [];
        }
        /*
          $wdata["for_area"] = \lib::$_area["url"];
          $wdata["view_all"] = "1"; */

        $o = \lib::_data()->_db_get_form_group($this->_getThisMenu['alias'], "view_menus");




        $w .= ' and  ( view_all=:view_all or ' . $o . ' ) and for_area=:for_area';



        $w .= ' order by `sys_order`';

        $ms = \lib::_db()->_get_data("sys_modules", "*", $w, $wdata);


        if (is_array($postion)) {
            $r = [];
        } else {

            $r = "";
        }

        foreach ($ms as $m) {


            if (\lib::_eng()->is_in_status("sys_modules", $m["id"])) {


                \lib::_data()->_update_data_language("sys_modules", $m);



                $mod = $m["type"];
                $modPath = \lib::_data()->_get_area($m["sys_area"]);
                $modPath .= \lib::_app_map()->mods_folder;
                $modPath .= $mod;


                \lib::_template()->_add_to_headr(\lib::_files()->_include_pkg_files($modPath));


                if (class_exists($mod) && trim($m["style"]) != "0") {

                    $m["mod_body"] = (new $mod($m))->_out();
                    $m["main_style"] = $m["style"];
                    $this->get_module_style($r, $m, $postion);
                }
            }
        }
        return $r;
    }

    private function get_module_style(&$r, $m, $postion)
    {
        $styledir = \lib::_data()->_get_area() . "/"
            . \lib::_app_map()->template_folder
            . $this->_getTemplate()["type"] . "/" . \lib::_app_map()->template_styles_folder;
        $styledir .= $m["style"];
        \lib::_files()->_try_include_Php_file($styledir);

        if (class_exists($m["style"])) {
            if (is_array($postion)) {
                $r[$m["position"]] .= (new $m["style"]($m))->_out();
            } else {
                $r .= (new $m["style"]($m))->_out();
            }
        } else if (!class_exists($m["style"]) && $m["style"] == "ins_module_style") {

            \lib::_console()->fatal_error("Class Not found", "libs", $m["style"] . " Class No exist in $modPath  \n In  " . __CLASS__ . "/" . __FUNCTION__ . "", "001");
        } else {

            $m["style"] = "ins_module_style";
            $this->get_module_style($r, $m, $postion);
        }
    }

    public function _get_alias_form_type($type)
    {

        $pw = "";
        $psp = "";

        $area = \lib::_data()->_this_area("url");

        $mpkgs = \lib::_db()->_get_data("sys_modules", "*", "for_area='$area' and type='mod_menu'");

        foreach ($mpkgs as $m) {
            $daaata = \lib::_data()->_arrayFromDB($m["sys_properties"]);




            $pw .= " $psp cat_id='" . $daaata["menu"] . "' ";
            $psp = " or ";
        }
        $mm = \lib::_db()->_get_row("sys_menus_items", "*", "`type`='$type' and ( $pw) ");


        return $mm["alias"];
    }

    /**
     * 
     * @param type $add
     * @param type $remove
     * @param type $home
     * @return type
     */
    public function _url($add = [], $remove = [], $home = false)
    {

        $myarray = [];
        $g = $this->_get();


        if (is_array($add)) {

            $myarray = $add + $g;
        } else {
            $myarray = $g;
        }



        $r = "/";

        if ($home || $add == "clear") {
            $def_data = ["area", "site", "alias"];
        } else {
            $def_data = ["area", "site", "alias", "mode", "id"];
        }




        foreach ($def_data as $value) {
            if (isset($myarray[$value]) && $myarray[$value] != "" && $myarray[$value] != "do" && !in_array($value, $remove)) {

                if ($value == "site") {
                    $r .= "site/";
                }
                $r .= $myarray[$value] . "/";
                unset($myarray[$value]);
            }
        }

        foreach ($remove as $m) {
            unset($myarray[$m]);
        }
        // unset($myarray["get_tmp_index"]);


        if (!$home && $add != "clear" && count($myarray) > 0) {

            $r .= "do/";

            foreach ($myarray as $k => $v) {
                if ($v != "") {
                    if (!in_array($k, $remove) && $myarray[$value] != "do") {
                        $r .= "$k/$v/";
                    }
                }
            }
        }


        $r = \lib::_data()->_url_clrea($r);

        return $r;
    }

    public function _get()
    {
        $data = $_GET;
        if (isset($data["do"])) {
            $vars = explode("/", $data["do"]);
            foreach ($vars as $key => $value) {
                if ($key % 2 == 0) {
                } else {
                    $data[$vars[$key - 1]] = $vars[$key];
                }
            }
        }


        unset($data["do"]);
        return $data;
    }
}
