<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of xml
 *
 * @author ismail
 */
namespace ins_lib\files;
class file_xml implements \ins_lib\files\loader {

    var $type = '';

    public function _load($file, $tag = "", $type = "") {

        $data = false;

        $this->type = $type;
        switch ($type) {

            case "array":
                $data = $this->arrayLoad($file, $tag);
                break;
            case "roots":
                $data = $this->rootsLoad($file, $tag);
                break;
            default:
                $data = $this->fullLoad($file, $tag);
                break;
        }

        return $data;
    }


    private function loadfile($file) {

        $xml = false;
        





        
         
        if (file_exists(dirname(dirname(__DIR__)) ."/". $file)) {
            $fullPath = \lib::_config()->site["url"] . $file;
            
        
            $xml = simplexml_load_file($fullPath);
            
            if (!$xml) {
                $fullPath = $_SERVER['DOCUMENT_ROOT']."/" . $file;
                $xml = simplexml_load_file($fullPath);



            }
            
       
        }



        
        return $xml;
    }

    private function fullLoad($file, $gettag = "") {



        $r = [];
        if ($gettag == "") {
            $r = $this->attrsLoad($file, $gettag);
        } else {

            $roots = $this->rootsLoad($file);
            foreach ($roots as $root) {
                $r[$root] = $this->attrsLoad($file, $root);
            }
        }
        /*  if ($xml = $this->loadfile($file)) {
          $r = $this->o_to_array($xml, $gettag, $sub);
          } */
        return $r;
    }

    private function attrsLoad($file, $gettag = "") {
        $data = false;




        if ($xml = $this->loadfile($file)) {


            $data = $this->o_to_array($xml, $gettag);
        } else {
            \lib::_console()->fatal_error("loading file error ", "files", $file, "002");
        }
        return $data;
    }

    function o_to_array($xml, $gettag) {

        foreach ($xml->children() as $key0 => $value) {



            foreach ($value->attributes() as $attributeskey0 => $attributesvalue1) {
                if (is_array($data[$key0])) {
                    $data[$key0] = array_merge($data[$key0], array($attributeskey0 => (string) $attributesvalue1));
                } else {
                    $data[$key0] = array($attributeskey0 => (string) $attributesvalue1);
                }
            }
            $v = trim((string) $value);
            if ($v == "") {
                if ($this->type == "values") {

                    $data[$key0] = $this->o_to_array($value, "");
                } else {
                    $data[$key0]["data_value"] = $this->o_to_array($value, "");
                }
            } else if ($v != "") {

                if ($this->type == "values") {

                    $data[$key0] = $v;
                } else {
                    $data[$key0]["data_value"] = $this->type . $v;
                }
            }
        }
        if ($gettag != "") {

            $data = $data[$gettag]["data_value"];
        }


        return $data;
    }

    private function arrayLoad($file, $tag = "") {
        $data = false;

        if ($xml = $this->loadfile($file)) {
            foreach ($xml->children() as $key0 => $value) {
                
                $data[$key0] = (string) $value;
            }
        } else {
            \lib::_console()->fatal_error("loading file error", "files", $file, "002");
        }
        return $data;
    }

    
    
        private function arrayLoad_s($file, $tag = "") {
        $data = false;

        if ($xml = $this->loadfile($file)) {
            foreach ($xml->children() as $key0 => $value) {
                
                $data[][$key0] = (string) $value;
            }
        } else {
            \lib::_console()->fatal_error("loading file error", "files", $file, "002");
        }
        return $data;
    }
    
    private function rootsLoad($file, $tag = "") {
        $data = [];
        
 


        if ($xml = $this->loadfile($file)) {
            foreach ($xml as $key0 => $value) {
                array_push($data, (string) $key0);
            }
        } else {
            \lib::_console()->fatal_error("loading file error", "files", $file, "002");
        }



    

        return $data;
    }

}
