/* global html2canvas */

function InsMap(o) {
    this.o = o;
}

InsMap.prototype._get_page_data = function() {
    return JSON.parse(ins(".ins_main")._getdata("data"));
};

InsMap.prototype._get = function() {
    var j = JSON.parse(ins(".ins_main")._getdata("data"));

    return j["get"];
};

function InsDB(o) {
    this.o = o;
}

/**
 app
  */
function App(o) {
    this.o = o;
}

function ajax_list_multi_update(mode, e) {
    var ids = "";
    var table = e._getdata("type");
}
/**
 *
 * @param {mode,table,ondeon:fun()} options
 */
App.prototype._list_multi_update = function(options) {
    var m = "";
    var ids = "";
    ins(".check_list_ids:checked")._each(function(e) {
        ids += m + e._getvalue();
        m = ",";
    });

    if (ids == "") {
        alert("no items chosen");
    } else {
        var send_options = options;
        if (ins(send_options.ondone)._is_exists()) {
            //delete send_options.ondone;
        }
        send_options.get_file = "pages/list";
        send_options.ids = ids;
        return ins()._ajax._send(
            "/ins_ajax.php",
            send_options,
            "POST",
            function(data) {
                if (ins(options.ondone)._is_exists()) {
                    options.ondone(data);
                }
            }
        );
    }
};

App.prototype._ajax = function(ajoptions) {
    var t = this;
    if (ins(this.o)._is_exists()) {
        my_class = this.o;
    }
    app_cont = "." + this.o;

    function update_content(options) {
        ins(app_cont)._ui._addloader();

        options = ins()._data._json_join(options, ins(app_cont)._getdata());

        ins(my_class)._ajax._class(options, function(data) {
            ins(app_cont)._sethtml(data);

            if (ins(ajoptions.onupdate)._is_exists()) {
                ajoptions.onupdate();
            }
            ins()._ui._removeloader();
            ins()._ui._update_ui();
        });
    }

    ins(app_cont + " .list_limit_option")._on("change", function(o) {
        ins()._data._set_session(o._getdata("jsname"), o._getvalue(), function() {
            update_content({});
        });
    });

    ins(app_cont + " .filter_item")._on("change", function(o) {
        var op = {};
        var f = "";
        var v = "";

        ins(app_cont + " .filter_item")._each(function(o) {
            if (o._getvalue() != "") {
                f += o._getattr("name") + ",";
                v += o._getvalue() + ",";
            }
        });

        update_content({ filter: f + ";" + v });
    });

    ins(app_cont + " .ins_pages_select")._on("change", function(o) {
        var options = o._getdata();
        options.page = o._getvalue();
        update_content(options);
    });

    ins(app_cont + " .refresh")._on(
        "click",
        function(o) {
            update_content({});
        },
        true
    );

    ins(app_cont + " .ajax_list_multi_update")._on(
        "click",
        function(e, ev) {
            ev.preventDefault();

            var mode = e._getdata("mode");
            if (ins(mode)._is_empty()) {
                mode = e._getparent()._getdata("mode");
            }
            if (!ins(e._getdata("jsconfirm"))._is_empty()) {
                if (confirm(e._getdata("jsconfirm"))) {
                    t._list_multi_update({
                        ondone: function() {
                            update_content({});
                        },
                        mode: e._getdata("mode"),
                        table: e._getdata("type"),
                    });
                }
            } else {
                t._list_multi_update({
                    ondone: function() {
                        update_content({});
                    },
                    mode: e._getdata("mode"),
                    table: e._getdata("type"),
                });
            }
        },
        true
    );

    ins(app_cont + " form")._on(
        "submit",
        function(e, ev) {
            ev.preventDefault();

            var data = e._data._get_inputs();
            data.mode = data.form_mode;
            if ((data.mode = "edit")) {
                data.id = data.form_id;
            }

            if (!data.error) {
                update_content(data);
            } else {
                data.error_inputs.forEach(function(a) {
                    ins(a)._addclass("ins_input_error");
                    a.focus();
                });
            }
        },
        true
    );

    ins(app_cont + " .list_delet_item")._on(
        "click",
        function(e, ev) {
            ev.preventDefault();

            if (!ins(e._getdata("jsconfirm"))._is_empty()) {
                if (confirm(e._getdata("jsconfirm"))) {
                    var send_options = {};
                    send_options.mode = "delete";
                    send_options.get_file = "pages/list";
                    send_options.ids = e._getdata("ids");
                    send_options.table = ins(
                        app_cont + " .ajax_list_multi_update"
                    )._getdata("type");

                    return ins()._ajax._send(
                        "/ins_ajax.php",
                        send_options,
                        "POST",
                        function(data) {
                            var options = ins(app_cont + " .ins_pages_select")._getdata();
                            options.page = ins(app_cont + " .ins_pages_select")._getvalue();
                            update_content(options);
                        }
                    );
                }
            }
        },
        true
    );

    ins(app_cont + " a")._on(
        "click",
        function(e, ev) {
            ev.preventDefault();
            var h = {};
            if (ins(e._getdata("u"))._is_exists()) {
                var h = JSON.parse(e._getdata("u"));
            }
            update_content(h);
        },
        true
    );
    update_content({});
    ins(function() {
        alert("onload");
        update_content({});
    })._load();
};

//<editor-fold defaultstate="collapsed" desc="UI">

function Charts(o) {
    this.o = o;
}
Charts.prototype._pie = function(options) {
    options["hole"] = options["hole"] ? options["hole"] : 0;
    options["title"] = options["title"] ? options["title"] : "";
    options["3d"] = options["3d"] ? options["3d"] : false;

    var o = this.o;
    if (typeof o != "object") {
        o = document.querySelector(o);
    }

    ins("https://www.gstatic.com/charts/loader.js")._onload(function() {
        google.charts.load("current", { packages: ["corechart"] });
        google.charts.setOnLoadCallback(drawChart);

        function drawChart() {
            var data = google.visualization.arrayToDataTable(options["data"]);

            var s = {
                title: options["title"],
                pieHole: options["hole"],
                is3D: options["3d"],
            };

            if (ins(options["colors"])._is_exists()) {
                s.colors = options["colors"];
            }

            var chart = new google.visualization.PieChart(o);
            chart.draw(data, s);
        }
    });
};
/**
  * 
  * @param {title,sub_title,bars:horizontal} options 
  *options.data= [
           ['Year', 'Sales', 'Expenses', 'Profit'],
           ['2014', 1000, 400, 200],
           ['2015', 1170, 460, 250],
           ['2016', 660, 1120, 300],
           ['2017', 1030, 540, 350]
         ]
  */
Charts.prototype._bar = function(options) {
    options["title"] = options["title"] ? options["title"] : "";
    options["sub_title"] = options["sub_title"] ? options["sub_title"] : "";
    options["bars"] = options["bars"] ? options["bars"] : "horizontal";
    var o = this.o;
    if (typeof o != "object") {
        o = document.querySelector(o);
    }

    ins("https://www.gstatic.com/charts/loader.js")._onload(function() {
        google.charts.load("current", { packages: ["bar"] });
        google.charts.setOnLoadCallback(drawChart);

        function drawChart() {
            var data = google.visualization.arrayToDataTable(options["data"]);
            var s = {
                chart: {
                    title: options["title"],
                    subtitle: options["sub_title"],
                },
                bars: options["bars"], // Required for Material Bar Charts.
            };

            var chart = new google.charts.Bar(o);
            chart.draw(data, google.charts.Bar.convertOptions(s));
        }
    });
};

/**
  * 
  * @param {title,legend,colors,data} options 
  * data: ['Series Name 1', 'Series Name 2', 'Series Name 3'],
     [1, 2, 3],
  */
Charts.prototype._histogram = function(options) {
    options["title"] = options["title"] ? options["title"] : "";
    options["legend"] = options["legend"] ?
        options["legend"] : { position: "none" };
    options["colors"] = options["colors"] ? options["colors"] : "";

    var o = this.o;
    if (typeof o != "object") {
        o = document.querySelector(o);
    }
    ins("https://www.gstatic.com/charts/loader.js")._onload(function() {
        google.charts.load("current", { packages: ["corechart"] });

        google.charts.setOnLoadCallback(drawChart);

        function drawChart() {
            var data = google.visualization.arrayToDataTable(options["data"]);
            var s = {
                title: options["title"],
            };

            if (options["colors"] != "") {
                s.colors = options["colors"];
            }

            var chart = new google.visualization.Histogram(o);
            chart.draw(data, s);
        }
    });
};

function UI(o) {
    this.o = o;
}
var updated = [];

function updateui(m, t) {
    switch (t) {
        case "ins_lightbox":
        case "lightbox":
            m._event(
                "click",
                function(e) {
                    var option = e._getdata();
                    if (!ins(e._getdata("title"))._is_empty())
                        option.title = e._getdata("title");
                    if (!ins(e._getdata("url"))._is_empty())
                        option.url = e._getdata("url");
                    if (!ins(e._getdata("style"))._is_empty())
                        option.style = e._getdata("style");
                    if (!ins(e._getdata("class"))._is_empty())
                        option.class = e._getdata("class");
                    if (!ins(e._getdata("data"))._is_empty())
                        option.title = e._getdata("data");
                    if (!ins(e._getdata("onclose"))._is_empty())
                        option.onclose = function() {
                            window[e._getdata("onclose")](e);
                        };
                    if (!ins(e._getdata("onopen"))._is_empty())
                        option.onopen = function() {
                            window[e._getdata("onopen")](e);
                        };

                    console.log(option);
                    ins("ins_plg_lightbox")._plgin(option, function(cls) {});
                },
                true
            );
            break;

        case "ins_clear":
            m._event("click", function(e) {
                if (!ins(m._getdata("input"))._is_empty()) {
                    ins(m._getdata("input"))._setvalue("");
                }

                if (!ins(m._getdata("img"))._is_empty()) {
                    ins(m._getdata("img"))._setattr("src", "");
                }
            });
            break;

        case "fill_select":
            m._event("click", function(e) {
                var option = m._getdata();

                if (!ins(e._getdata("onfill"))._is_empty())
                    option.onfill = function() {
                        window[e._getdata("onfill")](e, ins(e._getdata("to")));
                    };
                ins()._ui._fill_select(option);
            });
            break;

        case "ui_create_pdf":
            m._event("click", function(o) {
                ins()._ui._ui_create_pdf(o);
            });
            break;

        case "ui_create_image":
            m._event("click", function(o) {
                ins()._ui._ui_create_image(o);
            });

            break;

        case "doprint":
            m._event("click", function(o, e) {
                window.print();
            });
            break;

        case "print_area":
            function printImage(image) {
                var printWindow = window.open(
                    "",
                    "Print Window",
                    "height=600,width=900"
                );

                if (printWindow) {
                    printWindow.document.write("<html><head><title>Print Window</title>");
                    printWindow.document.write("</head><body ><img src='");
                    printWindow.document.write(image);
                    printWindow.document.write("' /></body></html>");
                    printWindow.focus();

                    setTimeout(function() {
                        printWindow.print();
                        printWindow.close();
                    }, 500);
                }
            }

            m._on("click", function(o, e) {
                ins()._ui._create_image({
                    area: o._getdata("area"),
                    callback: function(data) {
                        var data = JSON.parse(data);
                        printImage(data["url"]);
                    },
                });
            });

            break;

        case "chart":
            var options = JSON.parse(m._getdata("options"));
            if (m._getdata("chart") == "bar") {
                m._charts._bar(options);
            } else {
                m._charts._pie(options);
            }

            break;

        case "ins_tooltip":
            var tootip = null;
            m._event("mouseover", function(o, e) {
                var data = [];

                if (!ins(o._getdata("text"))._is_empty()) {
                    data.push({
                        name: "div",
                        child: o._getdata("html"),
                        event: [],
                        attrs: {},
                    });
                } else if (!ins(o._getdata("title"))._is_empty()) {
                    data.push({
                        name: "div",
                        child: o._getdata("title"),
                        event: [],
                        attrs: {},
                    });
                } else if (!ins(o._gethtml())._is_empty()) {
                    data.push({ name: "div", data: o._gethtml(), event: [], attrs: {} });
                }

                if (!ins(o._getdata("img"))._is_empty()) {
                    data.push({
                        name: "img",
                        data: t,
                        event: [],
                        attrs: { src: o._getdata("img") },
                    });
                }

                ins(".ins_added_tooltip")._remove();

                tootip = ins()._ui._get(data, "div", {
                    class: "ins_tooltip ins_added_tooltip ins_menu",
                });

                ins(tootip)._css({
                    top: e.clientY - (tootip.offsetHeight + 10) + "px",
                    left: e.clientX - (tootip.offsetWidth / 2 + 50) + "px",
                });
                ins("body")._append(tootip);
            });

            m._event("mouseout", function(o, e) {
                if (ins(tootip)._is_exists()) {
                    ins(tootip)._remove();
                }
            });

            m._event("mousemove", function(o, e) {
                ins(tootip)._css({
                    top: e.clientY - (tootip.offsetHeight + 20) + "px",
                    left: e.clientX - (tootip.offsetWidth / 2 + 20) + "px",
                });
            });

            break;

        case "clear_connect":
            m._event("input", function(e) {
                var a = e._getvalue();
                a = a.replace(/\s+|-|\'|\"/g, "_");
                ins("." + e._getdata("jsto"))._setvalue(a);
            });
            break;
        case "ins_data_update":
            var do_ins_udate = (e) => {
                var op = {
                    get_file: "db/update",
                    table: e._getdata("type"),
                    id: e._getdata("id"),
                    field: e._getdata("name"),
                    value: e._getvalue(),
                };

                i = 0;
                if (loader_Interval != null) {
                    clearInterval(loader_Interval);
                    loader_Interval = null;
                }
                var loader_Interval = setInterval(function() {
                    i++;
                    if (i == 100) {
                        i = 0;
                    }
                    ins(".ins_data_loader")._css({ width: +i + "%" });
                }, 10);

                ins()._ajax._send("/ins_ajax.php", op, null, function() {
                    ins(".ins_data_loader")._css({ width: "0" });

                    if (ins(loader_Interval)._is_exists()) {
                        clearInterval(loader_Interval);
                        loader_Interval = null;
                    }
                    ins()._ui._send_tiny_message();
                });
            };

            if (m._p("tagName") === "SELECT") {
                m._event("change", do_ins_udate);
            } else if (m._p("tagName") === "INPUT") {
                m._event("input", do_ins_udate);
            } else {
                m._event("click", do_ins_udate);
            }

            break;
        case "select_append":
            m._event("click", function(e) {
                var option = e._getdata();
                option.url =
                    "/ins_admin/" +
                    e._getdata("type") +
                    "/add/do/get_tmp_index/main_style/ins_appendto_combo/" +
                    e._getdata("to") +
                    "/";
                if (!ins(e._getdata("select_text"))._is_empty())
                    option.url += "select_text/" + e._getdata("select_text") + "/";

                if (!ins(e._getdata("select_value"))._is_empty())
                    option.url += "select_value/" + e._getdata("select_value") + "/";

                if (!ins(e._getdata("onclose"))._is_empty())
                    option.url += "onclose/" + e._getdata("onclose") + "/";

                if (!ins(e._getdata("onopen"))._is_empty()) {
                    option.onopen = function() {
                        window[e._getdata("onopen")](e);
                    };
                }
                option.onclose = function() {
                    if (!ins(e._getdata("onclose"))._is_empty()) {
                        window[e._getdata("onclose")](e);
                    }
                };
                ins()._ui._ins_lightbox(option);
            });

            break;

        case "ajax_upload":
            m._event(
                "change",
                function(e) {
                    var options = new FormData();
                    options.append("afile", e.files[0]);
                    ins(e)._ajax._upload(
                        "/ins_ajax.php?get_file=/eng/upload_1",
                        options,
                        function(d) {}
                    );
                },
                false
            );
            break;
        case "ajax_upload_file":
            m._on(
                "change",
                function(ie) {
                    var options = new FormData();
                    //  console.log(m._getdata("oncomplete"));
                    if (m._getdata("oncomplete") != null) {
                        window[m._getdata("oncomplete")]("a", "c");
                    }
                    Object.keys(ins(ie)._get(0).files).forEach(function(f) {
                        options.append("afile", ins(ie)._get(0).files[f]);

                        if (!ins(m._getdata("prefix"))._is_empty()) {
                            options.append("perfix", m._getdata("prefix"));
                        }
                        if (!ins(m._getdata("path"))._is_empty()) {
                            options.append("path", m._getdata("path"));
                        }
                        if (!ins(m._getdata("filename"))._is_empty()) {
                            options.append("filename", m._getdata("filename"));
                        }

                        ins(m)._ajax._upload(
                            "/ins_ajax.php?get_file=/eng/upload_1",
                            options,
                            function(d) {
                                var j = JSON.parse(d);
                                if (j.status == "0") {
                                    alert(j.msg);
                                } else {
                                    ie._parent()._addclass("uploaded");

                                    if (!ins(m._getdata("oncomplete"))._is_empty()) {
                                        window[m._getdata("oncomplete")](j, m);
                                    }
                                }

                                if (!ins(ie._getdata("progress_bar"))._is_empty()) {
                                    var pb = ins(ie._getdata("progress_bar"));
                                } else {
                                    var pb = m._parent()._find(".progress_bar");
                                }

                                pb._css({ width: "0px" });
                                pb._settext("");
                            }
                        );
                    }, true);
                },
                false
            );
            break;
        case "ajax_upload_delete":
            m._event(
                "click",

                function(ie) {
                    var options = { status: "delete", file: m._getdata("file") };
                    ins(ie)._ajax._send(
                        "/ins_ajax.php?get_file=/eng/upload_1",
                        options,
                        "POST",
                        function(d) {
                            var p = m._parent();
                            //  var f = p._find("._file");
                            var pb = p._find(".progress_bar");
                            if (ins(p._find("img"))._is_exists()) {
                                p._find("img")._setattr("src", "");
                            }

                            pb._css({ width: "0px" });
                            pb._settext("");
                            p._removeclass("uploaded");
                            p._find("*")._removeclass("uploaded");

                            // if (!ins(f)._is_empty()) {
                            if (!ins(m._getdata("ondelete"))._is_empty()) {
                                window[m._getdata("ondelete")](options, m);
                            }
                            // }
                        }
                    );
                },
                false
            );
            break;
        case "ins_datepicker":
            ins()._ui._datePicker(m._get(0), {
                type: "range",
                selected: function(d1, d2) {
                    //   alert(d1.toString())
                },
            });
            break;
        case "lightbox_remove":
            m._event("click", function(e) {
                ins()._ui._lightbox_remove();
            });
            break;
        case "logout":
            m._event("click", function(e) {
                var options = e._getdata();

                options["status"] = "logout";
                options["get_file"] = "eng/login";
                ins()._ajax._send("/ins_ajax.php?", options, null, function() {
                    if (ins(e._getdata("to"))._is_exists()) {
                        window.location = e._getdata("to");
                    } else {
                        window.location = "/";
                    }
                });
            });
            break;
        case "collapsed":
        case "ins_collapsed":
            m._ui._collapsed();
            break;
        case "tabs":
        case "ins_tabs":
            m._ui._tabs();
            break;
        case "ins_print":
        case "print":
            m._on(
                "click",
                function(o, e) {
                    ins()._print(o);
                },
                true
            );

            break;
        case "accordion":
        case "ins_accordion":
            m._ui._accordion();
            break;
        case "ins_autocomplete":
            ins("ins_plg_listauto")._plgin({ o: m }, function() {});

            break;
        case "ins_to_buttons_list":
            var options = {};
            if (ins(m._getdata("onchange"))._is_exists()) {
                options.onchange = window[m._getdata("onchange")];
            }
            m._ui._to_buttons_list(options);
            break;

        case "ins_json_form":
            m._ui._ins_json_form();
            break;

        case "clone":
            m._on("click", function(e) {
                ins(e._getdata("cloneto"))._append(
                    ins(e._getdata("clone"))._getouterhtml()
                );
                ins()._ui._update_ui();
            });
            break;
        case "remove":
            m._on("click", function(e) {
                var data = e._getdata("remove");
                if (data == "parent") {
                    var d = e._parent();
                }
                ins(d)._remove(e._getdata("callback"));
            });
            break;
        case "remove":
            m._on("click", function(e) {
                var data = e._getdata("remove");
                if (data == "parent") {
                    var d = e._parent();
                }
                ins(d)._remove(e._getdata("callback"));
            });
            break;
        case "show":
            m._on("click", function(e) {
                var d = e._getdata("show");
                ins(d)._removeclass("ins_hidden");
            });
            break;
        case "hide":
            m._on("click", function(e) {
                var d = e._getdata("hide");
                ins(d)._addclass("ins_hidden");
            });
            break;
        case "app_ajax":
            var options = {};

            if (ins(m._getdata("onupdate"))._is_exists()) {
                options.onupdate = function() {
                    window[m._getdata("onupdate")](m);
                };
            }
            ins(m._getdata("status"))._app._ajax(options);
            break;
    }
}

UI.prototype._ins_print = function(options) {
    if (ins(this.o)._is_exists()) {
        options.id = this.o;
    }
    var option = {};
    option.url =
        "/ins_ajax.php?get_file=pages/print&header=true&id=" + options.id;

    if (ins(options.datatype)._is_exists()) {
        option.url += "&datatype=" + options.datatype;
    }

    if (ins(options.dataid)._is_exists()) {
        option.url += "&dataid=" + options.dataid;
    }
    if (ins(options.xref)._is_exists()) {
        option.url += "&xref=" + options.xref;
    }

    if (ins(options.xref_field)._is_exists()) {
        option.url += "&xref_field=" + options.xref_field;
    }

    ins()._ui._ins_lightbox(option);
};

UI.prototype._update_ui = function() {
    ins(".ins_tiny_editor .ins_tiny_editor_body")._each(function(e) {
        var t = e._parent()._find(".ins_tiny_editor_textarea");
        e._sethtml(t._getvalue());
    });

    ins(".jsaction,.ins_jsaction,.insaction")
        ._get()
        .forEach(function(e) {
            if (!updated.includes(e)) {
                updated.push(e);
                var m = ins(e);
                if (ins(m._getdata("jsaction"))._is_exists()) {
                    updateui(m, m._getdata("jsaction"));
                }
                if (ins(m._getdata("insaction"))._is_exists()) {
                    var ex = m._getdata("insaction").split(",");
                    ex.forEach(function(e) {
                        updateui(m, e);
                    });
                }
            }
        });
};

UI.prototype._update_object = function(obj) {
    var m = ins(obj);

    if (ins(m._getdata("insaction"))._is_exists()) {
        var ex = m._getdata("insaction").split(",");
        ex.forEach(function(e) {
            updateui(m, e);
        });
    }
};

UI.prototype._order = function(options) {
    var t = ins(this.o)._get(0);

    for (var i = 0; i < t.childNodes.length; i++) {
        ins(t.childNodes[i])._darg({
            ondragstart: function(o, ev) {
                var id = "drag-" + new Date().getTime();
                o._setattr("id", id);
                ev.dataTransfer.setData("text", id);
            },
            hander: options.hander,
        });

        ins(t.childNodes[i])._drop({
            ondrop: function(drop_object, ev) {
                var drag_object = ins("#" + ev.dataTransfer.getData("text"))._get(0);
                ins(drop_object)._append_befor(drag_object);

                if (ins(options.ondone)._is_exists()) {
                    options.ondone(drop_object, drag_object);
                }
            },
        });
    }
};

UI.prototype._map_get_location = function(options) {
    /* function error(err) {
    alert(`Failed to locate. Error: ${err.message}`)
  }

  function success(pos) {

    console.log(`${pos.coords.latitude}, ${pos.coords.longitude}`);
    alert(`${pos.coords.latitude}, ${pos.coords.longitude}`);
  }
*/
    //function getGeolocation() {
    if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(options.ondone, options.onerror);
    }
    // }
};

UI.prototype._map = function(options) {
    var o = this.o;
    var script = document.createElement("script");
    script.src =
        "https://maps.googleapis.com/maps/api/js?key=AIzaSyCIAWRMS-am-n_Q2wkNjFWFjB_iIIchPOU&callback=initMap";
    script.defer = true;

    options.center = options.center ?
        options.center : {
            lat: 37.772,
            lng: -122.214,
        };

    options.zoom = options.zoom ? options.zoom : 8;

    function markers(map, data) {
        var ms = [];
        data.forEach(function(a) {
            var marker = new google.maps.Marker({
                position: a,
                title: a.title,
                map: map,
            });

            marker.set;

            if (options.onaddmarker != null) {
                options.onaddmarker(map, marker);
            }

            ms.push(marker);
        });
        return ms;
    }

    function path(map, path) {
        var flightPath = new google.maps.Polyline({
            path: path.data,
            geodesic: true,
            strokeColor: path.color ? path.color : "#FF0000",
            strokeOpacity: path.opacity ? path.opacity : 1.0,
            strokeWeight: path.weight ? path.weight : 2,
        });

        flightPath.setMap(map);

        return flightPath;
    }

    window.initMap = function() {
        var map = new google.maps.Map(document.querySelector(o), {
            zoom: options.zoom,
            center: options.center,
        });

        var ms = options.markers ? markers(map, options.markers) : false;
        var p = options.path ? path(map, options.path) : false;

        if (options.onload != null) {
            options.onload(map, ms, p);
        }
    };

    document.head.appendChild(script);
};

UI.prototype._ins_json_form = function() {
    var o = ins(this.o);

    var k = ins()._data._get_unique_id();
    o._addclass(k);
    k = "." + k;

    var data_body = o._append(
        "<div class='ins_grid ins_col_12 _ins_json_form_row '></div>"
    );

    var add_btn = ins(o._getdata("add_btn"));
    var delete_btn = ins(o._getdata("delete_btn"));

    var inputs = ins(o._getdata("inputs"));
    var input = ins(o._getdata("input"));

    var h = inputs._getouterhtml();

    add_btn._on(
        "click",
        function() {
            var ap = data_body._append(h);
            ap._removeclass("ins_hidden");
            ins()._ui._update_ui();
        },
        true
    );

    delete_btn._on(
        "click",
        function(t) {
            t._parent()._remove();
            _ins_json_form_update();
        },
        true
    );

    function _ins_json_form_update() {
        var allj = [];
        ins(k)
            ._find("._ins_json_form_row")
            ._find(o._getdata("inputs"))
            ._each(function(i) {
                var j = ins(i)._data._get_inputs();
                delete j.error;
                delete j.error_inputs;
                allj.push(j);
            });
        input._setvalue(JSON.stringify(allj));
    }

    ins(
        k +
        " ._ins_json_form_row input," +
        k +
        " ._ins_json_form_row textarea," +
        k +
        "  ._ins_json_form_row select"
    )._on(
        "change",
        function() {
            _ins_json_form_update();
        },
        true
    );

    if (!ins(ins(o._getdata("input"))._getvalue())._is_empty()) {
        var j = JSON.parse(ins(o._getdata("input"))._getvalue());

        j.forEach(function(v) {
            var ap = data_body._append(h);

            ap._removeclass("ins_hidden");
            ins(ap)._data._update_inputs(v);
            ins()._ui._update_ui();
        });
    }
};

//<editor-fold defaultstate="collapsed" desc="_autocomplete">

UI.prototype._to_buttons_list = function(options) {
    var o = ins(this.o);
    var th = this;
    var multiaple = false;
    var data = [];
    var ops = o._p("options");
    o._css({ display: "none" });
    if (!ins(o._getattr("multiple"))._is_empty()) {
        multiaple = true;
    }

    Object.keys(ops).forEach(function(k) {
        var kn = ins(ops[k]);
        var t = kn._gettext();
        var v = t;
        var s = false;
        var tooltip = false;
        if (ins(kn._getattr("value"))._is_exists()) {
            v = kn._getattr("value");
        }

        if (ins(kn._getdata("html"))._is_exists()) {
            t = kn._getdata("html");
        }

        if (ins(kn._getattr("selected"))._is_exists()) {
            s = true;
        }
        if (ins(kn._getdata("tooltip"))._is_exists()) {
            tooltip = kn._getdata("tooltip");
        }
        data.push({ v: v, t: t, s: s, tooltip: tooltip });
    });
    au_update_data();

    function au_update_data() {
        var ul = th._create("ul", "", {
            class: "ins_list ins_inline ins_highlight_area ",
        });
        o._append_after(ul);
        //   data.forEach(function (i) {
        Object.keys(ops).forEach(function(k) {
            var kn = ins(ops[k]);
            var t = kn._gettext();
            var v = t;
            //  var s = false;
            //  var tooltip = false;

            if (ins(kn._getattr("value"))._is_exists()) {
                v = kn._getattr("value");
            }

            if (ins(kn._getdata("html"))._is_exists()) {
                t = kn._getdata("html");
            }
            /*
                          if (ins(kn._getattr("selected"))._is_exists()) {
                          s = true;
                          }
                          if (ins(kn._getdata("tooltip"))._is_exists()) {
                          tooltip = kn._getdata("tooltip");
                          }
                          
                          */

            if (!ins(t.trim())._is_empty()) {
                var classes = " ins_buttons_item button  " + "_" + v;
                if (ins(kn._getattr("selected"))._is_exists()) {
                    classes += " ins_act ";
                }
                if (ins(kn._getattr("class"))._is_exists()) {
                    classes += "  " + kn._getattr("class");
                }

                var li = th._create("li", "" + t, {
                    "data-value": "" + v,
                    class: "" + classes,
                });

                if (ins(kn._getdata("tooltip"))._is_exists()) {
                    ins(li)._setattr("title", kn._getdata("tooltip"));
                }

                ins(ul)._append(li);
                ins(li)._sethtml("<span>" + t + "</span>");
                ins(li)._event("click", function(tho) {
                    if (
                        ins(kn._getattr("data-disable_class"))._is_exists() &&
                        !tho._hasclass("ins_act")
                    ) {
                        tho
                            ._parent()
                            ._find("li." + kn._getattr("data-disable_class"))
                            ._removeclass("ins_act");

                        tho
                            ._parent()
                            ._find("li." + kn._getattr("data-disable_class"))
                            ._each(function(oo) {
                                if (ins(oo._getdata("value"))._is_exists()) {
                                    o._find('option[value="' + oo._getdata("value") + '"]')._p(
                                        "selected",
                                        false
                                    );
                                }
                            });
                    }

                    var s = false;
                    if (tho._hasclass("ins_act")) {
                        tho._removeclass("ins_act");
                        o._find('option[value="' + v + '"]')._p("selected", false); //.selected = false;
                    } else {
                        s = true;
                        if (multiaple === true) {
                            o._find('option[value="' + v + '"]')._p("selected", true); //.selected = false;
                        } else {
                            tho._parent()._find("li")._removeclass("ins_act");
                            o._setvalue(v);
                        }

                        tho._addclass("ins_act");
                    }

                    if (ins(options.onchange)._is_exists()) {
                        options.onchange(tho, s);
                    }
                });
            }
        });
    }
};
UI.prototype._autocomplete = function(options) {
    var o = ins(this.o);

    console.log(options);

    var th = this;
    var data = [];
    var inp,
        ishow = null;
    let currentFocus = 0;
    let isopen = false;
    if (!ins(options)._is_exists()) {
        var options = {};
    }

    var v = "";
    if (o._get(0).tagName === "SELECT") {
        if (!ins(o._getattr("multiple"))._is_empty()) {
            options.multiaple = true;
        }

        if (!ins(o._getvalue())._is_empty() && options.multiaple != true) {
            v = o._find('option[value="' + o._getvalue() + '"]')._gettext(); //.selected = false;
        }

        var c = ins()._data._get_unique_id();
        var ishows = th._create("i", "", {
            type: "text",
            class: " fas fa-angle-down " + c,
        });

        var ins_au_keys_area = th._create("div", "", {
            type: "text",
            class: " ins_au_keys_area " + c,
        });

        var ins_autocomplete_input_area = th._create(
            "div",
            "", { class: "ins_autocomplete_input_area ins_ui_input ins_col_12 " + c }, [ins_au_keys_area, ishows]
        );

        var inps = th._create("input", "", {
            autocomplete: "off",
            value: v,
            type: "text",
            class: " ins_autocomplete_input ins_col_12   " + c,
        });
        var ins_autocomplete_data_list = th._create(
            "div",
            "", { class: " ins_col_12  ins_autocomplete_data_list " + c }, [inps]
        );

        var _all_input_area = th._create("div", "", { class: " ins_col_12 " + c }, [
            ins_autocomplete_input_area,
            ins_autocomplete_data_list,
        ]);

        var ins_autocomplete_all = ins(
            th._create(
                "div",
                "", { class: " ins_col_12  ins_autocomplete_all  " + c }, [_all_input_area]
            )
        );

        ins_au_keys_area = ins(ins_au_keys_area);

        _all_input_area = ins(_all_input_area);
        ins_autocomplete_input_area = ins(ins_autocomplete_input_area);
        ins_autocomplete_data_list = ins(ins_autocomplete_data_list);
        inp = ins(inps);
        ishow = ins(ishows);

        function update_data_select(value, selected) {
            var tmp = [];
            data.forEach(function(item) {
                if (item.v === value) {
                    item.selected = selected;
                }
                tmp.push(item);
            });

            data = tmp;
        }

        function au_clear_data(close = true) {
            ins(".ins_autocomplete_list")._remove();

            if (close) {
                ins_autocomplete_all._removeclass("ins_opend");

                _all_input_area._removeclass("ins_highlight_area");
            }
            isopen = false;
        }

        function au_addkey(text, value) {
            var ii = th._create("i", "", {
                class: "fas fa-times",
                "data-value": value,
            });
            var sp = th._create("span", text, { class: "ins_light" }, ii);

            o._find('option[value="' + value + '"]')._p("selected", true); //.selected = false;
            update_data_select(value, true);

            ins_au_keys_area._append(sp);

            ins(ii)._event("click", function(thi) {
                o._find('option[value="' + thi._getdata("value") + '"]')._p(
                    "selected",
                    false
                ); //.selected = false;
                thi._parent()._remove();
                update_data_select(thi._getdata("value"), false);
                au_clear_data();
            });
        }

        function au_update_data(t, all) {
            au_clear_data(false);
            var ul = th._create("ul", "", { class: "ins_autocomplete_list  " });

            ins_autocomplete_data_list._append(ul);

            isopen = true;
            data.forEach(function(i) {
                if (i.t.toLowerCase().search(t.toLowerCase()) > -1 || all) {
                    var disclass = "";
                    if (i.selected === true) {
                        disclass = "ins_disabled";
                    }
                    var li = th._create("li", "" + i.t, {
                        "data-value": "" + i.v,
                        class: "ins_autocomplete_item " + disclass,
                    });
                    ins(ul)._append(li);

                    ins_autocomplete_all._addclass("ins_opend");
                    _all_input_area._addclass("ins_highlight_area");

                    ins(li)._event("click", function(tho) {
                        if (!tho._hasclass("ins_disabled")) {
                            if (options.multiaple === true) {
                                au_addkey(tho._gettext(), tho._getdata("value"));
                                inp._setvalue("");
                            } else {
                                o._setvalue(i.v);
                                if (inp !== null) {
                                    //

                                    ins_au_keys_area._sethtml(tho._gettext());
                                }

                                var event = new Event("change", { bubbles: true });
                                o._get(0).dispatchEvent(event);
                            }
                            au_clear_data();
                        }
                    });
                }
            });
        }

        function au_addActive(x) {
            ins(x)._removeclass("ins_act");
            x[currentFocus].focus();
            ins(x[currentFocus])._addclass("ins_act");
        }

        o._append_befor(ins_autocomplete_all);

        o._css({ display: "none" });

        //<editor-fold defaultstate="collapsed" desc="options to object">
        var ops = o._p("options");

        Object.keys(ops).forEach(function(k) {
            var kn = ins(ops[k]);
            var aop = { v: kn._getattr("value"), t: kn._gettext() };
            if (kn._p("selected") && options.multiaple) {
                au_addkey(kn._gettext(), kn._getattr("value"));
                aop.selected = true;
            }
            data.push(aop);
        });
        //</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="events">

        inp._event("input", function(o) {
            au_update_data(o._getvalue(), false);
        });

        inp._event("keydown", function(o, e) {
            var x = ins(".ins_autocomplete_list li")._get();

            if (e.keyCode == 40) {
                //donw

                if (!isopen) {
                    au_update_data("all", true);
                }
                if (currentFocus < x.length) {
                    currentFocus++;
                    au_addActive(x);
                }
            } else if (e.keyCode == 38) {
                //up
                currentFocus--;
                if (currentFocus < -1) currentFocus = 0;
                au_addActive(x);
            } else if (e.keyCode == 13) {
                e.preventDefault();
                if (currentFocus > -1) {
                    if (x) x[currentFocus].click();
                }
            }
        });

        ins("*:not(." + c + ")")._on("click", function(e, o) {
            if (isopen) {
                au_clear_data();
                inp._setvalue("");
            }
        });

        function au_open_close(e) {
            e.preventDefault();
            inp._setvalue("");

            if (!isopen) {
                au_update_data("all", true);
            } else {
                au_clear_data();
            }
        }

        ins_au_keys_area._on("click", function(o, e) {
            au_open_close(e);
        });

        ins_autocomplete_input_area._on("click", function(o, e) {
            au_open_close(e);
        });
        ishow._on("click", function(o, e) {
            au_open_close(e);
        });
        //</editor-fold>
    } else {
        console.error(
            "INS ERORR: 04 to create autocompelet create befor select item :( "
        );
    }
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="create">

UI.prototype._get = function(tags, parent, parent_attrs) {
    var r = [];
    for (var k in tags) {
        var t = tags[k];
        var a = this._create(t.name, t.data, t.attrs, t.child);
        if (t.event !== null) {
            ins(a)._event(t.event[0], t.event[1]);
        }

        r.push(a);
    }

    if (parent === null) {
        parent = "div";
    }

    return this._create(parent, null, parent_attrs, r);
};
/*
 *
 * @param {type} tag
 * @param {type} text
 * @param {type} attrs
 * @param {type} child
 * @returns {UI.prototype._create.o|Element}
 *
 *
 */
UI.prototype._create = function(tag, text, attrs, child) {
    var o = document.createElement(tag);
    for (var k in attrs) {
        o.setAttribute(k, attrs[k]);
    }
    if (!ins(child)._is_empty()) {
        if (Array.isArray(child)) {
            child.forEach(function(c) {
                if (c != null) {
                    o.appendChild(c);
                }
            });
        } else if (typeof child === "object") {
            o.appendChild(child);
        } else if (typeof child === "string") {
            o.innerHTML = child;
            //o.appendChild(t);
        }
    }

    if (!ins(text)._is_empty()) {
        if (Array.isArray(text)) {
            text.forEach(function(c) {
                if (c != null) {
                    o.appendChild(c);
                }
            });
        } else if (typeof text === "object") {
            o.appendChild(text);
        } else if (typeof text === "string") {
            var t = document.createTextNode(text);
            o.appendChild(t);
        }
    }

    /*  console.log(typeof text);
          console.log(text);*/

    return o;
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="objects">

/**
 *
 * @param {type} title
 * @param {type} data
 * @param {type} url
 * @param {type} style
 * @param {type} addclass
 * @returns {undefined}
 */

/**
 *
 * @param {type} title
 * @param {type} data
 * @param {type} url
 * @param {type} style
 * @param {type} addclass
 * @returns {undefined}
 */
UI.prototype._lightbox = function(title, data, url, style, addclass, onclose) {
    // * @param {type} options {title:$title,url:$url ,style:$style ,class:$class,data:$data,onclose:function(){},onopen:function(){}}

    var options = {
        title: title,
        url: url,
        style: style,
        class: addclass,
        onclose: onclose,
        data: data,
    };
    node = ins("ins_plg_lightbox")._plgin(options, function() {});

    return node;
};

UI.prototype._to_lightbox = function(t) {
    var o = ins(t);
    ins()._ui._lightbox_remove();
    ins()._ui._lightbox(
        o._getdata("lightbox_title"),
        this.o.trim(),
        "",
        o._getdata("lightbox_style"),
        "ins_lightbox" + o._getdata("status")
    );
    ins("ui")._ui._update_ui();
};

//
/**
 *
 * @param {type} options {to, select_text, select_value, select_type, select_table}
 * @returns {Ajax.prototype._send.xhttp|XMLHttpRequest}
 */
UI.prototype._fill_select = function(options) {
    options.root = "true";
    options.get_file = "/ins_ajax/pages/get_combo_options";
    return ins()._ajax._send("/ins_ajax.php", options, "POST", function(d) {
        ins(options.to)._sethtml(d);
        if (ins(options.onfill)._is_exists()) {
            options.onfill();
        }
    });
};
/**
 *
 * @param {type} options {title:$title,url:$url ,style:$style ,class:$class,data:$data,onclose:function(){},onopen:function(){}}
 * @returns {undefined}
 */
UI.prototype._ins_lightbox = function(options, onreday) {
    return ins("ins_plg_lightbox")._plgin(options, onreday);
};

UI.prototype._lightbox_remove = function() {
    var addclass = "";
    if (ins(this.o)._is_exists()) {
        addclass = this.o;
    }
    ins(".ins_lightbox" + addclass)._remove();
};

UI.prototype._ins_lightbox_textarea = function(options) {
    options.style = options.style ? options.style : "width:60%;height:auto;";
    options.datastyle = options.datastyle ? options.datastyle : "height:500px;";

    options.textstyle = options.textstyle ?
        options.textstyle :
        "width: 100%;height: 250px;";

    options.textstyle += "    direction: ltr; min-width:100%";
    options.buttonstyle = options.buttonstyle ?
        options.buttonstyle :
        " width: 100%;";
    options.buttontitle = options.buttontitle ? options.buttontitle : "Send";

    options.class = options.class + " _ins_lightbox_textarea";

    var text = this._create("textarea", options.value, {
        class: "_ins_lightbox_textarea",
        style: options.textstyle,
    });
    var button = this._create("button", options.buttontitle, {
        class: "_ins_lightbox_button",
        style: options.buttonstyle,
    });
    options.data = this._create("div", [text, button]);
    this._ins_lightbox(options);

    ins(button)._on(
        "click",
        () => {
            if (ins(options.onsubmit)._is_exists()) {
                options.onsubmit(ins(text)._getvalue());
            }
            ins("._ins_lightbox_textarea")._ui._lightbox_remove();
        },
        true
    );
};

/**
 *
 * @param {type} options [area ,callback]
 * @returns {undefined}
 */
UI.prototype._create_image = function(options) {
    ins("/ins_lib/js/lib/html2canvas.min.js")._onload(function() {
        window.scrollTo(0, 0);
        html2canvas(document.querySelector(options.area)).then(function(canvas) {
            var base64URL = canvas
                .toDataURL("image/jpeg")
                .replace("image/jpeg", "image/octet-stream");

            options.get_file = "/ins_ajax/eng/screenshot";
            options.image = base64URL;
            options.root = "true";

            ins()._ajax._post({
                url: "/ins_ajax.php",
                options: options,
                onprogress: options.onprogress,
                callback: function(d) {
                    options.callback(d);
                },
            });
        });
    });
};

UI.prototype._ui_create_image = function(t) {
    var o = ins(t);
    var area = "";
    if (ins(this.o)._is_exists()) {
        area = this.o;
    } else if (ins(o._getdata("area"))._is_exists()) {
        area = o._getdata("area");
    }

    if (!ins(area)._is_empty()) {
        ins()._ui._create_image({
            area: area,
            onprogress: function(p) {
                if (ins(o._getdata("onprogress"))._is_exists()) {
                    ins(o._getdata("onprogress"))._css({ width: p + "%" });
                    if (p == 100) {
                        ins(o._getdata("onprogress"))._css({ width: "0%" });
                    }
                }
            },
            callback: function(jdata) {
                var data = JSON.parse(jdata.trim());

                if (ins(o._getdata("callback"))._is_exists()) {
                    window[o._getdata("callback")](data, o);
                } else {
                    window.open(data.url, "_blank");
                }
            },
        });
    }
};

/**
 *
 * @param {type} options [area ,callback]
 * @returns {undefined}
 */
UI.prototype._ui_create_pdf = function(t) {
    var o = ins(t);
    var options = o._getdata();

    if (ins(this.o)._is_exists()) {
        options.area = this.o;
    } else if (ins(o._getdata("area"))._is_exists()) {
        options.area = o._getdata("area");
    }

    options.onprogress = function(p) {
        if (ins(o._getdata("onprogress"))._is_exists()) {
            ins(o._getdata("onprogress"))._css({ width: p + "%" });
            if (p == 100) {
                ins(o._getdata("onprogress"))._css({ width: "0%" });
            }
        }
    };
    options.callback = function(jdata) {
        var data = JSON.parse(jdata.trim());
        if (ins(o._getdata("callback"))._is_exists()) {
            window[o._getdata("callback")](data, o);
        } else {
            window.open(data.url, "_blank");
        }
    };
    ins()._ui._create_pdf(options);
};

/**
 *
 * @param {type} options [area ,callback]
 * @returns {undefined}
 */
UI.prototype._create_pdf = function(options) {
    ins("/ins_lib/js/lib/html2canvas.min.js")._onload(function() {
        var element = document.querySelector(options.area);
        window.scrollTo(0, 0);

        html2canvas(
            element,

            {
                width: element.scrollWidth,
                height: element.scrollHeight,
            }
        ).then(function(canvas) {
            ins("/ins_lib/js/lib/jspdf.min.js")._onload(function() {
                var imgData = canvas.toDataURL("image/jpeg", 1.0);

                var pdf = new jsPDF("1", "pt", "a4");

                pdf.addImage(imgData, "JPEG", 0, 0, 595.28, 841.89);
                pdf.output("datauristring");

                options.get_file = "/ins_ajax/eng/screenshot";
                options.image = pdf.output("datauristring");
                options.root = "true";
                if (ins(options.filename)._is_empty()) {
                    options.filename = ins()._data._get_unique_id() + ".pdf";
                }

                ins()._ajax._post({
                    url: "/ins_ajax.php",
                    options: options,
                    onprogress: options.onprogress,
                    callback: function(d) {
                        options.callback(d);
                    },
                });
            });
        });
    });
};

UI.prototype._accordion = function() {
    var tho = ins(this.o);

    function open(h3) {
        tho
            ._find("div > h3")
            ._get()
            .forEach(function(o) {
                ins(o)._parent()._animation._height("min_height", "", "ins_opend");
            });
        ins(h3)._parent()._animation._height("max_height", "ins_opend");
    }

    tho
        ._find("div > h3")
        ._get()
        .forEach(function(o) {
            var h = ins(o);
            h._sethtml('<i class="fas fa-sort-down"></i>' + h._gethtml());
            h._parent()._setdata("max_height", h._parent()._height());
            h._parent()._setdata("min_height", h._height());
            open(tho._find("div > h3")._get(0));
            h._on("click", function(e) {
                var p = h._parent();
                if (p._hasclass("ins_opend")) {
                    p._animation._height("min_height", "", "ins_opend");
                } else {
                    open(h);
                }
            });
        });
    return tho;
};

/**
 *
 * @param {type} options{ id:,datatype:optional,dataid:optional,xref:optional,xref_field:optional}
 * @returns {undefined}
 */
UI.prototype._collapsed = function() {
    var o = ins(this.o);
    o._addclass("ins_collapsed_item");

    var h3 = o._find("h3");
    if (ins(h3)._is_exists()) {
        h3._on(
            "click",
            function(e) {
                if (o._hasclass("ins_opend")) {
                    o._removeclass("ins_opend");
                } else {
                    o._addclass("ins_opend");
                }
            },
            true
        );
    }
    return o;
};
UI.prototype._tabs = function() {
    function open(item) {
        var p = item._parent();
        p._find("li")._removeclass("ins_act");
        item._addclass("ins_act");
        p._parent()._find(".ins_tabs_body > div ")._addclass("ins_hidden");
        p._parent()._find(item._getdata("show"))._removeclass("ins_hidden");
    }

    var o = ins(this.o);
    var a = null;
    let t = o._find(".ins_tabs_header > li");

    o._find(".ins_tabs_body > div")
        ._get()
        .forEach(function(item) {
            ins(item)._addclass("ins_hidden");
        });

    if (!ins(o._find(".ins_tabs_header > li.ins_act"))._is_empty()) {
        a = o._find(".ins_tabs_header > li.ins_act");
    } else if (!ins(o._getdata("show"))._is_empty()) {
        a = o._find(
            '.ins_tabs_header > li[data-show="' + o._getdata("show") + '"]'
        );
        a._addclass("ins_act");
    } else {
        a = ins(o._find(".ins_tabs_header > li")._get(0));
        a._addclass("ins_act");
    }

    open(a);
    t._on(
        "click",
        function(item) {
            open(item);
        },
        true
    );
    return o;
};
//</editor-fold>

UI.prototype._print = function(t) {
    if (!ins(this.o)._is_empty()) {
        var area = this.o;

        ins()._ajax._send(
            "/ins_ajax.php", { get_file: "pages/print_area_data" },
            null,
            function(data) {
                var prtContent = document.getElementById(area);

                data += prtContent.innerHTML;
                var WinPrint = window.open(
                    "",
                    "",
                    "left=0,top=0,width=800,height=900,toolbar=0,scrollbars=0,status=0"
                );
                WinPrint.document.write(data);
                WinPrint.document.close();
                WinPrint.focus();
                WinPrint.print();
                // WinPrint.close();
            }
        );
    } else {
        window.print();
    }
};

UI.prototype._addloader = function(type) {
    if (ins(this.o)._is_empty()) this.o = "body";
    if (ins(type)._is_empty()) type = "";
    var i = this._create("i", "", { class: "fas fa-circle-notch fa-spin" });
    var node = this._create("span", "", { class: "ins_loader  " + type }, i);
    return ins(this.o)._append(node);
};
UI.prototype._removeloader = function() {
    if (ins(this.o)._is_empty()) this.o = "body";
    ins(this.o + " .ins_loader")._remove();
};
/**
 *
 * @param {type} msg
 * @param {type} type ["success","info","warning","error"] def:info
 * @returns message node
 */
UI.prototype._send_message = function(msg, type = " info ") {
    if (!ins(this.o)._is_empty()) {
        msg = this.o;
    }
    if (ins(msg)._is_empty()) {
        msg = ins()._data._get("operation_done_msg");
    }

    var close = this._create("i", "", { class: "message_close fas fa-times" });
    var node = this._create(
        "div",
        msg, { class: "ins_message  message  " + type },
        close
    );
    document.getElementsByTagName("body")[0].appendChild(node);

    ins(close)._event("click", function() {
        ins(".ins_message")._remove();
    });

    return node;
};

UI.prototype._send_tiny_message = function(msg, type = " info ") {
    if (!ins(this.o)._is_empty()) {
        msg = this.o;
    }
    if (ins(msg)._is_empty()) {
        msg = ins()._data._get("operation_done_msg");
    }
    var close = this._create("i", "", { class: "message_close fas fa-times" });
    var node = this._create(
        "div",
        msg, { class: "ins_message  message  " + type },
        close
    );
    var d = ins(".ins_message_area")._append(node);
    ins()._data._settimer(10000, function() {
        d._remove();
    });
    ins(close)._event("click", function(o) {
        d._remove();
    });

    return node;
};

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="Data">
function Data(o) {
    this.o = o;
}
Data.prototype._get = function(w = "") {
    var en = {
        operation_done_msg: "operation done successfully ",
        operation_error_msg: "operation Error ",
        months: [
            "January",
            "February",
            "March",
            "April",
            "May",
            "June",
            "July",
            "August",
            "September",
            "October",
            "Novemeber",
            "Decemeber",
        ],
        days: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
    };
    var ar = {
        operation_done_msg: "تم العمليه بنجاح  ",
        operation_error_msg: "حدث مشلكله اثناء العمليه ",
        months: [
            "يناير",
            "فبراير",
            "مارس",
            "ابريل",
            "مايو",
            "يونيو",
            "يوليو",
            "أغسطس",
            "سبتمبر",
            "أكتوبر",
            "نوفمبر",
            "ديسمبر",
        ],
        days: [
            "الاحد",
            "الاثنين",
            "الاثنين",
            "الاربعاء",
            "الخميس",
            "الجمعة",
            "السبت",
        ],
    };

    var r = "";

    if (ins("ar")._is_lang()) {
        r = ar[w];
    } else {
        r = en[w];
    }
    return r;
};

Data.prototype._interval = function(code, time) {
    setInterval(code, time);
};
Data.prototype._settimer = function(time, code) {
    setInterval(code, time);
};

Data.prototype._json_join = function(object1, object2) {
    return Object.assign(object1, object2);
};

Data.prototype._timer = function(options) {
    var t = this;
    options.end = options.end ? options.end : false;
    options.repeat = options.repeat !== undefined ? options.repeat : true;
    options.time = options.time ? options.time : 1000;
    if (!options.end) {
        window.setTimeout(function() {
            options = options.func(options);
            // console.log(options);
            if (options.repeat === true) {
                t._timer(options);
            } else if (options.repeat > 0) {
                options.repeat--;
                t._timer(options);
            }
        }, options.time);
    }
};

Data.prototype._date_gettoday = function(time, code) {
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1; //January is 0!
    var yyyy = today.getFullYear();
    if (dd < 10) {
        dd = "0" + dd;
    }
    if (mm < 10) {
        mm = "0" + mm;
    }

    return yyyy + "-" + mm + "-" + dd;
};

Data.prototype._generatePassword = function(length = 8) {
    var charset =
        "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",
        retVal = "";
    for (var i = 0, n = charset.length; i < length; ++i) {
        retVal += charset.charAt(Math.floor(Math.random() * n));
    }

    return retVal;
};

/*Data.prototype._getmonth = function (i) {
   var mos = [
     "January",
     "February",
     "March",
     "April",
     "May",
     "June",
     "July",
     "August",
     "September",
     "October",
     "Novemeber",
     "Decemeber",
   ];
   return mos[i];
 };*/
Data.prototype._page_data = function() {
    return JSON.parse(ins(".ins_main")._getdata("data"));
};
Data.prototype._get_page_data = function() {
    return JSON.parse(ins(".ins_main")._getdata("data"));
};

Data.prototype._set_session = function(name, value, done) {
    return ins()._ajax._send(
        "/ins_ajax/eng/session.php", { status: "set", name: name, value: value },
        "POST",
        done
    );
};
Data.prototype._get_session = function(name, done) {
    return ins()._ajax._send(
        "/ins_ajax/eng/session.php", { status: "get", name: name },
        "POST",
        done
    );
};
Data.prototype._get_unique_id = function(name, done) {
    return "_" + Math.random().toString(36).substr(2, 9);
};

Data.prototype._addtourl = function(url, ...adds) {
    var d = "";

    adds.forEach(function(a) {
        d += "/" + a;
    });

    if (url.indexOf("do") != -1) {
        url += "/";
    } else {
        url += "/do/";
    }
    url += d;
    url = this._replaceAll("///", "/", url);
    url = this._replaceAll("//", "/", url);
    return url;
};

Data.prototype._addtomyurl = function(...adds) {
    var d = "";

    var url = ins(this.o)._getdata("url");
    adds.forEach(function(a) {
        d += "/" + a;
    });

    if (url.indexOf("do") != -1) {
        url += "/";
    } else {
        url += "/do/";
    }
    url += d;
    url = this._replaceAll("///", "/", url);
    url = this._replaceAll("//", "/", url);
    return url;
};

Data.prototype._getmainurl = function() {
    return this._get_page_data().url;
};
/*Data.prototype._getdayweek = function (i) {
   var day = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
   return day[i];
 };*/
Data.prototype._replaceAll = function(search, replacement, String = null) {
    if (String === null) {
        String = this.o;
    }
    return String.replace(new RegExp(search, "g"), replacement);
};

Data.prototype._exists = function() {
    return !(typeof this.o === "undefined" || this.o === null);
};
Data.prototype._update_variables = function(search, String = null) {
    var t = this;
    if (String === null) {
        String = this.o;
    }
    if (!ins(search)._is_empty()) {
        Object.keys(search).forEach(function(i) {
            String = t._replaceAll("@{" + i + "}", search[i], String);
        });
    }
    return String;
};

Data.prototype._is_exists = function(i = false) {
    if (i === true) {
        return !(
            typeof ins(this.o)._get(0) === "undefined" || ins(this.o)._get(0) === null
        );
    } else {
        return !(typeof this.o === "undefined" || this.o === null);
    }
};
Data.prototype._is_empty = function() {
    return typeof this.o === "undefined" || this.o === null || this.o === "";
};
Data.prototype._validateEmail = function(email) {
    var re =
        /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
};

Data.prototype._clear_inputs = function() {
    ins(this.o)
        ._find("input,select,textarea")
        ._each(function(item, indx) {
            item._setvalue("");
        });
};

Data.prototype._update_inputs = function(j) {
    ins(this.o)
        ._find("input,select,textarea")
        ._each(function(item, indx) {
            var n = item._getattr("name");

            if (!ins(j[n])._empty()) {
                if (typeof j[n] === "object") {
                    j[n] = JSON.stringify(j[n]);
                }
                if (item._getdata("type") == "image") {
                    item
                        ._parents(".ui_image")
                        ._find("img")
                        ._setattr("src", "/ins_upload/" + j[n]);
                }
                item._setvalue(j[n]);
            }
        });
};

Data.prototype._get_inputs = function() {
    var o = this;

    let options = {};
    options.error = false;
    options.error_inputs = [];
    ins(this.o)
        ._find("input,select,textarea")
        ._each(function(item, indx) {
            //  console.log(item);

            let v = item._getvalue();
            if (!ins(v)._empty()) {
                if (
                    item._getattr("type") === "checkbox" ||
                    item._getattr("type") === "radio"
                ) {
                    if (item._get(0).checked) {
                        if (ins(item._getattr("name"))._is_exists()) {
                            var n = item._getattr("name");

                            if (n.search("]") > 0) {
                                if (ins(options[n])._is_exists()) {
                                    v = options[n] + "," + v;
                                }
                            }
                            options[n] = v;
                        }
                    }
                } else if (item._getattr("type") === "email" && !o._validateEmail(v)) {
                    options.error = true;
                    options.error_inputs.push(ins(item)._get(0));
                } else {
                    if (ins(item._getattr("name"))._is_exists()) {
                        var n = item._getattr("name");
                        if (n.search("]") > 0) {
                            if (ins(options[n])._is_exists()) {
                                v = options[n] + "," + v;
                            }
                        }
                        options[n] = v;
                    }
                }

                if (
                    ins(item._getattr("required"))._is_exists() &&
                    ins(item._getattr("minlength"))._is_exists()
                ) {
                    if (parseInt(item._getattr("minlength")) > v.length) {
                        options.error = true;
                        options.error_inputs.push(ins(item)._get(0));
                    }
                }
            } else if (
                ins(item._getattr("required"))._is_exists() ||
                ins(item._getattr("data-required"))._is_exists()
            ) {
                options.error = true;
                options.error_inputs.push(ins(item)._get(0));
            }
        });

    return options;
};

Data.prototype._app_settings_get = function(name = "") {
    var app = this.o;

    var app = ins()._data._get_page_data()._myname;
    ins("_get")._ajax._class({ name: name, app: app },
        function(data) {
            ondone(data);
        }, {
            _mypath: "ins_plgs/plg_sys_app_settings/",
            _myname: "plg_sys_app_settings",
        }
    );
};

Data.prototype._app_settings_set = function(name, value, ondone) {
    var app = this.o;

    var app = ins()._data._get_page_data()._myname;
    ins("_set")._ajax._class({ name: name, value: value, app: app },
        function(data) {
            ondone(data);
        }, {
            _mypath: "ins_plgs/plg_sys_app_settings/",
            _myname: "plg_sys_app_settings",
        }
    );
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="Animation">

function Animation(o) {
    this.o = o;
}
Animation.prototype._position = function(type, to, add, speed, callback) {
    if (ins(speed)._is_empty()) {
        speed = 5;
    }
    if (ins(callback)._is_empty()) {
        callback = function() {};
    }

    ins(this.o)
        ._get()
        .forEach(function(item) {
            var l = parseFloat(item.style[type]);
            let p = l;
            speed = speed / Math.abs(to);
            //  var add = true;
            let t = l + to;
            /* 
                      if (parseFloat(t) > parseFloat(to)) {
                      add = false;
                      }*/
            var inr = setInterval(frame, speed);

            function frame() {
                if (
                    (parseFloat(p) >= parseFloat(t) && add) ||
                    (parseFloat(p) <= parseFloat(t) && !add)
                ) {
                    clearInterval(inr);
                    callback(item);
                } else {
                    if (add) {
                        p += 5;
                    } else {
                        p -= 5;
                    }
                    item.style[type] = p + "px";
                }
            }
        });
};
Animation.prototype._fadeout = function(callback, speed) {
    if (speed == null) {
        speed = 5;
    }

    ins(this.o)
        ._get()
        .forEach(function(item) {
            item.style.opacity = 1;
            var i = setInterval(ch, speed);
            var to = 1;

            function ch() {
                if (to <= 0) {
                    clearInterval(i);
                    callback(item);
                } else {
                    to -= 0.01;
                    item.style.opacity = to;
                }
            }
        });
    return ins(this.o);
};
Animation.prototype._fadein = function(callback, speed) {
    if (speed == null) {
        speed = 5;
    }

    ins(this.o)
        ._get()
        .forEach(function(a) {
            a.style.opacity = 0;
            var i = setInterval(ch, speed);
            var to = 0;

            function ch() {
                if (to >= 1) {
                    clearInterval(i);
                    callback(a);
                } else {
                    to += 0.01;
                    a.style.opacity = to;
                }
            }
        });
    return ins(this.o);
};
Animation.prototype._height = function(h, addclass, removeclass, speed) {
    var o = ins(this.o);
    if (!ins(addclass)._is_empty()) {
        o._addclass(addclass);
    }
    if (!ins(removeclass)._is_empty()) {
        o._removeclass(removeclass);
    }
    if (isNaN(h)) {
        h = o._getdata(h);
    }
    if (ins(speed)._is_empty()) {
        speed = "0.3s ease-out";
    }
    o._css({ transition: speed, "overflow-y": "hidden" });
    o._css({ "max-height": h + "px" });
};
Animation.prototype._toggle_height = function(actclass) {
    if (!ins(actclass)._is_exists()) {
        actclass = "ins_opend";
    }
    var o = ins(this.o);
    if (o._hasclass(actclass)) {
        var m = "min_height";
        if (ins(o._getdata(m))._is_empty()) {
            m = 0;
        }
        o._animation._height(m, "", actclass);
    } else {
        o._animation._height("max_height", actclass);
    }
};
Animation.prototype._toggle_css = function(from, to, speed, actclass) {
    if (!ins(actclass)._is_exists()) {
        actclass = "ins_opend";
    }

    var o = ins(this.o);
    if (ins(speed)._is_empty()) {
        speed = "0.3s ease-out";
    }
    o._css({ transition: speed, "overflow-y": "hidden" });

    if (o._hasclass(actclass)) {
        o._css(from);
        o._removeclass(actclass);
    } else {
        o._css(to);
        o._addclass(actclass);
    }
};

Animation.prototype._down = function(options) {
    if (ins(options.from)._is_empty()) {
        options.from = 100;
    }
    if (ins(options.to)._is_empty()) {
        options.to = 0;
    }
    if (ins(options.speed)._is_empty()) {
        options.speed = 5;
    }
    var inv = setInterval(frame, options.speed);

    function frame() {
        if (options.from == options.to) {
            clearInterval(inv);

            if (ins(options.ondone)._is_exists()) {
                options.ondone();
            }
        } else {
            options.from--;
            options.frame(options.from);
        }
    }
};

Animation.prototype._up = function(options) {
    if (ins(options.from)._is_empty()) {
        options.from = 0;
    }
    if (ins(options.to)._is_empty()) {
        options.to = 100;
    }
    if (ins(options.speed)._is_empty()) {
        options.speed = 5;
    }
    var inv = setInterval(frame, options.speed);

    function frame() {
        if (options.from == options.to) {
            clearInterval(inv);

            if (ins(options.ondone)._is_exists()) {
                options.ondone();
            }
        } else {
            options.from++;
            options.frame(options.from);
        }
    }
};

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="Ajax">
if (typeof ins_jax == "undefined") {
    let ins_jax = null;
}

function Ajax(o) {
    this.o = o;
}

function addval(tag, val) {
    if (tag.tagName == "INPUT") {
        ins(tag)._setvalue(val);
    } else if (tag.tagName == "A") {
        ins(tag)._setattr("href", val);
    } else if (tag.tagName == "IMG") {
        ins(tag)._setattr("src", val);
    } else {
        ins(tag)._settext(val);
    }
}

Ajax.prototype._upload = function(url, options, callback) {
    let xhttp = new XMLHttpRequest();
    let o = this.o;
    let p = o._parent();
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            var j = JSON.parse(this.responseText);
            var n = j.name.split(".");

            if (!ins(o._getdata("add_path_to"))._is_empty()) {
                var g = ins(ins(o)._getdata("add_path_to"))._get(0);
                addval(g, "/" + j.filepath);
            }

            if (!ins(o._getdata("add_name_to"))._is_empty()) {
                var g = ins(ins(o)._getdata("add_name_to"))._get(0);
                addval(g, j.name);
            }

            if (!ins(o._getdata("img"))._is_empty()) {
                if (n[1] == "pdf") {
                    ins(o._getdata("img"))._append_befor(
                        '<a target="_blank" class="file_url _pdf" href="/' +
                        j.filepath +
                        '"><i class="far fa-file-pdf"></i></a>'
                    );
                    ins(o._getdata("img"))._css({ display: "none" });
                } else if (
                    n[1] == "jpg" ||
                    n[1] == "png" ||
                    n[1] == "jpeg" ||
                    n[1] == "gif"
                ) {
                    ins(o._getdata("img"))._setattr("src", "/" + j.filepath);
                    ins(o._getdata("img"))._css({ display: "block" });
                } else if (n[1] == "csv") {
                    ins(o._getdata("img"))._append_befor(
                        '<a target="_blank" class="file_url _pdf" href="/' +
                        j.filepath +
                        '"><i class="fas fa-file-csv"></i></a>'
                    );
                    ins(o._getdata("img"))._css({ display: "none" });
                } else {
                    ins(o._getdata("img"))._append_befor(
                        '<a target="_blank" class="file_url _pdf" href="/' +
                        j.filepath +
                        '"><i class="far fa-file"></i></a>'
                    );
                    ins(o._getdata("img"))._css({ display: "none" });
                }
            }
            if (!ins(o._getdata("input"))._is_empty()) {
                ins(o._getdata("input"))._setvalue(j.name);
            }

            if (!ins(p._find("a.file_url"))._is_empty()) {
                p._find("a.file_url")._setattr("href", "/" + j.filepath);
            }
            if (!ins(p._find(".file_delete"))._is_empty()) {
                p._find(".file_delete")._setdata("file", j.filepath);
            }

            if (!ins(p._find("img"))._is_empty()) {
                p._find("img")._setattr("src", "/" + j.filepath);
            }

            if (!ins(p._find(`input[type="hidden"]`))._is_empty()) {
                p._find(`input[type="hidden"]`)._setvalue(j.name);
            }

            callback(this.responseText, this);
        }
    };
    xhttp.upload.onprogress = function(e) {
        if (e.lengthComputable) {
            var percentComplete = (e.loaded / e.total) * 100;

            //  console.log(percentComplete);

            if (!ins(o._getdata("progress_bar"))._is_empty()) {
                var pr = ins(o._getdata("progress_bar"));
            } else {
                var pr = p._find(".progress_bar");
            }

            if (!ins(pr)._is_empty()) {
                pr._css({ width: percentComplete + "%" });
                pr._settext(Math.round(percentComplete) + "%");
            }
        }
    };
    xhttp.open("POST", url, true);
    xhttp.send(options);
    return xhttp;
};
/**
 *
 * @param {string} url
 * @param {josn} options
 * @param {string} type [POST,GET]
 * @param {function} callback
 * @returns {Ajax.prototype._send.xhttp|XMLHttpRequest}
 */
Ajax.prototype._send = function(url, options, type, callback, onprogress) {
    type = type == null ? "POST" : type;
    let xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            callback(this.responseText, this);
        }
    };
    xhttp.upload.onprogress = function(e) {
        if (e.lengthComputable) {
            var percentComplete = (e.loaded / e.total) * 100;
            if (ins(onprogress)._is_exists()) {
                onprogress(percentComplete, e);
            }
        }
    };
    var fd = new FormData();
    if (options instanceof FormData) {
        fd = options;
    } else if (typeof options === "string") {
        url += "?" + options;
    } else {
        Object.keys(options).forEach(function(k) {
            if (type === "POST") {
                fd.append(k, options[k]);
            } else {
                if (url.indexOf("?") == -1) {
                    url += "?";
                }

                url += "&" + k + "=" + options[k];
            }
        });
    }
    xhttp.open(type, url, true);
    xhttp.send(fd);
    return xhttp;
};
/**
 *
 * @param {type} attrs {url,options,callback}
 * @returns {Ajax.prototype._send.xhttp|XMLHttpRequest}
 */
Ajax.prototype._post = function(attrs) {
    return this._send(
        attrs.url,
        attrs.options,
        "POST",
        attrs.callback,
        attrs.onprogress
    );
};
/**
 *
 * @param {type} attrs {url,options,callback}
 * @returns {Ajax.prototype._send.xhttp|XMLHttpRequest}
 */
Ajax.prototype._get = function(attrs) {
    return this._send(
        attrs.url,
        attrs.options,
        "GET",
        attrs.callback,
        attrs.onprogress
    );
};
/**
 *
 * @param {type} options :{}
 * @param {type} callback
 * @param {type} file :actions
 * @returns {unresolved}
 *
 */
Ajax.prototype._here = function(data, callback, file) {
    if (file == null) {
        file = "actions";
    }

    if (ins(this.o)._is_exists()) {
        var options = ins(this.o)._getdata();
    } else {
        var options = ins()._data._get_page_data();
    }

    Object.keys(data).forEach(function(k) {
        options[k] = data[k];
    });

    options.myname = options["_myname"];
    options.root = "true";
    options.get_file = options["_mypath"] + "/ajax/" + file;
    if (ins(options.lang)._is_empty()) {
        options.lang = ins("body")._getdata("lang");
    }

    url = "/ins_ajax.php";
    return this._post({
        url: url,
        options: options,
        callback: callback,
    });
};
Ajax.prototype._class = function(data, callback, addoptions = null) {
    options = ins()._data._get_page_data();

    if (ins(addoptions)._is_exists()) {
        Object.keys(addoptions).forEach(function(k) {
            options[k] = addoptions[k];
        });
    }

    Object.keys(data).forEach(function(k) {
        options[k] = data[k];
    });
    options.get_file = "eng/get_class_ajax";
    url = "/ins_ajax.php";

    if (ins(options.status)._is_empty()) {
        options.status = this.o;
    }

    if (ins(options.lang)._is_empty()) {
        options.lang = ins("body")._getdata("lang");
    }

    return this._post({
        url: url,
        options: options,
        callback: callback,
    });
};

Ajax.prototype._url_to_lightbox = function(t) {
    var o = ins(t);
    var options = o._getdata();
    var url = this.o;

    return this._post({
        url: url,
        options: options,
        callback: function(data) {
            ins()._ui._lightbox_remove();
            ins()._ui._lightbox(
                o._getdata("lightbox_title"),
                data.trim(),
                "",
                o._getdata("lightbox_style"),
                "ins_lightbox" + o._getdata("status")
            );
            ins("ui")._ui._update_ui();

            if (ins(o._getdata("callback"))._is_exists()) {
                window[o._getdata("callback")](data, m);
            }
        },
    });
};

Ajax.prototype._to_lightbox = function(t) {
    var o = ins(t);
    var options = o._getdata();
    options.status = this.o;
    ins()._ajax._class(options, function(data) {
        ins()._ui._lightbox_remove();
        ins()._ui._lightbox(
            o._getdata("lightbox_title"),
            data.trim(),
            "",
            o._getdata("lightbox_style"),
            "ins_lightbox" + o._getdata("status")
        );
        ins("ui")._ui._update_ui();

        if (ins(o._getdata("callback"))._is_exists()) {
            window[o._getdata("callback")](data, m);
        }
    });
};

Ajax.prototype._to_container = function(t) {
    var o = ins(t);
    var options = o._getdata();
    options.status = this.o;

    ins()._ajax._class(options, function(data) {
        ins(o._getdata("container"))._sethtml(data.trim());
        ins("ui")._ui._update_ui();
        if (ins(o._getdata("callback"))._is_exists()) {
            window[o._getdata("callback")](data, m);
        }
    });
};

Ajax.prototype._update_core = function() {
    this._update_main(function() {}, "_render/core/", ".ins_table_data_area");
};

Ajax.prototype._update_main = function(done, addtourl = "", to = ".ins_main") {
    var url = ins()._data._getmainurl();
    url = ins()._data._addtourl(url, "/get_tmp_index/ins_main", addtourl);

    ins()._ui._addloader();

    return this._post({
        url: url,
        options: {},
        callback: function(data) {
            var d = ins()._ui._create("div");
            ins(d)._sethtml(data);

            var h = ins(d)._gethtml();

            if (to == ".ins_main") {
                h = "<div class='ins_mian_data'>" + h + "</div>";
            }
            ins(to)._sethtml(h);
            ins()._ui._removeloader();
            done();
        },
    });
};
Ajax.prototype._update_main_area = function(area, url, done) {
    if (ins(to)._is_empty()) url = "";
    return this._update_main(
        done,
        "/render_type/" + area + "/" + url,
        " .ins_" + area + "_area"
    );
};

Ajax.prototype._abort = function(ajax) {
    if (!ins(ajax)._data._exists()) {
        ajax = ins_jax;
    }
    if (ins(ajax)._data._exists()) {
        ajax.abort();
    }
    return this;
};
//</editor-fold>

function Drawing(o) {
    this.o = o;
}

/**
  * 
  * @param {type} o    
  *  var o = {
  1: {col: 6, row: 0, "data": "1 a", to: [{id: 6, "to": "right", c_x: 0, c_y: 1}]},
  2: {col: 5, row: 0, "data": "2 b", to: [6]},
  3: {col: 4, row: 0, "data": "3 c ", to: [{id: 6, c_x: 0, c_y: 0.5, "to": "left"}, 2, {id: 5, "from": "left", c_x: 1, c_y: 0}]},
  5: {col: 3, row: 1, "data": "e 5", to: [4, 6, {id: 8, to: "top", c_x: 1, c_y: 0.999}]},
  6: {col: 5, row: 1, "data": "f  6"},
  };
  
  * @param {type} get_options { 
  options.style : ' fill: #eef9fb,stroke: #73a5c8, stroke-width: 2px,  rx: 10,  ry: 10,  z-index: 4,',
  options.path_style : 'stroke-dasharray:6,stroke: #398ccb,stroke-width:1',options.path_head_style : 'fill:#398ccb',
  options.height : 50,options.width : 100,options.y : 0,options.x : 0, options.y_gap : 50,,options.x_gap : 50,
  }
  * @returns {this}
  */
Drawing.prototype._workflow = function(o, get_options = {}) {
    var options = {};

    options.style = "";
    options.path_style = "stroke-dasharray:6;stroke: #398ccb;stroke-width:1";
    options.path_head_style = "fill:#398ccb";
    options.height = 50;
    options.width = 100;
    options.y = 0;
    options.x = 0;
    options.y_gap = 50;
    options.x_gap = 50;
    options.class = "";
    // options.style = get_options.style ? get_options.style : options.style;

    options.class = get_options.class ? get_options.class : options.class;

    options.height = get_options.height ? get_options.height : options.height;
    options.width = get_options.width ? get_options.width : options.width;
    options.y_gap = get_options.y_gap ? get_options.y_gap : options.y_gap;
    options.x_gap = get_options.x_gap ? get_options.x_gap : options.x_gap;
    options.path_style = get_options.path_style ?
        get_options.path_style :
        options.path_style;
    options.path_head_style = get_options.path_head_style ?
        get_options.path_head_style :
        options.path_head_style;

    var svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
    svg.setAttributeNS(
        null,
        "style",
        "width:100%;height:100%;position: absolute;"
    );

    Object.keys(o).forEach(function(k) {
        a = o[k];

        a.width = a.width ? a.width : options.width;
        a.height = a.height ? a.height : options.height;
        a.class = a.class ? a.class : options.class;

        a.style = a.style ? a.style : options.style;
        a.col = a.col ? a.col : 0.001;
        a.row = a.row ? a.row : 0.001;

        a.x = options.x;
        a.y = (options.height + options.y_gap) * a.row;
        a.x = (a.width + options.x_gap) * a.col;

        const rect = document.createElementNS("http://www.w3.org/2000/svg", "rect");
        rect.setAttributeNS(null, "x", a.x);
        rect.setAttributeNS(null, "y", a.y);
        rect.setAttributeNS(null, "height", a.height);
        rect.setAttributeNS(null, "width", a.width);
        //    rect.setAttributeNS(null, 'style', a.style);
        rect.setAttributeNS(null, "class", a.class);

        svg.appendChild(rect);

        const foreign = document.createElementNS(
            "http://www.w3.org/2000/svg",
            "foreignObject"
        );
        foreign.setAttributeNS(null, "id", "_id_" + a.id);

        foreign.setAttributeNS(null, "x", a.x);
        foreign.setAttributeNS(null, "y", a.y);
        foreign.setAttributeNS(null, "height", a.height);
        foreign.setAttributeNS(null, "width", a.width);
        //   foreign.setAttributeNS(null, 'style', a.style);
        foreign.setAttributeNS(null, "class", a.class);

        foreign.setAttributeNS(null, "data-d", JSON.stringify(a));

        foreign.innerHTML =
            '<div style="width: 100%;text-align: center;position: RELATIVE;">' +
            a.data +
            "</div>";
        svg.appendChild(foreign);

        ins(foreign)._event("click", function(o, ev) {
            if (ins(a.onclick)._is_exists()) {
                a.onclick(o, ev);
            }
        });
    });

    //  var l = "";
    Object.keys(o).forEach(function(k) {
        from_object = o[k];
        if (ins(from_object.to)._is_exists()) {
            from_object.to.forEach(function(to) {
                var to_options = {};

                if (typeof to === "object") {
                    t = to.id;
                    to_options = to;
                } else {
                    t = to;
                }

                var to_obejct = o[t];
                if (ins(to_obejct)._is_exists()) {
                    var from_x = from_object.x + from_object.width / 2;
                    var from_y = from_object.y + from_object.height / 2;
                    var to_x = to_obejct.x + to_obejct.width / 2;
                    var to_y = to_obejct.y + to_obejct.height / 2;
                    var arrawstyle = "M 0 0 L 10 5 L 0 10 z";
                    var c_y = 0.999;
                    var c_x = 0.999;

                    if (parseInt(to_obejct.row) > parseInt(from_object.row)) {
                        if (!ins(to_options.from)._is_exists()) {
                            to_options.from = "bottom";
                        }
                        if (!ins(to_options.to)._is_exists()) {
                            to_options.to = "top";
                        }
                    } else if (parseInt(to_obejct.row) < parseInt(from_object.row)) {
                        if (!ins(to_options.from)._is_exists()) {
                            to_options.from = "top";
                        }

                        if (!ins(to_options.to)._is_exists()) {
                            to_options.to = "bottom";
                        }
                    }

                    if (parseInt(to_obejct.row) == parseInt(from_object.row)) {
                        if (parseInt(to_obejct.col) < parseInt(from_object.col)) {
                            if (!ins(to_options.from)._is_exists()) {
                                to_options.from = "left";
                            }
                            if (!ins(to_options.to)._is_exists()) {
                                to_options.to = "right";
                            }
                        } else if (parseInt(to_obejct.col) > parseInt(from_object.col)) {
                            if (!ins(to_options.from)._is_exists()) {
                                to_options.from = "right";
                            }
                            if (!ins(to_options.to)._is_exists()) {
                                to_options.to = "left";
                            }
                        }
                    }

                    if (ins(to_options.from)._is_exists()) {
                        if (to_options.from == "top") {
                            from_y = from_object.y;
                            from_x = from_object.x + from_object.width / 2;
                        } else if (to_options.from == "right") {
                            from_x = from_object.x + from_object.width;
                            from_y = from_object.y + from_object.height / 2;
                        } else if (to_options.from == "left") {
                            from_y = from_object.y + from_object.height / 2;
                            from_x = from_object.x;
                        } else if (to_options.from == "bottom") {
                            from_y = from_object.y + from_object.height;
                            from_x = from_object.x + from_object.width / 2;
                        }
                    }

                    if (ins(to_options.to)._is_exists()) {
                        if (to_options.to == "top") {
                            to_y = to_obejct.y - 10;
                            to_x = to_obejct.x + to_obejct.width / 2;
                        } else if (to_options.to == "right") {
                            to_x = to_obejct.x + to_obejct.width + 10;
                            to_y = to_obejct.y + to_obejct.height / 2;
                        } else if (to_options.to == "left") {
                            to_y = to_obejct.y + to_obejct.height / 2;
                            to_x = to_obejct.x - 10;
                        } else if (to_options.to == "bottom") {
                            to_y = to_obejct.y + to_obejct.height + 10;
                            to_x = to_obejct.x + to_obejct.width / 2;
                        }
                    }

                    if (ins(to_options.c_y)._is_exists()) {
                        c_y = parseFloat(to_options.c_y);
                    }

                    if (ins(to_options.c_x)._is_exists()) {
                        c_x = parseFloat(to_options.c_x);
                    }

                    var vy = to_y - from_y;
                    c_y = vy * c_y;
                    c_y = c_y + from_y;

                    var vx = to_x - from_x;
                    c_x = vx * c_x;
                    c_x = c_x + from_x;

                    var l_id = "_" + t + "_" + k;

                    const defs = document.createElementNS(
                        "http://www.w3.org/2000/svg",
                        "defs"
                    );
                    defs.innerHTML =
                        ' \n\
                        <marker id="arrow' +
                        l_id +
                        '"    markerWidth="10" markerHeight="10" refX="1" refY="5"  orient="auto" markerUnits="strokeWidth">\n\
                        <path d="' +
                        arrawstyle +
                        '"    style="' +
                        options.path_head_style +
                        '" /> \n\
                        </marker> \n\
                      ';

                    svg.appendChild(defs);

                    const path = document.createElementNS(
                        "http://www.w3.org/2000/svg",
                        "path"
                    );
                    path.setAttributeNS(
                        null,
                        "d",
                        "M" +
                        from_x +
                        "," +
                        from_y +
                        "  L" +
                        c_x +
                        "," +
                        c_y +
                        "    L" +
                        to_x +
                        "," +
                        to_y
                    );
                    path.setAttributeNS(null, "fill", "none");
                    path.setAttributeNS(null, "style", options.path_style);
                    path.setAttributeNS(null, "marker-end", "url(#arrow" + l_id + ")");

                    if (ins(to.title)._is_exists()) {
                        path.setAttributeNS(null, "title", to.title);
                    }

                    svg.appendChild(path);
                }
            });
        }
    });

    ins(this.o)._get(0).appendChild(svg);
    return ins(this.o);
};

//<editor-fold defaultstate="collapsed" desc="mian">
/**start_here */
function INS(o) {
    this.o = o;
    this._ui = new UI(o);
    this._drawing = new Drawing(o);
    this._ajax = new Ajax(o);
    this._data = new Data(o);
    this._animation = new Animation(o);
    this._charts = new Charts(o);
    this._app = new App(o);
    this._map = new InsMap(o);
    this._db = new InsDB(o);

    /* window.attachEvent('onload', function () {
          ins()._ui._update_ui();
          });*/
    this._load = function() {
        if (window.addEventListener) {
            // W3C standard
            window.addEventListener("load", this.o, false); // NB **not** 'onload'
        } else if (window.attachEvent) {
            // Microsoft
            window.attachEvent("onload", this.o);
        }
        return this.o;
    };
    this._get = function(n, p) {
        let evo = [];
        if (typeof this.o === "string") {
            if (p) {
                evo = window.parent.document.querySelectorAll(this.o);
            } else {
                evo = document.querySelectorAll(this.o);
            }
        } else if (this.o === document) {
            evo = [document];
        } else {
            if (this.o instanceof NodeList) {
                evo = this.o;
            } else if (this.o instanceof INS) {
                evo = this.o._get();
            } else {
                evo = [this.o];
            }
        }

        if (n != null) {
            return evo[n];
        } else {
            return evo;
        }
    };
    this._each = function(fun) {
        if (ins(this._get())._is_exists()) {
            this._get().forEach(function(item, indx) {
                fun(ins(item), indx);
            });
        }
    };
}
INS.prototype._index = function(num, isparent) {
    return ins(this._get(num, isparent));
};

INS.prototype._toggle_class = function(actclass) {
    var o = ins(this.o);

    if (o._hasclass(actclass)) {
        this._removeclass(actclass);
    } else {
        this._addclass(actclass);
    }
};

INS.prototype._p = function(prop, value) {
    var r = [];

    var l = this._get().length;

    this._get().forEach(function(item, indx) {
        if (ins(value)._is_empty()) {
            if (l === 1) {
                r = item[prop];
            } else {
                r.push(item[prop]);
            }
        } else {
            item[prop] = value;
            r.push(value);
        }
    });
    return r;
};

var jsupdated = [];

INS.prototype._onload = function(callback) {
    if (!updated.includes(this.o)) {
        var script = document.createElement("script");
        script.src = this.o;
        script.onload = function(e) {
            callback("done");
            updated.push(this.o);
        };
        document.head.appendChild(script);

        return ins(script);
    } else {
        callback("esxit");
        return null;
    }
};

INS.prototype._document_event = function(event, callback, useCapture) {
    document.addEventListener(
        event,
        function(e) {
            callback(e);
        },
        useCapture
    );
    return this;
};

INS.prototype._event = function(event, callback, useCapture) {
    if (ins(useCapture)._is_empty()) useCapture = false;
    this._get().forEach(function(item, indx) {
        item.addEventListener(
            event,
            (e) => {
                callback(ins(item), e);
            },
            useCapture
        );
    });
    return this;
};
INS.prototype._on = function(event, callback, ps, useCapture) {
    var o = this;
    var os = this.o;

    if (ins(useCapture)._is_empty()) useCapture = false;
    document.addEventListener(
        event,
        function(e) {
            o._get().forEach(function(item) {
                if (e.target === item) {
                    callback(ins(e.target), e, item);
                } else if (ps && ins(ins(e.target)._parents(os).o)._is_exists()) {
                    if (ins(e.target)._parents(os)._get(0) === item) {
                        callback(ins(item), e, item);
                    }
                }
            });
        },
        useCapture
    );
    return this;
};

INS.prototype._darg = function(options) {
    var t = ins(this._get(0));
    if (ins(options.hander)._is_exists()) {
        var h = ins(t._find(options.hander));
        h._on(
            "mousedown",
            function() {
                t._setattr("draggable", "true");
            },
            true
        );

        ins(document)._on("mouseup", function() {}, true);

        t._on(
            "dragend",
            function(o, ev) {
                t._removeattr("draggable");
                if (ins(options.ondragend)._is_exists()) {
                    options.ondragend(o, ev);
                }
            },
            true
        );
    } else {
        t._setattr("draggable", "true");
    }

    this._on(
        "dragstart",
        function(o, ev) {
            if (ins(options.ondragstart)._is_exists()) {
                options.ondragstart(o, ev);
            }
        },
        true
    );
};

INS.prototype._drop = function(options) {
    var t = this;
    t._event("drop", function(o, ev) {
        ev.preventDefault();
        if (ins(options.ondrop)._is_exists()) {
            options.ondrop(o, ev);
        }
    });
    t._event("dragover", function(o, ev) {
        ev.preventDefault();
        if (ins(options.ondragover)._is_exists()) {
            options.ondragover(o, ev);
        }
    });
};

INS.prototype._toggle_show = function() {
    if (this._hasclass("ins_hidden")) {
        this._removeclass("ins_hidden");
    } else {
        this._addclass("ins_hidden");
    }
};

INS.prototype._toggle = function(...fns) {
    var i = 0;
    this._on("click", function(obj, event) {
        if (i >= fns.length) {
            i = 0;
        }
        if (!ins(fns[i])._is_empty()) {
            fns[i](obj, event);
        }
        i++;
    });
};
INS.prototype._exists = function(i = false) {
    if (i === true) {
        return !(
            typeof ins(this.o)._get(0) === "undefined" || ins(this.o)._get(0) === null
        );
    } else {
        return !(typeof this.o === "undefined" || this.o === null);
    }
};
INS.prototype._empty = function() {
    return typeof this.o === "undefined" || this.o === null || this.o === "";
};
INS.prototype._is_exists = function(i = false) {
    if (i === true) {
        return !(
            typeof ins(this.o)._get(0) === "undefined" || ins(this.o)._get(0) === null
        );
    } else {
        return !(typeof this.o === "undefined" || this.o === null);
    }
};
INS.prototype._is_empty = function() {
    return typeof this.o === "undefined" || this.o === null || this.o === "";
};
INS.prototype._remove = function(callback) {
    this._get().forEach(function(item) {
        item.remove(item.selectedIndex);
    });
    if (!ins(callback)._is_empty()) {
        window[callback](this);
    }
};
INS.prototype._find = function(o) {
    var r = null;

    if (this._get(0) != null) {
        if (this._get(0).querySelectorAll(o).length > 0) {
            r = ins(this._get(0).querySelectorAll(o));
        }
    }
    return r;
};

INS.prototype._getchild_bytag = function(tag) {
    var item = null;
    for (var i = 0; i < this._get(0).childNodes.length; i++) {
        if (this._get(0).childNodes[i].tagName === tag) {
            item = ins(this._get(0).childNodes[i]);
            break;
        }
    }
    return item;
};

/**
 *
 * @returns {Array[node]}
 */
INS.prototype._getchildren = function() {
    var r = [];
    for (var i = 0; i < this._get(0).childNodes.length; i++) {
        r[i] = this._get(0).childNodes[i];
    }

    return r;
};

INS.prototype._getindex = function(data) {
    var o = this._get(0);
    var p = o.parentElement;
    var r = [];
    for (var i = 0; i < p.childNodes.length; i++) {
        r[i] = p.childNodes[i];
    }
    return r.indexOf(o);
};

INS.prototype._is_in_childs = function(target) {
    var r = false;
    if (ins(this._get(0).childNodes)._is_exists()) {
        var ch = this._getchilds();
        if (ch.length > 0) {
            for (var i = 0; i < ch.length; i++) {
                if (!r) {
                    var mo = ch[i];

                    if (mo == target) {
                        r = true;
                        continue;
                    } else {
                        r = ins(mo)._is_in_childs(target);
                        if (r) {
                            continue;
                        }
                    }
                }
            }
        }
    }
    return r;
};
INS.prototype._getchild_byclass = function(classname) {
    var item = null;
    for (var i = 0; i < this._get(0).childNodes.length; i++) {
        if (ins(this._get(0).childNodes[i].classList)._is_exists()) {
            if (this._get(0).childNodes[i].classList.contains(classname)) {
                item = ins(this._get(0).childNodes[i]);
                break;
            }
        }
    }
    return item;
};

INS.prototype._equal = function(o) {
    return this._get(0) === this._getobj(o);
};

INS.prototype._parent = function() {
    return ins(this._get(0).parentElement);
};
INS.prototype._getparent = function() {
    return ins(this._get(0).parentElement);
};
INS.prototype._height = function() {
    return this._get(0).offsetHeight;
};
INS.prototype._parents = function(v) {
    var get_item = null;
    if (!ins(v)._is_empty()) {
        get_item = ins(v)._get();
    }
    var a = this._get(0).parentNode;
    var els = [];
    while (a) {
        els.unshift(a);
        if (get_item != null) {
            get_item.forEach(function(iemt) {
                if (iemt == a) {
                    els = ins(iemt);
                    a = null;
                }
            });
        }

        if (a == null) {
            continue;
        } else {
            a = a.parentNode;
        }
    }

    return els;
};
INS.prototype._getattr = function(type) {
    return this._get(0).getAttribute(type);
};
INS.prototype._setattr = function(type, value) {
    this._get().forEach(function(item, indx) {
        item.setAttribute(type, value);
    });
    return this;
};
INS.prototype._removeattr = function(type) {
    this._get().forEach(function(item) {
        item.removeAttribute(type);
    });
    return this;
};
INS.prototype._setscroll = function(value) {
    this._get().forEach(function(item, indx) {
        item.scrollTop = value;
    });
    return this;
};
/**
 *
 * @param {type} type
 * @returns {r|data|obj|r@call;_get@arr;dataset|String|Date|$}
 */
INS.prototype._getdata = function(type = "") {
    let r = "";
    if (ins(this._get(0))._is_exists()) {
        if (type === "") {
            r = {};
            Object.assign(r, this._get(0).dataset);
        } else {
            r = this._get(0).dataset[type];
        }
    }

    return r;
};
INS.prototype._setdata = function(type, value) {
    this._get().forEach(function(item, indx) {
        item.dataset[type] = value;
    });
    return this;
};

INS.prototype._getvalue = function() {
    var r = null;
    if (ins(this._get()[0])._is_exists()) {
        if (ins(this._get(0).getAttribute("multiple"))._is_exists()) {
            r = [];
            for (var i = 0; i < this._get(0).options.length; i++) {
                if (this._get(0).options[i].selected)
                    r.push(this._get(0).options[i].value);
            }
        } else {
            r = this._get()[0].value;
        }
    }
    return r;
};
INS.prototype._setvalue = function(value) {
    this._get().forEach(function(item, indx) {
        if (ins(item.getAttribute("multiple"))._is_exists()) {
            for (var i = 0; i < item.options.length; i++) {
                if (value.indexOf(item.options[i].value) > -1)
                    item.options[i].selected = true;
            }
        } else {
            item.value = value;
        }
    });
    return this;
};
INS.prototype._gethtml = function() {
    return this._get(0).innerHTML;
};
INS.prototype._getouterhtml = function() {
    return this._get(0).outerHTML;
};

INS.prototype._sethtml = function(value) {
    this._get().forEach(function(item, indx) {
        item.innerHTML = value;
    });
    return this;
};

INS.prototype._getobj = function(data) {
    if (typeof data === "string") {
        var c = ins()._ui._create("div", "", "", data);
        r = c.children[0];
    } else if (data instanceof INS) {
        r = data._get(0);
    } else {
        r = data;
    }

    return r;
};

INS.prototype._clone = function() {
    var r = null;
    if (typeof this.o === "string") {
        var c = ins()._ui._create("div", "", "", this.o);
        r = c.children[0];
    } else if (this.o instanceof INS) {
        r = this.o._get(0).cloneNode(true);
    } else if (ins(this.o)._is_exists()) {
        r = this.o.cloneNode(true);
    }
    return ins(r);
};

INS.prototype._append = function(data) {
    var r = this._getobj(data);
    this._get().forEach(function(item, indx) {
        item.appendChild(r);
    });

    return ins(r);
};
INS.prototype._append_befor = function(data) {
    var r = this._getobj(data);
    this._get().forEach(function(item, indx) {
        item.parentNode.insertBefore(r, item);
    });
    return ins(r);
};
INS.prototype._append_after = function(data) {
    var r = this._getobj(data);
    this._get().forEach(function(item, indx) {
        item.parentNode.insertBefore(r, item.nextSibling);
    });
    return ins(r);
};
INS.prototype._gettext = function() {
    if (ins(this._get(0))._is_exists()) {
        return this._get(0).innerText;
    }
};
INS.prototype._settext = function(value) {
    this._get().forEach(function(item, indx) {
        if (ins(item)._is_exists()) {
            item.innerText = value;
        }
    });
    return this;
};
INS.prototype._addclass = function(...addClass) {
    this._get().forEach(function(item, indx) {
        if (ins(item)._is_exists() && !ins(addClass[0])._is_empty()) {
            item.classList.add(...addClass);
        }
    });
    return this;
};
INS.prototype._removeclass = function(...removeClass) {
    this._get().forEach(function(item, indx) {
        if (ins(item)._is_exists() && !ins(removeClass[0])._is_empty()) {
            item.classList.remove(...removeClass);
        }
    });
    return this;
};
INS.prototype._hasclass = function(value) {
    var r = false;
    this._get().forEach(function(item, indx) {
        if (item.classList.contains(value)) {
            r = true;
        }
    });
    return r;
};
INS.prototype._getclasses = function(sp = null, not = []) {
    var r = {};
    this._get().forEach(function(item) {
        if (!ins(item.classList)._is_empty()) {
            Object.assign(r, item.classList);

            if (sp !== null) {
                var tmp = "";
                Object.keys(r).forEach(function(c) {
                    if (not.indexOf(r[c]) == -1) {
                        tmp += sp + r[c];
                    }
                });

                r = tmp;
            }
        }
    });
    return r;
};
INS.prototype._removecss = function(value) {
    var r = false;
    this._get().forEach(function(item) {
        item.style.removeProperty(value);
    });
    return r;
};
INS.prototype._getcss = function(name) {
    var r = "";
    this._get().forEach(function(item) {
        if (Array.isArray(name)) {
            r = {};
            name.forEach(function(n) {
                if (item.style.getPropertyValue(n) !== "") {
                    r[n] = item.style.getPropertyValue(n);
                }
            });
        } else {
            r = item.style.getPropertyValue(name);
        }
    });
    return r;
};
INS.prototype._css = function(css, value = "") {
    this._get().forEach(function(item) {
        if (value !== "") {
            item.style[css] = value;
        } else {
            for (var name in css) {
                if (ins(item)._is_exists()) {
                    item.style[name] = css[name];
                }
            }
        }
    });
    return this;
};
INS.prototype._reload = function(url = "") {
    if (url != "") {
        window.location = url;
    } else {
        window.location.reload();
    }
};

INS.prototype._get_lang = function() {
    var l = ins("body")._getdata("lang");
    return ins("body")._getdata("lang");
};
INS.prototype._is_lang = function() {
    return this.o == ins("body")._getdata("lang");
};

INS.prototype._o = function(o) {
    this.o = o;
    return this._get();
};

INS.prototype._plgin = function(Options, onReady) {
    var t = this;
    var plg = this.o;
    try {
        return ins("/ins_lib/js/lib/plgins/" + plg + ".js")._onload(function(
            stat
        ) {
            var cls = eval(`new ${plg}(Options)`);
            cls._out();
            onReady(cls);
        });
    } catch (err) {}
};

function ins(o) {
    return new INS(o);
}
ins(function() {
    ins()._ui._update_ui();
})._load();