/* global ins, options */
function labels_actions(options, acdone) {
  options.type = ins(".labels_area_filter")._getdata("type");
  options.root = "true";
  options.get_file = "/ins_ajax/pages/labels";
  return ins()._ajax._send("/ins_ajax.php", options, "POST", acdone);
}

function _mian() {
  ins()._ajax._update_main(function () {
    if (ins(".ins_main .filter_labels")._is_exists(true)) {
      if (ins(".ins_main .filter_labels")._get().length > 0) {
        update_labels();
      }
    }
  });
}

function update_label_tds(o) {
  var options = {
    status: "update_obj",
    obj_id: o._getdata("obj_id"),
    obj_type: o._getdata("obj_type"),
  };
  labels_actions(options, function (data) {
    o._sethtml(data);
  });
}

function update_labels() {
  labels_actions({ status: "get_labels" }, function (data) {
    ins(".labels_area_filter")._sethtml(data);
    ins(".tag_item")._setattr("draggable", "true");
  });
  ins(".labels_area")._each(function (o) {
    update_label_tds(o);
  });
}

function list_multi_update(mode, e) {
  var ids = "";
  var table = ins()._data._page_data().table;
  var m = "";
  ins(".check_list_ids:checked")._each(function (e) {
    ids += m + e._getvalue();
    m = ",";
  });
  if (ids == "") {
    alert("no items chosen");
  } else {
    var c = { mode: mode, ids: ids, table: table };

    if (ins(e._getdata("c" + mode))._is_exists()) {
      c.type = "call";
      window[e._getdata("c" + mode)](ids, c);
    } else {
      if (ins(e._getdata("b" + mode))._is_exists()) {
        c.type = "callbefor";
        window[e._getdata("b" + mode)](ids, c);
      }

      var options = {
        get_file: "pages/list",
        mode: mode,
        ids: ids,
        table: table,
      };

      if (ins(e._getdata("co" + mode))._is_exists()) {
        c.type = "condition";
        if (window[e._getdata("a" + mode)](ids, c)) {
          return ins()._ajax._send(
            "/ins_ajax.php",
            options,
            "POST",
            function () {
              if (ins(e._getdata("a" + mode))._is_exists()) {
                c.type = "callafter";
                window[e._getdata("a" + mode)](ids, c);
              }

              _mian();
            }
          );
        }
      } else {
        return ins()._ajax._send("/ins_ajax.php", options, "POST", function () {
          if (ins(e._getdata("a" + mode))._is_exists()) {
            c.type = "callafter";
            window[e._getdata("a" + mode)](ids, c);
          }

          _mian();
        });
      }
    }
  }
}

//<editor-fold defaultstate="collapsed" desc="Labels">

// if (ins(".labels_area_filter")._get().length > 0) {
ins(".delete_from_obj")._on("click", function (o) {
  let oid = o._getdata("objid");
  var options = {
    id: o._getdata("id"),
    status: "delete_from_obj",
    obj_id: oid,
  };
  labels_actions(options, function () {
    var l = ins('.labels_area[data-obj_id="' + oid + '"]');
    update_label_tds(l);
  });
});
ins(".get_settings")._on("click", function (e) {
  var options = { id: e._getdata("id"), status: "edit" };
  labels_actions(options, function (data) {
    ins()._ui._lightbox("Edit Label", data, null, {
      width: "300px;",
      height: "300px;",
    });
  });
});
ins(".mod_labels_add")._on("click", function () {
  labels_actions({ status: "add" }, function (data) {
    ins()._ui._lightbox("Add Label", data, null, {
      width: "300px;",
      height: "300px;",
    });
  });
});
var t_obj = null;
ins(".tag_item")._on("dragstart", function (e, v) {
  v.dataTransfer.setData("id", e._getdata("id"));
  v.dataTransfer.setData("obj", e);
  t_obj = e;
  e._css({ opacity: "0.5" });
});
ins(document)._event("dragend", function (e, v) {
  if (t_obj !== null) {
    t_obj._css({ opacity: "1" });
    t_obj = null;
  }
});
ins(".labels_area")._on("dragleave", function (e, v) {
  e._css({ background: "transparent" });
});
ins(".labels_area")._on("dragover", function (e, v) {
  v.preventDefault();
  e._css({ background: "#ff8040" });
});
ins(".labels_area")._on("drop", function (o, e) {
  e.preventDefault();
  o._css({ background: "transparent" });
  if (t_obj !== null) {
    t_obj._css({ opacity: "1" });
    t_obj = null;
  }
  var options = {
    status: "add_to_obj",
    label_id: e.dataTransfer.getData("id"),
    obj_id: o._getdata("obj_id"),
    obj_type: o._getdata("obj_type"),
  };
  labels_actions(options, function (data) {
    update_label_tds(o);
  });
});
ins(".mod_labels_form")._on("submit", function (o, event) {
  event.preventDefault();
  labels_actions(o._data._get_inputs(), function (data) {
    ins(".labels_area_filter")._sethtml(data);
    ins()._ui._lightbox_remove();
  });
});
ins(".mod_labels_delete")._on("click", function (o) {
  var options = { id: o._getdata("id"), status: "delete" };
  labels_actions(options, function (data) {
    ins(".labels_area_filter")._sethtml(data);
    ins()._ui._lightbox_remove();
  });
});
//  }
//</editor-fold>

ins(".list_get_history")._on(
  "click",
  function (t) {
    var options = t._getdata();

    options.root = "true";
    options.get_file = "/ins_ajax/db/sys_history";
    return ins()._ajax._send("/ins_ajax.php", options, "POST", function (data) {
      ins()._ui._lightbox("History", data, null, 'width:550px;');
    });
  },
  true
);

ins(".sys_history_show_hide_data")._on(
  "click",
  function (t) {
    ins("." + t._getdata("sys_history_data"))._toggle_class(
      "sys_history_data_show"
    );
  },
  true
);

//<editor-fold defaultstate="collapsed" desc="grip list">

var gripstar = 0;
var gripp = null;
var gripsize = 0;
var gripoldclass = "";
var grapoffest = 50;
var gripLimit = 10;

function getth_size() {
  var thissize = 0;
  gripp
    ._parent()
    ._find(".ins_th")
    ._each(function (o) {
      var ac = ins(o)._getattr("class").split(" ");
      for (i = 0; i < ac.length; i++) {
        if (ac[i].search("ins_col_") > -1) {
          thissize += parseFloat(parseInt(ac[i].replace("ins_col_", "")));
        }
      }
    });
  return thissize;
}
ins(".ins_table_data_area .ins_th .ins_grip")._on(
  "mousedown",
  function (o, e) {
    gripstar = e.clientX;
    gripp = o._parent()._parent();
    var ac = ins(gripp)._getattr("class").split(" ");
    for (i = 0; i < ac.length; i++) {
      if (ac[i].search("ins_col_") > -1) {
        gripsize = parseInt(ac[i].replace("ins_col_", ""));
        gripoldclass = ac[i];
      }
    }

    gripLimit = 24 - getth_size();
    gripLimit += gripsize;
    grapoffest = ins(gripp)._get(0).offsetWidth / gripsize;
    grapoffest -= 5;
    document.documentElement.addEventListener("mousemove", doDrag, false);
    document.documentElement.addEventListener("mouseup", stopDrag, false);
    ins("body")._css({ cursor: "col-resize" });
  },
  true
);

function grip_update_p() {
  gripp_tr = gripp
    ._parent()
    ._parent()
    ._find(".ins_td._" + gripp._getdata("k"));
  gripp._removeclass(gripoldclass);
  gripp_tr._removeclass(gripoldclass);
  gripoldclass = "ins_col_" + gripsize;
  gripp._addclass(gripoldclass);
  gripp_tr._addclass(gripoldclass);
}

function doDrag(e) {
  width = e.clientX - gripstar;
  ins(".ins_table_data_area .ins_th .ins_grip")._getcss();

  if (width >= grapoffest) {
    if (gripLimit > gripsize) {
      gripsize++;
      gripstar = width + gripstar;
      grip_update_p();
    }
  } else if (width <= -grapoffest) {
    if (gripsize > 1) {
      gripsize--;
      gripstar = width + gripstar;
      grip_update_p();
    }
  }
}

function stopDrag(e) {
  grip_update_seetings(gripp._parent());
  gripstar = 0;
  gripp = null;
  gripsize = 0;
  gripoldclass = "";
  grapoffest = 50;
  ins("body")._css({ cursor: "default" });
  document.documentElement.removeEventListener("mousemove", doDrag, false);
  document.documentElement.removeEventListener("mouseup", stopDrag, false);
}

//</editor-fold>

function grip_update_seetings(header) {
  var options = {};
  header._find(".ins_th")._each(function (o) {
    if (ins(o._getdata("k"))._is_exists()) {
      var k = o._getdata("k");
      var ac = o._getattr("class").split(" ");
      var dataClass = " ";
      for (i = 0; i < ac.length; i++) {
        if (
          ac[i] != "ins_th" &&
          ac[i].search("_roder") == -1 &&
          ac[i].search("_" + k) == -1
        ) {
          dataClass += " " + ac[i];
        }
      }
      options[k] = { class: dataClass };
    }
  });
  var list = JSON.stringify(options);
  var app = ins()._data._get_page_data()._myname;
  ins("_list_update")._ajax._class(
    { list: list, app: app },
    function (data) {},
    {
      _mypath: "ins_plgs/plg_custom_fields/",
      _myname: "plg_custom_fields",
    }
  );
}
ins(".ins_block_list_swtitch")._on(
  "click",
  function (e) {
    var t = ins(".ins_view_body");

    if (t._hasclass("ins_table_cards")) {
      t._removeclass("ins_table_cards");
      ins(".ins_block_list_swtitch i")._addclass("fa-th-large");

      ins(".ins_block_list_swtitch i")._removeclass("fa-table");
    } else {
      t._addclass("ins_table_cards");

      ins(".ins_block_list_swtitch i")._addclass("fa-table");

      ins(".ins_block_list_swtitch i")._removeclass("fa-th-large");
    }
  },
  true
);

ins(function () {
  ins(".ins_table_data_area .ins_thead")._ui._order({
    hander: ".ins_list_move",
    ondone: function (drop_obejct, drag_object) {
      drop_obejct = ins(drop_obejct);
      drag_object = ins(drag_object);
      grip_update_seetings(drop_obejct._parent());

      var drag_object_k = drag_object._getdata("k");
      var drop_obejct_k = drop_obejct._getdata("k");

      drop_obejct
        ._parents(".ins_table")
        ._find(".ins_tr")
        ._each(function (o) {
          if (ins(o._find(".ins_td._" + drop_obejct_k))._is_exists()) {
            o._find(".ins_td._" + drop_obejct_k)._append_befor(
              o._find(".ins_td._" + drag_object_k)
            );
          }
        });
    },
  });

  ins(".ui_editable_select  .ins_btn_add ")._on("click", function (e) {
    var t = e._parent()._find(".ins_tooltip");
    if (t._hasclass("ins_hidden")) {
      t._removeclass("ins_hidden");
    } else {
      t._addclass("ins_hidden");
    }
  });

  ins(".ins_th.rows_select ,.ins_th.rows_select *")._toggle(
    function () {
      ins(".check_list_ids")._setattr("checked", true);
    },
    function () {
      ins(".check_list_ids")._removeattr("checked");
    }
  );

  ins(".list_multi_update")._on(
    "click",
    function (e) {
      var mode = e._getdata("mode");
      if (ins(mode)._is_empty()) {
        mode = e._getparent()._getdata("mode");
      }

      if (!ins(e._getdata("jsconfirm"))._is_empty()) {
        if (confirm(e._getdata("jsconfirm"))) {
          list_multi_update(mode, e);
        }
      } else {
        list_multi_update(mode, e);
      }
    },
    true
  );

  ins(".list_status_update")._on(
    "click",
    function (e) {
      var mode = e._getdata("mode");
      var ids = "";
      if (!ins(e._getdata("jsconfirm"))._is_empty()) {
        if (confirm(e._getdata("jsconfirm"))) {
          if (!ins(e._getdata("ids"))._is_empty()) {
            ids = e._getdata("ids");
          }
          var table = ins()._data._page_data().table;
          var options = {
            get_file: "pages/list",
            mode: mode,
            ids: ids,
            table: table,
          };
          return ins()._ajax._send(
            "/ins_ajax.php",
            options,
            "POST",
            function () {
              _mian();
            }
          );
        }
      } else {
        if (!ins(e._getdata("ids"))._is_empty()) {
          ids = e._getdata("ids");
        }
        var table = ins()._data._page_data().table;
        var options = {
          get_file: "pages/list",
          mode: mode,
          ids: ids,
          table: table,
        };
        return ins()._ajax._send("/ins_ajax.php", options, "POST", function () {
          _mian();
        });
      }
    },
    true
  );
  ins(".ins_pages_select")._on("change", function (e) {
    window.location = ins()._data._addtourl(
      e._getdata("url"),
      "/page/" + e._getvalue() + "/"
    );
  });
  ins(".list_limit_option")._on("change", function (o) {
    ins()._data._set_session(o._getdata("jsname"), o._getvalue(), function () {
      window.location.reload();
    });
  });
  ins(".dropdown-toggle,.dropdown-toggle i")._toggle(
    function () {
      ins(".dropdown-menu")._css({ display: "block" });
    },
    function () {
      ins(".dropdown-menu")._css({ display: "none" });
    }
  );
  //</editor-fold>

  //<editor-fold defaultstate="collapsed" desc="fliter">

  function updatefliter($this) {
    var f = "";
    var v = "";
    ins(".filter_item")._each(function (o) {
      if (o._getvalue() != "") {
        f += o._getattr("name") + ",";
        v += o._getvalue() + ",";
      }
    });

    if ($this._hasclass("bt_item_search")) {
      f += $this._getdata("filter_field") + ",";
      v += $this._getdata("filter_value") + ",";
    } else {
      if (!ins(ins(".filter_labels")._getdata("act_label"))._is_empty()) {
        f += "sys_labels,";
        v += ins(".filter_labels")._getdata("act_label") + ",";
      }
    }

    var u = ins(".ins_filter_bar")._getdata("url").split("do/");
    if (ins(".list_mode")._getdata("mode") == "ajax") {
      ins()._ajax._update_main_area(
        "table_data",
        u[0] + "do/filter/" + f + ";" + v + "/" + u[1]
      );
      ins()._ajax._update_main_area(
        "pagination",
        u[0] + "do/filter/" + f + ";" + v + "/" + u[1]
      );
    } else {
      window.location = u[0] + "do/filter/" + f + ";" + v + "/" + u[1];
    }
  }

  ins(".filter_item.oninput")._on("input", function (e) {
    updatefliter(e);
  });

  ins(".filter_item")._on("change", function (e) {
    updatefliter(e);
  });

  ins(".bt_item_search")._on("click", function (e) {
    updatefliter(e);
  });
  ins(".ins_mian_title")._on("click", function (e) {
    _mian();
  });

  //</editor-fold>

  ins(".ins_list_view_item")._on(
    "click",
    function (o) {
      var options = o._getdata();
      options.do = "show";
      if (o._hasclass("visabled")) {
        options.do = "hide";
        o._removeclass("visabled");
        o._find(".fas")._removeclass("fa-check");
        o._find(".fas")._addclass("fa-times");
      } else {
        o._addclass("visabled");
        o._find(".fas")._removeclass("fa-times");
        o._find(".fas")._addclass("fa-check");
      }

      ins("_list_update_item")._ajax._class(
        options,
        function (data) {
          ins()._ajax._update_core();
        },
        {
          _mypath: "ins_plgs/plg_custom_fields/",
          _myname: "plg_custom_fields",
        }
      );
    },
    true
  );

  if (ins(".labels_area_filter")._get().length > 0) {
    update_labels();
  }
})._load();
