<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace ins_lib\ui;

/**
 * Description of ui_html_utils
 *
 * @author ismail
 */
class ui_html_utils extends ui_editor
{

    var $d = [];

    protected function get($w)
    {


        $r = $this->d[$w] ? $this->d[$w] : "";

        if ($r != "") {
            $r = \lib::_data()->_lang_trans($r);
        }

        return $r;
    }

    protected function data_block($pro)
    {

        $h = "";
        foreach ($pro["data"] as $k => $v) {

            switch ($k) {
                case "image":

                    if (is_array($v)) {



                        if (!\lib::_files()->_is_file($v["src"]) || $v["src"] == "") {
                            $v["src"] = \lib::_app_map()->noimage;
                        }
                        $h .= "<div class='block_image'><img  " . $this->addAttrs($v) . "/></div>" . PHP_EOL;
                    } else {
                        /*  echo $v;
                          if (!\lib::_files()->_is_file($v) || $v["src"] == "") {
                          $v = \lib::_app_map()->noimage;
                          } */
                        $h .= "<div class='block_image'><img  src='$v?1=1'/></div>" . PHP_EOL;
                    }
                    break;
                case "url":

                    if (is_array($v)) {
                        $h = "<a " . $this->addAttrs($v) . " >$h</a>" . PHP_EOL;
                    } else {
                        $h = "<a href='$v'>$h</a>" . PHP_EOL;
                    }
                    break;
                case "title":
                    if (is_array($v)) {
                        $h .= "<h2 " . $this->addAttrs($v) . "/'>" . $v["data_value"] . "</h2>" . PHP_EOL;
                    } else {
                        $h .= "<h2 class='block_title'>$v</h2>" . PHP_EOL;
                    }
                    break;

                default:
                    if (is_array($v)) {
                        $h .= "<div " . $this->addAttrs($v) . "/'>" . $v["data_value"] . "</div>" . PHP_EOL;
                    } else {
                        $h .= "<div class='$k block_info'>$v</div>" . PHP_EOL;
                    }


                    break;
            }
        }


        $r = "<div  " . $this->getAttrs() . " class='block_data " . $this->get("class") . "'>"
            . "<div class='block_data_body'>$h</div>"
            . "</div>";
        return $r;
    }

    protected function getAttrs($input = false, $remove = [])
    {
        $r = "";
        $attr = $this->d;



        if (!$input) {
            unset($attr["type"]);
        }
        unset($attr["pclass"]);
        unset($attr["class"]);
        if (is_array($remove)) {
            foreach ($remove as $rmv) {

                unset($attr[$rmv]);
            }
        }
        $r = $this->addAttrs($attr, $remove);
        return $r;
    }

    protected function getAttrData($input = false, $remove = [])
    {
        $r = "";
        $attr = $this->d;



        if (!$input) {
            unset($attr["type"]);
        }
        if (is_array($remove)) {
            foreach ($remove as $rmv) {

                unset($attr[$rmv]);
            }
        }
        return $attr;
    }

    protected function addAttrs($attr, $remove)
    {
        $r = "";

        foreach ($attr as $k => $v) {


            if (!in_array($k, $remove)) {



                if ($attr["trans"] != "false") {
                    $v = \lib::_data()->_lang_trans($v);
                }

                $r .= " $k ='$v'";
            }
        }
        return $r;
    }

    protected function getPagination($pro)
    {
        $r = "";

        $hisPage = "1";




        $g = \lib::_eng()->_get();
        if (isset($g["page"])) {
            $hisPage = $g["page"];
        }

        //   $url = \lib::_eng()->_url(["page"]);

        $pages = ($pro["all"] / $pro["limit"]);

        $pages = ceil($pages);






        $ppage = $hisPage - 1;
        if ($ppage > 0) {

            $purl = \lib::_eng()->_url(["page" => $ppage]);
            $r .= $this->get_html(["type" => "a", "class" => "btn btn-default", "data" => '<i class="fa fa-angle-left" aria-hidden="true"></i>', "href" => $purl]);
        } else {
            $r .= $this->get_html(["type" => "a", "class" => "disbale btn", "data" => '<i class="fa fa-angle-left" aria-hidden="true"></i>', "href" => "#"]);
        }

        $op = [];
        for ($i = 1; $i <= $pages; $i++) {
            if ($hisPage == $i) {
                $more = "active";
            } else {
                $more = "";
            }

            $op[$i] = "  الى صفحة " . $i; // .= $this->get_html(["type" => "option", "value" => , "data" => ]);
        }


        $g = \lib::_eng()->_get();
        $mvalue = "";
        if (isset($g["page"])) {
            $mvalue = $g["page"];
        } else {
            $mvalue = "1";
        }



        $r .= $this->get_html(["type" => "select", "value" => $mvalue, "data-url" => \lib::_eng()->_url([], ["page"]), "data" => $op, "class" => "ins_pages_select   " . $more]);

        $ppage = $hisPage + 1;



        if ($ppage <= $pages) {

            $nurl = \lib::_eng()->_url(["page" => $ppage]);
            $r .= $this->get_html(["type" => "a", "class" => " btn btn-default ", "data" => '<i class="fa fa-angle-right" aria-hidden="true"></i>', "href" => $nurl]);
        } else {

            $r .= $this->get_html(["type" => "a", "class" => "disbale btn", "data" => '<i class="fa fa-angle-right" aria-hidden="true"></i>', "href" => "#"]);
        }


        return $this->get_html(["type" => "div", "class" => "ins_pages_bar btn-group", "data" => $r]);
        $r;
    }

    public function getselect_data($pro, $vals)
    {
        $r = "";
        $vals = explode(",", $vals);



        $m = "";

        $pro["select_value"] = $pro["select_value"] ? $pro["select_value"] : "id";
        $pro["select_text"] = $pro["select_text"] ? $pro["select_text"] : "title";


        foreach ($vals as $val) {

            if (isset($pro["select_type"]) && $pro["select_type"] == "db") {

                $data = \lib::_db()->_get_row($pro["select_table"], "*", "" . $pro["select_value"] . "='$val'");


                \ins::_data()->_update_language($data);

                if ($pro["select_text_show"] == "tree" || $pro["select_text_show"] == "treeonlist") {

                    $rdata = "";
                    \lib::_db()->get_data_uptree_2($rdata, $data[$pro["select_value"]], $pro["select_table"], "cat_id", "title", " >");

                    $r .= $m . substr(trim($rdata), 0, -1);
                } else {

                    $txs = explode(",", $pro["select_text"]);
                    foreach ($txs as $tx) {
                        if (isset($data[trim($tx)])) {
                            $r .= $data[trim($tx)] . " ";
                        } else if (count($txs)>1) {
                            $r .= trim($tx) . " ";
                        }
                    }
                }

                $m = " , ";
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "xml") {
                $data = $this->get_xml_data($pro, $pro["select_file"]);

                if (isset($this->get_xml_data($pro, $pro["select_file"])[$pro["select_file"]][$val]["data_value"])) {
                    $r .= $this->get_xml_data($pro, $pro["select_file"])[$pro["select_file"]][$val]["data_value"];
                } else {
                    $r .= $val;
                }
            } else {
                $ii = array_search($val, explode(",", $pro["select_value"]));
                if (isset(explode(",", $pro["select_text"])[$ii])) {
                    $val = explode(",", $pro["select_text"])[$ii];
                }

                $r .= $val;
            }
        }
        return $r;
    }

    public function video($data)
    {

        return \lib::_video()->videoembed_create_embed_object($data["data"], "_" . uniqid(), $data["width"], $data["height"]);
    }

    var $tree_com_strat = "";

    private function get_options_levels($pro, $levl)
    {

        if ($levl == "0") {

            $r = "";
        } else {

            $r = "&nbsp;&nbsp;&nbsp;&nbsp;";

            $w = " id='" . $levl . "'";

            $data = \lib::_db()->_get_row($pro["select_table"], "*", $w);

            $pro["tree_field"] = $pro["tree_field"] ? $pro["tree_field"] : $pro["name"];
            $r .= $this->get_options_levels($pro, $data[$pro["tree_field"]]);
        }



        return $r;
    }

    private function get_options_db($pro, $levl = "0")
    {

        $r = "";
        $pro["select_value"] = $pro["select_value"] ? $pro["select_value"] : "id";
        $pro["select_text"] = $pro["select_text"] ? $pro["select_text"] : "title";


        $pro["select_query"] = \lib::_data()->_lang_trans($pro["select_query"]);

        if ($pro["tree"] == "true") {

     


            if (isset($pro["select_query"]) && $pro["select_query"] != "") {

                $select_query = " and " . $pro["select_query"];
            }

            $pro["tree_field"] = $pro["tree_field"] ? $pro["tree_field"] : $pro["name"];
            $w = $pro["tree_field"] . "='" . $levl . "'  " . $select_query;
            $data = \lib::_db()->_get_data($pro["select_table"], "*", $w);



            $this->tree_com_strat = "--";
        } else {

            if (isset($pro["select_query_type"]) && $pro["select_query_type"] == "distinct") {

                $data = \lib::_db()->_get_data($pro["select_table"], "distinct(" . $pro["select_value"] . ")", $pro["select_query"]);
            } else  if (isset($pro["select_full_query"]) ) {

                    $data = \lib::_db()->_get_query($pro["select_full_query"]);

             
            } else {
                if (\lib::_options()->bysit && $pro["full"] !== "true") {


                    if (\lib::_db()->is_column_exists($pro["select_table"], "sys_site")) {

                        if ($pro["select_query"] != "") {
                            $pro["select_query"] .= " and ";
                        }
                        $pro["select_query"] .= "  (sys_site='" . \lib::_options()->bysit . "') ";
                    }
                }


                $data = \lib::_db()->_get_data($pro["select_table"], "*", $pro["select_query"]);
            }
        }

        foreach ($data as $k) {
            \ins::_data()->_update_language($k);


            \lib::_data()->_update_data_language($pro["select_table"], $k);


            if (is_array($pro["value"])) {
                $values = $pro["value"];
            } else {
                $values = explode(",", $pro["value"]);
            }




            if (in_array($k[$pro["select_value"]], $values)) {
                $m = "selected";
            } else if (isset($pro["sys_default"]) && $k["sys_default"] == "1") {



                $m = "selected";
            } else {
                $m = "";
            }

            $t = " ";

            $txs = explode(",", $pro["select_text"]);
            foreach ($txs as $tx) {
                if (isset($k[trim($tx)])) {
                    $t .= $k[trim($tx)] . " ";
                } else {
                    $t .= trim($tx) . " ";
                }
            }




            if ($pro["tree"] == "true") {
                $s = $this->get_options_levels($pro, $levl);

                if ($s != "") {

                    $s .= " <span>--</span> ";
                }

                $t = $s . $t;
            }

            if ($pro["select_text_show"] == "tree") {
                $t = "";
                \lib::_db()->get_data_uptree_2($t, $k[$pro["select_value"]], $pro["select_table"], "cat_id", "title", " > ");
                $t = substr(trim($t), 0, -1);
            }



            $r .= '<option ' . $m . ' value="' . $k[$pro["select_value"]] . '">' . $t . '</option> ';
            if ($pro["tree"] == "true") {
                $r .= $this->get_options_db($pro, $k["id"]);
            }
        }
        return $r;
    }

    public function getOptions($pro)
    {
        $r = "";
        $pro["value"] = \lib::_data()->_lang_trans(trim($pro["value"]));
        $r = '';



        if ($pro["start_empty"] != "false") {
            $r = '<option  value=""> </option> ';
        }


        if ($pro["add"] == "true") {


            $r .= '<option  value="ins_mian_add">---Add---</option> ';
        }


        if (is_array($pro["data"])) {
            foreach ($pro["data"] as $k => $v) {
                $m = "";
                if (in_array($k, explode(",", $pro["value"])) && (strlen(trim($pro["value"])))) {
                    $m = "selected";
                } else {
                    $m = "";
                }

                $r .= '<option ' . $m . ' value="' . $k . '"> ' . $v . '</option> ';
            }
        } else {

            if (isset($pro["select_type"]) && $pro["select_type"] == "db") {

                $this->tree_com_strat = "";
                if ($pro["start_empty"] == "true") {
                    $r .= '<option  value=""> </option> ';
                }
                if ($pro["start_zero"] != "false") {


                    $r .= '<option  value="0">-</option> ';
                }
                $r .= $this->get_options_db($pro);
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "template_styles") {
                $r .= $this->get_template_xml($pro, "styles");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "xml") {
                $r .= $this->get_xml($pro, "styles");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "template_classes") {
                $r .= $this->get_template_xml($pro, "classes");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "template_page_classes") {
                $r .= $this->get_template_xml($pro, "page_classes");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "template_positions") {
                $r .= $this->get_template_xml($pro, "positions");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "templates") {
                $r .= $this->get_xml(["select_file" => "templates"], "styles");
            } else if (isset($pro["select_type"]) && $pro["select_type"] == "sys_areas") {
                $data = \lib::_options()->areas;
                foreach ($data as $k => $v) {
                    if (in_array($v["url"], explode(",", $pro["value"]))) {
                        $m = "selected";
                    } else {
                        $m = "";
                    }
                    $r .= '<option ' . $m . ' value="' . $v["url"] . '"> ' . $k . '</option> ';
                }
            } else {

                if (isset($pro["select_value"])) {
                    $select_value = explode(",", $pro["select_value"]);
                }

                $select_text = explode(",", $pro["select_text"]);

                for ($i = 0; $i < count($select_text); $i++) {
                    $m = "";
                    if (isset($select_value[$i])) {
                        $k = $select_value[$i];
                    } else {
                        $k = $select_text[$i];
                    }
                    $v = $select_text[$i];
                    $values = explode(",", trim($pro["value"]));

                    if (in_array($k, $values) && $k !== "") {
                        $m = "selected";
                    } else {
                        $m = "";
                    }
                    $r .= '<option ' . $m . ' value="' . trim($k) . '"> ' . trim($v) . '</option> ';
                }
            }
        }
        return $r;
    }

    protected function get_options_array($array, $value)
    {

        $r = "";
        foreach ($array as $k => $v) {

            $values = explode(",", $value);


            if (in_array($k, $values)) {
                $m = "selected";
            } else {

                $m = "";
            }
            if (isset($value) && ($value == $k)) {
                $m = "selected";
            } else if ($m != "selected") {
                $m = "";
            }


            if (isset($v["value"])) {
                $k = $v["value"];
            }


            $att = $v;

            unset($att["data_value"]);
            foreach ($att as $mk => $mv) {
                $m .= " $mk='" . $mv . "' ";
            }
            if (isset($v[trim(\lib::_eng()->_this_lang)])) {

                $v["data_value"] = $v[trim(\lib::_eng()->_this_lang)];
            };


            $r .= '<option ' . $m . ' value="' . $k . '"> ' . $v["data_value"] . '</option> ';
        }

        return $r;
    }

    protected function get_xml_data($pro, $type = "properties")
    {
        $file = $pro["select_file"] ? $pro["select_file"] : $pro["select_table"];
        $path = $pro["select_path"] ? $pro["select_path"] : "/ins_lib/includes/xml/";
        $path =   "$path$file.xml";


        return \lib::_files()->loadfile($path, $type)->out;
    }

    protected function get_xml($pro, $type)
    {

        $file = $pro["select_file"] ? $pro["select_file"] : $pro["select_table"];
        $path = $pro["select_path"] ? $pro["select_path"] : "/ins_lib/includes/xml/";
        $path = "$path$file.xml";
        $p = \lib::_files()->loadfile($path, "properties")->out;


        if (isset($pro["select_tag"])) {
            $file = $pro["select_tag"];
        }



        return $this->get_options_array($p[$file], $pro["value"]);
    }

    protected function get_template_xml($pro, $type)
    {
        $area = \lib::_data()->_lang_trans($pro["area"]);
        $data = \lib::_db()->_get_row("sys_templates", "*", "`default`='1' and sys_area='$area'");
        if ($area != "data_area" && $area != "get.data_area") {
            $area = $area;
        } else {
            $area = "";
        }
        $p = \lib::_eng()->_get_properties_xml($data["type"], "", "properties", $area);



        return $this->get_options_array($p[$type], $pro["value"]);
    }

    /**
     * @param type $pro
     * [
     * ["thval"=>"thclas","thval"=>"thclas","thval"=>"thclas","thval"=>"thclas"]
     * ["tdval"=>"tdclas","tdval"=>"tdclas","tdval"=>"tdclas","tdval"=>"tdclas"]
     * ["$k"=>["class"=>"tdclass"],"$k"=>["class"=>"tdclass"],"$k"=>["class"=>"tdclass"]]
     * ["tdval","tdval","tdval","tdval","tdval","tdval","tdval","tdval","tdval"] 
     * ]
     * @return string <table>
     */
    protected function getTable($pro)
    {
        $i = 0;


        $class = $pro["class"];
        $r = "<table style='" . $pro["style"] . "' class='$class'>";

        if (is_array($pro["data"])) {


            foreach ($pro["data"] as $row) {
                $r .= "<tr  class='" . $row["class"] . "'>";
                foreach ($row["data"] as $k => $v) {
                    $m = "";



                    $myClass = "td";
                    if ($i == 0) {
                        $myClass = "th";
                    }

                    if (is_array($v)) {

                        if (isset($v["data"])) {
                            $value = $v["data"];
                        } else {

                            $value = $k;
                        }


                        $v["class"] .= " " . $myClass . "_" . $k . " " . $myClass . "_" . $v["id"];


                        unset($v["data"]);
                        foreach ($v as $tdk => $tdv) {
                            $m .= '' . $tdk . '="' . $tdv . '" ';
                        }
                    } else {

                        $m = ' class=" ' . $myClass . ' ' . $k . ' ' . $v . '"';
                    }

                    $r .= "<$myClass $m >";
                    $r .= "<span>$value</span>";
                    $r .= "</$myClass>";
                }
                $i++;
                $r .= "</t>";
            }
        }
        $r .= "</table>";
        return $r;
    }

    protected function getTableExportCSV($pro)
    {
        $r = [];
        foreach ($pro["data"] as $row) {
            $trmyClass = "";
            $row = $row["data"];
            $r_raw = [];
            foreach ($row as $k => $v) {
                if ($v["notcsv"] !== true) {

                    array_push($r_raw, strip_tags($v["data"]));
                }
            }
            array_push($r, $r_raw);
        }
        $myfile_data = $pro["file_name"];
        $_SESSION[$myfile_data]["data"] = $r;
        $_SESSION[$myfile_data]["file_name"] = $pro["file_name"] . "_" . uniqid();
        $url = "/csv_export.php?name=" . $myfile_data;
        echo "<meta class='ins_hidden'  http-equiv=\"refresh\" content=\"0;url=$url\" ></meta>";
        die();
    }

    /**
     * 
     * @param type $pro     
     *   $pro["data"]["row_1"] = ["data" => [
      "col_1" => ["data" => "a", "class" => "col2"],
      "col_2" => ["data" => "a", "class" => "col2"],
      "col_3" => ["data" => "a", "class" => "col2"],
      ]];

      $pro["data"]["row_2"] = ["data" => [
      "col_1" => ["data" => "a", "class" => "col2"],
      "col_2" => ["data" => "a", "class" => "col2"],
      "col_3" => ["data" => "a", "class" => "col2"],
      ]];
     * @return string
     */
    protected function getTabledivs($pro)
    {

        $i = 0;
        $class = $pro["class"];
        $r = "<div style='" . $pro["style"] . "' class='ins_table $class'>";
        $header_data = [];

        foreach ($pro["data"] as $row) {
            $trmyClass = "";

            if ($i == 0 && $pro["table_header"] != "false") {
                $trmyClass = "ins_thead ";
            } else {
                $trmyClass = "ins_table_body";
            }

            $tr_class = " ins_tr $trmyClass ";

            if (isset($row["class"])) {
                $tr_class .= "  " . $row["class"];
            }

            if ($pro["tr_class"]) {
                $tr_class .= " " . $pro["tr_class"];
            }

            $mclass = "";
            foreach ($row as $k => $v) {
                if ($k != "data" && $k != "class") {
                    $mclass .= " $k='$v' ";
                }
            }
            $r .= "<div $mclass class='$tr_class '>";
            $ti = 0;

            if (!isset($row["data"])) {
                $row["data"] = $row;
            }
            foreach ($row["data"] as $k => $v) {
                $m = "";
                $value = "";
                $td_class = " ";
                if ($pro["td_class"]) {
                    $td_class .= "  " . $pro["td_class"];
                }

                $td_class = str_replace('"', " ", $td_class);
                $myClass = " ins_td $td_class";
                if ($i == 0 && $pro["table_header"] != "false") {
                    $myClass = "ins_th";
                }



                if (is_array($v)) {


                    if (isset($v["data-" . \lib::_eng()->_this_lang])) {

                        $value = $v["data-" . \lib::_eng()->_this_lang];
                    } else   if (isset($v["data"])) {
                        $value = $v["data"];
                    } else {
                    }


                    if (isset($v[\lib::_eng()->_this_lang])) {

                        $daydata[$k] = $v[\lib::_eng()->_this_lang];
                    } else {
                        $daydata[$k] = $v["data_value"];
                    }



                    $myClass = str_replace('"', " ", $myClass);
                    $v["class"] = str_replace('"', " ", $v["class"]);
                    if (isset($v["class"])) {
                        $v["class"] .= " " . $myClass;
                    } else {

                        $v["class"] = " " . $myClass;
                    }




                    unset($v["data"]);
                    foreach ($v as $tdk => $tdv) {
                        $m .= '' . $tdk . '="' . $tdv . '" ';
                    }
                } else {

                    $m = ' class=" ' . $myClass . ' ' . $v . '" ';
                }


                $h_data = "";
                if (isset($header_data[$ti])) {
                    $h_data = ' data-header="' . $header_data[$ti] . '" ';
                }

                $r .= "<div  $h_data title='' $m >";

                if ($i == 0 && $pro["table_header"] != "false") {

                    array_push($header_data, trim(strip_tags($value)));
                }

                $r .= "<span>" . $value . "</span>";
                $r .= "</div>";
                $ti++;
            }
            $i++;
            $r .= "</div>";
        }
        $r .= "</div>";
        return $r;
    }



    function get_houres($times, $from, $to)
    {
        $array = [];
        $add = false;
        foreach ($times as $t) {
            if ($from == $t) {

                $add = true;
            }

            if ($add) {
                $array[] = $t;
            }
            if ($to == $t) {

                $add = false;
            }
        }
        return $array;
    }


    /**
     *      $data  = [
            ["from" => "9:30", "to" => "11:00", "day" => "tuesday", "color" => "#eee", "title" => "sdfsdf", "des" => "asdas asdas asdas"],
            ["from" => "12:00", "to" => "1:00", "day" => "thursday"],
            ["from" => "12:00", "to" => "1:00", "day" => "tuesday"]
        ];
     */


    function weekly_calender($pro)
    {


        $daydata = $this->get_xml_data(["select_file" => "days"])["days"];


        foreach ($daydata as $k => $v) {


            if (isset($v[\lib::_eng()->_this_lang])) {

                $daydata[$k] = $v[\lib::_eng()->_this_lang];
            } else {
                $daydata[$k] = $v["data_value"];
            }
        }

        $xtimes = $this->get_xml_data(["select_file" => "work_times"])["work_times"];
        $times = [];

        foreach ($xtimes as $k => $v) {
            $times[$v["value"]] = $v["data_value"];
        }
        if (is_array($pro["data"])) {
            $data = $pro["data"];
        } else {
            $data = json_decode($pro["data"], true);
        }


        $tr = [["data" => "ايام الاسبوع", "class" => "ins_col_6"]];
        foreach ($times as $t) {
            $tr[] = ["data" => $t, "class" => "ins_col_1"];
        }

        $table_data[] = ["data" => $tr, "class" => "ins_grid_24"];


        foreach ($daydata as $k => $v) {



            $tr = [["data" => $v, "class" => "ins_col_6"]];

            $hs = [];
            foreach ($data as $d) {

                if ($d["day"] ==  $k) {
                    $d["hours"] = $this->get_houres($times, $d["from"], $d["to"]);
                    $hs[] = $d;
                }
            }

            foreach ($times as $t) {
                $pdata = "";
                foreach ($hs as $h) {
                    if ($t == $h["hours"][0]) {
                        $styel = "";
                        $hlenght = count($h["hours"]);
                        $styel .= "width:{$hlenght}00%;";
                        $styel .=  $h["color"] ? "background:{$h["color"]};" : "";
                        $title =  $h["title"] ? "<h4 class='ins_calendar_item_title' >{$h["title"]}</h4>" : "<h4 class='ins_calendar_item_title' >{$h["from"]} - {$h["to"]}</h4>";
                        $des =  $h["des"] ? "<div class='ins_calendar_item_des'>{$h["des"]}</div>" : "";

                        $pdata = "<div class='ins_calendar_data_item'  style='$styel'> $title $des</div>";
                    }
                }
                $tr[] = ["data" => $pdata, "data-t" => $t, "data-day" =>  $k, "class" => "ins_col_1"];
            }

            $table_data[] = ["data" => $tr, "class" => "ins_grid_24"];
        }


        $data = [
            "table_divs" => ["data" => $table_data, "class" => "ins_weekly_calendar " . $pro["class"]]
        ];

        return  \lib::_ui()->_data($data)->_render();
    }



    protected function hierarchy($array)
    {



        $r = '<div class="branch">';
        foreach ($array["data"] as $a) {
            if (trim($a["title"]) != "") {
                $moreclass = "";
                if (count($array["data"]) == 1) {
                    $moreclass = "single";
                }

                $r .= '<div class="entry ' . $moreclass . '">'
                    . ' <span style=" ' . $a["style"] . ' " class="label ' . $a["class"] . '  ">' . $a["title"] . '</span>';
                if (is_array($a["data"])) {
                    $r .= $this->hierarchy($a);
                }
                $r .= '</div>';
            }
        }
        $r .= '</div>';

        return $r;
    }

    protected function getproperties($pro, $mode = "", $id = "")
    {
        $r = "";



        $v = "/" . \lib::_data()->_lang_trans($pro["for"]);

        if (isset($_GET['parent'])) {
            $v  = $_GET['parent'] . "/" . $v;
        }


        /*
        $fors = explode("/", $for);
        $fors = array_filter($fors);
        $parent = "";

       

        if (isset($fors[1])) {
            $parent = $fors[0];
            $for = $fors[1];
        } 


        $v .= $parent . "/";
*/



        if ($mode == "") {
            $mode = $_GET["mode"];
        }


        if ($id == "") {
            $id = $_GET["id"];
        }


        if ($mode == "edit") {
            $datapro = \lib::_eng()->_get_properties_DB($pro["protype"], $id);
        }


        $bestatus = \lib::_eng()->admin;
        /*  $area = \lib::_data()->_lang_trans($pro["data_area"]);
        echo  $area . $v;*/

        // $p = \lib::_eng()->_get_properties_xml($v, "", "properties", $area);

        $area = \lib::_data()->_lang_trans($pro["data_area"]);
        if (!isset($area) || $area == "") {
            $area = $this->get("area");
        }

        $p = \lib::_eng()->_get_properties_xml($v, "", "properties", $area);



        if (is_array($p) && count($p) > 0) {
            $data = $p["properties"];
            foreach ($data as $k => $v) {
                if (!isset($data[$k]["name"])) {
                    $data[$k]["name"] = $k;
                }
                if (!isset($data[$k]["type"])) {
                    $data[$k]["type"] = $k;
                }
                if (is_array($v)) {
                    if (isset($datapro[$data[$k]["name"]])) {
                        $data[$k]["value"] = $datapro[$data[$k]["name"]];
                    }
                    $data[$k]["name"] = "sys_properties__" . $data[$k]["name"];
                } else {
                    if (isset($datapro[$data["name"]])) {
                        $data["value"] = $datapro[$data["name"]];
                    }
                    $data["name"] = "sys_properties__" . $data["name"];
                }
            }


            $r .= $this->_render_Data($data);
            \lib::_eng()->admin = $bestatus;
        } else {


            $r .= \lib::_data()->_get_gen_word("no_properties");
        }
        return $r;
    }

    protected function get_menus($pro)
    {
        $r = "";


        $mdata = \lib::_db()->_get_data("sys_modules", "sys_properties", "type='mod_menu' and sys_area='" . \ins::_app_map()->_get()["data_area"] . "'");

        $ids = [];
        foreach ($mdata as $d) {
            $ids .= "," . json_decode($d["sys_properties"], true)["menu"];
        }
        $mdata = \lib::_db()->_get_data("sys_menus", "*", \lib::_data()->_db_create_where_from_array($ids));
        $n = "";
        $t = "";
        $m = "";

        foreach ($mdata as $d) {
            $t .= $m . $d['title'];
            $n .= $m . $d['alias'];
            $m = ",";
        }




        $r = $this->_render_Data(["type" => "tabs", "title" => $t, "name" => "$n"]);


        foreach ($mdata as $d) {


            $r .= $this->_render_Data([
                "tab" => ["name" => $d["alias"]],
                "list" => [
                    "type" => "list",
                    "select_type" => "db",
                    "select_table" => "sys_menus_items",
                    "style" => "height:200px;",
                    "select_text" => "title",
                    "select_value" => "alias",
                    "value" => $pro["value"],
                    "name" => $pro["name"] . "[]",
                    "select_query" => "cat_id='" . $d["id"] . "'"
                ], "end" => []
            ]);
        }


        $r .= $this->_render_Data(["type" => "tabs_end"]);

        //   $r .= $this->_render_Data(["type" => "endblock"]);
        \lib::_eng()->admin = $bestatus;



        return $r;
    }

    protected function get_lang($pro)
    {

        if (isset($pro['lang_id']) && $pro['lang_id'] != "") {
            $r = "<ul class='lng_bar'>";
            $data = \lib::_db()->_get_data("sys_language");

            foreach ($data as $d) {
                if ($d["default"] != "1") {
                    $r .= "<li>"
                        . "<a class='ins_jsaction' "
                        . "style='    font-size: 10px;'"
                        . " data-jsaction='lightbox' "
                        . " data-acttitle='Languages Update' "
                        . " data-actstyle='height:300px;width:50%'"
                        . " data-actdata='150px'"
                        . " data-url='/ins_ajax.php?file=eng/language&obj_type=" . $pro['lang_type'] . "&obj_field=" . $pro['name'] . "&lang=" . $d['alias'] . "&obj_id=" . $pro['lang_id'] . "&header=true'"
                        . " title='" . $d["title"] . "'>"
                        // . "  <img style=' width: 30px;' src='" . \lib::_app_map()->ins_images_sys . "" . $d["image"] . "'/>" 
                        . $d['title'] . "</a></li>";
                }
            }
            $r .= "</ul>";
        }
        return $r;
    }
}
