<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace ins_lib\ui;

use JsonException;

/**
 * Description of xml
 *
 * @author ismail
 */
class ui_html extends \ins_lib\ui\ui_html_utils
{

    var $data = null;
    var $_g = [];
    var  $icons = null;
    public function __construct($data)
    {
        $this->data = $data;

        $this->icons = new \ins_lib\ui\Icons($data);
    }

    public function _render($data = null)
    {
        if ($data !== null) {
            $this->data = $data;
        }
        return $this->_render_Data($this->data);
    }

    public function _get_select_options($d)
    {


        return $this->getOptions($d);
    }

    protected function _render_Data($data = [])
    {
        $this->_g = \lib::_eng()->_get();
        $r = "";

        if (is_array($data)) {
            $fkey = array_keys($data)[0];


            if (is_array($data[$fkey])) {
                foreach ($data as $k => $d) {
                    $this->d = $d;
                    if (!isset($this->d["type"])) {
                        $ks = explode("-", $k);
                        $this->d["type"] = $ks[0];
                    }

                    if (!isset($this->d["name"])) {
                        $ks = explode("-", $k);
                        $this->d["name"] = $ks[0];
                    }



                    $r .= $this->get_html();
                }
            } else {

                $this->d = $data;
                $r .= $this->get_html();
            }
        } else {
            $this->d = $data;
            $r .= $this->get_html();
        }

        return $r;
    }

    protected function get_html($data = "")
    {
        $r = "";
        $h = "";
        $lng = trim(\lib::_eng()->_this_lang);
        if ($data != "") {

            $this->d = $data;
        }
        $pclass = $this->d["pclass"];

        /*   if (isset($this->d["title-" . $lng])) {
          $this->d["title"] = $this->d["title-" . $lng];
          }
          if (isset($this->d["data-" . $lng])) {
          $this->d["data"] = $this->d["data-" . $lng];
          } */



        foreach ($this->d as $k => $v) {
            if (isset($this->d["$k-" . $lng])) {
                $this->d["$k"] = $this->d["$k-" . $lng];
            }
        }



        $mclass = "";





        if (isset($this->d["data-jsaction"])) {

            $mclass .= "ins_jsaction";
        }

        if (isset($this->d["data-uiaction"])) {

            $mclass .= "uiaction";
        }

        if (isset($this->d["moreclasses"])) {

            $this->d["classes"] .= " " . $this->d["moreclasses"];
            unset($this->d["moreclasses"]);
        }




        $g = " class=' $mclass " . $this->get("class") . "  " . $this->get("name") . "' ";

        $gcont = " class=' $mclass " . $this->d["classes"] . " " . $this->get("class") . "  " . $this->get("name") . " ' ";

        if (isset($this->d["classes"])) {
            unset($this->d["classes"]);
        }


        if (is_numeric($this->d["type"])) {
            unset($this->d["type"]);
        }

        $h = "";


        switch ($this->d["type"]) {
            case "cont_div":
                $r = "<div $gcont " . $this->getAttrs() . "></div>" . PHP_EOL;
                break;
            case "strat_div":
            case "div_start":
                $r = "<div $gcont " . $this->getAttrs() . ">" . PHP_EOL;
                break;
            case "google_captcha":
                $r = '
                <script src=\'https://www.google.com/recaptcha/api.js?render=6LdYk4YUAAAAAO5V6HdrjyJDhrTOFzn8m2P09F_L\'></script>
<script>
grecaptcha.ready(function() {
grecaptcha.execute(\'6LdYk4YUAAAAAO5V6HdrjyJDhrTOFzn8m2P09F_L\', {action: \'action_name\'})
.then(function(token) {
// Verify the token on the server.
});
});
</script>' . PHP_EOL;


                break;


            case "plugin":

                if ($this->d["trans"] != "false") {
                    foreach ($this->d as $k => $v) {
                        $this->d[$k] = \lib::_data()->_lang_trans($v, $this->d["lang_data"]);
                    }
                }

                $this->d["area"] = ($this->d["area"]) ? $this->d["area"] : $this->get("area");




                $h = \lib::_eng()->_get_plgin($this->d["data"], $this->d, $this->d["area"]);
                break;
            case "plgin":
                $r = \lib::_eng()->_get_plgin($this->get("name"), \lib::_data()->_arrayFromDB($this->get("data")), $this->get("area")); // ($this->d);
                break;

            case "function":
                $h = call_user_func($data["name"], $this->d);
                break;

            case "module":
                if (isset($this->d["module"])) {
                    $this->d["data"] = $this->d["module"];
                }
                // if (!isset($this->d["options"])) {

                $this->d["options"] = $this->d;
                //  }

                $this->d["type"] = $this->d["data"];



                $h = \lib::_eng()->_getModels_bytype($this->d["data"], $this->d["options"]); // \lib::_eng()->_get_plgin($this->d["data"], $this->d["options"]);
                break;

            case "svg":

                $r = '<svg ';

                if (isset($this->d["height"])) {
                    $r .= '  height="' . ($this->d["height"] + 8) . '"';
                }
                if (isset($this->d["svgstyle"])) {

                    $r .= '   style="' . $this->d["svgstyle"] . '" "';
                }

                if (isset($this->d["width"])) {

                    $r .= '   width="' . ($this->d["width"] + 8) . '"';
                }



                unset($this->d["svgstyle"]);

                $r .= '><' . $this->d["svg"] . '  ' . $this->getAttrs(false, ["data"]) . ' /></svg>';






                break;





            case "start":
            case "strat":
                if (!isset($this->d["data"])) {
                    $this->d["data"] = "div";
                }

                unset($this->d["name"]);

                $r = "<" . $this->d["data"] . $this->getAttrs(false, ["data"]) . " class=' " . $this->get("class") . "'>" . PHP_EOL;
                break;


            case "end":
                if (!isset($this->d["data"])) {
                    $this->d["data"] = "div";
                }



                $r = "</" . $this->d["data"] . ">" . PHP_EOL;
                break;





            case "start_form":

            case "strat_form":
            case "form_start":
                $r = "<form $gcont " . $this->getAttrs() . ">" . PHP_EOL;





                break;
            case "img":
                if (isset($this->d["src"])) {
                    $this->d["data"] = $this->d["src"];
                } else if (isset($this->d["value"])) {
                    $this->d["data"] = $this->d["value"];
                }
                $src = \lib::_data()->_get_img($this->d["data"], $this->d["path"]);

                if ($this->d["full_path"] || $this->d["fullpath"]) {
                    $src = $this->d["data"];
                }
                $src = \lib::_data()->_lang_trans($src, $this->d["lang_data"]);


                $h = "<img  class=' " . $this->get("type") . " " . $this->get("class") . " '  " . $this->getAttrs(false, ["data", "value", "src", "name"]) . " "
                    . "src='$src' />" . PHP_EOL;




                break;


            case "end_form":
                $r = "</form>" . PHP_EOL;
                break;

            case "admin":


                $clss = "ins_block col12";

                if (!isset($this->d["file"])) {
                    $this->d["file"] = $this->d["name"];
                }






                if (isset($this->d["class"])) {
                    $clss = $this->d["class"];
                }
                if (isset($this->d["set_mode"])) {
                    $o["_mode"] = $this->d["set_mode"];
                }

                $o["_properties_file"] = $this->d["file"];

                if (isset($this->d["query"])) {
                    $o['_query'] = $this->d["query"];
                }
                if (isset($this->d["parent_add"])) {
                    $o['_parent_add'] = $this->d["parent_add"];
                }

                if (isset($this->d["addtourl"])) {
                    $o['_addtourl'] = $this->d["addtourl"];
                }

                if (isset($this->d["_per_cancel"])) {
                    $o['_per_cancel'] = $this->d["_per_cancel"];
                }

                $this->d["addtourl"];


                $h = \lib::_ui()->_data(["div" => ["data" => \lib::_pages()->get_page("admin", $this->d["name"], $o), "class" => $clss]])
                    ->_render();


                break;


            case "input":
                $h = "<input $g " . $this->getAttrs() . "/>" . PHP_EOL;
                break;
            case "json":


                $value_Data = json_decode($this->d["value"], true);

                if (isset($this->d["clear"])) {
                    foreach ($value_Data as $k => $v) {
                        if (strpos($k, "sys_") == true) {
                            unset($value_Data[$k]);
                        }
                    }
                }

                $this->d["titles"] = str_replace("'", '"', $this->d["titles"]);



                $titles = json_decode($this->d["titles"], true);



                $table[] = [];



                foreach ($value_Data as $k => $v) {

                    if ($titles[$k] !== "ins_hidden") {
                        $k = $titles[$k] ? $titles[$k] : $k;

                        $table[] = [
                            ["data" => $k, "class" => "ins_col_8"],
                            ["data" => $v, "class" => "ins_col_16"]
                        ];
                    };
                }





                $data = [
                    "table_divs" => ["data" => $table, "class" => "ins_col_12"]
                ];



                $h .= \lib::_ui()->_data($data)->_render();



                break;






            case "json_row":


                $value_Data = json_decode($this->d["value"], true);

                if (isset($this->d["clear"])) {
                    foreach ($value_Data as $k => $v) {
                        if (strpos($k, "sys_") == true) {
                            unset($value_Data[$k]);
                        }
                    }
                }

                $this->d["titles"] = str_replace("'", '"', $this->d["titles"]);
                $this->d["titles"] = str_replace('\"', '"', $this->d["titles"]);


                $titles = json_decode($this->d["titles"], true);


                $table[] = [];


                $row = [];
                $ii = 0;
                $max = $this->d["rows"] ? ($this->d["rows"] + 1) : 5;



                foreach ($value_Data as $k => $v) {
                    $ii++;

                    if ($ii < $max) {

                        if ($titles[$k] !== "ins_hidden") {
                            $k = $titles[$k] ? $titles[$k] : $k;
                            $rowh[] = ["data" => $k, "class" => "ins_col_6"];
                        };
                    }
                }

                $table[] = ["data" => $rowh, "class" => "json_header_tr ins_dark"];
                $ii = 0;
                foreach ($value_Data as $k => $v) {
                    $ii++;
                    if ($ii < $max) {
                        if ($titles[$k] !== "ins_hidden") {
                            $row[] = ["data" => $v, "class" => "ins_col_6"];
                        };
                    }
                }
                $table[] = ["data" => $row, "class" => "json_body_tr"];


                $data = [
                    "table_divs" => ["data" => $table, "class" => "ins_col_12"]
                ];



                $h .= \lib::_ui()->_data($data)->_render();



                break;





            case "image_view":

                $v = "";
                if ($this->d["value"] != "") {
                    $v = \lib::_app_map()->upload_folder . $this->d["value"];
                } else {
                    $v = \lib::_app_map()->noimage;
                }
                $name = $this->d["name"];
                $upload = "";


                $ex = end(explode(".", $this->d["value"]));

                //<i class="far fa-file-pdf"></i>

                $r .= "<a href='$v' target='_blank'>";

                if ($ex == "pdf") {
                    $r .= "<i  " . $this->getAttrs() . "    style='    font-size: 30px;
    color: #ff3d3d;' class=\"far " . $this->get("class") . " fa-file-pdf\"></i>";
                } else {
                    $r .= "<img   " . $this->getAttrs() . " class='$name-img  " . $this->get("class") . "'   src='$v'/>";
                }

                $r .= "</a>";


                break;
            case "select_view":
            case "list_view":

                $r = $this->getselect_data($this->d["pro"], $this->d["value"]);


                break;
            case "uieditor":
            case "ui_editor":
                $r = $this->get_ui_editor($this->d, $this->d["value"]);
                break;

            case "editor":
            case "uieditor":
            case "ui_editor":
            case "ins_editor":

            case "ins_tiny_editor":
            case "ins_empty_editor":

                $name = $this->get("name");



                $data = [
                    "div" => ["contentEditable" => true, "class" => $clss, "clean" => true],
                    "textarea" => []
                ];

                $data["textarea"] = array_merge($data["textarea"], $this->getAttrData());

                $_un = "_" . uniqid();

                $h = "<div style='" . $this->get("style") . "'   class='ins_tiny_editor ins_ui_input'>"
                    . "<div  data-id='$_un'  class='$_un ins_tiny_editor_body  editor_$name ' style='height:116px; padding:5px;    overflow-y: auto;' contentEditable=true ></div> "
                    . "";


                $toolbar = "";

                $mt = "";

                if ($this->get("type") !== "ins_empty_editor") {
                    $toolbar = '<button  class="ins_editor_format"  title="' . \lib::_data()->_get_gen_word("blod") . '"    data-c="bold" ><i class="fas fa-bold"></i></button>'
                        . '<button  class="ins_editor_format"  title="' . \lib::_data()->_get_gen_word("italic") . '"   data-c="italic" ><i class="fas fa-italic"></i></button>'
                        . '<button  class="ins_editor_format"   title="' . \lib::_data()->_get_gen_word("underline") . '"    data-c="underline"  ><i class="fas fa-underline"></i></button>'
                        . '<button class="ins_editor_format"   title="' . \lib::_data()->_get_gen_word("strikethrough") . '"   data-c="strikethrough"  ><i class="fas fa-strikethrough"></i></button>'
                        . '<button class="ins_editor_sp"></button>'
                        . '<button  class="ins_editor_format" title="' . \lib::_data()->_get_gen_word("insertorderedlist") . '"   data-c="insertorderedlist"    ><i class="fas fa-list"></i></button>'
                        . '<button  class="ins_editor_format"   title="' . \lib::_data()->_get_gen_word("insertunorderedlist") . '"    data-c="insertunorderedlist"   ><i class="fas fa-list-ul"></i></button>'
                        . '<button class="ins_editor_sp"></button>'
                        . '<button  class="ins_editor_format"  title="' . \lib::_data()->_get_gen_word("justifyleft") . '"   data-c="justifyleft"  ><i class="fas fa-align-left"></i></button>'
                        . '<button  class="ins_editor_format"  title="' . \lib::_data()->_get_gen_word("justifycenter") . '"    data-c="justifycenter"  ><i class="fas fa-align-center "></i></i></button>'
                        . '<button   class="ins_editor_format" title="' . \lib::_data()->_get_gen_word("justifyright") . '"   data-c="justifyright"  ><i class="fas fa-align-right "></i></button>';



                    if ($this->get("type") === "ins_editor") {
                        $toolbar .= '<button class="ins_editor_sp"></button>';

                        $toolbar .= '<button style="    position: relative;"   class="ins_editor_fill" title="' . \lib::_data()->_get_gen_word("code") . '"  ><i class="fas fa-fill"></i>  <input type="color" style="    top: 0;
    position: absolute;
    width: 100%;
    left: 0;
    height: 100%;
    cursor: pointer;
    opacity: 0;"/></button>';
                        $toolbar .= '<button  style="    position: relative;"  class="ins_editor_font_co"  title="' . \lib::_data()->_get_gen_word("code") . '"  ><i class="fas fa-font"></i> <input type="color" style="    top: 0;
    position: absolute;
    width: 100%;
    left: 0;
    cursor: pointer;
    height: 100%;
    opacity: 0;"/></button>';


                        $toolbar .= ''
                            . '<button data-c="15px"  class="ins_editor_font_change_size btn_parent" title="' . \lib::_data()->_get_gen_word("font_size") . '"  >'
                            . '<ul  class="ins_editor_menu" >'
                            . '<li data-c="5px" class="ins_editor_font_change_size">5px</li>'
                            . '<li data-c="10px" class="ins_editor_font_change_size">10px</li>'
                            . '<li data-c="15px" class="ins_editor_font_change_size">15px</li>'
                            . '<li data-c="20px" class="ins_editor_font_change_size">20px</li>'
                            . '<li data-c="30px" class="ins_editor_font_change_size">30px</li>'
                            . '<li data-c="50px" class="ins_editor_font_change_size">50px</li>'
                            . '<li data-c="60px" class="ins_editor_font_change_size">60px</li>'
                            . '<li data-c="70px" class="ins_editor_font_change_size">70px</li>'
                            . '<li data-c="80px" class="ins_editor_font_change_size">80px</li>'
                            . '<li data-c="90px" class="ins_editor_font_change_size">90px</li>'
                            . '<li data-c="100px" class="ins_editor_font_change_size">100px</li>'
                            . '</ul>'
                            . ''
                            . ''
                            . ''
                            . '<span>15px</span></button>';


                        $toolbar .= '<button class="ins_editor_sp"></button>';


                        $toolbar .= '<button  class="ins_editor_getimage" title="' . \lib::_data()->_get_gen_word("insertimage") . '"  ><i class="far fa-image"></i></button>';
                        $toolbar .= '<button  class="ins_editor_geticon"  title="' . \lib::_data()->_get_gen_word("inserticone") . '"  ><i class="fas fa-magic"></i></button>';
                        $toolbar .= '<button  class="ins_editor_link"   title="' . \lib::_data()->_get_gen_word("insertlink") . '"  ><i class="fas fa-link"></i></button>';
                    }
                    $toolbar .= '<button class="ins_editor_sp"></button>';
                    $toolbar .= '<button   class="ins_editor_format"    title="' . \lib::_data()->_get_gen_word("removeFormat") . '"  data-c="removeFormat" ><i class="fas fa-paint-roller"></i></button>';
                    $toolbar .= '<button  class="ins_editor_change_css" title="' . \lib::_data()->_get_gen_word("changecss") . '"   ><i class="fab fa-css3-alt"></i></button>';
                    $toolbar .= '<button   class="ins_editor_show_code" title="' . \lib::_data()->_get_gen_word("code") . '"  ><i class="fas fa-code  "></i></button>';

                    $toolbar .= '<button   class="ins_editor_full_screen_btn" title="' . \lib::_data()->_get_gen_word("zoom") . '"  ><i class="fas fa-expand"></i></button>';




                    $toolbar .= '<span   class="ins_editor_message"  ></span>';




                    $toolbar .= $this->get("add_to_buttons");
                }

                unset($d["data"]);


                if ($this->get("templates") != "") {

                    $dbdata = \lib::_db()->_get_data("sys_text_templates", "*", "name='" . $this->get("templates") . "'");



                    $toolbar .= ''
                        . '<button  data-name="' . $this->get("templates") . '"  class="ins_toright ins_editor_templates_save"><i class="far fa-save"></i></button> '
                        . '<button     class="ins_toright ins_editor_templates_show"  class="ins_toright" ><i class="fas fa-database"></i></button>';



                    $mt .= "<div class='ins_hidden ins_editor_templates ins_editor_templates$_un'>";
                    foreach ($dbdata as $d) {
                        $mt .= ""
                            . " <li  title='" . $d["data"] . "' >"
                            . " <i data-id='" . $d["id"] . "'  class=\" fas fa-window-close  ins_editor_templates_delete\" ></i> "
                            . "<div class='ins_editor_templates_menu ins_light'>sadasdasd</div>"
                            . "<span  data-data='" . $d["data"] . "'>" . lib::_data()->_set_string_limit($d["data"]) . "</span></li>";
                    }
                    $mt .= "</div>";
                }



                if ($toolbar != "") {
                    $h .= "<ul   class='ins_editor_toolbar'>$toolbar</ul>";
                }

                $h .= $mt . "<div class='ins_tiny_editor_textarea_area ins_hidden  ' >"
                    . "<textarea style='    direction: ltr;width: calc(100% + 40px); height: 400px;margin: -20px;'  class='$_un  $name  ins_tiny_editor_textarea " . $this->get("type") . " " . $this->get("class") . " '  " . $this->getAttrs(false, ["data", "value", "src"]) . " "
                    . "   >" . $this->d["value"] . "</textarea> "
                    . "</div></div>"
                    . "" . PHP_EOL;


                $this->d["pstyle"] = $this->d["pstyle"] ? $this->d["pstyle"] : "height:150px;";


                break;

            case "hierarchy":

                $r = ' <div ' . $this->getAttrs(FALSE, ["data"]) . '  class="chart ' . $this->get("class") . '">'
                    . '<span style="' . $this->get("home_style") . '"  class="label ' . $this->get("home_class") . '">' . $this->d["title"] . '</span>'
                    . $this->hierarchy($this->d) . '</div>';
                break;

            case "editable_select":
            case "editable_list":
                $s = [];
                if ($this->d["editable_list"] == "list") {

                    $s["type"] = "list";
                } else {

                    $s["type"] = "select";
                }

                $s["value"] = $this->d["value"];


                $s["name"] = $this->d["name"];
                $s["clear"] = true;

                $s["class"] = $this->d["class"];

                $dbdata = \lib::_db()->_get_row("sys_lists", "*", " name='" . $s["name"] . "'");
                if (is_array($dbdata)) {
                    $dbdata = json_decode($dbdata["data"], true);
                    foreach ($dbdata as $d) {
                        $s["select_text"] .= $d["text"] . ",";
                        $s["select_value"] .= $d["value"] . ",";
                    }
                }

                $_un = "_" . uniqid();

                $data = [
                    "start" => ["class" => "ins_tooltip $_un ins_ui_input  ins_light ins_hidden"],
                    "input" => ["class" => "list_value"],
                    "i-1" => ["data-name" => $s["name"], "class" => "far ins_btn_save ins_btn_icon fa-save", "clear" => true],
                    "i-22" => ["data-name" => $s["name"], "class" => "fas ins_btn_manage ins_btn_icon  fa-cog", "clear" => true],
                    "end" => [],
                    "s" => $s,
                    "i-2" => ["onclick" => "ins('.$_un')._toggle_show()", "class" => "fas ins_btn_add fa-plus ins_btn_icon", "clear" => true]
                ];



                $h = \lib::_ui()->_data($data)->_render(); //$this->_render_Data($data);




                break;


            case "user_info":



                $user = \lib::_usere()->_get_user("all", $this->d["user_id"]);



                if ($user["title"] == "" && isset($this->d["default"])) {
                    $title = $this->d["default"];
                } else {


                    $title = $user["title"];
                }

                $myColors = ["a" => "blue", "b" => "green", "c" => "yellow", "d" => "brown", "e" => "gray", "f" => "pink", "i" => "pink", "n" => "pink"];


                $t = substr($title, 0, 2);


                $this->d["type"] = "span";
                $this->d["class"] .= " _ins_user_inf ";
                $this->d["style"] .= "background:" . $myColors[$t];
                $this->d["data"] = $t;

                unset($this->d["name"]);
                $r = \ins::_ui()->_data($this->d)->_render();


                break;




            case "select":
            case "list":


                $h = "";

                if (isset($this->d["manage"]) && $this->d["manage"] != "") {

                    $pclass .= "  ins_select_manage ";

                    $h = '<i    '
                        . ' data-select_type="' . $this->d["select_type"] . '" '
                        . ' data-select_table="' . $this->d["select_table"] . '" '
                        . ' data-select_value="' . $this->d["select_value"] . '" '
                        . ' data-select_text="' . $this->d["select_text"] . '"  '
                        . ' data-manage="' . $this->d["manage"] . '"'
                        . ' class="fas ins_select_manage_btn  fa-plus ins_btn_icon" ';

                    if (isset($this->d["lightbox_title"])) {

                        $h .= ' data-lightbox_title="' . $this->d["lightbox_title"] . '"';
                    }

                    $h .= '></i>';
                }



                $show = true;
                if (isset($this->d["set_hide"]) && $this->d["set_hide"] != "") {
                    $s = 'if(' . $this->d["set_hide"] . '){$show=false;};';
                    $s = str_replace("&;", "&", $s);
                    $s = \lib::_data()->_lang_trans($s, $this->d["lang_data"]);
                    eval($s);
                }

                if ($show || $this->d["builder"] === true) {

                    $this->d["value"] = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);

                    $op = $this->getOptions($this->d);



                    unset($this->d["add"]);
                    unset($this->d["add_file"]);
                    unset($this->d["add_path"]);
                    unset($this->d["jsname"]);
                    unset($this->d["add_mode"]);



                    unset($this->d["alias"]);
                    unset($this->d["select_type"]);
                    unset($this->d["select_text"]);
                    unset($this->d["select_value"]);
                    unset($this->d["select_values"]);
                    unset($this->d["select_table"]);
                    unset($this->d["select_query"]);

                    $g = "";


                    if ($this->d["auto"] == "true" || $this->d["ins_autocomplete"] == "true") {
                        $this->d["class"] .= " ins_jsaction ";
                        $this->d["data-insaction"] = "ins_autocomplete";
                    }

                    unset($this->d["auto"]);

                    if ($this->d["type"] == "list") {
                        $this->d["multiple"] = true;
                    }



                    $this->d["class"] .= " ins_ui_input ";

                    $g .= " class='   " . $this->get("type") . " " . $this->get("class") . " " . $this->get("name") . "' ";
                    unset($this->d["data"]);
                    $h .= "<select $g " . $this->getAttrs() . ">$op</select>";
                } else {
                    $h = "";
                }

                break;
            case "table":
                $r = $this->getTable($this->d);
                break;

            case "app_oject":

                $value = $this->get("value");

                if (isset($this->d["url_var"])) {
                    $vs = explode("/", $this->d["url_var"]);
                    $vs = array_filter($vs);
                    $this->d["value"] = "";
                    $mm = "";

                    foreach ($vs as $v) {
                        $url[$v] = $_GET[$v];
                    }



                    $url = array_filter($url);


                    foreach ($url as $k => $v) {
                        $this->d["value"] .= $mm . $v;
                        $mm = "/";
                    }

                    if ($this->d["value"] == "") {
                        $this->d["value"] = $value;
                    }
                }
                $value = $this->get("value");

                $vas = explode("/", $this->d["value"]);

                $vas = array_filter($vas);



                $this->d["value"] = implode("/", $vas);


                $v = \lib::_data()->_lang_trans($this->get("value"));


                if (!isset($vs[1])) {

                    $vs[1] = $vs[0];
                } else {
                }



                $lng = \lib::_eng()->_this_lang;
                $path = \lib::_files()->_getPath($v) . "/" . $v . "/properties.xml";
                if (\lib::_files()->_file_exist($path)) {
                    $data22 = \lib::_files()->loadfile($path, $this->d["type_name"])->out;
                    if (isset($data22[$this->d["type_name"]]["title-$lng"]["data_value"])) {
                        $t = $data22[$this->d["type_name"]]["title-$lng"]["data_value"];
                    } else if (isset($data22[$this->d["type_name"]]["title"]["data_value"])) {
                        $t = $v;
                    }
                } else {

                    $t = $v;
                }


                $h = "<input type='hidden' name='" . $this->d["name"] . "' value='$v'   >"
                    . ""
                    . "<span >$t <a class='ins_change_object_type' href='" . \lib::_eng()->_url([], ["parent", "type"]) . "'><i class=\"fas fa-edit\"></i></a></span>";


                break;

            case "path":


                $mclass = "";

                if (isset($this->d["set_disable"]) && $this->d["set_disable"] != "") {
                    $s = 'if(' . $this->d["set_disable"] . '){$mclass = "ins_disabled";
                                    };
                                    ';
                    $s = str_replace("&;", "&", $s);

                    $s = \lib::_data()->_lang_trans($s, $this->d["lang_data"]);

                    eval($s);
                }

                $show = true;
                if (isset($this->d["set_hide"]) && $this->d["set_hide"] != "") {
                    $s = 'if(' . $this->d["set_hide"] . '){$show = false;
                                    };
                                    ';
                    $s = str_replace("&;", "&", $s);
                    $s = \lib::_data()->_lang_trans($s, $this->d["lang_data"]);
                    eval($s);
                }





                if ($show || $this->d["builder"] === true) {





                    $data = [
                        "button" => [
                            "input" => true, "type" => "button",
                            "class" => $this->get("class") . " ins_ui_path " . $mclass,
                            "value" => $this->d["title"],
                            "data-to" => $this->d["to"]
                        ]
                    ];

                    if (isset($this->d["set_session"]) && $this->d["set_session"] != "") {
                        $data["button"]["data-set_session"] = $this->d["set_session"];
                    }


                    if (isset($this->d["ignore_data"]) && $this->d["ignore_data"] != "") {
                        $data["button"]["data-ignore_data"] = $this->d["ignore_data"];
                    }

                    unset($this->d["ignore_data"]);

                    unset($this->d["set_session"]);

                    unset($this->d["to"]);
                    unset($this->d["title"]);

                    unset($this->d["data-value"]);

                    $e = "0";





                    $data["button"] = array_merge($data["button"], $this->getAttrData());

                    $this->d = $data;




                    $r = $this->_render_Data($this->d);
                } else {

                    $r = "";
                }




                break;


            case "table_divs":
                $r = $this->getTabledivs($this->d);
                break;
            case "table_export_csv":
                $r = $this->getTableExportCSV($this->d);
                break;


            case "pagination":
                $r = $this->getPagination($this->d);
                break;
            case "video":
                $r = $this->video($this->d);
                break;



            case "data_block":
                $r = $this->data_block($this->d);
                break;





            case "ui_line":
                $r = ""
                    . "<div style=' " . $this->get("style") . " ' class='line " . $this->get("class") . " '>"
                    . "</div>" . PHP_EOL;
                break;
            case "properties":
                $r = $this->getproperties($this->d);
                break;


            case "menus":
                $r = $this->get_menus($this->d);
                break;

            case "icon_input":




                $name = $this->d["name"];
                $h = "<div class='icon_input'><span class='ins_icon_input $name-icon'>"
                    . $this->d["value"]
                    . "<span></div>";
                $h .= "<div class='image_bar'><ul>"
                    . "<li class='jsaction ins_dark'"
                    . " data-jsaction='attr, val'"
                    . " data-jsattr_for='.$name-img' "
                    . " data-jsval_for='.$name-input' "
                    . " data-jsattr='src' "
                    . " data-jsvalue=''  "
                    . " data-jsfor='.$name-img, .$name-input' "
                    . "  >"
                    . "<i class=\"fas fa-trash-alt\"></i>"
                    . "</li>"
                    . "<li class=' ins_jsaction ins_dark' data-jsaction='lightbox' data-title='get icone'  title='get icone'"
                    . " data-url='/ajax/pages-icons/do/get_tmp_index/main_style/src_to/$name-icon/val_to/$name-input' >"
                    . " "
                    . " <i class=\"fas fa-cloud-upload-alt\"></i>"
                    . ""
                    . "<input  name='$name' class=' $name-input'  type='hidden' value=\"" . htmlentities($this->d["value"]) . "\" />"
                    . ""
                    . "<a></a>"
                    . ""
                    . ""
                    . "</li>"
                    . "</ul>"
                    . "</div>" . PHP_EOL;
                break;
            case "image":
                $v = "";
                $n = "";

                if ($this->d["trans"] != "false") {
                    $this->d["value"] = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);
                }


                if ($this->d["value"] != "") {
                    $v = \lib::_app_map()->upload_folder . $this->d["value"];
                } else {
                    $v = \lib::_app_map()->noimage;
                }





                $name = $this->d["name"];
                $upload = "";

                $tname = "_" . uniqid();

                $f_id = "f_" . uniqid();



                $fileoptions = [
                    "id" => $f_id,
                    "name" => $n . '_file',
                    "class" => "ins_jsaction _file",
                    "data-name" => $f_id,
                    "data-jsaction" => "ajax_upload_file",
                    "data-img" => ".$tname-img",
                    "data-input" => ".$tname-input",
                    "data-progress_bar" => ".$f_id" . "_progress_bar",
                    "clean" => true,
                    "input" => true,
                    "type" => "file"
                ];


                if (isset($this->d["filename"])) {

                    $fileoptions["data-filename"] = $this->d["filename"];
                }

                if (isset($this->d["data-oncomplete"])) {
                    $fileoptions["data-oncomplete"] = $this->d["data-oncomplete"];
                }



                $upload_image = \lib::_ui()->_data([
                    "file" => $fileoptions,

                    "label" => ["data" => '<i class = "fas fa-upload"></i>', "for" => $f_id, "class" => "$mclass"]
                ])->_render();



                $lightbox_id = "_" . uniqid();





                $ex = end(explode(".", $v));

                //<i class="far fa-file-pdf"></i>

                $img = "<a href='$v' target='_blank'>";

                if ($ex == "pdf") {



                    $v =
                        \lib::_app_map()->ins_images_sys . "/pdf.png";
                }




                $img .= "<img class='$tname-img' src='$v' />";


                $img .= "</a>";




                $data = [
                    "div" => ["class" => "img_input", "data" =>   $img],
                    "input" => [
                        "class" => "$name-input $tname-input ",
                        "req" => $this->d["value"], "  "
                            . "data-type" => "image", "value" => $this->d["value"], "input" => "true", "type" => "hidden", "name" => $name
                    ],
                    "start-bar" => ["class" => "image_bar"],
                    "start-ulbar" => ["data" => "ul"],
                    "li-0" => [
                        "class" => "ins_jsaction ins_dark", "data" => '<i class = "fas fa-cloud-upload-alt"></i>', "data-jsaction" => "lightbox", "data-class" => $lightbox_id, "title" => "image",
                        "data-url" => "/ajax/pages-fileborwser/do/get_tmp_index/main_style/src_to/$tname-img/val_to/$tname-input/lightbox/$lightbox_id/'"
                    ],
                    "li-2" => ["class" => "ins_jsaction ins_dark", "data" => $upload_image],
                    "li-1" => [
                        "class" => "ins_jsaction ins_dark", "data-insaction" => "ins_clear",
                        "data-img" => ".$tname-img", "data-input" => ".$tname-input", "data" => '<i class="fas fa-trash-alt"></i>'
                    ],
                    "end-ulbar" => ["data" => "ul"],
                    "end-bar" => [],
                    "div-progress_bar" => ["class" => $f_id . '_progress_bar progress_bar ins_dark_toolbar']
                ];


                if (isset($this->d["required"])) {


                    $data["input"]["required"] = "required";
                }

                $h = \lib::_ui()->_data($data)->_render();

                break;




            case "image_upload":
                $v = "";
                if ($this->d["value"] != "") {
                    $v = \lib::_app_map()->upload_folder . $this->d["value"];
                } else {
                    $v = \lib::_app_map()->noimage;
                }
                $name = $this->d["name"];
                $upload = "";
                $h = "<div class = 'img_input '>";
                $h .= "";


                $uid = uniqid();

                $h .= ""
                    . " <ul>"
                    . " <li>"
                    . " <div data-uitype = \"uploader\" "
                    . " data-setperview='.$name-img.$uid' data-name='$name'  data-prefix='" . $this->get("data-prefix") . "'"
                    . "  data-setvalue='.$name-input.$uid'   data-fpath='" . \lib::_app_map()->upload_folder . "' "
                    . " data-oncomplete='" . $this->get("oncomplete") . "' class=\"uiaction\"></div></li>"
                    . "<li title='Delete' class='jsaction delete_img '  data-name='$name' "
                    . " data-jsaction='attr,val'"
                    . " data-jsattr_for='.$name-img.$uid' "
                    . " data-jsval_for='.$name-input.$uid' "
                    . " data-jsattr='src'"
                    . " data-jscallback='" . $this->get("removecallback") . "' "
                    . " data-jsvalue=''  "
                    . " data-jsfor='.$name-img,.$name-input' "
                    . "  ><i class=\"fas fa-trash-alt\"></i>"
                    . "</li>"
                    . "</ul>";


                $h .= "<img  class='$name-img $uid' src='$v'/></div>"
                    . " <input type='hidden' value='" . $this->d["value"] . "' name='$name' class='$name-input $uid' />"
                    . "" . PHP_EOL;


                break;
            case "ajax_upload":
                $n = $this->d["name"];


                if (!isset($this->d["progress_bar"])) {

                    $attrs = "data-progress='." . $n . "_progress_bar'";
                }



                $h .= ''
                    . '<input  ' . $attrs . " " . $this->getAttrs() . '   data-jsaction="ajax_upload" type="file" name="' . $n . '" id="' . $n . '" class="ins_jsaction ' . $n . '_file" />'
                    . '<label class="' . $this->d["class"] . ' button" for="' . $n . '">' . $this->d["title"] . '</label>'
                    . '<div class="' . $n . '_progress_bar progress_bar"></div>';

                $this->d["title"] = "";
                break;

            case "ajax_upload_image":
            case "ajax_upload_file":

                $n = $this->d["name"];
                $f = "";
                if ($this->d["value"] != "") {
                    $v = \lib::_app_map()->upload_folder . $this->d["value"];
                    $f = \lib::_app_map()->upload_folder . $this->d["value"];
                    $mclass = "uploaded";
                } else {
                    $v = \lib::_app_map()->noimage;
                    $mclass = "";
                }
                $id = uniqid() . "_" . $n . '_file';

                if (!isset($this->d["icon"])) {

                    $this->d["icon"] = '<i class = "fas fa-cloud-upload-alt"></i>';
                }
                $data = [
                    "file" => [
                        "id" => $id,
                        "name" => $n . '_file',
                        "class" => "ins_jsaction _file",
                        "data-name" => $n,
                        "data-jsaction" => "ajax_upload_file",
                        "multiple" => "multiple",
                        "style" => "    width: 0.01px;
                        overflow: hidden;
                        height: 0.01px;
                        padding: 0;
                        opacity: 0;",
                        "clean" => true,
                        "input" => true,
                        "type" => "file"
                    ],

                    "label" => ["data" => $this->d["icon"], "for" => $id, "class" => "$mclass"],
                    "div" => ["class" => $n . '_progress_bar progress_bar'],
                    "input" => ["class" => $n . '_hidden  _hidden', "input" => true, "type" => "hidden", "name" => $n, "clean" => true],
                    "a-link" => ["data-name" => $n, "target" => "_blank", "href" => $f, "data" => '<i class="far fa-file"></i>', "class" => $n . '_url file_url ' . $mclass],
                    "a-delete" => [
                        "data-file" => "/" . $f,

                        "data-ondelete" => $this->d["ondelete"],
                        "data-insaction" =>
                        "ajax_upload_delete",

                        "data-name" => $n, "href" => "#", "data" => '<i class="far fa-trash-alt"></i>',
                        "class" => $n . '_url file_delete insaction ' . $mclass
                    ]
                ];
                if (isset($this->d["ondelete"])) {
                    $fileoptions["a-delete"]["data-ondelete"] = $this->d["ondelete"];
                }



                if ($this->d["type"] == "ajax_upload_image") {
                    $data["img"] = ["fullpath" => true, "src" => $v, "class" => $n . '_img _img'];
                }

                $data["file"] = array_merge($data["file"], $this->getAttrData());
                $h .= \lib::_ui()->_data($data)->_render();
                break;


            case "lightbox":

                $style = '';

                if ($this->get("style") != "") {

                    $style .= $this->get("style");
                }


                if ($this->get("width") != "") {

                    $style .= "width :" . $this->get("width") . ";";
                }

                if ($this->get("height") != "") {
                    $style .= "height :" . $this->get("height") . ";";
                }
                if ($style != "") {
                    $style = "style='$style'";
                }




                $r = "<div  style=' " . $this->get("pstyle") . " ' "
                    . "class='lightbox_bg " . $this->d["class"] . "'>"
                    . "<div  $style  class='lightbox'>";
                if (isset($this->d["title"])) {
                    $r .= "<h2 class='lightbox_title'>" . $this->d["title"] . "</h2>";
                }


                $r .= "<div class='jsaction lightbox_close' data-jsaction='hide'   data-jshide='.lightbox_bg' >"
                    . '<i class="fa fa-times" aria-hidden="true"></i>'
                    . "</div>"
                    . "<div   class='lightbox_body'>"
                    . $this->d["data"]
                    . "</div>"
                    . "</div>"
                    . "</div>"
                    . ""
                    . "";
                break;
            case "uploader":

                $h = " <div   data-uitype=\"uploader\" " . $this->getAttrs() . "  class=\"uiaction     " . $this->get("class") . " \"></div>";
                break;


            case "date_range":
                $name = $this->d["name"];

                $u_id = "_" . uniqid();

                $h .= "<input autocomplete=\"no\"  onclick='ins()._ui._do_datePicker(this,\".$u_id-cl\",\"range\")' name='$name'  value='" . $this->d["value"] . "'  class=' ins_ui_input $u_id  oninput  $name  " . $this->get("class") . " ' />
                    <div  style='' 
                    class='ins_datePicker_con $u_id-cl'><a></a></div>";


                break;

            case "weekly_calender":
                $r = $this->weekly_calender($this->d);


                break;
            case "calendar":

                $h = " <div "
                    . "  data-events='" . json_encode($this->d["events"]) . "' "
                    . " data-uiaction=\"calendar\"  "
                    . "  class=\"uiaction    "
                    . "  " . $this->get("class") . " \"></div>";
                break;

                /*  case "editor":


              $t = $this->getAttrData(false, []);
              $t["data-insaction"] = "ins_editor";
              $t["class"] = " insaction  ";


              $t["tag"] = "textarea";
              $t["data"] = $this->d["value"];

              unset($this->d["value"]);



              $h = \lib::_ui()->_data(["tag" => $t])->_render();

              $this->d["type"] = "editor";



              break; */


            case "seditor":
                //     $h = " <textarea data-uitype=\"seditor\" " . $this->getAttrs() . "  class=\"uiaction   " . $this->get("class") . "  \">" . $this->d["value"] . "</textarea>";
                break;




            case "ins_texteditor":

                $va = $this->d["value"];
                if ($this->d["trans"] != "false") {
                    $va = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);
                }

                $this->d = $this->getAttrData(false, []);
                $this->d["data"] = $va;
                $this->d["tag"] = "textarea";
                $data = ["tag-2" => ["tag" => "div", "contenteditable" => "true", "style" => "height:100px;width:100px;"], "tag" => $this->d];


                $h = $this->_render_Data($data);

                break;
            case "textarea":

                $va = trim($this->d["value"]);
                $this->d = $this->getAttrData(false, []);
                $this->d["data"] = $va;
                $this->d["tag"] = "textarea";
                $this->d["class"] .= " ins_ui_input ";



                $data = ["tag" => $this->d];
                unset($this->d["value"]);
                $h = $this->_render_Data($data);

                break;

            case "mobile":

                $va = $this->d["value"];
                if ($this->d["trans"] != "false") {

                    $va = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);
                }


                $h = "<span>+20</span> <input type='tel' " . $this->getAttrs() . " $g  " . $va . "/>" . PHP_EOL;
                break;

            case "sound":
            case "audio":

                $r = '  
            <audio ' . $this->getAttrs() . '  controls >
  <source  src="' . $this->d["data"] . '" type="audio/mpeg">
Your browser does not support the audio element.
</audio>';
                break;

            case "pdf":

                $r = '   

<embed src="' . $this->d["data"] . '" style="width:100%; height:500px" alt="pdf" pluginspage="http://www.adobe.com/products/acrobat/readstep2.html">



';

                break;
            case "input":
                $r = $this->getPagination($this->d);
                break;
            case "get_edit_btn":
                $r = "<span "
                    . " class='list_edit jsaction' "
                    . " data-jsaction='get_input_update'  "
                    . $this->getAttrs()
                    . " >"
                    . " <i class=\"fa fa-pencil\" aria-hidden=\"true\"></i>"
                    . " </span>";
                break;

            case "close_update_btn":
                $r = "<span "
                    . " class='ins_update_close_btn jsaction   " . $this->get("class") . "'"
                    . " data-jsaction='remove'"
                    . " data-jsremove='.ins_data_update_area'    "
                    . $this->getAttrs()
                    . ">"
                    . ' <i class="fa fa-times" aria-hidden="true"></i>'
                    . " </span>";
                break;

            case "update_btn":
                $r = "<span "
                    . ""
                    . ""
                    . " class='ins_update_btn jsaction  " . $this->get("class") . "'"
                    . " data-jsaction='update'  "
                    . $this->getAttrs()
                    . ">"
                    . " <i class=\"fa fa-check\" aria-hidden=\"true\"></i>"
                    . " </span>";
                break;
            case "select_time":


                $vs = explode(":", $this->get("value"));
                $n = $this->d["name"];
                $data = [
                    "strat" => ["class" => "time_input"],
                    "select" => ["value" => $vs[0], "name" => $n, "select_text" => "00, 01
                    , 02, 03, 04, 05, 06, 07, 08, 09, 10, 11, 12 , 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,23", "class" => 'col5', "clean" => true],
                    "select-m" => ["value" => $vs[1], "name" => $n . '_m', "select_text" => "00,15,30,45", "class" => 'col5', "clean" => true],
                    "end" => []
                ];


                unset($this->d["name"]);


                $data["select"] = array_merge($data["select"], $this->getAttrData());
                $data["select-m"] = array_merge($data["select-m"], $this->getAttrData());

                $h = $this->_render($data);


                break;

            case "ins_tabs":



                $data = [
                    "start" => [
                        "data-insaction" => "tabs",
                        "id" => "_" . uniqid(), "class" => "insaction ins_tabs " . $this->get("class")
                    ],
                    "start-ul" => ["data" => "ul", "class" => "ins_tabs_header ins_border_bottom      ins_grid"]
                ];


                $jdata =  json_decode($this->d["data"], true);
                unset($this->d["data"]);
                unset($this->d["type"]);


                $data["start"] = $this->d;
                $data["start"]["class"] .= " insaction ins_tabs";
                $data["start"]["data-insaction"] = "tabs";
                $data["start"]["id"] = "_" . uniqid();


                foreach ($jdata as $d) {
                    $d["type"] = "li";
                    $d["class"] .= " ins_border_bottom ins_light   ";
                    if (!isset($d["data-show"]) && isset($d["name"])) {
                        $d["data-show"] = "." . $d["name"];
                    }
                    $data[] = $d;
                }
                $data["end-ul"] = ["data" => "ul"];

                $data["start-ins_tabs_body"] = ["class" => "ins_tabs_body"];
                $r = $this->_render($data);


                break;
            case "tabs":
                if (isset($this->d["tabs_classes"])) {
                    $cs = explode(",", $this->d["tabs_classes"]);
                    unset($this->d["tabs_classes"]);
                }
                if (isset($this->d["tabs_names"])) {
                    $ns = explode(",", $this->d["tabs_names"]);
                    unset($this->d["tabs_names"]);
                } else {
                    $ns = explode(",", $this->d["name"]);
                    unset($this->d["name"]);
                }

                if (isset($this->d["tabs_titles-" . \lib::_eng()->_this_lang])) {
                    $ts = explode(",", $this->d["tabs_titles-" . \lib::_eng()->_this_lang]);
                    unset($this->d["tabs_titles-" . \lib::_eng()->_this_lang]);
                } else if (isset($this->d["tabs_titles"])) {
                    $ts = explode(",", $this->d["tabs_titles"]);
                    unset($this->d["tabs_titles"]);
                } else {

                    $ts = explode(",", $this->d["title"]);
                    unset($this->d["title"]);
                }

                $data = [
                    "start" => ["data-insaction" => "tabs", "class" => "insaction ins_tabs " . $this->get("class")],
                    "start-ul" => ["data" => "ul", "class" => "ins_tabs_header ins_grid"]
                ];
                for ($i = 0; $i < count($ns); $i++) {
                    $data["li-" . $ns[$i]] = ["data" => $ts[$i], "data-show" => "." . $ns[$i]];
                    if (isset($cs[$i])) {

                        $data["li-" . $ns[$i]]["class"] = $cs[$i];
                    }
                }
                $data["end-ul"] = ["data" => "ul"];
                $data["start-ins_tabs_body"] = ["class" => "ins_tabs_body"];
                $r = $this->_render($data);
                break;



            case "tab":
                $data = ["start" => ["class" => $this->d["name"] . ' ' . $this->get("class")], "data" => $this->d["data"]];
                $r = $this->_render($data);
                break;
            case "block":
            case "ins_collapsed":
            case "ins_explained":

                if (!isset($this->d["data"]) && isset($this->d["data_value"])) {
                    $this->d["data"] = $this->d["data_value"];
                    unset($this->d["data_value"]);
                }
                $data = ["ins_panel" => ["data-insaction" => "ins_collapsed", "title" => $this->d["title"] . '<i class="fas fa-sort-down"></i>', "class" => ' ins_collapsed insaction ' . $this->get("class"), "data" => $this->d["data"]]];
                if ($this->d["type"] == "ins_explained") {
                    $data["ins_panel"]["class"] .= " " . "ins_opend";
                }
                $r = $this->_render($data);
                break;

            case "ins_accordion":
                $data = ["ins_panel" => ["data-insaction" => "ins_accordion", "title" => $this->d["title"], "class" => ' ins_accordion insaction ' . $this->get("class"), "data" => $this->d["data"]]];
                $r = $this->_render($data);
                break;

            case "ins_accordion_panel":
                $data = ["ins_panel" => ["title" => $this->d["title"], "class" => $this->get("class"), "data" => $this->d["data"]]];
                $r = $this->_render($data);
                break;


            case "panel":
            case "ins_panel":
                $data = [
                    "start" => ["class" => "ins_panel  " . $this->get("class")],
                ];
                $data["start"] = array_merge($data["start"], $this->getAttrData(false, ["data"]));

                if (isset($this->d["title"]) && $this->d["title"] != "") {
                    $data["h3"] = ["data" => $this->d["title"], "class" => "ins_panel_title col12"];
                }

                if (isset($this->d["data"]) && $this->d["data"] != "") {
                    $data["div"] = ["data" => $this->d["data"]];
                    $data["end"] = [];
                }
                $r = $this->_render($data);
                break;


            case "endblock":
                $data = ["div" => ["class" => "clearfix"], "end" => []];
                $r = $this->_render($data);
                break;


            case "ins_tabs_end":

            case "tabs_end":
            case "end_tabs":
            case "endtabs":
                $r = $this->_render(["end" => [], "end-1" => []]);
                break;



            case "panel_end":
            case "end_panel":
            case "endaccordion":
            case "endaccordion_panel":
            case "end_div":
            case "endtab":
            case "end":
                $r = '</div>' . PHP_EOL;
                break;


            case "bool":
                $m = "";
                $this->d["data"] = ["1" => \lib::_data()->_get_gen_word("yes"), "0" => \lib::_eng()->_get_gen_word("no")];
                $h = "<select $g " . $this->getAttrs() . ">" . $this->getOptions($this->d) . "</select>";
                break;

            case "currencies":
                $dc = \ins::_files()->_get_xml("currencies")["currencies"];
                $oc =  explode(",", \ins::_map()->_org["currencies"]);
                $this->d["select_text"] = "";
                if (!isset($this->d["value"])) {
                    $this->d["value"] = \ins::_map()->_org["default_currency"];
                }
                if (!isset($this->d["name"])) {
                    $this->d["name"] = "currency";
                }
                $p = "";
                foreach ($dc as $k => $d) {
                    if (in_array($k, $oc)) {
                        if (isset($d[\lib::_eng()->_this_lang])) {
                            $d["data_value"] = $d[\lib::_eng()->_this_lang];
                        }
                        $this->d["select_text"] .= $p . $d["data_value"];
                        $this->d["select_value"] .= $p . $k;

                        $p = ",";
                    }
                }

                $this->d["type"] = "select";
                $r = $this->_render($this->d);
                break;


            case "payment_methods":
                $dc = \ins::_files()->_get_xml("payment_methods")["payment_methods"];


                $oc =  explode(",", \ins::_map()->_org["payment_methods"]);

                $this->d["select_text"] = "";
                if (!isset($this->d["value"])) {
                    $this->d["value"] = \ins::_map()->_org["default_payment_method"];
                }
                if (!isset($this->d["name"])) {
                    $this->d["name"] = "payment_method";
                }
                $p = "";
                foreach ($dc as $k => $d) {
                    if (in_array($k, $oc)) {

                        if (isset($d[\lib::_eng()->_this_lang])) {

                            $d["data_value"] = $d[\lib::_eng()->_this_lang];
                        }
                        $this->d["select_text"] .= $p . $d["data_value"];
                        $this->d["select_value"] .= $p . $k;

                        $p = ",";
                    }
                }

                $this->d["type"] = "select";
                $r = $this->_render($this->d);
                break;


            case "wicon":
                $this->d["data"] = str_replace("fa-", "", $this->d["data"]);
                $r = ' <i class="fa fa-' . $this->d["data"] . '" aria-hidden="true"></i>';
                break;

            case "icon":
                $r =  $this->icons->_render($this->d);
                break;



            case "ins_date":

                $this->d["type"] = "date";
                $this->d["input"] = "true";
                if ($this->d["set_value"] == "today" || $this->d["value"] == "today") {
                    $this->d["value"] = date('Y-m-d');
                }



                $r = $this->_render($this->d);

                break;




            case "tag":



                if ($this->d["type"] == "tag") {
                    $this->d["type"] = $this->d["tag"];
                }

                if ($this->d["trans"] != "false") {
                    if (isset($this->d["href"])) {
                        $this->d["href"] = \lib::_data()->_lang_trans($this->d["href"], $this->d["lang_data"]);
                    }
                }

                unset($this->d["tag"]);

                if (!isset($this->d["data"]) && isset($this->d["data_value"])) {
                    $this->d["data"] = $this->d["data_value"];
                    unset($this->d["data_value"]);
                }




                $data = "";


                if (isset($this->d["data"])) {
                    if (trim($this->d["trans"]) != "false") {
                        $data = \lib::_data()->_lang_trans($this->d["data"], $this->d["lang_data"]);
                    } else {
                        $data = $this->d["data"];
                    }

                    unset($this->d["data"]);
                }









                // unset($this->d["value"]);

                if (isset($this->d["item_data"])) {
                    $data .= $this->d["item_data"];
                    unset($this->d["item_data"]);
                }


                if (is_array($data)) {
                    $data = \lib::_ui()->_data($data)->_render();
                };


                if (isset($this->d["jdata"])) {
                    $jdata =  json_decode($this->d["jdata"], true);
                    $data = \lib::_ui()->_data($jdata)->_render();
                    unset($this->d["jdata"]);
                }


                $attributes = "";
                if (isset($this->d["attributes"])) {
                    $attributes = $this->d["attributes"];
                    unset($this->d["attributes"]);
                }

                if (isset($this->d["pclass"])) {
                    $this->d["class"] .= " " . $this->d["pclass"];
                }

                if (isset($this->d["pstyle"])) {
                    $this->d["style"] .= " " . $this->d["pstyle"];
                    unset($this->d["pstyle"]);
                }


                if (isset($this->d["data-insaction"])) {
                    $this->d["class"] .= " insaction  ";
                }




                $attrs = $this->getAttrs(false, ["title"]);


                if (trim($this->d["type"]) == "a") {

                    $attrs = $this->getAttrs(false, ["name"]);
                }

                $attrs .= $attributes;

                if (trim($this->d["trans"]) != "false" && $this->d["builder"] !== "1") {
                    $data = \lib::_data()->_lang_trans($data, $this->d["lang_data"]);
                }
                unset($this->d["lang_data"]);
                $r = "<" . $this->d["type"] . " class='" . $this->d["class"] . "'  title='" . $this->d["title"] . "'   " . $attrs . " >" . $data . "</" . $this->d["type"] . ">" . PHP_EOL;

                break;
            default:


                $show = true;
                if (isset($this->d["set_hide"]) && $this->d["set_hide"] != "") {
                    $s = 'if(' . $this->d["set_hide"] . '){$show=false;};';
                    $s = str_replace("&;", "&", $s);
                    $s = \lib::_data()->_lang_trans($s, $this->d["lang_data"]);
                    eval($s);
                }

                if ($show || $this->d["builder"] === true) {

                    if (isset($this->d["type"])) {



                        if ($this->d["input"] == "true") {


                            $this->d["class"] .= " ins_ui_input ";
                            $g = " class=' $mclass " . $this->get("class") . "  " . $this->get("name") . "' ";
                            unset($this->d["input"]);
                            if ($this->d["trans"] != "false") {
                                $this->d["value"] = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);
                            }


                            if (isset($this->d["attributes"])) {
                                $g .= " " . $this->d["attributes"];
                                unset($this->d["attributes"]);
                            }

                            $h = "<input  $g " . $this->getAttrs(true, ["title"]) . "/>" . PHP_EOL;
                        } else {


                            $this->d["tag"] = $this->d["type"];
                            $this->d["type"] = "tag";


                            $r = $this->_render_Data(["tag" => $this->d]);
                        }
                    }
                } else {
                    $r = "";
                    $h = "";
                }



                break;
        }


        if (isset($this->d["classes"])) {
            $classes = explode(",", $this->d["classes"]);
            foreach ($classes as $c) {

                $pclass .= " " . $c;
            }
        }



        if ($this->d["clean"] == true) {
            $r = $h;
        } else {
            if ($h != "") {

                $ui_label = "";
                if ($this->d["title"] != "") {

                    if (isset($this->d["comment-" . \lib::_eng()->_this_lang])) {


                        $this->d["title"] .= ' <i title="' . $this->d["comment-" . \lib::_eng()->_this_lang] . '"  class="fas ins_comment fa-question-circle"></i>';
                    }

                    $ui_label .= "    <div class='ui_label'>" . $this->d["title"] . "</div>" . PHP_EOL;
                }
                $ui_value = "<div class='ui_value'>  $h " . PHP_EOL;
                /* if ($this->d["editable"] == "true") {
                  $ui_value .= $this->get_html(
                  ["type" => "update_btn",
                  "data-name" => $this->d["name"],
                  "data-type" => \lib::_eng()->_getThisMenu["type"],
                  "data-area" => \lib::$_area["url"],
                  "data-value" => "." . $this->get("type") . "." . $this->d["name"],
                  "data-jsupdate_value_parents" => "." . $this->d["name"],
                  "data-id" => $_REQUEST["id"],
                  "class" => "ins_update_btn"
                  ]
                  );
                  } */
                $ui_value .= " </div>" . PHP_EOL;

                if ($this->d["no_parent_ui"] == "false" || $this->d["clean"] == true) {
                    $r = "";
                } else {
                    $this->d["name"] = str_replace("[]", "", $this->d["name"]);



                    $this->d["value"] = \lib::_data()->_lang_trans($this->d["value"], $this->d["lang_data"]);


                    $ps = "";

                    if (isset($this->d["pstyle"])) {
                        $ps = "style= '" . $this->d["pstyle"] . "' ";
                    }




                    $r = "<div $ps  class=' ui_row $pclass ui_parent ui_" . $this->d["type"] . " ui_" . $this->d["name"] . "'>" . PHP_EOL;
                }



                if ($this->d["lang"] == "true") {
                    $r .= $this->get_lang($this->d);
                }
                $r .= "  <div> " . PHP_EOL;
                if ($this->d["show_item"] == "reverse") {

                    $r .= $ui_value . $ui_label;
                } else {

                    $r .= $ui_label . $ui_value;
                }



                $r .= "</div>" . PHP_EOL;
                if ($this->d["no_parent_ui"] != "false") {

                    $r .= "</div>" . PHP_EOL;
                }
            }
        }

        return $r;
    }
}
