<?php

class mod_chat extends ins_mod {

    public function __construct($data=[]) {
        parent::__construct($data);
    }

    var $render = "";

    function _chat_chk($rq) {

        $max_id = ins::_db()->_get_row("plg_chat", "max(id) as mid", "email='" . $_SESSION["plg_chat_login_email"] . "' order by `sys_created`");

        if ($rq["mid"] != $max_id["mid"]) {
            return mod_chat::_chat_data_body_chat($_SESSION["plg_chat_login_email"]);
        }
    }

    function _chat_send_msg($rq) {

        $data = [
            "name" => $_SESSION["plg_chat_login_name"],
            "email" => $_SESSION["plg_chat_login_email"],
            "message" => $rq["msg"],
            "type" => "_f_user"
        ];

        ins::_db()->_insert("plg_chat", $data);


        echo \lib::_emails()->sendemail("empcland@gmail.com", "1", $data);

        return mod_chat::_chat_data_body_chat($_SESSION["plg_chat_login_email"]);
    }

    function _chat_data_login($rq) {
        $_SESSION["plg_chat_login_name"] = $rq["name"];
        $_SESSION["plg_chat_login_email"] = $rq["email"];
        return mod_chat::_chat_data_body_chat($_SESSION["plg_chat_login_email"]);
    }

    function _chat_data_login_chat() {


        $data = [
            "start" => ["class" => "_chat_data_login ins_grid  "],
            "span-b" => ["class" => "_chat_data_login_info ins_col_12 ", "data" => " To chat with us first Login "],
            "name-b" => ["pclass" => "_chat_data_login_name ins_col_12 ", "input" => "true", "title" => "Name"],
            "email-c" => ["pclass" => "_chat_data_login_email ins_col_12", "input" => "true", "title" => "Email"],
            "button-c" => ["class" => " ins_button ins_col_6 ins_log_chat", "data" => "Log to Chat"],
            "end" => []
        ];
        return ins::_ui()->_data($data)->_render();
    }

    function _chat_data_msg($type, $body) {


        $img = '<i class="fas fa-user-alt"></i>';

        if ($type == "_f_us") {
            $title = "";
            $img = '<img src="/ins_templates/tmp_style/css/images/logo_small.png" />';
        } else {

            $title = $_SESSION["plg_chat_login_name"];
        }




        $data = [
            "start" => ["class" => "_chat_data_msg  $type "],
            "span" => ["class" => "_chat_data_msg_img  ", "data" => $img],
            "start-1" => ["class" => " _chat_data_msg_data"],
            "span-b" => ["class" => "_chat_data_msg_body  ", "data" => $body],
            "span-c" => ["class" => "_chat_data_msg_title ", "data" => $title],
            "end-2" => [],
            "end" => []
        ];
        return ins::_ui()->_data($data)->_render();
    }

    function _chat_data_body_chat($email) {

        $plg_chat_data = ins::_db()->_get_data("plg_chat", "*", "email='" . $email . "' order by `sys_created`");

        $msgs = "";
        $mid = "";
        foreach ($plg_chat_data as $d) {

            $msgs .= mod_chat::_chat_data_msg($d["type"], $d["message"]);

            $mid = $d["id"];
        }


        $data = [
            "div" => ["class" => "_chat_data_mian_area ", "data-mid" => $mid, "data" => "$msgs"],
            "start" => ["class" => "_chat_data_input_area ins_grid"],
            "textarea" => ["class" => "_chat_data_input  ", "pclass" => "ins_col_10"],
            "span" => ["class" => "_chat_data_input_btn  ins_col_2", "data" =>
                '<i class="fas fa-paper-plane"></i> <i class="fas fa-grin-beam"></i>'],
            "end" => []
        ];


        return ins::_ui()->_data($data)->_render();
    }

    function _chat_ui() {
        if (isset($_SESSION["plg_chat_login_email"])) {
            $_body_chat = $this->_chat_data_body_chat($_SESSION["plg_chat_login_email"]);
        } else {
            $_body_chat = $this->_chat_data_login_chat();
        }
        $data = ["div" =>
            ["class" => "_chat_data_btn _h_bg ", "data" => ' <i class="fas fa-comment-alt"></i>'],
            "start" => ["class" => "_chat_data_area "],
            "div-2" => ["class" => "_chat_data_title _h_bg ", "data" =>
                '<i class="fas ins_float_left fa-ellipsis-v"></i>'
                . "<h4 class='ins_float_left'>Chat with us</h4>"
                . '<i class="far ins_float_right fa-window-minimize"></i>'
            ],
            "div-3" => ["class" => "_chat_data_body", "data" => $_body_chat],
            "end" => []
        ];

        $this->render = ins::_ui()->_data($data)->_render();
    }

    function _out() {
        $this->_include("_css.css");
        $this->_include("_js.js");
        $this->_chat_ui();

        
        $data = ["div" => [
                "data-_myname" => $this->_myname,
                "data-_myPath" => $this->_myPath,
                "class" => "mod_chat_data ",
                "data" =>  $this->render
            ]
        ];
        return $this->__ui->_data($data)->_render();
    }

}
?>

