<?php

\lib::_eng()->updateStatus();
if ($_REQUEST["for"] == "bar") {
    switch ($_REQUEST["status"]) {
        case "all":
            echo all_bar();
            break;
        case "users":
            echo users_bar();
            break;
        case "get_chat":
            echo user_chat_bar();
    }
} else {
    switch ($_REQUEST["status"]) {
        case "all":
            echo all();
            break;
        case "users":
            echo groups() . users();
            break;
        case "send_msg":
            send_msg();
            $_REQUEST["id"] = $_REQUEST["to_id"];
            echo user_chat();
            break;

        case "get_chat":
            echo user_chat();
            break;
        case "update_status":
            update_status();

            break;
    }
}

function user_chat_bar() {
    $r = \lib::_ui()->_data([
                "start-ul" => ["data" => "ul"],
                "start" => ["data" => "li"],
                "textarea" => ["rows" => "2"
                    , "class" => "send_msg"
                    , "data-type" => $_REQUEST["type"]
                    , "data-from_id" => $_REQUEST["myid"]
                    , "data-to_id" => $_REQUEST["id"]
                ],
                "end" => ["data" => "li"],
                "li" => ["class" => "send_msg_bt", 'data' => ' <i class="fas fa-chevron-right"></i>'],
                "li-1" => ["class" => "add_att", 'data' => '<i class="fas fa-paperclip"></i>'],
                "end-ul" => ["data" => "ul"],
            ])->_render();



    return $r;
}

function all_bar() {
    return \lib::_ui()->_data([
                "button" => ["class" => "chat_new_button", "data" => '<i class="fa fa-plus-circle" aria-hidden="true"></i>'],
            ])->_render();
}

function all($id) {
    $r = "";
    $data = \lib::_db()->_get_data("com_chat", "*", "to_id='" . $_REQUEST["myid"] . "'");
    foreach ($data as $d) {

        if ($d["from_type"] == "group") {
            $user = \lib::_db()->_get_row("com_chat_groups", "*", "id='" . $d["from_id"] . "'");
        } else {

            $user = \lib::_db()->_get_row("sys_users", "*", "id='" . $d["from_id"] . "'");
        }


        $img = "";

        if (empty($user["image"])) {
            $img = "<div class='chat_usre_image'><img src='" . $_REQUEST["mypath"] . "/e_users.png' ></div>";
        }
        $r .= "<div data-from_type='" . $d["from_type"] . "' class='users fas msg_item'>" . $img . "<h5>" . $user["title"] . "</h5>";
        $r .= "<spsn class='chat_msg'>" . $d["msg"] . "</span></div>";
    }

    return $r;
}

function get_home($id) {


    all($id);
}

function groups() {
    $r = "";


    if (!isset($_REQUEST["def_groups"]) || $_REQUEST["def_groups"] != "0") {
        if (isset($_REQUEST["def_groups"])) {
            $data = explode(",", $_REQUEST["def_groups"]);
        } else {
            $data = \lib::_db()->_get_data("com_chat_groups_xref", "DISTINCT(group_id)", "user_id='" . $_REQUEST["myid"] . "'");
        }
        foreach ($data as $d) {
            $user = \lib::_db()->_get_row("com_chat_groups", "*", "id='" . $d["group_id"] . "'");
            $img = "";
            if (empty($user["image"])) {
                $img = "<div class='chat_usre_image'><img src='" . $_REQUEST["mypath"] . "/e_users.png' ></div>";
            }
            $r .= "<div data-type='group'  data-id='" . $user["id"] . "' class='group get_chat'>"
                    . "<div  class='fas msg_item'>" . $img . ""
                    . "<h5>" . $user["title"] . "</h5></div></div>";
        }
    }
    return $r;
}

function users() {
    $r = "";

    if (!isset($_REQUEST["def_users"]) || $_REQUEST["def_users"] != "0") {

        if (isset($_REQUEST["def_users"])) {
            $data = explode(",", $_REQUEST["def_users"]);
        } else {
            $data = \lib::_db()->_get_data("com_chat", "DISTINCT(from_id)", "to_id='" . $_REQUEST["myid"] . "'");
        }
        foreach ($data as $d) {
            $user = \lib::_db()->_get_row("sys_users", "*", "id='" . $d["from_id"] . "'");
            $img = "";
            if (empty($user["image"])) {
                $img = "<div class='chat_usre_image'><img src='" . $_REQUEST["mypath"] . "/e_users.png' ></div>";
            }
            $r .= "<div data-type='user'  data-id='" . $user["id"] . "' class='get_chat'><div  class='fas msg_item'>" . $img . "<h5>" . $user["title"] . "</h5></div></div>";
        }
    }

    return $r;
}

function update_status() {
    $data = \lib::_db()->_update("com_chat", ["msgstatus" => $_REQUEST["msgstatus"]], "id=:varid", ["varid" => $_REQUEST["id"]]);
}

function send_msg($id) {


    $data = \lib::_db()->_insert("com_chat", $_REQUEST);
}

function user_chat($id) {
    $r = "";


    $Data = \lib::_db()->_get_data("com_chat", "*", "((from_id=:from_id and  from_type=:from_type) and (to_id=:to_id and  to_type=:to_type)) or  "
            . "((from_id=:to_id and  from_type=:to_type) and (to_id=:from_id and  to_type=:from_type)) ", [
        "from_id" => $_REQUEST["from_id"],
        "from_type" => $_REQUEST["from_type"],
        "to_id" => $_REQUEST["to_id"],
        "to_type" => $_REQUEST["to_type"]
    ]);



    foreach ($Data as $d) {
        $user = \lib::_db()->_get_row($d["from_type"], "*", "id='" . $d["from_id"] . "'");
        if ($_REQUEST["from_id"] == $d["from_id"]) {
            $mclass = "from_me";
            $user["title"] = "You";
        } else {
            $mclass = "from_to";
        }

        $img = "";
        if (empty($user["image"])) {
            //   $img = "<div class='chat_usre_image'><img src='" . $_REQUEST["mypath"] . "/e_users.png' ></div>";
        }
        $r .= "<div data-id='" . $d["id"] . "' class='$mclass  " . $d["msgstatus"] . " chat_body fas msg_item'>" . $img . "<h5>" . $user["title"] . "</h5>";
        $r .= "<spsn class='chat_msg'>" . $d["msg"] . "</span></div>";
    }


    if (count($Data) == 0) {

        $r = "<div><h5></h5>";


        $r .= "<spsn class='chat_msg'>Faiz-e-Haakimi help desk</span></div>";
    }

    return $r;
}
